!(function (root, factory) {
  "use strict";
  "function" == typeof define && define.amd
    ? define("pdfjs-dist/build/pdf.worker", ["exports"], factory)
    : factory("undefined" != typeof exports ? exports : (root.pdfjsDistBuildPdfWorker = {}));
})(this, function (exports) {
  "use strict";
  var pdfjsLibs = ("undefined" != typeof document && document.currentScript && document.currentScript.src, {});
  (function () {
    !(function (root, factory) {
      !(function (exports) {
        var ArithmeticDecoder = (function () {
          function ArithmeticDecoder(data, start, end) {
            (this.data = data),
              (this.bp = start),
              (this.dataEnd = end),
              (this.chigh = data[start]),
              (this.clow = 0),
              this.byteIn(),
              (this.chigh = ((this.chigh << 7) & 65535) | ((this.clow >> 9) & 127)),
              (this.clow = (this.clow << 7) & 65535),
              (this.ct -= 7),
              (this.a = 32768);
          }
          var QeTable = [
            { qe: 22017, nmps: 1, nlps: 1, switchFlag: 1 },
            { qe: 13313, nmps: 2, nlps: 6, switchFlag: 0 },
            { qe: 6145, nmps: 3, nlps: 9, switchFlag: 0 },
            { qe: 2753, nmps: 4, nlps: 12, switchFlag: 0 },
            { qe: 1313, nmps: 5, nlps: 29, switchFlag: 0 },
            { qe: 545, nmps: 38, nlps: 33, switchFlag: 0 },
            { qe: 22017, nmps: 7, nlps: 6, switchFlag: 1 },
            { qe: 21505, nmps: 8, nlps: 14, switchFlag: 0 },
            { qe: 18433, nmps: 9, nlps: 14, switchFlag: 0 },
            { qe: 14337, nmps: 10, nlps: 14, switchFlag: 0 },
            { qe: 12289, nmps: 11, nlps: 17, switchFlag: 0 },
            { qe: 9217, nmps: 12, nlps: 18, switchFlag: 0 },
            { qe: 7169, nmps: 13, nlps: 20, switchFlag: 0 },
            { qe: 5633, nmps: 29, nlps: 21, switchFlag: 0 },
            { qe: 22017, nmps: 15, nlps: 14, switchFlag: 1 },
            { qe: 21505, nmps: 16, nlps: 14, switchFlag: 0 },
            { qe: 20737, nmps: 17, nlps: 15, switchFlag: 0 },
            { qe: 18433, nmps: 18, nlps: 16, switchFlag: 0 },
            { qe: 14337, nmps: 19, nlps: 17, switchFlag: 0 },
            { qe: 13313, nmps: 20, nlps: 18, switchFlag: 0 },
            { qe: 12289, nmps: 21, nlps: 19, switchFlag: 0 },
            { qe: 10241, nmps: 22, nlps: 19, switchFlag: 0 },
            { qe: 9217, nmps: 23, nlps: 20, switchFlag: 0 },
            { qe: 8705, nmps: 24, nlps: 21, switchFlag: 0 },
            { qe: 7169, nmps: 25, nlps: 22, switchFlag: 0 },
            { qe: 6145, nmps: 26, nlps: 23, switchFlag: 0 },
            { qe: 5633, nmps: 27, nlps: 24, switchFlag: 0 },
            { qe: 5121, nmps: 28, nlps: 25, switchFlag: 0 },
            { qe: 4609, nmps: 29, nlps: 26, switchFlag: 0 },
            { qe: 4353, nmps: 30, nlps: 27, switchFlag: 0 },
            { qe: 2753, nmps: 31, nlps: 28, switchFlag: 0 },
            { qe: 2497, nmps: 32, nlps: 29, switchFlag: 0 },
            { qe: 2209, nmps: 33, nlps: 30, switchFlag: 0 },
            { qe: 1313, nmps: 34, nlps: 31, switchFlag: 0 },
            { qe: 1089, nmps: 35, nlps: 32, switchFlag: 0 },
            { qe: 673, nmps: 36, nlps: 33, switchFlag: 0 },
            { qe: 545, nmps: 37, nlps: 34, switchFlag: 0 },
            { qe: 321, nmps: 38, nlps: 35, switchFlag: 0 },
            { qe: 273, nmps: 39, nlps: 36, switchFlag: 0 },
            { qe: 133, nmps: 40, nlps: 37, switchFlag: 0 },
            { qe: 73, nmps: 41, nlps: 38, switchFlag: 0 },
            { qe: 37, nmps: 42, nlps: 39, switchFlag: 0 },
            { qe: 21, nmps: 43, nlps: 40, switchFlag: 0 },
            { qe: 9, nmps: 44, nlps: 41, switchFlag: 0 },
            { qe: 5, nmps: 45, nlps: 42, switchFlag: 0 },
            { qe: 1, nmps: 45, nlps: 43, switchFlag: 0 },
            { qe: 22017, nmps: 46, nlps: 46, switchFlag: 0 },
          ];
          return (
            (ArithmeticDecoder.prototype = {
              byteIn: function () {
                var data = this.data,
                  bp = this.bp;
                if (255 === data[bp]) {
                  data[bp + 1] > 143
                    ? ((this.clow += 65280), (this.ct = 8))
                    : (bp++, (this.clow += data[bp] << 9), (this.ct = 7), (this.bp = bp));
                } else bp++, (this.clow += bp < this.dataEnd ? data[bp] << 8 : 65280), (this.ct = 8), (this.bp = bp);
                this.clow > 65535 && ((this.chigh += this.clow >> 16), (this.clow &= 65535));
              },
              readBit: function (contexts, pos) {
                var d,
                  cx_index = contexts[pos] >> 1,
                  cx_mps = 1 & contexts[pos],
                  qeTableIcx = QeTable[cx_index],
                  qeIcx = qeTableIcx.qe,
                  a = this.a - qeIcx;
                if (this.chigh < qeIcx)
                  a < qeIcx
                    ? ((a = qeIcx), (d = cx_mps), (cx_index = qeTableIcx.nmps))
                    : ((a = qeIcx),
                      (d = 1 ^ cx_mps),
                      1 === qeTableIcx.switchFlag && (cx_mps = d),
                      (cx_index = qeTableIcx.nlps));
                else {
                  if (((this.chigh -= qeIcx), 0 != (32768 & a))) return (this.a = a), cx_mps;
                  a < qeIcx
                    ? ((d = 1 ^ cx_mps), 1 === qeTableIcx.switchFlag && (cx_mps = d), (cx_index = qeTableIcx.nlps))
                    : ((d = cx_mps), (cx_index = qeTableIcx.nmps));
                }
                do {
                  0 === this.ct && this.byteIn(),
                    (a <<= 1),
                    (this.chigh = ((this.chigh << 1) & 65535) | ((this.clow >> 15) & 1)),
                    (this.clow = (this.clow << 1) & 65535),
                    this.ct--;
                } while (0 == (32768 & a));
                return (this.a = a), (contexts[pos] = (cx_index << 1) | cx_mps), d;
              },
            }),
            ArithmeticDecoder
          );
        })();
        exports.ArithmeticDecoder = ArithmeticDecoder;
      })((root.pdfjsCoreArithmeticDecoder = {}));
    })(this),
      (function (root, factory) {
        !(function (exports) {
          function isOdd(i) {
            return 0 != (1 & i);
          }
          function isEven(i) {
            return 0 == (1 & i);
          }
          function findUnequal(arr, start, value) {
            for (var j = start, jj = arr.length; j < jj; ++j) if (arr[j] !== value) return j;
            return j;
          }
          function setValues(arr, start, end, value) {
            for (var j = start; j < end; ++j) arr[j] = value;
          }
          function reverseValues(arr, start, end) {
            for (var i = start, j = end - 1; i < j; ++i, --j) {
              var temp = arr[i];
              (arr[i] = arr[j]), (arr[j] = temp);
            }
          }
          function createBidiText(str, isLTR, vertical) {
            return { str: str, dir: vertical ? "ttb" : isLTR ? "ltr" : "rtl" };
          }
          function bidi(str, startLevel, vertical) {
            var isLTR = !0,
              strLength = str.length;
            if (0 === strLength || vertical) return createBidiText(str, isLTR, vertical);
            (chars.length = strLength), (types.length = strLength);
            var i,
              ii,
              numBidi = 0;
            for (i = 0; i < strLength; ++i) {
              chars[i] = str.charAt(i);
              var charCode = str.charCodeAt(i),
                charType = "L";
              charCode <= 255
                ? (charType = baseTypes[charCode])
                : 1424 <= charCode && charCode <= 1524
                ? (charType = "R")
                : 1536 <= charCode && charCode <= 1791
                ? (charType = arabicTypes[255 & charCode])
                : 1792 <= charCode && charCode <= 2220 && (charType = "AL"),
                ("R" !== charType && "AL" !== charType && "AN" !== charType) || numBidi++,
                (types[i] = charType);
            }
            if (0 === numBidi) return (isLTR = !0), createBidiText(str, isLTR);
            -1 === startLevel &&
              (strLength / numBidi < 0.3 ? ((isLTR = !0), (startLevel = 0)) : ((isLTR = !1), (startLevel = 1)));
            var levels = [];
            for (i = 0; i < strLength; ++i) levels[i] = startLevel;
            var e = isOdd(startLevel) ? "R" : "L",
              sor = e,
              eor = sor,
              lastType = sor;
            for (i = 0; i < strLength; ++i) "NSM" === types[i] ? (types[i] = lastType) : (lastType = types[i]);
            lastType = sor;
            var t;
            for (i = 0; i < strLength; ++i)
              (t = types[i]),
                "EN" === t
                  ? (types[i] = "AL" === lastType ? "AN" : "EN")
                  : ("R" !== t && "L" !== t && "AL" !== t) || (lastType = t);
            for (i = 0; i < strLength; ++i) "AL" === (t = types[i]) && (types[i] = "R");
            for (i = 1; i < strLength - 1; ++i)
              "ES" === types[i] && "EN" === types[i - 1] && "EN" === types[i + 1] && (types[i] = "EN"),
                "CS" !== types[i] ||
                  ("EN" !== types[i - 1] && "AN" !== types[i - 1]) ||
                  types[i + 1] !== types[i - 1] ||
                  (types[i] = types[i - 1]);
            for (i = 0; i < strLength; ++i)
              if ("EN" === types[i]) {
                var j;
                for (j = i - 1; j >= 0 && "ET" === types[j]; --j) types[j] = "EN";
                for (j = i + 1; j < strLength && "ET" === types[j]; ++j) types[j] = "EN";
              }
            for (i = 0; i < strLength; ++i)
              ("WS" !== (t = types[i]) && "ES" !== t && "ET" !== t && "CS" !== t) || (types[i] = "ON");
            for (lastType = sor, i = 0; i < strLength; ++i)
              (t = types[i]),
                "EN" === t ? (types[i] = "L" === lastType ? "L" : "EN") : ("R" !== t && "L" !== t) || (lastType = t);
            for (i = 0; i < strLength; ++i)
              if ("ON" === types[i]) {
                var end = findUnequal(types, i + 1, "ON"),
                  before = sor;
                i > 0 && (before = types[i - 1]);
                var after = eor;
                end + 1 < strLength && (after = types[end + 1]),
                  "L" !== before && (before = "R"),
                  "L" !== after && (after = "R"),
                  before === after && setValues(types, i, end, before),
                  (i = end - 1);
              }
            for (i = 0; i < strLength; ++i) "ON" === types[i] && (types[i] = e);
            for (i = 0; i < strLength; ++i)
              (t = types[i]),
                isEven(levels[i])
                  ? "R" === t
                    ? (levels[i] += 1)
                    : ("AN" !== t && "EN" !== t) || (levels[i] += 2)
                  : ("L" !== t && "AN" !== t && "EN" !== t) || (levels[i] += 1);
            var level,
              highestLevel = -1,
              lowestOddLevel = 99;
            for (i = 0, ii = levels.length; i < ii; ++i)
              (level = levels[i]),
                highestLevel < level && (highestLevel = level),
                lowestOddLevel > level && isOdd(level) && (lowestOddLevel = level);
            for (level = highestLevel; level >= lowestOddLevel; --level) {
              var start = -1;
              for (i = 0, ii = levels.length; i < ii; ++i)
                levels[i] < level
                  ? start >= 0 && (reverseValues(chars, start, i), (start = -1))
                  : start < 0 && (start = i);
              start >= 0 && reverseValues(chars, start, levels.length);
            }
            for (i = 0, ii = chars.length; i < ii; ++i) {
              var ch = chars[i];
              ("<" !== ch && ">" !== ch) || (chars[i] = "");
            }
            return createBidiText(chars.join(""), isLTR);
          }
          var baseTypes = [
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "S",
              "B",
              "S",
              "WS",
              "B",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "B",
              "B",
              "B",
              "S",
              "WS",
              "ON",
              "ON",
              "ET",
              "ET",
              "ET",
              "ON",
              "ON",
              "ON",
              "ON",
              "ON",
              "ON",
              "CS",
              "ON",
              "CS",
              "ON",
              "EN",
              "EN",
              "EN",
              "EN",
              "EN",
              "EN",
              "EN",
              "EN",
              "EN",
              "EN",
              "ON",
              "ON",
              "ON",
              "ON",
              "ON",
              "ON",
              "ON",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "ON",
              "ON",
              "ON",
              "ON",
              "ON",
              "ON",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "ON",
              "ON",
              "ON",
              "ON",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "B",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "BN",
              "CS",
              "ON",
              "ET",
              "ET",
              "ET",
              "ET",
              "ON",
              "ON",
              "ON",
              "ON",
              "L",
              "ON",
              "ON",
              "ON",
              "ON",
              "ON",
              "ET",
              "ET",
              "EN",
              "EN",
              "ON",
              "L",
              "ON",
              "ON",
              "ON",
              "EN",
              "L",
              "ON",
              "ON",
              "ON",
              "ON",
              "ON",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "ON",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "ON",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
              "L",
            ],
            arabicTypes = [
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "CS",
              "AL",
              "ON",
              "ON",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AN",
              "AN",
              "AN",
              "AN",
              "AN",
              "AN",
              "AN",
              "AN",
              "AN",
              "AN",
              "ET",
              "AN",
              "AN",
              "AL",
              "AL",
              "AL",
              "NSM",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "ON",
              "NSM",
              "NSM",
              "NSM",
              "NSM",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
              "AL",
            ],
            chars = [],
            types = [];
          exports.bidi = bidi;
        })((root.pdfjsCoreBidi = {}));
      })(this),
      (function (root, factory) {
        !(function (exports) {
          var ISOAdobeCharset = [
              ".notdef",
              "space",
              "exclam",
              "quotedbl",
              "numbersign",
              "dollar",
              "percent",
              "ampersand",
              "quoteright",
              "parenleft",
              "parenright",
              "asterisk",
              "plus",
              "comma",
              "hyphen",
              "period",
              "slash",
              "zero",
              "one",
              "two",
              "three",
              "four",
              "five",
              "six",
              "seven",
              "eight",
              "nine",
              "colon",
              "semicolon",
              "less",
              "equal",
              "greater",
              "question",
              "at",
              "A",
              "B",
              "C",
              "D",
              "E",
              "F",
              "G",
              "H",
              "I",
              "J",
              "K",
              "L",
              "M",
              "N",
              "O",
              "P",
              "Q",
              "R",
              "S",
              "T",
              "U",
              "V",
              "W",
              "X",
              "Y",
              "Z",
              "bracketleft",
              "backslash",
              "bracketright",
              "asciicircum",
              "underscore",
              "quoteleft",
              "a",
              "b",
              "c",
              "d",
              "e",
              "f",
              "g",
              "h",
              "i",
              "j",
              "k",
              "l",
              "m",
              "n",
              "o",
              "p",
              "q",
              "r",
              "s",
              "t",
              "u",
              "v",
              "w",
              "x",
              "y",
              "z",
              "braceleft",
              "bar",
              "braceright",
              "asciitilde",
              "exclamdown",
              "cent",
              "sterling",
              "fraction",
              "yen",
              "florin",
              "section",
              "currency",
              "quotesingle",
              "quotedblleft",
              "guillemotleft",
              "guilsinglleft",
              "guilsinglright",
              "fi",
              "fl",
              "endash",
              "dagger",
              "daggerdbl",
              "periodcentered",
              "paragraph",
              "bullet",
              "quotesinglbase",
              "quotedblbase",
              "quotedblright",
              "guillemotright",
              "ellipsis",
              "perthousand",
              "questiondown",
              "grave",
              "acute",
              "circumflex",
              "tilde",
              "macron",
              "breve",
              "dotaccent",
              "dieresis",
              "ring",
              "cedilla",
              "hungarumlaut",
              "ogonek",
              "caron",
              "emdash",
              "AE",
              "ordfeminine",
              "Lslash",
              "Oslash",
              "OE",
              "ordmasculine",
              "ae",
              "dotlessi",
              "lslash",
              "oslash",
              "oe",
              "germandbls",
              "onesuperior",
              "logicalnot",
              "mu",
              "trademark",
              "Eth",
              "onehalf",
              "plusminus",
              "Thorn",
              "onequarter",
              "divide",
              "brokenbar",
              "degree",
              "thorn",
              "threequarters",
              "twosuperior",
              "registered",
              "minus",
              "eth",
              "multiply",
              "threesuperior",
              "copyright",
              "Aacute",
              "Acircumflex",
              "Adieresis",
              "Agrave",
              "Aring",
              "Atilde",
              "Ccedilla",
              "Eacute",
              "Ecircumflex",
              "Edieresis",
              "Egrave",
              "Iacute",
              "Icircumflex",
              "Idieresis",
              "Igrave",
              "Ntilde",
              "Oacute",
              "Ocircumflex",
              "Odieresis",
              "Ograve",
              "Otilde",
              "Scaron",
              "Uacute",
              "Ucircumflex",
              "Udieresis",
              "Ugrave",
              "Yacute",
              "Ydieresis",
              "Zcaron",
              "aacute",
              "acircumflex",
              "adieresis",
              "agrave",
              "aring",
              "atilde",
              "ccedilla",
              "eacute",
              "ecircumflex",
              "edieresis",
              "egrave",
              "iacute",
              "icircumflex",
              "idieresis",
              "igrave",
              "ntilde",
              "oacute",
              "ocircumflex",
              "odieresis",
              "ograve",
              "otilde",
              "scaron",
              "uacute",
              "ucircumflex",
              "udieresis",
              "ugrave",
              "yacute",
              "ydieresis",
              "zcaron",
            ],
            ExpertCharset = [
              ".notdef",
              "space",
              "exclamsmall",
              "Hungarumlautsmall",
              "dollaroldstyle",
              "dollarsuperior",
              "ampersandsmall",
              "Acutesmall",
              "parenleftsuperior",
              "parenrightsuperior",
              "twodotenleader",
              "onedotenleader",
              "comma",
              "hyphen",
              "period",
              "fraction",
              "zerooldstyle",
              "oneoldstyle",
              "twooldstyle",
              "threeoldstyle",
              "fouroldstyle",
              "fiveoldstyle",
              "sixoldstyle",
              "sevenoldstyle",
              "eightoldstyle",
              "nineoldstyle",
              "colon",
              "semicolon",
              "commasuperior",
              "threequartersemdash",
              "periodsuperior",
              "questionsmall",
              "asuperior",
              "bsuperior",
              "centsuperior",
              "dsuperior",
              "esuperior",
              "isuperior",
              "lsuperior",
              "msuperior",
              "nsuperior",
              "osuperior",
              "rsuperior",
              "ssuperior",
              "tsuperior",
              "ff",
              "fi",
              "fl",
              "ffi",
              "ffl",
              "parenleftinferior",
              "parenrightinferior",
              "Circumflexsmall",
              "hyphensuperior",
              "Gravesmall",
              "Asmall",
              "Bsmall",
              "Csmall",
              "Dsmall",
              "Esmall",
              "Fsmall",
              "Gsmall",
              "Hsmall",
              "Ismall",
              "Jsmall",
              "Ksmall",
              "Lsmall",
              "Msmall",
              "Nsmall",
              "Osmall",
              "Psmall",
              "Qsmall",
              "Rsmall",
              "Ssmall",
              "Tsmall",
              "Usmall",
              "Vsmall",
              "Wsmall",
              "Xsmall",
              "Ysmall",
              "Zsmall",
              "colonmonetary",
              "onefitted",
              "rupiah",
              "Tildesmall",
              "exclamdownsmall",
              "centoldstyle",
              "Lslashsmall",
              "Scaronsmall",
              "Zcaronsmall",
              "Dieresissmall",
              "Brevesmall",
              "Caronsmall",
              "Dotaccentsmall",
              "Macronsmall",
              "figuredash",
              "hypheninferior",
              "Ogoneksmall",
              "Ringsmall",
              "Cedillasmall",
              "onequarter",
              "onehalf",
              "threequarters",
              "questiondownsmall",
              "oneeighth",
              "threeeighths",
              "fiveeighths",
              "seveneighths",
              "onethird",
              "twothirds",
              "zerosuperior",
              "onesuperior",
              "twosuperior",
              "threesuperior",
              "foursuperior",
              "fivesuperior",
              "sixsuperior",
              "sevensuperior",
              "eightsuperior",
              "ninesuperior",
              "zeroinferior",
              "oneinferior",
              "twoinferior",
              "threeinferior",
              "fourinferior",
              "fiveinferior",
              "sixinferior",
              "seveninferior",
              "eightinferior",
              "nineinferior",
              "centinferior",
              "dollarinferior",
              "periodinferior",
              "commainferior",
              "Agravesmall",
              "Aacutesmall",
              "Acircumflexsmall",
              "Atildesmall",
              "Adieresissmall",
              "Aringsmall",
              "AEsmall",
              "Ccedillasmall",
              "Egravesmall",
              "Eacutesmall",
              "Ecircumflexsmall",
              "Edieresissmall",
              "Igravesmall",
              "Iacutesmall",
              "Icircumflexsmall",
              "Idieresissmall",
              "Ethsmall",
              "Ntildesmall",
              "Ogravesmall",
              "Oacutesmall",
              "Ocircumflexsmall",
              "Otildesmall",
              "Odieresissmall",
              "OEsmall",
              "Oslashsmall",
              "Ugravesmall",
              "Uacutesmall",
              "Ucircumflexsmall",
              "Udieresissmall",
              "Yacutesmall",
              "Thornsmall",
              "Ydieresissmall",
            ],
            ExpertSubsetCharset = [
              ".notdef",
              "space",
              "dollaroldstyle",
              "dollarsuperior",
              "parenleftsuperior",
              "parenrightsuperior",
              "twodotenleader",
              "onedotenleader",
              "comma",
              "hyphen",
              "period",
              "fraction",
              "zerooldstyle",
              "oneoldstyle",
              "twooldstyle",
              "threeoldstyle",
              "fouroldstyle",
              "fiveoldstyle",
              "sixoldstyle",
              "sevenoldstyle",
              "eightoldstyle",
              "nineoldstyle",
              "colon",
              "semicolon",
              "commasuperior",
              "threequartersemdash",
              "periodsuperior",
              "asuperior",
              "bsuperior",
              "centsuperior",
              "dsuperior",
              "esuperior",
              "isuperior",
              "lsuperior",
              "msuperior",
              "nsuperior",
              "osuperior",
              "rsuperior",
              "ssuperior",
              "tsuperior",
              "ff",
              "fi",
              "fl",
              "ffi",
              "ffl",
              "parenleftinferior",
              "parenrightinferior",
              "hyphensuperior",
              "colonmonetary",
              "onefitted",
              "rupiah",
              "centoldstyle",
              "figuredash",
              "hypheninferior",
              "onequarter",
              "onehalf",
              "threequarters",
              "oneeighth",
              "threeeighths",
              "fiveeighths",
              "seveneighths",
              "onethird",
              "twothirds",
              "zerosuperior",
              "onesuperior",
              "twosuperior",
              "threesuperior",
              "foursuperior",
              "fivesuperior",
              "sixsuperior",
              "sevensuperior",
              "eightsuperior",
              "ninesuperior",
              "zeroinferior",
              "oneinferior",
              "twoinferior",
              "threeinferior",
              "fourinferior",
              "fiveinferior",
              "sixinferior",
              "seveninferior",
              "eightinferior",
              "nineinferior",
              "centinferior",
              "dollarinferior",
              "periodinferior",
              "commainferior",
            ];
          (exports.ISOAdobeCharset = ISOAdobeCharset),
            (exports.ExpertCharset = ExpertCharset),
            (exports.ExpertSubsetCharset = ExpertSubsetCharset);
        })((root.pdfjsCoreCharsets = {}));
      })(this),
      (function (root, factory) {
        !(function (exports) {
          function getEncoding(encodingName) {
            switch (encodingName) {
              case "WinAnsiEncoding":
                return WinAnsiEncoding;
              case "StandardEncoding":
                return StandardEncoding;
              case "MacRomanEncoding":
                return MacRomanEncoding;
              case "SymbolSetEncoding":
                return SymbolSetEncoding;
              case "ZapfDingbatsEncoding":
                return ZapfDingbatsEncoding;
              case "ExpertEncoding":
                return ExpertEncoding;
              case "MacExpertEncoding":
                return MacExpertEncoding;
              default:
                return null;
            }
          }
          var ExpertEncoding = [
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "space",
              "exclamsmall",
              "Hungarumlautsmall",
              "",
              "dollaroldstyle",
              "dollarsuperior",
              "ampersandsmall",
              "Acutesmall",
              "parenleftsuperior",
              "parenrightsuperior",
              "twodotenleader",
              "onedotenleader",
              "comma",
              "hyphen",
              "period",
              "fraction",
              "zerooldstyle",
              "oneoldstyle",
              "twooldstyle",
              "threeoldstyle",
              "fouroldstyle",
              "fiveoldstyle",
              "sixoldstyle",
              "sevenoldstyle",
              "eightoldstyle",
              "nineoldstyle",
              "colon",
              "semicolon",
              "commasuperior",
              "threequartersemdash",
              "periodsuperior",
              "questionsmall",
              "",
              "asuperior",
              "bsuperior",
              "centsuperior",
              "dsuperior",
              "esuperior",
              "",
              "",
              "isuperior",
              "",
              "",
              "lsuperior",
              "msuperior",
              "nsuperior",
              "osuperior",
              "",
              "",
              "rsuperior",
              "ssuperior",
              "tsuperior",
              "",
              "ff",
              "fi",
              "fl",
              "ffi",
              "ffl",
              "parenleftinferior",
              "",
              "parenrightinferior",
              "Circumflexsmall",
              "hyphensuperior",
              "Gravesmall",
              "Asmall",
              "Bsmall",
              "Csmall",
              "Dsmall",
              "Esmall",
              "Fsmall",
              "Gsmall",
              "Hsmall",
              "Ismall",
              "Jsmall",
              "Ksmall",
              "Lsmall",
              "Msmall",
              "Nsmall",
              "Osmall",
              "Psmall",
              "Qsmall",
              "Rsmall",
              "Ssmall",
              "Tsmall",
              "Usmall",
              "Vsmall",
              "Wsmall",
              "Xsmall",
              "Ysmall",
              "Zsmall",
              "colonmonetary",
              "onefitted",
              "rupiah",
              "Tildesmall",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "exclamdownsmall",
              "centoldstyle",
              "Lslashsmall",
              "",
              "",
              "Scaronsmall",
              "Zcaronsmall",
              "Dieresissmall",
              "Brevesmall",
              "Caronsmall",
              "",
              "Dotaccentsmall",
              "",
              "",
              "Macronsmall",
              "",
              "",
              "figuredash",
              "hypheninferior",
              "",
              "",
              "Ogoneksmall",
              "Ringsmall",
              "Cedillasmall",
              "",
              "",
              "",
              "onequarter",
              "onehalf",
              "threequarters",
              "questiondownsmall",
              "oneeighth",
              "threeeighths",
              "fiveeighths",
              "seveneighths",
              "onethird",
              "twothirds",
              "",
              "",
              "zerosuperior",
              "onesuperior",
              "twosuperior",
              "threesuperior",
              "foursuperior",
              "fivesuperior",
              "sixsuperior",
              "sevensuperior",
              "eightsuperior",
              "ninesuperior",
              "zeroinferior",
              "oneinferior",
              "twoinferior",
              "threeinferior",
              "fourinferior",
              "fiveinferior",
              "sixinferior",
              "seveninferior",
              "eightinferior",
              "nineinferior",
              "centinferior",
              "dollarinferior",
              "periodinferior",
              "commainferior",
              "Agravesmall",
              "Aacutesmall",
              "Acircumflexsmall",
              "Atildesmall",
              "Adieresissmall",
              "Aringsmall",
              "AEsmall",
              "Ccedillasmall",
              "Egravesmall",
              "Eacutesmall",
              "Ecircumflexsmall",
              "Edieresissmall",
              "Igravesmall",
              "Iacutesmall",
              "Icircumflexsmall",
              "Idieresissmall",
              "Ethsmall",
              "Ntildesmall",
              "Ogravesmall",
              "Oacutesmall",
              "Ocircumflexsmall",
              "Otildesmall",
              "Odieresissmall",
              "OEsmall",
              "Oslashsmall",
              "Ugravesmall",
              "Uacutesmall",
              "Ucircumflexsmall",
              "Udieresissmall",
              "Yacutesmall",
              "Thornsmall",
              "Ydieresissmall",
            ],
            MacExpertEncoding = [
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "space",
              "exclamsmall",
              "Hungarumlautsmall",
              "centoldstyle",
              "dollaroldstyle",
              "dollarsuperior",
              "ampersandsmall",
              "Acutesmall",
              "parenleftsuperior",
              "parenrightsuperior",
              "twodotenleader",
              "onedotenleader",
              "comma",
              "hyphen",
              "period",
              "fraction",
              "zerooldstyle",
              "oneoldstyle",
              "twooldstyle",
              "threeoldstyle",
              "fouroldstyle",
              "fiveoldstyle",
              "sixoldstyle",
              "sevenoldstyle",
              "eightoldstyle",
              "nineoldstyle",
              "colon",
              "semicolon",
              "",
              "threequartersemdash",
              "",
              "questionsmall",
              "",
              "",
              "",
              "",
              "Ethsmall",
              "",
              "",
              "onequarter",
              "onehalf",
              "threequarters",
              "oneeighth",
              "threeeighths",
              "fiveeighths",
              "seveneighths",
              "onethird",
              "twothirds",
              "",
              "",
              "",
              "",
              "",
              "",
              "ff",
              "fi",
              "fl",
              "ffi",
              "ffl",
              "parenleftinferior",
              "",
              "parenrightinferior",
              "Circumflexsmall",
              "hypheninferior",
              "Gravesmall",
              "Asmall",
              "Bsmall",
              "Csmall",
              "Dsmall",
              "Esmall",
              "Fsmall",
              "Gsmall",
              "Hsmall",
              "Ismall",
              "Jsmall",
              "Ksmall",
              "Lsmall",
              "Msmall",
              "Nsmall",
              "Osmall",
              "Psmall",
              "Qsmall",
              "Rsmall",
              "Ssmall",
              "Tsmall",
              "Usmall",
              "Vsmall",
              "Wsmall",
              "Xsmall",
              "Ysmall",
              "Zsmall",
              "colonmonetary",
              "onefitted",
              "rupiah",
              "Tildesmall",
              "",
              "",
              "asuperior",
              "centsuperior",
              "",
              "",
              "",
              "",
              "Aacutesmall",
              "Agravesmall",
              "Acircumflexsmall",
              "Adieresissmall",
              "Atildesmall",
              "Aringsmall",
              "Ccedillasmall",
              "Eacutesmall",
              "Egravesmall",
              "Ecircumflexsmall",
              "Edieresissmall",
              "Iacutesmall",
              "Igravesmall",
              "Icircumflexsmall",
              "Idieresissmall",
              "Ntildesmall",
              "Oacutesmall",
              "Ogravesmall",
              "Ocircumflexsmall",
              "Odieresissmall",
              "Otildesmall",
              "Uacutesmall",
              "Ugravesmall",
              "Ucircumflexsmall",
              "Udieresissmall",
              "",
              "eightsuperior",
              "fourinferior",
              "threeinferior",
              "sixinferior",
              "eightinferior",
              "seveninferior",
              "Scaronsmall",
              "",
              "centinferior",
              "twoinferior",
              "",
              "Dieresissmall",
              "",
              "Caronsmall",
              "osuperior",
              "fiveinferior",
              "",
              "commainferior",
              "periodinferior",
              "Yacutesmall",
              "",
              "dollarinferior",
              "",
              "Thornsmall",
              "",
              "nineinferior",
              "zeroinferior",
              "Zcaronsmall",
              "AEsmall",
              "Oslashsmall",
              "questiondownsmall",
              "oneinferior",
              "Lslashsmall",
              "",
              "",
              "",
              "",
              "",
              "",
              "Cedillasmall",
              "",
              "",
              "",
              "",
              "",
              "OEsmall",
              "figuredash",
              "hyphensuperior",
              "",
              "",
              "",
              "",
              "exclamdownsmall",
              "",
              "Ydieresissmall",
              "",
              "onesuperior",
              "twosuperior",
              "threesuperior",
              "foursuperior",
              "fivesuperior",
              "sixsuperior",
              "sevensuperior",
              "ninesuperior",
              "zerosuperior",
              "",
              "esuperior",
              "rsuperior",
              "tsuperior",
              "",
              "",
              "isuperior",
              "ssuperior",
              "dsuperior",
              "",
              "",
              "",
              "",
              "",
              "lsuperior",
              "Ogoneksmall",
              "Brevesmall",
              "Macronsmall",
              "bsuperior",
              "nsuperior",
              "msuperior",
              "commasuperior",
              "periodsuperior",
              "Dotaccentsmall",
              "Ringsmall",
            ],
            MacRomanEncoding = [
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "space",
              "exclam",
              "quotedbl",
              "numbersign",
              "dollar",
              "percent",
              "ampersand",
              "quotesingle",
              "parenleft",
              "parenright",
              "asterisk",
              "plus",
              "comma",
              "hyphen",
              "period",
              "slash",
              "zero",
              "one",
              "two",
              "three",
              "four",
              "five",
              "six",
              "seven",
              "eight",
              "nine",
              "colon",
              "semicolon",
              "less",
              "equal",
              "greater",
              "question",
              "at",
              "A",
              "B",
              "C",
              "D",
              "E",
              "F",
              "G",
              "H",
              "I",
              "J",
              "K",
              "L",
              "M",
              "N",
              "O",
              "P",
              "Q",
              "R",
              "S",
              "T",
              "U",
              "V",
              "W",
              "X",
              "Y",
              "Z",
              "bracketleft",
              "backslash",
              "bracketright",
              "asciicircum",
              "underscore",
              "grave",
              "a",
              "b",
              "c",
              "d",
              "e",
              "f",
              "g",
              "h",
              "i",
              "j",
              "k",
              "l",
              "m",
              "n",
              "o",
              "p",
              "q",
              "r",
              "s",
              "t",
              "u",
              "v",
              "w",
              "x",
              "y",
              "z",
              "braceleft",
              "bar",
              "braceright",
              "asciitilde",
              "",
              "Adieresis",
              "Aring",
              "Ccedilla",
              "Eacute",
              "Ntilde",
              "Odieresis",
              "Udieresis",
              "aacute",
              "agrave",
              "acircumflex",
              "adieresis",
              "atilde",
              "aring",
              "ccedilla",
              "eacute",
              "egrave",
              "ecircumflex",
              "edieresis",
              "iacute",
              "igrave",
              "icircumflex",
              "idieresis",
              "ntilde",
              "oacute",
              "ograve",
              "ocircumflex",
              "odieresis",
              "otilde",
              "uacute",
              "ugrave",
              "ucircumflex",
              "udieresis",
              "dagger",
              "degree",
              "cent",
              "sterling",
              "section",
              "bullet",
              "paragraph",
              "germandbls",
              "registered",
              "copyright",
              "trademark",
              "acute",
              "dieresis",
              "notequal",
              "AE",
              "Oslash",
              "infinity",
              "plusminus",
              "lessequal",
              "greaterequal",
              "yen",
              "mu",
              "partialdiff",
              "summation",
              "product",
              "pi",
              "integral",
              "ordfeminine",
              "ordmasculine",
              "Omega",
              "ae",
              "oslash",
              "questiondown",
              "exclamdown",
              "logicalnot",
              "radical",
              "florin",
              "approxequal",
              "Delta",
              "guillemotleft",
              "guillemotright",
              "ellipsis",
              "space",
              "Agrave",
              "Atilde",
              "Otilde",
              "OE",
              "oe",
              "endash",
              "emdash",
              "quotedblleft",
              "quotedblright",
              "quoteleft",
              "quoteright",
              "divide",
              "lozenge",
              "ydieresis",
              "Ydieresis",
              "fraction",
              "currency",
              "guilsinglleft",
              "guilsinglright",
              "fi",
              "fl",
              "daggerdbl",
              "periodcentered",
              "quotesinglbase",
              "quotedblbase",
              "perthousand",
              "Acircumflex",
              "Ecircumflex",
              "Aacute",
              "Edieresis",
              "Egrave",
              "Iacute",
              "Icircumflex",
              "Idieresis",
              "Igrave",
              "Oacute",
              "Ocircumflex",
              "apple",
              "Ograve",
              "Uacute",
              "Ucircumflex",
              "Ugrave",
              "dotlessi",
              "circumflex",
              "tilde",
              "macron",
              "breve",
              "dotaccent",
              "ring",
              "cedilla",
              "hungarumlaut",
              "ogonek",
              "caron",
            ],
            StandardEncoding = [
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "space",
              "exclam",
              "quotedbl",
              "numbersign",
              "dollar",
              "percent",
              "ampersand",
              "quoteright",
              "parenleft",
              "parenright",
              "asterisk",
              "plus",
              "comma",
              "hyphen",
              "period",
              "slash",
              "zero",
              "one",
              "two",
              "three",
              "four",
              "five",
              "six",
              "seven",
              "eight",
              "nine",
              "colon",
              "semicolon",
              "less",
              "equal",
              "greater",
              "question",
              "at",
              "A",
              "B",
              "C",
              "D",
              "E",
              "F",
              "G",
              "H",
              "I",
              "J",
              "K",
              "L",
              "M",
              "N",
              "O",
              "P",
              "Q",
              "R",
              "S",
              "T",
              "U",
              "V",
              "W",
              "X",
              "Y",
              "Z",
              "bracketleft",
              "backslash",
              "bracketright",
              "asciicircum",
              "underscore",
              "quoteleft",
              "a",
              "b",
              "c",
              "d",
              "e",
              "f",
              "g",
              "h",
              "i",
              "j",
              "k",
              "l",
              "m",
              "n",
              "o",
              "p",
              "q",
              "r",
              "s",
              "t",
              "u",
              "v",
              "w",
              "x",
              "y",
              "z",
              "braceleft",
              "bar",
              "braceright",
              "asciitilde",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "exclamdown",
              "cent",
              "sterling",
              "fraction",
              "yen",
              "florin",
              "section",
              "currency",
              "quotesingle",
              "quotedblleft",
              "guillemotleft",
              "guilsinglleft",
              "guilsinglright",
              "fi",
              "fl",
              "",
              "endash",
              "dagger",
              "daggerdbl",
              "periodcentered",
              "",
              "paragraph",
              "bullet",
              "quotesinglbase",
              "quotedblbase",
              "quotedblright",
              "guillemotright",
              "ellipsis",
              "perthousand",
              "",
              "questiondown",
              "",
              "grave",
              "acute",
              "circumflex",
              "tilde",
              "macron",
              "breve",
              "dotaccent",
              "dieresis",
              "",
              "ring",
              "cedilla",
              "",
              "hungarumlaut",
              "ogonek",
              "caron",
              "emdash",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "AE",
              "",
              "ordfeminine",
              "",
              "",
              "",
              "",
              "Lslash",
              "Oslash",
              "OE",
              "ordmasculine",
              "",
              "",
              "",
              "",
              "",
              "ae",
              "",
              "",
              "",
              "dotlessi",
              "",
              "",
              "lslash",
              "oslash",
              "oe",
              "germandbls",
            ],
            WinAnsiEncoding = [
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "space",
              "exclam",
              "quotedbl",
              "numbersign",
              "dollar",
              "percent",
              "ampersand",
              "quotesingle",
              "parenleft",
              "parenright",
              "asterisk",
              "plus",
              "comma",
              "hyphen",
              "period",
              "slash",
              "zero",
              "one",
              "two",
              "three",
              "four",
              "five",
              "six",
              "seven",
              "eight",
              "nine",
              "colon",
              "semicolon",
              "less",
              "equal",
              "greater",
              "question",
              "at",
              "A",
              "B",
              "C",
              "D",
              "E",
              "F",
              "G",
              "H",
              "I",
              "J",
              "K",
              "L",
              "M",
              "N",
              "O",
              "P",
              "Q",
              "R",
              "S",
              "T",
              "U",
              "V",
              "W",
              "X",
              "Y",
              "Z",
              "bracketleft",
              "backslash",
              "bracketright",
              "asciicircum",
              "underscore",
              "grave",
              "a",
              "b",
              "c",
              "d",
              "e",
              "f",
              "g",
              "h",
              "i",
              "j",
              "k",
              "l",
              "m",
              "n",
              "o",
              "p",
              "q",
              "r",
              "s",
              "t",
              "u",
              "v",
              "w",
              "x",
              "y",
              "z",
              "braceleft",
              "bar",
              "braceright",
              "asciitilde",
              "bullet",
              "Euro",
              "bullet",
              "quotesinglbase",
              "florin",
              "quotedblbase",
              "ellipsis",
              "dagger",
              "daggerdbl",
              "circumflex",
              "perthousand",
              "Scaron",
              "guilsinglleft",
              "OE",
              "bullet",
              "Zcaron",
              "bullet",
              "bullet",
              "quoteleft",
              "quoteright",
              "quotedblleft",
              "quotedblright",
              "bullet",
              "endash",
              "emdash",
              "tilde",
              "trademark",
              "scaron",
              "guilsinglright",
              "oe",
              "bullet",
              "zcaron",
              "Ydieresis",
              "space",
              "exclamdown",
              "cent",
              "sterling",
              "currency",
              "yen",
              "brokenbar",
              "section",
              "dieresis",
              "copyright",
              "ordfeminine",
              "guillemotleft",
              "logicalnot",
              "hyphen",
              "registered",
              "macron",
              "degree",
              "plusminus",
              "twosuperior",
              "threesuperior",
              "acute",
              "mu",
              "paragraph",
              "periodcentered",
              "cedilla",
              "onesuperior",
              "ordmasculine",
              "guillemotright",
              "onequarter",
              "onehalf",
              "threequarters",
              "questiondown",
              "Agrave",
              "Aacute",
              "Acircumflex",
              "Atilde",
              "Adieresis",
              "Aring",
              "AE",
              "Ccedilla",
              "Egrave",
              "Eacute",
              "Ecircumflex",
              "Edieresis",
              "Igrave",
              "Iacute",
              "Icircumflex",
              "Idieresis",
              "Eth",
              "Ntilde",
              "Ograve",
              "Oacute",
              "Ocircumflex",
              "Otilde",
              "Odieresis",
              "multiply",
              "Oslash",
              "Ugrave",
              "Uacute",
              "Ucircumflex",
              "Udieresis",
              "Yacute",
              "Thorn",
              "germandbls",
              "agrave",
              "aacute",
              "acircumflex",
              "atilde",
              "adieresis",
              "aring",
              "ae",
              "ccedilla",
              "egrave",
              "eacute",
              "ecircumflex",
              "edieresis",
              "igrave",
              "iacute",
              "icircumflex",
              "idieresis",
              "eth",
              "ntilde",
              "ograve",
              "oacute",
              "ocircumflex",
              "otilde",
              "odieresis",
              "divide",
              "oslash",
              "ugrave",
              "uacute",
              "ucircumflex",
              "udieresis",
              "yacute",
              "thorn",
              "ydieresis",
            ],
            SymbolSetEncoding = [
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "space",
              "exclam",
              "universal",
              "numbersign",
              "existential",
              "percent",
              "ampersand",
              "suchthat",
              "parenleft",
              "parenright",
              "asteriskmath",
              "plus",
              "comma",
              "minus",
              "period",
              "slash",
              "zero",
              "one",
              "two",
              "three",
              "four",
              "five",
              "six",
              "seven",
              "eight",
              "nine",
              "colon",
              "semicolon",
              "less",
              "equal",
              "greater",
              "question",
              "congruent",
              "Alpha",
              "Beta",
              "Chi",
              "Delta",
              "Epsilon",
              "Phi",
              "Gamma",
              "Eta",
              "Iota",
              "theta1",
              "Kappa",
              "Lambda",
              "Mu",
              "Nu",
              "Omicron",
              "Pi",
              "Theta",
              "Rho",
              "Sigma",
              "Tau",
              "Upsilon",
              "sigma1",
              "Omega",
              "Xi",
              "Psi",
              "Zeta",
              "bracketleft",
              "therefore",
              "bracketright",
              "perpendicular",
              "underscore",
              "radicalex",
              "alpha",
              "beta",
              "chi",
              "delta",
              "epsilon",
              "phi",
              "gamma",
              "eta",
              "iota",
              "phi1",
              "kappa",
              "lambda",
              "mu",
              "nu",
              "omicron",
              "pi",
              "theta",
              "rho",
              "sigma",
              "tau",
              "upsilon",
              "omega1",
              "omega",
              "xi",
              "psi",
              "zeta",
              "braceleft",
              "bar",
              "braceright",
              "similar",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "Euro",
              "Upsilon1",
              "minute",
              "lessequal",
              "fraction",
              "infinity",
              "florin",
              "club",
              "diamond",
              "heart",
              "spade",
              "arrowboth",
              "arrowleft",
              "arrowup",
              "arrowright",
              "arrowdown",
              "degree",
              "plusminus",
              "second",
              "greaterequal",
              "multiply",
              "proportional",
              "partialdiff",
              "bullet",
              "divide",
              "notequal",
              "equivalence",
              "approxequal",
              "ellipsis",
              "arrowvertex",
              "arrowhorizex",
              "carriagereturn",
              "aleph",
              "Ifraktur",
              "Rfraktur",
              "weierstrass",
              "circlemultiply",
              "circleplus",
              "emptyset",
              "intersection",
              "union",
              "propersuperset",
              "reflexsuperset",
              "notsubset",
              "propersubset",
              "reflexsubset",
              "element",
              "notelement",
              "angle",
              "gradient",
              "registerserif",
              "copyrightserif",
              "trademarkserif",
              "product",
              "radical",
              "dotmath",
              "logicalnot",
              "logicaland",
              "logicalor",
              "arrowdblboth",
              "arrowdblleft",
              "arrowdblup",
              "arrowdblright",
              "arrowdbldown",
              "lozenge",
              "angleleft",
              "registersans",
              "copyrightsans",
              "trademarksans",
              "summation",
              "parenlefttp",
              "parenleftex",
              "parenleftbt",
              "bracketlefttp",
              "bracketleftex",
              "bracketleftbt",
              "bracelefttp",
              "braceleftmid",
              "braceleftbt",
              "braceex",
              "",
              "angleright",
              "integral",
              "integraltp",
              "integralex",
              "integralbt",
              "parenrighttp",
              "parenrightex",
              "parenrightbt",
              "bracketrighttp",
              "bracketrightex",
              "bracketrightbt",
              "bracerighttp",
              "bracerightmid",
              "bracerightbt",
            ],
            ZapfDingbatsEncoding = [
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "space",
              "a1",
              "a2",
              "a202",
              "a3",
              "a4",
              "a5",
              "a119",
              "a118",
              "a117",
              "a11",
              "a12",
              "a13",
              "a14",
              "a15",
              "a16",
              "a105",
              "a17",
              "a18",
              "a19",
              "a20",
              "a21",
              "a22",
              "a23",
              "a24",
              "a25",
              "a26",
              "a27",
              "a28",
              "a6",
              "a7",
              "a8",
              "a9",
              "a10",
              "a29",
              "a30",
              "a31",
              "a32",
              "a33",
              "a34",
              "a35",
              "a36",
              "a37",
              "a38",
              "a39",
              "a40",
              "a41",
              "a42",
              "a43",
              "a44",
              "a45",
              "a46",
              "a47",
              "a48",
              "a49",
              "a50",
              "a51",
              "a52",
              "a53",
              "a54",
              "a55",
              "a56",
              "a57",
              "a58",
              "a59",
              "a60",
              "a61",
              "a62",
              "a63",
              "a64",
              "a65",
              "a66",
              "a67",
              "a68",
              "a69",
              "a70",
              "a71",
              "a72",
              "a73",
              "a74",
              "a203",
              "a75",
              "a204",
              "a76",
              "a77",
              "a78",
              "a79",
              "a81",
              "a82",
              "a83",
              "a84",
              "a97",
              "a98",
              "a99",
              "a100",
              "",
              "a89",
              "a90",
              "a93",
              "a94",
              "a91",
              "a92",
              "a205",
              "a85",
              "a206",
              "a86",
              "a87",
              "a88",
              "a95",
              "a96",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "",
              "a101",
              "a102",
              "a103",
              "a104",
              "a106",
              "a107",
              "a108",
              "a112",
              "a111",
              "a110",
              "a109",
              "a120",
              "a121",
              "a122",
              "a123",
              "a124",
              "a125",
              "a126",
              "a127",
              "a128",
              "a129",
              "a130",
              "a131",
              "a132",
              "a133",
              "a134",
              "a135",
              "a136",
              "a137",
              "a138",
              "a139",
              "a140",
              "a141",
              "a142",
              "a143",
              "a144",
              "a145",
              "a146",
              "a147",
              "a148",
              "a149",
              "a150",
              "a151",
              "a152",
              "a153",
              "a154",
              "a155",
              "a156",
              "a157",
              "a158",
              "a159",
              "a160",
              "a161",
              "a163",
              "a164",
              "a196",
              "a165",
              "a192",
              "a166",
              "a167",
              "a168",
              "a169",
              "a170",
              "a171",
              "a172",
              "a173",
              "a162",
              "a174",
              "a175",
              "a176",
              "a177",
              "a178",
              "a179",
              "a193",
              "a180",
              "a199",
              "a181",
              "a200",
              "a182",
              "",
              "a201",
              "a183",
              "a184",
              "a197",
              "a185",
              "a194",
              "a198",
              "a186",
              "a195",
              "a187",
              "a188",
              "a189",
              "a190",
              "a191",
            ];
          (exports.WinAnsiEncoding = WinAnsiEncoding),
            (exports.StandardEncoding = StandardEncoding),
            (exports.MacRomanEncoding = MacRomanEncoding),
            (exports.SymbolSetEncoding = SymbolSetEncoding),
            (exports.ZapfDingbatsEncoding = ZapfDingbatsEncoding),
            (exports.ExpertEncoding = ExpertEncoding),
            (exports.getEncoding = getEncoding);
        })((root.pdfjsCoreEncodings = {}));
      })(this),
      (function (root, factory) {
        !(function (exports) {
          function setVerbosityLevel(level) {
            verbosity = level;
          }
          function getVerbosityLevel() {
            return verbosity;
          }
          function info(msg) {
            verbosity >= VERBOSITY_LEVELS.infos && console.log("Info: " + msg);
          }
          function warn(msg) {
            verbosity >= VERBOSITY_LEVELS.warnings && console.log("Warning: " + msg);
          }
          function deprecated(details) {
            console.log("Deprecated API usage: " + details);
          }
          function error(msg) {
            throw (
              (verbosity >= VERBOSITY_LEVELS.errors && (console.log("Error: " + msg), console.log(backtrace())),
              new Error(msg))
            );
          }
          function backtrace() {
            try {
              throw new Error();
            } catch (e) {
              return e.stack ? e.stack.split("\n").slice(2).join("\n") : "";
            }
          }
          function assert(cond, msg) {
            cond || error(msg);
          }
          function isSameOrigin(baseUrl, otherUrl) {
            try {
              var base = new URL(baseUrl);
              if (!base.origin || "null" === base.origin) return !1;
            } catch (e) {
              return !1;
            }
            var other = new URL(otherUrl, base);
            return base.origin === other.origin;
          }
          function isValidUrl(url, allowRelative) {
            if (!url || "string" != typeof url) return !1;
            var protocol = /^[a-z][a-z0-9+\-.]*(?=:)/i.exec(url);
            if (!protocol) return allowRelative;
            switch ((protocol = protocol[0].toLowerCase())) {
              case "http":
              case "https":
              case "ftp":
              case "mailto":
              case "tel":
                return !0;
              default:
                return !1;
            }
          }
          function shadow(obj, prop, value) {
            return (
              Object.defineProperty(obj, prop, { value: value, enumerable: !0, configurable: !0, writable: !1 }), value
            );
          }
          function getLookupTableFactory(initializer) {
            var lookup;
            return function () {
              return initializer && ((lookup = Object.create(null)), initializer(lookup), (initializer = null)), lookup;
            };
          }
          function removeNullCharacters(str) {
            return "string" != typeof str
              ? (warn("The argument for removeNullCharacters must be a string."), str)
              : str.replace(NullCharactersRegExp, "");
          }
          function bytesToString(bytes) {
            assert(
              null !== bytes && "object" == typeof bytes && void 0 !== bytes.length,
              "Invalid argument for bytesToString"
            );
            var length = bytes.length;
            if (length < 8192) return String.fromCharCode.apply(null, bytes);
            for (var strBuf = [], i = 0; i < length; i += 8192) {
              var chunkEnd = Math.min(i + 8192, length),
                chunk = bytes.subarray(i, chunkEnd);
              strBuf.push(String.fromCharCode.apply(null, chunk));
            }
            return strBuf.join("");
          }
          function stringToBytes(str) {
            assert("string" == typeof str, "Invalid argument for stringToBytes");
            for (var length = str.length, bytes = new Uint8Array(length), i = 0; i < length; ++i)
              bytes[i] = 255 & str.charCodeAt(i);
            return bytes;
          }
          function arrayByteLength(arr) {
            return void 0 !== arr.length ? arr.length : (assert(void 0 !== arr.byteLength), arr.byteLength);
          }
          function arraysToBytes(arr) {
            if (1 === arr.length && arr[0] instanceof Uint8Array) return arr[0];
            var i,
              item,
              itemLength,
              resultLength = 0,
              ii = arr.length;
            for (i = 0; i < ii; i++)
              (item = arr[i]), (itemLength = arrayByteLength(item)), (resultLength += itemLength);
            var pos = 0,
              data = new Uint8Array(resultLength);
            for (i = 0; i < ii; i++)
              (item = arr[i]),
                item instanceof Uint8Array ||
                  (item = "string" == typeof item ? stringToBytes(item) : new Uint8Array(item)),
                (itemLength = item.byteLength),
                data.set(item, pos),
                (pos += itemLength);
            return data;
          }
          function string32(value) {
            return String.fromCharCode((value >> 24) & 255, (value >> 16) & 255, (value >> 8) & 255, 255 & value);
          }
          function log2(x) {
            for (var n = 1, i = 0; x > n; ) (n <<= 1), i++;
            return i;
          }
          function readInt8(data, start) {
            return (data[start] << 24) >> 24;
          }
          function readUint16(data, offset) {
            return (data[offset] << 8) | data[offset + 1];
          }
          function readUint32(data, offset) {
            return ((data[offset] << 24) | (data[offset + 1] << 16) | (data[offset + 2] << 8) | data[offset + 3]) >>> 0;
          }
          function isLittleEndian() {
            var buffer8 = new Uint8Array(2);
            return (buffer8[0] = 1), 1 === new Uint16Array(buffer8.buffer)[0];
          }
          function isEvalSupported() {
            try {
              return new Function(""), !0;
            } catch (e) {
              return !1;
            }
          }
          function stringToPDFString(str) {
            var i,
              n = str.length,
              strBuf = [];
            if ("þ" === str[0] && "ÿ" === str[1])
              for (i = 2; i < n; i += 2)
                strBuf.push(String.fromCharCode((str.charCodeAt(i) << 8) | str.charCodeAt(i + 1)));
            else
              for (i = 0; i < n; ++i) {
                var code = PDFStringTranslateTable[str.charCodeAt(i)];
                strBuf.push(code ? String.fromCharCode(code) : str.charAt(i));
              }
            return strBuf.join("");
          }
          function stringToUTF8String(str) {
            return decodeURIComponent(escape(str));
          }
          function utf8StringToString(str) {
            return unescape(encodeURIComponent(str));
          }
          function isEmptyObj(obj) {
            for (var key in obj) return !1;
            return !0;
          }
          function isBool(v) {
            return "boolean" == typeof v;
          }
          function isInt(v) {
            return "number" == typeof v && (0 | v) === v;
          }
          function isNum(v) {
            return "number" == typeof v;
          }
          function isString(v) {
            return "string" == typeof v;
          }
          function isArray(v) {
            return v instanceof Array;
          }
          function isArrayBuffer(v) {
            return "object" == typeof v && null !== v && void 0 !== v.byteLength;
          }
          function isSpace(ch) {
            return 32 === ch || 9 === ch || 13 === ch || 10 === ch;
          }
          function createPromiseCapability() {
            var capability = {};
            return (
              (capability.promise = new Promise(function (resolve, reject) {
                (capability.resolve = resolve), (capability.reject = reject);
              })),
              capability
            );
          }
          function MessageHandler(sourceName, targetName, comObj) {
            (this.sourceName = sourceName),
              (this.targetName = targetName),
              (this.comObj = comObj),
              (this.callbackIndex = 1),
              (this.postMessageTransfers = !0);
            var callbacksCapabilities = (this.callbacksCapabilities = Object.create(null)),
              ah = (this.actionHandler = Object.create(null));
            (this._onComObjOnMessage = function (event) {
              var data = event.data;
              if (data.targetName === this.sourceName)
                if (data.isReply) {
                  var callbackId = data.callbackId;
                  if (data.callbackId in callbacksCapabilities) {
                    var callback = callbacksCapabilities[callbackId];
                    delete callbacksCapabilities[callbackId],
                      "error" in data ? callback.reject(data.error) : callback.resolve(data.data);
                  } else error("Cannot resolve callback " + callbackId);
                } else if (data.action in ah) {
                  var action = ah[data.action];
                  if (data.callbackId) {
                    var sourceName = this.sourceName,
                      targetName = data.sourceName;
                    Promise.resolve()
                      .then(function () {
                        return action[0].call(action[1], data.data);
                      })
                      .then(
                        function (result) {
                          comObj.postMessage({
                            sourceName: sourceName,
                            targetName: targetName,
                            isReply: !0,
                            callbackId: data.callbackId,
                            data: result,
                          });
                        },
                        function (reason) {
                          reason instanceof Error && (reason += ""),
                            comObj.postMessage({
                              sourceName: sourceName,
                              targetName: targetName,
                              isReply: !0,
                              callbackId: data.callbackId,
                              error: reason,
                            });
                        }
                      );
                  } else action[0].call(action[1], data.data);
                } else error("Unknown action from worker: " + data.action);
            }.bind(this)),
              comObj.addEventListener("message", this._onComObjOnMessage);
          }
          function loadJpegStream(id, imageUrl, objs) {
            var img = new Image();
            (img.onload = function () {
              objs.resolve(id, img);
            }),
              (img.onerror = function () {
                objs.resolve(id, null), warn("Error during JPEG image loading");
              }),
              (img.src = imageUrl);
          }
          var globalScope =
              "undefined" != typeof window
                ? window
                : "undefined" != typeof global
                ? global
                : "undefined" != typeof self
                ? self
                : this,
            FONT_IDENTITY_MATRIX = [0.001, 0, 0, 0.001, 0, 0],
            TextRenderingMode = {
              FILL: 0,
              STROKE: 1,
              FILL_STROKE: 2,
              INVISIBLE: 3,
              FILL_ADD_TO_PATH: 4,
              STROKE_ADD_TO_PATH: 5,
              FILL_STROKE_ADD_TO_PATH: 6,
              ADD_TO_PATH: 7,
              FILL_STROKE_MASK: 3,
              ADD_TO_PATH_FLAG: 4,
            },
            ImageKind = { GRAYSCALE_1BPP: 1, RGB_24BPP: 2, RGBA_32BPP: 3 },
            AnnotationType = {
              TEXT: 1,
              LINK: 2,
              FREETEXT: 3,
              LINE: 4,
              SQUARE: 5,
              CIRCLE: 6,
              POLYGON: 7,
              POLYLINE: 8,
              HIGHLIGHT: 9,
              UNDERLINE: 10,
              SQUIGGLY: 11,
              STRIKEOUT: 12,
              STAMP: 13,
              CARET: 14,
              INK: 15,
              POPUP: 16,
              FILEATTACHMENT: 17,
              SOUND: 18,
              MOVIE: 19,
              WIDGET: 20,
              SCREEN: 21,
              PRINTERMARK: 22,
              TRAPNET: 23,
              WATERMARK: 24,
              THREED: 25,
              REDACT: 26,
            },
            AnnotationFlag = {
              INVISIBLE: 1,
              HIDDEN: 2,
              PRINT: 4,
              NOZOOM: 8,
              NOROTATE: 16,
              NOVIEW: 32,
              READONLY: 64,
              LOCKED: 128,
              TOGGLENOVIEW: 256,
              LOCKEDCONTENTS: 512,
            },
            AnnotationFieldFlag = {
              READONLY: 1,
              REQUIRED: 2,
              NOEXPORT: 4,
              MULTILINE: 4096,
              PASSWORD: 8192,
              NOTOGGLETOOFF: 16384,
              RADIO: 32768,
              PUSHBUTTON: 65536,
              COMBO: 131072,
              EDIT: 262144,
              SORT: 524288,
              FILESELECT: 1048576,
              MULTISELECT: 2097152,
              DONOTSPELLCHECK: 4194304,
              DONOTSCROLL: 8388608,
              COMB: 16777216,
              RICHTEXT: 33554432,
              RADIOSINUNISON: 33554432,
              COMMITONSELCHANGE: 67108864,
            },
            AnnotationBorderStyleType = { SOLID: 1, DASHED: 2, BEVELED: 3, INSET: 4, UNDERLINE: 5 },
            StreamType = { UNKNOWN: 0, FLATE: 1, LZW: 2, DCT: 3, JPX: 4, JBIG: 5, A85: 6, AHX: 7, CCF: 8, RL: 9 },
            FontType = {
              UNKNOWN: 0,
              TYPE1: 1,
              TYPE1C: 2,
              CIDFONTTYPE0: 3,
              CIDFONTTYPE0C: 4,
              TRUETYPE: 5,
              CIDFONTTYPE2: 6,
              TYPE3: 7,
              OPENTYPE: 8,
              TYPE0: 9,
              MMTYPE1: 10,
            },
            VERBOSITY_LEVELS = { errors: 0, warnings: 1, infos: 5 },
            OPS = {
              dependency: 1,
              setLineWidth: 2,
              setLineCap: 3,
              setLineJoin: 4,
              setMiterLimit: 5,
              setDash: 6,
              setRenderingIntent: 7,
              setFlatness: 8,
              setGState: 9,
              save: 10,
              restore: 11,
              transform: 12,
              moveTo: 13,
              lineTo: 14,
              curveTo: 15,
              curveTo2: 16,
              curveTo3: 17,
              closePath: 18,
              rectangle: 19,
              stroke: 20,
              closeStroke: 21,
              fill: 22,
              eoFill: 23,
              fillStroke: 24,
              eoFillStroke: 25,
              closeFillStroke: 26,
              closeEOFillStroke: 27,
              endPath: 28,
              clip: 29,
              eoClip: 30,
              beginText: 31,
              endText: 32,
              setCharSpacing: 33,
              setWordSpacing: 34,
              setHScale: 35,
              setLeading: 36,
              setFont: 37,
              setTextRenderingMode: 38,
              setTextRise: 39,
              moveText: 40,
              setLeadingMoveText: 41,
              setTextMatrix: 42,
              nextLine: 43,
              showText: 44,
              showSpacedText: 45,
              nextLineShowText: 46,
              nextLineSetSpacingShowText: 47,
              setCharWidth: 48,
              setCharWidthAndBounds: 49,
              setStrokeColorSpace: 50,
              setFillColorSpace: 51,
              setStrokeColor: 52,
              setStrokeColorN: 53,
              setFillColor: 54,
              setFillColorN: 55,
              setStrokeGray: 56,
              setFillGray: 57,
              setStrokeRGBColor: 58,
              setFillRGBColor: 59,
              setStrokeCMYKColor: 60,
              setFillCMYKColor: 61,
              shadingFill: 62,
              beginInlineImage: 63,
              beginImageData: 64,
              endInlineImage: 65,
              paintXObject: 66,
              markPoint: 67,
              markPointProps: 68,
              beginMarkedContent: 69,
              beginMarkedContentProps: 70,
              endMarkedContent: 71,
              beginCompat: 72,
              endCompat: 73,
              paintFormXObjectBegin: 74,
              paintFormXObjectEnd: 75,
              beginGroup: 76,
              endGroup: 77,
              beginAnnotations: 78,
              endAnnotations: 79,
              beginAnnotation: 80,
              endAnnotation: 81,
              paintJpegXObject: 82,
              paintImageMaskXObject: 83,
              paintImageMaskXObjectGroup: 84,
              paintImageXObject: 85,
              paintInlineImageXObject: 86,
              paintInlineImageXObjectGroup: 87,
              paintImageXObjectRepeat: 88,
              paintImageMaskXObjectRepeat: 89,
              paintSolidColorImageMask: 90,
              constructPath: 91,
            },
            verbosity = VERBOSITY_LEVELS.warnings,
            UNSUPPORTED_FEATURES = {
              unknown: "unknown",
              forms: "forms",
              javaScript: "javaScript",
              smask: "smask",
              shadingPattern: "shadingPattern",
              font: "font",
            },
            PasswordResponses = { NEED_PASSWORD: 1, INCORRECT_PASSWORD: 2 },
            PasswordException = (function () {
              function PasswordException(msg, code) {
                (this.name = "PasswordException"), (this.message = msg), (this.code = code);
              }
              return (
                (PasswordException.prototype = new Error()),
                (PasswordException.constructor = PasswordException),
                PasswordException
              );
            })(),
            UnknownErrorException = (function () {
              function UnknownErrorException(msg, details) {
                (this.name = "UnknownErrorException"), (this.message = msg), (this.details = details);
              }
              return (
                (UnknownErrorException.prototype = new Error()),
                (UnknownErrorException.constructor = UnknownErrorException),
                UnknownErrorException
              );
            })(),
            InvalidPDFException = (function () {
              function InvalidPDFException(msg) {
                (this.name = "InvalidPDFException"), (this.message = msg);
              }
              return (
                (InvalidPDFException.prototype = new Error()),
                (InvalidPDFException.constructor = InvalidPDFException),
                InvalidPDFException
              );
            })(),
            MissingPDFException = (function () {
              function MissingPDFException(msg) {
                (this.name = "MissingPDFException"), (this.message = msg);
              }
              return (
                (MissingPDFException.prototype = new Error()),
                (MissingPDFException.constructor = MissingPDFException),
                MissingPDFException
              );
            })(),
            UnexpectedResponseException = (function () {
              function UnexpectedResponseException(msg, status) {
                (this.name = "UnexpectedResponseException"), (this.message = msg), (this.status = status);
              }
              return (
                (UnexpectedResponseException.prototype = new Error()),
                (UnexpectedResponseException.constructor = UnexpectedResponseException),
                UnexpectedResponseException
              );
            })(),
            NotImplementedException = (function () {
              function NotImplementedException(msg) {
                this.message = msg;
              }
              return (
                (NotImplementedException.prototype = new Error()),
                (NotImplementedException.prototype.name = "NotImplementedException"),
                (NotImplementedException.constructor = NotImplementedException),
                NotImplementedException
              );
            })(),
            MissingDataException = (function () {
              function MissingDataException(begin, end) {
                (this.begin = begin), (this.end = end), (this.message = "Missing data [" + begin + ", " + end + ")");
              }
              return (
                (MissingDataException.prototype = new Error()),
                (MissingDataException.prototype.name = "MissingDataException"),
                (MissingDataException.constructor = MissingDataException),
                MissingDataException
              );
            })(),
            XRefParseException = (function () {
              function XRefParseException(msg) {
                this.message = msg;
              }
              return (
                (XRefParseException.prototype = new Error()),
                (XRefParseException.prototype.name = "XRefParseException"),
                (XRefParseException.constructor = XRefParseException),
                XRefParseException
              );
            })(),
            NullCharactersRegExp = /\x00/g,
            Uint32ArrayView = (function () {
              function Uint32ArrayView(buffer, length) {
                (this.buffer = buffer),
                  (this.byteLength = buffer.length),
                  (this.length = void 0 === length ? this.byteLength >> 2 : length),
                  ensureUint32ArrayViewProps(this.length);
              }
              function createUint32ArrayProp(index) {
                return {
                  get: function () {
                    var buffer = this.buffer,
                      offset = index << 2;
                    return (
                      (buffer[offset] |
                        (buffer[offset + 1] << 8) |
                        (buffer[offset + 2] << 16) |
                        (buffer[offset + 3] << 24)) >>>
                      0
                    );
                  },
                  set: function (value) {
                    var buffer = this.buffer,
                      offset = index << 2;
                    (buffer[offset] = 255 & value),
                      (buffer[offset + 1] = (value >> 8) & 255),
                      (buffer[offset + 2] = (value >> 16) & 255),
                      (buffer[offset + 3] = (value >>> 24) & 255);
                  },
                };
              }
              function ensureUint32ArrayViewProps(length) {
                for (; uint32ArrayViewSetters < length; )
                  Object.defineProperty(
                    Uint32ArrayView.prototype,
                    uint32ArrayViewSetters,
                    createUint32ArrayProp(uint32ArrayViewSetters)
                  ),
                    uint32ArrayViewSetters++;
              }
              Uint32ArrayView.prototype = Object.create(null);
              var uint32ArrayViewSetters = 0;
              return Uint32ArrayView;
            })();
          exports.Uint32ArrayView = Uint32ArrayView;
          var IDENTITY_MATRIX = [1, 0, 0, 1, 0, 0],
            Util = (function () {
              function Util() {}
              var rgbBuf = ["rgb(", 0, ",", 0, ",", 0, ")"];
              (Util.makeCssRgb = function (r, g, b) {
                return (rgbBuf[1] = r), (rgbBuf[3] = g), (rgbBuf[5] = b), rgbBuf.join("");
              }),
                (Util.transform = function (m1, m2) {
                  return [
                    m1[0] * m2[0] + m1[2] * m2[1],
                    m1[1] * m2[0] + m1[3] * m2[1],
                    m1[0] * m2[2] + m1[2] * m2[3],
                    m1[1] * m2[2] + m1[3] * m2[3],
                    m1[0] * m2[4] + m1[2] * m2[5] + m1[4],
                    m1[1] * m2[4] + m1[3] * m2[5] + m1[5],
                  ];
                }),
                (Util.applyTransform = function (p, m) {
                  return [p[0] * m[0] + p[1] * m[2] + m[4], p[0] * m[1] + p[1] * m[3] + m[5]];
                }),
                (Util.applyInverseTransform = function (p, m) {
                  var d = m[0] * m[3] - m[1] * m[2];
                  return [
                    (p[0] * m[3] - p[1] * m[2] + m[2] * m[5] - m[4] * m[3]) / d,
                    (-p[0] * m[1] + p[1] * m[0] + m[4] * m[1] - m[5] * m[0]) / d,
                  ];
                }),
                (Util.getAxialAlignedBoundingBox = function (r, m) {
                  var p1 = Util.applyTransform(r, m),
                    p2 = Util.applyTransform(r.slice(2, 4), m),
                    p3 = Util.applyTransform([r[0], r[3]], m),
                    p4 = Util.applyTransform([r[2], r[1]], m);
                  return [
                    Math.min(p1[0], p2[0], p3[0], p4[0]),
                    Math.min(p1[1], p2[1], p3[1], p4[1]),
                    Math.max(p1[0], p2[0], p3[0], p4[0]),
                    Math.max(p1[1], p2[1], p3[1], p4[1]),
                  ];
                }),
                (Util.inverseTransform = function (m) {
                  var d = m[0] * m[3] - m[1] * m[2];
                  return [
                    m[3] / d,
                    -m[1] / d,
                    -m[2] / d,
                    m[0] / d,
                    (m[2] * m[5] - m[4] * m[3]) / d,
                    (m[4] * m[1] - m[5] * m[0]) / d,
                  ];
                }),
                (Util.apply3dTransform = function (m, v) {
                  return [
                    m[0] * v[0] + m[1] * v[1] + m[2] * v[2],
                    m[3] * v[0] + m[4] * v[1] + m[5] * v[2],
                    m[6] * v[0] + m[7] * v[1] + m[8] * v[2],
                  ];
                }),
                (Util.singularValueDecompose2dScale = function (m) {
                  var transpose = [m[0], m[2], m[1], m[3]],
                    a = m[0] * transpose[0] + m[1] * transpose[2],
                    b = m[0] * transpose[1] + m[1] * transpose[3],
                    c = m[2] * transpose[0] + m[3] * transpose[2],
                    d = m[2] * transpose[1] + m[3] * transpose[3],
                    first = (a + d) / 2,
                    second = Math.sqrt((a + d) * (a + d) - 4 * (a * d - c * b)) / 2,
                    sx = first + second || 1,
                    sy = first - second || 1;
                  return [Math.sqrt(sx), Math.sqrt(sy)];
                }),
                (Util.normalizeRect = function (rect) {
                  var r = rect.slice(0);
                  return (
                    rect[0] > rect[2] && ((r[0] = rect[2]), (r[2] = rect[0])),
                    rect[1] > rect[3] && ((r[1] = rect[3]), (r[3] = rect[1])),
                    r
                  );
                }),
                (Util.intersect = function (rect1, rect2) {
                  function compare(a, b) {
                    return a - b;
                  }
                  var orderedX = [rect1[0], rect1[2], rect2[0], rect2[2]].sort(compare),
                    orderedY = [rect1[1], rect1[3], rect2[1], rect2[3]].sort(compare),
                    result = [];
                  return (
                    (rect1 = Util.normalizeRect(rect1)),
                    (rect2 = Util.normalizeRect(rect2)),
                    ((orderedX[0] === rect1[0] && orderedX[1] === rect2[0]) ||
                      (orderedX[0] === rect2[0] && orderedX[1] === rect1[0])) &&
                      ((result[0] = orderedX[1]),
                      (result[2] = orderedX[2]),
                      ((orderedY[0] === rect1[1] && orderedY[1] === rect2[1]) ||
                        (orderedY[0] === rect2[1] && orderedY[1] === rect1[1])) &&
                        ((result[1] = orderedY[1]), (result[3] = orderedY[2]), result))
                  );
                }),
                (Util.sign = function (num) {
                  return num < 0 ? -1 : 1;
                });
              var ROMAN_NUMBER_MAP = [
                "",
                "C",
                "CC",
                "CCC",
                "CD",
                "D",
                "DC",
                "DCC",
                "DCCC",
                "CM",
                "",
                "X",
                "XX",
                "XXX",
                "XL",
                "L",
                "LX",
                "LXX",
                "LXXX",
                "XC",
                "",
                "I",
                "II",
                "III",
                "IV",
                "V",
                "VI",
                "VII",
                "VIII",
                "IX",
              ];
              return (
                (Util.toRoman = function (number, lowerCase) {
                  assert(isInt(number) && number > 0, "The number should be a positive integer.");
                  for (var pos, romanBuf = []; number >= 1e3; ) (number -= 1e3), romanBuf.push("M");
                  (pos = (number / 100) | 0),
                    (number %= 100),
                    romanBuf.push(ROMAN_NUMBER_MAP[pos]),
                    (pos = (number / 10) | 0),
                    (number %= 10),
                    romanBuf.push(ROMAN_NUMBER_MAP[10 + pos]),
                    romanBuf.push(ROMAN_NUMBER_MAP[20 + number]);
                  var romanStr = romanBuf.join("");
                  return lowerCase ? romanStr.toLowerCase() : romanStr;
                }),
                (Util.appendToArray = function (arr1, arr2) {
                  Array.prototype.push.apply(arr1, arr2);
                }),
                (Util.prependToArray = function (arr1, arr2) {
                  Array.prototype.unshift.apply(arr1, arr2);
                }),
                (Util.extendObj = function (obj1, obj2) {
                  for (var key in obj2) obj1[key] = obj2[key];
                }),
                (Util.getInheritableProperty = function (dict, name) {
                  for (; dict && !dict.has(name); ) dict = dict.get("Parent");
                  return dict ? dict.get(name) : null;
                }),
                (Util.inherit = function (sub, base, prototype) {
                  (sub.prototype = Object.create(base.prototype)), (sub.prototype.constructor = sub);
                  for (var prop in prototype) sub.prototype[prop] = prototype[prop];
                }),
                (Util.loadScript = function (src, callback) {
                  var script = document.createElement("script"),
                    loaded = !1;
                  script.setAttribute("src", src),
                    callback &&
                      (script.onload = function () {
                        loaded || callback(), (loaded = !0);
                      }),
                    document.getElementsByTagName("head")[0].appendChild(script);
                }),
                Util
              );
            })(),
            PageViewport = (function () {
              function PageViewport(viewBox, scale, rotation, offsetX, offsetY, dontFlip) {
                (this.viewBox = viewBox),
                  (this.scale = scale),
                  (this.rotation = rotation),
                  (this.offsetX = offsetX),
                  (this.offsetY = offsetY);
                var rotateA,
                  rotateB,
                  rotateC,
                  rotateD,
                  centerX = (viewBox[2] + viewBox[0]) / 2,
                  centerY = (viewBox[3] + viewBox[1]) / 2;
                switch (((rotation %= 360), (rotation = rotation < 0 ? rotation + 360 : rotation))) {
                  case 180:
                    (rotateA = -1), (rotateB = 0), (rotateC = 0), (rotateD = 1);
                    break;
                  case 90:
                    (rotateA = 0), (rotateB = 1), (rotateC = 1), (rotateD = 0);
                    break;
                  case 270:
                    (rotateA = 0), (rotateB = -1), (rotateC = -1), (rotateD = 0);
                    break;
                  default:
                    (rotateA = 1), (rotateB = 0), (rotateC = 0), (rotateD = -1);
                }
                dontFlip && ((rotateC = -rotateC), (rotateD = -rotateD));
                var offsetCanvasX, offsetCanvasY, width, height;
                0 === rotateA
                  ? ((offsetCanvasX = Math.abs(centerY - viewBox[1]) * scale + offsetX),
                    (offsetCanvasY = Math.abs(centerX - viewBox[0]) * scale + offsetY),
                    (width = Math.abs(viewBox[3] - viewBox[1]) * scale),
                    (height = Math.abs(viewBox[2] - viewBox[0]) * scale))
                  : ((offsetCanvasX = Math.abs(centerX - viewBox[0]) * scale + offsetX),
                    (offsetCanvasY = Math.abs(centerY - viewBox[1]) * scale + offsetY),
                    (width = Math.abs(viewBox[2] - viewBox[0]) * scale),
                    (height = Math.abs(viewBox[3] - viewBox[1]) * scale)),
                  (this.transform = [
                    rotateA * scale,
                    rotateB * scale,
                    rotateC * scale,
                    rotateD * scale,
                    offsetCanvasX - rotateA * scale * centerX - rotateC * scale * centerY,
                    offsetCanvasY - rotateB * scale * centerX - rotateD * scale * centerY,
                  ]),
                  (this.width = width),
                  (this.height = height),
                  (this.fontScale = scale);
              }
              return (
                (PageViewport.prototype = {
                  clone: function (args) {
                    args = args || {};
                    var scale = "scale" in args ? args.scale : this.scale,
                      rotation = "rotation" in args ? args.rotation : this.rotation;
                    return new PageViewport(
                      this.viewBox.slice(),
                      scale,
                      rotation,
                      this.offsetX,
                      this.offsetY,
                      args.dontFlip
                    );
                  },
                  convertToViewportPoint: function (x, y) {
                    return Util.applyTransform([x, y], this.transform);
                  },
                  convertToViewportRectangle: function (rect) {
                    var tl = Util.applyTransform([rect[0], rect[1]], this.transform),
                      br = Util.applyTransform([rect[2], rect[3]], this.transform);
                    return [tl[0], tl[1], br[0], br[1]];
                  },
                  convertToPdfPoint: function (x, y) {
                    return Util.applyInverseTransform([x, y], this.transform);
                  },
                }),
                PageViewport
              );
            })(),
            PDFStringTranslateTable = [
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              728,
              711,
              710,
              729,
              733,
              731,
              730,
              732,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              0,
              8226,
              8224,
              8225,
              8230,
              8212,
              8211,
              402,
              8260,
              8249,
              8250,
              8722,
              8240,
              8222,
              8220,
              8221,
              8216,
              8217,
              8218,
              8482,
              64257,
              64258,
              321,
              338,
              352,
              376,
              381,
              305,
              322,
              339,
              353,
              382,
              0,
              8364,
            ];
          !(function () {
            function Promise(resolver) {
              (this._status = STATUS_PENDING), (this._handlers = []);
              try {
                resolver.call(this, this._resolve.bind(this), this._reject.bind(this));
              } catch (e) {
                this._reject(e);
              }
            }
            if (globalScope.Promise)
              return (
                "function" != typeof globalScope.Promise.all &&
                  (globalScope.Promise.all = function (iterable) {
                    var resolve,
                      reject,
                      count = 0,
                      results = [],
                      promise = new globalScope.Promise(function (resolve_, reject_) {
                        (resolve = resolve_), (reject = reject_);
                      });
                    return (
                      iterable.forEach(function (p, i) {
                        count++,
                          p.then(function (result) {
                            (results[i] = result), 0 === --count && resolve(results);
                          }, reject);
                      }),
                      0 === count && resolve(results),
                      promise
                    );
                  }),
                "function" != typeof globalScope.Promise.resolve &&
                  (globalScope.Promise.resolve = function (value) {
                    return new globalScope.Promise(function (resolve) {
                      resolve(value);
                    });
                  }),
                "function" != typeof globalScope.Promise.reject &&
                  (globalScope.Promise.reject = function (reason) {
                    return new globalScope.Promise(function (resolve, reject) {
                      reject(reason);
                    });
                  }),
                void (
                  "function" != typeof globalScope.Promise.prototype.catch &&
                  (globalScope.Promise.prototype.catch = function (onReject) {
                    return globalScope.Promise.prototype.then(void 0, onReject);
                  })
                )
              );
            var STATUS_PENDING = 0,
              STATUS_REJECTED = 2,
              HandlerManager = {
                handlers: [],
                running: !1,
                unhandledRejections: [],
                pendingRejectionCheck: !1,
                scheduleHandlers: function (promise) {
                  promise._status !== STATUS_PENDING &&
                    ((this.handlers = this.handlers.concat(promise._handlers)),
                    (promise._handlers = []),
                    this.running || ((this.running = !0), setTimeout(this.runHandlers.bind(this), 0)));
                },
                runHandlers: function () {
                  for (var timeoutAt = Date.now() + 1; this.handlers.length > 0; ) {
                    var handler = this.handlers.shift(),
                      nextStatus = handler.thisPromise._status,
                      nextValue = handler.thisPromise._value;
                    try {
                      1 === nextStatus
                        ? "function" == typeof handler.onResolve && (nextValue = handler.onResolve(nextValue))
                        : "function" == typeof handler.onReject &&
                          ((nextValue = handler.onReject(nextValue)),
                          (nextStatus = 1),
                          handler.thisPromise._unhandledRejection &&
                            this.removeUnhandeledRejection(handler.thisPromise));
                    } catch (ex) {
                      (nextStatus = STATUS_REJECTED), (nextValue = ex);
                    }
                    if ((handler.nextPromise._updateStatus(nextStatus, nextValue), Date.now() >= timeoutAt)) break;
                  }
                  if (this.handlers.length > 0) return void setTimeout(this.runHandlers.bind(this), 0);
                  this.running = !1;
                },
                addUnhandledRejection: function (promise) {
                  this.unhandledRejections.push({ promise: promise, time: Date.now() }), this.scheduleRejectionCheck();
                },
                removeUnhandeledRejection: function (promise) {
                  promise._unhandledRejection = !1;
                  for (var i = 0; i < this.unhandledRejections.length; i++)
                    this.unhandledRejections[i].promise === promise && (this.unhandledRejections.splice(i), i--);
                },
                scheduleRejectionCheck: function () {
                  this.pendingRejectionCheck ||
                    ((this.pendingRejectionCheck = !0),
                    setTimeout(
                      function () {
                        this.pendingRejectionCheck = !1;
                        for (var now = Date.now(), i = 0; i < this.unhandledRejections.length; i++)
                          if (now - this.unhandledRejections[i].time > 500) {
                            var unhandled = this.unhandledRejections[i].promise._value,
                              msg = "Unhandled rejection: " + unhandled;
                            unhandled.stack && (msg += "\n" + unhandled.stack),
                              warn(msg),
                              this.unhandledRejections.splice(i),
                              i--;
                          }
                        this.unhandledRejections.length && this.scheduleRejectionCheck();
                      }.bind(this),
                      500
                    ));
                },
              };
            (Promise.all = function (promises) {
              function reject(reason) {
                deferred._status !== STATUS_REJECTED && ((results = []), rejectAll(reason));
              }
              var resolveAll,
                rejectAll,
                deferred = new Promise(function (resolve, reject) {
                  (resolveAll = resolve), (rejectAll = reject);
                }),
                unresolved = promises.length,
                results = [];
              if (0 === unresolved) return resolveAll(results), deferred;
              for (var i = 0, ii = promises.length; i < ii; ++i) {
                var promise = promises[i],
                  resolve = (function (i) {
                    return function (value) {
                      deferred._status !== STATUS_REJECTED &&
                        ((results[i] = value), 0 === --unresolved && resolveAll(results));
                    };
                  })(i);
                Promise.isPromise(promise) ? promise.then(resolve, reject) : resolve(promise);
              }
              return deferred;
            }),
              (Promise.isPromise = function (value) {
                return value && "function" == typeof value.then;
              }),
              (Promise.resolve = function (value) {
                return new Promise(function (resolve) {
                  resolve(value);
                });
              }),
              (Promise.reject = function (reason) {
                return new Promise(function (resolve, reject) {
                  reject(reason);
                });
              }),
              (Promise.prototype = {
                _status: null,
                _value: null,
                _handlers: null,
                _unhandledRejection: null,
                _updateStatus: function (status, value) {
                  if (1 !== this._status && this._status !== STATUS_REJECTED) {
                    if (1 === status && Promise.isPromise(value))
                      return void value.then(
                        this._updateStatus.bind(this, 1),
                        this._updateStatus.bind(this, STATUS_REJECTED)
                      );
                    (this._status = status),
                      (this._value = value),
                      status === STATUS_REJECTED &&
                        0 === this._handlers.length &&
                        ((this._unhandledRejection = !0), HandlerManager.addUnhandledRejection(this)),
                      HandlerManager.scheduleHandlers(this);
                  }
                },
                _resolve: function (value) {
                  this._updateStatus(1, value);
                },
                _reject: function (reason) {
                  this._updateStatus(STATUS_REJECTED, reason);
                },
                then: function (onResolve, onReject) {
                  var nextPromise = new Promise(function (resolve, reject) {
                    (this.resolve = resolve), (this.reject = reject);
                  });
                  return (
                    this._handlers.push({
                      thisPromise: this,
                      onResolve: onResolve,
                      onReject: onReject,
                      nextPromise: nextPromise,
                    }),
                    HandlerManager.scheduleHandlers(this),
                    nextPromise
                  );
                },
                catch: function (onReject) {
                  return this.then(void 0, onReject);
                },
              }),
              (globalScope.Promise = Promise);
          })(),
            (function () {
              function WeakMap() {
                this.id = "$weakmap" + id++;
              }
              if (!globalScope.WeakMap) {
                var id = 0;
                (WeakMap.prototype = {
                  has: function (obj) {
                    return !!Object.getOwnPropertyDescriptor(obj, this.id);
                  },
                  get: function (obj, defaultValue) {
                    return this.has(obj) ? obj[this.id] : defaultValue;
                  },
                  set: function (obj, value) {
                    Object.defineProperty(obj, this.id, { value: value, enumerable: !1, configurable: !0 });
                  },
                  delete: function (obj) {
                    delete obj[this.id];
                  },
                }),
                  (globalScope.WeakMap = WeakMap);
              }
            })();
          var StatTimer = (function () {
              function rpad(str, pad, length) {
                for (; str.length < length; ) str += pad;
                return str;
              }
              function StatTimer() {
                (this.started = Object.create(null)), (this.times = []), (this.enabled = !0);
              }
              return (
                (StatTimer.prototype = {
                  time: function (name) {
                    this.enabled &&
                      (name in this.started && warn("Timer is already running for " + name),
                      (this.started[name] = Date.now()));
                  },
                  timeEnd: function (name) {
                    this.enabled &&
                      (name in this.started || warn("Timer has not been started for " + name),
                      this.times.push({ name: name, start: this.started[name], end: Date.now() }),
                      delete this.started[name]);
                  },
                  toString: function () {
                    var i,
                      ii,
                      times = this.times,
                      out = "",
                      longest = 0;
                    for (i = 0, ii = times.length; i < ii; ++i) {
                      var name = times[i].name;
                      name.length > longest && (longest = name.length);
                    }
                    for (i = 0, ii = times.length; i < ii; ++i) {
                      var span = times[i],
                        duration = span.end - span.start;
                      out += rpad(span.name, " ", longest) + " " + duration + "ms\n";
                    }
                    return out;
                  },
                }),
                StatTimer
              );
            })(),
            createBlob = function (data, contentType) {
              if ("undefined" != typeof Blob) return new Blob([data], { type: contentType });
              warn('The "Blob" constructor is not supported.');
            },
            createObjectURL = (function () {
              var digits = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
              return function (data, contentType, forceDataSchema) {
                if (!forceDataSchema && "undefined" != typeof URL && URL.createObjectURL) {
                  var blob = createBlob(data, contentType);
                  return URL.createObjectURL(blob);
                }
                for (var buffer = "data:" + contentType + ";base64,", i = 0, ii = data.length; i < ii; i += 3) {
                  var b1 = 255 & data[i],
                    b2 = 255 & data[i + 1],
                    b3 = 255 & data[i + 2];
                  buffer +=
                    digits[b1 >> 2] +
                    digits[((3 & b1) << 4) | (b2 >> 4)] +
                    digits[i + 1 < ii ? ((15 & b2) << 2) | (b3 >> 6) : 64] +
                    digits[i + 2 < ii ? 63 & b3 : 64];
                }
                return buffer;
              };
            })();
          (MessageHandler.prototype = {
            on: function (actionName, handler, scope) {
              var ah = this.actionHandler;
              ah[actionName] && error('There is already an actionName called "' + actionName + '"'),
                (ah[actionName] = [handler, scope]);
            },
            send: function (actionName, data, transfers) {
              var message = {
                sourceName: this.sourceName,
                targetName: this.targetName,
                action: actionName,
                data: data,
              };
              this.postMessage(message, transfers);
            },
            sendWithPromise: function (actionName, data, transfers) {
              var callbackId = this.callbackIndex++,
                message = {
                  sourceName: this.sourceName,
                  targetName: this.targetName,
                  action: actionName,
                  data: data,
                  callbackId: callbackId,
                },
                capability = createPromiseCapability();
              this.callbacksCapabilities[callbackId] = capability;
              try {
                this.postMessage(message, transfers);
              } catch (e) {
                capability.reject(e);
              }
              return capability.promise;
            },
            postMessage: function (message, transfers) {
              transfers && this.postMessageTransfers
                ? this.comObj.postMessage(message, transfers)
                : this.comObj.postMessage(message);
            },
            destroy: function () {
              this.comObj.removeEventListener("message", this._onComObjOnMessage);
            },
          }),
            (function (scope) {
              function isRelativeScheme(scheme) {
                return void 0 !== relative[scheme];
              }
              function invalid() {
                clear.call(this), (this._isInvalid = !0);
              }
              function IDNAToASCII(h) {
                return "" === h && invalid.call(this), h.toLowerCase();
              }
              function percentEscape(c) {
                var unicode = c.charCodeAt(0);
                return unicode > 32 && unicode < 127 && -1 === [34, 35, 60, 62, 63, 96].indexOf(unicode)
                  ? c
                  : encodeURIComponent(c);
              }
              function percentEscapeQuery(c) {
                var unicode = c.charCodeAt(0);
                return unicode > 32 && unicode < 127 && -1 === [34, 35, 60, 62, 96].indexOf(unicode)
                  ? c
                  : encodeURIComponent(c);
              }
              function parse(input, stateOverride, base) {
                function err(message) {
                  errors.push(message);
                }
                var state = stateOverride || "scheme start",
                  cursor = 0,
                  buffer = "",
                  seenAt = !1,
                  seenBracket = !1,
                  errors = [];
                loop: for (; (input[cursor - 1] !== EOF || 0 === cursor) && !this._isInvalid; ) {
                  var c = input[cursor];
                  switch (state) {
                    case "scheme start":
                      if (!c || !ALPHA.test(c)) {
                        if (stateOverride) {
                          err("Invalid scheme.");
                          break loop;
                        }
                        (buffer = ""), (state = "no scheme");
                        continue;
                      }
                      (buffer += c.toLowerCase()), (state = "scheme");
                      break;
                    case "scheme":
                      if (c && ALPHANUMERIC.test(c)) buffer += c.toLowerCase();
                      else {
                        if (":" !== c) {
                          if (stateOverride) {
                            if (EOF === c) break loop;
                            err("Code point not allowed in scheme: " + c);
                            break loop;
                          }
                          (buffer = ""), (cursor = 0), (state = "no scheme");
                          continue;
                        }
                        if (((this._scheme = buffer), (buffer = ""), stateOverride)) break loop;
                        isRelativeScheme(this._scheme) && (this._isRelative = !0),
                          (state =
                            "file" === this._scheme
                              ? "relative"
                              : this._isRelative && base && base._scheme === this._scheme
                              ? "relative or authority"
                              : this._isRelative
                              ? "authority first slash"
                              : "scheme data");
                      }
                      break;
                    case "scheme data":
                      "?" === c
                        ? ((this._query = "?"), (state = "query"))
                        : "#" === c
                        ? ((this._fragment = "#"), (state = "fragment"))
                        : EOF !== c && "\t" !== c && "\n" !== c && "\r" !== c && (this._schemeData += percentEscape(c));
                      break;
                    case "no scheme":
                      if (base && isRelativeScheme(base._scheme)) {
                        state = "relative";
                        continue;
                      }
                      err("Missing scheme."), invalid.call(this);
                      break;
                    case "relative or authority":
                      if ("/" !== c || "/" !== input[cursor + 1]) {
                        err("Expected /, got: " + c), (state = "relative");
                        continue;
                      }
                      state = "authority ignore slashes";
                      break;
                    case "relative":
                      if (
                        ((this._isRelative = !0), "file" !== this._scheme && (this._scheme = base._scheme), EOF === c)
                      ) {
                        (this._host = base._host),
                          (this._port = base._port),
                          (this._path = base._path.slice()),
                          (this._query = base._query),
                          (this._username = base._username),
                          (this._password = base._password);
                        break loop;
                      }
                      if ("/" === c || "\\" === c)
                        "\\" === c && err("\\ is an invalid code point."), (state = "relative slash");
                      else if ("?" === c)
                        (this._host = base._host),
                          (this._port = base._port),
                          (this._path = base._path.slice()),
                          (this._query = "?"),
                          (this._username = base._username),
                          (this._password = base._password),
                          (state = "query");
                      else {
                        if ("#" !== c) {
                          var nextC = input[cursor + 1],
                            nextNextC = input[cursor + 2];
                          ("file" !== this._scheme ||
                            !ALPHA.test(c) ||
                            (":" !== nextC && "|" !== nextC) ||
                            (EOF !== nextNextC &&
                              "/" !== nextNextC &&
                              "\\" !== nextNextC &&
                              "?" !== nextNextC &&
                              "#" !== nextNextC)) &&
                            ((this._host = base._host),
                            (this._port = base._port),
                            (this._username = base._username),
                            (this._password = base._password),
                            (this._path = base._path.slice()),
                            this._path.pop()),
                            (state = "relative path");
                          continue;
                        }
                        (this._host = base._host),
                          (this._port = base._port),
                          (this._path = base._path.slice()),
                          (this._query = base._query),
                          (this._fragment = "#"),
                          (this._username = base._username),
                          (this._password = base._password),
                          (state = "fragment");
                      }
                      break;
                    case "relative slash":
                      if ("/" !== c && "\\" !== c) {
                        "file" !== this._scheme &&
                          ((this._host = base._host),
                          (this._port = base._port),
                          (this._username = base._username),
                          (this._password = base._password)),
                          (state = "relative path");
                        continue;
                      }
                      "\\" === c && err("\\ is an invalid code point."),
                        (state = "file" === this._scheme ? "file host" : "authority ignore slashes");
                      break;
                    case "authority first slash":
                      if ("/" !== c) {
                        err("Expected '/', got: " + c), (state = "authority ignore slashes");
                        continue;
                      }
                      state = "authority second slash";
                      break;
                    case "authority second slash":
                      if (((state = "authority ignore slashes"), "/" !== c)) {
                        err("Expected '/', got: " + c);
                        continue;
                      }
                      break;
                    case "authority ignore slashes":
                      if ("/" !== c && "\\" !== c) {
                        state = "authority";
                        continue;
                      }
                      err("Expected authority, got: " + c);
                      break;
                    case "authority":
                      if ("@" === c) {
                        seenAt && (err("@ already seen."), (buffer += "%40")), (seenAt = !0);
                        for (var i = 0; i < buffer.length; i++) {
                          var cp = buffer[i];
                          if ("\t" !== cp && "\n" !== cp && "\r" !== cp)
                            if (":" !== cp || null !== this._password) {
                              var tempC = percentEscape(cp);
                              null !== this._password ? (this._password += tempC) : (this._username += tempC);
                            } else this._password = "";
                          else err("Invalid whitespace in authority.");
                        }
                        buffer = "";
                      } else {
                        if (EOF === c || "/" === c || "\\" === c || "?" === c || "#" === c) {
                          (cursor -= buffer.length), (buffer = ""), (state = "host");
                          continue;
                        }
                        buffer += c;
                      }
                      break;
                    case "file host":
                      if (EOF === c || "/" === c || "\\" === c || "?" === c || "#" === c) {
                        2 !== buffer.length || !ALPHA.test(buffer[0]) || (":" !== buffer[1] && "|" !== buffer[1])
                          ? 0 === buffer.length
                            ? (state = "relative path start")
                            : ((this._host = IDNAToASCII.call(this, buffer)),
                              (buffer = ""),
                              (state = "relative path start"))
                          : (state = "relative path");
                        continue;
                      }
                      "\t" === c || "\n" === c || "\r" === c ? err("Invalid whitespace in file host.") : (buffer += c);
                      break;
                    case "host":
                    case "hostname":
                      if (":" !== c || seenBracket) {
                        if (EOF === c || "/" === c || "\\" === c || "?" === c || "#" === c) {
                          if (
                            ((this._host = IDNAToASCII.call(this, buffer)),
                            (buffer = ""),
                            (state = "relative path start"),
                            stateOverride)
                          )
                            break loop;
                          continue;
                        }
                        "\t" !== c && "\n" !== c && "\r" !== c
                          ? ("[" === c ? (seenBracket = !0) : "]" === c && (seenBracket = !1), (buffer += c))
                          : err("Invalid code point in host/hostname: " + c);
                      } else if (
                        ((this._host = IDNAToASCII.call(this, buffer)),
                        (buffer = ""),
                        (state = "port"),
                        "hostname" === stateOverride)
                      )
                        break loop;
                      break;
                    case "port":
                      if (/[0-9]/.test(c)) buffer += c;
                      else {
                        if (EOF === c || "/" === c || "\\" === c || "?" === c || "#" === c || stateOverride) {
                          if ("" !== buffer) {
                            var temp = parseInt(buffer, 10);
                            temp !== relative[this._scheme] && (this._port = temp + ""), (buffer = "");
                          }
                          if (stateOverride) break loop;
                          state = "relative path start";
                          continue;
                        }
                        "\t" === c || "\n" === c || "\r" === c
                          ? err("Invalid code point in port: " + c)
                          : invalid.call(this);
                      }
                      break;
                    case "relative path start":
                      if (
                        ("\\" === c && err("'\\' not allowed in path."),
                        (state = "relative path"),
                        "/" !== c && "\\" !== c)
                      )
                        continue;
                      break;
                    case "relative path":
                      if (EOF !== c && "/" !== c && "\\" !== c && (stateOverride || ("?" !== c && "#" !== c)))
                        "\t" !== c && "\n" !== c && "\r" !== c && (buffer += percentEscape(c));
                      else {
                        "\\" === c && err("\\ not allowed in relative path.");
                        var tmp;
                        (tmp = relativePathDotMapping[buffer.toLowerCase()]) && (buffer = tmp),
                          ".." === buffer
                            ? (this._path.pop(), "/" !== c && "\\" !== c && this._path.push(""))
                            : "." === buffer && "/" !== c && "\\" !== c
                            ? this._path.push("")
                            : "." !== buffer &&
                              ("file" === this._scheme &&
                                0 === this._path.length &&
                                2 === buffer.length &&
                                ALPHA.test(buffer[0]) &&
                                "|" === buffer[1] &&
                                (buffer = buffer[0] + ":"),
                              this._path.push(buffer)),
                          (buffer = ""),
                          "?" === c
                            ? ((this._query = "?"), (state = "query"))
                            : "#" === c && ((this._fragment = "#"), (state = "fragment"));
                      }
                      break;
                    case "query":
                      stateOverride || "#" !== c
                        ? EOF !== c && "\t" !== c && "\n" !== c && "\r" !== c && (this._query += percentEscapeQuery(c))
                        : ((this._fragment = "#"), (state = "fragment"));
                      break;
                    case "fragment":
                      EOF !== c && "\t" !== c && "\n" !== c && "\r" !== c && (this._fragment += c);
                  }
                  cursor++;
                }
              }
              function clear() {
                (this._scheme = ""),
                  (this._schemeData = ""),
                  (this._username = ""),
                  (this._password = null),
                  (this._host = ""),
                  (this._port = ""),
                  (this._path = []),
                  (this._query = ""),
                  (this._fragment = ""),
                  (this._isInvalid = !1),
                  (this._isRelative = !1);
              }
              function JURL(url, base) {
                void 0 === base || base instanceof JURL || (base = new JURL(String(base))),
                  (this._url = url),
                  clear.call(this);
                var input = url.replace(/^[ \t\r\n\f]+|[ \t\r\n\f]+$/g, "");
                parse.call(this, input, null, base);
              }
              var hasWorkingUrl = !1;
              try {
                if ("function" == typeof URL && "object" == typeof URL.prototype && "origin" in URL.prototype) {
                  var u = new URL("b", "http://a");
                  (u.pathname = "c%20d"), (hasWorkingUrl = "http://a/c%20d" === u.href);
                }
              } catch (e) {}
              if (!hasWorkingUrl) {
                var relative = Object.create(null);
                (relative.ftp = 21),
                  (relative.file = 0),
                  (relative.gopher = 70),
                  (relative.http = 80),
                  (relative.https = 443),
                  (relative.ws = 80),
                  (relative.wss = 443);
                var relativePathDotMapping = Object.create(null);
                (relativePathDotMapping["%2e"] = "."),
                  (relativePathDotMapping[".%2e"] = ".."),
                  (relativePathDotMapping["%2e."] = ".."),
                  (relativePathDotMapping["%2e%2e"] = "..");
                var EOF,
                  ALPHA = /[a-zA-Z]/,
                  ALPHANUMERIC = /[a-zA-Z0-9\+\-\.]/;
                JURL.prototype = {
                  toString: function () {
                    return this.href;
                  },
                  get href() {
                    if (this._isInvalid) return this._url;
                    var authority = "";
                    return (
                      ("" === this._username && null === this._password) ||
                        (authority = this._username + (null !== this._password ? ":" + this._password : "") + "@"),
                      this.protocol +
                        (this._isRelative ? "//" + authority + this.host : "") +
                        this.pathname +
                        this._query +
                        this._fragment
                    );
                  },
                  set href(href) {
                    clear.call(this), parse.call(this, href);
                  },
                  get protocol() {
                    return this._scheme + ":";
                  },
                  set protocol(protocol) {
                    this._isInvalid || parse.call(this, protocol + ":", "scheme start");
                  },
                  get host() {
                    return this._isInvalid ? "" : this._port ? this._host + ":" + this._port : this._host;
                  },
                  set host(host) {
                    !this._isInvalid && this._isRelative && parse.call(this, host, "host");
                  },
                  get hostname() {
                    return this._host;
                  },
                  set hostname(hostname) {
                    !this._isInvalid && this._isRelative && parse.call(this, hostname, "hostname");
                  },
                  get port() {
                    return this._port;
                  },
                  set port(port) {
                    !this._isInvalid && this._isRelative && parse.call(this, port, "port");
                  },
                  get pathname() {
                    return this._isInvalid ? "" : this._isRelative ? "/" + this._path.join("/") : this._schemeData;
                  },
                  set pathname(pathname) {
                    !this._isInvalid &&
                      this._isRelative &&
                      ((this._path = []), parse.call(this, pathname, "relative path start"));
                  },
                  get search() {
                    return this._isInvalid || !this._query || "?" === this._query ? "" : this._query;
                  },
                  set search(search) {
                    !this._isInvalid &&
                      this._isRelative &&
                      ((this._query = "?"),
                      "?" === search[0] && (search = search.slice(1)),
                      parse.call(this, search, "query"));
                  },
                  get hash() {
                    return this._isInvalid || !this._fragment || "#" === this._fragment ? "" : this._fragment;
                  },
                  set hash(hash) {
                    this._isInvalid ||
                      ((this._fragment = "#"),
                      "#" === hash[0] && (hash = hash.slice(1)),
                      parse.call(this, hash, "fragment"));
                  },
                  get origin() {
                    var host;
                    if (this._isInvalid || !this._scheme) return "";
                    switch (this._scheme) {
                      case "data":
                      case "file":
                      case "javascript":
                      case "mailto":
                        return "null";
                    }
                    return (host = this.host), host ? this._scheme + "://" + host : "";
                  },
                };
                var OriginalURL = scope.URL;
                OriginalURL &&
                  ((JURL.createObjectURL = function (blob) {
                    return OriginalURL.createObjectURL.apply(OriginalURL, arguments);
                  }),
                  (JURL.revokeObjectURL = function (url) {
                    OriginalURL.revokeObjectURL(url);
                  })),
                  (scope.URL = JURL);
              }
            })(globalScope),
            (exports.FONT_IDENTITY_MATRIX = FONT_IDENTITY_MATRIX),
            (exports.IDENTITY_MATRIX = IDENTITY_MATRIX),
            (exports.OPS = OPS),
            (exports.VERBOSITY_LEVELS = VERBOSITY_LEVELS),
            (exports.UNSUPPORTED_FEATURES = UNSUPPORTED_FEATURES),
            (exports.AnnotationBorderStyleType = AnnotationBorderStyleType),
            (exports.AnnotationFieldFlag = AnnotationFieldFlag),
            (exports.AnnotationFlag = AnnotationFlag),
            (exports.AnnotationType = AnnotationType),
            (exports.FontType = FontType),
            (exports.ImageKind = ImageKind),
            (exports.InvalidPDFException = InvalidPDFException),
            (exports.MessageHandler = MessageHandler),
            (exports.MissingDataException = MissingDataException),
            (exports.MissingPDFException = MissingPDFException),
            (exports.NotImplementedException = NotImplementedException),
            (exports.PageViewport = PageViewport),
            (exports.PasswordException = PasswordException),
            (exports.PasswordResponses = PasswordResponses),
            (exports.StatTimer = StatTimer),
            (exports.StreamType = StreamType),
            (exports.TextRenderingMode = TextRenderingMode),
            (exports.UnexpectedResponseException = UnexpectedResponseException),
            (exports.UnknownErrorException = UnknownErrorException),
            (exports.Util = Util),
            (exports.XRefParseException = XRefParseException),
            (exports.arrayByteLength = arrayByteLength),
            (exports.arraysToBytes = arraysToBytes),
            (exports.assert = assert),
            (exports.bytesToString = bytesToString),
            (exports.createBlob = createBlob),
            (exports.createPromiseCapability = createPromiseCapability),
            (exports.createObjectURL = createObjectURL),
            (exports.deprecated = deprecated),
            (exports.error = error),
            (exports.getLookupTableFactory = getLookupTableFactory),
            (exports.getVerbosityLevel = getVerbosityLevel),
            (exports.globalScope = globalScope),
            (exports.info = info),
            (exports.isArray = isArray),
            (exports.isArrayBuffer = isArrayBuffer),
            (exports.isBool = isBool),
            (exports.isEmptyObj = isEmptyObj),
            (exports.isInt = isInt),
            (exports.isNum = isNum),
            (exports.isString = isString),
            (exports.isSpace = isSpace),
            (exports.isSameOrigin = isSameOrigin),
            (exports.isValidUrl = isValidUrl),
            (exports.isLittleEndian = isLittleEndian),
            (exports.isEvalSupported = isEvalSupported),
            (exports.loadJpegStream = loadJpegStream),
            (exports.log2 = log2),
            (exports.readInt8 = readInt8),
            (exports.readUint16 = readUint16),
            (exports.readUint32 = readUint32),
            (exports.removeNullCharacters = removeNullCharacters),
            (exports.setVerbosityLevel = setVerbosityLevel),
            (exports.shadow = shadow),
            (exports.string32 = string32),
            (exports.stringToBytes = stringToBytes),
            (exports.stringToPDFString = stringToPDFString),
            (exports.stringToUTF8String = stringToUTF8String),
            (exports.utf8StringToString = utf8StringToString),
            (exports.warn = warn);
        })((root.pdfjsSharedUtil = {}));
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, coreCharsets, coreEncodings) {
          var error = sharedUtil.error,
            info = sharedUtil.info,
            bytesToString = sharedUtil.bytesToString,
            warn = sharedUtil.warn,
            isArray = sharedUtil.isArray,
            Util = sharedUtil.Util,
            stringToBytes = sharedUtil.stringToBytes,
            assert = sharedUtil.assert,
            ISOAdobeCharset = coreCharsets.ISOAdobeCharset,
            ExpertCharset = coreCharsets.ExpertCharset,
            ExpertSubsetCharset = coreCharsets.ExpertSubsetCharset,
            StandardEncoding = coreEncodings.StandardEncoding,
            ExpertEncoding = coreEncodings.ExpertEncoding,
            CFFStandardStrings = [
              ".notdef",
              "space",
              "exclam",
              "quotedbl",
              "numbersign",
              "dollar",
              "percent",
              "ampersand",
              "quoteright",
              "parenleft",
              "parenright",
              "asterisk",
              "plus",
              "comma",
              "hyphen",
              "period",
              "slash",
              "zero",
              "one",
              "two",
              "three",
              "four",
              "five",
              "six",
              "seven",
              "eight",
              "nine",
              "colon",
              "semicolon",
              "less",
              "equal",
              "greater",
              "question",
              "at",
              "A",
              "B",
              "C",
              "D",
              "E",
              "F",
              "G",
              "H",
              "I",
              "J",
              "K",
              "L",
              "M",
              "N",
              "O",
              "P",
              "Q",
              "R",
              "S",
              "T",
              "U",
              "V",
              "W",
              "X",
              "Y",
              "Z",
              "bracketleft",
              "backslash",
              "bracketright",
              "asciicircum",
              "underscore",
              "quoteleft",
              "a",
              "b",
              "c",
              "d",
              "e",
              "f",
              "g",
              "h",
              "i",
              "j",
              "k",
              "l",
              "m",
              "n",
              "o",
              "p",
              "q",
              "r",
              "s",
              "t",
              "u",
              "v",
              "w",
              "x",
              "y",
              "z",
              "braceleft",
              "bar",
              "braceright",
              "asciitilde",
              "exclamdown",
              "cent",
              "sterling",
              "fraction",
              "yen",
              "florin",
              "section",
              "currency",
              "quotesingle",
              "quotedblleft",
              "guillemotleft",
              "guilsinglleft",
              "guilsinglright",
              "fi",
              "fl",
              "endash",
              "dagger",
              "daggerdbl",
              "periodcentered",
              "paragraph",
              "bullet",
              "quotesinglbase",
              "quotedblbase",
              "quotedblright",
              "guillemotright",
              "ellipsis",
              "perthousand",
              "questiondown",
              "grave",
              "acute",
              "circumflex",
              "tilde",
              "macron",
              "breve",
              "dotaccent",
              "dieresis",
              "ring",
              "cedilla",
              "hungarumlaut",
              "ogonek",
              "caron",
              "emdash",
              "AE",
              "ordfeminine",
              "Lslash",
              "Oslash",
              "OE",
              "ordmasculine",
              "ae",
              "dotlessi",
              "lslash",
              "oslash",
              "oe",
              "germandbls",
              "onesuperior",
              "logicalnot",
              "mu",
              "trademark",
              "Eth",
              "onehalf",
              "plusminus",
              "Thorn",
              "onequarter",
              "divide",
              "brokenbar",
              "degree",
              "thorn",
              "threequarters",
              "twosuperior",
              "registered",
              "minus",
              "eth",
              "multiply",
              "threesuperior",
              "copyright",
              "Aacute",
              "Acircumflex",
              "Adieresis",
              "Agrave",
              "Aring",
              "Atilde",
              "Ccedilla",
              "Eacute",
              "Ecircumflex",
              "Edieresis",
              "Egrave",
              "Iacute",
              "Icircumflex",
              "Idieresis",
              "Igrave",
              "Ntilde",
              "Oacute",
              "Ocircumflex",
              "Odieresis",
              "Ograve",
              "Otilde",
              "Scaron",
              "Uacute",
              "Ucircumflex",
              "Udieresis",
              "Ugrave",
              "Yacute",
              "Ydieresis",
              "Zcaron",
              "aacute",
              "acircumflex",
              "adieresis",
              "agrave",
              "aring",
              "atilde",
              "ccedilla",
              "eacute",
              "ecircumflex",
              "edieresis",
              "egrave",
              "iacute",
              "icircumflex",
              "idieresis",
              "igrave",
              "ntilde",
              "oacute",
              "ocircumflex",
              "odieresis",
              "ograve",
              "otilde",
              "scaron",
              "uacute",
              "ucircumflex",
              "udieresis",
              "ugrave",
              "yacute",
              "ydieresis",
              "zcaron",
              "exclamsmall",
              "Hungarumlautsmall",
              "dollaroldstyle",
              "dollarsuperior",
              "ampersandsmall",
              "Acutesmall",
              "parenleftsuperior",
              "parenrightsuperior",
              "twodotenleader",
              "onedotenleader",
              "zerooldstyle",
              "oneoldstyle",
              "twooldstyle",
              "threeoldstyle",
              "fouroldstyle",
              "fiveoldstyle",
              "sixoldstyle",
              "sevenoldstyle",
              "eightoldstyle",
              "nineoldstyle",
              "commasuperior",
              "threequartersemdash",
              "periodsuperior",
              "questionsmall",
              "asuperior",
              "bsuperior",
              "centsuperior",
              "dsuperior",
              "esuperior",
              "isuperior",
              "lsuperior",
              "msuperior",
              "nsuperior",
              "osuperior",
              "rsuperior",
              "ssuperior",
              "tsuperior",
              "ff",
              "ffi",
              "ffl",
              "parenleftinferior",
              "parenrightinferior",
              "Circumflexsmall",
              "hyphensuperior",
              "Gravesmall",
              "Asmall",
              "Bsmall",
              "Csmall",
              "Dsmall",
              "Esmall",
              "Fsmall",
              "Gsmall",
              "Hsmall",
              "Ismall",
              "Jsmall",
              "Ksmall",
              "Lsmall",
              "Msmall",
              "Nsmall",
              "Osmall",
              "Psmall",
              "Qsmall",
              "Rsmall",
              "Ssmall",
              "Tsmall",
              "Usmall",
              "Vsmall",
              "Wsmall",
              "Xsmall",
              "Ysmall",
              "Zsmall",
              "colonmonetary",
              "onefitted",
              "rupiah",
              "Tildesmall",
              "exclamdownsmall",
              "centoldstyle",
              "Lslashsmall",
              "Scaronsmall",
              "Zcaronsmall",
              "Dieresissmall",
              "Brevesmall",
              "Caronsmall",
              "Dotaccentsmall",
              "Macronsmall",
              "figuredash",
              "hypheninferior",
              "Ogoneksmall",
              "Ringsmall",
              "Cedillasmall",
              "questiondownsmall",
              "oneeighth",
              "threeeighths",
              "fiveeighths",
              "seveneighths",
              "onethird",
              "twothirds",
              "zerosuperior",
              "foursuperior",
              "fivesuperior",
              "sixsuperior",
              "sevensuperior",
              "eightsuperior",
              "ninesuperior",
              "zeroinferior",
              "oneinferior",
              "twoinferior",
              "threeinferior",
              "fourinferior",
              "fiveinferior",
              "sixinferior",
              "seveninferior",
              "eightinferior",
              "nineinferior",
              "centinferior",
              "dollarinferior",
              "periodinferior",
              "commainferior",
              "Agravesmall",
              "Aacutesmall",
              "Acircumflexsmall",
              "Atildesmall",
              "Adieresissmall",
              "Aringsmall",
              "AEsmall",
              "Ccedillasmall",
              "Egravesmall",
              "Eacutesmall",
              "Ecircumflexsmall",
              "Edieresissmall",
              "Igravesmall",
              "Iacutesmall",
              "Icircumflexsmall",
              "Idieresissmall",
              "Ethsmall",
              "Ntildesmall",
              "Ogravesmall",
              "Oacutesmall",
              "Ocircumflexsmall",
              "Otildesmall",
              "Odieresissmall",
              "OEsmall",
              "Oslashsmall",
              "Ugravesmall",
              "Uacutesmall",
              "Ucircumflexsmall",
              "Udieresissmall",
              "Yacutesmall",
              "Thornsmall",
              "Ydieresissmall",
              "001.000",
              "001.001",
              "001.002",
              "001.003",
              "Black",
              "Bold",
              "Book",
              "Light",
              "Medium",
              "Regular",
              "Roman",
              "Semibold",
            ],
            CFFParser = (function () {
              function CFFParser(file, properties, seacAnalysisEnabled) {
                (this.bytes = file.getBytes()),
                  (this.properties = properties),
                  (this.seacAnalysisEnabled = !!seacAnalysisEnabled);
              }
              var CharstringValidationData = [
                  null,
                  { id: "hstem", min: 2, stackClearing: !0, stem: !0 },
                  null,
                  { id: "vstem", min: 2, stackClearing: !0, stem: !0 },
                  { id: "vmoveto", min: 1, stackClearing: !0 },
                  { id: "rlineto", min: 2, resetStack: !0 },
                  { id: "hlineto", min: 1, resetStack: !0 },
                  { id: "vlineto", min: 1, resetStack: !0 },
                  { id: "rrcurveto", min: 6, resetStack: !0 },
                  null,
                  { id: "callsubr", min: 1, undefStack: !0 },
                  { id: "return", min: 0, undefStack: !0 },
                  null,
                  null,
                  { id: "endchar", min: 0, stackClearing: !0 },
                  null,
                  null,
                  null,
                  { id: "hstemhm", min: 2, stackClearing: !0, stem: !0 },
                  { id: "hintmask", min: 0, stackClearing: !0 },
                  { id: "cntrmask", min: 0, stackClearing: !0 },
                  { id: "rmoveto", min: 2, stackClearing: !0 },
                  { id: "hmoveto", min: 1, stackClearing: !0 },
                  { id: "vstemhm", min: 2, stackClearing: !0, stem: !0 },
                  { id: "rcurveline", min: 8, resetStack: !0 },
                  { id: "rlinecurve", min: 8, resetStack: !0 },
                  { id: "vvcurveto", min: 4, resetStack: !0 },
                  { id: "hhcurveto", min: 4, resetStack: !0 },
                  null,
                  { id: "callgsubr", min: 1, undefStack: !0 },
                  { id: "vhcurveto", min: 4, resetStack: !0 },
                  { id: "hvcurveto", min: 4, resetStack: !0 },
                ],
                CharstringValidationData12 = [
                  null,
                  null,
                  null,
                  { id: "and", min: 2, stackDelta: -1 },
                  { id: "or", min: 2, stackDelta: -1 },
                  { id: "not", min: 1, stackDelta: 0 },
                  null,
                  null,
                  null,
                  { id: "abs", min: 1, stackDelta: 0 },
                  {
                    id: "add",
                    min: 2,
                    stackDelta: -1,
                    stackFn: function (stack, index) {
                      stack[index - 2] = stack[index - 2] + stack[index - 1];
                    },
                  },
                  {
                    id: "sub",
                    min: 2,
                    stackDelta: -1,
                    stackFn: function (stack, index) {
                      stack[index - 2] = stack[index - 2] - stack[index - 1];
                    },
                  },
                  {
                    id: "div",
                    min: 2,
                    stackDelta: -1,
                    stackFn: function (stack, index) {
                      stack[index - 2] = stack[index - 2] / stack[index - 1];
                    },
                  },
                  null,
                  {
                    id: "neg",
                    min: 1,
                    stackDelta: 0,
                    stackFn: function (stack, index) {
                      stack[index - 1] = -stack[index - 1];
                    },
                  },
                  { id: "eq", min: 2, stackDelta: -1 },
                  null,
                  null,
                  { id: "drop", min: 1, stackDelta: -1 },
                  null,
                  { id: "put", min: 2, stackDelta: -2 },
                  { id: "get", min: 1, stackDelta: 0 },
                  { id: "ifelse", min: 4, stackDelta: -3 },
                  { id: "random", min: 0, stackDelta: 1 },
                  {
                    id: "mul",
                    min: 2,
                    stackDelta: -1,
                    stackFn: function (stack, index) {
                      stack[index - 2] = stack[index - 2] * stack[index - 1];
                    },
                  },
                  null,
                  { id: "sqrt", min: 1, stackDelta: 0 },
                  { id: "dup", min: 1, stackDelta: 1 },
                  { id: "exch", min: 2, stackDelta: 0 },
                  { id: "index", min: 2, stackDelta: 0 },
                  { id: "roll", min: 3, stackDelta: -2 },
                  null,
                  null,
                  null,
                  { id: "hflex", min: 7, resetStack: !0 },
                  { id: "flex", min: 13, resetStack: !0 },
                  { id: "hflex1", min: 9, resetStack: !0 },
                  { id: "flex1", min: 11, resetStack: !0 },
                ];
              return (
                (CFFParser.prototype = {
                  parse: function () {
                    var properties = this.properties,
                      cff = new CFF();
                    this.cff = cff;
                    var header = this.parseHeader(),
                      nameIndex = this.parseIndex(header.endPos),
                      topDictIndex = this.parseIndex(nameIndex.endPos),
                      stringIndex = this.parseIndex(topDictIndex.endPos),
                      globalSubrIndex = this.parseIndex(stringIndex.endPos),
                      topDictParsed = this.parseDict(topDictIndex.obj.get(0)),
                      topDict = this.createDict(CFFTopDict, topDictParsed, cff.strings);
                    (cff.header = header.obj),
                      (cff.names = this.parseNameIndex(nameIndex.obj)),
                      (cff.strings = this.parseStringIndex(stringIndex.obj)),
                      (cff.topDict = topDict),
                      (cff.globalSubrIndex = globalSubrIndex.obj),
                      this.parsePrivateDict(cff.topDict),
                      (cff.isCIDFont = topDict.hasName("ROS"));
                    var charStringOffset = topDict.getByName("CharStrings"),
                      charStringIndex = this.parseIndex(charStringOffset).obj,
                      fontMatrix = topDict.getByName("FontMatrix");
                    fontMatrix && (properties.fontMatrix = fontMatrix);
                    var fontBBox = topDict.getByName("FontBBox");
                    fontBBox &&
                      ((properties.ascent = fontBBox[3]),
                      (properties.descent = fontBBox[1]),
                      (properties.ascentScaled = !0));
                    var charset, encoding;
                    if (cff.isCIDFont) {
                      for (
                        var fdArrayIndex = this.parseIndex(topDict.getByName("FDArray")).obj,
                          i = 0,
                          ii = fdArrayIndex.count;
                        i < ii;
                        ++i
                      ) {
                        var dictRaw = fdArrayIndex.get(i),
                          fontDict = this.createDict(CFFTopDict, this.parseDict(dictRaw), cff.strings);
                        this.parsePrivateDict(fontDict), cff.fdArray.push(fontDict);
                      }
                      (encoding = null),
                        (charset = this.parseCharsets(
                          topDict.getByName("charset"),
                          charStringIndex.count,
                          cff.strings,
                          !0
                        )),
                        (cff.fdSelect = this.parseFDSelect(topDict.getByName("FDSelect"), charStringIndex.count));
                    } else
                      (charset = this.parseCharsets(
                        topDict.getByName("charset"),
                        charStringIndex.count,
                        cff.strings,
                        !1
                      )),
                        (encoding = this.parseEncoding(
                          topDict.getByName("Encoding"),
                          properties,
                          cff.strings,
                          charset.charset
                        ));
                    (cff.charset = charset), (cff.encoding = encoding);
                    var charStringsAndSeacs = this.parseCharStrings(
                      charStringIndex,
                      topDict.privateDict.subrsIndex,
                      globalSubrIndex.obj,
                      cff.fdSelect,
                      cff.fdArray
                    );
                    return (
                      (cff.charStrings = charStringsAndSeacs.charStrings),
                      (cff.seacs = charStringsAndSeacs.seacs),
                      (cff.widths = charStringsAndSeacs.widths),
                      cff
                    );
                  },
                  parseHeader: function () {
                    for (
                      var bytes = this.bytes, bytesLength = bytes.length, offset = 0;
                      offset < bytesLength && 1 !== bytes[offset];

                    )
                      ++offset;
                    offset >= bytesLength
                      ? error("Invalid CFF header")
                      : 0 !== offset &&
                        (info("cff data is shifted"), (bytes = bytes.subarray(offset)), (this.bytes = bytes));
                    var major = bytes[0],
                      minor = bytes[1],
                      hdrSize = bytes[2],
                      offSize = bytes[3];
                    return { obj: new CFFHeader(major, minor, hdrSize, offSize), endPos: hdrSize };
                  },
                  parseDict: function (dict) {
                    function parseFloatOperand() {
                      for (
                        var str = "",
                          lookup = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", ".", "E", "E-", null, "-"],
                          length = dict.length;
                        pos < length;

                      ) {
                        var b = dict[pos++],
                          b1 = b >> 4,
                          b2 = 15 & b;
                        if (15 === b1) break;
                        if (((str += lookup[b1]), 15 === b2)) break;
                        str += lookup[b2];
                      }
                      return parseFloat(str);
                    }
                    var pos = 0,
                      operands = [],
                      entries = [];
                    pos = 0;
                    for (var end = dict.length; pos < end; ) {
                      var b = dict[pos];
                      b <= 21
                        ? (12 === b && (b = (b << 8) | dict[++pos]),
                          entries.push([b, operands]),
                          (operands = []),
                          ++pos)
                        : operands.push(
                            (function () {
                              var value = dict[pos++];
                              return 30 === value
                                ? parseFloatOperand()
                                : 28 === value
                                ? ((value = dict[pos++]), (value = ((value << 24) | (dict[pos++] << 16)) >> 16))
                                : 29 === value
                                ? ((value = dict[pos++]),
                                  (value = (value << 8) | dict[pos++]),
                                  (value = (value << 8) | dict[pos++]),
                                  (value = (value << 8) | dict[pos++]))
                                : value >= 32 && value <= 246
                                ? value - 139
                                : value >= 247 && value <= 250
                                ? 256 * (value - 247) + dict[pos++] + 108
                                : value >= 251 && value <= 254
                                ? -256 * (value - 251) - dict[pos++] - 108
                                : (error("255 is not a valid DICT command"), -1);
                            })()
                          );
                    }
                    return entries;
                  },
                  parseIndex: function (pos) {
                    var i,
                      ii,
                      cffIndex = new CFFIndex(),
                      bytes = this.bytes,
                      count = (bytes[pos++] << 8) | bytes[pos++],
                      offsets = [],
                      end = pos;
                    if (0 !== count) {
                      var offsetSize = bytes[pos++],
                        startPos = pos + (count + 1) * offsetSize - 1;
                      for (i = 0, ii = count + 1; i < ii; ++i) {
                        for (var offset = 0, j = 0; j < offsetSize; ++j) (offset <<= 8), (offset += bytes[pos++]);
                        offsets.push(startPos + offset);
                      }
                      end = offsets[count];
                    }
                    for (i = 0, ii = offsets.length - 1; i < ii; ++i) {
                      var offsetStart = offsets[i],
                        offsetEnd = offsets[i + 1];
                      cffIndex.add(bytes.subarray(offsetStart, offsetEnd));
                    }
                    return { obj: cffIndex, endPos: end };
                  },
                  parseNameIndex: function (index) {
                    for (var names = [], i = 0, ii = index.count; i < ii; ++i) {
                      for (
                        var name = index.get(i), length = Math.min(name.length, 127), data = [], j = 0;
                        j < length;
                        ++j
                      ) {
                        var c = name[j];
                        0 !== j || 0 !== c
                          ? (data[j] =
                              c < 33 ||
                              c > 126 ||
                              91 === c ||
                              93 === c ||
                              40 === c ||
                              41 === c ||
                              123 === c ||
                              125 === c ||
                              60 === c ||
                              62 === c ||
                              47 === c ||
                              37 === c ||
                              35 === c
                                ? 95
                                : c)
                          : (data[j] = c);
                      }
                      names.push(bytesToString(data));
                    }
                    return names;
                  },
                  parseStringIndex: function (index) {
                    for (var strings = new CFFStrings(), i = 0, ii = index.count; i < ii; ++i) {
                      var data = index.get(i);
                      strings.add(bytesToString(data));
                    }
                    return strings;
                  },
                  createDict: function (Type, dict, strings) {
                    for (var cffDict = new Type(strings), i = 0, ii = dict.length; i < ii; ++i) {
                      var pair = dict[i],
                        key = pair[0],
                        value = pair[1];
                      cffDict.setByKey(key, value);
                    }
                    return cffDict;
                  },
                  parseCharString: function (state, data, localSubrIndex, globalSubrIndex) {
                    if (state.callDepth > 10) return !1;
                    for (
                      var stackSize = state.stackSize, stack = state.stack, length = data.length, j = 0;
                      j < length;

                    ) {
                      var value = data[j++],
                        validationCommand = null;
                      if (12 === value) {
                        var q = data[j++];
                        0 === q
                          ? ((data[j - 2] = 139), (data[j - 1] = 22), (stackSize = 0))
                          : (validationCommand = CharstringValidationData12[q]);
                      } else if (28 === value)
                        (stack[stackSize] = ((data[j] << 24) | (data[j + 1] << 16)) >> 16), (j += 2), stackSize++;
                      else if (14 === value) {
                        if (stackSize >= 4 && ((stackSize -= 4), this.seacAnalysisEnabled))
                          return (state.seac = stack.slice(stackSize, stackSize + 4)), !1;
                        validationCommand = CharstringValidationData[value];
                      } else if (value >= 32 && value <= 246) (stack[stackSize] = value - 139), stackSize++;
                      else if (value >= 247 && value <= 254)
                        (stack[stackSize] =
                          value < 251 ? ((value - 247) << 8) + data[j] + 108 : -((value - 251) << 8) - data[j] - 108),
                          j++,
                          stackSize++;
                      else if (255 === value)
                        (stack[stackSize] =
                          ((data[j] << 24) | (data[j + 1] << 16) | (data[j + 2] << 8) | data[j + 3]) / 65536),
                          (j += 4),
                          stackSize++;
                      else if (19 === value || 20 === value)
                        (state.hints += stackSize >> 1),
                          (j += (state.hints + 7) >> 3),
                          (stackSize %= 2),
                          (validationCommand = CharstringValidationData[value]);
                      else {
                        if (10 === value || 29 === value) {
                          var subrsIndex;
                          if (!(subrsIndex = 10 === value ? localSubrIndex : globalSubrIndex))
                            return (
                              (validationCommand = CharstringValidationData[value]),
                              warn("Missing subrsIndex for " + validationCommand.id),
                              !1
                            );
                          var bias = 32768;
                          subrsIndex.count < 1240 ? (bias = 107) : subrsIndex.count < 33900 && (bias = 1131);
                          var subrNumber = stack[--stackSize] + bias;
                          if (subrNumber < 0 || subrNumber >= subrsIndex.count)
                            return (
                              (validationCommand = CharstringValidationData[value]),
                              warn("Out of bounds subrIndex for " + validationCommand.id),
                              !1
                            );
                          (state.stackSize = stackSize), state.callDepth++;
                          var valid = this.parseCharString(
                            state,
                            subrsIndex.get(subrNumber),
                            localSubrIndex,
                            globalSubrIndex
                          );
                          if (!valid) return !1;
                          state.callDepth--, (stackSize = state.stackSize);
                          continue;
                        }
                        if (11 === value) return (state.stackSize = stackSize), !0;
                        validationCommand = CharstringValidationData[value];
                      }
                      if (validationCommand) {
                        if (
                          (validationCommand.stem && (state.hints += stackSize >> 1),
                          "min" in validationCommand && !state.undefStack && stackSize < validationCommand.min)
                        )
                          return (
                            warn(
                              "Not enough parameters for " +
                                validationCommand.id +
                                "; actual: " +
                                stackSize +
                                ", expected: " +
                                validationCommand.min
                            ),
                            !1
                          );
                        state.firstStackClearing &&
                          validationCommand.stackClearing &&
                          ((state.firstStackClearing = !1),
                          (stackSize -= validationCommand.min),
                          stackSize >= 2 && validationCommand.stem
                            ? (stackSize %= 2)
                            : stackSize > 1 && warn("Found too many parameters for stack-clearing command"),
                          stackSize > 0 && stack[stackSize - 1] >= 0 && (state.width = stack[stackSize - 1])),
                          "stackDelta" in validationCommand
                            ? ("stackFn" in validationCommand && validationCommand.stackFn(stack, stackSize),
                              (stackSize += validationCommand.stackDelta))
                            : validationCommand.stackClearing
                            ? (stackSize = 0)
                            : validationCommand.resetStack
                            ? ((stackSize = 0), (state.undefStack = !1))
                            : validationCommand.undefStack &&
                              ((stackSize = 0), (state.undefStack = !0), (state.firstStackClearing = !1));
                      }
                    }
                    return (state.stackSize = stackSize), !0;
                  },
                  parseCharStrings: function (charStrings, localSubrIndex, globalSubrIndex, fdSelect, fdArray) {
                    for (var seacs = [], widths = [], count = charStrings.count, i = 0; i < count; i++) {
                      var charstring = charStrings.get(i),
                        state = {
                          callDepth: 0,
                          stackSize: 0,
                          stack: [],
                          undefStack: !0,
                          hints: 0,
                          firstStackClearing: !0,
                          seac: null,
                          width: null,
                        },
                        valid = !0,
                        localSubrToUse = null;
                      if (fdSelect && fdArray.length) {
                        var fdIndex = fdSelect.getFDIndex(i);
                        -1 === fdIndex && (warn("Glyph index is not in fd select."), (valid = !1)),
                          fdIndex >= fdArray.length && (warn("Invalid fd index for glyph index."), (valid = !1)),
                          valid && (localSubrToUse = fdArray[fdIndex].privateDict.subrsIndex);
                      } else localSubrIndex && (localSubrToUse = localSubrIndex);
                      valid && (valid = this.parseCharString(state, charstring, localSubrToUse, globalSubrIndex)),
                        null !== state.width && (widths[i] = state.width),
                        null !== state.seac && (seacs[i] = state.seac),
                        valid || charStrings.set(i, new Uint8Array([14]));
                    }
                    return { charStrings: charStrings, seacs: seacs, widths: widths };
                  },
                  emptyPrivateDictionary: function (parentDict) {
                    var privateDict = this.createDict(CFFPrivateDict, [], parentDict.strings);
                    parentDict.setByKey(18, [0, 0]), (parentDict.privateDict = privateDict);
                  },
                  parsePrivateDict: function (parentDict) {
                    if (!parentDict.hasName("Private")) return void this.emptyPrivateDictionary(parentDict);
                    var privateOffset = parentDict.getByName("Private");
                    if (!isArray(privateOffset) || 2 !== privateOffset.length)
                      return void parentDict.removeByName("Private");
                    var size = privateOffset[0],
                      offset = privateOffset[1];
                    if (0 === size || offset >= this.bytes.length) return void this.emptyPrivateDictionary(parentDict);
                    var privateDictEnd = offset + size,
                      dictData = this.bytes.subarray(offset, privateDictEnd),
                      dict = this.parseDict(dictData),
                      privateDict = this.createDict(CFFPrivateDict, dict, parentDict.strings);
                    if (((parentDict.privateDict = privateDict), privateDict.getByName("Subrs"))) {
                      var subrsOffset = privateDict.getByName("Subrs"),
                        relativeOffset = offset + subrsOffset;
                      if (0 === subrsOffset || relativeOffset >= this.bytes.length)
                        return void this.emptyPrivateDictionary(parentDict);
                      var subrsIndex = this.parseIndex(relativeOffset);
                      privateDict.subrsIndex = subrsIndex.obj;
                    }
                  },
                  parseCharsets: function (pos, length, strings, cid) {
                    if (0 === pos) return new CFFCharset(!0, CFFCharsetPredefinedTypes.ISO_ADOBE, ISOAdobeCharset);
                    if (1 === pos) return new CFFCharset(!0, CFFCharsetPredefinedTypes.EXPERT, ExpertCharset);
                    if (2 === pos)
                      return new CFFCharset(!0, CFFCharsetPredefinedTypes.EXPERT_SUBSET, ExpertSubsetCharset);
                    var id,
                      count,
                      i,
                      bytes = this.bytes,
                      start = pos,
                      format = bytes[pos++],
                      charset = [".notdef"];
                    switch (((length -= 1), format)) {
                      case 0:
                        for (i = 0; i < length; i++)
                          (id = (bytes[pos++] << 8) | bytes[pos++]), charset.push(cid ? id : strings.get(id));
                        break;
                      case 1:
                        for (; charset.length <= length; )
                          for (id = (bytes[pos++] << 8) | bytes[pos++], count = bytes[pos++], i = 0; i <= count; i++)
                            charset.push(cid ? id++ : strings.get(id++));
                        break;
                      case 2:
                        for (; charset.length <= length; )
                          for (
                            id = (bytes[pos++] << 8) | bytes[pos++], count = (bytes[pos++] << 8) | bytes[pos++], i = 0;
                            i <= count;
                            i++
                          )
                            charset.push(cid ? id++ : strings.get(id++));
                        break;
                      default:
                        error("Unknown charset format");
                    }
                    var end = pos,
                      raw = bytes.subarray(start, end);
                    return new CFFCharset(!1, format, charset, raw);
                  },
                  parseEncoding: function (pos, properties, strings, charset) {
                    var format,
                      i,
                      ii,
                      encoding = Object.create(null),
                      bytes = this.bytes,
                      predefined = !1,
                      raw = null;
                    if (0 === pos || 1 === pos) {
                      (predefined = !0), (format = pos);
                      var baseEncoding = pos ? ExpertEncoding : StandardEncoding;
                      for (i = 0, ii = charset.length; i < ii; i++) {
                        var index = baseEncoding.indexOf(charset[i]);
                        -1 !== index && (encoding[index] = i);
                      }
                    } else {
                      var dataStart = pos;
                      switch (127 & (format = bytes[pos++])) {
                        case 0:
                          var glyphsCount = bytes[pos++];
                          for (i = 1; i <= glyphsCount; i++) encoding[bytes[pos++]] = i;
                          break;
                        case 1:
                          var rangesCount = bytes[pos++],
                            gid = 1;
                          for (i = 0; i < rangesCount; i++)
                            for (var start = bytes[pos++], left = bytes[pos++], j = start; j <= start + left; j++)
                              encoding[j] = gid++;
                          break;
                        default:
                          error("Unknown encoding format: " + format + " in CFF");
                      }
                      var dataEnd = pos;
                      128 & format &&
                        ((bytes[dataStart] &= 127),
                        (function () {
                          var supplementsCount = bytes[pos++];
                          for (i = 0; i < supplementsCount; i++) {
                            var code = bytes[pos++],
                              sid = (bytes[pos++] << 8) + (255 & bytes[pos++]);
                            encoding[code] = charset.indexOf(strings.get(sid));
                          }
                        })(),
                        !0),
                        (raw = bytes.subarray(dataStart, dataEnd));
                    }
                    return (format &= 127), new CFFEncoding(predefined, format, encoding, raw);
                  },
                  parseFDSelect: function (pos, length) {
                    var rawBytes,
                      i,
                      start = pos,
                      bytes = this.bytes,
                      format = bytes[pos++],
                      fdSelect = [],
                      invalidFirstGID = !1;
                    switch (format) {
                      case 0:
                        for (i = 0; i < length; ++i) {
                          var id = bytes[pos++];
                          fdSelect.push(id);
                        }
                        rawBytes = bytes.subarray(start, pos);
                        break;
                      case 3:
                        var rangesCount = (bytes[pos++] << 8) | bytes[pos++];
                        for (i = 0; i < rangesCount; ++i) {
                          var first = (bytes[pos++] << 8) | bytes[pos++];
                          0 === i &&
                            0 !== first &&
                            (warn("parseFDSelect: The first range must have a first GID of 0 -- trying to recover."),
                            (invalidFirstGID = !0),
                            (first = 0));
                          for (
                            var fdIndex = bytes[pos++], next = (bytes[pos] << 8) | bytes[pos + 1], j = first;
                            j < next;
                            ++j
                          )
                            fdSelect.push(fdIndex);
                        }
                        (pos += 2),
                          (rawBytes = bytes.subarray(start, pos)),
                          invalidFirstGID && (rawBytes[3] = rawBytes[4] = 0);
                        break;
                      default:
                        error('parseFDSelect: Unknown format "' + format + '".');
                    }
                    return (
                      assert(fdSelect.length === length, "parseFDSelect: Invalid font data."),
                      new CFFFDSelect(fdSelect, rawBytes)
                    );
                  },
                }),
                CFFParser
              );
            })(),
            CFF = (function () {
              function CFF() {
                (this.header = null),
                  (this.names = []),
                  (this.topDict = null),
                  (this.strings = new CFFStrings()),
                  (this.globalSubrIndex = null),
                  (this.encoding = null),
                  (this.charset = null),
                  (this.charStrings = null),
                  (this.fdArray = []),
                  (this.fdSelect = null),
                  (this.isCIDFont = !1);
              }
              return CFF;
            })(),
            CFFHeader = (function () {
              function CFFHeader(major, minor, hdrSize, offSize) {
                (this.major = major), (this.minor = minor), (this.hdrSize = hdrSize), (this.offSize = offSize);
              }
              return CFFHeader;
            })(),
            CFFStrings = (function () {
              function CFFStrings() {
                this.strings = [];
              }
              return (
                (CFFStrings.prototype = {
                  get: function (index) {
                    return index >= 0 && index <= 390
                      ? CFFStandardStrings[index]
                      : index - 391 <= this.strings.length
                      ? this.strings[index - 391]
                      : CFFStandardStrings[0];
                  },
                  add: function (value) {
                    this.strings.push(value);
                  },
                  get count() {
                    return this.strings.length;
                  },
                }),
                CFFStrings
              );
            })(),
            CFFIndex = (function () {
              function CFFIndex() {
                (this.objects = []), (this.length = 0);
              }
              return (
                (CFFIndex.prototype = {
                  add: function (data) {
                    (this.length += data.length), this.objects.push(data);
                  },
                  set: function (index, data) {
                    (this.length += data.length - this.objects[index].length), (this.objects[index] = data);
                  },
                  get: function (index) {
                    return this.objects[index];
                  },
                  get count() {
                    return this.objects.length;
                  },
                }),
                CFFIndex
              );
            })(),
            CFFDict = (function () {
              function CFFDict(tables, strings) {
                (this.keyToNameMap = tables.keyToNameMap),
                  (this.nameToKeyMap = tables.nameToKeyMap),
                  (this.defaults = tables.defaults),
                  (this.types = tables.types),
                  (this.opcodes = tables.opcodes),
                  (this.order = tables.order),
                  (this.strings = strings),
                  (this.values = Object.create(null));
              }
              return (
                (CFFDict.prototype = {
                  setByKey: function (key, value) {
                    if (!(key in this.keyToNameMap)) return !1;
                    if (0 === value.length) return !0;
                    var type = this.types[key];
                    return ("num" !== type && "sid" !== type && "offset" !== type) ||
                      ((value = value[0]), !isNaN(value))
                      ? ((this.values[key] = value), !0)
                      : (warn("Invalid CFFDict value: " + value + ", for key: " + key + "."), !0);
                  },
                  setByName: function (name, value) {
                    name in this.nameToKeyMap || error('Invalid dictionary name "' + name + '"'),
                      (this.values[this.nameToKeyMap[name]] = value);
                  },
                  hasName: function (name) {
                    return this.nameToKeyMap[name] in this.values;
                  },
                  getByName: function (name) {
                    name in this.nameToKeyMap || error('Invalid dictionary name "' + name + '"');
                    var key = this.nameToKeyMap[name];
                    return key in this.values ? this.values[key] : this.defaults[key];
                  },
                  removeByName: function (name) {
                    delete this.values[this.nameToKeyMap[name]];
                  },
                }),
                (CFFDict.createTables = function (layout) {
                  for (
                    var tables = {
                        keyToNameMap: {},
                        nameToKeyMap: {},
                        defaults: {},
                        types: {},
                        opcodes: {},
                        order: [],
                      },
                      i = 0,
                      ii = layout.length;
                    i < ii;
                    ++i
                  ) {
                    var entry = layout[i],
                      key = isArray(entry[0]) ? (entry[0][0] << 8) + entry[0][1] : entry[0];
                    (tables.keyToNameMap[key] = entry[1]),
                      (tables.nameToKeyMap[entry[1]] = key),
                      (tables.types[key] = entry[2]),
                      (tables.defaults[key] = entry[3]),
                      (tables.opcodes[key] = isArray(entry[0]) ? entry[0] : [entry[0]]),
                      tables.order.push(key);
                  }
                  return tables;
                }),
                CFFDict
              );
            })(),
            CFFTopDict = (function () {
              function CFFTopDict(strings) {
                null === tables && (tables = CFFDict.createTables(layout)),
                  CFFDict.call(this, tables, strings),
                  (this.privateDict = null);
              }
              var layout = [
                  [[12, 30], "ROS", ["sid", "sid", "num"], null],
                  [[12, 20], "SyntheticBase", "num", null],
                  [0, "version", "sid", null],
                  [1, "Notice", "sid", null],
                  [[12, 0], "Copyright", "sid", null],
                  [2, "FullName", "sid", null],
                  [3, "FamilyName", "sid", null],
                  [4, "Weight", "sid", null],
                  [[12, 1], "isFixedPitch", "num", 0],
                  [[12, 2], "ItalicAngle", "num", 0],
                  [[12, 3], "UnderlinePosition", "num", -100],
                  [[12, 4], "UnderlineThickness", "num", 50],
                  [[12, 5], "PaintType", "num", 0],
                  [[12, 6], "CharstringType", "num", 2],
                  [[12, 7], "FontMatrix", ["num", "num", "num", "num", "num", "num"], [0.001, 0, 0, 0.001, 0, 0]],
                  [13, "UniqueID", "num", null],
                  [5, "FontBBox", ["num", "num", "num", "num"], [0, 0, 0, 0]],
                  [[12, 8], "StrokeWidth", "num", 0],
                  [14, "XUID", "array", null],
                  [15, "charset", "offset", 0],
                  [16, "Encoding", "offset", 0],
                  [17, "CharStrings", "offset", 0],
                  [18, "Private", ["offset", "offset"], null],
                  [[12, 21], "PostScript", "sid", null],
                  [[12, 22], "BaseFontName", "sid", null],
                  [[12, 23], "BaseFontBlend", "delta", null],
                  [[12, 31], "CIDFontVersion", "num", 0],
                  [[12, 32], "CIDFontRevision", "num", 0],
                  [[12, 33], "CIDFontType", "num", 0],
                  [[12, 34], "CIDCount", "num", 8720],
                  [[12, 35], "UIDBase", "num", null],
                  [[12, 37], "FDSelect", "offset", null],
                  [[12, 36], "FDArray", "offset", null],
                  [[12, 38], "FontName", "sid", null],
                ],
                tables = null;
              return (CFFTopDict.prototype = Object.create(CFFDict.prototype)), CFFTopDict;
            })(),
            CFFPrivateDict = (function () {
              function CFFPrivateDict(strings) {
                null === tables && (tables = CFFDict.createTables(layout)),
                  CFFDict.call(this, tables, strings),
                  (this.subrsIndex = null);
              }
              var layout = [
                  [6, "BlueValues", "delta", null],
                  [7, "OtherBlues", "delta", null],
                  [8, "FamilyBlues", "delta", null],
                  [9, "FamilyOtherBlues", "delta", null],
                  [[12, 9], "BlueScale", "num", 0.039625],
                  [[12, 10], "BlueShift", "num", 7],
                  [[12, 11], "BlueFuzz", "num", 1],
                  [10, "StdHW", "num", null],
                  [11, "StdVW", "num", null],
                  [[12, 12], "StemSnapH", "delta", null],
                  [[12, 13], "StemSnapV", "delta", null],
                  [[12, 14], "ForceBold", "num", 0],
                  [[12, 17], "LanguageGroup", "num", 0],
                  [[12, 18], "ExpansionFactor", "num", 0.06],
                  [[12, 19], "initialRandomSeed", "num", 0],
                  [20, "defaultWidthX", "num", 0],
                  [21, "nominalWidthX", "num", 0],
                  [19, "Subrs", "offset", null],
                ],
                tables = null;
              return (CFFPrivateDict.prototype = Object.create(CFFDict.prototype)), CFFPrivateDict;
            })(),
            CFFCharsetPredefinedTypes = { ISO_ADOBE: 0, EXPERT: 1, EXPERT_SUBSET: 2 },
            CFFCharset = (function () {
              function CFFCharset(predefined, format, charset, raw) {
                (this.predefined = predefined), (this.format = format), (this.charset = charset), (this.raw = raw);
              }
              return CFFCharset;
            })(),
            CFFEncoding = (function () {
              function CFFEncoding(predefined, format, encoding, raw) {
                (this.predefined = predefined), (this.format = format), (this.encoding = encoding), (this.raw = raw);
              }
              return CFFEncoding;
            })(),
            CFFFDSelect = (function () {
              function CFFFDSelect(fdSelect, raw) {
                (this.fdSelect = fdSelect), (this.raw = raw);
              }
              return (
                (CFFFDSelect.prototype = {
                  getFDIndex: function (glyphIndex) {
                    return glyphIndex < 0 || glyphIndex >= this.fdSelect.length ? -1 : this.fdSelect[glyphIndex];
                  },
                }),
                CFFFDSelect
              );
            })(),
            CFFOffsetTracker = (function () {
              function CFFOffsetTracker() {
                this.offsets = Object.create(null);
              }
              return (
                (CFFOffsetTracker.prototype = {
                  isTracking: function (key) {
                    return key in this.offsets;
                  },
                  track: function (key, location) {
                    key in this.offsets && error("Already tracking location of " + key), (this.offsets[key] = location);
                  },
                  offset: function (value) {
                    for (var key in this.offsets) this.offsets[key] += value;
                  },
                  setEntryLocation: function (key, values, output) {
                    key in this.offsets || error("Not tracking location of " + key);
                    for (
                      var data = output.data, dataOffset = this.offsets[key], i = 0, ii = values.length;
                      i < ii;
                      ++i
                    ) {
                      var offset0 = 5 * i + dataOffset,
                        offset1 = offset0 + 1,
                        offset2 = offset0 + 2,
                        offset3 = offset0 + 3,
                        offset4 = offset0 + 4;
                      (29 === data[offset0] &&
                        0 === data[offset1] &&
                        0 === data[offset2] &&
                        0 === data[offset3] &&
                        0 === data[offset4]) ||
                        error("writing to an offset that is not empty");
                      var value = values[i];
                      (data[offset0] = 29),
                        (data[offset1] = (value >> 24) & 255),
                        (data[offset2] = (value >> 16) & 255),
                        (data[offset3] = (value >> 8) & 255),
                        (data[offset4] = 255 & value);
                    }
                  },
                }),
                CFFOffsetTracker
              );
            })(),
            CFFCompiler = (function () {
              function CFFCompiler(cff) {
                this.cff = cff;
              }
              return (
                (CFFCompiler.prototype = {
                  compile: function () {
                    var cff = this.cff,
                      output = {
                        data: [],
                        length: 0,
                        add: function (data) {
                          (this.data = this.data.concat(data)), (this.length = this.data.length);
                        },
                      },
                      header = this.compileHeader(cff.header);
                    output.add(header);
                    var nameIndex = this.compileNameIndex(cff.names);
                    if ((output.add(nameIndex), cff.isCIDFont && cff.topDict.hasName("FontMatrix"))) {
                      var base = cff.topDict.getByName("FontMatrix");
                      cff.topDict.removeByName("FontMatrix");
                      for (var i = 0, ii = cff.fdArray.length; i < ii; i++) {
                        var subDict = cff.fdArray[i],
                          matrix = base.slice(0);
                        subDict.hasName("FontMatrix") &&
                          (matrix = Util.transform(matrix, subDict.getByName("FontMatrix"))),
                          subDict.setByName("FontMatrix", matrix);
                      }
                    }
                    var compiled = this.compileTopDicts([cff.topDict], output.length, cff.isCIDFont);
                    output.add(compiled.output);
                    var topDictTracker = compiled.trackers[0],
                      stringIndex = this.compileStringIndex(cff.strings.strings);
                    output.add(stringIndex);
                    var globalSubrIndex = this.compileIndex(cff.globalSubrIndex);
                    if ((output.add(globalSubrIndex), cff.encoding && cff.topDict.hasName("Encoding")))
                      if (cff.encoding.predefined)
                        topDictTracker.setEntryLocation("Encoding", [cff.encoding.format], output);
                      else {
                        var encoding = this.compileEncoding(cff.encoding);
                        topDictTracker.setEntryLocation("Encoding", [output.length], output), output.add(encoding);
                      }
                    if (cff.charset && cff.topDict.hasName("charset"))
                      if (cff.charset.predefined)
                        topDictTracker.setEntryLocation("charset", [cff.charset.format], output);
                      else {
                        var charset = this.compileCharset(cff.charset);
                        topDictTracker.setEntryLocation("charset", [output.length], output), output.add(charset);
                      }
                    var charStrings = this.compileCharStrings(cff.charStrings);
                    if (
                      (topDictTracker.setEntryLocation("CharStrings", [output.length], output),
                      output.add(charStrings),
                      cff.isCIDFont)
                    ) {
                      topDictTracker.setEntryLocation("FDSelect", [output.length], output);
                      var fdSelect = this.compileFDSelect(cff.fdSelect.raw);
                      output.add(fdSelect),
                        (compiled = this.compileTopDicts(cff.fdArray, output.length, !0)),
                        topDictTracker.setEntryLocation("FDArray", [output.length], output),
                        output.add(compiled.output);
                      var fontDictTrackers = compiled.trackers;
                      this.compilePrivateDicts(cff.fdArray, fontDictTrackers, output);
                    }
                    return (
                      this.compilePrivateDicts([cff.topDict], [topDictTracker], output), output.add([0]), output.data
                    );
                  },
                  encodeNumber: function (value) {
                    return parseFloat(value) !== parseInt(value, 10) || isNaN(value)
                      ? this.encodeFloat(value)
                      : this.encodeInteger(value);
                  },
                  encodeFloat: function (num) {
                    var value = num.toString(),
                      m = /\.(\d*?)(?:9{5,20}|0{5,20})\d{0,2}(?:e(.+)|$)/.exec(value);
                    if (m) {
                      var epsilon = parseFloat("1e" + ((m[2] ? +m[2] : 0) + m[1].length));
                      value = (Math.round(num * epsilon) / epsilon).toString();
                    }
                    var i,
                      ii,
                      nibbles = "";
                    for (i = 0, ii = value.length; i < ii; ++i) {
                      var a = value[i];
                      nibbles += "e" === a ? ("-" === value[++i] ? "c" : "b") : "." === a ? "a" : "-" === a ? "e" : a;
                    }
                    nibbles += 1 & nibbles.length ? "f" : "ff";
                    var out = [30];
                    for (i = 0, ii = nibbles.length; i < ii; i += 2) out.push(parseInt(nibbles.substr(i, 2), 16));
                    return out;
                  },
                  encodeInteger: function (value) {
                    var code;
                    return (
                      value >= -107 && value <= 107
                        ? (code = [value + 139])
                        : value >= 108 && value <= 1131
                        ? ((value -= 108), (code = [247 + (value >> 8), 255 & value]))
                        : value >= -1131 && value <= -108
                        ? ((value = -value - 108), (code = [251 + (value >> 8), 255 & value]))
                        : (code =
                            value >= -32768 && value <= 32767
                              ? [28, (value >> 8) & 255, 255 & value]
                              : [29, (value >> 24) & 255, (value >> 16) & 255, (value >> 8) & 255, 255 & value]),
                      code
                    );
                  },
                  compileHeader: function (header) {
                    return [header.major, header.minor, header.hdrSize, header.offSize];
                  },
                  compileNameIndex: function (names) {
                    for (var nameIndex = new CFFIndex(), i = 0, ii = names.length; i < ii; ++i)
                      nameIndex.add(stringToBytes(names[i]));
                    return this.compileIndex(nameIndex);
                  },
                  compileTopDicts: function (dicts, length, removeCidKeys) {
                    for (
                      var fontDictTrackers = [], fdArrayIndex = new CFFIndex(), i = 0, ii = dicts.length;
                      i < ii;
                      ++i
                    ) {
                      var fontDict = dicts[i];
                      removeCidKeys &&
                        (fontDict.removeByName("CIDFontVersion"),
                        fontDict.removeByName("CIDFontRevision"),
                        fontDict.removeByName("CIDFontType"),
                        fontDict.removeByName("CIDCount"),
                        fontDict.removeByName("UIDBase"));
                      var fontDictTracker = new CFFOffsetTracker(),
                        fontDictData = this.compileDict(fontDict, fontDictTracker);
                      fontDictTrackers.push(fontDictTracker),
                        fdArrayIndex.add(fontDictData),
                        fontDictTracker.offset(length);
                    }
                    return (
                      (fdArrayIndex = this.compileIndex(fdArrayIndex, fontDictTrackers)),
                      { trackers: fontDictTrackers, output: fdArrayIndex }
                    );
                  },
                  compilePrivateDicts: function (dicts, trackers, output) {
                    for (var i = 0, ii = dicts.length; i < ii; ++i) {
                      var fontDict = dicts[i];
                      assert(
                        fontDict.privateDict && fontDict.hasName("Private"),
                        "There must be an private dictionary."
                      );
                      var privateDict = fontDict.privateDict,
                        privateDictTracker = new CFFOffsetTracker(),
                        privateDictData = this.compileDict(privateDict, privateDictTracker),
                        outputLength = output.length;
                      if (
                        (privateDictTracker.offset(outputLength),
                        privateDictData.length || (outputLength = 0),
                        trackers[i].setEntryLocation("Private", [privateDictData.length, outputLength], output),
                        output.add(privateDictData),
                        privateDict.subrsIndex && privateDict.hasName("Subrs"))
                      ) {
                        var subrs = this.compileIndex(privateDict.subrsIndex);
                        privateDictTracker.setEntryLocation("Subrs", [privateDictData.length], output),
                          output.add(subrs);
                      }
                    }
                  },
                  compileDict: function (dict, offsetTracker) {
                    for (var out = [], order = dict.order, i = 0; i < order.length; ++i) {
                      var key = order[i];
                      if (key in dict.values) {
                        var values = dict.values[key],
                          types = dict.types[key];
                        if (
                          (isArray(types) || (types = [types]),
                          isArray(values) || (values = [values]),
                          0 !== values.length)
                        ) {
                          for (var j = 0, jj = types.length; j < jj; ++j) {
                            var type = types[j],
                              value = values[j];
                            switch (type) {
                              case "num":
                              case "sid":
                                out = out.concat(this.encodeNumber(value));
                                break;
                              case "offset":
                                var name = dict.keyToNameMap[key];
                                offsetTracker.isTracking(name) || offsetTracker.track(name, out.length),
                                  (out = out.concat([29, 0, 0, 0, 0]));
                                break;
                              case "array":
                              case "delta":
                                out = out.concat(this.encodeNumber(value));
                                for (var k = 1, kk = values.length; k < kk; ++k)
                                  out = out.concat(this.encodeNumber(values[k]));
                                break;
                              default:
                                error("Unknown data type of " + type);
                            }
                          }
                          out = out.concat(dict.opcodes[key]);
                        }
                      }
                    }
                    return out;
                  },
                  compileStringIndex: function (strings) {
                    for (var stringIndex = new CFFIndex(), i = 0, ii = strings.length; i < ii; ++i)
                      stringIndex.add(stringToBytes(strings[i]));
                    return this.compileIndex(stringIndex);
                  },
                  compileGlobalSubrIndex: function () {
                    var globalSubrIndex = this.cff.globalSubrIndex;
                    this.out.writeByteArray(this.compileIndex(globalSubrIndex));
                  },
                  compileCharStrings: function (charStrings) {
                    return this.compileIndex(charStrings);
                  },
                  compileCharset: function (charset) {
                    return this.compileTypedArray(charset.raw);
                  },
                  compileEncoding: function (encoding) {
                    return this.compileTypedArray(encoding.raw);
                  },
                  compileFDSelect: function (fdSelect) {
                    return this.compileTypedArray(fdSelect);
                  },
                  compileTypedArray: function (data) {
                    for (var out = [], i = 0, ii = data.length; i < ii; ++i) out[i] = data[i];
                    return out;
                  },
                  compileIndex: function (index, trackers) {
                    trackers = trackers || [];
                    var objects = index.objects,
                      count = objects.length;
                    if (0 === count) return [0, 0, 0];
                    var i,
                      data = [(count >> 8) & 255, 255 & count],
                      lastOffset = 1;
                    for (i = 0; i < count; ++i) lastOffset += objects[i].length;
                    var offsetSize;
                    (offsetSize = lastOffset < 256 ? 1 : lastOffset < 65536 ? 2 : lastOffset < 16777216 ? 3 : 4),
                      data.push(offsetSize);
                    var relativeOffset = 1;
                    for (i = 0; i < count + 1; i++)
                      1 === offsetSize
                        ? data.push(255 & relativeOffset)
                        : 2 === offsetSize
                        ? data.push((relativeOffset >> 8) & 255, 255 & relativeOffset)
                        : 3 === offsetSize
                        ? data.push((relativeOffset >> 16) & 255, (relativeOffset >> 8) & 255, 255 & relativeOffset)
                        : data.push(
                            (relativeOffset >>> 24) & 255,
                            (relativeOffset >> 16) & 255,
                            (relativeOffset >> 8) & 255,
                            255 & relativeOffset
                          ),
                        objects[i] && (relativeOffset += objects[i].length);
                    for (i = 0; i < count; i++) {
                      trackers[i] && trackers[i].offset(data.length);
                      for (var j = 0, jj = objects[i].length; j < jj; j++) data.push(objects[i][j]);
                    }
                    return data;
                  },
                }),
                CFFCompiler
              );
            })();
          (exports.CFFStandardStrings = CFFStandardStrings),
            (exports.CFFParser = CFFParser),
            (exports.CFF = CFF),
            (exports.CFFHeader = CFFHeader),
            (exports.CFFStrings = CFFStrings),
            (exports.CFFIndex = CFFIndex),
            (exports.CFFCharset = CFFCharset),
            (exports.CFFTopDict = CFFTopDict),
            (exports.CFFPrivateDict = CFFPrivateDict),
            (exports.CFFCompiler = CFFCompiler);
        })((root.pdfjsCoreCFFParser = {}), root.pdfjsSharedUtil, root.pdfjsCoreCharsets, root.pdfjsCoreEncodings);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil) {
          var MissingDataException = sharedUtil.MissingDataException,
            arrayByteLength = sharedUtil.arrayByteLength,
            arraysToBytes = sharedUtil.arraysToBytes,
            assert = sharedUtil.assert,
            createPromiseCapability = sharedUtil.createPromiseCapability,
            isInt = sharedUtil.isInt,
            isEmptyObj = sharedUtil.isEmptyObj,
            ChunkedStream = (function () {
              function ChunkedStream(length, chunkSize, manager) {
                (this.bytes = new Uint8Array(length)),
                  (this.start = 0),
                  (this.pos = 0),
                  (this.end = length),
                  (this.chunkSize = chunkSize),
                  (this.loadedChunks = []),
                  (this.numChunksLoaded = 0),
                  (this.numChunks = Math.ceil(length / chunkSize)),
                  (this.manager = manager),
                  (this.progressiveDataLength = 0),
                  (this.lastSuccessfulEnsureByteChunk = -1);
              }
              return (
                (ChunkedStream.prototype = {
                  getMissingChunks: function () {
                    for (var chunks = [], chunk = 0, n = this.numChunks; chunk < n; ++chunk)
                      this.loadedChunks[chunk] || chunks.push(chunk);
                    return chunks;
                  },
                  getBaseStreams: function () {
                    return [this];
                  },
                  allChunksLoaded: function () {
                    return this.numChunksLoaded === this.numChunks;
                  },
                  onReceiveData: function (begin, chunk) {
                    var end = begin + chunk.byteLength;
                    assert(begin % this.chunkSize == 0, "Bad begin offset: " + begin);
                    var length = this.bytes.length;
                    assert(end % this.chunkSize == 0 || end === length, "Bad end offset: " + end),
                      this.bytes.set(new Uint8Array(chunk), begin);
                    var curChunk,
                      chunkSize = this.chunkSize,
                      beginChunk = Math.floor(begin / chunkSize),
                      endChunk = Math.floor((end - 1) / chunkSize) + 1;
                    for (curChunk = beginChunk; curChunk < endChunk; ++curChunk)
                      this.loadedChunks[curChunk] || ((this.loadedChunks[curChunk] = !0), ++this.numChunksLoaded);
                  },
                  onReceiveProgressiveData: function (data) {
                    var position = this.progressiveDataLength,
                      beginChunk = Math.floor(position / this.chunkSize);
                    this.bytes.set(new Uint8Array(data), position),
                      (position += data.byteLength),
                      (this.progressiveDataLength = position);
                    var curChunk,
                      endChunk = position >= this.end ? this.numChunks : Math.floor(position / this.chunkSize);
                    for (curChunk = beginChunk; curChunk < endChunk; ++curChunk)
                      this.loadedChunks[curChunk] || ((this.loadedChunks[curChunk] = !0), ++this.numChunksLoaded);
                  },
                  ensureByte: function (pos) {
                    var chunk = Math.floor(pos / this.chunkSize);
                    if (chunk !== this.lastSuccessfulEnsureByteChunk) {
                      if (!this.loadedChunks[chunk]) throw new MissingDataException(pos, pos + 1);
                      this.lastSuccessfulEnsureByteChunk = chunk;
                    }
                  },
                  ensureRange: function (begin, end) {
                    if (!(begin >= end || end <= this.progressiveDataLength))
                      for (
                        var chunkSize = this.chunkSize,
                          beginChunk = Math.floor(begin / chunkSize),
                          endChunk = Math.floor((end - 1) / chunkSize) + 1,
                          chunk = beginChunk;
                        chunk < endChunk;
                        ++chunk
                      )
                        if (!this.loadedChunks[chunk]) throw new MissingDataException(begin, end);
                  },
                  nextEmptyChunk: function (beginChunk) {
                    for (var chunk, numChunks = this.numChunks, i = 0; i < numChunks; ++i)
                      if (((chunk = (beginChunk + i) % numChunks), !this.loadedChunks[chunk])) return chunk;
                    return null;
                  },
                  hasChunk: function (chunk) {
                    return !!this.loadedChunks[chunk];
                  },
                  get length() {
                    return this.end - this.start;
                  },
                  get isEmpty() {
                    return 0 === this.length;
                  },
                  getByte: function () {
                    var pos = this.pos;
                    return pos >= this.end ? -1 : (this.ensureByte(pos), this.bytes[this.pos++]);
                  },
                  getUint16: function () {
                    var b0 = this.getByte(),
                      b1 = this.getByte();
                    return -1 === b0 || -1 === b1 ? -1 : (b0 << 8) + b1;
                  },
                  getInt32: function () {
                    return (this.getByte() << 24) + (this.getByte() << 16) + (this.getByte() << 8) + this.getByte();
                  },
                  getBytes: function (length) {
                    var bytes = this.bytes,
                      pos = this.pos,
                      strEnd = this.end;
                    if (!length) return this.ensureRange(pos, strEnd), bytes.subarray(pos, strEnd);
                    var end = pos + length;
                    return (
                      end > strEnd && (end = strEnd),
                      this.ensureRange(pos, end),
                      (this.pos = end),
                      bytes.subarray(pos, end)
                    );
                  },
                  peekByte: function () {
                    var peekedByte = this.getByte();
                    return this.pos--, peekedByte;
                  },
                  peekBytes: function (length) {
                    var bytes = this.getBytes(length);
                    return (this.pos -= bytes.length), bytes;
                  },
                  getByteRange: function (begin, end) {
                    return this.ensureRange(begin, end), this.bytes.subarray(begin, end);
                  },
                  skip: function (n) {
                    n || (n = 1), (this.pos += n);
                  },
                  reset: function () {
                    this.pos = this.start;
                  },
                  moveStart: function () {
                    this.start = this.pos;
                  },
                  makeSubStream: function (start, length, dict) {
                    function ChunkedStreamSubstream() {}
                    this.ensureRange(start, start + length),
                      (ChunkedStreamSubstream.prototype = Object.create(this)),
                      (ChunkedStreamSubstream.prototype.getMissingChunks = function () {
                        for (
                          var chunkSize = this.chunkSize,
                            beginChunk = Math.floor(this.start / chunkSize),
                            endChunk = Math.floor((this.end - 1) / chunkSize) + 1,
                            missingChunks = [],
                            chunk = beginChunk;
                          chunk < endChunk;
                          ++chunk
                        )
                          this.loadedChunks[chunk] || missingChunks.push(chunk);
                        return missingChunks;
                      });
                    var subStream = new ChunkedStreamSubstream();
                    return (
                      (subStream.pos = subStream.start = start),
                      (subStream.end = start + length || this.end),
                      (subStream.dict = dict),
                      subStream
                    );
                  },
                  isStream: !0,
                }),
                ChunkedStream
              );
            })(),
            ChunkedStreamManager = (function () {
              function ChunkedStreamManager(pdfNetworkStream, args) {
                var chunkSize = args.rangeChunkSize,
                  length = args.length;
                (this.stream = new ChunkedStream(length, chunkSize, this)),
                  (this.length = length),
                  (this.chunkSize = chunkSize),
                  (this.pdfNetworkStream = pdfNetworkStream),
                  (this.url = args.url),
                  (this.disableAutoFetch = args.disableAutoFetch),
                  (this.msgHandler = args.msgHandler),
                  (this.currRequestId = 0),
                  (this.chunksNeededByRequest = Object.create(null)),
                  (this.requestsByChunk = Object.create(null)),
                  (this.promisesByRequest = Object.create(null)),
                  (this.progressiveDataLength = 0),
                  (this.aborted = !1),
                  (this._loadedStreamCapability = createPromiseCapability());
              }
              return (
                (ChunkedStreamManager.prototype = {
                  onLoadedStream: function () {
                    return this._loadedStreamCapability.promise;
                  },
                  sendRequest: function (begin, end) {
                    var rangeReader = this.pdfNetworkStream.getRangeReader(begin, end);
                    rangeReader.isStreamingSupported || (rangeReader.onProgress = this.onProgress.bind(this));
                    var chunks = [],
                      loaded = 0,
                      manager = this;
                    new Promise(function (resolve, reject) {
                      var readChunk = function (chunk) {
                        try {
                          if (!chunk.done) {
                            var data = chunk.value;
                            return (
                              chunks.push(data),
                              (loaded += arrayByteLength(data)),
                              rangeReader.isStreamingSupported && manager.onProgress({ loaded: loaded }),
                              void rangeReader.read().then(readChunk, reject)
                            );
                          }
                          var chunkData = arraysToBytes(chunks);
                          (chunks = null), resolve(chunkData);
                        } catch (e) {
                          reject(e);
                        }
                      };
                      rangeReader.read().then(readChunk, reject);
                    }).then(
                      function (data) {
                        this.aborted || this.onReceiveData({ chunk: data, begin: begin });
                      }.bind(this)
                    );
                  },
                  requestAllChunks: function () {
                    var missingChunks = this.stream.getMissingChunks();
                    return this._requestChunks(missingChunks), this._loadedStreamCapability.promise;
                  },
                  _requestChunks: function (chunks) {
                    var i,
                      ii,
                      requestId = this.currRequestId++,
                      chunksNeeded = Object.create(null);
                    for (this.chunksNeededByRequest[requestId] = chunksNeeded, i = 0, ii = chunks.length; i < ii; i++)
                      this.stream.hasChunk(chunks[i]) || (chunksNeeded[chunks[i]] = !0);
                    if (isEmptyObj(chunksNeeded)) return Promise.resolve();
                    var capability = createPromiseCapability();
                    this.promisesByRequest[requestId] = capability;
                    var chunksToRequest = [];
                    for (var chunk in chunksNeeded)
                      (chunk |= 0),
                        chunk in this.requestsByChunk ||
                          ((this.requestsByChunk[chunk] = []), chunksToRequest.push(chunk)),
                        this.requestsByChunk[chunk].push(requestId);
                    if (!chunksToRequest.length) return capability.promise;
                    var groupedChunksToRequest = this.groupChunks(chunksToRequest);
                    for (i = 0; i < groupedChunksToRequest.length; ++i) {
                      var groupedChunk = groupedChunksToRequest[i],
                        begin = groupedChunk.beginChunk * this.chunkSize,
                        end = Math.min(groupedChunk.endChunk * this.chunkSize, this.length);
                      this.sendRequest(begin, end);
                    }
                    return capability.promise;
                  },
                  getStream: function () {
                    return this.stream;
                  },
                  requestRange: function (begin, end) {
                    end = Math.min(end, this.length);
                    for (
                      var beginChunk = this.getBeginChunk(begin),
                        endChunk = this.getEndChunk(end),
                        chunks = [],
                        chunk = beginChunk;
                      chunk < endChunk;
                      ++chunk
                    )
                      chunks.push(chunk);
                    return this._requestChunks(chunks);
                  },
                  requestRanges: function (ranges) {
                    ranges = ranges || [];
                    for (var chunksToRequest = [], i = 0; i < ranges.length; i++)
                      for (
                        var beginChunk = this.getBeginChunk(ranges[i].begin),
                          endChunk = this.getEndChunk(ranges[i].end),
                          chunk = beginChunk;
                        chunk < endChunk;
                        ++chunk
                      )
                        chunksToRequest.indexOf(chunk) < 0 && chunksToRequest.push(chunk);
                    return (
                      chunksToRequest.sort(function (a, b) {
                        return a - b;
                      }),
                      this._requestChunks(chunksToRequest)
                    );
                  },
                  groupChunks: function (chunks) {
                    for (var groupedChunks = [], beginChunk = -1, prevChunk = -1, i = 0; i < chunks.length; ++i) {
                      var chunk = chunks[i];
                      beginChunk < 0 && (beginChunk = chunk),
                        prevChunk >= 0 &&
                          prevChunk + 1 !== chunk &&
                          (groupedChunks.push({ beginChunk: beginChunk, endChunk: prevChunk + 1 }),
                          (beginChunk = chunk)),
                        i + 1 === chunks.length && groupedChunks.push({ beginChunk: beginChunk, endChunk: chunk + 1 }),
                        (prevChunk = chunk);
                    }
                    return groupedChunks;
                  },
                  onProgress: function (args) {
                    var bytesLoaded = this.stream.numChunksLoaded * this.chunkSize + args.loaded;
                    this.msgHandler.send("DocProgress", { loaded: bytesLoaded, total: this.length });
                  },
                  onReceiveData: function (args) {
                    var chunk = args.chunk,
                      isProgressive = void 0 === args.begin,
                      begin = isProgressive ? this.progressiveDataLength : args.begin,
                      end = begin + chunk.byteLength,
                      beginChunk = Math.floor(begin / this.chunkSize),
                      endChunk = end < this.length ? Math.floor(end / this.chunkSize) : Math.ceil(end / this.chunkSize);
                    isProgressive
                      ? (this.stream.onReceiveProgressiveData(chunk), (this.progressiveDataLength = end))
                      : this.stream.onReceiveData(begin, chunk),
                      this.stream.allChunksLoaded() && this._loadedStreamCapability.resolve(this.stream);
                    var i,
                      requestId,
                      loadedRequests = [];
                    for (chunk = beginChunk; chunk < endChunk; ++chunk) {
                      var requestIds = this.requestsByChunk[chunk] || [];
                      for (delete this.requestsByChunk[chunk], i = 0; i < requestIds.length; ++i) {
                        requestId = requestIds[i];
                        var chunksNeeded = this.chunksNeededByRequest[requestId];
                        chunk in chunksNeeded && delete chunksNeeded[chunk],
                          isEmptyObj(chunksNeeded) && loadedRequests.push(requestId);
                      }
                    }
                    if (!this.disableAutoFetch && isEmptyObj(this.requestsByChunk)) {
                      var nextEmptyChunk;
                      if (1 === this.stream.numChunksLoaded) {
                        var lastChunk = this.stream.numChunks - 1;
                        this.stream.hasChunk(lastChunk) || (nextEmptyChunk = lastChunk);
                      } else nextEmptyChunk = this.stream.nextEmptyChunk(endChunk);
                      isInt(nextEmptyChunk) && this._requestChunks([nextEmptyChunk]);
                    }
                    for (i = 0; i < loadedRequests.length; ++i) {
                      requestId = loadedRequests[i];
                      var capability = this.promisesByRequest[requestId];
                      delete this.promisesByRequest[requestId], capability.resolve();
                    }
                    this.msgHandler.send("DocProgress", {
                      loaded: this.stream.numChunksLoaded * this.chunkSize,
                      total: this.length,
                    });
                  },
                  onError: function (err) {
                    this._loadedStreamCapability.reject(err);
                  },
                  getBeginChunk: function (begin) {
                    return Math.floor(begin / this.chunkSize);
                  },
                  getEndChunk: function (end) {
                    return Math.floor((end - 1) / this.chunkSize) + 1;
                  },
                  abort: function () {
                    (this.aborted = !0), this.pdfNetworkStream && this.pdfNetworkStream.cancelAllRequests("abort");
                    for (var requestId in this.promisesByRequest) {
                      this.promisesByRequest[requestId].reject(new Error("Request was aborted"));
                    }
                  },
                }),
                ChunkedStreamManager
              );
            })();
          (exports.ChunkedStream = ChunkedStream), (exports.ChunkedStreamManager = ChunkedStreamManager);
        })((root.pdfjsCoreChunkedStream = {}), root.pdfjsSharedUtil);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil) {
          var getLookupTableFactory = sharedUtil.getLookupTableFactory,
            getGlyphsUnicode = getLookupTableFactory(function (t) {
              (t.A = 65),
                (t.AE = 198),
                (t.AEacute = 508),
                (t.AEmacron = 482),
                (t.AEsmall = 63462),
                (t.Aacute = 193),
                (t.Aacutesmall = 63457),
                (t.Abreve = 258),
                (t.Abreveacute = 7854),
                (t.Abrevecyrillic = 1232),
                (t.Abrevedotbelow = 7862),
                (t.Abrevegrave = 7856),
                (t.Abrevehookabove = 7858),
                (t.Abrevetilde = 7860),
                (t.Acaron = 461),
                (t.Acircle = 9398),
                (t.Acircumflex = 194),
                (t.Acircumflexacute = 7844),
                (t.Acircumflexdotbelow = 7852),
                (t.Acircumflexgrave = 7846),
                (t.Acircumflexhookabove = 7848),
                (t.Acircumflexsmall = 63458),
                (t.Acircumflextilde = 7850),
                (t.Acute = 63177),
                (t.Acutesmall = 63412),
                (t.Acyrillic = 1040),
                (t.Adblgrave = 512),
                (t.Adieresis = 196),
                (t.Adieresiscyrillic = 1234),
                (t.Adieresismacron = 478),
                (t.Adieresissmall = 63460),
                (t.Adotbelow = 7840),
                (t.Adotmacron = 480),
                (t.Agrave = 192),
                (t.Agravesmall = 63456),
                (t.Ahookabove = 7842),
                (t.Aiecyrillic = 1236),
                (t.Ainvertedbreve = 514),
                (t.Alpha = 913),
                (t.Alphatonos = 902),
                (t.Amacron = 256),
                (t.Amonospace = 65313),
                (t.Aogonek = 260),
                (t.Aring = 197),
                (t.Aringacute = 506),
                (t.Aringbelow = 7680),
                (t.Aringsmall = 63461),
                (t.Asmall = 63329),
                (t.Atilde = 195),
                (t.Atildesmall = 63459),
                (t.Aybarmenian = 1329),
                (t.B = 66),
                (t.Bcircle = 9399),
                (t.Bdotaccent = 7682),
                (t.Bdotbelow = 7684),
                (t.Becyrillic = 1041),
                (t.Benarmenian = 1330),
                (t.Beta = 914),
                (t.Bhook = 385),
                (t.Blinebelow = 7686),
                (t.Bmonospace = 65314),
                (t.Brevesmall = 63220),
                (t.Bsmall = 63330),
                (t.Btopbar = 386),
                (t.C = 67),
                (t.Caarmenian = 1342),
                (t.Cacute = 262),
                (t.Caron = 63178),
                (t.Caronsmall = 63221),
                (t.Ccaron = 268),
                (t.Ccedilla = 199),
                (t.Ccedillaacute = 7688),
                (t.Ccedillasmall = 63463),
                (t.Ccircle = 9400),
                (t.Ccircumflex = 264),
                (t.Cdot = 266),
                (t.Cdotaccent = 266),
                (t.Cedillasmall = 63416),
                (t.Chaarmenian = 1353),
                (t.Cheabkhasiancyrillic = 1212),
                (t.Checyrillic = 1063),
                (t.Chedescenderabkhasiancyrillic = 1214),
                (t.Chedescendercyrillic = 1206),
                (t.Chedieresiscyrillic = 1268),
                (t.Cheharmenian = 1347),
                (t.Chekhakassiancyrillic = 1227),
                (t.Cheverticalstrokecyrillic = 1208),
                (t.Chi = 935),
                (t.Chook = 391),
                (t.Circumflexsmall = 63222),
                (t.Cmonospace = 65315),
                (t.Coarmenian = 1361),
                (t.Csmall = 63331),
                (t.D = 68),
                (t.DZ = 497),
                (t.DZcaron = 452),
                (t.Daarmenian = 1332),
                (t.Dafrican = 393),
                (t.Dcaron = 270),
                (t.Dcedilla = 7696),
                (t.Dcircle = 9401),
                (t.Dcircumflexbelow = 7698),
                (t.Dcroat = 272),
                (t.Ddotaccent = 7690),
                (t.Ddotbelow = 7692),
                (t.Decyrillic = 1044),
                (t.Deicoptic = 1006),
                (t.Delta = 8710),
                (t.Deltagreek = 916),
                (t.Dhook = 394),
                (t.Dieresis = 63179),
                (t.DieresisAcute = 63180),
                (t.DieresisGrave = 63181),
                (t.Dieresissmall = 63400),
                (t.Digammagreek = 988),
                (t.Djecyrillic = 1026),
                (t.Dlinebelow = 7694),
                (t.Dmonospace = 65316),
                (t.Dotaccentsmall = 63223),
                (t.Dslash = 272),
                (t.Dsmall = 63332),
                (t.Dtopbar = 395),
                (t.Dz = 498),
                (t.Dzcaron = 453),
                (t.Dzeabkhasiancyrillic = 1248),
                (t.Dzecyrillic = 1029),
                (t.Dzhecyrillic = 1039),
                (t.E = 69),
                (t.Eacute = 201),
                (t.Eacutesmall = 63465),
                (t.Ebreve = 276),
                (t.Ecaron = 282),
                (t.Ecedillabreve = 7708),
                (t.Echarmenian = 1333),
                (t.Ecircle = 9402),
                (t.Ecircumflex = 202),
                (t.Ecircumflexacute = 7870),
                (t.Ecircumflexbelow = 7704),
                (t.Ecircumflexdotbelow = 7878),
                (t.Ecircumflexgrave = 7872),
                (t.Ecircumflexhookabove = 7874),
                (t.Ecircumflexsmall = 63466),
                (t.Ecircumflextilde = 7876),
                (t.Ecyrillic = 1028),
                (t.Edblgrave = 516),
                (t.Edieresis = 203),
                (t.Edieresissmall = 63467),
                (t.Edot = 278),
                (t.Edotaccent = 278),
                (t.Edotbelow = 7864),
                (t.Efcyrillic = 1060),
                (t.Egrave = 200),
                (t.Egravesmall = 63464),
                (t.Eharmenian = 1335),
                (t.Ehookabove = 7866),
                (t.Eightroman = 8551),
                (t.Einvertedbreve = 518),
                (t.Eiotifiedcyrillic = 1124),
                (t.Elcyrillic = 1051),
                (t.Elevenroman = 8554),
                (t.Emacron = 274),
                (t.Emacronacute = 7702),
                (t.Emacrongrave = 7700),
                (t.Emcyrillic = 1052),
                (t.Emonospace = 65317),
                (t.Encyrillic = 1053),
                (t.Endescendercyrillic = 1186),
                (t.Eng = 330),
                (t.Enghecyrillic = 1188),
                (t.Enhookcyrillic = 1223),
                (t.Eogonek = 280),
                (t.Eopen = 400),
                (t.Epsilon = 917),
                (t.Epsilontonos = 904),
                (t.Ercyrillic = 1056),
                (t.Ereversed = 398),
                (t.Ereversedcyrillic = 1069),
                (t.Escyrillic = 1057),
                (t.Esdescendercyrillic = 1194),
                (t.Esh = 425),
                (t.Esmall = 63333),
                (t.Eta = 919),
                (t.Etarmenian = 1336),
                (t.Etatonos = 905),
                (t.Eth = 208),
                (t.Ethsmall = 63472),
                (t.Etilde = 7868),
                (t.Etildebelow = 7706),
                (t.Euro = 8364),
                (t.Ezh = 439),
                (t.Ezhcaron = 494),
                (t.Ezhreversed = 440),
                (t.F = 70),
                (t.Fcircle = 9403),
                (t.Fdotaccent = 7710),
                (t.Feharmenian = 1366),
                (t.Feicoptic = 996),
                (t.Fhook = 401),
                (t.Fitacyrillic = 1138),
                (t.Fiveroman = 8548);
              (t.Fmonospace = 65318),
                (t.Fourroman = 8547),
                (t.Fsmall = 63334),
                (t.G = 71),
                (t.GBsquare = 13191),
                (t.Gacute = 500),
                (t.Gamma = 915),
                (t.Gammaafrican = 404),
                (t.Gangiacoptic = 1002),
                (t.Gbreve = 286),
                (t.Gcaron = 486),
                (t.Gcedilla = 290),
                (t.Gcircle = 9404),
                (t.Gcircumflex = 284),
                (t.Gcommaaccent = 290),
                (t.Gdot = 288),
                (t.Gdotaccent = 288),
                (t.Gecyrillic = 1043),
                (t.Ghadarmenian = 1346),
                (t.Ghemiddlehookcyrillic = 1172),
                (t.Ghestrokecyrillic = 1170),
                (t.Gheupturncyrillic = 1168),
                (t.Ghook = 403),
                (t.Gimarmenian = 1331),
                (t.Gjecyrillic = 1027),
                (t.Gmacron = 7712),
                (t.Gmonospace = 65319),
                (t.Grave = 63182),
                (t.Gravesmall = 63328),
                (t.Gsmall = 63335),
                (t.Gsmallhook = 667),
                (t.Gstroke = 484),
                (t.H = 72),
                (t.H18533 = 9679),
                (t.H18543 = 9642),
                (t.H18551 = 9643),
                (t.H22073 = 9633),
                (t.HPsquare = 13259),
                (t.Haabkhasiancyrillic = 1192),
                (t.Hadescendercyrillic = 1202),
                (t.Hardsigncyrillic = 1066),
                (t.Hbar = 294),
                (t.Hbrevebelow = 7722),
                (t.Hcedilla = 7720),
                (t.Hcircle = 9405),
                (t.Hcircumflex = 292),
                (t.Hdieresis = 7718),
                (t.Hdotaccent = 7714),
                (t.Hdotbelow = 7716),
                (t.Hmonospace = 65320),
                (t.Hoarmenian = 1344),
                (t.Horicoptic = 1e3),
                (t.Hsmall = 63336),
                (t.Hungarumlaut = 63183),
                (t.Hungarumlautsmall = 63224),
                (t.Hzsquare = 13200),
                (t.I = 73),
                (t.IAcyrillic = 1071),
                (t.IJ = 306),
                (t.IUcyrillic = 1070),
                (t.Iacute = 205),
                (t.Iacutesmall = 63469),
                (t.Ibreve = 300),
                (t.Icaron = 463),
                (t.Icircle = 9406),
                (t.Icircumflex = 206),
                (t.Icircumflexsmall = 63470),
                (t.Icyrillic = 1030),
                (t.Idblgrave = 520),
                (t.Idieresis = 207),
                (t.Idieresisacute = 7726),
                (t.Idieresiscyrillic = 1252),
                (t.Idieresissmall = 63471),
                (t.Idot = 304),
                (t.Idotaccent = 304),
                (t.Idotbelow = 7882),
                (t.Iebrevecyrillic = 1238),
                (t.Iecyrillic = 1045),
                (t.Ifraktur = 8465),
                (t.Igrave = 204),
                (t.Igravesmall = 63468),
                (t.Ihookabove = 7880),
                (t.Iicyrillic = 1048),
                (t.Iinvertedbreve = 522),
                (t.Iishortcyrillic = 1049),
                (t.Imacron = 298),
                (t.Imacroncyrillic = 1250),
                (t.Imonospace = 65321),
                (t.Iniarmenian = 1339),
                (t.Iocyrillic = 1025),
                (t.Iogonek = 302),
                (t.Iota = 921),
                (t.Iotaafrican = 406),
                (t.Iotadieresis = 938),
                (t.Iotatonos = 906),
                (t.Ismall = 63337),
                (t.Istroke = 407),
                (t.Itilde = 296),
                (t.Itildebelow = 7724),
                (t.Izhitsacyrillic = 1140),
                (t.Izhitsadblgravecyrillic = 1142),
                (t.J = 74),
                (t.Jaarmenian = 1345),
                (t.Jcircle = 9407),
                (t.Jcircumflex = 308),
                (t.Jecyrillic = 1032),
                (t.Jheharmenian = 1355),
                (t.Jmonospace = 65322),
                (t.Jsmall = 63338),
                (t.K = 75),
                (t.KBsquare = 13189),
                (t.KKsquare = 13261),
                (t.Kabashkircyrillic = 1184),
                (t.Kacute = 7728),
                (t.Kacyrillic = 1050),
                (t.Kadescendercyrillic = 1178),
                (t.Kahookcyrillic = 1219),
                (t.Kappa = 922),
                (t.Kastrokecyrillic = 1182),
                (t.Kaverticalstrokecyrillic = 1180),
                (t.Kcaron = 488),
                (t.Kcedilla = 310),
                (t.Kcircle = 9408),
                (t.Kcommaaccent = 310),
                (t.Kdotbelow = 7730),
                (t.Keharmenian = 1364),
                (t.Kenarmenian = 1343),
                (t.Khacyrillic = 1061),
                (t.Kheicoptic = 998),
                (t.Khook = 408),
                (t.Kjecyrillic = 1036),
                (t.Klinebelow = 7732),
                (t.Kmonospace = 65323),
                (t.Koppacyrillic = 1152),
                (t.Koppagreek = 990),
                (t.Ksicyrillic = 1134),
                (t.Ksmall = 63339),
                (t.L = 76),
                (t.LJ = 455),
                (t.LL = 63167),
                (t.Lacute = 313),
                (t.Lambda = 923),
                (t.Lcaron = 317),
                (t.Lcedilla = 315),
                (t.Lcircle = 9409),
                (t.Lcircumflexbelow = 7740),
                (t.Lcommaaccent = 315),
                (t.Ldot = 319),
                (t.Ldotaccent = 319),
                (t.Ldotbelow = 7734),
                (t.Ldotbelowmacron = 7736),
                (t.Liwnarmenian = 1340),
                (t.Lj = 456),
                (t.Ljecyrillic = 1033),
                (t.Llinebelow = 7738),
                (t.Lmonospace = 65324),
                (t.Lslash = 321),
                (t.Lslashsmall = 63225),
                (t.Lsmall = 63340),
                (t.M = 77),
                (t.MBsquare = 13190),
                (t.Macron = 63184),
                (t.Macronsmall = 63407),
                (t.Macute = 7742),
                (t.Mcircle = 9410),
                (t.Mdotaccent = 7744),
                (t.Mdotbelow = 7746),
                (t.Menarmenian = 1348),
                (t.Mmonospace = 65325),
                (t.Msmall = 63341),
                (t.Mturned = 412),
                (t.Mu = 924),
                (t.N = 78),
                (t.NJ = 458),
                (t.Nacute = 323),
                (t.Ncaron = 327),
                (t.Ncedilla = 325),
                (t.Ncircle = 9411),
                (t.Ncircumflexbelow = 7754),
                (t.Ncommaaccent = 325),
                (t.Ndotaccent = 7748),
                (t.Ndotbelow = 7750),
                (t.Nhookleft = 413),
                (t.Nineroman = 8552),
                (t.Nj = 459),
                (t.Njecyrillic = 1034),
                (t.Nlinebelow = 7752),
                (t.Nmonospace = 65326),
                (t.Nowarmenian = 1350),
                (t.Nsmall = 63342),
                (t.Ntilde = 209),
                (t.Ntildesmall = 63473),
                (t.Nu = 925),
                (t.O = 79),
                (t.OE = 338),
                (t.OEsmall = 63226),
                (t.Oacute = 211),
                (t.Oacutesmall = 63475),
                (t.Obarredcyrillic = 1256),
                (t.Obarreddieresiscyrillic = 1258);
              (t.Obreve = 334),
                (t.Ocaron = 465),
                (t.Ocenteredtilde = 415),
                (t.Ocircle = 9412),
                (t.Ocircumflex = 212),
                (t.Ocircumflexacute = 7888),
                (t.Ocircumflexdotbelow = 7896),
                (t.Ocircumflexgrave = 7890),
                (t.Ocircumflexhookabove = 7892),
                (t.Ocircumflexsmall = 63476),
                (t.Ocircumflextilde = 7894),
                (t.Ocyrillic = 1054),
                (t.Odblacute = 336),
                (t.Odblgrave = 524),
                (t.Odieresis = 214),
                (t.Odieresiscyrillic = 1254),
                (t.Odieresissmall = 63478),
                (t.Odotbelow = 7884),
                (t.Ogoneksmall = 63227),
                (t.Ograve = 210),
                (t.Ogravesmall = 63474),
                (t.Oharmenian = 1365),
                (t.Ohm = 8486),
                (t.Ohookabove = 7886),
                (t.Ohorn = 416),
                (t.Ohornacute = 7898),
                (t.Ohorndotbelow = 7906),
                (t.Ohorngrave = 7900),
                (t.Ohornhookabove = 7902),
                (t.Ohorntilde = 7904),
                (t.Ohungarumlaut = 336),
                (t.Oi = 418),
                (t.Oinvertedbreve = 526),
                (t.Omacron = 332),
                (t.Omacronacute = 7762),
                (t.Omacrongrave = 7760),
                (t.Omega = 8486),
                (t.Omegacyrillic = 1120),
                (t.Omegagreek = 937),
                (t.Omegaroundcyrillic = 1146),
                (t.Omegatitlocyrillic = 1148),
                (t.Omegatonos = 911),
                (t.Omicron = 927),
                (t.Omicrontonos = 908),
                (t.Omonospace = 65327),
                (t.Oneroman = 8544),
                (t.Oogonek = 490),
                (t.Oogonekmacron = 492),
                (t.Oopen = 390),
                (t.Oslash = 216),
                (t.Oslashacute = 510),
                (t.Oslashsmall = 63480),
                (t.Osmall = 63343),
                (t.Ostrokeacute = 510),
                (t.Otcyrillic = 1150),
                (t.Otilde = 213),
                (t.Otildeacute = 7756),
                (t.Otildedieresis = 7758),
                (t.Otildesmall = 63477),
                (t.P = 80),
                (t.Pacute = 7764),
                (t.Pcircle = 9413),
                (t.Pdotaccent = 7766),
                (t.Pecyrillic = 1055),
                (t.Peharmenian = 1354),
                (t.Pemiddlehookcyrillic = 1190),
                (t.Phi = 934),
                (t.Phook = 420),
                (t.Pi = 928),
                (t.Piwrarmenian = 1363),
                (t.Pmonospace = 65328),
                (t.Psi = 936),
                (t.Psicyrillic = 1136),
                (t.Psmall = 63344),
                (t.Q = 81),
                (t.Qcircle = 9414),
                (t.Qmonospace = 65329),
                (t.Qsmall = 63345),
                (t.R = 82),
                (t.Raarmenian = 1356),
                (t.Racute = 340),
                (t.Rcaron = 344),
                (t.Rcedilla = 342),
                (t.Rcircle = 9415),
                (t.Rcommaaccent = 342),
                (t.Rdblgrave = 528),
                (t.Rdotaccent = 7768),
                (t.Rdotbelow = 7770),
                (t.Rdotbelowmacron = 7772),
                (t.Reharmenian = 1360),
                (t.Rfraktur = 8476),
                (t.Rho = 929),
                (t.Ringsmall = 63228),
                (t.Rinvertedbreve = 530),
                (t.Rlinebelow = 7774),
                (t.Rmonospace = 65330),
                (t.Rsmall = 63346),
                (t.Rsmallinverted = 641),
                (t.Rsmallinvertedsuperior = 694),
                (t.S = 83),
                (t.SF010000 = 9484),
                (t.SF020000 = 9492),
                (t.SF030000 = 9488),
                (t.SF040000 = 9496),
                (t.SF050000 = 9532),
                (t.SF060000 = 9516),
                (t.SF070000 = 9524),
                (t.SF080000 = 9500),
                (t.SF090000 = 9508),
                (t.SF100000 = 9472),
                (t.SF110000 = 9474),
                (t.SF190000 = 9569),
                (t.SF200000 = 9570),
                (t.SF210000 = 9558),
                (t.SF220000 = 9557),
                (t.SF230000 = 9571),
                (t.SF240000 = 9553),
                (t.SF250000 = 9559),
                (t.SF260000 = 9565),
                (t.SF270000 = 9564),
                (t.SF280000 = 9563),
                (t.SF360000 = 9566),
                (t.SF370000 = 9567),
                (t.SF380000 = 9562),
                (t.SF390000 = 9556),
                (t.SF400000 = 9577),
                (t.SF410000 = 9574),
                (t.SF420000 = 9568),
                (t.SF430000 = 9552),
                (t.SF440000 = 9580),
                (t.SF450000 = 9575),
                (t.SF460000 = 9576),
                (t.SF470000 = 9572),
                (t.SF480000 = 9573),
                (t.SF490000 = 9561),
                (t.SF500000 = 9560),
                (t.SF510000 = 9554),
                (t.SF520000 = 9555),
                (t.SF530000 = 9579),
                (t.SF540000 = 9578),
                (t.Sacute = 346),
                (t.Sacutedotaccent = 7780),
                (t.Sampigreek = 992),
                (t.Scaron = 352),
                (t.Scarondotaccent = 7782),
                (t.Scaronsmall = 63229),
                (t.Scedilla = 350),
                (t.Schwa = 399),
                (t.Schwacyrillic = 1240),
                (t.Schwadieresiscyrillic = 1242),
                (t.Scircle = 9416),
                (t.Scircumflex = 348),
                (t.Scommaaccent = 536),
                (t.Sdotaccent = 7776),
                (t.Sdotbelow = 7778),
                (t.Sdotbelowdotaccent = 7784),
                (t.Seharmenian = 1357),
                (t.Sevenroman = 8550),
                (t.Shaarmenian = 1351),
                (t.Shacyrillic = 1064),
                (t.Shchacyrillic = 1065),
                (t.Sheicoptic = 994),
                (t.Shhacyrillic = 1210),
                (t.Shimacoptic = 1004),
                (t.Sigma = 931),
                (t.Sixroman = 8549),
                (t.Smonospace = 65331),
                (t.Softsigncyrillic = 1068),
                (t.Ssmall = 63347),
                (t.Stigmagreek = 986),
                (t.T = 84),
                (t.Tau = 932),
                (t.Tbar = 358),
                (t.Tcaron = 356),
                (t.Tcedilla = 354),
                (t.Tcircle = 9417),
                (t.Tcircumflexbelow = 7792),
                (t.Tcommaaccent = 354),
                (t.Tdotaccent = 7786),
                (t.Tdotbelow = 7788),
                (t.Tecyrillic = 1058),
                (t.Tedescendercyrillic = 1196),
                (t.Tenroman = 8553),
                (t.Tetsecyrillic = 1204),
                (t.Theta = 920),
                (t.Thook = 428),
                (t.Thorn = 222),
                (t.Thornsmall = 63486),
                (t.Threeroman = 8546),
                (t.Tildesmall = 63230),
                (t.Tiwnarmenian = 1359),
                (t.Tlinebelow = 7790),
                (t.Tmonospace = 65332),
                (t.Toarmenian = 1337),
                (t.Tonefive = 444),
                (t.Tonesix = 388),
                (t.Tonetwo = 423),
                (t.Tretroflexhook = 430),
                (t.Tsecyrillic = 1062),
                (t.Tshecyrillic = 1035);
              (t.Tsmall = 63348),
                (t.Twelveroman = 8555),
                (t.Tworoman = 8545),
                (t.U = 85),
                (t.Uacute = 218),
                (t.Uacutesmall = 63482),
                (t.Ubreve = 364),
                (t.Ucaron = 467),
                (t.Ucircle = 9418),
                (t.Ucircumflex = 219),
                (t.Ucircumflexbelow = 7798),
                (t.Ucircumflexsmall = 63483),
                (t.Ucyrillic = 1059),
                (t.Udblacute = 368),
                (t.Udblgrave = 532),
                (t.Udieresis = 220),
                (t.Udieresisacute = 471),
                (t.Udieresisbelow = 7794),
                (t.Udieresiscaron = 473),
                (t.Udieresiscyrillic = 1264),
                (t.Udieresisgrave = 475),
                (t.Udieresismacron = 469),
                (t.Udieresissmall = 63484),
                (t.Udotbelow = 7908),
                (t.Ugrave = 217),
                (t.Ugravesmall = 63481),
                (t.Uhookabove = 7910),
                (t.Uhorn = 431),
                (t.Uhornacute = 7912),
                (t.Uhorndotbelow = 7920),
                (t.Uhorngrave = 7914),
                (t.Uhornhookabove = 7916),
                (t.Uhorntilde = 7918),
                (t.Uhungarumlaut = 368),
                (t.Uhungarumlautcyrillic = 1266),
                (t.Uinvertedbreve = 534),
                (t.Ukcyrillic = 1144),
                (t.Umacron = 362),
                (t.Umacroncyrillic = 1262),
                (t.Umacrondieresis = 7802),
                (t.Umonospace = 65333),
                (t.Uogonek = 370),
                (t.Upsilon = 933),
                (t.Upsilon1 = 978),
                (t.Upsilonacutehooksymbolgreek = 979),
                (t.Upsilonafrican = 433),
                (t.Upsilondieresis = 939),
                (t.Upsilondieresishooksymbolgreek = 980),
                (t.Upsilonhooksymbol = 978),
                (t.Upsilontonos = 910),
                (t.Uring = 366),
                (t.Ushortcyrillic = 1038),
                (t.Usmall = 63349),
                (t.Ustraightcyrillic = 1198),
                (t.Ustraightstrokecyrillic = 1200),
                (t.Utilde = 360),
                (t.Utildeacute = 7800),
                (t.Utildebelow = 7796),
                (t.V = 86),
                (t.Vcircle = 9419),
                (t.Vdotbelow = 7806),
                (t.Vecyrillic = 1042),
                (t.Vewarmenian = 1358),
                (t.Vhook = 434),
                (t.Vmonospace = 65334),
                (t.Voarmenian = 1352),
                (t.Vsmall = 63350),
                (t.Vtilde = 7804),
                (t.W = 87),
                (t.Wacute = 7810),
                (t.Wcircle = 9420),
                (t.Wcircumflex = 372),
                (t.Wdieresis = 7812),
                (t.Wdotaccent = 7814),
                (t.Wdotbelow = 7816),
                (t.Wgrave = 7808),
                (t.Wmonospace = 65335),
                (t.Wsmall = 63351),
                (t.X = 88),
                (t.Xcircle = 9421),
                (t.Xdieresis = 7820),
                (t.Xdotaccent = 7818),
                (t.Xeharmenian = 1341),
                (t.Xi = 926),
                (t.Xmonospace = 65336),
                (t.Xsmall = 63352),
                (t.Y = 89),
                (t.Yacute = 221),
                (t.Yacutesmall = 63485),
                (t.Yatcyrillic = 1122),
                (t.Ycircle = 9422),
                (t.Ycircumflex = 374),
                (t.Ydieresis = 376),
                (t.Ydieresissmall = 63487),
                (t.Ydotaccent = 7822),
                (t.Ydotbelow = 7924),
                (t.Yericyrillic = 1067),
                (t.Yerudieresiscyrillic = 1272),
                (t.Ygrave = 7922),
                (t.Yhook = 435),
                (t.Yhookabove = 7926),
                (t.Yiarmenian = 1349),
                (t.Yicyrillic = 1031),
                (t.Yiwnarmenian = 1362),
                (t.Ymonospace = 65337),
                (t.Ysmall = 63353),
                (t.Ytilde = 7928),
                (t.Yusbigcyrillic = 1130),
                (t.Yusbigiotifiedcyrillic = 1132),
                (t.Yuslittlecyrillic = 1126),
                (t.Yuslittleiotifiedcyrillic = 1128),
                (t.Z = 90),
                (t.Zaarmenian = 1334),
                (t.Zacute = 377),
                (t.Zcaron = 381),
                (t.Zcaronsmall = 63231),
                (t.Zcircle = 9423),
                (t.Zcircumflex = 7824),
                (t.Zdot = 379),
                (t.Zdotaccent = 379),
                (t.Zdotbelow = 7826),
                (t.Zecyrillic = 1047),
                (t.Zedescendercyrillic = 1176),
                (t.Zedieresiscyrillic = 1246),
                (t.Zeta = 918),
                (t.Zhearmenian = 1338),
                (t.Zhebrevecyrillic = 1217),
                (t.Zhecyrillic = 1046),
                (t.Zhedescendercyrillic = 1174),
                (t.Zhedieresiscyrillic = 1244),
                (t.Zlinebelow = 7828),
                (t.Zmonospace = 65338),
                (t.Zsmall = 63354),
                (t.Zstroke = 437),
                (t.a = 97),
                (t.aabengali = 2438),
                (t.aacute = 225),
                (t.aadeva = 2310),
                (t.aagujarati = 2694),
                (t.aagurmukhi = 2566),
                (t.aamatragurmukhi = 2622),
                (t.aarusquare = 13059),
                (t.aavowelsignbengali = 2494),
                (t.aavowelsigndeva = 2366),
                (t.aavowelsigngujarati = 2750),
                (t.abbreviationmarkarmenian = 1375),
                (t.abbreviationsigndeva = 2416),
                (t.abengali = 2437),
                (t.abopomofo = 12570),
                (t.abreve = 259),
                (t.abreveacute = 7855),
                (t.abrevecyrillic = 1233),
                (t.abrevedotbelow = 7863),
                (t.abrevegrave = 7857),
                (t.abrevehookabove = 7859),
                (t.abrevetilde = 7861),
                (t.acaron = 462),
                (t.acircle = 9424),
                (t.acircumflex = 226),
                (t.acircumflexacute = 7845),
                (t.acircumflexdotbelow = 7853),
                (t.acircumflexgrave = 7847),
                (t.acircumflexhookabove = 7849),
                (t.acircumflextilde = 7851),
                (t.acute = 180),
                (t.acutebelowcmb = 791),
                (t.acutecmb = 769),
                (t.acutecomb = 769),
                (t.acutedeva = 2388),
                (t.acutelowmod = 719),
                (t.acutetonecmb = 833),
                (t.acyrillic = 1072),
                (t.adblgrave = 513),
                (t.addakgurmukhi = 2673),
                (t.adeva = 2309),
                (t.adieresis = 228),
                (t.adieresiscyrillic = 1235),
                (t.adieresismacron = 479),
                (t.adotbelow = 7841),
                (t.adotmacron = 481),
                (t.ae = 230),
                (t.aeacute = 509),
                (t.aekorean = 12624),
                (t.aemacron = 483),
                (t.afii00208 = 8213),
                (t.afii08941 = 8356),
                (t.afii10017 = 1040),
                (t.afii10018 = 1041),
                (t.afii10019 = 1042),
                (t.afii10020 = 1043),
                (t.afii10021 = 1044),
                (t.afii10022 = 1045),
                (t.afii10023 = 1025),
                (t.afii10024 = 1046),
                (t.afii10025 = 1047),
                (t.afii10026 = 1048),
                (t.afii10027 = 1049),
                (t.afii10028 = 1050),
                (t.afii10029 = 1051),
                (t.afii10030 = 1052);
              (t.afii10031 = 1053),
                (t.afii10032 = 1054),
                (t.afii10033 = 1055),
                (t.afii10034 = 1056),
                (t.afii10035 = 1057),
                (t.afii10036 = 1058),
                (t.afii10037 = 1059),
                (t.afii10038 = 1060),
                (t.afii10039 = 1061),
                (t.afii10040 = 1062),
                (t.afii10041 = 1063),
                (t.afii10042 = 1064),
                (t.afii10043 = 1065),
                (t.afii10044 = 1066),
                (t.afii10045 = 1067),
                (t.afii10046 = 1068),
                (t.afii10047 = 1069),
                (t.afii10048 = 1070),
                (t.afii10049 = 1071),
                (t.afii10050 = 1168),
                (t.afii10051 = 1026),
                (t.afii10052 = 1027),
                (t.afii10053 = 1028),
                (t.afii10054 = 1029),
                (t.afii10055 = 1030),
                (t.afii10056 = 1031),
                (t.afii10057 = 1032),
                (t.afii10058 = 1033),
                (t.afii10059 = 1034),
                (t.afii10060 = 1035),
                (t.afii10061 = 1036),
                (t.afii10062 = 1038),
                (t.afii10063 = 63172),
                (t.afii10064 = 63173),
                (t.afii10065 = 1072),
                (t.afii10066 = 1073),
                (t.afii10067 = 1074),
                (t.afii10068 = 1075),
                (t.afii10069 = 1076),
                (t.afii10070 = 1077),
                (t.afii10071 = 1105),
                (t.afii10072 = 1078),
                (t.afii10073 = 1079),
                (t.afii10074 = 1080),
                (t.afii10075 = 1081),
                (t.afii10076 = 1082),
                (t.afii10077 = 1083),
                (t.afii10078 = 1084),
                (t.afii10079 = 1085),
                (t.afii10080 = 1086),
                (t.afii10081 = 1087),
                (t.afii10082 = 1088),
                (t.afii10083 = 1089),
                (t.afii10084 = 1090),
                (t.afii10085 = 1091),
                (t.afii10086 = 1092),
                (t.afii10087 = 1093),
                (t.afii10088 = 1094),
                (t.afii10089 = 1095),
                (t.afii10090 = 1096),
                (t.afii10091 = 1097),
                (t.afii10092 = 1098),
                (t.afii10093 = 1099),
                (t.afii10094 = 1100),
                (t.afii10095 = 1101),
                (t.afii10096 = 1102),
                (t.afii10097 = 1103),
                (t.afii10098 = 1169),
                (t.afii10099 = 1106),
                (t.afii10100 = 1107),
                (t.afii10101 = 1108),
                (t.afii10102 = 1109),
                (t.afii10103 = 1110),
                (t.afii10104 = 1111),
                (t.afii10105 = 1112),
                (t.afii10106 = 1113),
                (t.afii10107 = 1114),
                (t.afii10108 = 1115),
                (t.afii10109 = 1116),
                (t.afii10110 = 1118),
                (t.afii10145 = 1039),
                (t.afii10146 = 1122),
                (t.afii10147 = 1138),
                (t.afii10148 = 1140),
                (t.afii10192 = 63174),
                (t.afii10193 = 1119),
                (t.afii10194 = 1123),
                (t.afii10195 = 1139),
                (t.afii10196 = 1141),
                (t.afii10831 = 63175),
                (t.afii10832 = 63176),
                (t.afii10846 = 1241),
                (t.afii299 = 8206),
                (t.afii300 = 8207),
                (t.afii301 = 8205),
                (t.afii57381 = 1642),
                (t.afii57388 = 1548),
                (t.afii57392 = 1632),
                (t.afii57393 = 1633),
                (t.afii57394 = 1634),
                (t.afii57395 = 1635),
                (t.afii57396 = 1636),
                (t.afii57397 = 1637),
                (t.afii57398 = 1638),
                (t.afii57399 = 1639),
                (t.afii57400 = 1640),
                (t.afii57401 = 1641),
                (t.afii57403 = 1563),
                (t.afii57407 = 1567),
                (t.afii57409 = 1569),
                (t.afii57410 = 1570),
                (t.afii57411 = 1571),
                (t.afii57412 = 1572),
                (t.afii57413 = 1573),
                (t.afii57414 = 1574),
                (t.afii57415 = 1575),
                (t.afii57416 = 1576),
                (t.afii57417 = 1577),
                (t.afii57418 = 1578),
                (t.afii57419 = 1579),
                (t.afii57420 = 1580),
                (t.afii57421 = 1581),
                (t.afii57422 = 1582),
                (t.afii57423 = 1583),
                (t.afii57424 = 1584),
                (t.afii57425 = 1585),
                (t.afii57426 = 1586),
                (t.afii57427 = 1587),
                (t.afii57428 = 1588),
                (t.afii57429 = 1589),
                (t.afii57430 = 1590),
                (t.afii57431 = 1591),
                (t.afii57432 = 1592),
                (t.afii57433 = 1593),
                (t.afii57434 = 1594),
                (t.afii57440 = 1600),
                (t.afii57441 = 1601),
                (t.afii57442 = 1602),
                (t.afii57443 = 1603),
                (t.afii57444 = 1604),
                (t.afii57445 = 1605),
                (t.afii57446 = 1606),
                (t.afii57448 = 1608),
                (t.afii57449 = 1609),
                (t.afii57450 = 1610),
                (t.afii57451 = 1611),
                (t.afii57452 = 1612),
                (t.afii57453 = 1613),
                (t.afii57454 = 1614),
                (t.afii57455 = 1615),
                (t.afii57456 = 1616),
                (t.afii57457 = 1617),
                (t.afii57458 = 1618),
                (t.afii57470 = 1607),
                (t.afii57505 = 1700),
                (t.afii57506 = 1662),
                (t.afii57507 = 1670),
                (t.afii57508 = 1688),
                (t.afii57509 = 1711),
                (t.afii57511 = 1657),
                (t.afii57512 = 1672),
                (t.afii57513 = 1681),
                (t.afii57514 = 1722),
                (t.afii57519 = 1746),
                (t.afii57534 = 1749),
                (t.afii57636 = 8362),
                (t.afii57645 = 1470),
                (t.afii57658 = 1475),
                (t.afii57664 = 1488),
                (t.afii57665 = 1489),
                (t.afii57666 = 1490),
                (t.afii57667 = 1491),
                (t.afii57668 = 1492),
                (t.afii57669 = 1493),
                (t.afii57670 = 1494),
                (t.afii57671 = 1495),
                (t.afii57672 = 1496),
                (t.afii57673 = 1497),
                (t.afii57674 = 1498),
                (t.afii57675 = 1499),
                (t.afii57676 = 1500),
                (t.afii57677 = 1501),
                (t.afii57678 = 1502),
                (t.afii57679 = 1503),
                (t.afii57680 = 1504),
                (t.afii57681 = 1505),
                (t.afii57682 = 1506),
                (t.afii57683 = 1507),
                (t.afii57684 = 1508),
                (t.afii57685 = 1509),
                (t.afii57686 = 1510),
                (t.afii57687 = 1511),
                (t.afii57688 = 1512),
                (t.afii57689 = 1513),
                (t.afii57690 = 1514),
                (t.afii57694 = 64298),
                (t.afii57695 = 64299),
                (t.afii57700 = 64331),
                (t.afii57705 = 64287),
                (t.afii57716 = 1520);
              (t.afii57717 = 1521),
                (t.afii57718 = 1522),
                (t.afii57723 = 64309),
                (t.afii57793 = 1460),
                (t.afii57794 = 1461),
                (t.afii57795 = 1462),
                (t.afii57796 = 1467),
                (t.afii57797 = 1464),
                (t.afii57798 = 1463),
                (t.afii57799 = 1456),
                (t.afii57800 = 1458),
                (t.afii57801 = 1457),
                (t.afii57802 = 1459),
                (t.afii57803 = 1474),
                (t.afii57804 = 1473),
                (t.afii57806 = 1465),
                (t.afii57807 = 1468),
                (t.afii57839 = 1469),
                (t.afii57841 = 1471),
                (t.afii57842 = 1472),
                (t.afii57929 = 700),
                (t.afii61248 = 8453),
                (t.afii61289 = 8467),
                (t.afii61352 = 8470),
                (t.afii61573 = 8236),
                (t.afii61574 = 8237),
                (t.afii61575 = 8238),
                (t.afii61664 = 8204),
                (t.afii63167 = 1645),
                (t.afii64937 = 701),
                (t.agrave = 224),
                (t.agujarati = 2693),
                (t.agurmukhi = 2565),
                (t.ahiragana = 12354),
                (t.ahookabove = 7843),
                (t.aibengali = 2448),
                (t.aibopomofo = 12574),
                (t.aideva = 2320),
                (t.aiecyrillic = 1237),
                (t.aigujarati = 2704),
                (t.aigurmukhi = 2576),
                (t.aimatragurmukhi = 2632),
                (t.ainarabic = 1593),
                (t.ainfinalarabic = 65226),
                (t.aininitialarabic = 65227),
                (t.ainmedialarabic = 65228),
                (t.ainvertedbreve = 515),
                (t.aivowelsignbengali = 2504),
                (t.aivowelsigndeva = 2376),
                (t.aivowelsigngujarati = 2760),
                (t.akatakana = 12450),
                (t.akatakanahalfwidth = 65393),
                (t.akorean = 12623),
                (t.alef = 1488),
                (t.alefarabic = 1575),
                (t.alefdageshhebrew = 64304),
                (t.aleffinalarabic = 65166),
                (t.alefhamzaabovearabic = 1571),
                (t.alefhamzaabovefinalarabic = 65156),
                (t.alefhamzabelowarabic = 1573),
                (t.alefhamzabelowfinalarabic = 65160),
                (t.alefhebrew = 1488),
                (t.aleflamedhebrew = 64335),
                (t.alefmaddaabovearabic = 1570),
                (t.alefmaddaabovefinalarabic = 65154),
                (t.alefmaksuraarabic = 1609),
                (t.alefmaksurafinalarabic = 65264),
                (t.alefmaksurainitialarabic = 65267),
                (t.alefmaksuramedialarabic = 65268),
                (t.alefpatahhebrew = 64302),
                (t.alefqamatshebrew = 64303),
                (t.aleph = 8501),
                (t.allequal = 8780),
                (t.alpha = 945),
                (t.alphatonos = 940),
                (t.amacron = 257),
                (t.amonospace = 65345),
                (t.ampersand = 38),
                (t.ampersandmonospace = 65286),
                (t.ampersandsmall = 63270),
                (t.amsquare = 13250),
                (t.anbopomofo = 12578),
                (t.angbopomofo = 12580),
                (t.angbracketleft = 12296),
                (t.angbracketright = 12297),
                (t.angkhankhuthai = 3674),
                (t.angle = 8736),
                (t.anglebracketleft = 12296),
                (t.anglebracketleftvertical = 65087),
                (t.anglebracketright = 12297),
                (t.anglebracketrightvertical = 65088),
                (t.angleleft = 9001),
                (t.angleright = 9002),
                (t.angstrom = 8491),
                (t.anoteleia = 903),
                (t.anudattadeva = 2386),
                (t.anusvarabengali = 2434),
                (t.anusvaradeva = 2306),
                (t.anusvaragujarati = 2690),
                (t.aogonek = 261),
                (t.apaatosquare = 13056),
                (t.aparen = 9372),
                (t.apostrophearmenian = 1370),
                (t.apostrophemod = 700),
                (t.apple = 63743),
                (t.approaches = 8784),
                (t.approxequal = 8776),
                (t.approxequalorimage = 8786),
                (t.approximatelyequal = 8773),
                (t.araeaekorean = 12686),
                (t.araeakorean = 12685),
                (t.arc = 8978),
                (t.arighthalfring = 7834),
                (t.aring = 229),
                (t.aringacute = 507),
                (t.aringbelow = 7681),
                (t.arrowboth = 8596),
                (t.arrowdashdown = 8675),
                (t.arrowdashleft = 8672),
                (t.arrowdashright = 8674),
                (t.arrowdashup = 8673),
                (t.arrowdblboth = 8660),
                (t.arrowdbldown = 8659),
                (t.arrowdblleft = 8656),
                (t.arrowdblright = 8658),
                (t.arrowdblup = 8657),
                (t.arrowdown = 8595),
                (t.arrowdownleft = 8601),
                (t.arrowdownright = 8600),
                (t.arrowdownwhite = 8681),
                (t.arrowheaddownmod = 709),
                (t.arrowheadleftmod = 706),
                (t.arrowheadrightmod = 707),
                (t.arrowheadupmod = 708),
                (t.arrowhorizex = 63719),
                (t.arrowleft = 8592),
                (t.arrowleftdbl = 8656),
                (t.arrowleftdblstroke = 8653),
                (t.arrowleftoverright = 8646),
                (t.arrowleftwhite = 8678),
                (t.arrowright = 8594),
                (t.arrowrightdblstroke = 8655),
                (t.arrowrightheavy = 10142),
                (t.arrowrightoverleft = 8644),
                (t.arrowrightwhite = 8680),
                (t.arrowtableft = 8676),
                (t.arrowtabright = 8677),
                (t.arrowup = 8593),
                (t.arrowupdn = 8597),
                (t.arrowupdnbse = 8616),
                (t.arrowupdownbase = 8616),
                (t.arrowupleft = 8598),
                (t.arrowupleftofdown = 8645),
                (t.arrowupright = 8599),
                (t.arrowupwhite = 8679),
                (t.arrowvertex = 63718),
                (t.asciicircum = 94),
                (t.asciicircummonospace = 65342),
                (t.asciitilde = 126),
                (t.asciitildemonospace = 65374),
                (t.ascript = 593),
                (t.ascriptturned = 594),
                (t.asmallhiragana = 12353),
                (t.asmallkatakana = 12449),
                (t.asmallkatakanahalfwidth = 65383),
                (t.asterisk = 42),
                (t.asteriskaltonearabic = 1645),
                (t.asteriskarabic = 1645),
                (t.asteriskmath = 8727),
                (t.asteriskmonospace = 65290),
                (t.asterisksmall = 65121),
                (t.asterism = 8258),
                (t.asuperior = 63209),
                (t.asymptoticallyequal = 8771),
                (t.at = 64),
                (t.atilde = 227),
                (t.atmonospace = 65312),
                (t.atsmall = 65131),
                (t.aturned = 592),
                (t.aubengali = 2452),
                (t.aubopomofo = 12576),
                (t.audeva = 2324),
                (t.augujarati = 2708),
                (t.augurmukhi = 2580),
                (t.aulengthmarkbengali = 2519),
                (t.aumatragurmukhi = 2636),
                (t.auvowelsignbengali = 2508),
                (t.auvowelsigndeva = 2380),
                (t.auvowelsigngujarati = 2764),
                (t.avagrahadeva = 2365),
                (t.aybarmenian = 1377),
                (t.ayin = 1506),
                (t.ayinaltonehebrew = 64288),
                (t.ayinhebrew = 1506),
                (t.b = 98),
                (t.babengali = 2476),
                (t.backslash = 92),
                (t.backslashmonospace = 65340),
                (t.badeva = 2348),
                (t.bagujarati = 2732);
              (t.bagurmukhi = 2604),
                (t.bahiragana = 12400),
                (t.bahtthai = 3647),
                (t.bakatakana = 12496),
                (t.bar = 124),
                (t.barmonospace = 65372),
                (t.bbopomofo = 12549),
                (t.bcircle = 9425),
                (t.bdotaccent = 7683),
                (t.bdotbelow = 7685),
                (t.beamedsixteenthnotes = 9836),
                (t.because = 8757),
                (t.becyrillic = 1073),
                (t.beharabic = 1576),
                (t.behfinalarabic = 65168),
                (t.behinitialarabic = 65169),
                (t.behiragana = 12409),
                (t.behmedialarabic = 65170),
                (t.behmeeminitialarabic = 64671),
                (t.behmeemisolatedarabic = 64520),
                (t.behnoonfinalarabic = 64621),
                (t.bekatakana = 12505),
                (t.benarmenian = 1378),
                (t.bet = 1489),
                (t.beta = 946),
                (t.betasymbolgreek = 976),
                (t.betdagesh = 64305),
                (t.betdageshhebrew = 64305),
                (t.bethebrew = 1489),
                (t.betrafehebrew = 64332),
                (t.bhabengali = 2477),
                (t.bhadeva = 2349),
                (t.bhagujarati = 2733),
                (t.bhagurmukhi = 2605),
                (t.bhook = 595),
                (t.bihiragana = 12403),
                (t.bikatakana = 12499),
                (t.bilabialclick = 664),
                (t.bindigurmukhi = 2562),
                (t.birusquare = 13105),
                (t.blackcircle = 9679),
                (t.blackdiamond = 9670),
                (t.blackdownpointingtriangle = 9660),
                (t.blackleftpointingpointer = 9668),
                (t.blackleftpointingtriangle = 9664),
                (t.blacklenticularbracketleft = 12304),
                (t.blacklenticularbracketleftvertical = 65083),
                (t.blacklenticularbracketright = 12305),
                (t.blacklenticularbracketrightvertical = 65084),
                (t.blacklowerlefttriangle = 9699),
                (t.blacklowerrighttriangle = 9698),
                (t.blackrectangle = 9644),
                (t.blackrightpointingpointer = 9658),
                (t.blackrightpointingtriangle = 9654),
                (t.blacksmallsquare = 9642),
                (t.blacksmilingface = 9787),
                (t.blacksquare = 9632),
                (t.blackstar = 9733),
                (t.blackupperlefttriangle = 9700),
                (t.blackupperrighttriangle = 9701),
                (t.blackuppointingsmalltriangle = 9652),
                (t.blackuppointingtriangle = 9650),
                (t.blank = 9251),
                (t.blinebelow = 7687),
                (t.block = 9608),
                (t.bmonospace = 65346),
                (t.bobaimaithai = 3610),
                (t.bohiragana = 12412),
                (t.bokatakana = 12508),
                (t.bparen = 9373),
                (t.bqsquare = 13251),
                (t.braceex = 63732),
                (t.braceleft = 123),
                (t.braceleftbt = 63731),
                (t.braceleftmid = 63730),
                (t.braceleftmonospace = 65371),
                (t.braceleftsmall = 65115),
                (t.bracelefttp = 63729),
                (t.braceleftvertical = 65079),
                (t.braceright = 125),
                (t.bracerightbt = 63742),
                (t.bracerightmid = 63741),
                (t.bracerightmonospace = 65373),
                (t.bracerightsmall = 65116),
                (t.bracerighttp = 63740),
                (t.bracerightvertical = 65080),
                (t.bracketleft = 91),
                (t.bracketleftbt = 63728),
                (t.bracketleftex = 63727),
                (t.bracketleftmonospace = 65339),
                (t.bracketlefttp = 63726),
                (t.bracketright = 93),
                (t.bracketrightbt = 63739),
                (t.bracketrightex = 63738),
                (t.bracketrightmonospace = 65341),
                (t.bracketrighttp = 63737),
                (t.breve = 728),
                (t.brevebelowcmb = 814),
                (t.brevecmb = 774),
                (t.breveinvertedbelowcmb = 815),
                (t.breveinvertedcmb = 785),
                (t.breveinverteddoublecmb = 865),
                (t.bridgebelowcmb = 810),
                (t.bridgeinvertedbelowcmb = 826),
                (t.brokenbar = 166),
                (t.bstroke = 384),
                (t.bsuperior = 63210),
                (t.btopbar = 387),
                (t.buhiragana = 12406),
                (t.bukatakana = 12502),
                (t.bullet = 8226),
                (t.bulletinverse = 9688),
                (t.bulletoperator = 8729),
                (t.bullseye = 9678),
                (t.c = 99),
                (t.caarmenian = 1390),
                (t.cabengali = 2458),
                (t.cacute = 263),
                (t.cadeva = 2330),
                (t.cagujarati = 2714),
                (t.cagurmukhi = 2586),
                (t.calsquare = 13192),
                (t.candrabindubengali = 2433),
                (t.candrabinducmb = 784),
                (t.candrabindudeva = 2305),
                (t.candrabindugujarati = 2689),
                (t.capslock = 8682),
                (t.careof = 8453),
                (t.caron = 711),
                (t.caronbelowcmb = 812),
                (t.caroncmb = 780),
                (t.carriagereturn = 8629),
                (t.cbopomofo = 12568),
                (t.ccaron = 269),
                (t.ccedilla = 231),
                (t.ccedillaacute = 7689),
                (t.ccircle = 9426),
                (t.ccircumflex = 265),
                (t.ccurl = 597),
                (t.cdot = 267),
                (t.cdotaccent = 267),
                (t.cdsquare = 13253),
                (t.cedilla = 184),
                (t.cedillacmb = 807),
                (t.cent = 162),
                (t.centigrade = 8451),
                (t.centinferior = 63199),
                (t.centmonospace = 65504),
                (t.centoldstyle = 63394),
                (t.centsuperior = 63200),
                (t.chaarmenian = 1401),
                (t.chabengali = 2459),
                (t.chadeva = 2331),
                (t.chagujarati = 2715),
                (t.chagurmukhi = 2587),
                (t.chbopomofo = 12564),
                (t.cheabkhasiancyrillic = 1213),
                (t.checkmark = 10003),
                (t.checyrillic = 1095),
                (t.chedescenderabkhasiancyrillic = 1215),
                (t.chedescendercyrillic = 1207),
                (t.chedieresiscyrillic = 1269),
                (t.cheharmenian = 1395),
                (t.chekhakassiancyrillic = 1228),
                (t.cheverticalstrokecyrillic = 1209),
                (t.chi = 967),
                (t.chieuchacirclekorean = 12919),
                (t.chieuchaparenkorean = 12823),
                (t.chieuchcirclekorean = 12905),
                (t.chieuchkorean = 12618),
                (t.chieuchparenkorean = 12809),
                (t.chochangthai = 3594),
                (t.chochanthai = 3592),
                (t.chochingthai = 3593),
                (t.chochoethai = 3596),
                (t.chook = 392),
                (t.cieucacirclekorean = 12918),
                (t.cieucaparenkorean = 12822),
                (t.cieuccirclekorean = 12904),
                (t.cieuckorean = 12616),
                (t.cieucparenkorean = 12808),
                (t.cieucuparenkorean = 12828),
                (t.circle = 9675),
                (t.circlecopyrt = 169),
                (t.circlemultiply = 8855),
                (t.circleot = 8857),
                (t.circleplus = 8853),
                (t.circlepostalmark = 12342),
                (t.circlewithlefthalfblack = 9680),
                (t.circlewithrighthalfblack = 9681),
                (t.circumflex = 710),
                (t.circumflexbelowcmb = 813),
                (t.circumflexcmb = 770),
                (t.clear = 8999),
                (t.clickalveolar = 450),
                (t.clickdental = 448),
                (t.clicklateral = 449),
                (t.clickretroflex = 451),
                (t.club = 9827),
                (t.clubsuitblack = 9827);
              (t.clubsuitwhite = 9831),
                (t.cmcubedsquare = 13220),
                (t.cmonospace = 65347),
                (t.cmsquaredsquare = 13216),
                (t.coarmenian = 1409),
                (t.colon = 58),
                (t.colonmonetary = 8353),
                (t.colonmonospace = 65306),
                (t.colonsign = 8353),
                (t.colonsmall = 65109),
                (t.colontriangularhalfmod = 721),
                (t.colontriangularmod = 720),
                (t.comma = 44),
                (t.commaabovecmb = 787),
                (t.commaaboverightcmb = 789),
                (t.commaaccent = 63171),
                (t.commaarabic = 1548),
                (t.commaarmenian = 1373),
                (t.commainferior = 63201),
                (t.commamonospace = 65292),
                (t.commareversedabovecmb = 788),
                (t.commareversedmod = 701),
                (t.commasmall = 65104),
                (t.commasuperior = 63202),
                (t.commaturnedabovecmb = 786),
                (t.commaturnedmod = 699),
                (t.compass = 9788),
                (t.congruent = 8773),
                (t.contourintegral = 8750),
                (t.control = 8963),
                (t.controlACK = 6),
                (t.controlBEL = 7),
                (t.controlBS = 8),
                (t.controlCAN = 24),
                (t.controlCR = 13),
                (t.controlDC1 = 17),
                (t.controlDC2 = 18),
                (t.controlDC3 = 19),
                (t.controlDC4 = 20),
                (t.controlDEL = 127),
                (t.controlDLE = 16),
                (t.controlEM = 25),
                (t.controlENQ = 5),
                (t.controlEOT = 4),
                (t.controlESC = 27),
                (t.controlETB = 23),
                (t.controlETX = 3),
                (t.controlFF = 12),
                (t.controlFS = 28),
                (t.controlGS = 29),
                (t.controlHT = 9),
                (t.controlLF = 10),
                (t.controlNAK = 21),
                (t.controlRS = 30),
                (t.controlSI = 15),
                (t.controlSO = 14),
                (t.controlSOT = 2),
                (t.controlSTX = 1),
                (t.controlSUB = 26),
                (t.controlSYN = 22),
                (t.controlUS = 31),
                (t.controlVT = 11),
                (t.copyright = 169),
                (t.copyrightsans = 63721),
                (t.copyrightserif = 63193),
                (t.cornerbracketleft = 12300),
                (t.cornerbracketlefthalfwidth = 65378),
                (t.cornerbracketleftvertical = 65089),
                (t.cornerbracketright = 12301),
                (t.cornerbracketrighthalfwidth = 65379),
                (t.cornerbracketrightvertical = 65090),
                (t.corporationsquare = 13183),
                (t.cosquare = 13255),
                (t.coverkgsquare = 13254),
                (t.cparen = 9374),
                (t.cruzeiro = 8354),
                (t.cstretched = 663),
                (t.curlyand = 8911),
                (t.curlyor = 8910),
                (t.currency = 164),
                (t.cyrBreve = 63185),
                (t.cyrFlex = 63186),
                (t.cyrbreve = 63188),
                (t.cyrflex = 63189),
                (t.d = 100),
                (t.daarmenian = 1380),
                (t.dabengali = 2470),
                (t.dadarabic = 1590),
                (t.dadeva = 2342),
                (t.dadfinalarabic = 65214),
                (t.dadinitialarabic = 65215),
                (t.dadmedialarabic = 65216),
                (t.dagesh = 1468),
                (t.dageshhebrew = 1468),
                (t.dagger = 8224),
                (t.daggerdbl = 8225),
                (t.dagujarati = 2726),
                (t.dagurmukhi = 2598),
                (t.dahiragana = 12384),
                (t.dakatakana = 12480),
                (t.dalarabic = 1583),
                (t.dalet = 1491),
                (t.daletdagesh = 64307),
                (t.daletdageshhebrew = 64307),
                (t.dalethebrew = 1491),
                (t.dalfinalarabic = 65194),
                (t.dammaarabic = 1615),
                (t.dammalowarabic = 1615),
                (t.dammatanaltonearabic = 1612),
                (t.dammatanarabic = 1612),
                (t.danda = 2404),
                (t.dargahebrew = 1447),
                (t.dargalefthebrew = 1447),
                (t.dasiapneumatacyrilliccmb = 1157),
                (t.dblGrave = 63187),
                (t.dblanglebracketleft = 12298),
                (t.dblanglebracketleftvertical = 65085),
                (t.dblanglebracketright = 12299),
                (t.dblanglebracketrightvertical = 65086),
                (t.dblarchinvertedbelowcmb = 811),
                (t.dblarrowleft = 8660),
                (t.dblarrowright = 8658),
                (t.dbldanda = 2405),
                (t.dblgrave = 63190),
                (t.dblgravecmb = 783),
                (t.dblintegral = 8748),
                (t.dbllowline = 8215),
                (t.dbllowlinecmb = 819),
                (t.dbloverlinecmb = 831),
                (t.dblprimemod = 698),
                (t.dblverticalbar = 8214),
                (t.dblverticallineabovecmb = 782),
                (t.dbopomofo = 12553),
                (t.dbsquare = 13256),
                (t.dcaron = 271),
                (t.dcedilla = 7697),
                (t.dcircle = 9427),
                (t.dcircumflexbelow = 7699),
                (t.dcroat = 273),
                (t.ddabengali = 2465),
                (t.ddadeva = 2337),
                (t.ddagujarati = 2721),
                (t.ddagurmukhi = 2593),
                (t.ddalarabic = 1672),
                (t.ddalfinalarabic = 64393),
                (t.dddhadeva = 2396),
                (t.ddhabengali = 2466),
                (t.ddhadeva = 2338),
                (t.ddhagujarati = 2722),
                (t.ddhagurmukhi = 2594),
                (t.ddotaccent = 7691),
                (t.ddotbelow = 7693),
                (t.decimalseparatorarabic = 1643),
                (t.decimalseparatorpersian = 1643),
                (t.decyrillic = 1076),
                (t.degree = 176),
                (t.dehihebrew = 1453),
                (t.dehiragana = 12391),
                (t.deicoptic = 1007),
                (t.dekatakana = 12487),
                (t.deleteleft = 9003),
                (t.deleteright = 8998),
                (t.delta = 948),
                (t.deltaturned = 397),
                (t.denominatorminusonenumeratorbengali = 2552),
                (t.dezh = 676),
                (t.dhabengali = 2471),
                (t.dhadeva = 2343),
                (t.dhagujarati = 2727),
                (t.dhagurmukhi = 2599),
                (t.dhook = 599),
                (t.dialytikatonos = 901),
                (t.dialytikatonoscmb = 836),
                (t.diamond = 9830),
                (t.diamondsuitwhite = 9826),
                (t.dieresis = 168),
                (t.dieresisacute = 63191),
                (t.dieresisbelowcmb = 804),
                (t.dieresiscmb = 776),
                (t.dieresisgrave = 63192),
                (t.dieresistonos = 901),
                (t.dihiragana = 12386),
                (t.dikatakana = 12482),
                (t.dittomark = 12291),
                (t.divide = 247),
                (t.divides = 8739),
                (t.divisionslash = 8725),
                (t.djecyrillic = 1106),
                (t.dkshade = 9619),
                (t.dlinebelow = 7695),
                (t.dlsquare = 13207),
                (t.dmacron = 273),
                (t.dmonospace = 65348),
                (t.dnblock = 9604),
                (t.dochadathai = 3598),
                (t.dodekthai = 3604),
                (t.dohiragana = 12393),
                (t.dokatakana = 12489),
                (t.dollar = 36),
                (t.dollarinferior = 63203);
              (t.dollarmonospace = 65284),
                (t.dollaroldstyle = 63268),
                (t.dollarsmall = 65129),
                (t.dollarsuperior = 63204),
                (t.dong = 8363),
                (t.dorusquare = 13094),
                (t.dotaccent = 729),
                (t.dotaccentcmb = 775),
                (t.dotbelowcmb = 803),
                (t.dotbelowcomb = 803),
                (t.dotkatakana = 12539),
                (t.dotlessi = 305),
                (t.dotlessj = 63166),
                (t.dotlessjstrokehook = 644),
                (t.dotmath = 8901),
                (t.dottedcircle = 9676),
                (t.doubleyodpatah = 64287),
                (t.doubleyodpatahhebrew = 64287),
                (t.downtackbelowcmb = 798),
                (t.downtackmod = 725),
                (t.dparen = 9375),
                (t.dsuperior = 63211),
                (t.dtail = 598),
                (t.dtopbar = 396),
                (t.duhiragana = 12389),
                (t.dukatakana = 12485),
                (t.dz = 499),
                (t.dzaltone = 675),
                (t.dzcaron = 454),
                (t.dzcurl = 677),
                (t.dzeabkhasiancyrillic = 1249),
                (t.dzecyrillic = 1109),
                (t.dzhecyrillic = 1119),
                (t.e = 101),
                (t.eacute = 233),
                (t.earth = 9793),
                (t.ebengali = 2447),
                (t.ebopomofo = 12572),
                (t.ebreve = 277),
                (t.ecandradeva = 2317),
                (t.ecandragujarati = 2701),
                (t.ecandravowelsigndeva = 2373),
                (t.ecandravowelsigngujarati = 2757),
                (t.ecaron = 283),
                (t.ecedillabreve = 7709),
                (t.echarmenian = 1381),
                (t.echyiwnarmenian = 1415),
                (t.ecircle = 9428),
                (t.ecircumflex = 234),
                (t.ecircumflexacute = 7871),
                (t.ecircumflexbelow = 7705),
                (t.ecircumflexdotbelow = 7879),
                (t.ecircumflexgrave = 7873),
                (t.ecircumflexhookabove = 7875),
                (t.ecircumflextilde = 7877),
                (t.ecyrillic = 1108),
                (t.edblgrave = 517),
                (t.edeva = 2319),
                (t.edieresis = 235),
                (t.edot = 279),
                (t.edotaccent = 279),
                (t.edotbelow = 7865),
                (t.eegurmukhi = 2575),
                (t.eematragurmukhi = 2631),
                (t.efcyrillic = 1092),
                (t.egrave = 232),
                (t.egujarati = 2703),
                (t.eharmenian = 1383),
                (t.ehbopomofo = 12573),
                (t.ehiragana = 12360),
                (t.ehookabove = 7867),
                (t.eibopomofo = 12575),
                (t.eight = 56),
                (t.eightarabic = 1640),
                (t.eightbengali = 2542),
                (t.eightcircle = 9319),
                (t.eightcircleinversesansserif = 10129),
                (t.eightdeva = 2414),
                (t.eighteencircle = 9329),
                (t.eighteenparen = 9349),
                (t.eighteenperiod = 9369),
                (t.eightgujarati = 2798),
                (t.eightgurmukhi = 2670),
                (t.eighthackarabic = 1640),
                (t.eighthangzhou = 12328),
                (t.eighthnotebeamed = 9835),
                (t.eightideographicparen = 12839),
                (t.eightinferior = 8328),
                (t.eightmonospace = 65304),
                (t.eightoldstyle = 63288),
                (t.eightparen = 9339),
                (t.eightperiod = 9359),
                (t.eightpersian = 1784),
                (t.eightroman = 8567),
                (t.eightsuperior = 8312),
                (t.eightthai = 3672),
                (t.einvertedbreve = 519),
                (t.eiotifiedcyrillic = 1125),
                (t.ekatakana = 12456),
                (t.ekatakanahalfwidth = 65396),
                (t.ekonkargurmukhi = 2676),
                (t.ekorean = 12628),
                (t.elcyrillic = 1083),
                (t.element = 8712),
                (t.elevencircle = 9322),
                (t.elevenparen = 9342),
                (t.elevenperiod = 9362),
                (t.elevenroman = 8570),
                (t.ellipsis = 8230),
                (t.ellipsisvertical = 8942),
                (t.emacron = 275),
                (t.emacronacute = 7703),
                (t.emacrongrave = 7701),
                (t.emcyrillic = 1084),
                (t.emdash = 8212),
                (t.emdashvertical = 65073),
                (t.emonospace = 65349),
                (t.emphasismarkarmenian = 1371),
                (t.emptyset = 8709),
                (t.enbopomofo = 12579),
                (t.encyrillic = 1085),
                (t.endash = 8211),
                (t.endashvertical = 65074),
                (t.endescendercyrillic = 1187),
                (t.eng = 331),
                (t.engbopomofo = 12581),
                (t.enghecyrillic = 1189),
                (t.enhookcyrillic = 1224),
                (t.enspace = 8194),
                (t.eogonek = 281),
                (t.eokorean = 12627),
                (t.eopen = 603),
                (t.eopenclosed = 666),
                (t.eopenreversed = 604),
                (t.eopenreversedclosed = 606),
                (t.eopenreversedhook = 605),
                (t.eparen = 9376),
                (t.epsilon = 949),
                (t.epsilontonos = 941),
                (t.equal = 61),
                (t.equalmonospace = 65309),
                (t.equalsmall = 65126),
                (t.equalsuperior = 8316),
                (t.equivalence = 8801),
                (t.erbopomofo = 12582),
                (t.ercyrillic = 1088),
                (t.ereversed = 600),
                (t.ereversedcyrillic = 1101),
                (t.escyrillic = 1089),
                (t.esdescendercyrillic = 1195),
                (t.esh = 643),
                (t.eshcurl = 646),
                (t.eshortdeva = 2318),
                (t.eshortvowelsigndeva = 2374),
                (t.eshreversedloop = 426),
                (t.eshsquatreversed = 645),
                (t.esmallhiragana = 12359),
                (t.esmallkatakana = 12455),
                (t.esmallkatakanahalfwidth = 65386),
                (t.estimated = 8494),
                (t.esuperior = 63212),
                (t.eta = 951),
                (t.etarmenian = 1384),
                (t.etatonos = 942),
                (t.eth = 240),
                (t.etilde = 7869),
                (t.etildebelow = 7707),
                (t.etnahtafoukhhebrew = 1425),
                (t.etnahtafoukhlefthebrew = 1425),
                (t.etnahtahebrew = 1425),
                (t.etnahtalefthebrew = 1425),
                (t.eturned = 477),
                (t.eukorean = 12641),
                (t.euro = 8364),
                (t.evowelsignbengali = 2503),
                (t.evowelsigndeva = 2375),
                (t.evowelsigngujarati = 2759),
                (t.exclam = 33),
                (t.exclamarmenian = 1372),
                (t.exclamdbl = 8252),
                (t.exclamdown = 161),
                (t.exclamdownsmall = 63393),
                (t.exclammonospace = 65281),
                (t.exclamsmall = 63265),
                (t.existential = 8707),
                (t.ezh = 658),
                (t.ezhcaron = 495),
                (t.ezhcurl = 659),
                (t.ezhreversed = 441),
                (t.ezhtail = 442),
                (t.f = 102),
                (t.fadeva = 2398),
                (t.fagurmukhi = 2654),
                (t.fahrenheit = 8457),
                (t.fathaarabic = 1614),
                (t.fathalowarabic = 1614),
                (t.fathatanarabic = 1611),
                (t.fbopomofo = 12552),
                (t.fcircle = 9429),
                (t.fdotaccent = 7711);
              (t.feharabic = 1601),
                (t.feharmenian = 1414),
                (t.fehfinalarabic = 65234),
                (t.fehinitialarabic = 65235),
                (t.fehmedialarabic = 65236),
                (t.feicoptic = 997),
                (t.female = 9792),
                (t.ff = 64256),
                (t.ffi = 64259),
                (t.ffl = 64260),
                (t.fi = 64257),
                (t.fifteencircle = 9326),
                (t.fifteenparen = 9346),
                (t.fifteenperiod = 9366),
                (t.figuredash = 8210),
                (t.filledbox = 9632),
                (t.filledrect = 9644),
                (t.finalkaf = 1498),
                (t.finalkafdagesh = 64314),
                (t.finalkafdageshhebrew = 64314),
                (t.finalkafhebrew = 1498),
                (t.finalmem = 1501),
                (t.finalmemhebrew = 1501),
                (t.finalnun = 1503),
                (t.finalnunhebrew = 1503),
                (t.finalpe = 1507),
                (t.finalpehebrew = 1507),
                (t.finaltsadi = 1509),
                (t.finaltsadihebrew = 1509),
                (t.firsttonechinese = 713),
                (t.fisheye = 9673),
                (t.fitacyrillic = 1139),
                (t.five = 53),
                (t.fivearabic = 1637),
                (t.fivebengali = 2539),
                (t.fivecircle = 9316),
                (t.fivecircleinversesansserif = 10126),
                (t.fivedeva = 2411),
                (t.fiveeighths = 8541),
                (t.fivegujarati = 2795),
                (t.fivegurmukhi = 2667),
                (t.fivehackarabic = 1637),
                (t.fivehangzhou = 12325),
                (t.fiveideographicparen = 12836),
                (t.fiveinferior = 8325),
                (t.fivemonospace = 65301),
                (t.fiveoldstyle = 63285),
                (t.fiveparen = 9336),
                (t.fiveperiod = 9356),
                (t.fivepersian = 1781),
                (t.fiveroman = 8564),
                (t.fivesuperior = 8309),
                (t.fivethai = 3669),
                (t.fl = 64258),
                (t.florin = 402),
                (t.fmonospace = 65350),
                (t.fmsquare = 13209),
                (t.fofanthai = 3615),
                (t.fofathai = 3613),
                (t.fongmanthai = 3663),
                (t.forall = 8704),
                (t.four = 52),
                (t.fourarabic = 1636),
                (t.fourbengali = 2538),
                (t.fourcircle = 9315),
                (t.fourcircleinversesansserif = 10125),
                (t.fourdeva = 2410),
                (t.fourgujarati = 2794),
                (t.fourgurmukhi = 2666),
                (t.fourhackarabic = 1636),
                (t.fourhangzhou = 12324),
                (t.fourideographicparen = 12835),
                (t.fourinferior = 8324),
                (t.fourmonospace = 65300),
                (t.fournumeratorbengali = 2551),
                (t.fouroldstyle = 63284),
                (t.fourparen = 9335),
                (t.fourperiod = 9355),
                (t.fourpersian = 1780),
                (t.fourroman = 8563),
                (t.foursuperior = 8308),
                (t.fourteencircle = 9325),
                (t.fourteenparen = 9345),
                (t.fourteenperiod = 9365),
                (t.fourthai = 3668),
                (t.fourthtonechinese = 715),
                (t.fparen = 9377),
                (t.fraction = 8260),
                (t.franc = 8355),
                (t.g = 103),
                (t.gabengali = 2455),
                (t.gacute = 501),
                (t.gadeva = 2327),
                (t.gafarabic = 1711),
                (t.gaffinalarabic = 64403),
                (t.gafinitialarabic = 64404),
                (t.gafmedialarabic = 64405),
                (t.gagujarati = 2711),
                (t.gagurmukhi = 2583),
                (t.gahiragana = 12364),
                (t.gakatakana = 12460),
                (t.gamma = 947),
                (t.gammalatinsmall = 611),
                (t.gammasuperior = 736),
                (t.gangiacoptic = 1003),
                (t.gbopomofo = 12557),
                (t.gbreve = 287),
                (t.gcaron = 487),
                (t.gcedilla = 291),
                (t.gcircle = 9430),
                (t.gcircumflex = 285),
                (t.gcommaaccent = 291),
                (t.gdot = 289),
                (t.gdotaccent = 289),
                (t.gecyrillic = 1075),
                (t.gehiragana = 12370),
                (t.gekatakana = 12466),
                (t.geometricallyequal = 8785),
                (t.gereshaccenthebrew = 1436),
                (t.gereshhebrew = 1523),
                (t.gereshmuqdamhebrew = 1437),
                (t.germandbls = 223),
                (t.gershayimaccenthebrew = 1438),
                (t.gershayimhebrew = 1524),
                (t.getamark = 12307),
                (t.ghabengali = 2456),
                (t.ghadarmenian = 1394),
                (t.ghadeva = 2328),
                (t.ghagujarati = 2712),
                (t.ghagurmukhi = 2584),
                (t.ghainarabic = 1594),
                (t.ghainfinalarabic = 65230),
                (t.ghaininitialarabic = 65231),
                (t.ghainmedialarabic = 65232),
                (t.ghemiddlehookcyrillic = 1173),
                (t.ghestrokecyrillic = 1171),
                (t.gheupturncyrillic = 1169),
                (t.ghhadeva = 2394),
                (t.ghhagurmukhi = 2650),
                (t.ghook = 608),
                (t.ghzsquare = 13203),
                (t.gihiragana = 12366),
                (t.gikatakana = 12462),
                (t.gimarmenian = 1379),
                (t.gimel = 1490),
                (t.gimeldagesh = 64306),
                (t.gimeldageshhebrew = 64306),
                (t.gimelhebrew = 1490),
                (t.gjecyrillic = 1107),
                (t.glottalinvertedstroke = 446),
                (t.glottalstop = 660),
                (t.glottalstopinverted = 662),
                (t.glottalstopmod = 704),
                (t.glottalstopreversed = 661),
                (t.glottalstopreversedmod = 705),
                (t.glottalstopreversedsuperior = 740),
                (t.glottalstopstroke = 673),
                (t.glottalstopstrokereversed = 674),
                (t.gmacron = 7713),
                (t.gmonospace = 65351),
                (t.gohiragana = 12372),
                (t.gokatakana = 12468),
                (t.gparen = 9378),
                (t.gpasquare = 13228),
                (t.gradient = 8711),
                (t.grave = 96),
                (t.gravebelowcmb = 790),
                (t.gravecmb = 768),
                (t.gravecomb = 768),
                (t.gravedeva = 2387),
                (t.gravelowmod = 718),
                (t.gravemonospace = 65344),
                (t.gravetonecmb = 832),
                (t.greater = 62),
                (t.greaterequal = 8805),
                (t.greaterequalorless = 8923),
                (t.greatermonospace = 65310),
                (t.greaterorequivalent = 8819),
                (t.greaterorless = 8823),
                (t.greateroverequal = 8807),
                (t.greatersmall = 65125),
                (t.gscript = 609),
                (t.gstroke = 485),
                (t.guhiragana = 12368),
                (t.guillemotleft = 171),
                (t.guillemotright = 187),
                (t.guilsinglleft = 8249),
                (t.guilsinglright = 8250),
                (t.gukatakana = 12464),
                (t.guramusquare = 13080),
                (t.gysquare = 13257),
                (t.h = 104),
                (t.haabkhasiancyrillic = 1193),
                (t.haaltonearabic = 1729),
                (t.habengali = 2489),
                (t.hadescendercyrillic = 1203),
                (t.hadeva = 2361),
                (t.hagujarati = 2745),
                (t.hagurmukhi = 2617),
                (t.haharabic = 1581);
              (t.hahfinalarabic = 65186),
                (t.hahinitialarabic = 65187),
                (t.hahiragana = 12399),
                (t.hahmedialarabic = 65188),
                (t.haitusquare = 13098),
                (t.hakatakana = 12495),
                (t.hakatakanahalfwidth = 65418),
                (t.halantgurmukhi = 2637),
                (t.hamzaarabic = 1569),
                (t.hamzalowarabic = 1569),
                (t.hangulfiller = 12644),
                (t.hardsigncyrillic = 1098),
                (t.harpoonleftbarbup = 8636),
                (t.harpoonrightbarbup = 8640),
                (t.hasquare = 13258),
                (t.hatafpatah = 1458),
                (t.hatafpatah16 = 1458),
                (t.hatafpatah23 = 1458),
                (t.hatafpatah2f = 1458),
                (t.hatafpatahhebrew = 1458),
                (t.hatafpatahnarrowhebrew = 1458),
                (t.hatafpatahquarterhebrew = 1458),
                (t.hatafpatahwidehebrew = 1458),
                (t.hatafqamats = 1459),
                (t.hatafqamats1b = 1459),
                (t.hatafqamats28 = 1459),
                (t.hatafqamats34 = 1459),
                (t.hatafqamatshebrew = 1459),
                (t.hatafqamatsnarrowhebrew = 1459),
                (t.hatafqamatsquarterhebrew = 1459),
                (t.hatafqamatswidehebrew = 1459),
                (t.hatafsegol = 1457),
                (t.hatafsegol17 = 1457),
                (t.hatafsegol24 = 1457),
                (t.hatafsegol30 = 1457),
                (t.hatafsegolhebrew = 1457),
                (t.hatafsegolnarrowhebrew = 1457),
                (t.hatafsegolquarterhebrew = 1457),
                (t.hatafsegolwidehebrew = 1457),
                (t.hbar = 295),
                (t.hbopomofo = 12559),
                (t.hbrevebelow = 7723),
                (t.hcedilla = 7721),
                (t.hcircle = 9431),
                (t.hcircumflex = 293),
                (t.hdieresis = 7719),
                (t.hdotaccent = 7715),
                (t.hdotbelow = 7717),
                (t.he = 1492),
                (t.heart = 9829),
                (t.heartsuitblack = 9829),
                (t.heartsuitwhite = 9825),
                (t.hedagesh = 64308),
                (t.hedageshhebrew = 64308),
                (t.hehaltonearabic = 1729),
                (t.heharabic = 1607),
                (t.hehebrew = 1492),
                (t.hehfinalaltonearabic = 64423),
                (t.hehfinalalttwoarabic = 65258),
                (t.hehfinalarabic = 65258),
                (t.hehhamzaabovefinalarabic = 64421),
                (t.hehhamzaaboveisolatedarabic = 64420),
                (t.hehinitialaltonearabic = 64424),
                (t.hehinitialarabic = 65259),
                (t.hehiragana = 12408),
                (t.hehmedialaltonearabic = 64425),
                (t.hehmedialarabic = 65260),
                (t.heiseierasquare = 13179),
                (t.hekatakana = 12504),
                (t.hekatakanahalfwidth = 65421),
                (t.hekutaarusquare = 13110),
                (t.henghook = 615),
                (t.herutusquare = 13113),
                (t.het = 1495),
                (t.hethebrew = 1495),
                (t.hhook = 614),
                (t.hhooksuperior = 689),
                (t.hieuhacirclekorean = 12923),
                (t.hieuhaparenkorean = 12827),
                (t.hieuhcirclekorean = 12909),
                (t.hieuhkorean = 12622),
                (t.hieuhparenkorean = 12813),
                (t.hihiragana = 12402),
                (t.hikatakana = 12498),
                (t.hikatakanahalfwidth = 65419),
                (t.hiriq = 1460),
                (t.hiriq14 = 1460),
                (t.hiriq21 = 1460),
                (t.hiriq2d = 1460),
                (t.hiriqhebrew = 1460),
                (t.hiriqnarrowhebrew = 1460),
                (t.hiriqquarterhebrew = 1460),
                (t.hiriqwidehebrew = 1460),
                (t.hlinebelow = 7830),
                (t.hmonospace = 65352),
                (t.hoarmenian = 1392),
                (t.hohipthai = 3627),
                (t.hohiragana = 12411),
                (t.hokatakana = 12507),
                (t.hokatakanahalfwidth = 65422),
                (t.holam = 1465),
                (t.holam19 = 1465),
                (t.holam26 = 1465),
                (t.holam32 = 1465),
                (t.holamhebrew = 1465),
                (t.holamnarrowhebrew = 1465),
                (t.holamquarterhebrew = 1465),
                (t.holamwidehebrew = 1465),
                (t.honokhukthai = 3630),
                (t.hookabovecomb = 777),
                (t.hookcmb = 777),
                (t.hookpalatalizedbelowcmb = 801),
                (t.hookretroflexbelowcmb = 802),
                (t.hoonsquare = 13122),
                (t.horicoptic = 1001),
                (t.horizontalbar = 8213),
                (t.horncmb = 795),
                (t.hotsprings = 9832),
                (t.house = 8962),
                (t.hparen = 9379),
                (t.hsuperior = 688),
                (t.hturned = 613),
                (t.huhiragana = 12405),
                (t.huiitosquare = 13107),
                (t.hukatakana = 12501),
                (t.hukatakanahalfwidth = 65420),
                (t.hungarumlaut = 733),
                (t.hungarumlautcmb = 779),
                (t.hv = 405),
                (t.hyphen = 45),
                (t.hypheninferior = 63205),
                (t.hyphenmonospace = 65293),
                (t.hyphensmall = 65123),
                (t.hyphensuperior = 63206),
                (t.hyphentwo = 8208),
                (t.i = 105),
                (t.iacute = 237),
                (t.iacyrillic = 1103),
                (t.ibengali = 2439),
                (t.ibopomofo = 12583),
                (t.ibreve = 301),
                (t.icaron = 464),
                (t.icircle = 9432),
                (t.icircumflex = 238),
                (t.icyrillic = 1110),
                (t.idblgrave = 521),
                (t.ideographearthcircle = 12943),
                (t.ideographfirecircle = 12939),
                (t.ideographicallianceparen = 12863),
                (t.ideographiccallparen = 12858),
                (t.ideographiccentrecircle = 12965),
                (t.ideographicclose = 12294),
                (t.ideographiccomma = 12289),
                (t.ideographiccommaleft = 65380),
                (t.ideographiccongratulationparen = 12855),
                (t.ideographiccorrectcircle = 12963),
                (t.ideographicearthparen = 12847),
                (t.ideographicenterpriseparen = 12861),
                (t.ideographicexcellentcircle = 12957),
                (t.ideographicfestivalparen = 12864),
                (t.ideographicfinancialcircle = 12950),
                (t.ideographicfinancialparen = 12854),
                (t.ideographicfireparen = 12843),
                (t.ideographichaveparen = 12850),
                (t.ideographichighcircle = 12964),
                (t.ideographiciterationmark = 12293),
                (t.ideographiclaborcircle = 12952),
                (t.ideographiclaborparen = 12856),
                (t.ideographicleftcircle = 12967),
                (t.ideographiclowcircle = 12966),
                (t.ideographicmedicinecircle = 12969),
                (t.ideographicmetalparen = 12846),
                (t.ideographicmoonparen = 12842),
                (t.ideographicnameparen = 12852),
                (t.ideographicperiod = 12290),
                (t.ideographicprintcircle = 12958),
                (t.ideographicreachparen = 12867),
                (t.ideographicrepresentparen = 12857),
                (t.ideographicresourceparen = 12862),
                (t.ideographicrightcircle = 12968),
                (t.ideographicsecretcircle = 12953),
                (t.ideographicselfparen = 12866),
                (t.ideographicsocietyparen = 12851),
                (t.ideographicspace = 12288),
                (t.ideographicspecialparen = 12853),
                (t.ideographicstockparen = 12849),
                (t.ideographicstudyparen = 12859),
                (t.ideographicsunparen = 12848),
                (t.ideographicsuperviseparen = 12860),
                (t.ideographicwaterparen = 12844),
                (t.ideographicwoodparen = 12845),
                (t.ideographiczero = 12295),
                (t.ideographmetalcircle = 12942),
                (t.ideographmooncircle = 12938),
                (t.ideographnamecircle = 12948),
                (t.ideographsuncircle = 12944),
                (t.ideographwatercircle = 12940),
                (t.ideographwoodcircle = 12941),
                (t.ideva = 2311),
                (t.idieresis = 239);
              (t.idieresisacute = 7727),
                (t.idieresiscyrillic = 1253),
                (t.idotbelow = 7883),
                (t.iebrevecyrillic = 1239),
                (t.iecyrillic = 1077),
                (t.ieungacirclekorean = 12917),
                (t.ieungaparenkorean = 12821),
                (t.ieungcirclekorean = 12903),
                (t.ieungkorean = 12615),
                (t.ieungparenkorean = 12807),
                (t.igrave = 236),
                (t.igujarati = 2695),
                (t.igurmukhi = 2567),
                (t.ihiragana = 12356),
                (t.ihookabove = 7881),
                (t.iibengali = 2440),
                (t.iicyrillic = 1080),
                (t.iideva = 2312),
                (t.iigujarati = 2696),
                (t.iigurmukhi = 2568),
                (t.iimatragurmukhi = 2624),
                (t.iinvertedbreve = 523),
                (t.iishortcyrillic = 1081),
                (t.iivowelsignbengali = 2496),
                (t.iivowelsigndeva = 2368),
                (t.iivowelsigngujarati = 2752),
                (t.ij = 307),
                (t.ikatakana = 12452),
                (t.ikatakanahalfwidth = 65394),
                (t.ikorean = 12643),
                (t.ilde = 732),
                (t.iluyhebrew = 1452),
                (t.imacron = 299),
                (t.imacroncyrillic = 1251),
                (t.imageorapproximatelyequal = 8787),
                (t.imatragurmukhi = 2623),
                (t.imonospace = 65353),
                (t.increment = 8710),
                (t.infinity = 8734),
                (t.iniarmenian = 1387),
                (t.integral = 8747),
                (t.integralbottom = 8993),
                (t.integralbt = 8993),
                (t.integralex = 63733),
                (t.integraltop = 8992),
                (t.integraltp = 8992),
                (t.intersection = 8745),
                (t.intisquare = 13061),
                (t.invbullet = 9688),
                (t.invcircle = 9689),
                (t.invsmileface = 9787),
                (t.iocyrillic = 1105),
                (t.iogonek = 303),
                (t.iota = 953),
                (t.iotadieresis = 970),
                (t.iotadieresistonos = 912),
                (t.iotalatin = 617),
                (t.iotatonos = 943),
                (t.iparen = 9380),
                (t.irigurmukhi = 2674),
                (t.ismallhiragana = 12355),
                (t.ismallkatakana = 12451),
                (t.ismallkatakanahalfwidth = 65384),
                (t.issharbengali = 2554),
                (t.istroke = 616),
                (t.isuperior = 63213),
                (t.iterationhiragana = 12445),
                (t.iterationkatakana = 12541),
                (t.itilde = 297),
                (t.itildebelow = 7725),
                (t.iubopomofo = 12585),
                (t.iucyrillic = 1102),
                (t.ivowelsignbengali = 2495),
                (t.ivowelsigndeva = 2367),
                (t.ivowelsigngujarati = 2751),
                (t.izhitsacyrillic = 1141),
                (t.izhitsadblgravecyrillic = 1143),
                (t.j = 106),
                (t.jaarmenian = 1393),
                (t.jabengali = 2460),
                (t.jadeva = 2332),
                (t.jagujarati = 2716),
                (t.jagurmukhi = 2588),
                (t.jbopomofo = 12560),
                (t.jcaron = 496),
                (t.jcircle = 9433),
                (t.jcircumflex = 309),
                (t.jcrossedtail = 669),
                (t.jdotlessstroke = 607),
                (t.jecyrillic = 1112),
                (t.jeemarabic = 1580),
                (t.jeemfinalarabic = 65182),
                (t.jeeminitialarabic = 65183),
                (t.jeemmedialarabic = 65184),
                (t.jeharabic = 1688),
                (t.jehfinalarabic = 64395),
                (t.jhabengali = 2461),
                (t.jhadeva = 2333),
                (t.jhagujarati = 2717),
                (t.jhagurmukhi = 2589),
                (t.jheharmenian = 1403),
                (t.jis = 12292),
                (t.jmonospace = 65354),
                (t.jparen = 9381),
                (t.jsuperior = 690),
                (t.k = 107),
                (t.kabashkircyrillic = 1185),
                (t.kabengali = 2453),
                (t.kacute = 7729),
                (t.kacyrillic = 1082),
                (t.kadescendercyrillic = 1179),
                (t.kadeva = 2325),
                (t.kaf = 1499),
                (t.kafarabic = 1603),
                (t.kafdagesh = 64315),
                (t.kafdageshhebrew = 64315),
                (t.kaffinalarabic = 65242),
                (t.kafhebrew = 1499),
                (t.kafinitialarabic = 65243),
                (t.kafmedialarabic = 65244),
                (t.kafrafehebrew = 64333),
                (t.kagujarati = 2709),
                (t.kagurmukhi = 2581),
                (t.kahiragana = 12363),
                (t.kahookcyrillic = 1220),
                (t.kakatakana = 12459),
                (t.kakatakanahalfwidth = 65398),
                (t.kappa = 954),
                (t.kappasymbolgreek = 1008),
                (t.kapyeounmieumkorean = 12657),
                (t.kapyeounphieuphkorean = 12676),
                (t.kapyeounpieupkorean = 12664),
                (t.kapyeounssangpieupkorean = 12665),
                (t.karoriisquare = 13069),
                (t.kashidaautoarabic = 1600),
                (t.kashidaautonosidebearingarabic = 1600),
                (t.kasmallkatakana = 12533),
                (t.kasquare = 13188),
                (t.kasraarabic = 1616),
                (t.kasratanarabic = 1613),
                (t.kastrokecyrillic = 1183),
                (t.katahiraprolongmarkhalfwidth = 65392),
                (t.kaverticalstrokecyrillic = 1181),
                (t.kbopomofo = 12558),
                (t.kcalsquare = 13193),
                (t.kcaron = 489),
                (t.kcedilla = 311),
                (t.kcircle = 9434),
                (t.kcommaaccent = 311),
                (t.kdotbelow = 7731),
                (t.keharmenian = 1412),
                (t.kehiragana = 12369),
                (t.kekatakana = 12465),
                (t.kekatakanahalfwidth = 65401),
                (t.kenarmenian = 1391),
                (t.kesmallkatakana = 12534),
                (t.kgreenlandic = 312),
                (t.khabengali = 2454),
                (t.khacyrillic = 1093),
                (t.khadeva = 2326),
                (t.khagujarati = 2710),
                (t.khagurmukhi = 2582),
                (t.khaharabic = 1582),
                (t.khahfinalarabic = 65190),
                (t.khahinitialarabic = 65191),
                (t.khahmedialarabic = 65192),
                (t.kheicoptic = 999),
                (t.khhadeva = 2393),
                (t.khhagurmukhi = 2649),
                (t.khieukhacirclekorean = 12920),
                (t.khieukhaparenkorean = 12824),
                (t.khieukhcirclekorean = 12906),
                (t.khieukhkorean = 12619),
                (t.khieukhparenkorean = 12810),
                (t.khokhaithai = 3586),
                (t.khokhonthai = 3589),
                (t.khokhuatthai = 3587),
                (t.khokhwaithai = 3588),
                (t.khomutthai = 3675),
                (t.khook = 409),
                (t.khorakhangthai = 3590),
                (t.khzsquare = 13201),
                (t.kihiragana = 12365),
                (t.kikatakana = 12461),
                (t.kikatakanahalfwidth = 65399),
                (t.kiroguramusquare = 13077),
                (t.kiromeetorusquare = 13078),
                (t.kirosquare = 13076),
                (t.kiyeokacirclekorean = 12910),
                (t.kiyeokaparenkorean = 12814),
                (t.kiyeokcirclekorean = 12896),
                (t.kiyeokkorean = 12593),
                (t.kiyeokparenkorean = 12800),
                (t.kiyeoksioskorean = 12595),
                (t.kjecyrillic = 1116),
                (t.klinebelow = 7733),
                (t.klsquare = 13208),
                (t.kmcubedsquare = 13222),
                (t.kmonospace = 65355),
                (t.kmsquaredsquare = 13218);
              (t.kohiragana = 12371),
                (t.kohmsquare = 13248),
                (t.kokaithai = 3585),
                (t.kokatakana = 12467),
                (t.kokatakanahalfwidth = 65402),
                (t.kooposquare = 13086),
                (t.koppacyrillic = 1153),
                (t.koreanstandardsymbol = 12927),
                (t.koroniscmb = 835),
                (t.kparen = 9382),
                (t.kpasquare = 13226),
                (t.ksicyrillic = 1135),
                (t.ktsquare = 13263),
                (t.kturned = 670),
                (t.kuhiragana = 12367),
                (t.kukatakana = 12463),
                (t.kukatakanahalfwidth = 65400),
                (t.kvsquare = 13240),
                (t.kwsquare = 13246),
                (t.l = 108),
                (t.labengali = 2482),
                (t.lacute = 314),
                (t.ladeva = 2354),
                (t.lagujarati = 2738),
                (t.lagurmukhi = 2610),
                (t.lakkhangyaothai = 3653),
                (t.lamaleffinalarabic = 65276),
                (t.lamalefhamzaabovefinalarabic = 65272),
                (t.lamalefhamzaaboveisolatedarabic = 65271),
                (t.lamalefhamzabelowfinalarabic = 65274),
                (t.lamalefhamzabelowisolatedarabic = 65273),
                (t.lamalefisolatedarabic = 65275),
                (t.lamalefmaddaabovefinalarabic = 65270),
                (t.lamalefmaddaaboveisolatedarabic = 65269),
                (t.lamarabic = 1604),
                (t.lambda = 955),
                (t.lambdastroke = 411),
                (t.lamed = 1500),
                (t.lameddagesh = 64316),
                (t.lameddageshhebrew = 64316),
                (t.lamedhebrew = 1500),
                (t.lamfinalarabic = 65246),
                (t.lamhahinitialarabic = 64714),
                (t.laminitialarabic = 65247),
                (t.lamjeeminitialarabic = 64713),
                (t.lamkhahinitialarabic = 64715),
                (t.lamlamhehisolatedarabic = 65010),
                (t.lammedialarabic = 65248),
                (t.lammeemhahinitialarabic = 64904),
                (t.lammeeminitialarabic = 64716),
                (t.largecircle = 9711),
                (t.lbar = 410),
                (t.lbelt = 620),
                (t.lbopomofo = 12556),
                (t.lcaron = 318),
                (t.lcedilla = 316),
                (t.lcircle = 9435),
                (t.lcircumflexbelow = 7741),
                (t.lcommaaccent = 316),
                (t.ldot = 320),
                (t.ldotaccent = 320),
                (t.ldotbelow = 7735),
                (t.ldotbelowmacron = 7737),
                (t.leftangleabovecmb = 794),
                (t.lefttackbelowcmb = 792),
                (t.less = 60),
                (t.lessequal = 8804),
                (t.lessequalorgreater = 8922),
                (t.lessmonospace = 65308),
                (t.lessorequivalent = 8818),
                (t.lessorgreater = 8822),
                (t.lessoverequal = 8806),
                (t.lesssmall = 65124),
                (t.lezh = 622),
                (t.lfblock = 9612),
                (t.lhookretroflex = 621),
                (t.lira = 8356),
                (t.liwnarmenian = 1388),
                (t.lj = 457),
                (t.ljecyrillic = 1113),
                (t.ll = 63168),
                (t.lladeva = 2355),
                (t.llagujarati = 2739),
                (t.llinebelow = 7739),
                (t.llladeva = 2356),
                (t.llvocalicbengali = 2529),
                (t.llvocalicdeva = 2401),
                (t.llvocalicvowelsignbengali = 2531),
                (t.llvocalicvowelsigndeva = 2403),
                (t.lmiddletilde = 619),
                (t.lmonospace = 65356),
                (t.lmsquare = 13264),
                (t.lochulathai = 3628),
                (t.logicaland = 8743),
                (t.logicalnot = 172),
                (t.logicalnotreversed = 8976),
                (t.logicalor = 8744),
                (t.lolingthai = 3621),
                (t.longs = 383),
                (t.lowlinecenterline = 65102),
                (t.lowlinecmb = 818),
                (t.lowlinedashed = 65101),
                (t.lozenge = 9674),
                (t.lparen = 9383),
                (t.lslash = 322),
                (t.lsquare = 8467),
                (t.lsuperior = 63214),
                (t.ltshade = 9617),
                (t.luthai = 3622),
                (t.lvocalicbengali = 2444),
                (t.lvocalicdeva = 2316),
                (t.lvocalicvowelsignbengali = 2530),
                (t.lvocalicvowelsigndeva = 2402),
                (t.lxsquare = 13267),
                (t.m = 109),
                (t.mabengali = 2478),
                (t.macron = 175),
                (t.macronbelowcmb = 817),
                (t.macroncmb = 772),
                (t.macronlowmod = 717),
                (t.macronmonospace = 65507),
                (t.macute = 7743),
                (t.madeva = 2350),
                (t.magujarati = 2734),
                (t.magurmukhi = 2606),
                (t.mahapakhhebrew = 1444),
                (t.mahapakhlefthebrew = 1444),
                (t.mahiragana = 12414),
                (t.maichattawalowleftthai = 63637),
                (t.maichattawalowrightthai = 63636),
                (t.maichattawathai = 3659),
                (t.maichattawaupperleftthai = 63635),
                (t.maieklowleftthai = 63628),
                (t.maieklowrightthai = 63627),
                (t.maiekthai = 3656),
                (t.maiekupperleftthai = 63626),
                (t.maihanakatleftthai = 63620),
                (t.maihanakatthai = 3633),
                (t.maitaikhuleftthai = 63625),
                (t.maitaikhuthai = 3655),
                (t.maitholowleftthai = 63631),
                (t.maitholowrightthai = 63630),
                (t.maithothai = 3657),
                (t.maithoupperleftthai = 63629),
                (t.maitrilowleftthai = 63634),
                (t.maitrilowrightthai = 63633),
                (t.maitrithai = 3658),
                (t.maitriupperleftthai = 63632),
                (t.maiyamokthai = 3654),
                (t.makatakana = 12510),
                (t.makatakanahalfwidth = 65423),
                (t.male = 9794),
                (t.mansyonsquare = 13127),
                (t.maqafhebrew = 1470),
                (t.mars = 9794),
                (t.masoracirclehebrew = 1455),
                (t.masquare = 13187),
                (t.mbopomofo = 12551),
                (t.mbsquare = 13268),
                (t.mcircle = 9436),
                (t.mcubedsquare = 13221),
                (t.mdotaccent = 7745),
                (t.mdotbelow = 7747),
                (t.meemarabic = 1605),
                (t.meemfinalarabic = 65250),
                (t.meeminitialarabic = 65251),
                (t.meemmedialarabic = 65252),
                (t.meemmeeminitialarabic = 64721),
                (t.meemmeemisolatedarabic = 64584),
                (t.meetorusquare = 13133),
                (t.mehiragana = 12417),
                (t.meizierasquare = 13182),
                (t.mekatakana = 12513),
                (t.mekatakanahalfwidth = 65426),
                (t.mem = 1502),
                (t.memdagesh = 64318),
                (t.memdageshhebrew = 64318),
                (t.memhebrew = 1502),
                (t.menarmenian = 1396),
                (t.merkhahebrew = 1445),
                (t.merkhakefulahebrew = 1446),
                (t.merkhakefulalefthebrew = 1446),
                (t.merkhalefthebrew = 1445),
                (t.mhook = 625),
                (t.mhzsquare = 13202),
                (t.middledotkatakanahalfwidth = 65381),
                (t.middot = 183),
                (t.mieumacirclekorean = 12914),
                (t.mieumaparenkorean = 12818),
                (t.mieumcirclekorean = 12900),
                (t.mieumkorean = 12609),
                (t.mieumpansioskorean = 12656),
                (t.mieumparenkorean = 12804),
                (t.mieumpieupkorean = 12654),
                (t.mieumsioskorean = 12655),
                (t.mihiragana = 12415),
                (t.mikatakana = 12511),
                (t.mikatakanahalfwidth = 65424),
                (t.minus = 8722),
                (t.minusbelowcmb = 800);
              (t.minuscircle = 8854),
                (t.minusmod = 727),
                (t.minusplus = 8723),
                (t.minute = 8242),
                (t.miribaarusquare = 13130),
                (t.mirisquare = 13129),
                (t.mlonglegturned = 624),
                (t.mlsquare = 13206),
                (t.mmcubedsquare = 13219),
                (t.mmonospace = 65357),
                (t.mmsquaredsquare = 13215),
                (t.mohiragana = 12418),
                (t.mohmsquare = 13249),
                (t.mokatakana = 12514),
                (t.mokatakanahalfwidth = 65427),
                (t.molsquare = 13270),
                (t.momathai = 3617),
                (t.moverssquare = 13223),
                (t.moverssquaredsquare = 13224),
                (t.mparen = 9384),
                (t.mpasquare = 13227),
                (t.mssquare = 13235),
                (t.msuperior = 63215),
                (t.mturned = 623),
                (t.mu = 181),
                (t.mu1 = 181),
                (t.muasquare = 13186),
                (t.muchgreater = 8811),
                (t.muchless = 8810),
                (t.mufsquare = 13196),
                (t.mugreek = 956),
                (t.mugsquare = 13197),
                (t.muhiragana = 12416),
                (t.mukatakana = 12512),
                (t.mukatakanahalfwidth = 65425),
                (t.mulsquare = 13205),
                (t.multiply = 215),
                (t.mumsquare = 13211),
                (t.munahhebrew = 1443),
                (t.munahlefthebrew = 1443),
                (t.musicalnote = 9834),
                (t.musicalnotedbl = 9835),
                (t.musicflatsign = 9837),
                (t.musicsharpsign = 9839),
                (t.mussquare = 13234),
                (t.muvsquare = 13238),
                (t.muwsquare = 13244),
                (t.mvmegasquare = 13241),
                (t.mvsquare = 13239),
                (t.mwmegasquare = 13247),
                (t.mwsquare = 13245),
                (t.n = 110),
                (t.nabengali = 2472),
                (t.nabla = 8711),
                (t.nacute = 324),
                (t.nadeva = 2344),
                (t.nagujarati = 2728),
                (t.nagurmukhi = 2600),
                (t.nahiragana = 12394),
                (t.nakatakana = 12490),
                (t.nakatakanahalfwidth = 65413),
                (t.napostrophe = 329),
                (t.nasquare = 13185),
                (t.nbopomofo = 12555),
                (t.nbspace = 160),
                (t.ncaron = 328),
                (t.ncedilla = 326),
                (t.ncircle = 9437),
                (t.ncircumflexbelow = 7755),
                (t.ncommaaccent = 326),
                (t.ndotaccent = 7749),
                (t.ndotbelow = 7751),
                (t.nehiragana = 12397),
                (t.nekatakana = 12493),
                (t.nekatakanahalfwidth = 65416),
                (t.newsheqelsign = 8362),
                (t.nfsquare = 13195),
                (t.ngabengali = 2457),
                (t.ngadeva = 2329),
                (t.ngagujarati = 2713),
                (t.ngagurmukhi = 2585),
                (t.ngonguthai = 3591),
                (t.nhiragana = 12435),
                (t.nhookleft = 626),
                (t.nhookretroflex = 627),
                (t.nieunacirclekorean = 12911),
                (t.nieunaparenkorean = 12815),
                (t.nieuncieuckorean = 12597),
                (t.nieuncirclekorean = 12897),
                (t.nieunhieuhkorean = 12598),
                (t.nieunkorean = 12596),
                (t.nieunpansioskorean = 12648),
                (t.nieunparenkorean = 12801),
                (t.nieunsioskorean = 12647),
                (t.nieuntikeutkorean = 12646),
                (t.nihiragana = 12395),
                (t.nikatakana = 12491),
                (t.nikatakanahalfwidth = 65414),
                (t.nikhahitleftthai = 63641),
                (t.nikhahitthai = 3661),
                (t.nine = 57),
                (t.ninearabic = 1641),
                (t.ninebengali = 2543),
                (t.ninecircle = 9320),
                (t.ninecircleinversesansserif = 10130),
                (t.ninedeva = 2415),
                (t.ninegujarati = 2799),
                (t.ninegurmukhi = 2671),
                (t.ninehackarabic = 1641),
                (t.ninehangzhou = 12329),
                (t.nineideographicparen = 12840),
                (t.nineinferior = 8329),
                (t.ninemonospace = 65305),
                (t.nineoldstyle = 63289),
                (t.nineparen = 9340),
                (t.nineperiod = 9360),
                (t.ninepersian = 1785),
                (t.nineroman = 8568),
                (t.ninesuperior = 8313),
                (t.nineteencircle = 9330),
                (t.nineteenparen = 9350),
                (t.nineteenperiod = 9370),
                (t.ninethai = 3673),
                (t.nj = 460),
                (t.njecyrillic = 1114),
                (t.nkatakana = 12531),
                (t.nkatakanahalfwidth = 65437),
                (t.nlegrightlong = 414),
                (t.nlinebelow = 7753),
                (t.nmonospace = 65358),
                (t.nmsquare = 13210),
                (t.nnabengali = 2467),
                (t.nnadeva = 2339),
                (t.nnagujarati = 2723),
                (t.nnagurmukhi = 2595),
                (t.nnnadeva = 2345),
                (t.nohiragana = 12398),
                (t.nokatakana = 12494),
                (t.nokatakanahalfwidth = 65417),
                (t.nonbreakingspace = 160),
                (t.nonenthai = 3603),
                (t.nonuthai = 3609),
                (t.noonarabic = 1606),
                (t.noonfinalarabic = 65254),
                (t.noonghunnaarabic = 1722),
                (t.noonghunnafinalarabic = 64415),
                (t.nooninitialarabic = 65255),
                (t.noonjeeminitialarabic = 64722),
                (t.noonjeemisolatedarabic = 64587),
                (t.noonmedialarabic = 65256),
                (t.noonmeeminitialarabic = 64725),
                (t.noonmeemisolatedarabic = 64590),
                (t.noonnoonfinalarabic = 64653),
                (t.notcontains = 8716),
                (t.notelement = 8713),
                (t.notelementof = 8713),
                (t.notequal = 8800),
                (t.notgreater = 8815),
                (t.notgreaternorequal = 8817),
                (t.notgreaternorless = 8825),
                (t.notidentical = 8802),
                (t.notless = 8814),
                (t.notlessnorequal = 8816),
                (t.notparallel = 8742),
                (t.notprecedes = 8832),
                (t.notsubset = 8836),
                (t.notsucceeds = 8833),
                (t.notsuperset = 8837),
                (t.nowarmenian = 1398),
                (t.nparen = 9385),
                (t.nssquare = 13233),
                (t.nsuperior = 8319),
                (t.ntilde = 241),
                (t.nu = 957),
                (t.nuhiragana = 12396),
                (t.nukatakana = 12492),
                (t.nukatakanahalfwidth = 65415),
                (t.nuktabengali = 2492),
                (t.nuktadeva = 2364),
                (t.nuktagujarati = 2748),
                (t.nuktagurmukhi = 2620),
                (t.numbersign = 35),
                (t.numbersignmonospace = 65283),
                (t.numbersignsmall = 65119),
                (t.numeralsigngreek = 884),
                (t.numeralsignlowergreek = 885),
                (t.numero = 8470),
                (t.nun = 1504),
                (t.nundagesh = 64320),
                (t.nundageshhebrew = 64320),
                (t.nunhebrew = 1504),
                (t.nvsquare = 13237),
                (t.nwsquare = 13243),
                (t.nyabengali = 2462),
                (t.nyadeva = 2334),
                (t.nyagujarati = 2718),
                (t.nyagurmukhi = 2590),
                (t.o = 111),
                (t.oacute = 243),
                (t.oangthai = 3629);
              (t.obarred = 629),
                (t.obarredcyrillic = 1257),
                (t.obarreddieresiscyrillic = 1259),
                (t.obengali = 2451),
                (t.obopomofo = 12571),
                (t.obreve = 335),
                (t.ocandradeva = 2321),
                (t.ocandragujarati = 2705),
                (t.ocandravowelsigndeva = 2377),
                (t.ocandravowelsigngujarati = 2761),
                (t.ocaron = 466),
                (t.ocircle = 9438),
                (t.ocircumflex = 244),
                (t.ocircumflexacute = 7889),
                (t.ocircumflexdotbelow = 7897),
                (t.ocircumflexgrave = 7891),
                (t.ocircumflexhookabove = 7893),
                (t.ocircumflextilde = 7895),
                (t.ocyrillic = 1086),
                (t.odblacute = 337),
                (t.odblgrave = 525),
                (t.odeva = 2323),
                (t.odieresis = 246),
                (t.odieresiscyrillic = 1255),
                (t.odotbelow = 7885),
                (t.oe = 339),
                (t.oekorean = 12634),
                (t.ogonek = 731),
                (t.ogonekcmb = 808),
                (t.ograve = 242),
                (t.ogujarati = 2707),
                (t.oharmenian = 1413),
                (t.ohiragana = 12362),
                (t.ohookabove = 7887),
                (t.ohorn = 417),
                (t.ohornacute = 7899),
                (t.ohorndotbelow = 7907),
                (t.ohorngrave = 7901),
                (t.ohornhookabove = 7903),
                (t.ohorntilde = 7905),
                (t.ohungarumlaut = 337),
                (t.oi = 419),
                (t.oinvertedbreve = 527),
                (t.okatakana = 12458),
                (t.okatakanahalfwidth = 65397),
                (t.okorean = 12631),
                (t.olehebrew = 1451),
                (t.omacron = 333),
                (t.omacronacute = 7763),
                (t.omacrongrave = 7761),
                (t.omdeva = 2384),
                (t.omega = 969),
                (t.omega1 = 982),
                (t.omegacyrillic = 1121),
                (t.omegalatinclosed = 631),
                (t.omegaroundcyrillic = 1147),
                (t.omegatitlocyrillic = 1149),
                (t.omegatonos = 974),
                (t.omgujarati = 2768),
                (t.omicron = 959),
                (t.omicrontonos = 972),
                (t.omonospace = 65359),
                (t.one = 49),
                (t.onearabic = 1633),
                (t.onebengali = 2535),
                (t.onecircle = 9312),
                (t.onecircleinversesansserif = 10122),
                (t.onedeva = 2407),
                (t.onedotenleader = 8228),
                (t.oneeighth = 8539),
                (t.onefitted = 63196),
                (t.onegujarati = 2791),
                (t.onegurmukhi = 2663),
                (t.onehackarabic = 1633),
                (t.onehalf = 189),
                (t.onehangzhou = 12321),
                (t.oneideographicparen = 12832),
                (t.oneinferior = 8321),
                (t.onemonospace = 65297),
                (t.onenumeratorbengali = 2548),
                (t.oneoldstyle = 63281),
                (t.oneparen = 9332),
                (t.oneperiod = 9352),
                (t.onepersian = 1777),
                (t.onequarter = 188),
                (t.oneroman = 8560),
                (t.onesuperior = 185),
                (t.onethai = 3665),
                (t.onethird = 8531),
                (t.oogonek = 491),
                (t.oogonekmacron = 493),
                (t.oogurmukhi = 2579),
                (t.oomatragurmukhi = 2635),
                (t.oopen = 596),
                (t.oparen = 9386),
                (t.openbullet = 9702),
                (t.option = 8997),
                (t.ordfeminine = 170),
                (t.ordmasculine = 186),
                (t.orthogonal = 8735),
                (t.oshortdeva = 2322),
                (t.oshortvowelsigndeva = 2378),
                (t.oslash = 248),
                (t.oslashacute = 511),
                (t.osmallhiragana = 12361),
                (t.osmallkatakana = 12457),
                (t.osmallkatakanahalfwidth = 65387),
                (t.ostrokeacute = 511),
                (t.osuperior = 63216),
                (t.otcyrillic = 1151),
                (t.otilde = 245),
                (t.otildeacute = 7757),
                (t.otildedieresis = 7759),
                (t.oubopomofo = 12577),
                (t.overline = 8254),
                (t.overlinecenterline = 65098),
                (t.overlinecmb = 773),
                (t.overlinedashed = 65097),
                (t.overlinedblwavy = 65100),
                (t.overlinewavy = 65099),
                (t.overscore = 175),
                (t.ovowelsignbengali = 2507),
                (t.ovowelsigndeva = 2379),
                (t.ovowelsigngujarati = 2763),
                (t.p = 112),
                (t.paampssquare = 13184),
                (t.paasentosquare = 13099),
                (t.pabengali = 2474),
                (t.pacute = 7765),
                (t.padeva = 2346),
                (t.pagedown = 8671),
                (t.pageup = 8670),
                (t.pagujarati = 2730),
                (t.pagurmukhi = 2602),
                (t.pahiragana = 12401),
                (t.paiyannoithai = 3631),
                (t.pakatakana = 12497),
                (t.palatalizationcyrilliccmb = 1156),
                (t.palochkacyrillic = 1216),
                (t.pansioskorean = 12671),
                (t.paragraph = 182),
                (t.parallel = 8741),
                (t.parenleft = 40),
                (t.parenleftaltonearabic = 64830),
                (t.parenleftbt = 63725),
                (t.parenleftex = 63724),
                (t.parenleftinferior = 8333),
                (t.parenleftmonospace = 65288),
                (t.parenleftsmall = 65113),
                (t.parenleftsuperior = 8317),
                (t.parenlefttp = 63723),
                (t.parenleftvertical = 65077),
                (t.parenright = 41),
                (t.parenrightaltonearabic = 64831),
                (t.parenrightbt = 63736),
                (t.parenrightex = 63735),
                (t.parenrightinferior = 8334),
                (t.parenrightmonospace = 65289),
                (t.parenrightsmall = 65114),
                (t.parenrightsuperior = 8318),
                (t.parenrighttp = 63734),
                (t.parenrightvertical = 65078),
                (t.partialdiff = 8706),
                (t.paseqhebrew = 1472),
                (t.pashtahebrew = 1433),
                (t.pasquare = 13225),
                (t.patah = 1463),
                (t.patah11 = 1463),
                (t.patah1d = 1463),
                (t.patah2a = 1463),
                (t.patahhebrew = 1463),
                (t.patahnarrowhebrew = 1463),
                (t.patahquarterhebrew = 1463),
                (t.patahwidehebrew = 1463),
                (t.pazerhebrew = 1441),
                (t.pbopomofo = 12550),
                (t.pcircle = 9439),
                (t.pdotaccent = 7767),
                (t.pe = 1508),
                (t.pecyrillic = 1087),
                (t.pedagesh = 64324),
                (t.pedageshhebrew = 64324),
                (t.peezisquare = 13115),
                (t.pefinaldageshhebrew = 64323),
                (t.peharabic = 1662),
                (t.peharmenian = 1402),
                (t.pehebrew = 1508),
                (t.pehfinalarabic = 64343),
                (t.pehinitialarabic = 64344),
                (t.pehiragana = 12410),
                (t.pehmedialarabic = 64345),
                (t.pekatakana = 12506),
                (t.pemiddlehookcyrillic = 1191),
                (t.perafehebrew = 64334),
                (t.percent = 37),
                (t.percentarabic = 1642),
                (t.percentmonospace = 65285),
                (t.percentsmall = 65130),
                (t.period = 46),
                (t.periodarmenian = 1417);
              (t.periodcentered = 183),
                (t.periodhalfwidth = 65377),
                (t.periodinferior = 63207),
                (t.periodmonospace = 65294),
                (t.periodsmall = 65106),
                (t.periodsuperior = 63208),
                (t.perispomenigreekcmb = 834),
                (t.perpendicular = 8869),
                (t.perthousand = 8240),
                (t.peseta = 8359),
                (t.pfsquare = 13194),
                (t.phabengali = 2475),
                (t.phadeva = 2347),
                (t.phagujarati = 2731),
                (t.phagurmukhi = 2603),
                (t.phi = 966),
                (t.phi1 = 981),
                (t.phieuphacirclekorean = 12922),
                (t.phieuphaparenkorean = 12826),
                (t.phieuphcirclekorean = 12908),
                (t.phieuphkorean = 12621),
                (t.phieuphparenkorean = 12812),
                (t.philatin = 632),
                (t.phinthuthai = 3642),
                (t.phisymbolgreek = 981),
                (t.phook = 421),
                (t.phophanthai = 3614),
                (t.phophungthai = 3612),
                (t.phosamphaothai = 3616),
                (t.pi = 960),
                (t.pieupacirclekorean = 12915),
                (t.pieupaparenkorean = 12819),
                (t.pieupcieuckorean = 12662),
                (t.pieupcirclekorean = 12901),
                (t.pieupkiyeokkorean = 12658),
                (t.pieupkorean = 12610),
                (t.pieupparenkorean = 12805),
                (t.pieupsioskiyeokkorean = 12660),
                (t.pieupsioskorean = 12612),
                (t.pieupsiostikeutkorean = 12661),
                (t.pieupthieuthkorean = 12663),
                (t.pieuptikeutkorean = 12659),
                (t.pihiragana = 12404),
                (t.pikatakana = 12500),
                (t.pisymbolgreek = 982),
                (t.piwrarmenian = 1411),
                (t.plus = 43),
                (t.plusbelowcmb = 799),
                (t.pluscircle = 8853),
                (t.plusminus = 177),
                (t.plusmod = 726),
                (t.plusmonospace = 65291),
                (t.plussmall = 65122),
                (t.plussuperior = 8314),
                (t.pmonospace = 65360),
                (t.pmsquare = 13272),
                (t.pohiragana = 12413),
                (t.pointingindexdownwhite = 9759),
                (t.pointingindexleftwhite = 9756),
                (t.pointingindexrightwhite = 9758),
                (t.pointingindexupwhite = 9757),
                (t.pokatakana = 12509),
                (t.poplathai = 3611),
                (t.postalmark = 12306),
                (t.postalmarkface = 12320),
                (t.pparen = 9387),
                (t.precedes = 8826),
                (t.prescription = 8478),
                (t.primemod = 697),
                (t.primereversed = 8245),
                (t.product = 8719),
                (t.projective = 8965),
                (t.prolongedkana = 12540),
                (t.propellor = 8984),
                (t.propersubset = 8834),
                (t.propersuperset = 8835),
                (t.proportion = 8759),
                (t.proportional = 8733),
                (t.psi = 968),
                (t.psicyrillic = 1137),
                (t.psilipneumatacyrilliccmb = 1158),
                (t.pssquare = 13232),
                (t.puhiragana = 12407),
                (t.pukatakana = 12503),
                (t.pvsquare = 13236),
                (t.pwsquare = 13242),
                (t.q = 113),
                (t.qadeva = 2392),
                (t.qadmahebrew = 1448),
                (t.qafarabic = 1602),
                (t.qaffinalarabic = 65238),
                (t.qafinitialarabic = 65239),
                (t.qafmedialarabic = 65240),
                (t.qamats = 1464),
                (t.qamats10 = 1464),
                (t.qamats1a = 1464),
                (t.qamats1c = 1464),
                (t.qamats27 = 1464),
                (t.qamats29 = 1464),
                (t.qamats33 = 1464),
                (t.qamatsde = 1464),
                (t.qamatshebrew = 1464),
                (t.qamatsnarrowhebrew = 1464),
                (t.qamatsqatanhebrew = 1464),
                (t.qamatsqatannarrowhebrew = 1464),
                (t.qamatsqatanquarterhebrew = 1464),
                (t.qamatsqatanwidehebrew = 1464),
                (t.qamatsquarterhebrew = 1464),
                (t.qamatswidehebrew = 1464),
                (t.qarneyparahebrew = 1439),
                (t.qbopomofo = 12561),
                (t.qcircle = 9440),
                (t.qhook = 672),
                (t.qmonospace = 65361),
                (t.qof = 1511),
                (t.qofdagesh = 64327),
                (t.qofdageshhebrew = 64327),
                (t.qofhebrew = 1511),
                (t.qparen = 9388),
                (t.quarternote = 9833),
                (t.qubuts = 1467),
                (t.qubuts18 = 1467),
                (t.qubuts25 = 1467),
                (t.qubuts31 = 1467),
                (t.qubutshebrew = 1467),
                (t.qubutsnarrowhebrew = 1467),
                (t.qubutsquarterhebrew = 1467),
                (t.qubutswidehebrew = 1467),
                (t.question = 63),
                (t.questionarabic = 1567),
                (t.questionarmenian = 1374),
                (t.questiondown = 191),
                (t.questiondownsmall = 63423),
                (t.questiongreek = 894),
                (t.questionmonospace = 65311),
                (t.questionsmall = 63295),
                (t.quotedbl = 34),
                (t.quotedblbase = 8222),
                (t.quotedblleft = 8220),
                (t.quotedblmonospace = 65282),
                (t.quotedblprime = 12318),
                (t.quotedblprimereversed = 12317),
                (t.quotedblright = 8221),
                (t.quoteleft = 8216),
                (t.quoteleftreversed = 8219),
                (t.quotereversed = 8219),
                (t.quoteright = 8217),
                (t.quoterightn = 329),
                (t.quotesinglbase = 8218),
                (t.quotesingle = 39),
                (t.quotesinglemonospace = 65287),
                (t.r = 114),
                (t.raarmenian = 1404),
                (t.rabengali = 2480),
                (t.racute = 341),
                (t.radeva = 2352),
                (t.radical = 8730),
                (t.radicalex = 63717),
                (t.radoverssquare = 13230),
                (t.radoverssquaredsquare = 13231),
                (t.radsquare = 13229),
                (t.rafe = 1471),
                (t.rafehebrew = 1471),
                (t.ragujarati = 2736),
                (t.ragurmukhi = 2608),
                (t.rahiragana = 12425),
                (t.rakatakana = 12521),
                (t.rakatakanahalfwidth = 65431),
                (t.ralowerdiagonalbengali = 2545),
                (t.ramiddlediagonalbengali = 2544),
                (t.ramshorn = 612),
                (t.ratio = 8758),
                (t.rbopomofo = 12566),
                (t.rcaron = 345),
                (t.rcedilla = 343),
                (t.rcircle = 9441),
                (t.rcommaaccent = 343),
                (t.rdblgrave = 529),
                (t.rdotaccent = 7769),
                (t.rdotbelow = 7771),
                (t.rdotbelowmacron = 7773),
                (t.referencemark = 8251),
                (t.reflexsubset = 8838),
                (t.reflexsuperset = 8839),
                (t.registered = 174),
                (t.registersans = 63720),
                (t.registerserif = 63194),
                (t.reharabic = 1585),
                (t.reharmenian = 1408),
                (t.rehfinalarabic = 65198),
                (t.rehiragana = 12428),
                (t.rekatakana = 12524),
                (t.rekatakanahalfwidth = 65434),
                (t.resh = 1512),
                (t.reshdageshhebrew = 64328),
                (t.reshhebrew = 1512),
                (t.reversedtilde = 8765),
                (t.reviahebrew = 1431),
                (t.reviamugrashhebrew = 1431),
                (t.revlogicalnot = 8976);
              (t.rfishhook = 638),
                (t.rfishhookreversed = 639),
                (t.rhabengali = 2525),
                (t.rhadeva = 2397),
                (t.rho = 961),
                (t.rhook = 637),
                (t.rhookturned = 635),
                (t.rhookturnedsuperior = 693),
                (t.rhosymbolgreek = 1009),
                (t.rhotichookmod = 734),
                (t.rieulacirclekorean = 12913),
                (t.rieulaparenkorean = 12817),
                (t.rieulcirclekorean = 12899),
                (t.rieulhieuhkorean = 12608),
                (t.rieulkiyeokkorean = 12602),
                (t.rieulkiyeoksioskorean = 12649),
                (t.rieulkorean = 12601),
                (t.rieulmieumkorean = 12603),
                (t.rieulpansioskorean = 12652),
                (t.rieulparenkorean = 12803),
                (t.rieulphieuphkorean = 12607),
                (t.rieulpieupkorean = 12604),
                (t.rieulpieupsioskorean = 12651),
                (t.rieulsioskorean = 12605),
                (t.rieulthieuthkorean = 12606),
                (t.rieultikeutkorean = 12650),
                (t.rieulyeorinhieuhkorean = 12653),
                (t.rightangle = 8735),
                (t.righttackbelowcmb = 793),
                (t.righttriangle = 8895),
                (t.rihiragana = 12426),
                (t.rikatakana = 12522),
                (t.rikatakanahalfwidth = 65432),
                (t.ring = 730),
                (t.ringbelowcmb = 805),
                (t.ringcmb = 778),
                (t.ringhalfleft = 703),
                (t.ringhalfleftarmenian = 1369),
                (t.ringhalfleftbelowcmb = 796),
                (t.ringhalfleftcentered = 723),
                (t.ringhalfright = 702),
                (t.ringhalfrightbelowcmb = 825),
                (t.ringhalfrightcentered = 722),
                (t.rinvertedbreve = 531),
                (t.rittorusquare = 13137),
                (t.rlinebelow = 7775),
                (t.rlongleg = 636),
                (t.rlonglegturned = 634),
                (t.rmonospace = 65362),
                (t.rohiragana = 12429),
                (t.rokatakana = 12525),
                (t.rokatakanahalfwidth = 65435),
                (t.roruathai = 3619),
                (t.rparen = 9389),
                (t.rrabengali = 2524),
                (t.rradeva = 2353),
                (t.rragurmukhi = 2652),
                (t.rreharabic = 1681),
                (t.rrehfinalarabic = 64397),
                (t.rrvocalicbengali = 2528),
                (t.rrvocalicdeva = 2400),
                (t.rrvocalicgujarati = 2784),
                (t.rrvocalicvowelsignbengali = 2500),
                (t.rrvocalicvowelsigndeva = 2372),
                (t.rrvocalicvowelsigngujarati = 2756),
                (t.rsuperior = 63217),
                (t.rtblock = 9616),
                (t.rturned = 633),
                (t.rturnedsuperior = 692),
                (t.ruhiragana = 12427),
                (t.rukatakana = 12523),
                (t.rukatakanahalfwidth = 65433),
                (t.rupeemarkbengali = 2546),
                (t.rupeesignbengali = 2547),
                (t.rupiah = 63197),
                (t.ruthai = 3620),
                (t.rvocalicbengali = 2443),
                (t.rvocalicdeva = 2315),
                (t.rvocalicgujarati = 2699),
                (t.rvocalicvowelsignbengali = 2499),
                (t.rvocalicvowelsigndeva = 2371),
                (t.rvocalicvowelsigngujarati = 2755),
                (t.s = 115),
                (t.sabengali = 2488),
                (t.sacute = 347),
                (t.sacutedotaccent = 7781),
                (t.sadarabic = 1589),
                (t.sadeva = 2360),
                (t.sadfinalarabic = 65210),
                (t.sadinitialarabic = 65211),
                (t.sadmedialarabic = 65212),
                (t.sagujarati = 2744),
                (t.sagurmukhi = 2616),
                (t.sahiragana = 12373),
                (t.sakatakana = 12469),
                (t.sakatakanahalfwidth = 65403),
                (t.sallallahoualayhewasallamarabic = 65018),
                (t.samekh = 1505),
                (t.samekhdagesh = 64321),
                (t.samekhdageshhebrew = 64321),
                (t.samekhhebrew = 1505),
                (t.saraaathai = 3634),
                (t.saraaethai = 3649),
                (t.saraaimaimalaithai = 3652),
                (t.saraaimaimuanthai = 3651),
                (t.saraamthai = 3635),
                (t.saraathai = 3632),
                (t.saraethai = 3648),
                (t.saraiileftthai = 63622),
                (t.saraiithai = 3637),
                (t.saraileftthai = 63621),
                (t.saraithai = 3636),
                (t.saraothai = 3650),
                (t.saraueeleftthai = 63624),
                (t.saraueethai = 3639),
                (t.saraueleftthai = 63623),
                (t.sarauethai = 3638),
                (t.sarauthai = 3640),
                (t.sarauuthai = 3641),
                (t.sbopomofo = 12569),
                (t.scaron = 353),
                (t.scarondotaccent = 7783),
                (t.scedilla = 351),
                (t.schwa = 601),
                (t.schwacyrillic = 1241),
                (t.schwadieresiscyrillic = 1243),
                (t.schwahook = 602),
                (t.scircle = 9442),
                (t.scircumflex = 349),
                (t.scommaaccent = 537),
                (t.sdotaccent = 7777),
                (t.sdotbelow = 7779),
                (t.sdotbelowdotaccent = 7785),
                (t.seagullbelowcmb = 828),
                (t.second = 8243),
                (t.secondtonechinese = 714),
                (t.section = 167),
                (t.seenarabic = 1587),
                (t.seenfinalarabic = 65202),
                (t.seeninitialarabic = 65203),
                (t.seenmedialarabic = 65204),
                (t.segol = 1462),
                (t.segol13 = 1462),
                (t.segol1f = 1462),
                (t.segol2c = 1462),
                (t.segolhebrew = 1462),
                (t.segolnarrowhebrew = 1462),
                (t.segolquarterhebrew = 1462),
                (t.segoltahebrew = 1426),
                (t.segolwidehebrew = 1462),
                (t.seharmenian = 1405),
                (t.sehiragana = 12379),
                (t.sekatakana = 12475),
                (t.sekatakanahalfwidth = 65406),
                (t.semicolon = 59),
                (t.semicolonarabic = 1563),
                (t.semicolonmonospace = 65307),
                (t.semicolonsmall = 65108),
                (t.semivoicedmarkkana = 12444),
                (t.semivoicedmarkkanahalfwidth = 65439),
                (t.sentisquare = 13090),
                (t.sentosquare = 13091),
                (t.seven = 55),
                (t.sevenarabic = 1639),
                (t.sevenbengali = 2541),
                (t.sevencircle = 9318),
                (t.sevencircleinversesansserif = 10128),
                (t.sevendeva = 2413),
                (t.seveneighths = 8542),
                (t.sevengujarati = 2797),
                (t.sevengurmukhi = 2669),
                (t.sevenhackarabic = 1639),
                (t.sevenhangzhou = 12327),
                (t.sevenideographicparen = 12838),
                (t.seveninferior = 8327),
                (t.sevenmonospace = 65303),
                (t.sevenoldstyle = 63287),
                (t.sevenparen = 9338),
                (t.sevenperiod = 9358),
                (t.sevenpersian = 1783),
                (t.sevenroman = 8566),
                (t.sevensuperior = 8311),
                (t.seventeencircle = 9328),
                (t.seventeenparen = 9348),
                (t.seventeenperiod = 9368),
                (t.seventhai = 3671),
                (t.sfthyphen = 173),
                (t.shaarmenian = 1399),
                (t.shabengali = 2486),
                (t.shacyrillic = 1096),
                (t.shaddaarabic = 1617),
                (t.shaddadammaarabic = 64609),
                (t.shaddadammatanarabic = 64606),
                (t.shaddafathaarabic = 64608),
                (t.shaddakasraarabic = 64610),
                (t.shaddakasratanarabic = 64607),
                (t.shade = 9618),
                (t.shadedark = 9619),
                (t.shadelight = 9617),
                (t.shademedium = 9618);
              (t.shadeva = 2358),
                (t.shagujarati = 2742),
                (t.shagurmukhi = 2614),
                (t.shalshelethebrew = 1427),
                (t.shbopomofo = 12565),
                (t.shchacyrillic = 1097),
                (t.sheenarabic = 1588),
                (t.sheenfinalarabic = 65206),
                (t.sheeninitialarabic = 65207),
                (t.sheenmedialarabic = 65208),
                (t.sheicoptic = 995),
                (t.sheqel = 8362),
                (t.sheqelhebrew = 8362),
                (t.sheva = 1456),
                (t.sheva115 = 1456),
                (t.sheva15 = 1456),
                (t.sheva22 = 1456),
                (t.sheva2e = 1456),
                (t.shevahebrew = 1456),
                (t.shevanarrowhebrew = 1456),
                (t.shevaquarterhebrew = 1456),
                (t.shevawidehebrew = 1456),
                (t.shhacyrillic = 1211),
                (t.shimacoptic = 1005),
                (t.shin = 1513),
                (t.shindagesh = 64329),
                (t.shindageshhebrew = 64329),
                (t.shindageshshindot = 64300),
                (t.shindageshshindothebrew = 64300),
                (t.shindageshsindot = 64301),
                (t.shindageshsindothebrew = 64301),
                (t.shindothebrew = 1473),
                (t.shinhebrew = 1513),
                (t.shinshindot = 64298),
                (t.shinshindothebrew = 64298),
                (t.shinsindot = 64299),
                (t.shinsindothebrew = 64299),
                (t.shook = 642),
                (t.sigma = 963),
                (t.sigma1 = 962),
                (t.sigmafinal = 962),
                (t.sigmalunatesymbolgreek = 1010),
                (t.sihiragana = 12375),
                (t.sikatakana = 12471),
                (t.sikatakanahalfwidth = 65404),
                (t.siluqhebrew = 1469),
                (t.siluqlefthebrew = 1469),
                (t.similar = 8764),
                (t.sindothebrew = 1474),
                (t.siosacirclekorean = 12916),
                (t.siosaparenkorean = 12820),
                (t.sioscieuckorean = 12670),
                (t.sioscirclekorean = 12902),
                (t.sioskiyeokkorean = 12666),
                (t.sioskorean = 12613),
                (t.siosnieunkorean = 12667),
                (t.siosparenkorean = 12806),
                (t.siospieupkorean = 12669),
                (t.siostikeutkorean = 12668),
                (t.six = 54),
                (t.sixarabic = 1638),
                (t.sixbengali = 2540),
                (t.sixcircle = 9317),
                (t.sixcircleinversesansserif = 10127),
                (t.sixdeva = 2412),
                (t.sixgujarati = 2796),
                (t.sixgurmukhi = 2668),
                (t.sixhackarabic = 1638),
                (t.sixhangzhou = 12326),
                (t.sixideographicparen = 12837),
                (t.sixinferior = 8326),
                (t.sixmonospace = 65302),
                (t.sixoldstyle = 63286),
                (t.sixparen = 9337),
                (t.sixperiod = 9357),
                (t.sixpersian = 1782),
                (t.sixroman = 8565),
                (t.sixsuperior = 8310),
                (t.sixteencircle = 9327),
                (t.sixteencurrencydenominatorbengali = 2553),
                (t.sixteenparen = 9347),
                (t.sixteenperiod = 9367),
                (t.sixthai = 3670),
                (t.slash = 47),
                (t.slashmonospace = 65295),
                (t.slong = 383),
                (t.slongdotaccent = 7835),
                (t.smileface = 9786),
                (t.smonospace = 65363),
                (t.sofpasuqhebrew = 1475),
                (t.softhyphen = 173),
                (t.softsigncyrillic = 1100),
                (t.sohiragana = 12381),
                (t.sokatakana = 12477),
                (t.sokatakanahalfwidth = 65407),
                (t.soliduslongoverlaycmb = 824),
                (t.solidusshortoverlaycmb = 823),
                (t.sorusithai = 3625),
                (t.sosalathai = 3624),
                (t.sosothai = 3595),
                (t.sosuathai = 3626),
                (t.space = 32),
                (t.spacehackarabic = 32),
                (t.spade = 9824),
                (t.spadesuitblack = 9824),
                (t.spadesuitwhite = 9828),
                (t.sparen = 9390),
                (t.squarebelowcmb = 827),
                (t.squarecc = 13252),
                (t.squarecm = 13213),
                (t.squarediagonalcrosshatchfill = 9641),
                (t.squarehorizontalfill = 9636),
                (t.squarekg = 13199),
                (t.squarekm = 13214),
                (t.squarekmcapital = 13262),
                (t.squareln = 13265),
                (t.squarelog = 13266),
                (t.squaremg = 13198),
                (t.squaremil = 13269),
                (t.squaremm = 13212),
                (t.squaremsquared = 13217),
                (t.squareorthogonalcrosshatchfill = 9638),
                (t.squareupperlefttolowerrightfill = 9639),
                (t.squareupperrighttolowerleftfill = 9640),
                (t.squareverticalfill = 9637),
                (t.squarewhitewithsmallblack = 9635),
                (t.srsquare = 13275),
                (t.ssabengali = 2487),
                (t.ssadeva = 2359),
                (t.ssagujarati = 2743),
                (t.ssangcieuckorean = 12617),
                (t.ssanghieuhkorean = 12677),
                (t.ssangieungkorean = 12672),
                (t.ssangkiyeokkorean = 12594),
                (t.ssangnieunkorean = 12645),
                (t.ssangpieupkorean = 12611),
                (t.ssangsioskorean = 12614),
                (t.ssangtikeutkorean = 12600),
                (t.ssuperior = 63218),
                (t.sterling = 163),
                (t.sterlingmonospace = 65505),
                (t.strokelongoverlaycmb = 822),
                (t.strokeshortoverlaycmb = 821),
                (t.subset = 8834),
                (t.subsetnotequal = 8842),
                (t.subsetorequal = 8838),
                (t.succeeds = 8827),
                (t.suchthat = 8715),
                (t.suhiragana = 12377),
                (t.sukatakana = 12473),
                (t.sukatakanahalfwidth = 65405),
                (t.sukunarabic = 1618),
                (t.summation = 8721),
                (t.sun = 9788),
                (t.superset = 8835),
                (t.supersetnotequal = 8843),
                (t.supersetorequal = 8839),
                (t.svsquare = 13276),
                (t.syouwaerasquare = 13180),
                (t.t = 116),
                (t.tabengali = 2468),
                (t.tackdown = 8868),
                (t.tackleft = 8867),
                (t.tadeva = 2340),
                (t.tagujarati = 2724),
                (t.tagurmukhi = 2596),
                (t.taharabic = 1591),
                (t.tahfinalarabic = 65218),
                (t.tahinitialarabic = 65219),
                (t.tahiragana = 12383),
                (t.tahmedialarabic = 65220),
                (t.taisyouerasquare = 13181),
                (t.takatakana = 12479),
                (t.takatakanahalfwidth = 65408),
                (t.tatweelarabic = 1600),
                (t.tau = 964),
                (t.tav = 1514),
                (t.tavdages = 64330),
                (t.tavdagesh = 64330),
                (t.tavdageshhebrew = 64330),
                (t.tavhebrew = 1514),
                (t.tbar = 359),
                (t.tbopomofo = 12554),
                (t.tcaron = 357),
                (t.tccurl = 680),
                (t.tcedilla = 355),
                (t.tcheharabic = 1670),
                (t.tchehfinalarabic = 64379),
                (t.tchehinitialarabic = 64380),
                (t.tchehmedialarabic = 64381),
                (t.tcircle = 9443),
                (t.tcircumflexbelow = 7793),
                (t.tcommaaccent = 355),
                (t.tdieresis = 7831),
                (t.tdotaccent = 7787),
                (t.tdotbelow = 7789),
                (t.tecyrillic = 1090),
                (t.tedescendercyrillic = 1197),
                (t.teharabic = 1578),
                (t.tehfinalarabic = 65174);
              (t.tehhahinitialarabic = 64674),
                (t.tehhahisolatedarabic = 64524),
                (t.tehinitialarabic = 65175),
                (t.tehiragana = 12390),
                (t.tehjeeminitialarabic = 64673),
                (t.tehjeemisolatedarabic = 64523),
                (t.tehmarbutaarabic = 1577),
                (t.tehmarbutafinalarabic = 65172),
                (t.tehmedialarabic = 65176),
                (t.tehmeeminitialarabic = 64676),
                (t.tehmeemisolatedarabic = 64526),
                (t.tehnoonfinalarabic = 64627),
                (t.tekatakana = 12486),
                (t.tekatakanahalfwidth = 65411),
                (t.telephone = 8481),
                (t.telephoneblack = 9742),
                (t.telishagedolahebrew = 1440),
                (t.telishaqetanahebrew = 1449),
                (t.tencircle = 9321),
                (t.tenideographicparen = 12841),
                (t.tenparen = 9341),
                (t.tenperiod = 9361),
                (t.tenroman = 8569),
                (t.tesh = 679),
                (t.tet = 1496),
                (t.tetdagesh = 64312),
                (t.tetdageshhebrew = 64312),
                (t.tethebrew = 1496),
                (t.tetsecyrillic = 1205),
                (t.tevirhebrew = 1435),
                (t.tevirlefthebrew = 1435),
                (t.thabengali = 2469),
                (t.thadeva = 2341),
                (t.thagujarati = 2725),
                (t.thagurmukhi = 2597),
                (t.thalarabic = 1584),
                (t.thalfinalarabic = 65196),
                (t.thanthakhatlowleftthai = 63640),
                (t.thanthakhatlowrightthai = 63639),
                (t.thanthakhatthai = 3660),
                (t.thanthakhatupperleftthai = 63638),
                (t.theharabic = 1579),
                (t.thehfinalarabic = 65178),
                (t.thehinitialarabic = 65179),
                (t.thehmedialarabic = 65180),
                (t.thereexists = 8707),
                (t.therefore = 8756),
                (t.theta = 952),
                (t.theta1 = 977),
                (t.thetasymbolgreek = 977),
                (t.thieuthacirclekorean = 12921),
                (t.thieuthaparenkorean = 12825),
                (t.thieuthcirclekorean = 12907),
                (t.thieuthkorean = 12620),
                (t.thieuthparenkorean = 12811),
                (t.thirteencircle = 9324),
                (t.thirteenparen = 9344),
                (t.thirteenperiod = 9364),
                (t.thonangmonthothai = 3601),
                (t.thook = 429),
                (t.thophuthaothai = 3602),
                (t.thorn = 254),
                (t.thothahanthai = 3607),
                (t.thothanthai = 3600),
                (t.thothongthai = 3608),
                (t.thothungthai = 3606),
                (t.thousandcyrillic = 1154),
                (t.thousandsseparatorarabic = 1644),
                (t.thousandsseparatorpersian = 1644),
                (t.three = 51),
                (t.threearabic = 1635),
                (t.threebengali = 2537),
                (t.threecircle = 9314),
                (t.threecircleinversesansserif = 10124),
                (t.threedeva = 2409),
                (t.threeeighths = 8540),
                (t.threegujarati = 2793),
                (t.threegurmukhi = 2665),
                (t.threehackarabic = 1635),
                (t.threehangzhou = 12323),
                (t.threeideographicparen = 12834),
                (t.threeinferior = 8323),
                (t.threemonospace = 65299),
                (t.threenumeratorbengali = 2550),
                (t.threeoldstyle = 63283),
                (t.threeparen = 9334),
                (t.threeperiod = 9354),
                (t.threepersian = 1779),
                (t.threequarters = 190),
                (t.threequartersemdash = 63198),
                (t.threeroman = 8562),
                (t.threesuperior = 179),
                (t.threethai = 3667),
                (t.thzsquare = 13204),
                (t.tihiragana = 12385),
                (t.tikatakana = 12481),
                (t.tikatakanahalfwidth = 65409),
                (t.tikeutacirclekorean = 12912),
                (t.tikeutaparenkorean = 12816),
                (t.tikeutcirclekorean = 12898),
                (t.tikeutkorean = 12599),
                (t.tikeutparenkorean = 12802),
                (t.tilde = 732),
                (t.tildebelowcmb = 816),
                (t.tildecmb = 771),
                (t.tildecomb = 771),
                (t.tildedoublecmb = 864),
                (t.tildeoperator = 8764),
                (t.tildeoverlaycmb = 820),
                (t.tildeverticalcmb = 830),
                (t.timescircle = 8855),
                (t.tipehahebrew = 1430),
                (t.tipehalefthebrew = 1430),
                (t.tippigurmukhi = 2672),
                (t.titlocyrilliccmb = 1155),
                (t.tiwnarmenian = 1407),
                (t.tlinebelow = 7791),
                (t.tmonospace = 65364),
                (t.toarmenian = 1385),
                (t.tohiragana = 12392),
                (t.tokatakana = 12488),
                (t.tokatakanahalfwidth = 65412),
                (t.tonebarextrahighmod = 741),
                (t.tonebarextralowmod = 745),
                (t.tonebarhighmod = 742),
                (t.tonebarlowmod = 744),
                (t.tonebarmidmod = 743),
                (t.tonefive = 445),
                (t.tonesix = 389),
                (t.tonetwo = 424),
                (t.tonos = 900),
                (t.tonsquare = 13095),
                (t.topatakthai = 3599),
                (t.tortoiseshellbracketleft = 12308),
                (t.tortoiseshellbracketleftsmall = 65117),
                (t.tortoiseshellbracketleftvertical = 65081),
                (t.tortoiseshellbracketright = 12309),
                (t.tortoiseshellbracketrightsmall = 65118),
                (t.tortoiseshellbracketrightvertical = 65082),
                (t.totaothai = 3605),
                (t.tpalatalhook = 427),
                (t.tparen = 9391),
                (t.trademark = 8482),
                (t.trademarksans = 63722),
                (t.trademarkserif = 63195),
                (t.tretroflexhook = 648),
                (t.triagdn = 9660),
                (t.triaglf = 9668),
                (t.triagrt = 9658),
                (t.triagup = 9650),
                (t.ts = 678),
                (t.tsadi = 1510),
                (t.tsadidagesh = 64326),
                (t.tsadidageshhebrew = 64326),
                (t.tsadihebrew = 1510),
                (t.tsecyrillic = 1094),
                (t.tsere = 1461),
                (t.tsere12 = 1461),
                (t.tsere1e = 1461),
                (t.tsere2b = 1461),
                (t.tserehebrew = 1461),
                (t.tserenarrowhebrew = 1461),
                (t.tserequarterhebrew = 1461),
                (t.tserewidehebrew = 1461),
                (t.tshecyrillic = 1115),
                (t.tsuperior = 63219),
                (t.ttabengali = 2463),
                (t.ttadeva = 2335),
                (t.ttagujarati = 2719),
                (t.ttagurmukhi = 2591),
                (t.tteharabic = 1657),
                (t.ttehfinalarabic = 64359),
                (t.ttehinitialarabic = 64360),
                (t.ttehmedialarabic = 64361),
                (t.tthabengali = 2464),
                (t.tthadeva = 2336),
                (t.tthagujarati = 2720),
                (t.tthagurmukhi = 2592),
                (t.tturned = 647),
                (t.tuhiragana = 12388),
                (t.tukatakana = 12484),
                (t.tukatakanahalfwidth = 65410),
                (t.tusmallhiragana = 12387),
                (t.tusmallkatakana = 12483),
                (t.tusmallkatakanahalfwidth = 65391),
                (t.twelvecircle = 9323),
                (t.twelveparen = 9343),
                (t.twelveperiod = 9363),
                (t.twelveroman = 8571),
                (t.twentycircle = 9331),
                (t.twentyhangzhou = 21316),
                (t.twentyparen = 9351),
                (t.twentyperiod = 9371),
                (t.two = 50),
                (t.twoarabic = 1634),
                (t.twobengali = 2536),
                (t.twocircle = 9313),
                (t.twocircleinversesansserif = 10123),
                (t.twodeva = 2408),
                (t.twodotenleader = 8229);
              (t.twodotleader = 8229),
                (t.twodotleadervertical = 65072),
                (t.twogujarati = 2792),
                (t.twogurmukhi = 2664),
                (t.twohackarabic = 1634),
                (t.twohangzhou = 12322),
                (t.twoideographicparen = 12833),
                (t.twoinferior = 8322),
                (t.twomonospace = 65298),
                (t.twonumeratorbengali = 2549),
                (t.twooldstyle = 63282),
                (t.twoparen = 9333),
                (t.twoperiod = 9353),
                (t.twopersian = 1778),
                (t.tworoman = 8561),
                (t.twostroke = 443),
                (t.twosuperior = 178),
                (t.twothai = 3666),
                (t.twothirds = 8532),
                (t.u = 117),
                (t.uacute = 250),
                (t.ubar = 649),
                (t.ubengali = 2441),
                (t.ubopomofo = 12584),
                (t.ubreve = 365),
                (t.ucaron = 468),
                (t.ucircle = 9444),
                (t.ucircumflex = 251),
                (t.ucircumflexbelow = 7799),
                (t.ucyrillic = 1091),
                (t.udattadeva = 2385),
                (t.udblacute = 369),
                (t.udblgrave = 533),
                (t.udeva = 2313),
                (t.udieresis = 252),
                (t.udieresisacute = 472),
                (t.udieresisbelow = 7795),
                (t.udieresiscaron = 474),
                (t.udieresiscyrillic = 1265),
                (t.udieresisgrave = 476),
                (t.udieresismacron = 470),
                (t.udotbelow = 7909),
                (t.ugrave = 249),
                (t.ugujarati = 2697),
                (t.ugurmukhi = 2569),
                (t.uhiragana = 12358),
                (t.uhookabove = 7911),
                (t.uhorn = 432),
                (t.uhornacute = 7913),
                (t.uhorndotbelow = 7921),
                (t.uhorngrave = 7915),
                (t.uhornhookabove = 7917),
                (t.uhorntilde = 7919),
                (t.uhungarumlaut = 369),
                (t.uhungarumlautcyrillic = 1267),
                (t.uinvertedbreve = 535),
                (t.ukatakana = 12454),
                (t.ukatakanahalfwidth = 65395),
                (t.ukcyrillic = 1145),
                (t.ukorean = 12636),
                (t.umacron = 363),
                (t.umacroncyrillic = 1263),
                (t.umacrondieresis = 7803),
                (t.umatragurmukhi = 2625),
                (t.umonospace = 65365),
                (t.underscore = 95),
                (t.underscoredbl = 8215),
                (t.underscoremonospace = 65343),
                (t.underscorevertical = 65075),
                (t.underscorewavy = 65103),
                (t.union = 8746),
                (t.universal = 8704),
                (t.uogonek = 371),
                (t.uparen = 9392),
                (t.upblock = 9600),
                (t.upperdothebrew = 1476),
                (t.upsilon = 965),
                (t.upsilondieresis = 971),
                (t.upsilondieresistonos = 944),
                (t.upsilonlatin = 650),
                (t.upsilontonos = 973),
                (t.uptackbelowcmb = 797),
                (t.uptackmod = 724),
                (t.uragurmukhi = 2675),
                (t.uring = 367),
                (t.ushortcyrillic = 1118),
                (t.usmallhiragana = 12357),
                (t.usmallkatakana = 12453),
                (t.usmallkatakanahalfwidth = 65385),
                (t.ustraightcyrillic = 1199),
                (t.ustraightstrokecyrillic = 1201),
                (t.utilde = 361),
                (t.utildeacute = 7801),
                (t.utildebelow = 7797),
                (t.uubengali = 2442),
                (t.uudeva = 2314),
                (t.uugujarati = 2698),
                (t.uugurmukhi = 2570),
                (t.uumatragurmukhi = 2626),
                (t.uuvowelsignbengali = 2498),
                (t.uuvowelsigndeva = 2370),
                (t.uuvowelsigngujarati = 2754),
                (t.uvowelsignbengali = 2497),
                (t.uvowelsigndeva = 2369),
                (t.uvowelsigngujarati = 2753),
                (t.v = 118),
                (t.vadeva = 2357),
                (t.vagujarati = 2741),
                (t.vagurmukhi = 2613),
                (t.vakatakana = 12535),
                (t.vav = 1493),
                (t.vavdagesh = 64309),
                (t.vavdagesh65 = 64309),
                (t.vavdageshhebrew = 64309),
                (t.vavhebrew = 1493),
                (t.vavholam = 64331),
                (t.vavholamhebrew = 64331),
                (t.vavvavhebrew = 1520),
                (t.vavyodhebrew = 1521),
                (t.vcircle = 9445),
                (t.vdotbelow = 7807),
                (t.vecyrillic = 1074),
                (t.veharabic = 1700),
                (t.vehfinalarabic = 64363),
                (t.vehinitialarabic = 64364),
                (t.vehmedialarabic = 64365),
                (t.vekatakana = 12537),
                (t.venus = 9792),
                (t.verticalbar = 124),
                (t.verticallineabovecmb = 781),
                (t.verticallinebelowcmb = 809),
                (t.verticallinelowmod = 716),
                (t.verticallinemod = 712),
                (t.vewarmenian = 1406),
                (t.vhook = 651),
                (t.vikatakana = 12536),
                (t.viramabengali = 2509),
                (t.viramadeva = 2381),
                (t.viramagujarati = 2765),
                (t.visargabengali = 2435),
                (t.visargadeva = 2307),
                (t.visargagujarati = 2691),
                (t.vmonospace = 65366),
                (t.voarmenian = 1400),
                (t.voicediterationhiragana = 12446),
                (t.voicediterationkatakana = 12542),
                (t.voicedmarkkana = 12443),
                (t.voicedmarkkanahalfwidth = 65438),
                (t.vokatakana = 12538),
                (t.vparen = 9393),
                (t.vtilde = 7805),
                (t.vturned = 652),
                (t.vuhiragana = 12436),
                (t.vukatakana = 12532),
                (t.w = 119),
                (t.wacute = 7811),
                (t.waekorean = 12633),
                (t.wahiragana = 12431),
                (t.wakatakana = 12527),
                (t.wakatakanahalfwidth = 65436),
                (t.wakorean = 12632),
                (t.wasmallhiragana = 12430),
                (t.wasmallkatakana = 12526),
                (t.wattosquare = 13143),
                (t.wavedash = 12316),
                (t.wavyunderscorevertical = 65076),
                (t.wawarabic = 1608),
                (t.wawfinalarabic = 65262),
                (t.wawhamzaabovearabic = 1572),
                (t.wawhamzaabovefinalarabic = 65158),
                (t.wbsquare = 13277),
                (t.wcircle = 9446),
                (t.wcircumflex = 373),
                (t.wdieresis = 7813),
                (t.wdotaccent = 7815),
                (t.wdotbelow = 7817),
                (t.wehiragana = 12433),
                (t.weierstrass = 8472),
                (t.wekatakana = 12529),
                (t.wekorean = 12638),
                (t.weokorean = 12637),
                (t.wgrave = 7809),
                (t.whitebullet = 9702),
                (t.whitecircle = 9675),
                (t.whitecircleinverse = 9689),
                (t.whitecornerbracketleft = 12302),
                (t.whitecornerbracketleftvertical = 65091),
                (t.whitecornerbracketright = 12303),
                (t.whitecornerbracketrightvertical = 65092),
                (t.whitediamond = 9671),
                (t.whitediamondcontainingblacksmalldiamond = 9672),
                (t.whitedownpointingsmalltriangle = 9663),
                (t.whitedownpointingtriangle = 9661),
                (t.whiteleftpointingsmalltriangle = 9667),
                (t.whiteleftpointingtriangle = 9665),
                (t.whitelenticularbracketleft = 12310),
                (t.whitelenticularbracketright = 12311),
                (t.whiterightpointingsmalltriangle = 9657),
                (t.whiterightpointingtriangle = 9655),
                (t.whitesmallsquare = 9643);
              (t.whitesmilingface = 9786),
                (t.whitesquare = 9633),
                (t.whitestar = 9734),
                (t.whitetelephone = 9743),
                (t.whitetortoiseshellbracketleft = 12312),
                (t.whitetortoiseshellbracketright = 12313),
                (t.whiteuppointingsmalltriangle = 9653),
                (t.whiteuppointingtriangle = 9651),
                (t.wihiragana = 12432),
                (t.wikatakana = 12528),
                (t.wikorean = 12639),
                (t.wmonospace = 65367),
                (t.wohiragana = 12434),
                (t.wokatakana = 12530),
                (t.wokatakanahalfwidth = 65382),
                (t.won = 8361),
                (t.wonmonospace = 65510),
                (t.wowaenthai = 3623),
                (t.wparen = 9394),
                (t.wring = 7832),
                (t.wsuperior = 695),
                (t.wturned = 653),
                (t.wynn = 447),
                (t.x = 120),
                (t.xabovecmb = 829),
                (t.xbopomofo = 12562),
                (t.xcircle = 9447),
                (t.xdieresis = 7821),
                (t.xdotaccent = 7819),
                (t.xeharmenian = 1389),
                (t.xi = 958),
                (t.xmonospace = 65368),
                (t.xparen = 9395),
                (t.xsuperior = 739),
                (t.y = 121),
                (t.yaadosquare = 13134),
                (t.yabengali = 2479),
                (t.yacute = 253),
                (t.yadeva = 2351),
                (t.yaekorean = 12626),
                (t.yagujarati = 2735),
                (t.yagurmukhi = 2607),
                (t.yahiragana = 12420),
                (t.yakatakana = 12516),
                (t.yakatakanahalfwidth = 65428),
                (t.yakorean = 12625),
                (t.yamakkanthai = 3662),
                (t.yasmallhiragana = 12419),
                (t.yasmallkatakana = 12515),
                (t.yasmallkatakanahalfwidth = 65388),
                (t.yatcyrillic = 1123),
                (t.ycircle = 9448),
                (t.ycircumflex = 375),
                (t.ydieresis = 255),
                (t.ydotaccent = 7823),
                (t.ydotbelow = 7925),
                (t.yeharabic = 1610),
                (t.yehbarreearabic = 1746),
                (t.yehbarreefinalarabic = 64431),
                (t.yehfinalarabic = 65266),
                (t.yehhamzaabovearabic = 1574),
                (t.yehhamzaabovefinalarabic = 65162),
                (t.yehhamzaaboveinitialarabic = 65163),
                (t.yehhamzaabovemedialarabic = 65164),
                (t.yehinitialarabic = 65267),
                (t.yehmedialarabic = 65268),
                (t.yehmeeminitialarabic = 64733),
                (t.yehmeemisolatedarabic = 64600),
                (t.yehnoonfinalarabic = 64660),
                (t.yehthreedotsbelowarabic = 1745),
                (t.yekorean = 12630),
                (t.yen = 165),
                (t.yenmonospace = 65509),
                (t.yeokorean = 12629),
                (t.yeorinhieuhkorean = 12678),
                (t.yerahbenyomohebrew = 1450),
                (t.yerahbenyomolefthebrew = 1450),
                (t.yericyrillic = 1099),
                (t.yerudieresiscyrillic = 1273),
                (t.yesieungkorean = 12673),
                (t.yesieungpansioskorean = 12675),
                (t.yesieungsioskorean = 12674),
                (t.yetivhebrew = 1434),
                (t.ygrave = 7923),
                (t.yhook = 436),
                (t.yhookabove = 7927),
                (t.yiarmenian = 1397),
                (t.yicyrillic = 1111),
                (t.yikorean = 12642),
                (t.yinyang = 9775),
                (t.yiwnarmenian = 1410),
                (t.ymonospace = 65369),
                (t.yod = 1497),
                (t.yoddagesh = 64313),
                (t.yoddageshhebrew = 64313),
                (t.yodhebrew = 1497),
                (t.yodyodhebrew = 1522),
                (t.yodyodpatahhebrew = 64287),
                (t.yohiragana = 12424),
                (t.yoikorean = 12681),
                (t.yokatakana = 12520),
                (t.yokatakanahalfwidth = 65430),
                (t.yokorean = 12635),
                (t.yosmallhiragana = 12423),
                (t.yosmallkatakana = 12519),
                (t.yosmallkatakanahalfwidth = 65390),
                (t.yotgreek = 1011),
                (t.yoyaekorean = 12680),
                (t.yoyakorean = 12679),
                (t.yoyakthai = 3618),
                (t.yoyingthai = 3597),
                (t.yparen = 9396),
                (t.ypogegrammeni = 890),
                (t.ypogegrammenigreekcmb = 837),
                (t.yr = 422),
                (t.yring = 7833),
                (t.ysuperior = 696),
                (t.ytilde = 7929),
                (t.yturned = 654),
                (t.yuhiragana = 12422),
                (t.yuikorean = 12684),
                (t.yukatakana = 12518),
                (t.yukatakanahalfwidth = 65429),
                (t.yukorean = 12640),
                (t.yusbigcyrillic = 1131),
                (t.yusbigiotifiedcyrillic = 1133),
                (t.yuslittlecyrillic = 1127),
                (t.yuslittleiotifiedcyrillic = 1129),
                (t.yusmallhiragana = 12421),
                (t.yusmallkatakana = 12517),
                (t.yusmallkatakanahalfwidth = 65389),
                (t.yuyekorean = 12683),
                (t.yuyeokorean = 12682),
                (t.yyabengali = 2527),
                (t.yyadeva = 2399),
                (t.z = 122),
                (t.zaarmenian = 1382),
                (t.zacute = 378),
                (t.zadeva = 2395),
                (t.zagurmukhi = 2651),
                (t.zaharabic = 1592),
                (t.zahfinalarabic = 65222),
                (t.zahinitialarabic = 65223),
                (t.zahiragana = 12374),
                (t.zahmedialarabic = 65224),
                (t.zainarabic = 1586),
                (t.zainfinalarabic = 65200),
                (t.zakatakana = 12470),
                (t.zaqefgadolhebrew = 1429),
                (t.zaqefqatanhebrew = 1428),
                (t.zarqahebrew = 1432),
                (t.zayin = 1494),
                (t.zayindagesh = 64310),
                (t.zayindageshhebrew = 64310),
                (t.zayinhebrew = 1494),
                (t.zbopomofo = 12567),
                (t.zcaron = 382),
                (t.zcircle = 9449),
                (t.zcircumflex = 7825),
                (t.zcurl = 657),
                (t.zdot = 380),
                (t.zdotaccent = 380),
                (t.zdotbelow = 7827),
                (t.zecyrillic = 1079),
                (t.zedescendercyrillic = 1177),
                (t.zedieresiscyrillic = 1247),
                (t.zehiragana = 12380),
                (t.zekatakana = 12476),
                (t.zero = 48),
                (t.zeroarabic = 1632),
                (t.zerobengali = 2534),
                (t.zerodeva = 2406),
                (t.zerogujarati = 2790),
                (t.zerogurmukhi = 2662),
                (t.zerohackarabic = 1632),
                (t.zeroinferior = 8320),
                (t.zeromonospace = 65296),
                (t.zerooldstyle = 63280),
                (t.zeropersian = 1776),
                (t.zerosuperior = 8304),
                (t.zerothai = 3664),
                (t.zerowidthjoiner = 65279),
                (t.zerowidthnonjoiner = 8204),
                (t.zerowidthspace = 8203),
                (t.zeta = 950),
                (t.zhbopomofo = 12563),
                (t.zhearmenian = 1386),
                (t.zhebrevecyrillic = 1218),
                (t.zhecyrillic = 1078),
                (t.zhedescendercyrillic = 1175),
                (t.zhedieresiscyrillic = 1245),
                (t.zihiragana = 12376),
                (t.zikatakana = 12472),
                (t.zinorhebrew = 1454),
                (t.zlinebelow = 7829),
                (t.zmonospace = 65370),
                (t.zohiragana = 12382),
                (t.zokatakana = 12478),
                (t.zparen = 9397),
                (t.zretroflexhook = 656);
              (t.zstroke = 438), (t.zuhiragana = 12378), (t.zukatakana = 12474), (t[".notdef"] = 0);
            }),
            getDingbatsGlyphsUnicode = getLookupTableFactory(function (t) {
              (t.space = 32),
                (t.a1 = 9985),
                (t.a2 = 9986),
                (t.a202 = 9987),
                (t.a3 = 9988),
                (t.a4 = 9742),
                (t.a5 = 9990),
                (t.a119 = 9991),
                (t.a118 = 9992),
                (t.a117 = 9993),
                (t.a11 = 9755),
                (t.a12 = 9758),
                (t.a13 = 9996),
                (t.a14 = 9997),
                (t.a15 = 9998),
                (t.a16 = 9999),
                (t.a105 = 1e4),
                (t.a17 = 10001),
                (t.a18 = 10002),
                (t.a19 = 10003),
                (t.a20 = 10004),
                (t.a21 = 10005),
                (t.a22 = 10006),
                (t.a23 = 10007),
                (t.a24 = 10008),
                (t.a25 = 10009),
                (t.a26 = 10010),
                (t.a27 = 10011),
                (t.a28 = 10012),
                (t.a6 = 10013),
                (t.a7 = 10014),
                (t.a8 = 10015),
                (t.a9 = 10016),
                (t.a10 = 10017),
                (t.a29 = 10018),
                (t.a30 = 10019),
                (t.a31 = 10020),
                (t.a32 = 10021),
                (t.a33 = 10022),
                (t.a34 = 10023),
                (t.a35 = 9733),
                (t.a36 = 10025),
                (t.a37 = 10026),
                (t.a38 = 10027),
                (t.a39 = 10028),
                (t.a40 = 10029),
                (t.a41 = 10030),
                (t.a42 = 10031),
                (t.a43 = 10032),
                (t.a44 = 10033),
                (t.a45 = 10034),
                (t.a46 = 10035),
                (t.a47 = 10036),
                (t.a48 = 10037),
                (t.a49 = 10038),
                (t.a50 = 10039),
                (t.a51 = 10040),
                (t.a52 = 10041),
                (t.a53 = 10042),
                (t.a54 = 10043),
                (t.a55 = 10044),
                (t.a56 = 10045),
                (t.a57 = 10046),
                (t.a58 = 10047),
                (t.a59 = 10048),
                (t.a60 = 10049),
                (t.a61 = 10050),
                (t.a62 = 10051),
                (t.a63 = 10052),
                (t.a64 = 10053),
                (t.a65 = 10054),
                (t.a66 = 10055),
                (t.a67 = 10056),
                (t.a68 = 10057),
                (t.a69 = 10058),
                (t.a70 = 10059),
                (t.a71 = 9679),
                (t.a72 = 10061),
                (t.a73 = 9632),
                (t.a74 = 10063),
                (t.a203 = 10064),
                (t.a75 = 10065),
                (t.a204 = 10066),
                (t.a76 = 9650),
                (t.a77 = 9660),
                (t.a78 = 9670),
                (t.a79 = 10070),
                (t.a81 = 9687),
                (t.a82 = 10072),
                (t.a83 = 10073),
                (t.a84 = 10074),
                (t.a97 = 10075),
                (t.a98 = 10076),
                (t.a99 = 10077),
                (t.a100 = 10078),
                (t.a101 = 10081),
                (t.a102 = 10082),
                (t.a103 = 10083),
                (t.a104 = 10084),
                (t.a106 = 10085),
                (t.a107 = 10086),
                (t.a108 = 10087),
                (t.a112 = 9827),
                (t.a111 = 9830),
                (t.a110 = 9829),
                (t.a109 = 9824),
                (t.a120 = 9312),
                (t.a121 = 9313),
                (t.a122 = 9314),
                (t.a123 = 9315),
                (t.a124 = 9316),
                (t.a125 = 9317),
                (t.a126 = 9318),
                (t.a127 = 9319),
                (t.a128 = 9320),
                (t.a129 = 9321),
                (t.a130 = 10102),
                (t.a131 = 10103),
                (t.a132 = 10104),
                (t.a133 = 10105),
                (t.a134 = 10106),
                (t.a135 = 10107),
                (t.a136 = 10108),
                (t.a137 = 10109),
                (t.a138 = 10110),
                (t.a139 = 10111),
                (t.a140 = 10112),
                (t.a141 = 10113),
                (t.a142 = 10114),
                (t.a143 = 10115),
                (t.a144 = 10116),
                (t.a145 = 10117),
                (t.a146 = 10118),
                (t.a147 = 10119),
                (t.a148 = 10120),
                (t.a149 = 10121),
                (t.a150 = 10122),
                (t.a151 = 10123),
                (t.a152 = 10124),
                (t.a153 = 10125),
                (t.a154 = 10126),
                (t.a155 = 10127),
                (t.a156 = 10128),
                (t.a157 = 10129),
                (t.a158 = 10130),
                (t.a159 = 10131),
                (t.a160 = 10132),
                (t.a161 = 8594),
                (t.a163 = 8596),
                (t.a164 = 8597),
                (t.a196 = 10136),
                (t.a165 = 10137),
                (t.a192 = 10138),
                (t.a166 = 10139),
                (t.a167 = 10140),
                (t.a168 = 10141),
                (t.a169 = 10142),
                (t.a170 = 10143),
                (t.a171 = 10144),
                (t.a172 = 10145),
                (t.a173 = 10146),
                (t.a162 = 10147),
                (t.a174 = 10148),
                (t.a175 = 10149),
                (t.a176 = 10150),
                (t.a177 = 10151),
                (t.a178 = 10152),
                (t.a179 = 10153),
                (t.a193 = 10154),
                (t.a180 = 10155),
                (t.a199 = 10156),
                (t.a181 = 10157),
                (t.a200 = 10158),
                (t.a182 = 10159),
                (t.a201 = 10161),
                (t.a183 = 10162),
                (t.a184 = 10163),
                (t.a197 = 10164),
                (t.a185 = 10165),
                (t.a194 = 10166),
                (t.a198 = 10167),
                (t.a186 = 10168),
                (t.a195 = 10169),
                (t.a187 = 10170),
                (t.a188 = 10171),
                (t.a189 = 10172),
                (t.a190 = 10173),
                (t.a191 = 10174),
                (t.a89 = 10088),
                (t.a90 = 10089),
                (t.a93 = 10090),
                (t.a94 = 10091),
                (t.a91 = 10092),
                (t.a92 = 10093),
                (t.a205 = 10094),
                (t.a85 = 10095),
                (t.a206 = 10096),
                (t.a86 = 10097),
                (t.a87 = 10098),
                (t.a88 = 10099);
              (t.a95 = 10100), (t.a96 = 10101), (t[".notdef"] = 0);
            });
          (exports.getGlyphsUnicode = getGlyphsUnicode), (exports.getDingbatsGlyphsUnicode = getDingbatsGlyphsUnicode);
        })((root.pdfjsCoreGlyphList = {}), root.pdfjsSharedUtil);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, coreArithmeticDecoder) {
          var error = sharedUtil.error,
            log2 = sharedUtil.log2,
            readInt8 = sharedUtil.readInt8,
            readUint16 = sharedUtil.readUint16,
            readUint32 = sharedUtil.readUint32,
            shadow = sharedUtil.shadow,
            ArithmeticDecoder = coreArithmeticDecoder.ArithmeticDecoder,
            Jbig2Image = (function () {
              function ContextCache() {}
              function DecodingContext(data, start, end) {
                (this.data = data), (this.start = start), (this.end = end);
              }
              function decodeInteger(contextCache, procedure, decoder) {
                function readBits(length) {
                  for (var v = 0, i = 0; i < length; i++) {
                    var bit = decoder.readBit(contexts, prev);
                    (prev = prev < 256 ? (prev << 1) | bit : (511 & ((prev << 1) | bit)) | 256), (v = (v << 1) | bit);
                  }
                  return v >>> 0;
                }
                var contexts = contextCache.getContexts(procedure),
                  prev = 1,
                  sign = readBits(1),
                  value = readBits(1)
                    ? readBits(1)
                      ? readBits(1)
                        ? readBits(1)
                          ? readBits(1)
                            ? readBits(32) + 4436
                            : readBits(12) + 340
                          : readBits(8) + 84
                        : readBits(6) + 20
                      : readBits(4) + 4
                    : readBits(2);
                return 0 === sign ? value : value > 0 ? -value : null;
              }
              function decodeIAID(contextCache, decoder, codeLength) {
                for (var contexts = contextCache.getContexts("IAID"), prev = 1, i = 0; i < codeLength; i++) {
                  prev = (prev << 1) | decoder.readBit(contexts, prev);
                }
                return codeLength < 31 ? prev & ((1 << codeLength) - 1) : 2147483647 & prev;
              }
              function decodeBitmapTemplate0(width, height, decodingContext) {
                var contextLabel,
                  i,
                  j,
                  pixel,
                  row,
                  row1,
                  row2,
                  decoder = decodingContext.decoder,
                  contexts = decodingContext.contextCache.getContexts("GB"),
                  bitmap = [];
                for (i = 0; i < height; i++)
                  for (
                    row = bitmap[i] = new Uint8Array(width),
                      row1 = i < 1 ? row : bitmap[i - 1],
                      row2 = i < 2 ? row : bitmap[i - 2],
                      contextLabel =
                        (row2[0] << 13) |
                        (row2[1] << 12) |
                        (row2[2] << 11) |
                        (row1[0] << 7) |
                        (row1[1] << 6) |
                        (row1[2] << 5) |
                        (row1[3] << 4),
                      j = 0;
                    j < width;
                    j++
                  )
                    (row[j] = pixel = decoder.readBit(contexts, contextLabel)),
                      (contextLabel =
                        ((31735 & contextLabel) << 1) |
                        (j + 3 < width ? row2[j + 3] << 11 : 0) |
                        (j + 4 < width ? row1[j + 4] << 4 : 0) |
                        pixel);
                return bitmap;
              }
              function decodeBitmap(mmr, width, height, templateIndex, prediction, skip, at, decodingContext) {
                if (
                  (mmr && error("JBIG2 error: MMR encoding is not supported"),
                  0 === templateIndex &&
                    !skip &&
                    !prediction &&
                    4 === at.length &&
                    3 === at[0].x &&
                    -1 === at[0].y &&
                    -3 === at[1].x &&
                    -1 === at[1].y &&
                    2 === at[2].x &&
                    -2 === at[2].y &&
                    -2 === at[3].x &&
                    -2 === at[3].y)
                )
                  return decodeBitmapTemplate0(width, height, decodingContext);
                var useskip = !!skip,
                  template = CodingTemplates[templateIndex].concat(at);
                template.sort(function (a, b) {
                  return a.y - b.y || a.x - b.x;
                });
                var c,
                  k,
                  templateLength = template.length,
                  templateX = new Int8Array(templateLength),
                  templateY = new Int8Array(templateLength),
                  changingTemplateEntries = [],
                  reuseMask = 0,
                  minX = 0,
                  maxX = 0,
                  minY = 0;
                for (k = 0; k < templateLength; k++)
                  (templateX[k] = template[k].x),
                    (templateY[k] = template[k].y),
                    (minX = Math.min(minX, template[k].x)),
                    (maxX = Math.max(maxX, template[k].x)),
                    (minY = Math.min(minY, template[k].y)),
                    k < templateLength - 1 &&
                    template[k].y === template[k + 1].y &&
                    template[k].x === template[k + 1].x - 1
                      ? (reuseMask |= 1 << (templateLength - 1 - k))
                      : changingTemplateEntries.push(k);
                var changingEntriesLength = changingTemplateEntries.length,
                  changingTemplateX = new Int8Array(changingEntriesLength),
                  changingTemplateY = new Int8Array(changingEntriesLength),
                  changingTemplateBit = new Uint16Array(changingEntriesLength);
                for (c = 0; c < changingEntriesLength; c++)
                  (k = changingTemplateEntries[c]),
                    (changingTemplateX[c] = template[k].x),
                    (changingTemplateY[c] = template[k].y),
                    (changingTemplateBit[c] = 1 << (templateLength - 1 - k));
                for (
                  var j,
                    i0,
                    j0,
                    bit,
                    shift,
                    sbb_left = -minX,
                    sbb_top = -minY,
                    sbb_right = width - maxX,
                    pseudoPixelContext = ReusedContexts[templateIndex],
                    row = new Uint8Array(width),
                    bitmap = [],
                    decoder = decodingContext.decoder,
                    contexts = decodingContext.contextCache.getContexts("GB"),
                    ltp = 0,
                    contextLabel = 0,
                    i = 0;
                  i < height;
                  i++
                ) {
                  if (prediction) {
                    if ((ltp ^= decoder.readBit(contexts, pseudoPixelContext))) {
                      bitmap.push(row);
                      continue;
                    }
                  }
                  for (row = new Uint8Array(row), bitmap.push(row), j = 0; j < width; j++)
                    if (useskip && skip[i][j]) row[j] = 0;
                    else {
                      if (j >= sbb_left && j < sbb_right && i >= sbb_top)
                        for (contextLabel = (contextLabel << 1) & reuseMask, k = 0; k < changingEntriesLength; k++)
                          (i0 = i + changingTemplateY[k]),
                            (j0 = j + changingTemplateX[k]),
                            (bit = bitmap[i0][j0]) && ((bit = changingTemplateBit[k]), (contextLabel |= bit));
                      else
                        for (contextLabel = 0, shift = templateLength - 1, k = 0; k < templateLength; k++, shift--)
                          (j0 = j + templateX[k]) >= 0 &&
                            j0 < width &&
                            (i0 = i + templateY[k]) >= 0 &&
                            (bit = bitmap[i0][j0]) &&
                            (contextLabel |= bit << shift);
                      var pixel = decoder.readBit(contexts, contextLabel);
                      row[j] = pixel;
                    }
                }
                return bitmap;
              }
              function decodeRefinement(
                width,
                height,
                templateIndex,
                referenceBitmap,
                offsetX,
                offsetY,
                prediction,
                at,
                decodingContext
              ) {
                var codingTemplate = RefinementTemplates[templateIndex].coding;
                0 === templateIndex && (codingTemplate = codingTemplate.concat([at[0]]));
                var k,
                  codingTemplateLength = codingTemplate.length,
                  codingTemplateX = new Int32Array(codingTemplateLength),
                  codingTemplateY = new Int32Array(codingTemplateLength);
                for (k = 0; k < codingTemplateLength; k++)
                  (codingTemplateX[k] = codingTemplate[k].x), (codingTemplateY[k] = codingTemplate[k].y);
                var referenceTemplate = RefinementTemplates[templateIndex].reference;
                0 === templateIndex && (referenceTemplate = referenceTemplate.concat([at[1]]));
                var referenceTemplateLength = referenceTemplate.length,
                  referenceTemplateX = new Int32Array(referenceTemplateLength),
                  referenceTemplateY = new Int32Array(referenceTemplateLength);
                for (k = 0; k < referenceTemplateLength; k++)
                  (referenceTemplateX[k] = referenceTemplate[k].x), (referenceTemplateY[k] = referenceTemplate[k].y);
                for (
                  var referenceWidth = referenceBitmap[0].length,
                    referenceHeight = referenceBitmap.length,
                    pseudoPixelContext = RefinementReusedContexts[templateIndex],
                    bitmap = [],
                    decoder = decodingContext.decoder,
                    contexts = decodingContext.contextCache.getContexts("GR"),
                    ltp = 0,
                    i = 0;
                  i < height;
                  i++
                ) {
                  if (prediction) {
                    (ltp ^= decoder.readBit(contexts, pseudoPixelContext)),
                      ltp && error("JBIG2 error: prediction is not supported");
                  }
                  var row = new Uint8Array(width);
                  bitmap.push(row);
                  for (var j = 0; j < width; j++) {
                    var i0,
                      j0,
                      contextLabel = 0;
                    for (k = 0; k < codingTemplateLength; k++)
                      (i0 = i + codingTemplateY[k]),
                        (j0 = j + codingTemplateX[k]),
                        i0 < 0 || j0 < 0 || j0 >= width
                          ? (contextLabel <<= 1)
                          : (contextLabel = (contextLabel << 1) | bitmap[i0][j0]);
                    for (k = 0; k < referenceTemplateLength; k++)
                      (i0 = i + referenceTemplateY[k] + offsetY),
                        (j0 = j + referenceTemplateX[k] + offsetX),
                        i0 < 0 || i0 >= referenceHeight || j0 < 0 || j0 >= referenceWidth
                          ? (contextLabel <<= 1)
                          : (contextLabel = (contextLabel << 1) | referenceBitmap[i0][j0]);
                    var pixel = decoder.readBit(contexts, contextLabel);
                    row[j] = pixel;
                  }
                }
                return bitmap;
              }
              function decodeSymbolDictionary(
                huffman,
                refinement,
                symbols,
                numberOfNewSymbols,
                numberOfExportedSymbols,
                huffmanTables,
                templateIndex,
                at,
                refinementTemplateIndex,
                refinementAt,
                decodingContext
              ) {
                huffman && error("JBIG2 error: huffman is not supported");
                for (
                  var newSymbols = [],
                    currentHeight = 0,
                    symbolCodeLength = log2(symbols.length + numberOfNewSymbols),
                    decoder = decodingContext.decoder,
                    contextCache = decodingContext.contextCache;
                  newSymbols.length < numberOfNewSymbols;

                ) {
                  currentHeight += decodeInteger(contextCache, "IADH", decoder);
                  for (var currentWidth = 0, totalWidth = 0; ; ) {
                    var deltaWidth = decodeInteger(contextCache, "IADW", decoder);
                    if (null === deltaWidth) break;
                    (currentWidth += deltaWidth), (totalWidth += currentWidth);
                    var bitmap;
                    if (refinement) {
                      var numberOfInstances = decodeInteger(contextCache, "IAAI", decoder);
                      if (numberOfInstances > 1)
                        bitmap = decodeTextRegion(
                          huffman,
                          refinement,
                          currentWidth,
                          currentHeight,
                          0,
                          numberOfInstances,
                          1,
                          symbols.concat(newSymbols),
                          symbolCodeLength,
                          0,
                          0,
                          1,
                          0,
                          huffmanTables,
                          refinementTemplateIndex,
                          refinementAt,
                          decodingContext
                        );
                      else {
                        var symbolId = decodeIAID(contextCache, decoder, symbolCodeLength),
                          rdx = decodeInteger(contextCache, "IARDX", decoder),
                          rdy = decodeInteger(contextCache, "IARDY", decoder);
                        bitmap = decodeRefinement(
                          currentWidth,
                          currentHeight,
                          refinementTemplateIndex,
                          symbolId < symbols.length ? symbols[symbolId] : newSymbols[symbolId - symbols.length],
                          rdx,
                          rdy,
                          !1,
                          refinementAt,
                          decodingContext
                        );
                      }
                    } else
                      bitmap = decodeBitmap(
                        !1,
                        currentWidth,
                        currentHeight,
                        templateIndex,
                        !1,
                        null,
                        at,
                        decodingContext
                      );
                    newSymbols.push(bitmap);
                  }
                }
                for (
                  var exportedSymbols = [],
                    flags = [],
                    currentFlag = !1,
                    totalSymbolsLength = symbols.length + numberOfNewSymbols;
                  flags.length < totalSymbolsLength;

                ) {
                  for (var runLength = decodeInteger(contextCache, "IAEX", decoder); runLength--; )
                    flags.push(currentFlag);
                  currentFlag = !currentFlag;
                }
                for (var i = 0, ii = symbols.length; i < ii; i++) flags[i] && exportedSymbols.push(symbols[i]);
                for (var j = 0; j < numberOfNewSymbols; i++, j++) flags[i] && exportedSymbols.push(newSymbols[j]);
                return exportedSymbols;
              }
              function decodeTextRegion(
                huffman,
                refinement,
                width,
                height,
                defaultPixelValue,
                numberOfSymbolInstances,
                stripSize,
                inputSymbols,
                symbolCodeLength,
                transposed,
                dsOffset,
                referenceCorner,
                combinationOperator,
                huffmanTables,
                refinementTemplateIndex,
                refinementAt,
                decodingContext
              ) {
                huffman && error("JBIG2 error: huffman is not supported");
                var i,
                  row,
                  bitmap = [];
                for (i = 0; i < height; i++) {
                  if (((row = new Uint8Array(width)), defaultPixelValue))
                    for (var j = 0; j < width; j++) row[j] = defaultPixelValue;
                  bitmap.push(row);
                }
                var decoder = decodingContext.decoder,
                  contextCache = decodingContext.contextCache,
                  stripT = -decodeInteger(contextCache, "IADT", decoder),
                  firstS = 0;
                for (i = 0; i < numberOfSymbolInstances; ) {
                  stripT += decodeInteger(contextCache, "IADT", decoder);
                  firstS += decodeInteger(contextCache, "IAFS", decoder);
                  for (var currentS = firstS; ; ) {
                    var currentT = 1 === stripSize ? 0 : decodeInteger(contextCache, "IAIT", decoder),
                      t = stripSize * stripT + currentT,
                      symbolId = decodeIAID(contextCache, decoder, symbolCodeLength),
                      applyRefinement = refinement && decodeInteger(contextCache, "IARI", decoder),
                      symbolBitmap = inputSymbols[symbolId],
                      symbolWidth = symbolBitmap[0].length,
                      symbolHeight = symbolBitmap.length;
                    if (applyRefinement) {
                      var rdw = decodeInteger(contextCache, "IARDW", decoder),
                        rdh = decodeInteger(contextCache, "IARDH", decoder),
                        rdx = decodeInteger(contextCache, "IARDX", decoder),
                        rdy = decodeInteger(contextCache, "IARDY", decoder);
                      (symbolWidth += rdw),
                        (symbolHeight += rdh),
                        (symbolBitmap = decodeRefinement(
                          symbolWidth,
                          symbolHeight,
                          refinementTemplateIndex,
                          symbolBitmap,
                          (rdw >> 1) + rdx,
                          (rdh >> 1) + rdy,
                          !1,
                          refinementAt,
                          decodingContext
                        ));
                    }
                    var s2,
                      t2,
                      symbolRow,
                      offsetT = t - (1 & referenceCorner ? 0 : symbolHeight),
                      offsetS = currentS - (2 & referenceCorner ? symbolWidth : 0);
                    if (transposed) {
                      for (s2 = 0; s2 < symbolHeight; s2++)
                        if ((row = bitmap[offsetS + s2])) {
                          symbolRow = symbolBitmap[s2];
                          var maxWidth = Math.min(width - offsetT, symbolWidth);
                          switch (combinationOperator) {
                            case 0:
                              for (t2 = 0; t2 < maxWidth; t2++) row[offsetT + t2] |= symbolRow[t2];
                              break;
                            case 2:
                              for (t2 = 0; t2 < maxWidth; t2++) row[offsetT + t2] ^= symbolRow[t2];
                              break;
                            default:
                              error("JBIG2 error: operator " + combinationOperator + " is not supported");
                          }
                        }
                      currentS += symbolHeight - 1;
                    } else {
                      for (t2 = 0; t2 < symbolHeight; t2++)
                        if ((row = bitmap[offsetT + t2]))
                          switch (((symbolRow = symbolBitmap[t2]), combinationOperator)) {
                            case 0:
                              for (s2 = 0; s2 < symbolWidth; s2++) row[offsetS + s2] |= symbolRow[s2];
                              break;
                            case 2:
                              for (s2 = 0; s2 < symbolWidth; s2++) row[offsetS + s2] ^= symbolRow[s2];
                              break;
                            default:
                              error("JBIG2 error: operator " + combinationOperator + " is not supported");
                          }
                      currentS += symbolWidth - 1;
                    }
                    i++;
                    var deltaS = decodeInteger(contextCache, "IADS", decoder);
                    if (null === deltaS) break;
                    currentS += deltaS + dsOffset;
                  }
                }
                return bitmap;
              }
              function readSegmentHeader(data, start) {
                var segmentHeader = {};
                segmentHeader.number = readUint32(data, start);
                var flags = data[start + 4],
                  segmentType = 63 & flags;
                SegmentTypes[segmentType] || error("JBIG2 error: invalid segment type: " + segmentType),
                  (segmentHeader.type = segmentType),
                  (segmentHeader.typeName = SegmentTypes[segmentType]),
                  (segmentHeader.deferredNonRetain = !!(128 & flags));
                var pageAssociationFieldSize = !!(64 & flags),
                  referredFlags = data[start + 5],
                  referredToCount = (referredFlags >> 5) & 7,
                  retainBits = [31 & referredFlags],
                  position = start + 6;
                if (7 === referredFlags) {
                  (referredToCount = 536870911 & readUint32(data, position - 1)), (position += 3);
                  var bytes = (referredToCount + 7) >> 3;
                  for (retainBits[0] = data[position++]; --bytes > 0; ) retainBits.push(data[position++]);
                } else (5 !== referredFlags && 6 !== referredFlags) || error("JBIG2 error: invalid referred-to flags");
                segmentHeader.retainBits = retainBits;
                var i,
                  ii,
                  referredToSegmentNumberSize = segmentHeader.number <= 256 ? 1 : segmentHeader.number <= 65536 ? 2 : 4,
                  referredTo = [];
                for (i = 0; i < referredToCount; i++) {
                  var number =
                    1 === referredToSegmentNumberSize
                      ? data[position]
                      : 2 === referredToSegmentNumberSize
                      ? readUint16(data, position)
                      : readUint32(data, position);
                  referredTo.push(number), (position += referredToSegmentNumberSize);
                }
                if (
                  ((segmentHeader.referredTo = referredTo),
                  pageAssociationFieldSize
                    ? ((segmentHeader.pageAssociation = readUint32(data, position)), (position += 4))
                    : (segmentHeader.pageAssociation = data[position++]),
                  (segmentHeader.length = readUint32(data, position)),
                  (position += 4),
                  4294967295 === segmentHeader.length)
                )
                  if (38 === segmentType) {
                    var genericRegionInfo = readRegionSegmentInformation(data, position),
                      genericRegionSegmentFlags = data[position + RegionSegmentInformationFieldLength],
                      genericRegionMmr = !!(1 & genericRegionSegmentFlags),
                      searchPattern = new Uint8Array(6);
                    for (
                      genericRegionMmr || ((searchPattern[0] = 255), (searchPattern[1] = 172)),
                        searchPattern[2] = (genericRegionInfo.height >>> 24) & 255,
                        searchPattern[3] = (genericRegionInfo.height >> 16) & 255,
                        searchPattern[4] = (genericRegionInfo.height >> 8) & 255,
                        searchPattern[5] = 255 & genericRegionInfo.height,
                        i = position,
                        ii = data.length;
                      i < ii;
                      i++
                    ) {
                      for (var j = 0; j < 6 && searchPattern[j] === data[i + j]; ) j++;
                      if (6 === j) {
                        segmentHeader.length = i + 6;
                        break;
                      }
                    }
                    4294967295 === segmentHeader.length && error("JBIG2 error: segment end was not found");
                  } else error("JBIG2 error: invalid unknown segment length");
                return (segmentHeader.headerEnd = position), segmentHeader;
              }
              function readSegments(header, data, start, end) {
                for (var segments = [], position = start; position < end; ) {
                  var segmentHeader = readSegmentHeader(data, position);
                  position = segmentHeader.headerEnd;
                  var segment = { header: segmentHeader, data: data };
                  if (
                    (header.randomAccess ||
                      ((segment.start = position), (position += segmentHeader.length), (segment.end = position)),
                    segments.push(segment),
                    51 === segmentHeader.type)
                  )
                    break;
                }
                if (header.randomAccess)
                  for (var i = 0, ii = segments.length; i < ii; i++)
                    (segments[i].start = position),
                      (position += segments[i].header.length),
                      (segments[i].end = position);
                return segments;
              }
              function readRegionSegmentInformation(data, start) {
                return {
                  width: readUint32(data, start),
                  height: readUint32(data, start + 4),
                  x: readUint32(data, start + 8),
                  y: readUint32(data, start + 12),
                  combinationOperator: 7 & data[start + 16],
                };
              }
              function processSegment(segment, visitor) {
                var args,
                  at,
                  i,
                  atLength,
                  header = segment.header,
                  data = segment.data,
                  position = segment.start,
                  end = segment.end;
                switch (header.type) {
                  case 0:
                    var dictionary = {},
                      dictionaryFlags = readUint16(data, position);
                    if (
                      ((dictionary.huffman = !!(1 & dictionaryFlags)),
                      (dictionary.refinement = !!(2 & dictionaryFlags)),
                      (dictionary.huffmanDHSelector = (dictionaryFlags >> 2) & 3),
                      (dictionary.huffmanDWSelector = (dictionaryFlags >> 4) & 3),
                      (dictionary.bitmapSizeSelector = (dictionaryFlags >> 6) & 1),
                      (dictionary.aggregationInstancesSelector = (dictionaryFlags >> 7) & 1),
                      (dictionary.bitmapCodingContextUsed = !!(256 & dictionaryFlags)),
                      (dictionary.bitmapCodingContextRetained = !!(512 & dictionaryFlags)),
                      (dictionary.template = (dictionaryFlags >> 10) & 3),
                      (dictionary.refinementTemplate = (dictionaryFlags >> 12) & 1),
                      (position += 2),
                      !dictionary.huffman)
                    ) {
                      for (atLength = 0 === dictionary.template ? 4 : 1, at = [], i = 0; i < atLength; i++)
                        at.push({ x: readInt8(data, position), y: readInt8(data, position + 1) }), (position += 2);
                      dictionary.at = at;
                    }
                    if (dictionary.refinement && !dictionary.refinementTemplate) {
                      for (at = [], i = 0; i < 2; i++)
                        at.push({ x: readInt8(data, position), y: readInt8(data, position + 1) }), (position += 2);
                      dictionary.refinementAt = at;
                    }
                    (dictionary.numberOfExportedSymbols = readUint32(data, position)),
                      (position += 4),
                      (dictionary.numberOfNewSymbols = readUint32(data, position)),
                      (position += 4),
                      (args = [dictionary, header.number, header.referredTo, data, position, end]);
                    break;
                  case 6:
                  case 7:
                    var textRegion = {};
                    (textRegion.info = readRegionSegmentInformation(data, position)),
                      (position += RegionSegmentInformationFieldLength);
                    var textRegionSegmentFlags = readUint16(data, position);
                    if (
                      ((position += 2),
                      (textRegion.huffman = !!(1 & textRegionSegmentFlags)),
                      (textRegion.refinement = !!(2 & textRegionSegmentFlags)),
                      (textRegion.stripSize = 1 << ((textRegionSegmentFlags >> 2) & 3)),
                      (textRegion.referenceCorner = (textRegionSegmentFlags >> 4) & 3),
                      (textRegion.transposed = !!(64 & textRegionSegmentFlags)),
                      (textRegion.combinationOperator = (textRegionSegmentFlags >> 7) & 3),
                      (textRegion.defaultPixelValue = (textRegionSegmentFlags >> 9) & 1),
                      (textRegion.dsOffset = (textRegionSegmentFlags << 17) >> 27),
                      (textRegion.refinementTemplate = (textRegionSegmentFlags >> 15) & 1),
                      textRegion.huffman)
                    ) {
                      var textRegionHuffmanFlags = readUint16(data, position);
                      (position += 2),
                        (textRegion.huffmanFS = 3 & textRegionHuffmanFlags),
                        (textRegion.huffmanDS = (textRegionHuffmanFlags >> 2) & 3),
                        (textRegion.huffmanDT = (textRegionHuffmanFlags >> 4) & 3),
                        (textRegion.huffmanRefinementDW = (textRegionHuffmanFlags >> 6) & 3),
                        (textRegion.huffmanRefinementDH = (textRegionHuffmanFlags >> 8) & 3),
                        (textRegion.huffmanRefinementDX = (textRegionHuffmanFlags >> 10) & 3),
                        (textRegion.huffmanRefinementDY = (textRegionHuffmanFlags >> 12) & 3),
                        (textRegion.huffmanRefinementSizeSelector = !!(14 & textRegionHuffmanFlags));
                    }
                    if (textRegion.refinement && !textRegion.refinementTemplate) {
                      for (at = [], i = 0; i < 2; i++)
                        at.push({ x: readInt8(data, position), y: readInt8(data, position + 1) }), (position += 2);
                      textRegion.refinementAt = at;
                    }
                    (textRegion.numberOfSymbolInstances = readUint32(data, position)),
                      (position += 4),
                      textRegion.huffman && error("JBIG2 error: huffman is not supported"),
                      (args = [textRegion, header.referredTo, data, position, end]);
                    break;
                  case 38:
                  case 39:
                    var genericRegion = {};
                    (genericRegion.info = readRegionSegmentInformation(data, position)),
                      (position += RegionSegmentInformationFieldLength);
                    var genericRegionSegmentFlags = data[position++];
                    if (
                      ((genericRegion.mmr = !!(1 & genericRegionSegmentFlags)),
                      (genericRegion.template = (genericRegionSegmentFlags >> 1) & 3),
                      (genericRegion.prediction = !!(8 & genericRegionSegmentFlags)),
                      !genericRegion.mmr)
                    ) {
                      for (atLength = 0 === genericRegion.template ? 4 : 1, at = [], i = 0; i < atLength; i++)
                        at.push({ x: readInt8(data, position), y: readInt8(data, position + 1) }), (position += 2);
                      genericRegion.at = at;
                    }
                    args = [genericRegion, data, position, end];
                    break;
                  case 48:
                    var pageInfo = {
                      width: readUint32(data, position),
                      height: readUint32(data, position + 4),
                      resolutionX: readUint32(data, position + 8),
                      resolutionY: readUint32(data, position + 12),
                    };
                    4294967295 === pageInfo.height && delete pageInfo.height;
                    var pageSegmentFlags = data[position + 16];
                    readUint16(data, position + 17);
                    (pageInfo.lossless = !!(1 & pageSegmentFlags)),
                      (pageInfo.refinement = !!(2 & pageSegmentFlags)),
                      (pageInfo.defaultPixelValue = (pageSegmentFlags >> 2) & 1),
                      (pageInfo.combinationOperator = (pageSegmentFlags >> 3) & 3),
                      (pageInfo.requiresBuffer = !!(32 & pageSegmentFlags)),
                      (pageInfo.combinationOperatorOverride = !!(64 & pageSegmentFlags)),
                      (args = [pageInfo]);
                    break;
                  case 49:
                  case 50:
                  case 51:
                  case 62:
                    break;
                  default:
                    error("JBIG2 error: segment type " + header.typeName + "(" + header.type + ") is not implemented");
                }
                var callbackName = "on" + header.typeName;
                callbackName in visitor && visitor[callbackName].apply(visitor, args);
              }
              function processSegments(segments, visitor) {
                for (var i = 0, ii = segments.length; i < ii; i++) processSegment(segments[i], visitor);
              }
              function parseJbig2Chunks(chunks) {
                for (var visitor = new SimpleSegmentVisitor(), i = 0, ii = chunks.length; i < ii; i++) {
                  var chunk = chunks[i];
                  processSegments(readSegments({}, chunk.data, chunk.start, chunk.end), visitor);
                }
                return visitor.buffer;
              }
              function SimpleSegmentVisitor() {}
              function Jbig2Image() {}
              (ContextCache.prototype = {
                getContexts: function (id) {
                  return id in this ? this[id] : (this[id] = new Int8Array(65536));
                },
              }),
                (DecodingContext.prototype = {
                  get decoder() {
                    var decoder = new ArithmeticDecoder(this.data, this.start, this.end);
                    return shadow(this, "decoder", decoder);
                  },
                  get contextCache() {
                    var cache = new ContextCache();
                    return shadow(this, "contextCache", cache);
                  },
                });
              var SegmentTypes = [
                  "SymbolDictionary",
                  null,
                  null,
                  null,
                  "IntermediateTextRegion",
                  null,
                  "ImmediateTextRegion",
                  "ImmediateLosslessTextRegion",
                  null,
                  null,
                  null,
                  null,
                  null,
                  null,
                  null,
                  null,
                  "patternDictionary",
                  null,
                  null,
                  null,
                  "IntermediateHalftoneRegion",
                  null,
                  "ImmediateHalftoneRegion",
                  "ImmediateLosslessHalftoneRegion",
                  null,
                  null,
                  null,
                  null,
                  null,
                  null,
                  null,
                  null,
                  null,
                  null,
                  null,
                  null,
                  "IntermediateGenericRegion",
                  null,
                  "ImmediateGenericRegion",
                  "ImmediateLosslessGenericRegion",
                  "IntermediateGenericRefinementRegion",
                  null,
                  "ImmediateGenericRefinementRegion",
                  "ImmediateLosslessGenericRefinementRegion",
                  null,
                  null,
                  null,
                  null,
                  "PageInformation",
                  "EndOfPage",
                  "EndOfStripe",
                  "EndOfFile",
                  "Profiles",
                  "Tables",
                  null,
                  null,
                  null,
                  null,
                  null,
                  null,
                  null,
                  null,
                  "Extension",
                ],
                CodingTemplates = [
                  [
                    { x: -1, y: -2 },
                    { x: 0, y: -2 },
                    { x: 1, y: -2 },
                    { x: -2, y: -1 },
                    { x: -1, y: -1 },
                    { x: 0, y: -1 },
                    { x: 1, y: -1 },
                    { x: 2, y: -1 },
                    { x: -4, y: 0 },
                    { x: -3, y: 0 },
                    { x: -2, y: 0 },
                    { x: -1, y: 0 },
                  ],
                  [
                    { x: -1, y: -2 },
                    { x: 0, y: -2 },
                    { x: 1, y: -2 },
                    { x: 2, y: -2 },
                    { x: -2, y: -1 },
                    { x: -1, y: -1 },
                    { x: 0, y: -1 },
                    { x: 1, y: -1 },
                    { x: 2, y: -1 },
                    { x: -3, y: 0 },
                    { x: -2, y: 0 },
                    { x: -1, y: 0 },
                  ],
                  [
                    { x: -1, y: -2 },
                    { x: 0, y: -2 },
                    { x: 1, y: -2 },
                    { x: -2, y: -1 },
                    { x: -1, y: -1 },
                    { x: 0, y: -1 },
                    { x: 1, y: -1 },
                    { x: -2, y: 0 },
                    { x: -1, y: 0 },
                  ],
                  [
                    { x: -3, y: -1 },
                    { x: -2, y: -1 },
                    { x: -1, y: -1 },
                    { x: 0, y: -1 },
                    { x: 1, y: -1 },
                    { x: -4, y: 0 },
                    { x: -3, y: 0 },
                    { x: -2, y: 0 },
                    { x: -1, y: 0 },
                  ],
                ],
                RefinementTemplates = [
                  {
                    coding: [
                      { x: 0, y: -1 },
                      { x: 1, y: -1 },
                      { x: -1, y: 0 },
                    ],
                    reference: [
                      { x: 0, y: -1 },
                      { x: 1, y: -1 },
                      { x: -1, y: 0 },
                      { x: 0, y: 0 },
                      { x: 1, y: 0 },
                      { x: -1, y: 1 },
                      { x: 0, y: 1 },
                      { x: 1, y: 1 },
                    ],
                  },
                  {
                    coding: [
                      { x: -1, y: -1 },
                      { x: 0, y: -1 },
                      { x: 1, y: -1 },
                      { x: -1, y: 0 },
                    ],
                    reference: [
                      { x: 0, y: -1 },
                      { x: -1, y: 0 },
                      { x: 0, y: 0 },
                      { x: 1, y: 0 },
                      { x: 0, y: 1 },
                      { x: 1, y: 1 },
                    ],
                  },
                ],
                ReusedContexts = [39717, 1941, 229, 405],
                RefinementReusedContexts = [32, 8],
                RegionSegmentInformationFieldLength = 17;
              return (
                (SimpleSegmentVisitor.prototype = {
                  onPageInformation: function (info) {
                    this.currentPageInfo = info;
                    var rowSize = (info.width + 7) >> 3,
                      buffer = new Uint8Array(rowSize * info.height);
                    if (info.defaultPixelValue) for (var i = 0, ii = buffer.length; i < ii; i++) buffer[i] = 255;
                    this.buffer = buffer;
                  },
                  drawBitmap: function (regionInfo, bitmap) {
                    var i,
                      j,
                      mask,
                      offset,
                      pageInfo = this.currentPageInfo,
                      width = regionInfo.width,
                      height = regionInfo.height,
                      rowSize = (pageInfo.width + 7) >> 3,
                      combinationOperator = pageInfo.combinationOperatorOverride
                        ? regionInfo.combinationOperator
                        : pageInfo.combinationOperator,
                      buffer = this.buffer,
                      mask0 = 128 >> (7 & regionInfo.x),
                      offset0 = regionInfo.y * rowSize + (regionInfo.x >> 3);
                    switch (combinationOperator) {
                      case 0:
                        for (i = 0; i < height; i++) {
                          for (mask = mask0, offset = offset0, j = 0; j < width; j++)
                            bitmap[i][j] && (buffer[offset] |= mask), (mask >>= 1) || ((mask = 128), offset++);
                          offset0 += rowSize;
                        }
                        break;
                      case 2:
                        for (i = 0; i < height; i++) {
                          for (mask = mask0, offset = offset0, j = 0; j < width; j++)
                            bitmap[i][j] && (buffer[offset] ^= mask), (mask >>= 1) || ((mask = 128), offset++);
                          offset0 += rowSize;
                        }
                        break;
                      default:
                        error("JBIG2 error: operator " + combinationOperator + " is not supported");
                    }
                  },
                  onImmediateGenericRegion: function (region, data, start, end) {
                    var regionInfo = region.info,
                      decodingContext = new DecodingContext(data, start, end),
                      bitmap = decodeBitmap(
                        region.mmr,
                        regionInfo.width,
                        regionInfo.height,
                        region.template,
                        region.prediction,
                        null,
                        region.at,
                        decodingContext
                      );
                    this.drawBitmap(regionInfo, bitmap);
                  },
                  onImmediateLosslessGenericRegion: function () {
                    this.onImmediateGenericRegion.apply(this, arguments);
                  },
                  onSymbolDictionary: function (dictionary, currentSegment, referredSegments, data, start, end) {
                    dictionary.huffman && error("JBIG2 error: huffman is not supported");
                    var symbols = this.symbols;
                    symbols || (this.symbols = symbols = {});
                    for (var inputSymbols = [], i = 0, ii = referredSegments.length; i < ii; i++)
                      inputSymbols = inputSymbols.concat(symbols[referredSegments[i]]);
                    var decodingContext = new DecodingContext(data, start, end);
                    symbols[currentSegment] = decodeSymbolDictionary(
                      dictionary.huffman,
                      dictionary.refinement,
                      inputSymbols,
                      dictionary.numberOfNewSymbols,
                      dictionary.numberOfExportedSymbols,
                      void 0,
                      dictionary.template,
                      dictionary.at,
                      dictionary.refinementTemplate,
                      dictionary.refinementAt,
                      decodingContext
                    );
                  },
                  onImmediateTextRegion: function (region, referredSegments, data, start, end) {
                    for (
                      var regionInfo = region.info,
                        symbols = this.symbols,
                        inputSymbols = [],
                        i = 0,
                        ii = referredSegments.length;
                      i < ii;
                      i++
                    )
                      inputSymbols = inputSymbols.concat(symbols[referredSegments[i]]);
                    var symbolCodeLength = log2(inputSymbols.length),
                      decodingContext = new DecodingContext(data, start, end),
                      bitmap = decodeTextRegion(
                        region.huffman,
                        region.refinement,
                        regionInfo.width,
                        regionInfo.height,
                        region.defaultPixelValue,
                        region.numberOfSymbolInstances,
                        region.stripSize,
                        inputSymbols,
                        symbolCodeLength,
                        region.transposed,
                        region.dsOffset,
                        region.referenceCorner,
                        region.combinationOperator,
                        void 0,
                        region.refinementTemplate,
                        region.refinementAt,
                        decodingContext
                      );
                    this.drawBitmap(regionInfo, bitmap);
                  },
                  onImmediateLosslessTextRegion: function () {
                    this.onImmediateTextRegion.apply(this, arguments);
                  },
                }),
                (Jbig2Image.prototype = {
                  parseChunks: function (chunks) {
                    return parseJbig2Chunks(chunks);
                  },
                }),
                Jbig2Image
              );
            })();
          exports.Jbig2Image = Jbig2Image;
        })((root.pdfjsCoreJbig2 = {}), root.pdfjsSharedUtil, root.pdfjsCoreArithmeticDecoder);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil) {
          var error = sharedUtil.error,
            JpegImage = (function () {
              function JpegImage() {
                (this.decodeTransform = null), (this.colorTransform = -1);
              }
              function buildHuffmanTable(codeLengths, values) {
                for (var i, j, k = 0, code = [], length = 16; length > 0 && !codeLengths[length - 1]; ) length--;
                code.push({ children: [], index: 0 });
                var q,
                  p = code[0];
                for (i = 0; i < length; i++) {
                  for (j = 0; j < codeLengths[i]; j++) {
                    for (p = code.pop(), p.children[p.index] = values[k]; p.index > 0; ) p = code.pop();
                    for (p.index++, code.push(p); code.length <= i; )
                      code.push((q = { children: [], index: 0 })), (p.children[p.index] = q.children), (p = q);
                    k++;
                  }
                  i + 1 < length &&
                    (code.push((q = { children: [], index: 0 })), (p.children[p.index] = q.children), (p = q));
                }
                return code[0].children;
              }
              function getBlockBufferOffset(component, row, col) {
                return 64 * ((component.blocksPerLine + 1) * row + col);
              }
              function decodeScan(
                data,
                offset,
                frame,
                components,
                resetInterval,
                spectralStart,
                spectralEnd,
                successivePrev,
                successive
              ) {
                function readBit() {
                  if (bitsCount > 0) return bitsCount--, (bitsData >> bitsCount) & 1;
                  if (255 === (bitsData = data[offset++])) {
                    var nextByte = data[offset++];
                    nextByte && error("JPEG error: unexpected marker " + ((bitsData << 8) | nextByte).toString(16));
                  }
                  return (bitsCount = 7), bitsData >>> 7;
                }
                function decodeHuffman(tree) {
                  for (var node = tree; ; ) {
                    if ("number" == typeof (node = node[readBit()])) return node;
                    "object" != typeof node && error("JPEG error: invalid huffman sequence");
                  }
                }
                function receive(length) {
                  for (var n = 0; length > 0; ) (n = (n << 1) | readBit()), length--;
                  return n;
                }
                function receiveAndExtend(length) {
                  if (1 === length) return 1 === readBit() ? 1 : -1;
                  var n = receive(length);
                  return n >= 1 << (length - 1) ? n : n + (-1 << length) + 1;
                }
                function decodeBaseline(component, offset) {
                  var t = decodeHuffman(component.huffmanTableDC),
                    diff = 0 === t ? 0 : receiveAndExtend(t);
                  component.blockData[offset] = component.pred += diff;
                  for (var k = 1; k < 64; ) {
                    var rs = decodeHuffman(component.huffmanTableAC),
                      s = 15 & rs,
                      r = rs >> 4;
                    if (0 !== s) {
                      k += r;
                      var z = dctZigZag[k];
                      (component.blockData[offset + z] = receiveAndExtend(s)), k++;
                    } else {
                      if (r < 15) break;
                      k += 16;
                    }
                  }
                }
                function decodeDCFirst(component, offset) {
                  var t = decodeHuffman(component.huffmanTableDC),
                    diff = 0 === t ? 0 : receiveAndExtend(t) << successive;
                  component.blockData[offset] = component.pred += diff;
                }
                function decodeDCSuccessive(component, offset) {
                  component.blockData[offset] |= readBit() << successive;
                }
                function decodeACFirst(component, offset) {
                  if (eobrun > 0) return void eobrun--;
                  for (var k = spectralStart, e = spectralEnd; k <= e; ) {
                    var rs = decodeHuffman(component.huffmanTableAC),
                      s = 15 & rs,
                      r = rs >> 4;
                    if (0 !== s) {
                      k += r;
                      var z = dctZigZag[k];
                      (component.blockData[offset + z] = receiveAndExtend(s) * (1 << successive)), k++;
                    } else {
                      if (r < 15) {
                        eobrun = receive(r) + (1 << r) - 1;
                        break;
                      }
                      k += 16;
                    }
                  }
                }
                function decodeACSuccessive(component, offset) {
                  for (var s, rs, k = spectralStart, e = spectralEnd, r = 0; k <= e; ) {
                    var z = dctZigZag[k];
                    switch (successiveACState) {
                      case 0:
                        (rs = decodeHuffman(component.huffmanTableAC)),
                          (s = 15 & rs),
                          (r = rs >> 4),
                          0 === s
                            ? r < 15
                              ? ((eobrun = receive(r) + (1 << r)), (successiveACState = 4))
                              : ((r = 16), (successiveACState = 1))
                            : (1 !== s && error("JPEG error: invalid ACn encoding"),
                              (successiveACNextValue = receiveAndExtend(s)),
                              (successiveACState = r ? 2 : 3));
                        continue;
                      case 1:
                      case 2:
                        component.blockData[offset + z]
                          ? (component.blockData[offset + z] += readBit() << successive)
                          : 0 === --r && (successiveACState = 2 === successiveACState ? 3 : 0);
                        break;
                      case 3:
                        component.blockData[offset + z]
                          ? (component.blockData[offset + z] += readBit() << successive)
                          : ((component.blockData[offset + z] = successiveACNextValue << successive),
                            (successiveACState = 0));
                        break;
                      case 4:
                        component.blockData[offset + z] && (component.blockData[offset + z] += readBit() << successive);
                    }
                    k++;
                  }
                  4 === successiveACState && 0 === --eobrun && (successiveACState = 0);
                }
                var successiveACNextValue,
                  component,
                  i,
                  j,
                  k,
                  n,
                  decodeFn,
                  mcusPerLine = frame.mcusPerLine,
                  progressive = frame.progressive,
                  startOffset = offset,
                  bitsData = 0,
                  bitsCount = 0,
                  eobrun = 0,
                  successiveACState = 0,
                  componentsLength = components.length;
                decodeFn = progressive
                  ? 0 === spectralStart
                    ? 0 === successivePrev
                      ? decodeDCFirst
                      : decodeDCSuccessive
                    : 0 === successivePrev
                    ? decodeACFirst
                    : decodeACSuccessive
                  : decodeBaseline;
                var marker,
                  mcuExpected,
                  mcu = 0;
                (mcuExpected =
                  1 === componentsLength
                    ? components[0].blocksPerLine * components[0].blocksPerColumn
                    : mcusPerLine * frame.mcusPerColumn),
                  resetInterval || (resetInterval = mcuExpected);
                for (var h, v; mcu < mcuExpected; ) {
                  for (i = 0; i < componentsLength; i++) components[i].pred = 0;
                  if (((eobrun = 0), 1 === componentsLength))
                    for (component = components[0], n = 0; n < resetInterval; n++)
                      !(function (component, decode, mcu) {
                        decode(
                          component,
                          getBlockBufferOffset(
                            component,
                            (mcu / component.blocksPerLine) | 0,
                            mcu % component.blocksPerLine
                          )
                        );
                      })(component, decodeFn, mcu),
                        mcu++;
                  else
                    for (n = 0; n < resetInterval; n++) {
                      for (i = 0; i < componentsLength; i++)
                        for (component = components[i], h = component.h, v = component.v, j = 0; j < v; j++)
                          for (k = 0; k < h; k++)
                            !(function (component, decode, mcu, row, col) {
                              var mcuRow = (mcu / mcusPerLine) | 0,
                                mcuCol = mcu % mcusPerLine;
                              decode(
                                component,
                                getBlockBufferOffset(component, mcuRow * component.v + row, mcuCol * component.h + col)
                              );
                            })(component, decodeFn, mcu, j, k);
                      mcu++;
                    }
                  for (
                    bitsCount = 0, marker = (data[offset] << 8) | data[offset + 1];
                    0 === data[offset] && offset < data.length - 1;

                  )
                    offset++, (marker = (data[offset] << 8) | data[offset + 1]);
                  if (
                    (marker <= 65280 && error("JPEG error: marker was not found"),
                    !(marker >= 65488 && marker <= 65495))
                  )
                    break;
                  offset += 2;
                }
                return offset - startOffset;
              }
              function quantizeAndInverse(component, blockBufferOffset, p) {
                var v0,
                  v1,
                  v2,
                  v3,
                  v4,
                  v5,
                  v6,
                  v7,
                  p0,
                  p1,
                  p2,
                  p3,
                  p4,
                  p5,
                  p6,
                  p7,
                  t,
                  qt = component.quantizationTable,
                  blockData = component.blockData;
                qt || error("JPEG error: missing required Quantization Table.");
                for (var row = 0; row < 64; row += 8)
                  (p0 = blockData[blockBufferOffset + row]),
                    (p1 = blockData[blockBufferOffset + row + 1]),
                    (p2 = blockData[blockBufferOffset + row + 2]),
                    (p3 = blockData[blockBufferOffset + row + 3]),
                    (p4 = blockData[blockBufferOffset + row + 4]),
                    (p5 = blockData[blockBufferOffset + row + 5]),
                    (p6 = blockData[blockBufferOffset + row + 6]),
                    (p7 = blockData[blockBufferOffset + row + 7]),
                    (p0 *= qt[row]),
                    0 != (p1 | p2 | p3 | p4 | p5 | p6 | p7)
                      ? ((p1 *= qt[row + 1]),
                        (p2 *= qt[row + 2]),
                        (p3 *= qt[row + 3]),
                        (p4 *= qt[row + 4]),
                        (p5 *= qt[row + 5]),
                        (p6 *= qt[row + 6]),
                        (p7 *= qt[row + 7]),
                        (v0 = (dctSqrt2 * p0 + 128) >> 8),
                        (v1 = (dctSqrt2 * p4 + 128) >> 8),
                        (v2 = p2),
                        (v3 = p6),
                        (v4 = (dctSqrt1d2 * (p1 - p7) + 128) >> 8),
                        (v7 = (dctSqrt1d2 * (p1 + p7) + 128) >> 8),
                        (v5 = p3 << 4),
                        (v6 = p5 << 4),
                        (v0 = (v0 + v1 + 1) >> 1),
                        (v1 = v0 - v1),
                        (t = (v2 * dctSin6 + v3 * dctCos6 + 128) >> 8),
                        (v2 = (v2 * dctCos6 - v3 * dctSin6 + 128) >> 8),
                        (v3 = t),
                        (v4 = (v4 + v6 + 1) >> 1),
                        (v6 = v4 - v6),
                        (v7 = (v7 + v5 + 1) >> 1),
                        (v5 = v7 - v5),
                        (v0 = (v0 + v3 + 1) >> 1),
                        (v3 = v0 - v3),
                        (v1 = (v1 + v2 + 1) >> 1),
                        (v2 = v1 - v2),
                        (t = (v4 * dctSin3 + v7 * dctCos3 + 2048) >> 12),
                        (v4 = (v4 * dctCos3 - v7 * dctSin3 + 2048) >> 12),
                        (v7 = t),
                        (t = (v5 * dctSin1 + v6 * dctCos1 + 2048) >> 12),
                        (v5 = (v5 * dctCos1 - v6 * dctSin1 + 2048) >> 12),
                        (v6 = t),
                        (p[row] = v0 + v7),
                        (p[row + 7] = v0 - v7),
                        (p[row + 1] = v1 + v6),
                        (p[row + 6] = v1 - v6),
                        (p[row + 2] = v2 + v5),
                        (p[row + 5] = v2 - v5),
                        (p[row + 3] = v3 + v4),
                        (p[row + 4] = v3 - v4))
                      : ((t = (dctSqrt2 * p0 + 512) >> 10),
                        (p[row] = t),
                        (p[row + 1] = t),
                        (p[row + 2] = t),
                        (p[row + 3] = t),
                        (p[row + 4] = t),
                        (p[row + 5] = t),
                        (p[row + 6] = t),
                        (p[row + 7] = t));
                for (var col = 0; col < 8; ++col)
                  (p0 = p[col]),
                    (p1 = p[col + 8]),
                    (p2 = p[col + 16]),
                    (p3 = p[col + 24]),
                    (p4 = p[col + 32]),
                    (p5 = p[col + 40]),
                    (p6 = p[col + 48]),
                    (p7 = p[col + 56]),
                    0 != (p1 | p2 | p3 | p4 | p5 | p6 | p7)
                      ? ((v0 = (dctSqrt2 * p0 + 2048) >> 12),
                        (v1 = (dctSqrt2 * p4 + 2048) >> 12),
                        (v2 = p2),
                        (v3 = p6),
                        (v4 = (dctSqrt1d2 * (p1 - p7) + 2048) >> 12),
                        (v7 = (dctSqrt1d2 * (p1 + p7) + 2048) >> 12),
                        (v5 = p3),
                        (v6 = p5),
                        (v0 = 4112 + ((v0 + v1 + 1) >> 1)),
                        (v1 = v0 - v1),
                        (t = (v2 * dctSin6 + v3 * dctCos6 + 2048) >> 12),
                        (v2 = (v2 * dctCos6 - v3 * dctSin6 + 2048) >> 12),
                        (v3 = t),
                        (v4 = (v4 + v6 + 1) >> 1),
                        (v6 = v4 - v6),
                        (v7 = (v7 + v5 + 1) >> 1),
                        (v5 = v7 - v5),
                        (v0 = (v0 + v3 + 1) >> 1),
                        (v3 = v0 - v3),
                        (v1 = (v1 + v2 + 1) >> 1),
                        (v2 = v1 - v2),
                        (t = (v4 * dctSin3 + v7 * dctCos3 + 2048) >> 12),
                        (v4 = (v4 * dctCos3 - v7 * dctSin3 + 2048) >> 12),
                        (v7 = t),
                        (t = (v5 * dctSin1 + v6 * dctCos1 + 2048) >> 12),
                        (v5 = (v5 * dctCos1 - v6 * dctSin1 + 2048) >> 12),
                        (v6 = t),
                        (p0 = v0 + v7),
                        (p7 = v0 - v7),
                        (p1 = v1 + v6),
                        (p6 = v1 - v6),
                        (p2 = v2 + v5),
                        (p5 = v2 - v5),
                        (p3 = v3 + v4),
                        (p4 = v3 - v4),
                        (p0 = p0 < 16 ? 0 : p0 >= 4080 ? 255 : p0 >> 4),
                        (p1 = p1 < 16 ? 0 : p1 >= 4080 ? 255 : p1 >> 4),
                        (p2 = p2 < 16 ? 0 : p2 >= 4080 ? 255 : p2 >> 4),
                        (p3 = p3 < 16 ? 0 : p3 >= 4080 ? 255 : p3 >> 4),
                        (p4 = p4 < 16 ? 0 : p4 >= 4080 ? 255 : p4 >> 4),
                        (p5 = p5 < 16 ? 0 : p5 >= 4080 ? 255 : p5 >> 4),
                        (p6 = p6 < 16 ? 0 : p6 >= 4080 ? 255 : p6 >> 4),
                        (p7 = p7 < 16 ? 0 : p7 >= 4080 ? 255 : p7 >> 4),
                        (blockData[blockBufferOffset + col] = p0),
                        (blockData[blockBufferOffset + col + 8] = p1),
                        (blockData[blockBufferOffset + col + 16] = p2),
                        (blockData[blockBufferOffset + col + 24] = p3),
                        (blockData[blockBufferOffset + col + 32] = p4),
                        (blockData[blockBufferOffset + col + 40] = p5),
                        (blockData[blockBufferOffset + col + 48] = p6),
                        (blockData[blockBufferOffset + col + 56] = p7))
                      : ((t = (dctSqrt2 * p0 + 8192) >> 14),
                        (t = t < -2040 ? 0 : t >= 2024 ? 255 : (t + 2056) >> 4),
                        (blockData[blockBufferOffset + col] = t),
                        (blockData[blockBufferOffset + col + 8] = t),
                        (blockData[blockBufferOffset + col + 16] = t),
                        (blockData[blockBufferOffset + col + 24] = t),
                        (blockData[blockBufferOffset + col + 32] = t),
                        (blockData[blockBufferOffset + col + 40] = t),
                        (blockData[blockBufferOffset + col + 48] = t),
                        (blockData[blockBufferOffset + col + 56] = t));
              }
              function buildComponentData(frame, component) {
                for (
                  var blocksPerLine = component.blocksPerLine,
                    blocksPerColumn = component.blocksPerColumn,
                    computationBuffer = new Int16Array(64),
                    blockRow = 0;
                  blockRow < blocksPerColumn;
                  blockRow++
                )
                  for (var blockCol = 0; blockCol < blocksPerLine; blockCol++) {
                    var offset = getBlockBufferOffset(component, blockRow, blockCol);
                    quantizeAndInverse(component, offset, computationBuffer);
                  }
                return component.blockData;
              }
              function clamp0to255(a) {
                return a <= 0 ? 0 : a >= 255 ? 255 : a;
              }
              var dctZigZag = new Uint8Array([
                  0,
                  1,
                  8,
                  16,
                  9,
                  2,
                  3,
                  10,
                  17,
                  24,
                  32,
                  25,
                  18,
                  11,
                  4,
                  5,
                  12,
                  19,
                  26,
                  33,
                  40,
                  48,
                  41,
                  34,
                  27,
                  20,
                  13,
                  6,
                  7,
                  14,
                  21,
                  28,
                  35,
                  42,
                  49,
                  56,
                  57,
                  50,
                  43,
                  36,
                  29,
                  22,
                  15,
                  23,
                  30,
                  37,
                  44,
                  51,
                  58,
                  59,
                  52,
                  45,
                  38,
                  31,
                  39,
                  46,
                  53,
                  60,
                  61,
                  54,
                  47,
                  55,
                  62,
                  63,
                ]),
                dctCos1 = 4017,
                dctSin1 = 799,
                dctCos3 = 3406,
                dctSin3 = 2276,
                dctCos6 = 1567,
                dctSin6 = 3784,
                dctSqrt2 = 5793,
                dctSqrt1d2 = 2896;
              return (
                (JpegImage.prototype = {
                  parse: function (data) {
                    function readUint16() {
                      var value = (data[offset] << 8) | data[offset + 1];
                      return (offset += 2), value;
                    }
                    var frame,
                      resetInterval,
                      offset = 0,
                      jfif = null,
                      adobe = null,
                      quantizationTables = [],
                      huffmanTablesAC = [],
                      huffmanTablesDC = [],
                      fileMarker = readUint16();
                    for (
                      65496 !== fileMarker && error("JPEG error: SOI not found"), fileMarker = readUint16();
                      65497 !== fileMarker;

                    ) {
                      var i, j, l;
                      switch (fileMarker) {
                        case 65504:
                        case 65505:
                        case 65506:
                        case 65507:
                        case 65508:
                        case 65509:
                        case 65510:
                        case 65511:
                        case 65512:
                        case 65513:
                        case 65514:
                        case 65515:
                        case 65516:
                        case 65517:
                        case 65518:
                        case 65519:
                        case 65534:
                          var appData = (function () {
                            var length = readUint16(),
                              array = data.subarray(offset, offset + length - 2);
                            return (offset += array.length), array;
                          })();
                          65504 === fileMarker &&
                            74 === appData[0] &&
                            70 === appData[1] &&
                            73 === appData[2] &&
                            70 === appData[3] &&
                            0 === appData[4] &&
                            (jfif = {
                              version: { major: appData[5], minor: appData[6] },
                              densityUnits: appData[7],
                              xDensity: (appData[8] << 8) | appData[9],
                              yDensity: (appData[10] << 8) | appData[11],
                              thumbWidth: appData[12],
                              thumbHeight: appData[13],
                              thumbData: appData.subarray(14, 14 + 3 * appData[12] * appData[13]),
                            }),
                            65518 === fileMarker &&
                              65 === appData[0] &&
                              100 === appData[1] &&
                              111 === appData[2] &&
                              98 === appData[3] &&
                              101 === appData[4] &&
                              (adobe = {
                                version: (appData[5] << 8) | appData[6],
                                flags0: (appData[7] << 8) | appData[8],
                                flags1: (appData[9] << 8) | appData[10],
                                transformCode: appData[11],
                              });
                          break;
                        case 65499:
                          for (
                            var z,
                              quantizationTablesLength = readUint16(),
                              quantizationTablesEnd = quantizationTablesLength + offset - 2;
                            offset < quantizationTablesEnd;

                          ) {
                            var quantizationTableSpec = data[offset++],
                              tableData = new Uint16Array(64);
                            if (quantizationTableSpec >> 4 == 0)
                              for (j = 0; j < 64; j++) (z = dctZigZag[j]), (tableData[z] = data[offset++]);
                            else if (quantizationTableSpec >> 4 == 1)
                              for (j = 0; j < 64; j++) (z = dctZigZag[j]), (tableData[z] = readUint16());
                            else error("JPEG error: DQT - invalid table spec");
                            quantizationTables[15 & quantizationTableSpec] = tableData;
                          }
                          break;
                        case 65472:
                        case 65473:
                        case 65474:
                          frame && error("JPEG error: Only single frame JPEGs supported"),
                            readUint16(),
                            (frame = {}),
                            (frame.extended = 65473 === fileMarker),
                            (frame.progressive = 65474 === fileMarker),
                            (frame.precision = data[offset++]),
                            (frame.scanLines = readUint16()),
                            (frame.samplesPerLine = readUint16()),
                            (frame.components = []),
                            (frame.componentIds = {});
                          var componentId,
                            componentsCount = data[offset++],
                            maxH = 0,
                            maxV = 0;
                          for (i = 0; i < componentsCount; i++) {
                            componentId = data[offset];
                            var h = data[offset + 1] >> 4,
                              v = 15 & data[offset + 1];
                            maxH < h && (maxH = h), maxV < v && (maxV = v);
                            var qId = data[offset + 2];
                            (l = frame.components.push({ h: h, v: v, quantizationId: qId, quantizationTable: null })),
                              (frame.componentIds[componentId] = l - 1),
                              (offset += 3);
                          }
                          (frame.maxH = maxH),
                            (frame.maxV = maxV),
                            (function (frame) {
                              for (
                                var mcusPerLine = Math.ceil(frame.samplesPerLine / 8 / frame.maxH),
                                  mcusPerColumn = Math.ceil(frame.scanLines / 8 / frame.maxV),
                                  i = 0;
                                i < frame.components.length;
                                i++
                              ) {
                                component = frame.components[i];
                                var blocksPerLine = Math.ceil(
                                    (Math.ceil(frame.samplesPerLine / 8) * component.h) / frame.maxH
                                  ),
                                  blocksPerColumn = Math.ceil(
                                    (Math.ceil(frame.scanLines / 8) * component.v) / frame.maxV
                                  ),
                                  blocksPerLineForMcu = mcusPerLine * component.h,
                                  blocksPerColumnForMcu = mcusPerColumn * component.v,
                                  blocksBufferSize = 64 * blocksPerColumnForMcu * (blocksPerLineForMcu + 1);
                                (component.blockData = new Int16Array(blocksBufferSize)),
                                  (component.blocksPerLine = blocksPerLine),
                                  (component.blocksPerColumn = blocksPerColumn);
                              }
                              (frame.mcusPerLine = mcusPerLine), (frame.mcusPerColumn = mcusPerColumn);
                            })(frame);
                          break;
                        case 65476:
                          var huffmanLength = readUint16();
                          for (i = 2; i < huffmanLength; ) {
                            var huffmanTableSpec = data[offset++],
                              codeLengths = new Uint8Array(16),
                              codeLengthSum = 0;
                            for (j = 0; j < 16; j++, offset++) codeLengthSum += codeLengths[j] = data[offset];
                            var huffmanValues = new Uint8Array(codeLengthSum);
                            for (j = 0; j < codeLengthSum; j++, offset++) huffmanValues[j] = data[offset];
                            (i += 17 + codeLengthSum),
                              ((huffmanTableSpec >> 4 == 0 ? huffmanTablesDC : huffmanTablesAC)[
                                15 & huffmanTableSpec
                              ] = buildHuffmanTable(codeLengths, huffmanValues));
                          }
                          break;
                        case 65501:
                          readUint16(), (resetInterval = readUint16());
                          break;
                        case 65498:
                          var component,
                            selectorsCount = (readUint16(), data[offset++]),
                            components = [];
                          for (i = 0; i < selectorsCount; i++) {
                            var componentIndex = frame.componentIds[data[offset++]];
                            component = frame.components[componentIndex];
                            var tableSpec = data[offset++];
                            (component.huffmanTableDC = huffmanTablesDC[tableSpec >> 4]),
                              (component.huffmanTableAC = huffmanTablesAC[15 & tableSpec]),
                              components.push(component);
                          }
                          var spectralStart = data[offset++],
                            spectralEnd = data[offset++],
                            successiveApproximation = data[offset++],
                            processed = decodeScan(
                              data,
                              offset,
                              frame,
                              components,
                              resetInterval,
                              spectralStart,
                              spectralEnd,
                              successiveApproximation >> 4,
                              15 & successiveApproximation
                            );
                          offset += processed;
                          break;
                        case 65535:
                          255 !== data[offset] && offset--;
                          break;
                        default:
                          if (255 === data[offset - 3] && data[offset - 2] >= 192 && data[offset - 2] <= 254) {
                            offset -= 3;
                            break;
                          }
                          error("JPEG error: unknown marker " + fileMarker.toString(16));
                      }
                      fileMarker = readUint16();
                    }
                    for (
                      this.width = frame.samplesPerLine,
                        this.height = frame.scanLines,
                        this.jfif = jfif,
                        this.adobe = adobe,
                        this.components = [],
                        i = 0;
                      i < frame.components.length;
                      i++
                    ) {
                      component = frame.components[i];
                      var quantizationTable = quantizationTables[component.quantizationId];
                      quantizationTable && (component.quantizationTable = quantizationTable),
                        this.components.push({
                          output: buildComponentData(frame, component),
                          scaleX: component.h / frame.maxH,
                          scaleY: component.v / frame.maxV,
                          blocksPerLine: component.blocksPerLine,
                          blocksPerColumn: component.blocksPerColumn,
                        });
                    }
                    this.numComponents = this.components.length;
                  },
                  _getLinearizedBlockData: function (width, height) {
                    var component,
                      componentScaleX,
                      componentScaleY,
                      blocksPerScanline,
                      x,
                      y,
                      i,
                      j,
                      k,
                      index,
                      output,
                      scaleX = this.width / width,
                      scaleY = this.height / height,
                      offset = 0,
                      numComponents = this.components.length,
                      dataLength = width * height * numComponents,
                      data = new Uint8Array(dataLength),
                      xScaleBlockOffset = new Uint32Array(width);
                    for (i = 0; i < numComponents; i++) {
                      for (
                        component = this.components[i],
                          componentScaleX = component.scaleX * scaleX,
                          componentScaleY = component.scaleY * scaleY,
                          offset = i,
                          output = component.output,
                          blocksPerScanline = (component.blocksPerLine + 1) << 3,
                          x = 0;
                        x < width;
                        x++
                      )
                        (j = 0 | (x * componentScaleX)), (xScaleBlockOffset[x] = ((4294967288 & j) << 3) | (7 & j));
                      for (y = 0; y < height; y++)
                        for (
                          j = 0 | (y * componentScaleY),
                            index = (blocksPerScanline * (4294967288 & j)) | ((7 & j) << 3),
                            x = 0;
                          x < width;
                          x++
                        )
                          (data[offset] = output[index + xScaleBlockOffset[x]]), (offset += numComponents);
                    }
                    var transform = this.decodeTransform;
                    if (transform)
                      for (i = 0; i < dataLength; )
                        for (j = 0, k = 0; j < numComponents; j++, i++, k += 2)
                          data[i] = ((data[i] * transform[k]) >> 8) + transform[k + 1];
                    return data;
                  },
                  _isColorConversionNeeded: function () {
                    return (
                      !(!this.adobe || !this.adobe.transformCode) ||
                      (3 === this.numComponents
                        ? !(!this.adobe && 0 === this.colorTransform)
                        : !this.adobe && 1 === this.colorTransform)
                    );
                  },
                  _convertYccToRgb: function (data) {
                    for (var Y, Cb, Cr, i = 0, length = data.length; i < length; i += 3)
                      (Y = data[i]),
                        (Cb = data[i + 1]),
                        (Cr = data[i + 2]),
                        (data[i] = clamp0to255(Y - 179.456 + 1.402 * Cr)),
                        (data[i + 1] = clamp0to255(Y + 135.459 - 0.344 * Cb - 0.714 * Cr)),
                        (data[i + 2] = clamp0to255(Y - 226.816 + 1.772 * Cb));
                    return data;
                  },
                  _convertYcckToRgb: function (data) {
                    for (var Y, Cb, Cr, k, offset = 0, i = 0, length = data.length; i < length; i += 4) {
                      (Y = data[i]), (Cb = data[i + 1]), (Cr = data[i + 2]), (k = data[i + 3]);
                      var r =
                          Cb *
                            (-660635669420364e-19 * Cb +
                              0.000437130475926232 * Cr -
                              54080610064599e-18 * Y +
                              0.00048449797120281 * k -
                              0.154362151871126) -
                          122.67195406894 +
                          Cr *
                            (-0.000957964378445773 * Cr +
                              0.000817076911346625 * Y -
                              0.00477271405408747 * k +
                              1.53380253221734) +
                          Y * (0.000961250184130688 * Y - 0.00266257332283933 * k + 0.48357088451265) +
                          k * (-0.000336197177618394 * k + 0.484791561490776),
                        g =
                          107.268039397724 +
                          Cb *
                            (219927104525741e-19 * Cb -
                              0.000640992018297945 * Cr +
                              0.000659397001245577 * Y +
                              0.000426105652938837 * k -
                              0.176491792462875) +
                          Cr *
                            (-0.000778269941513683 * Cr +
                              0.00130872261408275 * Y +
                              0.000770482631801132 * k -
                              0.151051492775562) +
                          Y * (0.00126935368114843 * Y - 0.00265090189010898 * k + 0.25802910206845) +
                          k * (-0.000318913117588328 * k - 0.213742400323665),
                        b =
                          Cb *
                            (-0.000570115196973677 * Cb -
                              263409051004589e-19 * Cr +
                              0.0020741088115012 * Y -
                              0.00288260236853442 * k +
                              0.814272968359295) -
                          20.810012546947 +
                          Cr *
                            (-153496057440975e-19 * Cr -
                              0.000132689043961446 * Y +
                              0.000560833691242812 * k -
                              0.195152027534049) +
                          Y * (0.00174418132927582 * Y - 0.00255243321439347 * k + 0.116935020465145) +
                          k * (-0.000343531996510555 * k + 0.24165260232407);
                      (data[offset++] = clamp0to255(r)),
                        (data[offset++] = clamp0to255(g)),
                        (data[offset++] = clamp0to255(b));
                    }
                    return data;
                  },
                  _convertYcckToCmyk: function (data) {
                    for (var Y, Cb, Cr, i = 0, length = data.length; i < length; i += 4)
                      (Y = data[i]),
                        (Cb = data[i + 1]),
                        (Cr = data[i + 2]),
                        (data[i] = clamp0to255(434.456 - Y - 1.402 * Cr)),
                        (data[i + 1] = clamp0to255(119.541 - Y + 0.344 * Cb + 0.714 * Cr)),
                        (data[i + 2] = clamp0to255(481.816 - Y - 1.772 * Cb));
                    return data;
                  },
                  _convertCmykToRgb: function (data) {
                    for (var c, m, y, k, offset = 0, min = -16581375, i = 0, length = data.length; i < length; i += 4) {
                      (c = data[i]), (m = data[i + 1]), (y = data[i + 2]), (k = data[i + 3]);
                      var r =
                          c *
                            (-4.387332384609988 * c +
                              54.48615194189176 * m +
                              18.82290502165302 * y +
                              212.25662451639585 * k -
                              72734.4411664936) +
                          m *
                            (1.7149763477362134 * m -
                              5.6096736904047315 * y -
                              17.873870861415444 * k -
                              1401.7366389350734) +
                          y * (-2.5217340131683033 * y - 21.248923337353073 * k + 4465.541406466231) -
                          k * (21.86122147463605 * k + 48317.86113160301),
                        g =
                          c *
                            (8.841041422036149 * c +
                              60.118027045597366 * m +
                              6.871425592049007 * y +
                              31.159100130055922 * k -
                              20220.756542821975) +
                          m *
                            (-15.310361306967817 * m +
                              17.575251261109482 * y +
                              131.35250912493976 * k -
                              48691.05921601825) +
                          y * (4.444339102852739 * y + 9.8632861493405 * k - 6341.191035517494) -
                          k * (20.737325471181034 * k + 47890.15695978492),
                        b =
                          c *
                            (0.8842522430003296 * c +
                              8.078677503112928 * m +
                              30.89978309703729 * y -
                              0.23883238689178934 * k -
                              3616.812083916688) +
                          m *
                            (10.49593273432072 * m +
                              63.02378494754052 * y +
                              50.606957656360734 * k -
                              28620.90484698408) +
                          y * (0.03296041114873217 * y + 115.60384449646641 * k - 49363.43385999684) -
                          k * (22.33816807309886 * k + 45932.16563550634);
                      (data[offset++] = r >= 0 ? 255 : r <= min ? 0 : (255 + r * (1 / 255 / 255)) | 0),
                        (data[offset++] = g >= 0 ? 255 : g <= min ? 0 : (255 + g * (1 / 255 / 255)) | 0),
                        (data[offset++] = b >= 0 ? 255 : b <= min ? 0 : (255 + b * (1 / 255 / 255)) | 0);
                    }
                    return data;
                  },
                  getData: function (width, height, forceRGBoutput) {
                    this.numComponents > 4 && error("JPEG error: Unsupported color mode");
                    var data = this._getLinearizedBlockData(width, height);
                    if (1 === this.numComponents && forceRGBoutput) {
                      for (
                        var dataLength = data.length, rgbData = new Uint8Array(3 * dataLength), offset = 0, i = 0;
                        i < dataLength;
                        i++
                      ) {
                        var grayColor = data[i];
                        (rgbData[offset++] = grayColor),
                          (rgbData[offset++] = grayColor),
                          (rgbData[offset++] = grayColor);
                      }
                      return rgbData;
                    }
                    if (3 === this.numComponents && this._isColorConversionNeeded()) return this._convertYccToRgb(data);
                    if (4 === this.numComponents) {
                      if (this._isColorConversionNeeded())
                        return forceRGBoutput ? this._convertYcckToRgb(data) : this._convertYcckToCmyk(data);
                      if (forceRGBoutput) return this._convertCmykToRgb(data);
                    }
                    return data;
                  },
                }),
                JpegImage
              );
            })();
          exports.JpegImage = JpegImage;
        })((root.pdfjsCoreJpg = {}), root.pdfjsSharedUtil);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, coreArithmeticDecoder) {
          var info = sharedUtil.info,
            warn = sharedUtil.warn,
            error = sharedUtil.error,
            log2 = sharedUtil.log2,
            readUint16 = sharedUtil.readUint16,
            readUint32 = sharedUtil.readUint32,
            ArithmeticDecoder = coreArithmeticDecoder.ArithmeticDecoder,
            JpxImage = (function () {
              function JpxImage() {
                this.failOnCorruptedImage = !1;
              }
              function calculateComponentDimensions(component, siz) {
                (component.x0 = Math.ceil(siz.XOsiz / component.XRsiz)),
                  (component.x1 = Math.ceil(siz.Xsiz / component.XRsiz)),
                  (component.y0 = Math.ceil(siz.YOsiz / component.YRsiz)),
                  (component.y1 = Math.ceil(siz.Ysiz / component.YRsiz)),
                  (component.width = component.x1 - component.x0),
                  (component.height = component.y1 - component.y0);
              }
              function calculateTileGrids(context, components) {
                for (
                  var tile,
                    siz = context.SIZ,
                    tiles = [],
                    numXtiles = Math.ceil((siz.Xsiz - siz.XTOsiz) / siz.XTsiz),
                    numYtiles = Math.ceil((siz.Ysiz - siz.YTOsiz) / siz.YTsiz),
                    q = 0;
                  q < numYtiles;
                  q++
                )
                  for (var p = 0; p < numXtiles; p++)
                    (tile = {}),
                      (tile.tx0 = Math.max(siz.XTOsiz + p * siz.XTsiz, siz.XOsiz)),
                      (tile.ty0 = Math.max(siz.YTOsiz + q * siz.YTsiz, siz.YOsiz)),
                      (tile.tx1 = Math.min(siz.XTOsiz + (p + 1) * siz.XTsiz, siz.Xsiz)),
                      (tile.ty1 = Math.min(siz.YTOsiz + (q + 1) * siz.YTsiz, siz.Ysiz)),
                      (tile.width = tile.tx1 - tile.tx0),
                      (tile.height = tile.ty1 - tile.ty0),
                      (tile.components = []),
                      tiles.push(tile);
                context.tiles = tiles;
                for (var componentsCount = siz.Csiz, i = 0, ii = componentsCount; i < ii; i++)
                  for (var component = components[i], j = 0, jj = tiles.length; j < jj; j++) {
                    var tileComponent = {};
                    (tile = tiles[j]),
                      (tileComponent.tcx0 = Math.ceil(tile.tx0 / component.XRsiz)),
                      (tileComponent.tcy0 = Math.ceil(tile.ty0 / component.YRsiz)),
                      (tileComponent.tcx1 = Math.ceil(tile.tx1 / component.XRsiz)),
                      (tileComponent.tcy1 = Math.ceil(tile.ty1 / component.YRsiz)),
                      (tileComponent.width = tileComponent.tcx1 - tileComponent.tcx0),
                      (tileComponent.height = tileComponent.tcy1 - tileComponent.tcy0),
                      (tile.components[i] = tileComponent);
                  }
              }
              function getBlocksDimensions(context, component, r) {
                var codOrCoc = component.codingStyleParameters,
                  result = {};
                return (
                  codOrCoc.entropyCoderWithCustomPrecincts
                    ? ((result.PPx = codOrCoc.precinctsSizes[r].PPx), (result.PPy = codOrCoc.precinctsSizes[r].PPy))
                    : ((result.PPx = 15), (result.PPy = 15)),
                  (result.xcb_ = r > 0 ? Math.min(codOrCoc.xcb, result.PPx - 1) : Math.min(codOrCoc.xcb, result.PPx)),
                  (result.ycb_ = r > 0 ? Math.min(codOrCoc.ycb, result.PPy - 1) : Math.min(codOrCoc.ycb, result.PPy)),
                  result
                );
              }
              function buildPrecincts(context, resolution, dimensions) {
                var precinctWidth = 1 << dimensions.PPx,
                  precinctHeight = 1 << dimensions.PPy,
                  isZeroRes = 0 === resolution.resLevel,
                  precinctWidthInSubband = 1 << (dimensions.PPx + (isZeroRes ? 0 : -1)),
                  precinctHeightInSubband = 1 << (dimensions.PPy + (isZeroRes ? 0 : -1)),
                  numprecinctswide =
                    resolution.trx1 > resolution.trx0
                      ? Math.ceil(resolution.trx1 / precinctWidth) - Math.floor(resolution.trx0 / precinctWidth)
                      : 0,
                  numprecinctshigh =
                    resolution.try1 > resolution.try0
                      ? Math.ceil(resolution.try1 / precinctHeight) - Math.floor(resolution.try0 / precinctHeight)
                      : 0,
                  numprecincts = numprecinctswide * numprecinctshigh;
                resolution.precinctParameters = {
                  precinctWidth: precinctWidth,
                  precinctHeight: precinctHeight,
                  numprecinctswide: numprecinctswide,
                  numprecinctshigh: numprecinctshigh,
                  numprecincts: numprecincts,
                  precinctWidthInSubband: precinctWidthInSubband,
                  precinctHeightInSubband: precinctHeightInSubband,
                };
              }
              function buildCodeblocks(context, subband, dimensions) {
                var i,
                  j,
                  codeblock,
                  precinctNumber,
                  xcb_ = dimensions.xcb_,
                  ycb_ = dimensions.ycb_,
                  codeblockWidth = 1 << xcb_,
                  codeblockHeight = 1 << ycb_,
                  cbx0 = subband.tbx0 >> xcb_,
                  cby0 = subband.tby0 >> ycb_,
                  cbx1 = (subband.tbx1 + codeblockWidth - 1) >> xcb_,
                  cby1 = (subband.tby1 + codeblockHeight - 1) >> ycb_,
                  precinctParameters = subband.resolution.precinctParameters,
                  codeblocks = [],
                  precincts = [];
                for (j = cby0; j < cby1; j++)
                  for (i = cbx0; i < cbx1; i++) {
                    (codeblock = {
                      cbx: i,
                      cby: j,
                      tbx0: codeblockWidth * i,
                      tby0: codeblockHeight * j,
                      tbx1: codeblockWidth * (i + 1),
                      tby1: codeblockHeight * (j + 1),
                    }),
                      (codeblock.tbx0_ = Math.max(subband.tbx0, codeblock.tbx0)),
                      (codeblock.tby0_ = Math.max(subband.tby0, codeblock.tby0)),
                      (codeblock.tbx1_ = Math.min(subband.tbx1, codeblock.tbx1)),
                      (codeblock.tby1_ = Math.min(subband.tby1, codeblock.tby1));
                    var pi = Math.floor((codeblock.tbx0_ - subband.tbx0) / precinctParameters.precinctWidthInSubband),
                      pj = Math.floor((codeblock.tby0_ - subband.tby0) / precinctParameters.precinctHeightInSubband);
                    if (
                      ((precinctNumber = pi + pj * precinctParameters.numprecinctswide),
                      (codeblock.precinctNumber = precinctNumber),
                      (codeblock.subbandType = subband.type),
                      (codeblock.Lblock = 3),
                      !(codeblock.tbx1_ <= codeblock.tbx0_ || codeblock.tby1_ <= codeblock.tby0_))
                    ) {
                      codeblocks.push(codeblock);
                      var precinct = precincts[precinctNumber];
                      void 0 !== precinct
                        ? (i < precinct.cbxMin ? (precinct.cbxMin = i) : i > precinct.cbxMax && (precinct.cbxMax = i),
                          j < precinct.cbyMin ? (precinct.cbxMin = j) : j > precinct.cbyMax && (precinct.cbyMax = j))
                        : (precincts[precinctNumber] = precinct = { cbxMin: i, cbyMin: j, cbxMax: i, cbyMax: j }),
                        (codeblock.precinct = precinct);
                    }
                  }
                (subband.codeblockParameters = {
                  codeblockWidth: xcb_,
                  codeblockHeight: ycb_,
                  numcodeblockwide: cbx1 - cbx0 + 1,
                  numcodeblockhigh: cby1 - cby0 + 1,
                }),
                  (subband.codeblocks = codeblocks),
                  (subband.precincts = precincts);
              }
              function createPacket(resolution, precinctNumber, layerNumber) {
                for (
                  var precinctCodeblocks = [], subbands = resolution.subbands, i = 0, ii = subbands.length;
                  i < ii;
                  i++
                )
                  for (
                    var subband = subbands[i], codeblocks = subband.codeblocks, j = 0, jj = codeblocks.length;
                    j < jj;
                    j++
                  ) {
                    var codeblock = codeblocks[j];
                    codeblock.precinctNumber === precinctNumber && precinctCodeblocks.push(codeblock);
                  }
                return { layerNumber: layerNumber, codeblocks: precinctCodeblocks };
              }
              function LayerResolutionComponentPositionIterator(context) {
                for (
                  var siz = context.SIZ,
                    tileIndex = context.currentTile.index,
                    tile = context.tiles[tileIndex],
                    layersCount = tile.codingStyleDefaultParameters.layersCount,
                    componentsCount = siz.Csiz,
                    maxDecompositionLevelsCount = 0,
                    q = 0;
                  q < componentsCount;
                  q++
                )
                  maxDecompositionLevelsCount = Math.max(
                    maxDecompositionLevelsCount,
                    tile.components[q].codingStyleParameters.decompositionLevelsCount
                  );
                var l = 0,
                  r = 0,
                  i = 0,
                  k = 0;
                this.nextPacket = function () {
                  for (; l < layersCount; l++) {
                    for (; r <= maxDecompositionLevelsCount; r++) {
                      for (; i < componentsCount; i++) {
                        var component = tile.components[i];
                        if (!(r > component.codingStyleParameters.decompositionLevelsCount)) {
                          for (
                            var resolution = component.resolutions[r],
                              numprecincts = resolution.precinctParameters.numprecincts;
                            k < numprecincts;

                          ) {
                            var packet = createPacket(resolution, k, l);
                            return k++, packet;
                          }
                          k = 0;
                        }
                      }
                      i = 0;
                    }
                    r = 0;
                  }
                  error("JPX Error: Out of packets");
                };
              }
              function ResolutionLayerComponentPositionIterator(context) {
                for (
                  var siz = context.SIZ,
                    tileIndex = context.currentTile.index,
                    tile = context.tiles[tileIndex],
                    layersCount = tile.codingStyleDefaultParameters.layersCount,
                    componentsCount = siz.Csiz,
                    maxDecompositionLevelsCount = 0,
                    q = 0;
                  q < componentsCount;
                  q++
                )
                  maxDecompositionLevelsCount = Math.max(
                    maxDecompositionLevelsCount,
                    tile.components[q].codingStyleParameters.decompositionLevelsCount
                  );
                var r = 0,
                  l = 0,
                  i = 0,
                  k = 0;
                this.nextPacket = function () {
                  for (; r <= maxDecompositionLevelsCount; r++) {
                    for (; l < layersCount; l++) {
                      for (; i < componentsCount; i++) {
                        var component = tile.components[i];
                        if (!(r > component.codingStyleParameters.decompositionLevelsCount)) {
                          for (
                            var resolution = component.resolutions[r],
                              numprecincts = resolution.precinctParameters.numprecincts;
                            k < numprecincts;

                          ) {
                            var packet = createPacket(resolution, k, l);
                            return k++, packet;
                          }
                          k = 0;
                        }
                      }
                      i = 0;
                    }
                    l = 0;
                  }
                  error("JPX Error: Out of packets");
                };
              }
              function ResolutionPositionComponentLayerIterator(context) {
                var l,
                  r,
                  c,
                  p,
                  siz = context.SIZ,
                  tileIndex = context.currentTile.index,
                  tile = context.tiles[tileIndex],
                  layersCount = tile.codingStyleDefaultParameters.layersCount,
                  componentsCount = siz.Csiz,
                  maxDecompositionLevelsCount = 0;
                for (c = 0; c < componentsCount; c++) {
                  var component = tile.components[c];
                  maxDecompositionLevelsCount = Math.max(
                    maxDecompositionLevelsCount,
                    component.codingStyleParameters.decompositionLevelsCount
                  );
                }
                var maxNumPrecinctsInLevel = new Int32Array(maxDecompositionLevelsCount + 1);
                for (r = 0; r <= maxDecompositionLevelsCount; ++r) {
                  var maxNumPrecincts = 0;
                  for (c = 0; c < componentsCount; ++c) {
                    var resolutions = tile.components[c].resolutions;
                    r < resolutions.length &&
                      (maxNumPrecincts = Math.max(maxNumPrecincts, resolutions[r].precinctParameters.numprecincts));
                  }
                  maxNumPrecinctsInLevel[r] = maxNumPrecincts;
                }
                (l = 0),
                  (r = 0),
                  (c = 0),
                  (p = 0),
                  (this.nextPacket = function () {
                    for (; r <= maxDecompositionLevelsCount; r++) {
                      for (; p < maxNumPrecinctsInLevel[r]; p++) {
                        for (; c < componentsCount; c++) {
                          var component = tile.components[c];
                          if (!(r > component.codingStyleParameters.decompositionLevelsCount)) {
                            var resolution = component.resolutions[r],
                              numprecincts = resolution.precinctParameters.numprecincts;
                            if (!(p >= numprecincts)) {
                              for (; l < layersCount; ) {
                                var packet = createPacket(resolution, p, l);
                                return l++, packet;
                              }
                              l = 0;
                            }
                          }
                        }
                        c = 0;
                      }
                      p = 0;
                    }
                    error("JPX Error: Out of packets");
                  });
              }
              function PositionComponentResolutionLayerIterator(context) {
                var siz = context.SIZ,
                  tileIndex = context.currentTile.index,
                  tile = context.tiles[tileIndex],
                  layersCount = tile.codingStyleDefaultParameters.layersCount,
                  componentsCount = siz.Csiz,
                  precinctsSizes = getPrecinctSizesInImageScale(tile),
                  precinctsIterationSizes = precinctsSizes,
                  l = 0,
                  r = 0,
                  c = 0,
                  px = 0,
                  py = 0;
                this.nextPacket = function () {
                  for (; py < precinctsIterationSizes.maxNumHigh; py++) {
                    for (; px < precinctsIterationSizes.maxNumWide; px++) {
                      for (; c < componentsCount; c++) {
                        for (
                          var component = tile.components[c],
                            decompositionLevelsCount = component.codingStyleParameters.decompositionLevelsCount;
                          r <= decompositionLevelsCount;
                          r++
                        ) {
                          var resolution = component.resolutions[r],
                            sizeInImageScale = precinctsSizes.components[c].resolutions[r],
                            k = getPrecinctIndexIfExist(px, py, sizeInImageScale, precinctsIterationSizes, resolution);
                          if (null !== k) {
                            for (; l < layersCount; ) {
                              var packet = createPacket(resolution, k, l);
                              return l++, packet;
                            }
                            l = 0;
                          }
                        }
                        r = 0;
                      }
                      c = 0;
                    }
                    px = 0;
                  }
                  error("JPX Error: Out of packets");
                };
              }
              function ComponentPositionResolutionLayerIterator(context) {
                var siz = context.SIZ,
                  tileIndex = context.currentTile.index,
                  tile = context.tiles[tileIndex],
                  layersCount = tile.codingStyleDefaultParameters.layersCount,
                  componentsCount = siz.Csiz,
                  precinctsSizes = getPrecinctSizesInImageScale(tile),
                  l = 0,
                  r = 0,
                  c = 0,
                  px = 0,
                  py = 0;
                this.nextPacket = function () {
                  for (; c < componentsCount; ++c) {
                    for (
                      var component = tile.components[c],
                        precinctsIterationSizes = precinctsSizes.components[c],
                        decompositionLevelsCount = component.codingStyleParameters.decompositionLevelsCount;
                      py < precinctsIterationSizes.maxNumHigh;
                      py++
                    ) {
                      for (; px < precinctsIterationSizes.maxNumWide; px++) {
                        for (; r <= decompositionLevelsCount; r++) {
                          var resolution = component.resolutions[r],
                            sizeInImageScale = precinctsIterationSizes.resolutions[r],
                            k = getPrecinctIndexIfExist(px, py, sizeInImageScale, precinctsIterationSizes, resolution);
                          if (null !== k) {
                            for (; l < layersCount; ) {
                              var packet = createPacket(resolution, k, l);
                              return l++, packet;
                            }
                            l = 0;
                          }
                        }
                        r = 0;
                      }
                      px = 0;
                    }
                    py = 0;
                  }
                  error("JPX Error: Out of packets");
                };
              }
              function getPrecinctIndexIfExist(pxIndex, pyIndex, sizeInImageScale, precinctIterationSizes, resolution) {
                var posX = pxIndex * precinctIterationSizes.minWidth,
                  posY = pyIndex * precinctIterationSizes.minHeight;
                if (posX % sizeInImageScale.width != 0 || posY % sizeInImageScale.height != 0) return null;
                var startPrecinctRowIndex =
                  (posY / sizeInImageScale.width) * resolution.precinctParameters.numprecinctswide;
                return posX / sizeInImageScale.height + startPrecinctRowIndex;
              }
              function getPrecinctSizesInImageScale(tile) {
                for (
                  var componentsCount = tile.components.length,
                    minWidth = Number.MAX_VALUE,
                    minHeight = Number.MAX_VALUE,
                    maxNumWide = 0,
                    maxNumHigh = 0,
                    sizePerComponent = new Array(componentsCount),
                    c = 0;
                  c < componentsCount;
                  c++
                ) {
                  for (
                    var component = tile.components[c],
                      decompositionLevelsCount = component.codingStyleParameters.decompositionLevelsCount,
                      sizePerResolution = new Array(decompositionLevelsCount + 1),
                      minWidthCurrentComponent = Number.MAX_VALUE,
                      minHeightCurrentComponent = Number.MAX_VALUE,
                      maxNumWideCurrentComponent = 0,
                      maxNumHighCurrentComponent = 0,
                      scale = 1,
                      r = decompositionLevelsCount;
                    r >= 0;
                    --r
                  ) {
                    var resolution = component.resolutions[r],
                      widthCurrentResolution = scale * resolution.precinctParameters.precinctWidth,
                      heightCurrentResolution = scale * resolution.precinctParameters.precinctHeight;
                    (minWidthCurrentComponent = Math.min(minWidthCurrentComponent, widthCurrentResolution)),
                      (minHeightCurrentComponent = Math.min(minHeightCurrentComponent, heightCurrentResolution)),
                      (maxNumWideCurrentComponent = Math.max(
                        maxNumWideCurrentComponent,
                        resolution.precinctParameters.numprecinctswide
                      )),
                      (maxNumHighCurrentComponent = Math.max(
                        maxNumHighCurrentComponent,
                        resolution.precinctParameters.numprecinctshigh
                      )),
                      (sizePerResolution[r] = { width: widthCurrentResolution, height: heightCurrentResolution }),
                      (scale <<= 1);
                  }
                  (minWidth = Math.min(minWidth, minWidthCurrentComponent)),
                    (minHeight = Math.min(minHeight, minHeightCurrentComponent)),
                    (maxNumWide = Math.max(maxNumWide, maxNumWideCurrentComponent)),
                    (maxNumHigh = Math.max(maxNumHigh, maxNumHighCurrentComponent)),
                    (sizePerComponent[c] = {
                      resolutions: sizePerResolution,
                      minWidth: minWidthCurrentComponent,
                      minHeight: minHeightCurrentComponent,
                      maxNumWide: maxNumWideCurrentComponent,
                      maxNumHigh: maxNumHighCurrentComponent,
                    });
                }
                return {
                  components: sizePerComponent,
                  minWidth: minWidth,
                  minHeight: minHeight,
                  maxNumWide: maxNumWide,
                  maxNumHigh: maxNumHigh,
                };
              }
              function buildPackets(context) {
                for (
                  var siz = context.SIZ,
                    tileIndex = context.currentTile.index,
                    tile = context.tiles[tileIndex],
                    componentsCount = siz.Csiz,
                    c = 0;
                  c < componentsCount;
                  c++
                ) {
                  for (
                    var component = tile.components[c],
                      decompositionLevelsCount = component.codingStyleParameters.decompositionLevelsCount,
                      resolutions = [],
                      subbands = [],
                      r = 0;
                    r <= decompositionLevelsCount;
                    r++
                  ) {
                    var blocksDimensions = getBlocksDimensions(context, component, r),
                      resolution = {},
                      scale = 1 << (decompositionLevelsCount - r);
                    (resolution.trx0 = Math.ceil(component.tcx0 / scale)),
                      (resolution.try0 = Math.ceil(component.tcy0 / scale)),
                      (resolution.trx1 = Math.ceil(component.tcx1 / scale)),
                      (resolution.try1 = Math.ceil(component.tcy1 / scale)),
                      (resolution.resLevel = r),
                      buildPrecincts(context, resolution, blocksDimensions),
                      resolutions.push(resolution);
                    var subband;
                    if (0 === r)
                      (subband = {}),
                        (subband.type = "LL"),
                        (subband.tbx0 = Math.ceil(component.tcx0 / scale)),
                        (subband.tby0 = Math.ceil(component.tcy0 / scale)),
                        (subband.tbx1 = Math.ceil(component.tcx1 / scale)),
                        (subband.tby1 = Math.ceil(component.tcy1 / scale)),
                        (subband.resolution = resolution),
                        buildCodeblocks(context, subband, blocksDimensions),
                        subbands.push(subband),
                        (resolution.subbands = [subband]);
                    else {
                      var bscale = 1 << (decompositionLevelsCount - r + 1),
                        resolutionSubbands = [];
                      (subband = {}),
                        (subband.type = "HL"),
                        (subband.tbx0 = Math.ceil(component.tcx0 / bscale - 0.5)),
                        (subband.tby0 = Math.ceil(component.tcy0 / bscale)),
                        (subband.tbx1 = Math.ceil(component.tcx1 / bscale - 0.5)),
                        (subband.tby1 = Math.ceil(component.tcy1 / bscale)),
                        (subband.resolution = resolution),
                        buildCodeblocks(context, subband, blocksDimensions),
                        subbands.push(subband),
                        resolutionSubbands.push(subband),
                        (subband = {}),
                        (subband.type = "LH"),
                        (subband.tbx0 = Math.ceil(component.tcx0 / bscale)),
                        (subband.tby0 = Math.ceil(component.tcy0 / bscale - 0.5)),
                        (subband.tbx1 = Math.ceil(component.tcx1 / bscale)),
                        (subband.tby1 = Math.ceil(component.tcy1 / bscale - 0.5)),
                        (subband.resolution = resolution),
                        buildCodeblocks(context, subband, blocksDimensions),
                        subbands.push(subband),
                        resolutionSubbands.push(subband),
                        (subband = {}),
                        (subband.type = "HH"),
                        (subband.tbx0 = Math.ceil(component.tcx0 / bscale - 0.5)),
                        (subband.tby0 = Math.ceil(component.tcy0 / bscale - 0.5)),
                        (subband.tbx1 = Math.ceil(component.tcx1 / bscale - 0.5)),
                        (subband.tby1 = Math.ceil(component.tcy1 / bscale - 0.5)),
                        (subband.resolution = resolution),
                        buildCodeblocks(context, subband, blocksDimensions),
                        subbands.push(subband),
                        resolutionSubbands.push(subband),
                        (resolution.subbands = resolutionSubbands);
                    }
                  }
                  (component.resolutions = resolutions), (component.subbands = subbands);
                }
                var progressionOrder = tile.codingStyleDefaultParameters.progressionOrder;
                switch (progressionOrder) {
                  case 0:
                    tile.packetsIterator = new LayerResolutionComponentPositionIterator(context);
                    break;
                  case 1:
                    tile.packetsIterator = new ResolutionLayerComponentPositionIterator(context);
                    break;
                  case 2:
                    tile.packetsIterator = new ResolutionPositionComponentLayerIterator(context);
                    break;
                  case 3:
                    tile.packetsIterator = new PositionComponentResolutionLayerIterator(context);
                    break;
                  case 4:
                    tile.packetsIterator = new ComponentPositionResolutionLayerIterator(context);
                    break;
                  default:
                    error("JPX Error: Unsupported progression order " + progressionOrder);
                }
              }
              function parseTilePackets(context, data, offset, dataLength) {
                function readBits(count) {
                  for (; bufferSize < count; ) {
                    var b = data[offset + position];
                    position++,
                      skipNextBit
                        ? ((buffer = (buffer << 7) | b), (bufferSize += 7), (skipNextBit = !1))
                        : ((buffer = (buffer << 8) | b), (bufferSize += 8)),
                      255 === b && (skipNextBit = !0);
                  }
                  return (bufferSize -= count), (buffer >>> bufferSize) & ((1 << count) - 1);
                }
                function skipMarkerIfEqual(value) {
                  return 255 === data[offset + position - 1] && data[offset + position] === value
                    ? (skipBytes(1), !0)
                    : 255 === data[offset + position] && data[offset + position + 1] === value && (skipBytes(2), !0);
                }
                function skipBytes(count) {
                  position += count;
                }
                function alignToByte() {
                  (bufferSize = 0), skipNextBit && (position++, (skipNextBit = !1));
                }
                for (
                  var buffer,
                    position = 0,
                    bufferSize = 0,
                    skipNextBit = !1,
                    tileIndex = context.currentTile.index,
                    tile = context.tiles[tileIndex],
                    sopMarkerUsed = context.COD.sopMarkerUsed,
                    ephMarkerUsed = context.COD.ephMarkerUsed,
                    packetsIterator = tile.packetsIterator;
                  position < dataLength;

                ) {
                  alignToByte(), sopMarkerUsed && skipMarkerIfEqual(145) && skipBytes(4);
                  var packet = packetsIterator.nextPacket();
                  if (readBits(1)) {
                    for (
                      var codeblock, layerNumber = packet.layerNumber, queue = [], i = 0, ii = packet.codeblocks.length;
                      i < ii;
                      i++
                    ) {
                      codeblock = packet.codeblocks[i];
                      var precinct = codeblock.precinct,
                        codeblockColumn = codeblock.cbx - precinct.cbxMin,
                        codeblockRow = codeblock.cby - precinct.cbyMin,
                        codeblockIncluded = !1,
                        firstTimeInclusion = !1;
                      if (void 0 !== codeblock.included) codeblockIncluded = !!readBits(1);
                      else {
                        precinct = codeblock.precinct;
                        var inclusionTree, zeroBitPlanesTree;
                        if (void 0 !== precinct.inclusionTree) inclusionTree = precinct.inclusionTree;
                        else {
                          var width = precinct.cbxMax - precinct.cbxMin + 1,
                            height = precinct.cbyMax - precinct.cbyMin + 1;
                          (inclusionTree = new InclusionTree(width, height, layerNumber)),
                            (zeroBitPlanesTree = new TagTree(width, height)),
                            (precinct.inclusionTree = inclusionTree),
                            (precinct.zeroBitPlanesTree = zeroBitPlanesTree);
                        }
                        if (inclusionTree.reset(codeblockColumn, codeblockRow, layerNumber))
                          for (;;) {
                            if (!readBits(1)) {
                              inclusionTree.incrementValue(layerNumber);
                              break;
                            }
                            if (!inclusionTree.nextLevel()) {
                              (codeblock.included = !0), (codeblockIncluded = firstTimeInclusion = !0);
                              break;
                            }
                          }
                      }
                      if (codeblockIncluded) {
                        if (firstTimeInclusion) {
                          for (
                            zeroBitPlanesTree = precinct.zeroBitPlanesTree,
                              zeroBitPlanesTree.reset(codeblockColumn, codeblockRow);
                            ;

                          )
                            if (readBits(1)) {
                              if (!zeroBitPlanesTree.nextLevel()) break;
                            } else zeroBitPlanesTree.incrementValue();
                          codeblock.zeroBitPlanes = zeroBitPlanesTree.value;
                        }
                        for (
                          var codingpasses = (function () {
                            if (0 === readBits(1)) return 1;
                            if (0 === readBits(1)) return 2;
                            var value = readBits(2);
                            return value < 3
                              ? value + 3
                              : (value = readBits(5)) < 31
                              ? value + 6
                              : (value = readBits(7)) + 37;
                          })();
                          readBits(1);

                        )
                          codeblock.Lblock++;
                        var codingpassesLog2 = log2(codingpasses),
                          bits =
                            (codingpasses < 1 << codingpassesLog2 ? codingpassesLog2 - 1 : codingpassesLog2) +
                            codeblock.Lblock,
                          codedDataLength = readBits(bits);
                        queue.push({ codeblock: codeblock, codingpasses: codingpasses, dataLength: codedDataLength });
                      }
                    }
                    for (alignToByte(), ephMarkerUsed && skipMarkerIfEqual(146); queue.length > 0; ) {
                      var packetItem = queue.shift();
                      (codeblock = packetItem.codeblock),
                        void 0 === codeblock.data && (codeblock.data = []),
                        codeblock.data.push({
                          data: data,
                          start: offset + position,
                          end: offset + position + packetItem.dataLength,
                          codingpasses: packetItem.codingpasses,
                        }),
                        (position += packetItem.dataLength);
                    }
                  }
                }
                return position;
              }
              function copyCoefficients(
                coefficients,
                levelWidth,
                levelHeight,
                subband,
                delta,
                mb,
                reversible,
                segmentationSymbolUsed
              ) {
                for (
                  var x0 = subband.tbx0,
                    y0 = subband.tby0,
                    width = subband.tbx1 - subband.tbx0,
                    codeblocks = subband.codeblocks,
                    right = "H" === subband.type.charAt(0) ? 1 : 0,
                    bottom = "H" === subband.type.charAt(1) ? levelWidth : 0,
                    i = 0,
                    ii = codeblocks.length;
                  i < ii;
                  ++i
                ) {
                  var codeblock = codeblocks[i],
                    blockWidth = codeblock.tbx1_ - codeblock.tbx0_,
                    blockHeight = codeblock.tby1_ - codeblock.tby0_;
                  if (0 !== blockWidth && 0 !== blockHeight && void 0 !== codeblock.data) {
                    var bitModel, currentCodingpassType;
                    (bitModel = new BitModel(
                      blockWidth,
                      blockHeight,
                      codeblock.subbandType,
                      codeblock.zeroBitPlanes,
                      mb
                    )),
                      (currentCodingpassType = 2);
                    var j,
                      jj,
                      dataItem,
                      data = codeblock.data,
                      totalLength = 0,
                      codingpasses = 0;
                    for (j = 0, jj = data.length; j < jj; j++)
                      (dataItem = data[j]),
                        (totalLength += dataItem.end - dataItem.start),
                        (codingpasses += dataItem.codingpasses);
                    var encodedData = new Uint8Array(totalLength),
                      position = 0;
                    for (j = 0, jj = data.length; j < jj; j++) {
                      dataItem = data[j];
                      var chunk = dataItem.data.subarray(dataItem.start, dataItem.end);
                      encodedData.set(chunk, position), (position += chunk.length);
                    }
                    var decoder = new ArithmeticDecoder(encodedData, 0, totalLength);
                    for (bitModel.setDecoder(decoder), j = 0; j < codingpasses; j++) {
                      switch (currentCodingpassType) {
                        case 0:
                          bitModel.runSignificancePropagationPass();
                          break;
                        case 1:
                          bitModel.runMagnitudeRefinementPass();
                          break;
                        case 2:
                          bitModel.runCleanupPass(), segmentationSymbolUsed && bitModel.checkSegmentationSymbol();
                      }
                      currentCodingpassType = (currentCodingpassType + 1) % 3;
                    }
                    var k,
                      n,
                      nb,
                      offset = codeblock.tbx0_ - x0 + (codeblock.tby0_ - y0) * width,
                      sign = bitModel.coefficentsSign,
                      magnitude = bitModel.coefficentsMagnitude,
                      bitsDecoded = bitModel.bitsDecoded,
                      magnitudeCorrection = reversible ? 0 : 0.5;
                    position = 0;
                    var interleave = "LL" !== subband.type;
                    for (j = 0; j < blockHeight; j++) {
                      var row = (offset / width) | 0,
                        levelOffset = 2 * row * (levelWidth - width) + right + bottom;
                      for (k = 0; k < blockWidth; k++) {
                        if (0 !== (n = magnitude[position])) {
                          (n = (n + magnitudeCorrection) * delta),
                            0 !== sign[position] && (n = -n),
                            (nb = bitsDecoded[position]);
                          var pos = interleave ? levelOffset + (offset << 1) : offset;
                          coefficients[pos] = reversible && nb >= mb ? n : n * (1 << (mb - nb));
                        }
                        offset++, position++;
                      }
                      offset += width - blockWidth;
                    }
                  }
                }
              }
              function transformTile(context, tile, c) {
                for (
                  var component = tile.components[c],
                    codingStyleParameters = component.codingStyleParameters,
                    quantizationParameters = component.quantizationParameters,
                    decompositionLevelsCount = codingStyleParameters.decompositionLevelsCount,
                    spqcds = quantizationParameters.SPqcds,
                    scalarExpounded = quantizationParameters.scalarExpounded,
                    guardBits = quantizationParameters.guardBits,
                    segmentationSymbolUsed = codingStyleParameters.segmentationSymbolUsed,
                    precision = context.components[c].precision,
                    reversible = codingStyleParameters.reversibleTransformation,
                    transform = reversible ? new ReversibleTransform() : new IrreversibleTransform(),
                    subbandCoefficients = [],
                    b = 0,
                    i = 0;
                  i <= decompositionLevelsCount;
                  i++
                ) {
                  for (
                    var resolution = component.resolutions[i],
                      width = resolution.trx1 - resolution.trx0,
                      height = resolution.try1 - resolution.try0,
                      coefficients = new Float32Array(width * height),
                      j = 0,
                      jj = resolution.subbands.length;
                    j < jj;
                    j++
                  ) {
                    var mu, epsilon;
                    scalarExpounded
                      ? ((mu = spqcds[b].mu), (epsilon = spqcds[b].epsilon), b++)
                      : ((mu = spqcds[0].mu), (epsilon = spqcds[0].epsilon + (i > 0 ? 1 - i : 0)));
                    var subband = resolution.subbands[j],
                      gainLog2 = SubbandsGainLog2[subband.type];
                    copyCoefficients(
                      coefficients,
                      width,
                      height,
                      subband,
                      reversible ? 1 : Math.pow(2, precision + gainLog2 - epsilon) * (1 + mu / 2048),
                      guardBits + epsilon - 1,
                      reversible,
                      segmentationSymbolUsed
                    );
                  }
                  subbandCoefficients.push({ width: width, height: height, items: coefficients });
                }
                var result = transform.calculate(subbandCoefficients, component.tcx0, component.tcy0);
                return {
                  left: component.tcx0,
                  top: component.tcy0,
                  width: result.width,
                  height: result.height,
                  items: result.items,
                };
              }
              function transformComponents(context) {
                for (
                  var siz = context.SIZ,
                    components = context.components,
                    componentsCount = siz.Csiz,
                    resultImages = [],
                    i = 0,
                    ii = context.tiles.length;
                  i < ii;
                  i++
                ) {
                  var c,
                    tile = context.tiles[i],
                    transformedTiles = [];
                  for (c = 0; c < componentsCount; c++) transformedTiles[c] = transformTile(context, tile, c);
                  var shift,
                    offset,
                    max,
                    min,
                    maxK,
                    j,
                    jj,
                    y0,
                    y1,
                    y2,
                    r,
                    g,
                    b,
                    k,
                    val,
                    tile0 = transformedTiles[0],
                    out = new Uint8Array(tile0.items.length * componentsCount),
                    result = { left: tile0.left, top: tile0.top, width: tile0.width, height: tile0.height, items: out },
                    pos = 0;
                  if (tile.codingStyleDefaultParameters.multipleComponentTransform) {
                    var fourComponents = 4 === componentsCount,
                      y0items = transformedTiles[0].items,
                      y1items = transformedTiles[1].items,
                      y2items = transformedTiles[2].items,
                      y3items = fourComponents ? transformedTiles[3].items : null;
                    (shift = components[0].precision - 8),
                      (offset = 0.5 + (128 << shift)),
                      (max = 255 * (1 << shift)),
                      (maxK = 0.5 * max),
                      (min = -maxK);
                    var component0 = tile.components[0],
                      alpha01 = componentsCount - 3;
                    if (((jj = y0items.length), component0.codingStyleParameters.reversibleTransformation))
                      for (j = 0; j < jj; j++, pos += alpha01)
                        (y0 = y0items[j] + offset),
                          (y1 = y1items[j]),
                          (y2 = y2items[j]),
                          (g = y0 - ((y2 + y1) >> 2)),
                          (r = g + y2),
                          (b = g + y1),
                          (out[pos++] = r <= 0 ? 0 : r >= max ? 255 : r >> shift),
                          (out[pos++] = g <= 0 ? 0 : g >= max ? 255 : g >> shift),
                          (out[pos++] = b <= 0 ? 0 : b >= max ? 255 : b >> shift);
                    else
                      for (j = 0; j < jj; j++, pos += alpha01)
                        (y0 = y0items[j] + offset),
                          (y1 = y1items[j]),
                          (y2 = y2items[j]),
                          (r = y0 + 1.402 * y2),
                          (g = y0 - 0.34413 * y1 - 0.71414 * y2),
                          (b = y0 + 1.772 * y1),
                          (out[pos++] = r <= 0 ? 0 : r >= max ? 255 : r >> shift),
                          (out[pos++] = g <= 0 ? 0 : g >= max ? 255 : g >> shift),
                          (out[pos++] = b <= 0 ? 0 : b >= max ? 255 : b >> shift);
                    if (fourComponents)
                      for (j = 0, pos = 3; j < jj; j++, pos += 4)
                        (k = y3items[j]), (out[pos] = k <= min ? 0 : k >= maxK ? 255 : (k + offset) >> shift);
                  } else
                    for (c = 0; c < componentsCount; c++) {
                      var items = transformedTiles[c].items;
                      for (
                        shift = components[c].precision - 8,
                          offset = 0.5 + (128 << shift),
                          max = 127.5 * (1 << shift),
                          min = -max,
                          pos = c,
                          j = 0,
                          jj = items.length;
                        j < jj;
                        j++
                      )
                        (val = items[j]),
                          (out[pos] = val <= min ? 0 : val >= max ? 255 : (val + offset) >> shift),
                          (pos += componentsCount);
                    }
                  resultImages.push(result);
                }
                return resultImages;
              }
              function initializeTile(context, tileIndex) {
                for (
                  var siz = context.SIZ, componentsCount = siz.Csiz, tile = context.tiles[tileIndex], c = 0;
                  c < componentsCount;
                  c++
                ) {
                  var component = tile.components[c],
                    qcdOrQcc =
                      void 0 !== context.currentTile.QCC[c] ? context.currentTile.QCC[c] : context.currentTile.QCD;
                  component.quantizationParameters = qcdOrQcc;
                  var codOrCoc =
                    void 0 !== context.currentTile.COC[c] ? context.currentTile.COC[c] : context.currentTile.COD;
                  component.codingStyleParameters = codOrCoc;
                }
                tile.codingStyleDefaultParameters = context.currentTile.COD;
              }
              var SubbandsGainLog2 = { LL: 0, LH: 1, HL: 1, HH: 2 };
              JpxImage.prototype = {
                parse: function (data) {
                  if (65359 === readUint16(data, 0)) return void this.parseCodestream(data, 0, data.length);
                  for (var position = 0, length = data.length; position < length; ) {
                    var headerSize = 8,
                      lbox = readUint32(data, position),
                      tbox = readUint32(data, position + 4);
                    (position += headerSize),
                      1 === lbox &&
                        ((lbox = 4294967296 * readUint32(data, position) + readUint32(data, position + 4)),
                        (position += 8),
                        (headerSize += 8)),
                      0 === lbox && (lbox = length - position + headerSize),
                      lbox < headerSize && error("JPX Error: Invalid box field size");
                    var dataLength = lbox - headerSize,
                      jumpDataLength = !0;
                    switch (tbox) {
                      case 1785737832:
                        jumpDataLength = !1;
                        break;
                      case 1668246642:
                        var method = data[position];
                        if (1 === method) {
                          var colorspace = readUint32(data, position + 3);
                          switch (colorspace) {
                            case 16:
                            case 17:
                            case 18:
                              break;
                            default:
                              warn("Unknown colorspace " + colorspace);
                          }
                        } else 2 === method && info("ICC profile not supported");
                        break;
                      case 1785737827:
                        this.parseCodestream(data, position, position + dataLength);
                        break;
                      case 1783636e3:
                        218793738 !== readUint32(data, position) && warn("Invalid JP2 signature");
                        break;
                      case 1783634458:
                      case 1718909296:
                      case 1920099697:
                      case 1919251232:
                      case 1768449138:
                        break;
                      default:
                        var headerType = String.fromCharCode(
                          (tbox >> 24) & 255,
                          (tbox >> 16) & 255,
                          (tbox >> 8) & 255,
                          255 & tbox
                        );
                        warn("Unsupported header type " + tbox + " (" + headerType + ")");
                    }
                    jumpDataLength && (position += dataLength);
                  }
                },
                parseImageProperties: function (stream) {
                  for (var newByte = stream.getByte(); newByte >= 0; ) {
                    var oldByte = newByte;
                    newByte = stream.getByte();
                    if (65361 === ((oldByte << 8) | newByte)) {
                      stream.skip(4);
                      var Xsiz = stream.getInt32() >>> 0,
                        Ysiz = stream.getInt32() >>> 0,
                        XOsiz = stream.getInt32() >>> 0,
                        YOsiz = stream.getInt32() >>> 0;
                      stream.skip(16);
                      var Csiz = stream.getUint16();
                      return (
                        (this.width = Xsiz - XOsiz),
                        (this.height = Ysiz - YOsiz),
                        (this.componentsCount = Csiz),
                        void (this.bitsPerComponent = 8)
                      );
                    }
                  }
                  error("JPX Error: No size marker found in JPX stream");
                },
                parseCodestream: function (data, start, end) {
                  var context = {},
                    doNotRecover = !1;
                  try {
                    for (var position = start; position + 1 < end; ) {
                      var code = readUint16(data, position);
                      position += 2;
                      var j,
                        sqcd,
                        spqcds,
                        spqcdSize,
                        scalarExpounded,
                        tile,
                        length = 0;
                      switch (code) {
                        case 65359:
                          context.mainHeader = !0;
                          break;
                        case 65497:
                          break;
                        case 65361:
                          length = readUint16(data, position);
                          var siz = {};
                          (siz.Xsiz = readUint32(data, position + 4)),
                            (siz.Ysiz = readUint32(data, position + 8)),
                            (siz.XOsiz = readUint32(data, position + 12)),
                            (siz.YOsiz = readUint32(data, position + 16)),
                            (siz.XTsiz = readUint32(data, position + 20)),
                            (siz.YTsiz = readUint32(data, position + 24)),
                            (siz.XTOsiz = readUint32(data, position + 28)),
                            (siz.YTOsiz = readUint32(data, position + 32));
                          var componentsCount = readUint16(data, position + 36);
                          siz.Csiz = componentsCount;
                          var components = [];
                          j = position + 38;
                          for (var i = 0; i < componentsCount; i++) {
                            var component = {
                              precision: 1 + (127 & data[j]),
                              isSigned: !!(128 & data[j]),
                              XRsiz: data[j + 1],
                              YRsiz: data[j + 1],
                            };
                            calculateComponentDimensions(component, siz), components.push(component);
                          }
                          (context.SIZ = siz),
                            (context.components = components),
                            calculateTileGrids(context, components),
                            (context.QCC = []),
                            (context.COC = []);
                          break;
                        case 65372:
                          length = readUint16(data, position);
                          var qcd = {};
                          switch (((j = position + 2), 31 & (sqcd = data[j++]))) {
                            case 0:
                              (spqcdSize = 8), (scalarExpounded = !0);
                              break;
                            case 1:
                              (spqcdSize = 16), (scalarExpounded = !1);
                              break;
                            case 2:
                              (spqcdSize = 16), (scalarExpounded = !0);
                              break;
                            default:
                              throw new Error("Invalid SQcd value " + sqcd);
                          }
                          for (
                            qcd.noQuantization = 8 === spqcdSize,
                              qcd.scalarExpounded = scalarExpounded,
                              qcd.guardBits = sqcd >> 5,
                              spqcds = [];
                            j < length + position;

                          ) {
                            var spqcd = {};
                            8 === spqcdSize
                              ? ((spqcd.epsilon = data[j++] >> 3), (spqcd.mu = 0))
                              : ((spqcd.epsilon = data[j] >> 3),
                                (spqcd.mu = ((7 & data[j]) << 8) | data[j + 1]),
                                (j += 2)),
                              spqcds.push(spqcd);
                          }
                          (qcd.SPqcds = spqcds),
                            context.mainHeader
                              ? (context.QCD = qcd)
                              : ((context.currentTile.QCD = qcd), (context.currentTile.QCC = []));
                          break;
                        case 65373:
                          length = readUint16(data, position);
                          var qcc = {};
                          j = position + 2;
                          var cqcc;
                          switch (
                            (context.SIZ.Csiz < 257 ? (cqcc = data[j++]) : ((cqcc = readUint16(data, j)), (j += 2)),
                            31 & (sqcd = data[j++]))
                          ) {
                            case 0:
                              (spqcdSize = 8), (scalarExpounded = !0);
                              break;
                            case 1:
                              (spqcdSize = 16), (scalarExpounded = !1);
                              break;
                            case 2:
                              (spqcdSize = 16), (scalarExpounded = !0);
                              break;
                            default:
                              throw new Error("Invalid SQcd value " + sqcd);
                          }
                          for (
                            qcc.noQuantization = 8 === spqcdSize,
                              qcc.scalarExpounded = scalarExpounded,
                              qcc.guardBits = sqcd >> 5,
                              spqcds = [];
                            j < length + position;

                          )
                            (spqcd = {}),
                              8 === spqcdSize
                                ? ((spqcd.epsilon = data[j++] >> 3), (spqcd.mu = 0))
                                : ((spqcd.epsilon = data[j] >> 3),
                                  (spqcd.mu = ((7 & data[j]) << 8) | data[j + 1]),
                                  (j += 2)),
                              spqcds.push(spqcd);
                          (qcc.SPqcds = spqcds),
                            context.mainHeader ? (context.QCC[cqcc] = qcc) : (context.currentTile.QCC[cqcc] = qcc);
                          break;
                        case 65362:
                          length = readUint16(data, position);
                          var cod = {};
                          j = position + 2;
                          var scod = data[j++];
                          (cod.entropyCoderWithCustomPrecincts = !!(1 & scod)),
                            (cod.sopMarkerUsed = !!(2 & scod)),
                            (cod.ephMarkerUsed = !!(4 & scod)),
                            (cod.progressionOrder = data[j++]),
                            (cod.layersCount = readUint16(data, j)),
                            (j += 2),
                            (cod.multipleComponentTransform = data[j++]),
                            (cod.decompositionLevelsCount = data[j++]),
                            (cod.xcb = 2 + (15 & data[j++])),
                            (cod.ycb = 2 + (15 & data[j++]));
                          var blockStyle = data[j++];
                          if (
                            ((cod.selectiveArithmeticCodingBypass = !!(1 & blockStyle)),
                            (cod.resetContextProbabilities = !!(2 & blockStyle)),
                            (cod.terminationOnEachCodingPass = !!(4 & blockStyle)),
                            (cod.verticalyStripe = !!(8 & blockStyle)),
                            (cod.predictableTermination = !!(16 & blockStyle)),
                            (cod.segmentationSymbolUsed = !!(32 & blockStyle)),
                            (cod.reversibleTransformation = data[j++]),
                            cod.entropyCoderWithCustomPrecincts)
                          ) {
                            for (var precinctsSizes = []; j < length + position; ) {
                              var precinctsSize = data[j++];
                              precinctsSizes.push({ PPx: 15 & precinctsSize, PPy: precinctsSize >> 4 });
                            }
                            cod.precinctsSizes = precinctsSizes;
                          }
                          var unsupported = [];
                          if (
                            (cod.selectiveArithmeticCodingBypass && unsupported.push("selectiveArithmeticCodingBypass"),
                            cod.resetContextProbabilities && unsupported.push("resetContextProbabilities"),
                            cod.terminationOnEachCodingPass && unsupported.push("terminationOnEachCodingPass"),
                            cod.verticalyStripe && unsupported.push("verticalyStripe"),
                            cod.predictableTermination && unsupported.push("predictableTermination"),
                            unsupported.length > 0)
                          )
                            throw (
                              ((doNotRecover = !0),
                              new Error("Unsupported COD options (" + unsupported.join(", ") + ")"))
                            );
                          context.mainHeader
                            ? (context.COD = cod)
                            : ((context.currentTile.COD = cod), (context.currentTile.COC = []));
                          break;
                        case 65424:
                          (length = readUint16(data, position)),
                            (tile = {}),
                            (tile.index = readUint16(data, position + 2)),
                            (tile.length = readUint32(data, position + 4)),
                            (tile.dataEnd = tile.length + position - 2),
                            (tile.partIndex = data[position + 8]),
                            (tile.partsCount = data[position + 9]),
                            (context.mainHeader = !1),
                            0 === tile.partIndex &&
                              ((tile.COD = context.COD),
                              (tile.COC = context.COC.slice(0)),
                              (tile.QCD = context.QCD),
                              (tile.QCC = context.QCC.slice(0))),
                            (context.currentTile = tile);
                          break;
                        case 65427:
                          (tile = context.currentTile),
                            0 === tile.partIndex && (initializeTile(context, tile.index), buildPackets(context)),
                            (length = tile.dataEnd - position),
                            parseTilePackets(context, data, position, length);
                          break;
                        case 65365:
                        case 65367:
                        case 65368:
                        case 65380:
                          length = readUint16(data, position);
                          break;
                        case 65363:
                          throw new Error("Codestream code 0xFF53 (COC) is not implemented");
                        default:
                          throw new Error("Unknown codestream code: " + code.toString(16));
                      }
                      position += length;
                    }
                  } catch (e) {
                    doNotRecover || this.failOnCorruptedImage
                      ? error("JPX Error: " + e.message)
                      : warn("JPX: Trying to recover from: " + e.message);
                  }
                  (this.tiles = transformComponents(context)),
                    (this.width = context.SIZ.Xsiz - context.SIZ.XOsiz),
                    (this.height = context.SIZ.Ysiz - context.SIZ.YOsiz),
                    (this.componentsCount = context.SIZ.Csiz);
                },
              };
              var TagTree = (function () {
                  function TagTree(width, height) {
                    var levelsLength = log2(Math.max(width, height)) + 1;
                    this.levels = [];
                    for (var i = 0; i < levelsLength; i++) {
                      var level = { width: width, height: height, items: [] };
                      this.levels.push(level), (width = Math.ceil(width / 2)), (height = Math.ceil(height / 2));
                    }
                  }
                  return (
                    (TagTree.prototype = {
                      reset: function (i, j) {
                        for (var level, currentLevel = 0, value = 0; currentLevel < this.levels.length; ) {
                          level = this.levels[currentLevel];
                          var index = i + j * level.width;
                          if (void 0 !== level.items[index]) {
                            value = level.items[index];
                            break;
                          }
                          (level.index = index), (i >>= 1), (j >>= 1), currentLevel++;
                        }
                        currentLevel--,
                          (level = this.levels[currentLevel]),
                          (level.items[level.index] = value),
                          (this.currentLevel = currentLevel),
                          delete this.value;
                      },
                      incrementValue: function () {
                        var level = this.levels[this.currentLevel];
                        level.items[level.index]++;
                      },
                      nextLevel: function () {
                        var currentLevel = this.currentLevel,
                          level = this.levels[currentLevel],
                          value = level.items[level.index];
                        return --currentLevel < 0
                          ? ((this.value = value), !1)
                          : ((this.currentLevel = currentLevel),
                            (level = this.levels[currentLevel]),
                            (level.items[level.index] = value),
                            !0);
                      },
                    }),
                    TagTree
                  );
                })(),
                InclusionTree = (function () {
                  function InclusionTree(width, height, defaultValue) {
                    var levelsLength = log2(Math.max(width, height)) + 1;
                    this.levels = [];
                    for (var i = 0; i < levelsLength; i++) {
                      for (var items = new Uint8Array(width * height), j = 0, jj = items.length; j < jj; j++)
                        items[j] = defaultValue;
                      var level = { width: width, height: height, items: items };
                      this.levels.push(level), (width = Math.ceil(width / 2)), (height = Math.ceil(height / 2));
                    }
                  }
                  return (
                    (InclusionTree.prototype = {
                      reset: function (i, j, stopValue) {
                        for (var currentLevel = 0; currentLevel < this.levels.length; ) {
                          var level = this.levels[currentLevel],
                            index = i + j * level.width;
                          level.index = index;
                          var value = level.items[index];
                          if (255 === value) break;
                          if (value > stopValue) return (this.currentLevel = currentLevel), this.propagateValues(), !1;
                          (i >>= 1), (j >>= 1), currentLevel++;
                        }
                        return (this.currentLevel = currentLevel - 1), !0;
                      },
                      incrementValue: function (stopValue) {
                        var level = this.levels[this.currentLevel];
                        (level.items[level.index] = stopValue + 1), this.propagateValues();
                      },
                      propagateValues: function () {
                        for (
                          var levelIndex = this.currentLevel,
                            level = this.levels[levelIndex],
                            currentValue = level.items[level.index];
                          --levelIndex >= 0;

                        )
                          (level = this.levels[levelIndex]), (level.items[level.index] = currentValue);
                      },
                      nextLevel: function () {
                        var currentLevel = this.currentLevel,
                          level = this.levels[currentLevel],
                          value = level.items[level.index];
                        return (
                          (level.items[level.index] = 255),
                          !(--currentLevel < 0) &&
                            ((this.currentLevel = currentLevel),
                            (level = this.levels[currentLevel]),
                            (level.items[level.index] = value),
                            !0)
                        );
                      },
                    }),
                    InclusionTree
                  );
                })(),
                BitModel = (function () {
                  function BitModel(width, height, subband, zeroBitPlanes, mb) {
                    (this.width = width),
                      (this.height = height),
                      (this.contextLabelTable =
                        "HH" === subband ? HHContextLabel : "HL" === subband ? HLContextLabel : LLAndLHContextsLabel);
                    var coefficientCount = width * height;
                    (this.neighborsSignificance = new Uint8Array(coefficientCount)),
                      (this.coefficentsSign = new Uint8Array(coefficientCount)),
                      (this.coefficentsMagnitude =
                        mb > 14
                          ? new Uint32Array(coefficientCount)
                          : mb > 6
                          ? new Uint16Array(coefficientCount)
                          : new Uint8Array(coefficientCount)),
                      (this.processingFlags = new Uint8Array(coefficientCount));
                    var bitsDecoded = new Uint8Array(coefficientCount);
                    if (0 !== zeroBitPlanes) for (var i = 0; i < coefficientCount; i++) bitsDecoded[i] = zeroBitPlanes;
                    (this.bitsDecoded = bitsDecoded), this.reset();
                  }
                  var LLAndLHContextsLabel = new Uint8Array([
                      0,
                      5,
                      8,
                      0,
                      3,
                      7,
                      8,
                      0,
                      4,
                      7,
                      8,
                      0,
                      0,
                      0,
                      0,
                      0,
                      1,
                      6,
                      8,
                      0,
                      3,
                      7,
                      8,
                      0,
                      4,
                      7,
                      8,
                      0,
                      0,
                      0,
                      0,
                      0,
                      2,
                      6,
                      8,
                      0,
                      3,
                      7,
                      8,
                      0,
                      4,
                      7,
                      8,
                      0,
                      0,
                      0,
                      0,
                      0,
                      2,
                      6,
                      8,
                      0,
                      3,
                      7,
                      8,
                      0,
                      4,
                      7,
                      8,
                      0,
                      0,
                      0,
                      0,
                      0,
                      2,
                      6,
                      8,
                      0,
                      3,
                      7,
                      8,
                      0,
                      4,
                      7,
                      8,
                    ]),
                    HLContextLabel = new Uint8Array([
                      0,
                      3,
                      4,
                      0,
                      5,
                      7,
                      7,
                      0,
                      8,
                      8,
                      8,
                      0,
                      0,
                      0,
                      0,
                      0,
                      1,
                      3,
                      4,
                      0,
                      6,
                      7,
                      7,
                      0,
                      8,
                      8,
                      8,
                      0,
                      0,
                      0,
                      0,
                      0,
                      2,
                      3,
                      4,
                      0,
                      6,
                      7,
                      7,
                      0,
                      8,
                      8,
                      8,
                      0,
                      0,
                      0,
                      0,
                      0,
                      2,
                      3,
                      4,
                      0,
                      6,
                      7,
                      7,
                      0,
                      8,
                      8,
                      8,
                      0,
                      0,
                      0,
                      0,
                      0,
                      2,
                      3,
                      4,
                      0,
                      6,
                      7,
                      7,
                      0,
                      8,
                      8,
                      8,
                    ]),
                    HHContextLabel = new Uint8Array([
                      0,
                      1,
                      2,
                      0,
                      1,
                      2,
                      2,
                      0,
                      2,
                      2,
                      2,
                      0,
                      0,
                      0,
                      0,
                      0,
                      3,
                      4,
                      5,
                      0,
                      4,
                      5,
                      5,
                      0,
                      5,
                      5,
                      5,
                      0,
                      0,
                      0,
                      0,
                      0,
                      6,
                      7,
                      7,
                      0,
                      7,
                      7,
                      7,
                      0,
                      7,
                      7,
                      7,
                      0,
                      0,
                      0,
                      0,
                      0,
                      8,
                      8,
                      8,
                      0,
                      8,
                      8,
                      8,
                      0,
                      8,
                      8,
                      8,
                      0,
                      0,
                      0,
                      0,
                      0,
                      8,
                      8,
                      8,
                      0,
                      8,
                      8,
                      8,
                      0,
                      8,
                      8,
                      8,
                    ]);
                  return (
                    (BitModel.prototype = {
                      setDecoder: function (decoder) {
                        this.decoder = decoder;
                      },
                      reset: function () {
                        (this.contexts = new Int8Array(19)),
                          (this.contexts[0] = 8),
                          (this.contexts[17] = 92),
                          (this.contexts[18] = 6);
                      },
                      setNeighborsSignificance: function (row, column, index) {
                        var i,
                          neighborsSignificance = this.neighborsSignificance,
                          width = this.width,
                          height = this.height,
                          left = column > 0,
                          right = column + 1 < width;
                        row > 0 &&
                          ((i = index - width),
                          left && (neighborsSignificance[i - 1] += 16),
                          right && (neighborsSignificance[i + 1] += 16),
                          (neighborsSignificance[i] += 4)),
                          row + 1 < height &&
                            ((i = index + width),
                            left && (neighborsSignificance[i - 1] += 16),
                            right && (neighborsSignificance[i + 1] += 16),
                            (neighborsSignificance[i] += 4)),
                          left && (neighborsSignificance[index - 1] += 1),
                          right && (neighborsSignificance[index + 1] += 1),
                          (neighborsSignificance[index] |= 128);
                      },
                      runSignificancePropagationPass: function () {
                        for (
                          var decoder = this.decoder,
                            width = this.width,
                            height = this.height,
                            coefficentsMagnitude = this.coefficentsMagnitude,
                            coefficentsSign = this.coefficentsSign,
                            neighborsSignificance = this.neighborsSignificance,
                            processingFlags = this.processingFlags,
                            contexts = this.contexts,
                            labels = this.contextLabelTable,
                            bitsDecoded = this.bitsDecoded,
                            i0 = 0;
                          i0 < height;
                          i0 += 4
                        )
                          for (var j = 0; j < width; j++)
                            for (var index = i0 * width + j, i1 = 0; i1 < 4; i1++, index += width) {
                              var i = i0 + i1;
                              if (i >= height) break;
                              if (
                                ((processingFlags[index] &= -2),
                                !coefficentsMagnitude[index] && neighborsSignificance[index])
                              ) {
                                var contextLabel = labels[neighborsSignificance[index]],
                                  decision = decoder.readBit(contexts, contextLabel);
                                if (decision) {
                                  var sign = this.decodeSignBit(i, j, index);
                                  (coefficentsSign[index] = sign),
                                    (coefficentsMagnitude[index] = 1),
                                    this.setNeighborsSignificance(i, j, index),
                                    (processingFlags[index] |= 2);
                                }
                                bitsDecoded[index]++, (processingFlags[index] |= 1);
                              }
                            }
                      },
                      decodeSignBit: function (row, column, index) {
                        var contribution,
                          sign0,
                          sign1,
                          significance1,
                          contextLabel,
                          decoded,
                          width = this.width,
                          height = this.height,
                          coefficentsMagnitude = this.coefficentsMagnitude,
                          coefficentsSign = this.coefficentsSign;
                        (significance1 = column > 0 && 0 !== coefficentsMagnitude[index - 1]),
                          column + 1 < width && 0 !== coefficentsMagnitude[index + 1]
                            ? ((sign1 = coefficentsSign[index + 1]),
                              significance1
                                ? ((sign0 = coefficentsSign[index - 1]), (contribution = 1 - sign1 - sign0))
                                : (contribution = 1 - sign1 - sign1))
                            : significance1
                            ? ((sign0 = coefficentsSign[index - 1]), (contribution = 1 - sign0 - sign0))
                            : (contribution = 0);
                        var horizontalContribution = 3 * contribution;
                        return (
                          (significance1 = row > 0 && 0 !== coefficentsMagnitude[index - width]),
                          row + 1 < height && 0 !== coefficentsMagnitude[index + width]
                            ? ((sign1 = coefficentsSign[index + width]),
                              significance1
                                ? ((sign0 = coefficentsSign[index - width]),
                                  (contribution = 1 - sign1 - sign0 + horizontalContribution))
                                : (contribution = 1 - sign1 - sign1 + horizontalContribution))
                            : significance1
                            ? ((sign0 = coefficentsSign[index - width]),
                              (contribution = 1 - sign0 - sign0 + horizontalContribution))
                            : (contribution = horizontalContribution),
                          contribution >= 0
                            ? ((contextLabel = 9 + contribution),
                              (decoded = this.decoder.readBit(this.contexts, contextLabel)))
                            : ((contextLabel = 9 - contribution),
                              (decoded = 1 ^ this.decoder.readBit(this.contexts, contextLabel))),
                          decoded
                        );
                      },
                      runMagnitudeRefinementPass: function () {
                        for (
                          var indexNext,
                            decoder = this.decoder,
                            width = this.width,
                            height = this.height,
                            coefficentsMagnitude = this.coefficentsMagnitude,
                            neighborsSignificance = this.neighborsSignificance,
                            contexts = this.contexts,
                            bitsDecoded = this.bitsDecoded,
                            processingFlags = this.processingFlags,
                            length = width * height,
                            width4 = 4 * width,
                            index0 = 0;
                          index0 < length;
                          index0 = indexNext
                        ) {
                          indexNext = Math.min(length, index0 + width4);
                          for (var j = 0; j < width; j++)
                            for (var index = index0 + j; index < indexNext; index += width)
                              if (coefficentsMagnitude[index] && 0 == (1 & processingFlags[index])) {
                                var contextLabel = 16;
                                if (0 != (2 & processingFlags[index])) {
                                  processingFlags[index] ^= 2;
                                  var significance = 127 & neighborsSignificance[index];
                                  contextLabel = 0 === significance ? 15 : 14;
                                }
                                var bit = decoder.readBit(contexts, contextLabel);
                                (coefficentsMagnitude[index] = (coefficentsMagnitude[index] << 1) | bit),
                                  bitsDecoded[index]++,
                                  (processingFlags[index] |= 1);
                              }
                        }
                      },
                      runCleanupPass: function () {
                        for (
                          var iNext,
                            decoder = this.decoder,
                            width = this.width,
                            height = this.height,
                            neighborsSignificance = this.neighborsSignificance,
                            coefficentsMagnitude = this.coefficentsMagnitude,
                            coefficentsSign = this.coefficentsSign,
                            contexts = this.contexts,
                            labels = this.contextLabelTable,
                            bitsDecoded = this.bitsDecoded,
                            processingFlags = this.processingFlags,
                            oneRowDown = width,
                            twoRowsDown = 2 * width,
                            threeRowsDown = 3 * width,
                            i0 = 0;
                          i0 < height;
                          i0 = iNext
                        ) {
                          iNext = Math.min(i0 + 4, height);
                          for (var indexBase = i0 * width, checkAllEmpty = i0 + 3 < height, j = 0; j < width; j++) {
                            var sign,
                              index0 = indexBase + j,
                              allEmpty =
                                checkAllEmpty &&
                                0 === processingFlags[index0] &&
                                0 === processingFlags[index0 + oneRowDown] &&
                                0 === processingFlags[index0 + twoRowsDown] &&
                                0 === processingFlags[index0 + threeRowsDown] &&
                                0 === neighborsSignificance[index0] &&
                                0 === neighborsSignificance[index0 + oneRowDown] &&
                                0 === neighborsSignificance[index0 + twoRowsDown] &&
                                0 === neighborsSignificance[index0 + threeRowsDown],
                              i1 = 0,
                              index = index0,
                              i = i0;
                            if (allEmpty) {
                              if (!decoder.readBit(contexts, 18)) {
                                bitsDecoded[index0]++,
                                  bitsDecoded[index0 + oneRowDown]++,
                                  bitsDecoded[index0 + twoRowsDown]++,
                                  bitsDecoded[index0 + threeRowsDown]++;
                                continue;
                              }
                              (i1 = (decoder.readBit(contexts, 17) << 1) | decoder.readBit(contexts, 17)),
                                0 !== i1 && ((i = i0 + i1), (index += i1 * width)),
                                (sign = this.decodeSignBit(i, j, index)),
                                (coefficentsSign[index] = sign),
                                (coefficentsMagnitude[index] = 1),
                                this.setNeighborsSignificance(i, j, index),
                                (processingFlags[index] |= 2),
                                (index = index0);
                              for (var i2 = i0; i2 <= i; i2++, index += width) bitsDecoded[index]++;
                              i1++;
                            }
                            for (i = i0 + i1; i < iNext; i++, index += width)
                              if (!coefficentsMagnitude[index] && 0 == (1 & processingFlags[index])) {
                                var contextLabel = labels[neighborsSignificance[index]],
                                  decision = decoder.readBit(contexts, contextLabel);
                                1 === decision &&
                                  ((sign = this.decodeSignBit(i, j, index)),
                                  (coefficentsSign[index] = sign),
                                  (coefficentsMagnitude[index] = 1),
                                  this.setNeighborsSignificance(i, j, index),
                                  (processingFlags[index] |= 2)),
                                  bitsDecoded[index]++;
                              }
                          }
                        }
                      },
                      checkSegmentationSymbol: function () {
                        var decoder = this.decoder,
                          contexts = this.contexts;
                        10 !=
                          ((decoder.readBit(contexts, 17) << 3) |
                            (decoder.readBit(contexts, 17) << 2) |
                            (decoder.readBit(contexts, 17) << 1) |
                            decoder.readBit(contexts, 17)) && error("JPX Error: Invalid segmentation symbol");
                      },
                    }),
                    BitModel
                  );
                })(),
                Transform = (function () {
                  function Transform() {}
                  return (
                    (Transform.prototype.calculate = function (subbands, u0, v0) {
                      for (var ll = subbands[0], i = 1, ii = subbands.length; i < ii; i++)
                        ll = this.iterate(ll, subbands[i], u0, v0);
                      return ll;
                    }),
                    (Transform.prototype.extend = function (buffer, offset, size) {
                      var i1 = offset - 1,
                        j1 = offset + 1,
                        i2 = offset + size - 2,
                        j2 = offset + size;
                      (buffer[i1--] = buffer[j1++]),
                        (buffer[j2++] = buffer[i2--]),
                        (buffer[i1--] = buffer[j1++]),
                        (buffer[j2++] = buffer[i2--]),
                        (buffer[i1--] = buffer[j1++]),
                        (buffer[j2++] = buffer[i2--]),
                        (buffer[i1] = buffer[j1]),
                        (buffer[j2] = buffer[i2]);
                    }),
                    (Transform.prototype.iterate = function (ll, hl_lh_hh, u0, v0) {
                      var i,
                        j,
                        k,
                        l,
                        u,
                        v,
                        llWidth = ll.width,
                        llHeight = ll.height,
                        llItems = ll.items,
                        width = hl_lh_hh.width,
                        height = hl_lh_hh.height,
                        items = hl_lh_hh.items;
                      for (k = 0, i = 0; i < llHeight; i++)
                        for (l = 2 * i * width, j = 0; j < llWidth; j++, k++, l += 2) items[l] = llItems[k];
                      llItems = ll.items = null;
                      var rowBuffer = new Float32Array(width + 8);
                      if (1 === width) {
                        if (0 != (1 & u0)) for (v = 0, k = 0; v < height; v++, k += width) items[k] *= 0.5;
                      } else
                        for (v = 0, k = 0; v < height; v++, k += width)
                          rowBuffer.set(items.subarray(k, k + width), 4),
                            this.extend(rowBuffer, 4, width),
                            this.filter(rowBuffer, 4, width),
                            items.set(rowBuffer.subarray(4, 4 + width), k);
                      var numBuffers = 16,
                        colBuffers = [];
                      for (i = 0; i < numBuffers; i++) colBuffers.push(new Float32Array(height + 8));
                      var b,
                        currentBuffer = 0;
                      if (((ll = 4 + height), 1 === height)) {
                        if (0 != (1 & v0)) for (u = 0; u < width; u++) items[u] *= 0.5;
                      } else
                        for (u = 0; u < width; u++) {
                          if (0 === currentBuffer) {
                            for (numBuffers = Math.min(width - u, numBuffers), k = u, l = 4; l < ll; k += width, l++)
                              for (b = 0; b < numBuffers; b++) colBuffers[b][l] = items[k + b];
                            currentBuffer = numBuffers;
                          }
                          currentBuffer--;
                          var buffer = colBuffers[currentBuffer];
                          if ((this.extend(buffer, 4, height), this.filter(buffer, 4, height), 0 === currentBuffer))
                            for (k = u - numBuffers + 1, l = 4; l < ll; k += width, l++)
                              for (b = 0; b < numBuffers; b++) items[k + b] = colBuffers[b][l];
                        }
                      return { width: width, height: height, items: items };
                    }),
                    Transform
                  );
                })(),
                IrreversibleTransform = (function () {
                  function IrreversibleTransform() {
                    Transform.call(this);
                  }
                  return (
                    (IrreversibleTransform.prototype = Object.create(Transform.prototype)),
                    (IrreversibleTransform.prototype.filter = function (x, offset, length) {
                      var len = length >> 1;
                      offset |= 0;
                      var j,
                        n,
                        current,
                        next,
                        alpha = -1.586134342059924,
                        beta = -0.052980118572961,
                        gamma = 0.882911075530934,
                        delta = 0.443506852043971,
                        K = 1.230174104914001;
                      for (j = offset - 3, n = len + 4; n--; j += 2) x[j] *= 0.8128930661159609;
                      for (
                        j = offset - 2, current = delta * x[j - 1], n = len + 3;
                        n-- && ((next = delta * x[j + 1]), (x[j] = K * x[j] - current - next), n--);
                        j += 2
                      )
                        (j += 2), (current = delta * x[j + 1]), (x[j] = K * x[j] - current - next);
                      for (
                        j = offset - 1, current = gamma * x[j - 1], n = len + 2;
                        n-- && ((next = gamma * x[j + 1]), (x[j] -= current + next), n--);
                        j += 2
                      )
                        (j += 2), (current = gamma * x[j + 1]), (x[j] -= current + next);
                      for (
                        j = offset, current = beta * x[j - 1], n = len + 1;
                        n-- && ((next = beta * x[j + 1]), (x[j] -= current + next), n--);
                        j += 2
                      )
                        (j += 2), (current = beta * x[j + 1]), (x[j] -= current + next);
                      if (0 !== len)
                        for (
                          j = offset + 1, current = alpha * x[j - 1], n = len;
                          n-- && ((next = alpha * x[j + 1]), (x[j] -= current + next), n--);
                          j += 2
                        )
                          (j += 2), (current = alpha * x[j + 1]), (x[j] -= current + next);
                    }),
                    IrreversibleTransform
                  );
                })(),
                ReversibleTransform = (function () {
                  function ReversibleTransform() {
                    Transform.call(this);
                  }
                  return (
                    (ReversibleTransform.prototype = Object.create(Transform.prototype)),
                    (ReversibleTransform.prototype.filter = function (x, offset, length) {
                      var len = length >> 1;
                      offset |= 0;
                      var j, n;
                      for (j = offset, n = len + 1; n--; j += 2) x[j] -= (x[j - 1] + x[j + 1] + 2) >> 2;
                      for (j = offset + 1, n = len; n--; j += 2) x[j] += (x[j - 1] + x[j + 1]) >> 1;
                    }),
                    ReversibleTransform
                  );
                })();
              return JpxImage;
            })();
          exports.JpxImage = JpxImage;
        })((root.pdfjsCoreJpx = {}), root.pdfjsSharedUtil, root.pdfjsCoreArithmeticDecoder);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil) {
          var getLookupTableFactory = sharedUtil.getLookupTableFactory,
            getMetrics = getLookupTableFactory(function (t) {
              (t.Courier = 600),
                (t["Courier-Bold"] = 600),
                (t["Courier-BoldOblique"] = 600),
                (t["Courier-Oblique"] = 600),
                (t.Helvetica = getLookupTableFactory(function (t) {
                  (t.space = 278),
                    (t.exclam = 278),
                    (t.quotedbl = 355),
                    (t.numbersign = 556),
                    (t.dollar = 556),
                    (t.percent = 889),
                    (t.ampersand = 667),
                    (t.quoteright = 222),
                    (t.parenleft = 333),
                    (t.parenright = 333),
                    (t.asterisk = 389),
                    (t.plus = 584),
                    (t.comma = 278),
                    (t.hyphen = 333),
                    (t.period = 278),
                    (t.slash = 278),
                    (t.zero = 556),
                    (t.one = 556),
                    (t.two = 556),
                    (t.three = 556),
                    (t.four = 556),
                    (t.five = 556),
                    (t.six = 556),
                    (t.seven = 556),
                    (t.eight = 556),
                    (t.nine = 556),
                    (t.colon = 278),
                    (t.semicolon = 278),
                    (t.less = 584),
                    (t.equal = 584),
                    (t.greater = 584),
                    (t.question = 556),
                    (t.at = 1015),
                    (t.A = 667),
                    (t.B = 667),
                    (t.C = 722),
                    (t.D = 722),
                    (t.E = 667),
                    (t.F = 611),
                    (t.G = 778),
                    (t.H = 722),
                    (t.I = 278),
                    (t.J = 500),
                    (t.K = 667),
                    (t.L = 556),
                    (t.M = 833),
                    (t.N = 722),
                    (t.O = 778),
                    (t.P = 667),
                    (t.Q = 778),
                    (t.R = 722),
                    (t.S = 667),
                    (t.T = 611),
                    (t.U = 722),
                    (t.V = 667),
                    (t.W = 944),
                    (t.X = 667),
                    (t.Y = 667),
                    (t.Z = 611),
                    (t.bracketleft = 278),
                    (t.backslash = 278),
                    (t.bracketright = 278),
                    (t.asciicircum = 469),
                    (t.underscore = 556),
                    (t.quoteleft = 222),
                    (t.a = 556),
                    (t.b = 556),
                    (t.c = 500),
                    (t.d = 556),
                    (t.e = 556),
                    (t.f = 278),
                    (t.g = 556),
                    (t.h = 556),
                    (t.i = 222),
                    (t.j = 222),
                    (t.k = 500),
                    (t.l = 222),
                    (t.m = 833),
                    (t.n = 556),
                    (t.o = 556),
                    (t.p = 556),
                    (t.q = 556),
                    (t.r = 333),
                    (t.s = 500),
                    (t.t = 278),
                    (t.u = 556),
                    (t.v = 500),
                    (t.w = 722),
                    (t.x = 500),
                    (t.y = 500),
                    (t.z = 500),
                    (t.braceleft = 334),
                    (t.bar = 260),
                    (t.braceright = 334),
                    (t.asciitilde = 584),
                    (t.exclamdown = 333),
                    (t.cent = 556),
                    (t.sterling = 556),
                    (t.fraction = 167),
                    (t.yen = 556),
                    (t.florin = 556),
                    (t.section = 556),
                    (t.currency = 556),
                    (t.quotesingle = 191),
                    (t.quotedblleft = 333),
                    (t.guillemotleft = 556),
                    (t.guilsinglleft = 333),
                    (t.guilsinglright = 333),
                    (t.fi = 500),
                    (t.fl = 500),
                    (t.endash = 556),
                    (t.dagger = 556),
                    (t.daggerdbl = 556),
                    (t.periodcentered = 278),
                    (t.paragraph = 537),
                    (t.bullet = 350),
                    (t.quotesinglbase = 222),
                    (t.quotedblbase = 333),
                    (t.quotedblright = 333),
                    (t.guillemotright = 556),
                    (t.ellipsis = 1e3),
                    (t.perthousand = 1e3),
                    (t.questiondown = 611),
                    (t.grave = 333),
                    (t.acute = 333),
                    (t.circumflex = 333),
                    (t.tilde = 333),
                    (t.macron = 333),
                    (t.breve = 333),
                    (t.dotaccent = 333),
                    (t.dieresis = 333),
                    (t.ring = 333),
                    (t.cedilla = 333),
                    (t.hungarumlaut = 333),
                    (t.ogonek = 333),
                    (t.caron = 333),
                    (t.emdash = 1e3),
                    (t.AE = 1e3),
                    (t.ordfeminine = 370),
                    (t.Lslash = 556),
                    (t.Oslash = 778),
                    (t.OE = 1e3),
                    (t.ordmasculine = 365),
                    (t.ae = 889),
                    (t.dotlessi = 278),
                    (t.lslash = 222),
                    (t.oslash = 611),
                    (t.oe = 944),
                    (t.germandbls = 611),
                    (t.Idieresis = 278),
                    (t.eacute = 556),
                    (t.abreve = 556),
                    (t.uhungarumlaut = 556),
                    (t.ecaron = 556),
                    (t.Ydieresis = 667),
                    (t.divide = 584),
                    (t.Yacute = 667),
                    (t.Acircumflex = 667),
                    (t.aacute = 556),
                    (t.Ucircumflex = 722),
                    (t.yacute = 500),
                    (t.scommaaccent = 500),
                    (t.ecircumflex = 556),
                    (t.Uring = 722),
                    (t.Udieresis = 722),
                    (t.aogonek = 556),
                    (t.Uacute = 722),
                    (t.uogonek = 556),
                    (t.Edieresis = 667),
                    (t.Dcroat = 722),
                    (t.commaaccent = 250),
                    (t.copyright = 737),
                    (t.Emacron = 667),
                    (t.ccaron = 500),
                    (t.aring = 556),
                    (t.Ncommaaccent = 722),
                    (t.lacute = 222),
                    (t.agrave = 556),
                    (t.Tcommaaccent = 611),
                    (t.Cacute = 722),
                    (t.atilde = 556),
                    (t.Edotaccent = 667),
                    (t.scaron = 500),
                    (t.scedilla = 500),
                    (t.iacute = 278),
                    (t.lozenge = 471),
                    (t.Rcaron = 722),
                    (t.Gcommaaccent = 778),
                    (t.ucircumflex = 556),
                    (t.acircumflex = 556),
                    (t.Amacron = 667),
                    (t.rcaron = 333),
                    (t.ccedilla = 500),
                    (t.Zdotaccent = 611),
                    (t.Thorn = 667),
                    (t.Omacron = 778),
                    (t.Racute = 722),
                    (t.Sacute = 667),
                    (t.dcaron = 643),
                    (t.Umacron = 722);
                  (t.uring = 556),
                    (t.threesuperior = 333),
                    (t.Ograve = 778),
                    (t.Agrave = 667),
                    (t.Abreve = 667),
                    (t.multiply = 584),
                    (t.uacute = 556),
                    (t.Tcaron = 611),
                    (t.partialdiff = 476),
                    (t.ydieresis = 500),
                    (t.Nacute = 722),
                    (t.icircumflex = 278),
                    (t.Ecircumflex = 667),
                    (t.adieresis = 556),
                    (t.edieresis = 556),
                    (t.cacute = 500),
                    (t.nacute = 556),
                    (t.umacron = 556),
                    (t.Ncaron = 722),
                    (t.Iacute = 278),
                    (t.plusminus = 584),
                    (t.brokenbar = 260),
                    (t.registered = 737),
                    (t.Gbreve = 778),
                    (t.Idotaccent = 278),
                    (t.summation = 600),
                    (t.Egrave = 667),
                    (t.racute = 333),
                    (t.omacron = 556),
                    (t.Zacute = 611),
                    (t.Zcaron = 611),
                    (t.greaterequal = 549),
                    (t.Eth = 722),
                    (t.Ccedilla = 722),
                    (t.lcommaaccent = 222),
                    (t.tcaron = 317),
                    (t.eogonek = 556),
                    (t.Uogonek = 722),
                    (t.Aacute = 667),
                    (t.Adieresis = 667),
                    (t.egrave = 556),
                    (t.zacute = 500),
                    (t.iogonek = 222),
                    (t.Oacute = 778),
                    (t.oacute = 556),
                    (t.amacron = 556),
                    (t.sacute = 500),
                    (t.idieresis = 278),
                    (t.Ocircumflex = 778),
                    (t.Ugrave = 722),
                    (t.Delta = 612),
                    (t.thorn = 556),
                    (t.twosuperior = 333),
                    (t.Odieresis = 778),
                    (t.mu = 556),
                    (t.igrave = 278),
                    (t.ohungarumlaut = 556),
                    (t.Eogonek = 667),
                    (t.dcroat = 556),
                    (t.threequarters = 834),
                    (t.Scedilla = 667),
                    (t.lcaron = 299),
                    (t.Kcommaaccent = 667),
                    (t.Lacute = 556),
                    (t.trademark = 1e3),
                    (t.edotaccent = 556),
                    (t.Igrave = 278),
                    (t.Imacron = 278),
                    (t.Lcaron = 556),
                    (t.onehalf = 834),
                    (t.lessequal = 549),
                    (t.ocircumflex = 556),
                    (t.ntilde = 556),
                    (t.Uhungarumlaut = 722),
                    (t.Eacute = 667),
                    (t.emacron = 556),
                    (t.gbreve = 556),
                    (t.onequarter = 834),
                    (t.Scaron = 667),
                    (t.Scommaaccent = 667),
                    (t.Ohungarumlaut = 778),
                    (t.degree = 400),
                    (t.ograve = 556),
                    (t.Ccaron = 722),
                    (t.ugrave = 556),
                    (t.radical = 453),
                    (t.Dcaron = 722),
                    (t.rcommaaccent = 333),
                    (t.Ntilde = 722),
                    (t.otilde = 556),
                    (t.Rcommaaccent = 722),
                    (t.Lcommaaccent = 556),
                    (t.Atilde = 667),
                    (t.Aogonek = 667),
                    (t.Aring = 667),
                    (t.Otilde = 778),
                    (t.zdotaccent = 500),
                    (t.Ecaron = 667),
                    (t.Iogonek = 278),
                    (t.kcommaaccent = 500),
                    (t.minus = 584),
                    (t.Icircumflex = 278),
                    (t.ncaron = 556),
                    (t.tcommaaccent = 278),
                    (t.logicalnot = 584),
                    (t.odieresis = 556),
                    (t.udieresis = 556),
                    (t.notequal = 549),
                    (t.gcommaaccent = 556),
                    (t.eth = 556),
                    (t.zcaron = 500),
                    (t.ncommaaccent = 556),
                    (t.onesuperior = 333),
                    (t.imacron = 278),
                    (t.Euro = 556);
                })),
                (t["Helvetica-Bold"] = getLookupTableFactory(function (t) {
                  (t.space = 278),
                    (t.exclam = 333),
                    (t.quotedbl = 474),
                    (t.numbersign = 556),
                    (t.dollar = 556),
                    (t.percent = 889),
                    (t.ampersand = 722),
                    (t.quoteright = 278),
                    (t.parenleft = 333),
                    (t.parenright = 333),
                    (t.asterisk = 389),
                    (t.plus = 584),
                    (t.comma = 278),
                    (t.hyphen = 333),
                    (t.period = 278),
                    (t.slash = 278),
                    (t.zero = 556),
                    (t.one = 556),
                    (t.two = 556),
                    (t.three = 556),
                    (t.four = 556),
                    (t.five = 556),
                    (t.six = 556),
                    (t.seven = 556),
                    (t.eight = 556),
                    (t.nine = 556),
                    (t.colon = 333),
                    (t.semicolon = 333),
                    (t.less = 584),
                    (t.equal = 584),
                    (t.greater = 584),
                    (t.question = 611),
                    (t.at = 975),
                    (t.A = 722),
                    (t.B = 722),
                    (t.C = 722),
                    (t.D = 722),
                    (t.E = 667),
                    (t.F = 611),
                    (t.G = 778),
                    (t.H = 722),
                    (t.I = 278),
                    (t.J = 556),
                    (t.K = 722),
                    (t.L = 611),
                    (t.M = 833),
                    (t.N = 722),
                    (t.O = 778),
                    (t.P = 667),
                    (t.Q = 778),
                    (t.R = 722),
                    (t.S = 667),
                    (t.T = 611),
                    (t.U = 722),
                    (t.V = 667),
                    (t.W = 944),
                    (t.X = 667),
                    (t.Y = 667),
                    (t.Z = 611),
                    (t.bracketleft = 333),
                    (t.backslash = 278),
                    (t.bracketright = 333),
                    (t.asciicircum = 584),
                    (t.underscore = 556),
                    (t.quoteleft = 278),
                    (t.a = 556),
                    (t.b = 611),
                    (t.c = 556),
                    (t.d = 611),
                    (t.e = 556),
                    (t.f = 333),
                    (t.g = 611),
                    (t.h = 611),
                    (t.i = 278),
                    (t.j = 278),
                    (t.k = 556),
                    (t.l = 278),
                    (t.m = 889),
                    (t.n = 611),
                    (t.o = 611),
                    (t.p = 611),
                    (t.q = 611),
                    (t.r = 389),
                    (t.s = 556),
                    (t.t = 333),
                    (t.u = 611),
                    (t.v = 556),
                    (t.w = 778),
                    (t.x = 556),
                    (t.y = 556),
                    (t.z = 500),
                    (t.braceleft = 389),
                    (t.bar = 280),
                    (t.braceright = 389),
                    (t.asciitilde = 584),
                    (t.exclamdown = 333),
                    (t.cent = 556),
                    (t.sterling = 556),
                    (t.fraction = 167),
                    (t.yen = 556),
                    (t.florin = 556),
                    (t.section = 556),
                    (t.currency = 556),
                    (t.quotesingle = 238),
                    (t.quotedblleft = 500),
                    (t.guillemotleft = 556),
                    (t.guilsinglleft = 333),
                    (t.guilsinglright = 333),
                    (t.fi = 611),
                    (t.fl = 611),
                    (t.endash = 556),
                    (t.dagger = 556),
                    (t.daggerdbl = 556),
                    (t.periodcentered = 278),
                    (t.paragraph = 556),
                    (t.bullet = 350),
                    (t.quotesinglbase = 278),
                    (t.quotedblbase = 500),
                    (t.quotedblright = 500),
                    (t.guillemotright = 556),
                    (t.ellipsis = 1e3),
                    (t.perthousand = 1e3),
                    (t.questiondown = 611),
                    (t.grave = 333),
                    (t.acute = 333),
                    (t.circumflex = 333),
                    (t.tilde = 333),
                    (t.macron = 333),
                    (t.breve = 333),
                    (t.dotaccent = 333),
                    (t.dieresis = 333),
                    (t.ring = 333),
                    (t.cedilla = 333),
                    (t.hungarumlaut = 333),
                    (t.ogonek = 333),
                    (t.caron = 333),
                    (t.emdash = 1e3),
                    (t.AE = 1e3),
                    (t.ordfeminine = 370),
                    (t.Lslash = 611),
                    (t.Oslash = 778),
                    (t.OE = 1e3),
                    (t.ordmasculine = 365),
                    (t.ae = 889),
                    (t.dotlessi = 278),
                    (t.lslash = 278),
                    (t.oslash = 611),
                    (t.oe = 944),
                    (t.germandbls = 611),
                    (t.Idieresis = 278),
                    (t.eacute = 556),
                    (t.abreve = 556),
                    (t.uhungarumlaut = 611),
                    (t.ecaron = 556),
                    (t.Ydieresis = 667),
                    (t.divide = 584),
                    (t.Yacute = 667),
                    (t.Acircumflex = 722),
                    (t.aacute = 556),
                    (t.Ucircumflex = 722),
                    (t.yacute = 556),
                    (t.scommaaccent = 556),
                    (t.ecircumflex = 556),
                    (t.Uring = 722),
                    (t.Udieresis = 722),
                    (t.aogonek = 556),
                    (t.Uacute = 722),
                    (t.uogonek = 611),
                    (t.Edieresis = 667),
                    (t.Dcroat = 722),
                    (t.commaaccent = 250),
                    (t.copyright = 737),
                    (t.Emacron = 667),
                    (t.ccaron = 556),
                    (t.aring = 556),
                    (t.Ncommaaccent = 722),
                    (t.lacute = 278),
                    (t.agrave = 556),
                    (t.Tcommaaccent = 611),
                    (t.Cacute = 722),
                    (t.atilde = 556),
                    (t.Edotaccent = 667),
                    (t.scaron = 556),
                    (t.scedilla = 556),
                    (t.iacute = 278),
                    (t.lozenge = 494),
                    (t.Rcaron = 722),
                    (t.Gcommaaccent = 778),
                    (t.ucircumflex = 611),
                    (t.acircumflex = 556),
                    (t.Amacron = 722),
                    (t.rcaron = 389),
                    (t.ccedilla = 556),
                    (t.Zdotaccent = 611),
                    (t.Thorn = 667),
                    (t.Omacron = 778),
                    (t.Racute = 722),
                    (t.Sacute = 667),
                    (t.dcaron = 743),
                    (t.Umacron = 722);
                  (t.uring = 611),
                    (t.threesuperior = 333),
                    (t.Ograve = 778),
                    (t.Agrave = 722),
                    (t.Abreve = 722),
                    (t.multiply = 584),
                    (t.uacute = 611),
                    (t.Tcaron = 611),
                    (t.partialdiff = 494),
                    (t.ydieresis = 556),
                    (t.Nacute = 722),
                    (t.icircumflex = 278),
                    (t.Ecircumflex = 667),
                    (t.adieresis = 556),
                    (t.edieresis = 556),
                    (t.cacute = 556),
                    (t.nacute = 611),
                    (t.umacron = 611),
                    (t.Ncaron = 722),
                    (t.Iacute = 278),
                    (t.plusminus = 584),
                    (t.brokenbar = 280),
                    (t.registered = 737),
                    (t.Gbreve = 778),
                    (t.Idotaccent = 278),
                    (t.summation = 600),
                    (t.Egrave = 667),
                    (t.racute = 389),
                    (t.omacron = 611),
                    (t.Zacute = 611),
                    (t.Zcaron = 611),
                    (t.greaterequal = 549),
                    (t.Eth = 722),
                    (t.Ccedilla = 722),
                    (t.lcommaaccent = 278),
                    (t.tcaron = 389),
                    (t.eogonek = 556),
                    (t.Uogonek = 722),
                    (t.Aacute = 722),
                    (t.Adieresis = 722),
                    (t.egrave = 556),
                    (t.zacute = 500),
                    (t.iogonek = 278),
                    (t.Oacute = 778),
                    (t.oacute = 611),
                    (t.amacron = 556),
                    (t.sacute = 556),
                    (t.idieresis = 278),
                    (t.Ocircumflex = 778),
                    (t.Ugrave = 722),
                    (t.Delta = 612),
                    (t.thorn = 611),
                    (t.twosuperior = 333),
                    (t.Odieresis = 778),
                    (t.mu = 611),
                    (t.igrave = 278),
                    (t.ohungarumlaut = 611),
                    (t.Eogonek = 667),
                    (t.dcroat = 611),
                    (t.threequarters = 834),
                    (t.Scedilla = 667),
                    (t.lcaron = 400),
                    (t.Kcommaaccent = 722),
                    (t.Lacute = 611),
                    (t.trademark = 1e3),
                    (t.edotaccent = 556),
                    (t.Igrave = 278),
                    (t.Imacron = 278),
                    (t.Lcaron = 611),
                    (t.onehalf = 834),
                    (t.lessequal = 549),
                    (t.ocircumflex = 611),
                    (t.ntilde = 611),
                    (t.Uhungarumlaut = 722),
                    (t.Eacute = 667),
                    (t.emacron = 556),
                    (t.gbreve = 611),
                    (t.onequarter = 834),
                    (t.Scaron = 667),
                    (t.Scommaaccent = 667),
                    (t.Ohungarumlaut = 778),
                    (t.degree = 400),
                    (t.ograve = 611),
                    (t.Ccaron = 722),
                    (t.ugrave = 611),
                    (t.radical = 549),
                    (t.Dcaron = 722),
                    (t.rcommaaccent = 389),
                    (t.Ntilde = 722),
                    (t.otilde = 611),
                    (t.Rcommaaccent = 722),
                    (t.Lcommaaccent = 611),
                    (t.Atilde = 722),
                    (t.Aogonek = 722),
                    (t.Aring = 722),
                    (t.Otilde = 778),
                    (t.zdotaccent = 500),
                    (t.Ecaron = 667),
                    (t.Iogonek = 278),
                    (t.kcommaaccent = 556),
                    (t.minus = 584),
                    (t.Icircumflex = 278),
                    (t.ncaron = 611),
                    (t.tcommaaccent = 333),
                    (t.logicalnot = 584),
                    (t.odieresis = 611),
                    (t.udieresis = 611),
                    (t.notequal = 549),
                    (t.gcommaaccent = 611),
                    (t.eth = 611),
                    (t.zcaron = 500),
                    (t.ncommaaccent = 611),
                    (t.onesuperior = 333),
                    (t.imacron = 278),
                    (t.Euro = 556);
                })),
                (t["Helvetica-BoldOblique"] = getLookupTableFactory(function (t) {
                  (t.space = 278),
                    (t.exclam = 333),
                    (t.quotedbl = 474),
                    (t.numbersign = 556),
                    (t.dollar = 556),
                    (t.percent = 889),
                    (t.ampersand = 722),
                    (t.quoteright = 278),
                    (t.parenleft = 333),
                    (t.parenright = 333),
                    (t.asterisk = 389),
                    (t.plus = 584),
                    (t.comma = 278),
                    (t.hyphen = 333),
                    (t.period = 278),
                    (t.slash = 278),
                    (t.zero = 556),
                    (t.one = 556),
                    (t.two = 556),
                    (t.three = 556),
                    (t.four = 556),
                    (t.five = 556),
                    (t.six = 556),
                    (t.seven = 556),
                    (t.eight = 556),
                    (t.nine = 556),
                    (t.colon = 333),
                    (t.semicolon = 333),
                    (t.less = 584),
                    (t.equal = 584),
                    (t.greater = 584),
                    (t.question = 611),
                    (t.at = 975),
                    (t.A = 722),
                    (t.B = 722),
                    (t.C = 722),
                    (t.D = 722),
                    (t.E = 667),
                    (t.F = 611),
                    (t.G = 778),
                    (t.H = 722),
                    (t.I = 278),
                    (t.J = 556),
                    (t.K = 722),
                    (t.L = 611),
                    (t.M = 833),
                    (t.N = 722),
                    (t.O = 778),
                    (t.P = 667),
                    (t.Q = 778),
                    (t.R = 722),
                    (t.S = 667),
                    (t.T = 611),
                    (t.U = 722),
                    (t.V = 667),
                    (t.W = 944),
                    (t.X = 667),
                    (t.Y = 667),
                    (t.Z = 611),
                    (t.bracketleft = 333),
                    (t.backslash = 278),
                    (t.bracketright = 333),
                    (t.asciicircum = 584),
                    (t.underscore = 556),
                    (t.quoteleft = 278),
                    (t.a = 556),
                    (t.b = 611),
                    (t.c = 556),
                    (t.d = 611),
                    (t.e = 556),
                    (t.f = 333),
                    (t.g = 611),
                    (t.h = 611),
                    (t.i = 278),
                    (t.j = 278),
                    (t.k = 556),
                    (t.l = 278),
                    (t.m = 889),
                    (t.n = 611),
                    (t.o = 611),
                    (t.p = 611),
                    (t.q = 611),
                    (t.r = 389),
                    (t.s = 556),
                    (t.t = 333),
                    (t.u = 611),
                    (t.v = 556),
                    (t.w = 778),
                    (t.x = 556),
                    (t.y = 556),
                    (t.z = 500),
                    (t.braceleft = 389),
                    (t.bar = 280),
                    (t.braceright = 389),
                    (t.asciitilde = 584),
                    (t.exclamdown = 333),
                    (t.cent = 556),
                    (t.sterling = 556),
                    (t.fraction = 167),
                    (t.yen = 556),
                    (t.florin = 556),
                    (t.section = 556),
                    (t.currency = 556),
                    (t.quotesingle = 238),
                    (t.quotedblleft = 500),
                    (t.guillemotleft = 556),
                    (t.guilsinglleft = 333),
                    (t.guilsinglright = 333),
                    (t.fi = 611),
                    (t.fl = 611),
                    (t.endash = 556),
                    (t.dagger = 556),
                    (t.daggerdbl = 556),
                    (t.periodcentered = 278),
                    (t.paragraph = 556),
                    (t.bullet = 350),
                    (t.quotesinglbase = 278),
                    (t.quotedblbase = 500),
                    (t.quotedblright = 500),
                    (t.guillemotright = 556),
                    (t.ellipsis = 1e3),
                    (t.perthousand = 1e3),
                    (t.questiondown = 611),
                    (t.grave = 333),
                    (t.acute = 333),
                    (t.circumflex = 333),
                    (t.tilde = 333),
                    (t.macron = 333),
                    (t.breve = 333),
                    (t.dotaccent = 333),
                    (t.dieresis = 333),
                    (t.ring = 333),
                    (t.cedilla = 333),
                    (t.hungarumlaut = 333),
                    (t.ogonek = 333),
                    (t.caron = 333),
                    (t.emdash = 1e3),
                    (t.AE = 1e3),
                    (t.ordfeminine = 370),
                    (t.Lslash = 611),
                    (t.Oslash = 778),
                    (t.OE = 1e3),
                    (t.ordmasculine = 365),
                    (t.ae = 889),
                    (t.dotlessi = 278),
                    (t.lslash = 278),
                    (t.oslash = 611),
                    (t.oe = 944),
                    (t.germandbls = 611),
                    (t.Idieresis = 278),
                    (t.eacute = 556),
                    (t.abreve = 556),
                    (t.uhungarumlaut = 611),
                    (t.ecaron = 556),
                    (t.Ydieresis = 667),
                    (t.divide = 584),
                    (t.Yacute = 667),
                    (t.Acircumflex = 722),
                    (t.aacute = 556),
                    (t.Ucircumflex = 722),
                    (t.yacute = 556),
                    (t.scommaaccent = 556),
                    (t.ecircumflex = 556),
                    (t.Uring = 722),
                    (t.Udieresis = 722),
                    (t.aogonek = 556),
                    (t.Uacute = 722),
                    (t.uogonek = 611),
                    (t.Edieresis = 667),
                    (t.Dcroat = 722),
                    (t.commaaccent = 250),
                    (t.copyright = 737),
                    (t.Emacron = 667),
                    (t.ccaron = 556),
                    (t.aring = 556),
                    (t.Ncommaaccent = 722),
                    (t.lacute = 278),
                    (t.agrave = 556),
                    (t.Tcommaaccent = 611),
                    (t.Cacute = 722),
                    (t.atilde = 556),
                    (t.Edotaccent = 667),
                    (t.scaron = 556),
                    (t.scedilla = 556),
                    (t.iacute = 278),
                    (t.lozenge = 494),
                    (t.Rcaron = 722),
                    (t.Gcommaaccent = 778),
                    (t.ucircumflex = 611),
                    (t.acircumflex = 556),
                    (t.Amacron = 722),
                    (t.rcaron = 389),
                    (t.ccedilla = 556),
                    (t.Zdotaccent = 611),
                    (t.Thorn = 667),
                    (t.Omacron = 778),
                    (t.Racute = 722),
                    (t.Sacute = 667),
                    (t.dcaron = 743),
                    (t.Umacron = 722);
                  (t.uring = 611),
                    (t.threesuperior = 333),
                    (t.Ograve = 778),
                    (t.Agrave = 722),
                    (t.Abreve = 722),
                    (t.multiply = 584),
                    (t.uacute = 611),
                    (t.Tcaron = 611),
                    (t.partialdiff = 494),
                    (t.ydieresis = 556),
                    (t.Nacute = 722),
                    (t.icircumflex = 278),
                    (t.Ecircumflex = 667),
                    (t.adieresis = 556),
                    (t.edieresis = 556),
                    (t.cacute = 556),
                    (t.nacute = 611),
                    (t.umacron = 611),
                    (t.Ncaron = 722),
                    (t.Iacute = 278),
                    (t.plusminus = 584),
                    (t.brokenbar = 280),
                    (t.registered = 737),
                    (t.Gbreve = 778),
                    (t.Idotaccent = 278),
                    (t.summation = 600),
                    (t.Egrave = 667),
                    (t.racute = 389),
                    (t.omacron = 611),
                    (t.Zacute = 611),
                    (t.Zcaron = 611),
                    (t.greaterequal = 549),
                    (t.Eth = 722),
                    (t.Ccedilla = 722),
                    (t.lcommaaccent = 278),
                    (t.tcaron = 389),
                    (t.eogonek = 556),
                    (t.Uogonek = 722),
                    (t.Aacute = 722),
                    (t.Adieresis = 722),
                    (t.egrave = 556),
                    (t.zacute = 500),
                    (t.iogonek = 278),
                    (t.Oacute = 778),
                    (t.oacute = 611),
                    (t.amacron = 556),
                    (t.sacute = 556),
                    (t.idieresis = 278),
                    (t.Ocircumflex = 778),
                    (t.Ugrave = 722),
                    (t.Delta = 612),
                    (t.thorn = 611),
                    (t.twosuperior = 333),
                    (t.Odieresis = 778),
                    (t.mu = 611),
                    (t.igrave = 278),
                    (t.ohungarumlaut = 611),
                    (t.Eogonek = 667),
                    (t.dcroat = 611),
                    (t.threequarters = 834),
                    (t.Scedilla = 667),
                    (t.lcaron = 400),
                    (t.Kcommaaccent = 722),
                    (t.Lacute = 611),
                    (t.trademark = 1e3),
                    (t.edotaccent = 556),
                    (t.Igrave = 278),
                    (t.Imacron = 278),
                    (t.Lcaron = 611),
                    (t.onehalf = 834),
                    (t.lessequal = 549),
                    (t.ocircumflex = 611),
                    (t.ntilde = 611),
                    (t.Uhungarumlaut = 722),
                    (t.Eacute = 667),
                    (t.emacron = 556),
                    (t.gbreve = 611),
                    (t.onequarter = 834),
                    (t.Scaron = 667),
                    (t.Scommaaccent = 667),
                    (t.Ohungarumlaut = 778),
                    (t.degree = 400),
                    (t.ograve = 611),
                    (t.Ccaron = 722),
                    (t.ugrave = 611),
                    (t.radical = 549),
                    (t.Dcaron = 722),
                    (t.rcommaaccent = 389),
                    (t.Ntilde = 722),
                    (t.otilde = 611),
                    (t.Rcommaaccent = 722),
                    (t.Lcommaaccent = 611),
                    (t.Atilde = 722),
                    (t.Aogonek = 722),
                    (t.Aring = 722),
                    (t.Otilde = 778),
                    (t.zdotaccent = 500),
                    (t.Ecaron = 667),
                    (t.Iogonek = 278),
                    (t.kcommaaccent = 556),
                    (t.minus = 584),
                    (t.Icircumflex = 278),
                    (t.ncaron = 611),
                    (t.tcommaaccent = 333),
                    (t.logicalnot = 584),
                    (t.odieresis = 611),
                    (t.udieresis = 611),
                    (t.notequal = 549),
                    (t.gcommaaccent = 611),
                    (t.eth = 611),
                    (t.zcaron = 500),
                    (t.ncommaaccent = 611),
                    (t.onesuperior = 333),
                    (t.imacron = 278),
                    (t.Euro = 556);
                })),
                (t["Helvetica-Oblique"] = getLookupTableFactory(function (t) {
                  (t.space = 278),
                    (t.exclam = 278),
                    (t.quotedbl = 355),
                    (t.numbersign = 556),
                    (t.dollar = 556),
                    (t.percent = 889),
                    (t.ampersand = 667),
                    (t.quoteright = 222),
                    (t.parenleft = 333),
                    (t.parenright = 333),
                    (t.asterisk = 389),
                    (t.plus = 584),
                    (t.comma = 278),
                    (t.hyphen = 333),
                    (t.period = 278),
                    (t.slash = 278),
                    (t.zero = 556),
                    (t.one = 556),
                    (t.two = 556),
                    (t.three = 556),
                    (t.four = 556),
                    (t.five = 556),
                    (t.six = 556),
                    (t.seven = 556),
                    (t.eight = 556),
                    (t.nine = 556),
                    (t.colon = 278),
                    (t.semicolon = 278),
                    (t.less = 584),
                    (t.equal = 584),
                    (t.greater = 584),
                    (t.question = 556),
                    (t.at = 1015),
                    (t.A = 667),
                    (t.B = 667),
                    (t.C = 722),
                    (t.D = 722),
                    (t.E = 667),
                    (t.F = 611),
                    (t.G = 778),
                    (t.H = 722),
                    (t.I = 278),
                    (t.J = 500),
                    (t.K = 667),
                    (t.L = 556),
                    (t.M = 833),
                    (t.N = 722),
                    (t.O = 778),
                    (t.P = 667),
                    (t.Q = 778),
                    (t.R = 722),
                    (t.S = 667),
                    (t.T = 611),
                    (t.U = 722),
                    (t.V = 667),
                    (t.W = 944),
                    (t.X = 667),
                    (t.Y = 667),
                    (t.Z = 611),
                    (t.bracketleft = 278),
                    (t.backslash = 278),
                    (t.bracketright = 278),
                    (t.asciicircum = 469),
                    (t.underscore = 556),
                    (t.quoteleft = 222),
                    (t.a = 556),
                    (t.b = 556),
                    (t.c = 500),
                    (t.d = 556),
                    (t.e = 556),
                    (t.f = 278),
                    (t.g = 556),
                    (t.h = 556),
                    (t.i = 222),
                    (t.j = 222),
                    (t.k = 500),
                    (t.l = 222),
                    (t.m = 833),
                    (t.n = 556),
                    (t.o = 556),
                    (t.p = 556),
                    (t.q = 556),
                    (t.r = 333),
                    (t.s = 500),
                    (t.t = 278),
                    (t.u = 556),
                    (t.v = 500),
                    (t.w = 722),
                    (t.x = 500),
                    (t.y = 500),
                    (t.z = 500),
                    (t.braceleft = 334),
                    (t.bar = 260),
                    (t.braceright = 334),
                    (t.asciitilde = 584),
                    (t.exclamdown = 333),
                    (t.cent = 556),
                    (t.sterling = 556),
                    (t.fraction = 167),
                    (t.yen = 556),
                    (t.florin = 556),
                    (t.section = 556),
                    (t.currency = 556),
                    (t.quotesingle = 191),
                    (t.quotedblleft = 333),
                    (t.guillemotleft = 556),
                    (t.guilsinglleft = 333),
                    (t.guilsinglright = 333),
                    (t.fi = 500),
                    (t.fl = 500),
                    (t.endash = 556),
                    (t.dagger = 556),
                    (t.daggerdbl = 556),
                    (t.periodcentered = 278),
                    (t.paragraph = 537),
                    (t.bullet = 350),
                    (t.quotesinglbase = 222),
                    (t.quotedblbase = 333),
                    (t.quotedblright = 333),
                    (t.guillemotright = 556),
                    (t.ellipsis = 1e3),
                    (t.perthousand = 1e3),
                    (t.questiondown = 611),
                    (t.grave = 333),
                    (t.acute = 333),
                    (t.circumflex = 333),
                    (t.tilde = 333),
                    (t.macron = 333),
                    (t.breve = 333),
                    (t.dotaccent = 333),
                    (t.dieresis = 333),
                    (t.ring = 333),
                    (t.cedilla = 333),
                    (t.hungarumlaut = 333),
                    (t.ogonek = 333),
                    (t.caron = 333),
                    (t.emdash = 1e3),
                    (t.AE = 1e3),
                    (t.ordfeminine = 370),
                    (t.Lslash = 556),
                    (t.Oslash = 778),
                    (t.OE = 1e3),
                    (t.ordmasculine = 365),
                    (t.ae = 889),
                    (t.dotlessi = 278),
                    (t.lslash = 222),
                    (t.oslash = 611),
                    (t.oe = 944),
                    (t.germandbls = 611),
                    (t.Idieresis = 278),
                    (t.eacute = 556),
                    (t.abreve = 556),
                    (t.uhungarumlaut = 556),
                    (t.ecaron = 556),
                    (t.Ydieresis = 667),
                    (t.divide = 584),
                    (t.Yacute = 667),
                    (t.Acircumflex = 667),
                    (t.aacute = 556),
                    (t.Ucircumflex = 722),
                    (t.yacute = 500),
                    (t.scommaaccent = 500),
                    (t.ecircumflex = 556),
                    (t.Uring = 722),
                    (t.Udieresis = 722),
                    (t.aogonek = 556),
                    (t.Uacute = 722),
                    (t.uogonek = 556),
                    (t.Edieresis = 667),
                    (t.Dcroat = 722),
                    (t.commaaccent = 250),
                    (t.copyright = 737),
                    (t.Emacron = 667),
                    (t.ccaron = 500),
                    (t.aring = 556),
                    (t.Ncommaaccent = 722),
                    (t.lacute = 222),
                    (t.agrave = 556),
                    (t.Tcommaaccent = 611),
                    (t.Cacute = 722),
                    (t.atilde = 556),
                    (t.Edotaccent = 667),
                    (t.scaron = 500),
                    (t.scedilla = 500),
                    (t.iacute = 278),
                    (t.lozenge = 471),
                    (t.Rcaron = 722),
                    (t.Gcommaaccent = 778),
                    (t.ucircumflex = 556),
                    (t.acircumflex = 556),
                    (t.Amacron = 667),
                    (t.rcaron = 333),
                    (t.ccedilla = 500),
                    (t.Zdotaccent = 611),
                    (t.Thorn = 667),
                    (t.Omacron = 778),
                    (t.Racute = 722),
                    (t.Sacute = 667),
                    (t.dcaron = 643),
                    (t.Umacron = 722);
                  (t.uring = 556),
                    (t.threesuperior = 333),
                    (t.Ograve = 778),
                    (t.Agrave = 667),
                    (t.Abreve = 667),
                    (t.multiply = 584),
                    (t.uacute = 556),
                    (t.Tcaron = 611),
                    (t.partialdiff = 476),
                    (t.ydieresis = 500),
                    (t.Nacute = 722),
                    (t.icircumflex = 278),
                    (t.Ecircumflex = 667),
                    (t.adieresis = 556),
                    (t.edieresis = 556),
                    (t.cacute = 500),
                    (t.nacute = 556),
                    (t.umacron = 556),
                    (t.Ncaron = 722),
                    (t.Iacute = 278),
                    (t.plusminus = 584),
                    (t.brokenbar = 260),
                    (t.registered = 737),
                    (t.Gbreve = 778),
                    (t.Idotaccent = 278),
                    (t.summation = 600),
                    (t.Egrave = 667),
                    (t.racute = 333),
                    (t.omacron = 556),
                    (t.Zacute = 611),
                    (t.Zcaron = 611),
                    (t.greaterequal = 549),
                    (t.Eth = 722),
                    (t.Ccedilla = 722),
                    (t.lcommaaccent = 222),
                    (t.tcaron = 317),
                    (t.eogonek = 556),
                    (t.Uogonek = 722),
                    (t.Aacute = 667),
                    (t.Adieresis = 667),
                    (t.egrave = 556),
                    (t.zacute = 500),
                    (t.iogonek = 222),
                    (t.Oacute = 778),
                    (t.oacute = 556),
                    (t.amacron = 556),
                    (t.sacute = 500),
                    (t.idieresis = 278),
                    (t.Ocircumflex = 778),
                    (t.Ugrave = 722),
                    (t.Delta = 612),
                    (t.thorn = 556),
                    (t.twosuperior = 333),
                    (t.Odieresis = 778),
                    (t.mu = 556),
                    (t.igrave = 278),
                    (t.ohungarumlaut = 556),
                    (t.Eogonek = 667),
                    (t.dcroat = 556),
                    (t.threequarters = 834),
                    (t.Scedilla = 667),
                    (t.lcaron = 299),
                    (t.Kcommaaccent = 667),
                    (t.Lacute = 556),
                    (t.trademark = 1e3),
                    (t.edotaccent = 556),
                    (t.Igrave = 278),
                    (t.Imacron = 278),
                    (t.Lcaron = 556),
                    (t.onehalf = 834),
                    (t.lessequal = 549),
                    (t.ocircumflex = 556),
                    (t.ntilde = 556),
                    (t.Uhungarumlaut = 722),
                    (t.Eacute = 667),
                    (t.emacron = 556),
                    (t.gbreve = 556),
                    (t.onequarter = 834),
                    (t.Scaron = 667),
                    (t.Scommaaccent = 667),
                    (t.Ohungarumlaut = 778),
                    (t.degree = 400),
                    (t.ograve = 556),
                    (t.Ccaron = 722),
                    (t.ugrave = 556),
                    (t.radical = 453),
                    (t.Dcaron = 722),
                    (t.rcommaaccent = 333),
                    (t.Ntilde = 722),
                    (t.otilde = 556),
                    (t.Rcommaaccent = 722),
                    (t.Lcommaaccent = 556),
                    (t.Atilde = 667),
                    (t.Aogonek = 667),
                    (t.Aring = 667),
                    (t.Otilde = 778),
                    (t.zdotaccent = 500),
                    (t.Ecaron = 667),
                    (t.Iogonek = 278),
                    (t.kcommaaccent = 500),
                    (t.minus = 584),
                    (t.Icircumflex = 278),
                    (t.ncaron = 556),
                    (t.tcommaaccent = 278),
                    (t.logicalnot = 584),
                    (t.odieresis = 556),
                    (t.udieresis = 556),
                    (t.notequal = 549),
                    (t.gcommaaccent = 556),
                    (t.eth = 556),
                    (t.zcaron = 500),
                    (t.ncommaaccent = 556),
                    (t.onesuperior = 333),
                    (t.imacron = 278),
                    (t.Euro = 556);
                })),
                (t.Symbol = getLookupTableFactory(function (t) {
                  (t.space = 250),
                    (t.exclam = 333),
                    (t.universal = 713),
                    (t.numbersign = 500),
                    (t.existential = 549),
                    (t.percent = 833),
                    (t.ampersand = 778),
                    (t.suchthat = 439),
                    (t.parenleft = 333),
                    (t.parenright = 333),
                    (t.asteriskmath = 500),
                    (t.plus = 549),
                    (t.comma = 250),
                    (t.minus = 549),
                    (t.period = 250),
                    (t.slash = 278),
                    (t.zero = 500),
                    (t.one = 500),
                    (t.two = 500),
                    (t.three = 500),
                    (t.four = 500),
                    (t.five = 500),
                    (t.six = 500),
                    (t.seven = 500),
                    (t.eight = 500),
                    (t.nine = 500),
                    (t.colon = 278),
                    (t.semicolon = 278),
                    (t.less = 549),
                    (t.equal = 549),
                    (t.greater = 549),
                    (t.question = 444),
                    (t.congruent = 549),
                    (t.Alpha = 722),
                    (t.Beta = 667),
                    (t.Chi = 722),
                    (t.Delta = 612),
                    (t.Epsilon = 611),
                    (t.Phi = 763),
                    (t.Gamma = 603),
                    (t.Eta = 722),
                    (t.Iota = 333),
                    (t.theta1 = 631),
                    (t.Kappa = 722),
                    (t.Lambda = 686),
                    (t.Mu = 889),
                    (t.Nu = 722),
                    (t.Omicron = 722),
                    (t.Pi = 768),
                    (t.Theta = 741),
                    (t.Rho = 556),
                    (t.Sigma = 592),
                    (t.Tau = 611),
                    (t.Upsilon = 690),
                    (t.sigma1 = 439),
                    (t.Omega = 768),
                    (t.Xi = 645),
                    (t.Psi = 795),
                    (t.Zeta = 611),
                    (t.bracketleft = 333),
                    (t.therefore = 863),
                    (t.bracketright = 333),
                    (t.perpendicular = 658),
                    (t.underscore = 500),
                    (t.radicalex = 500),
                    (t.alpha = 631),
                    (t.beta = 549),
                    (t.chi = 549),
                    (t.delta = 494),
                    (t.epsilon = 439),
                    (t.phi = 521),
                    (t.gamma = 411),
                    (t.eta = 603),
                    (t.iota = 329),
                    (t.phi1 = 603),
                    (t.kappa = 549),
                    (t.lambda = 549),
                    (t.mu = 576),
                    (t.nu = 521),
                    (t.omicron = 549),
                    (t.pi = 549),
                    (t.theta = 521),
                    (t.rho = 549),
                    (t.sigma = 603),
                    (t.tau = 439),
                    (t.upsilon = 576),
                    (t.omega1 = 713),
                    (t.omega = 686),
                    (t.xi = 493),
                    (t.psi = 686),
                    (t.zeta = 494),
                    (t.braceleft = 480),
                    (t.bar = 200),
                    (t.braceright = 480),
                    (t.similar = 549),
                    (t.Euro = 750),
                    (t.Upsilon1 = 620),
                    (t.minute = 247),
                    (t.lessequal = 549),
                    (t.fraction = 167),
                    (t.infinity = 713),
                    (t.florin = 500),
                    (t.club = 753),
                    (t.diamond = 753),
                    (t.heart = 753),
                    (t.spade = 753),
                    (t.arrowboth = 1042),
                    (t.arrowleft = 987),
                    (t.arrowup = 603),
                    (t.arrowright = 987),
                    (t.arrowdown = 603),
                    (t.degree = 400),
                    (t.plusminus = 549),
                    (t.second = 411),
                    (t.greaterequal = 549),
                    (t.multiply = 549),
                    (t.proportional = 713),
                    (t.partialdiff = 494),
                    (t.bullet = 460),
                    (t.divide = 549),
                    (t.notequal = 549),
                    (t.equivalence = 549),
                    (t.approxequal = 549),
                    (t.ellipsis = 1e3),
                    (t.arrowvertex = 603),
                    (t.arrowhorizex = 1e3),
                    (t.carriagereturn = 658),
                    (t.aleph = 823),
                    (t.Ifraktur = 686),
                    (t.Rfraktur = 795),
                    (t.weierstrass = 987),
                    (t.circlemultiply = 768),
                    (t.circleplus = 768),
                    (t.emptyset = 823),
                    (t.intersection = 768),
                    (t.union = 768),
                    (t.propersuperset = 713),
                    (t.reflexsuperset = 713),
                    (t.notsubset = 713),
                    (t.propersubset = 713),
                    (t.reflexsubset = 713),
                    (t.element = 713),
                    (t.notelement = 713),
                    (t.angle = 768),
                    (t.gradient = 713),
                    (t.registerserif = 790),
                    (t.copyrightserif = 790),
                    (t.trademarkserif = 890),
                    (t.product = 823),
                    (t.radical = 549),
                    (t.dotmath = 250),
                    (t.logicalnot = 713),
                    (t.logicaland = 603),
                    (t.logicalor = 603),
                    (t.arrowdblboth = 1042),
                    (t.arrowdblleft = 987),
                    (t.arrowdblup = 603),
                    (t.arrowdblright = 987),
                    (t.arrowdbldown = 603),
                    (t.lozenge = 494),
                    (t.angleleft = 329),
                    (t.registersans = 790),
                    (t.copyrightsans = 790),
                    (t.trademarksans = 786),
                    (t.summation = 713),
                    (t.parenlefttp = 384),
                    (t.parenleftex = 384),
                    (t.parenleftbt = 384),
                    (t.bracketlefttp = 384),
                    (t.bracketleftex = 384),
                    (t.bracketleftbt = 384),
                    (t.bracelefttp = 494),
                    (t.braceleftmid = 494),
                    (t.braceleftbt = 494),
                    (t.braceex = 494),
                    (t.angleright = 329),
                    (t.integral = 274),
                    (t.integraltp = 686),
                    (t.integralex = 686),
                    (t.integralbt = 686),
                    (t.parenrighttp = 384),
                    (t.parenrightex = 384),
                    (t.parenrightbt = 384),
                    (t.bracketrighttp = 384),
                    (t.bracketrightex = 384),
                    (t.bracketrightbt = 384),
                    (t.bracerighttp = 494),
                    (t.bracerightmid = 494),
                    (t.bracerightbt = 494),
                    (t.apple = 790);
                })),
                (t["Times-Roman"] = getLookupTableFactory(function (t) {
                  (t.space = 250),
                    (t.exclam = 333),
                    (t.quotedbl = 408),
                    (t.numbersign = 500),
                    (t.dollar = 500),
                    (t.percent = 833),
                    (t.ampersand = 778),
                    (t.quoteright = 333),
                    (t.parenleft = 333),
                    (t.parenright = 333),
                    (t.asterisk = 500),
                    (t.plus = 564),
                    (t.comma = 250),
                    (t.hyphen = 333),
                    (t.period = 250),
                    (t.slash = 278),
                    (t.zero = 500),
                    (t.one = 500),
                    (t.two = 500),
                    (t.three = 500),
                    (t.four = 500),
                    (t.five = 500),
                    (t.six = 500),
                    (t.seven = 500),
                    (t.eight = 500),
                    (t.nine = 500),
                    (t.colon = 278),
                    (t.semicolon = 278),
                    (t.less = 564),
                    (t.equal = 564),
                    (t.greater = 564),
                    (t.question = 444),
                    (t.at = 921),
                    (t.A = 722),
                    (t.B = 667),
                    (t.C = 667),
                    (t.D = 722),
                    (t.E = 611),
                    (t.F = 556),
                    (t.G = 722),
                    (t.H = 722),
                    (t.I = 333),
                    (t.J = 389),
                    (t.K = 722),
                    (t.L = 611),
                    (t.M = 889),
                    (t.N = 722),
                    (t.O = 722),
                    (t.P = 556),
                    (t.Q = 722),
                    (t.R = 667),
                    (t.S = 556),
                    (t.T = 611),
                    (t.U = 722),
                    (t.V = 722),
                    (t.W = 944),
                    (t.X = 722),
                    (t.Y = 722),
                    (t.Z = 611),
                    (t.bracketleft = 333),
                    (t.backslash = 278),
                    (t.bracketright = 333),
                    (t.asciicircum = 469),
                    (t.underscore = 500),
                    (t.quoteleft = 333),
                    (t.a = 444),
                    (t.b = 500),
                    (t.c = 444),
                    (t.d = 500),
                    (t.e = 444),
                    (t.f = 333),
                    (t.g = 500),
                    (t.h = 500),
                    (t.i = 278),
                    (t.j = 278),
                    (t.k = 500),
                    (t.l = 278),
                    (t.m = 778),
                    (t.n = 500),
                    (t.o = 500),
                    (t.p = 500),
                    (t.q = 500),
                    (t.r = 333),
                    (t.s = 389),
                    (t.t = 278),
                    (t.u = 500),
                    (t.v = 500),
                    (t.w = 722),
                    (t.x = 500),
                    (t.y = 500),
                    (t.z = 444),
                    (t.braceleft = 480),
                    (t.bar = 200),
                    (t.braceright = 480),
                    (t.asciitilde = 541),
                    (t.exclamdown = 333),
                    (t.cent = 500),
                    (t.sterling = 500),
                    (t.fraction = 167),
                    (t.yen = 500),
                    (t.florin = 500),
                    (t.section = 500),
                    (t.currency = 500),
                    (t.quotesingle = 180),
                    (t.quotedblleft = 444),
                    (t.guillemotleft = 500),
                    (t.guilsinglleft = 333),
                    (t.guilsinglright = 333),
                    (t.fi = 556),
                    (t.fl = 556),
                    (t.endash = 500),
                    (t.dagger = 500),
                    (t.daggerdbl = 500),
                    (t.periodcentered = 250),
                    (t.paragraph = 453),
                    (t.bullet = 350),
                    (t.quotesinglbase = 333),
                    (t.quotedblbase = 444),
                    (t.quotedblright = 444),
                    (t.guillemotright = 500),
                    (t.ellipsis = 1e3),
                    (t.perthousand = 1e3),
                    (t.questiondown = 444),
                    (t.grave = 333),
                    (t.acute = 333),
                    (t.circumflex = 333),
                    (t.tilde = 333),
                    (t.macron = 333),
                    (t.breve = 333),
                    (t.dotaccent = 333),
                    (t.dieresis = 333),
                    (t.ring = 333),
                    (t.cedilla = 333),
                    (t.hungarumlaut = 333),
                    (t.ogonek = 333),
                    (t.caron = 333),
                    (t.emdash = 1e3),
                    (t.AE = 889),
                    (t.ordfeminine = 276),
                    (t.Lslash = 611),
                    (t.Oslash = 722),
                    (t.OE = 889),
                    (t.ordmasculine = 310),
                    (t.ae = 667),
                    (t.dotlessi = 278),
                    (t.lslash = 278),
                    (t.oslash = 500),
                    (t.oe = 722),
                    (t.germandbls = 500),
                    (t.Idieresis = 333),
                    (t.eacute = 444),
                    (t.abreve = 444),
                    (t.uhungarumlaut = 500),
                    (t.ecaron = 444),
                    (t.Ydieresis = 722),
                    (t.divide = 564),
                    (t.Yacute = 722),
                    (t.Acircumflex = 722),
                    (t.aacute = 444),
                    (t.Ucircumflex = 722),
                    (t.yacute = 500),
                    (t.scommaaccent = 389),
                    (t.ecircumflex = 444),
                    (t.Uring = 722),
                    (t.Udieresis = 722),
                    (t.aogonek = 444),
                    (t.Uacute = 722),
                    (t.uogonek = 500),
                    (t.Edieresis = 611),
                    (t.Dcroat = 722),
                    (t.commaaccent = 250),
                    (t.copyright = 760),
                    (t.Emacron = 611),
                    (t.ccaron = 444),
                    (t.aring = 444),
                    (t.Ncommaaccent = 722),
                    (t.lacute = 278),
                    (t.agrave = 444),
                    (t.Tcommaaccent = 611),
                    (t.Cacute = 667),
                    (t.atilde = 444),
                    (t.Edotaccent = 611),
                    (t.scaron = 389),
                    (t.scedilla = 389),
                    (t.iacute = 278),
                    (t.lozenge = 471),
                    (t.Rcaron = 667),
                    (t.Gcommaaccent = 722),
                    (t.ucircumflex = 500),
                    (t.acircumflex = 444),
                    (t.Amacron = 722),
                    (t.rcaron = 333),
                    (t.ccedilla = 444),
                    (t.Zdotaccent = 611),
                    (t.Thorn = 556),
                    (t.Omacron = 722),
                    (t.Racute = 667),
                    (t.Sacute = 556),
                    (t.dcaron = 588),
                    (t.Umacron = 722);
                  (t.uring = 500),
                    (t.threesuperior = 300),
                    (t.Ograve = 722),
                    (t.Agrave = 722),
                    (t.Abreve = 722),
                    (t.multiply = 564),
                    (t.uacute = 500),
                    (t.Tcaron = 611),
                    (t.partialdiff = 476),
                    (t.ydieresis = 500),
                    (t.Nacute = 722),
                    (t.icircumflex = 278),
                    (t.Ecircumflex = 611),
                    (t.adieresis = 444),
                    (t.edieresis = 444),
                    (t.cacute = 444),
                    (t.nacute = 500),
                    (t.umacron = 500),
                    (t.Ncaron = 722),
                    (t.Iacute = 333),
                    (t.plusminus = 564),
                    (t.brokenbar = 200),
                    (t.registered = 760),
                    (t.Gbreve = 722),
                    (t.Idotaccent = 333),
                    (t.summation = 600),
                    (t.Egrave = 611),
                    (t.racute = 333),
                    (t.omacron = 500),
                    (t.Zacute = 611),
                    (t.Zcaron = 611),
                    (t.greaterequal = 549),
                    (t.Eth = 722),
                    (t.Ccedilla = 667),
                    (t.lcommaaccent = 278),
                    (t.tcaron = 326),
                    (t.eogonek = 444),
                    (t.Uogonek = 722),
                    (t.Aacute = 722),
                    (t.Adieresis = 722),
                    (t.egrave = 444),
                    (t.zacute = 444),
                    (t.iogonek = 278),
                    (t.Oacute = 722),
                    (t.oacute = 500),
                    (t.amacron = 444),
                    (t.sacute = 389),
                    (t.idieresis = 278),
                    (t.Ocircumflex = 722),
                    (t.Ugrave = 722),
                    (t.Delta = 612),
                    (t.thorn = 500),
                    (t.twosuperior = 300),
                    (t.Odieresis = 722),
                    (t.mu = 500),
                    (t.igrave = 278),
                    (t.ohungarumlaut = 500),
                    (t.Eogonek = 611),
                    (t.dcroat = 500),
                    (t.threequarters = 750),
                    (t.Scedilla = 556),
                    (t.lcaron = 344),
                    (t.Kcommaaccent = 722),
                    (t.Lacute = 611),
                    (t.trademark = 980),
                    (t.edotaccent = 444),
                    (t.Igrave = 333),
                    (t.Imacron = 333),
                    (t.Lcaron = 611),
                    (t.onehalf = 750),
                    (t.lessequal = 549),
                    (t.ocircumflex = 500),
                    (t.ntilde = 500),
                    (t.Uhungarumlaut = 722),
                    (t.Eacute = 611),
                    (t.emacron = 444),
                    (t.gbreve = 500),
                    (t.onequarter = 750),
                    (t.Scaron = 556),
                    (t.Scommaaccent = 556),
                    (t.Ohungarumlaut = 722),
                    (t.degree = 400),
                    (t.ograve = 500),
                    (t.Ccaron = 667),
                    (t.ugrave = 500),
                    (t.radical = 453),
                    (t.Dcaron = 722),
                    (t.rcommaaccent = 333),
                    (t.Ntilde = 722),
                    (t.otilde = 500),
                    (t.Rcommaaccent = 667),
                    (t.Lcommaaccent = 611),
                    (t.Atilde = 722),
                    (t.Aogonek = 722),
                    (t.Aring = 722),
                    (t.Otilde = 722),
                    (t.zdotaccent = 444),
                    (t.Ecaron = 611),
                    (t.Iogonek = 333),
                    (t.kcommaaccent = 500),
                    (t.minus = 564),
                    (t.Icircumflex = 333),
                    (t.ncaron = 500),
                    (t.tcommaaccent = 278),
                    (t.logicalnot = 564),
                    (t.odieresis = 500),
                    (t.udieresis = 500),
                    (t.notequal = 549),
                    (t.gcommaaccent = 500),
                    (t.eth = 500),
                    (t.zcaron = 444),
                    (t.ncommaaccent = 500),
                    (t.onesuperior = 300),
                    (t.imacron = 278),
                    (t.Euro = 500);
                })),
                (t["Times-Bold"] = getLookupTableFactory(function (t) {
                  (t.space = 250),
                    (t.exclam = 333),
                    (t.quotedbl = 555),
                    (t.numbersign = 500),
                    (t.dollar = 500),
                    (t.percent = 1e3),
                    (t.ampersand = 833),
                    (t.quoteright = 333),
                    (t.parenleft = 333),
                    (t.parenright = 333),
                    (t.asterisk = 500),
                    (t.plus = 570),
                    (t.comma = 250),
                    (t.hyphen = 333),
                    (t.period = 250),
                    (t.slash = 278),
                    (t.zero = 500),
                    (t.one = 500),
                    (t.two = 500),
                    (t.three = 500),
                    (t.four = 500),
                    (t.five = 500),
                    (t.six = 500),
                    (t.seven = 500),
                    (t.eight = 500),
                    (t.nine = 500),
                    (t.colon = 333),
                    (t.semicolon = 333),
                    (t.less = 570),
                    (t.equal = 570),
                    (t.greater = 570),
                    (t.question = 500),
                    (t.at = 930),
                    (t.A = 722),
                    (t.B = 667),
                    (t.C = 722),
                    (t.D = 722),
                    (t.E = 667),
                    (t.F = 611),
                    (t.G = 778),
                    (t.H = 778),
                    (t.I = 389),
                    (t.J = 500),
                    (t.K = 778),
                    (t.L = 667),
                    (t.M = 944),
                    (t.N = 722),
                    (t.O = 778),
                    (t.P = 611),
                    (t.Q = 778),
                    (t.R = 722),
                    (t.S = 556),
                    (t.T = 667),
                    (t.U = 722),
                    (t.V = 722),
                    (t.W = 1e3),
                    (t.X = 722),
                    (t.Y = 722),
                    (t.Z = 667),
                    (t.bracketleft = 333),
                    (t.backslash = 278),
                    (t.bracketright = 333),
                    (t.asciicircum = 581),
                    (t.underscore = 500),
                    (t.quoteleft = 333),
                    (t.a = 500),
                    (t.b = 556),
                    (t.c = 444),
                    (t.d = 556),
                    (t.e = 444),
                    (t.f = 333),
                    (t.g = 500),
                    (t.h = 556),
                    (t.i = 278),
                    (t.j = 333),
                    (t.k = 556),
                    (t.l = 278),
                    (t.m = 833),
                    (t.n = 556),
                    (t.o = 500),
                    (t.p = 556),
                    (t.q = 556),
                    (t.r = 444),
                    (t.s = 389),
                    (t.t = 333),
                    (t.u = 556),
                    (t.v = 500),
                    (t.w = 722),
                    (t.x = 500),
                    (t.y = 500),
                    (t.z = 444),
                    (t.braceleft = 394),
                    (t.bar = 220),
                    (t.braceright = 394),
                    (t.asciitilde = 520),
                    (t.exclamdown = 333),
                    (t.cent = 500),
                    (t.sterling = 500),
                    (t.fraction = 167),
                    (t.yen = 500),
                    (t.florin = 500),
                    (t.section = 500),
                    (t.currency = 500),
                    (t.quotesingle = 278),
                    (t.quotedblleft = 500),
                    (t.guillemotleft = 500),
                    (t.guilsinglleft = 333),
                    (t.guilsinglright = 333),
                    (t.fi = 556),
                    (t.fl = 556),
                    (t.endash = 500),
                    (t.dagger = 500),
                    (t.daggerdbl = 500),
                    (t.periodcentered = 250),
                    (t.paragraph = 540),
                    (t.bullet = 350),
                    (t.quotesinglbase = 333),
                    (t.quotedblbase = 500),
                    (t.quotedblright = 500),
                    (t.guillemotright = 500),
                    (t.ellipsis = 1e3),
                    (t.perthousand = 1e3),
                    (t.questiondown = 500),
                    (t.grave = 333),
                    (t.acute = 333),
                    (t.circumflex = 333),
                    (t.tilde = 333),
                    (t.macron = 333),
                    (t.breve = 333),
                    (t.dotaccent = 333),
                    (t.dieresis = 333),
                    (t.ring = 333),
                    (t.cedilla = 333),
                    (t.hungarumlaut = 333),
                    (t.ogonek = 333),
                    (t.caron = 333),
                    (t.emdash = 1e3),
                    (t.AE = 1e3),
                    (t.ordfeminine = 300),
                    (t.Lslash = 667),
                    (t.Oslash = 778),
                    (t.OE = 1e3),
                    (t.ordmasculine = 330),
                    (t.ae = 722),
                    (t.dotlessi = 278),
                    (t.lslash = 278),
                    (t.oslash = 500),
                    (t.oe = 722),
                    (t.germandbls = 556),
                    (t.Idieresis = 389),
                    (t.eacute = 444),
                    (t.abreve = 500),
                    (t.uhungarumlaut = 556),
                    (t.ecaron = 444),
                    (t.Ydieresis = 722),
                    (t.divide = 570),
                    (t.Yacute = 722),
                    (t.Acircumflex = 722),
                    (t.aacute = 500),
                    (t.Ucircumflex = 722),
                    (t.yacute = 500),
                    (t.scommaaccent = 389),
                    (t.ecircumflex = 444),
                    (t.Uring = 722),
                    (t.Udieresis = 722),
                    (t.aogonek = 500),
                    (t.Uacute = 722),
                    (t.uogonek = 556),
                    (t.Edieresis = 667),
                    (t.Dcroat = 722),
                    (t.commaaccent = 250),
                    (t.copyright = 747),
                    (t.Emacron = 667),
                    (t.ccaron = 444),
                    (t.aring = 500),
                    (t.Ncommaaccent = 722),
                    (t.lacute = 278),
                    (t.agrave = 500),
                    (t.Tcommaaccent = 667),
                    (t.Cacute = 722),
                    (t.atilde = 500),
                    (t.Edotaccent = 667),
                    (t.scaron = 389),
                    (t.scedilla = 389),
                    (t.iacute = 278),
                    (t.lozenge = 494),
                    (t.Rcaron = 722),
                    (t.Gcommaaccent = 778),
                    (t.ucircumflex = 556),
                    (t.acircumflex = 500),
                    (t.Amacron = 722),
                    (t.rcaron = 444),
                    (t.ccedilla = 444),
                    (t.Zdotaccent = 667),
                    (t.Thorn = 611),
                    (t.Omacron = 778),
                    (t.Racute = 722),
                    (t.Sacute = 556),
                    (t.dcaron = 672),
                    (t.Umacron = 722);
                  (t.uring = 556),
                    (t.threesuperior = 300),
                    (t.Ograve = 778),
                    (t.Agrave = 722),
                    (t.Abreve = 722),
                    (t.multiply = 570),
                    (t.uacute = 556),
                    (t.Tcaron = 667),
                    (t.partialdiff = 494),
                    (t.ydieresis = 500),
                    (t.Nacute = 722),
                    (t.icircumflex = 278),
                    (t.Ecircumflex = 667),
                    (t.adieresis = 500),
                    (t.edieresis = 444),
                    (t.cacute = 444),
                    (t.nacute = 556),
                    (t.umacron = 556),
                    (t.Ncaron = 722),
                    (t.Iacute = 389),
                    (t.plusminus = 570),
                    (t.brokenbar = 220),
                    (t.registered = 747),
                    (t.Gbreve = 778),
                    (t.Idotaccent = 389),
                    (t.summation = 600),
                    (t.Egrave = 667),
                    (t.racute = 444),
                    (t.omacron = 500),
                    (t.Zacute = 667),
                    (t.Zcaron = 667),
                    (t.greaterequal = 549),
                    (t.Eth = 722),
                    (t.Ccedilla = 722),
                    (t.lcommaaccent = 278),
                    (t.tcaron = 416),
                    (t.eogonek = 444),
                    (t.Uogonek = 722),
                    (t.Aacute = 722),
                    (t.Adieresis = 722),
                    (t.egrave = 444),
                    (t.zacute = 444),
                    (t.iogonek = 278),
                    (t.Oacute = 778),
                    (t.oacute = 500),
                    (t.amacron = 500),
                    (t.sacute = 389),
                    (t.idieresis = 278),
                    (t.Ocircumflex = 778),
                    (t.Ugrave = 722),
                    (t.Delta = 612),
                    (t.thorn = 556),
                    (t.twosuperior = 300),
                    (t.Odieresis = 778),
                    (t.mu = 556),
                    (t.igrave = 278),
                    (t.ohungarumlaut = 500),
                    (t.Eogonek = 667),
                    (t.dcroat = 556),
                    (t.threequarters = 750),
                    (t.Scedilla = 556),
                    (t.lcaron = 394),
                    (t.Kcommaaccent = 778),
                    (t.Lacute = 667),
                    (t.trademark = 1e3),
                    (t.edotaccent = 444),
                    (t.Igrave = 389),
                    (t.Imacron = 389),
                    (t.Lcaron = 667),
                    (t.onehalf = 750),
                    (t.lessequal = 549),
                    (t.ocircumflex = 500),
                    (t.ntilde = 556),
                    (t.Uhungarumlaut = 722),
                    (t.Eacute = 667),
                    (t.emacron = 444),
                    (t.gbreve = 500),
                    (t.onequarter = 750),
                    (t.Scaron = 556),
                    (t.Scommaaccent = 556),
                    (t.Ohungarumlaut = 778),
                    (t.degree = 400),
                    (t.ograve = 500),
                    (t.Ccaron = 722),
                    (t.ugrave = 556),
                    (t.radical = 549),
                    (t.Dcaron = 722),
                    (t.rcommaaccent = 444),
                    (t.Ntilde = 722),
                    (t.otilde = 500),
                    (t.Rcommaaccent = 722),
                    (t.Lcommaaccent = 667),
                    (t.Atilde = 722),
                    (t.Aogonek = 722),
                    (t.Aring = 722),
                    (t.Otilde = 778),
                    (t.zdotaccent = 444),
                    (t.Ecaron = 667),
                    (t.Iogonek = 389),
                    (t.kcommaaccent = 556),
                    (t.minus = 570),
                    (t.Icircumflex = 389),
                    (t.ncaron = 556),
                    (t.tcommaaccent = 333),
                    (t.logicalnot = 570),
                    (t.odieresis = 500),
                    (t.udieresis = 556),
                    (t.notequal = 549),
                    (t.gcommaaccent = 500),
                    (t.eth = 500),
                    (t.zcaron = 444),
                    (t.ncommaaccent = 556),
                    (t.onesuperior = 300),
                    (t.imacron = 278),
                    (t.Euro = 500);
                })),
                (t["Times-BoldItalic"] = getLookupTableFactory(function (t) {
                  (t.space = 250),
                    (t.exclam = 389),
                    (t.quotedbl = 555),
                    (t.numbersign = 500),
                    (t.dollar = 500),
                    (t.percent = 833),
                    (t.ampersand = 778),
                    (t.quoteright = 333),
                    (t.parenleft = 333),
                    (t.parenright = 333),
                    (t.asterisk = 500),
                    (t.plus = 570),
                    (t.comma = 250),
                    (t.hyphen = 333),
                    (t.period = 250),
                    (t.slash = 278),
                    (t.zero = 500),
                    (t.one = 500),
                    (t.two = 500),
                    (t.three = 500),
                    (t.four = 500),
                    (t.five = 500),
                    (t.six = 500),
                    (t.seven = 500),
                    (t.eight = 500),
                    (t.nine = 500),
                    (t.colon = 333),
                    (t.semicolon = 333),
                    (t.less = 570),
                    (t.equal = 570),
                    (t.greater = 570),
                    (t.question = 500),
                    (t.at = 832),
                    (t.A = 667),
                    (t.B = 667),
                    (t.C = 667),
                    (t.D = 722),
                    (t.E = 667),
                    (t.F = 667),
                    (t.G = 722),
                    (t.H = 778),
                    (t.I = 389),
                    (t.J = 500),
                    (t.K = 667),
                    (t.L = 611),
                    (t.M = 889),
                    (t.N = 722),
                    (t.O = 722),
                    (t.P = 611),
                    (t.Q = 722),
                    (t.R = 667),
                    (t.S = 556),
                    (t.T = 611),
                    (t.U = 722),
                    (t.V = 667),
                    (t.W = 889),
                    (t.X = 667),
                    (t.Y = 611),
                    (t.Z = 611),
                    (t.bracketleft = 333),
                    (t.backslash = 278),
                    (t.bracketright = 333),
                    (t.asciicircum = 570),
                    (t.underscore = 500),
                    (t.quoteleft = 333),
                    (t.a = 500),
                    (t.b = 500),
                    (t.c = 444),
                    (t.d = 500),
                    (t.e = 444),
                    (t.f = 333),
                    (t.g = 500),
                    (t.h = 556),
                    (t.i = 278),
                    (t.j = 278),
                    (t.k = 500),
                    (t.l = 278),
                    (t.m = 778),
                    (t.n = 556),
                    (t.o = 500),
                    (t.p = 500),
                    (t.q = 500),
                    (t.r = 389),
                    (t.s = 389),
                    (t.t = 278),
                    (t.u = 556),
                    (t.v = 444),
                    (t.w = 667),
                    (t.x = 500),
                    (t.y = 444),
                    (t.z = 389),
                    (t.braceleft = 348),
                    (t.bar = 220),
                    (t.braceright = 348),
                    (t.asciitilde = 570),
                    (t.exclamdown = 389),
                    (t.cent = 500),
                    (t.sterling = 500),
                    (t.fraction = 167),
                    (t.yen = 500),
                    (t.florin = 500),
                    (t.section = 500),
                    (t.currency = 500),
                    (t.quotesingle = 278),
                    (t.quotedblleft = 500),
                    (t.guillemotleft = 500),
                    (t.guilsinglleft = 333),
                    (t.guilsinglright = 333),
                    (t.fi = 556),
                    (t.fl = 556),
                    (t.endash = 500),
                    (t.dagger = 500),
                    (t.daggerdbl = 500),
                    (t.periodcentered = 250),
                    (t.paragraph = 500),
                    (t.bullet = 350),
                    (t.quotesinglbase = 333),
                    (t.quotedblbase = 500),
                    (t.quotedblright = 500),
                    (t.guillemotright = 500),
                    (t.ellipsis = 1e3),
                    (t.perthousand = 1e3),
                    (t.questiondown = 500),
                    (t.grave = 333),
                    (t.acute = 333),
                    (t.circumflex = 333),
                    (t.tilde = 333),
                    (t.macron = 333),
                    (t.breve = 333),
                    (t.dotaccent = 333),
                    (t.dieresis = 333),
                    (t.ring = 333),
                    (t.cedilla = 333),
                    (t.hungarumlaut = 333),
                    (t.ogonek = 333),
                    (t.caron = 333),
                    (t.emdash = 1e3),
                    (t.AE = 944),
                    (t.ordfeminine = 266),
                    (t.Lslash = 611),
                    (t.Oslash = 722),
                    (t.OE = 944),
                    (t.ordmasculine = 300),
                    (t.ae = 722),
                    (t.dotlessi = 278),
                    (t.lslash = 278),
                    (t.oslash = 500),
                    (t.oe = 722),
                    (t.germandbls = 500),
                    (t.Idieresis = 389),
                    (t.eacute = 444),
                    (t.abreve = 500),
                    (t.uhungarumlaut = 556),
                    (t.ecaron = 444),
                    (t.Ydieresis = 611),
                    (t.divide = 570),
                    (t.Yacute = 611),
                    (t.Acircumflex = 667),
                    (t.aacute = 500),
                    (t.Ucircumflex = 722),
                    (t.yacute = 444),
                    (t.scommaaccent = 389),
                    (t.ecircumflex = 444),
                    (t.Uring = 722),
                    (t.Udieresis = 722),
                    (t.aogonek = 500),
                    (t.Uacute = 722),
                    (t.uogonek = 556),
                    (t.Edieresis = 667),
                    (t.Dcroat = 722),
                    (t.commaaccent = 250),
                    (t.copyright = 747),
                    (t.Emacron = 667),
                    (t.ccaron = 444),
                    (t.aring = 500),
                    (t.Ncommaaccent = 722),
                    (t.lacute = 278),
                    (t.agrave = 500),
                    (t.Tcommaaccent = 611),
                    (t.Cacute = 667),
                    (t.atilde = 500),
                    (t.Edotaccent = 667),
                    (t.scaron = 389),
                    (t.scedilla = 389),
                    (t.iacute = 278),
                    (t.lozenge = 494),
                    (t.Rcaron = 667),
                    (t.Gcommaaccent = 722),
                    (t.ucircumflex = 556),
                    (t.acircumflex = 500),
                    (t.Amacron = 667),
                    (t.rcaron = 389),
                    (t.ccedilla = 444),
                    (t.Zdotaccent = 611),
                    (t.Thorn = 611),
                    (t.Omacron = 722),
                    (t.Racute = 667),
                    (t.Sacute = 556),
                    (t.dcaron = 608),
                    (t.Umacron = 722);
                  (t.uring = 556),
                    (t.threesuperior = 300),
                    (t.Ograve = 722),
                    (t.Agrave = 667),
                    (t.Abreve = 667),
                    (t.multiply = 570),
                    (t.uacute = 556),
                    (t.Tcaron = 611),
                    (t.partialdiff = 494),
                    (t.ydieresis = 444),
                    (t.Nacute = 722),
                    (t.icircumflex = 278),
                    (t.Ecircumflex = 667),
                    (t.adieresis = 500),
                    (t.edieresis = 444),
                    (t.cacute = 444),
                    (t.nacute = 556),
                    (t.umacron = 556),
                    (t.Ncaron = 722),
                    (t.Iacute = 389),
                    (t.plusminus = 570),
                    (t.brokenbar = 220),
                    (t.registered = 747),
                    (t.Gbreve = 722),
                    (t.Idotaccent = 389),
                    (t.summation = 600),
                    (t.Egrave = 667),
                    (t.racute = 389),
                    (t.omacron = 500),
                    (t.Zacute = 611),
                    (t.Zcaron = 611),
                    (t.greaterequal = 549),
                    (t.Eth = 722),
                    (t.Ccedilla = 667),
                    (t.lcommaaccent = 278),
                    (t.tcaron = 366),
                    (t.eogonek = 444),
                    (t.Uogonek = 722),
                    (t.Aacute = 667),
                    (t.Adieresis = 667),
                    (t.egrave = 444),
                    (t.zacute = 389),
                    (t.iogonek = 278),
                    (t.Oacute = 722),
                    (t.oacute = 500),
                    (t.amacron = 500),
                    (t.sacute = 389),
                    (t.idieresis = 278),
                    (t.Ocircumflex = 722),
                    (t.Ugrave = 722),
                    (t.Delta = 612),
                    (t.thorn = 500),
                    (t.twosuperior = 300),
                    (t.Odieresis = 722),
                    (t.mu = 576),
                    (t.igrave = 278),
                    (t.ohungarumlaut = 500),
                    (t.Eogonek = 667),
                    (t.dcroat = 500),
                    (t.threequarters = 750),
                    (t.Scedilla = 556),
                    (t.lcaron = 382),
                    (t.Kcommaaccent = 667),
                    (t.Lacute = 611),
                    (t.trademark = 1e3),
                    (t.edotaccent = 444),
                    (t.Igrave = 389),
                    (t.Imacron = 389),
                    (t.Lcaron = 611),
                    (t.onehalf = 750),
                    (t.lessequal = 549),
                    (t.ocircumflex = 500),
                    (t.ntilde = 556),
                    (t.Uhungarumlaut = 722),
                    (t.Eacute = 667),
                    (t.emacron = 444),
                    (t.gbreve = 500),
                    (t.onequarter = 750),
                    (t.Scaron = 556),
                    (t.Scommaaccent = 556),
                    (t.Ohungarumlaut = 722),
                    (t.degree = 400),
                    (t.ograve = 500),
                    (t.Ccaron = 667),
                    (t.ugrave = 556),
                    (t.radical = 549),
                    (t.Dcaron = 722),
                    (t.rcommaaccent = 389),
                    (t.Ntilde = 722),
                    (t.otilde = 500),
                    (t.Rcommaaccent = 667),
                    (t.Lcommaaccent = 611),
                    (t.Atilde = 667),
                    (t.Aogonek = 667),
                    (t.Aring = 667),
                    (t.Otilde = 722),
                    (t.zdotaccent = 389),
                    (t.Ecaron = 667),
                    (t.Iogonek = 389),
                    (t.kcommaaccent = 500),
                    (t.minus = 606),
                    (t.Icircumflex = 389),
                    (t.ncaron = 556),
                    (t.tcommaaccent = 278),
                    (t.logicalnot = 606),
                    (t.odieresis = 500),
                    (t.udieresis = 556),
                    (t.notequal = 549),
                    (t.gcommaaccent = 500),
                    (t.eth = 500),
                    (t.zcaron = 389),
                    (t.ncommaaccent = 556),
                    (t.onesuperior = 300),
                    (t.imacron = 278),
                    (t.Euro = 500);
                })),
                (t["Times-Italic"] = getLookupTableFactory(function (t) {
                  (t.space = 250),
                    (t.exclam = 333),
                    (t.quotedbl = 420),
                    (t.numbersign = 500),
                    (t.dollar = 500),
                    (t.percent = 833),
                    (t.ampersand = 778),
                    (t.quoteright = 333),
                    (t.parenleft = 333),
                    (t.parenright = 333),
                    (t.asterisk = 500),
                    (t.plus = 675),
                    (t.comma = 250),
                    (t.hyphen = 333),
                    (t.period = 250),
                    (t.slash = 278),
                    (t.zero = 500),
                    (t.one = 500),
                    (t.two = 500),
                    (t.three = 500),
                    (t.four = 500),
                    (t.five = 500),
                    (t.six = 500),
                    (t.seven = 500),
                    (t.eight = 500),
                    (t.nine = 500),
                    (t.colon = 333),
                    (t.semicolon = 333),
                    (t.less = 675),
                    (t.equal = 675),
                    (t.greater = 675),
                    (t.question = 500),
                    (t.at = 920),
                    (t.A = 611),
                    (t.B = 611),
                    (t.C = 667),
                    (t.D = 722),
                    (t.E = 611),
                    (t.F = 611),
                    (t.G = 722),
                    (t.H = 722),
                    (t.I = 333),
                    (t.J = 444),
                    (t.K = 667),
                    (t.L = 556),
                    (t.M = 833),
                    (t.N = 667),
                    (t.O = 722),
                    (t.P = 611),
                    (t.Q = 722),
                    (t.R = 611),
                    (t.S = 500),
                    (t.T = 556),
                    (t.U = 722),
                    (t.V = 611),
                    (t.W = 833),
                    (t.X = 611),
                    (t.Y = 556),
                    (t.Z = 556),
                    (t.bracketleft = 389),
                    (t.backslash = 278),
                    (t.bracketright = 389),
                    (t.asciicircum = 422),
                    (t.underscore = 500),
                    (t.quoteleft = 333),
                    (t.a = 500),
                    (t.b = 500),
                    (t.c = 444),
                    (t.d = 500),
                    (t.e = 444),
                    (t.f = 278),
                    (t.g = 500),
                    (t.h = 500),
                    (t.i = 278),
                    (t.j = 278),
                    (t.k = 444),
                    (t.l = 278),
                    (t.m = 722),
                    (t.n = 500),
                    (t.o = 500),
                    (t.p = 500),
                    (t.q = 500),
                    (t.r = 389),
                    (t.s = 389),
                    (t.t = 278),
                    (t.u = 500),
                    (t.v = 444),
                    (t.w = 667),
                    (t.x = 444),
                    (t.y = 444),
                    (t.z = 389),
                    (t.braceleft = 400),
                    (t.bar = 275),
                    (t.braceright = 400),
                    (t.asciitilde = 541),
                    (t.exclamdown = 389),
                    (t.cent = 500),
                    (t.sterling = 500),
                    (t.fraction = 167),
                    (t.yen = 500),
                    (t.florin = 500),
                    (t.section = 500),
                    (t.currency = 500),
                    (t.quotesingle = 214),
                    (t.quotedblleft = 556),
                    (t.guillemotleft = 500),
                    (t.guilsinglleft = 333),
                    (t.guilsinglright = 333),
                    (t.fi = 500),
                    (t.fl = 500),
                    (t.endash = 500),
                    (t.dagger = 500),
                    (t.daggerdbl = 500),
                    (t.periodcentered = 250),
                    (t.paragraph = 523),
                    (t.bullet = 350),
                    (t.quotesinglbase = 333),
                    (t.quotedblbase = 556),
                    (t.quotedblright = 556),
                    (t.guillemotright = 500),
                    (t.ellipsis = 889),
                    (t.perthousand = 1e3),
                    (t.questiondown = 500),
                    (t.grave = 333),
                    (t.acute = 333),
                    (t.circumflex = 333),
                    (t.tilde = 333),
                    (t.macron = 333),
                    (t.breve = 333),
                    (t.dotaccent = 333),
                    (t.dieresis = 333),
                    (t.ring = 333),
                    (t.cedilla = 333),
                    (t.hungarumlaut = 333),
                    (t.ogonek = 333),
                    (t.caron = 333),
                    (t.emdash = 889),
                    (t.AE = 889),
                    (t.ordfeminine = 276),
                    (t.Lslash = 556),
                    (t.Oslash = 722),
                    (t.OE = 944),
                    (t.ordmasculine = 310),
                    (t.ae = 667),
                    (t.dotlessi = 278),
                    (t.lslash = 278),
                    (t.oslash = 500),
                    (t.oe = 667),
                    (t.germandbls = 500),
                    (t.Idieresis = 333),
                    (t.eacute = 444),
                    (t.abreve = 500),
                    (t.uhungarumlaut = 500),
                    (t.ecaron = 444),
                    (t.Ydieresis = 556),
                    (t.divide = 675),
                    (t.Yacute = 556),
                    (t.Acircumflex = 611),
                    (t.aacute = 500),
                    (t.Ucircumflex = 722),
                    (t.yacute = 444),
                    (t.scommaaccent = 389),
                    (t.ecircumflex = 444),
                    (t.Uring = 722),
                    (t.Udieresis = 722),
                    (t.aogonek = 500),
                    (t.Uacute = 722),
                    (t.uogonek = 500),
                    (t.Edieresis = 611),
                    (t.Dcroat = 722),
                    (t.commaaccent = 250),
                    (t.copyright = 760),
                    (t.Emacron = 611),
                    (t.ccaron = 444),
                    (t.aring = 500),
                    (t.Ncommaaccent = 667),
                    (t.lacute = 278),
                    (t.agrave = 500),
                    (t.Tcommaaccent = 556),
                    (t.Cacute = 667),
                    (t.atilde = 500),
                    (t.Edotaccent = 611),
                    (t.scaron = 389),
                    (t.scedilla = 389),
                    (t.iacute = 278),
                    (t.lozenge = 471),
                    (t.Rcaron = 611),
                    (t.Gcommaaccent = 722),
                    (t.ucircumflex = 500),
                    (t.acircumflex = 500),
                    (t.Amacron = 611),
                    (t.rcaron = 389),
                    (t.ccedilla = 444),
                    (t.Zdotaccent = 556),
                    (t.Thorn = 611),
                    (t.Omacron = 722),
                    (t.Racute = 611),
                    (t.Sacute = 500),
                    (t.dcaron = 544),
                    (t.Umacron = 722);
                  (t.uring = 500),
                    (t.threesuperior = 300),
                    (t.Ograve = 722),
                    (t.Agrave = 611),
                    (t.Abreve = 611),
                    (t.multiply = 675),
                    (t.uacute = 500),
                    (t.Tcaron = 556),
                    (t.partialdiff = 476),
                    (t.ydieresis = 444),
                    (t.Nacute = 667),
                    (t.icircumflex = 278),
                    (t.Ecircumflex = 611),
                    (t.adieresis = 500),
                    (t.edieresis = 444),
                    (t.cacute = 444),
                    (t.nacute = 500),
                    (t.umacron = 500),
                    (t.Ncaron = 667),
                    (t.Iacute = 333),
                    (t.plusminus = 675),
                    (t.brokenbar = 275),
                    (t.registered = 760),
                    (t.Gbreve = 722),
                    (t.Idotaccent = 333),
                    (t.summation = 600),
                    (t.Egrave = 611),
                    (t.racute = 389),
                    (t.omacron = 500),
                    (t.Zacute = 556),
                    (t.Zcaron = 556),
                    (t.greaterequal = 549),
                    (t.Eth = 722),
                    (t.Ccedilla = 667),
                    (t.lcommaaccent = 278),
                    (t.tcaron = 300),
                    (t.eogonek = 444),
                    (t.Uogonek = 722),
                    (t.Aacute = 611),
                    (t.Adieresis = 611),
                    (t.egrave = 444),
                    (t.zacute = 389),
                    (t.iogonek = 278),
                    (t.Oacute = 722),
                    (t.oacute = 500),
                    (t.amacron = 500),
                    (t.sacute = 389),
                    (t.idieresis = 278),
                    (t.Ocircumflex = 722),
                    (t.Ugrave = 722),
                    (t.Delta = 612),
                    (t.thorn = 500),
                    (t.twosuperior = 300),
                    (t.Odieresis = 722),
                    (t.mu = 500),
                    (t.igrave = 278),
                    (t.ohungarumlaut = 500),
                    (t.Eogonek = 611),
                    (t.dcroat = 500),
                    (t.threequarters = 750),
                    (t.Scedilla = 500),
                    (t.lcaron = 300),
                    (t.Kcommaaccent = 667),
                    (t.Lacute = 556),
                    (t.trademark = 980),
                    (t.edotaccent = 444),
                    (t.Igrave = 333),
                    (t.Imacron = 333),
                    (t.Lcaron = 611),
                    (t.onehalf = 750),
                    (t.lessequal = 549),
                    (t.ocircumflex = 500),
                    (t.ntilde = 500),
                    (t.Uhungarumlaut = 722),
                    (t.Eacute = 611),
                    (t.emacron = 444),
                    (t.gbreve = 500),
                    (t.onequarter = 750),
                    (t.Scaron = 500),
                    (t.Scommaaccent = 500),
                    (t.Ohungarumlaut = 722),
                    (t.degree = 400),
                    (t.ograve = 500),
                    (t.Ccaron = 667),
                    (t.ugrave = 500),
                    (t.radical = 453),
                    (t.Dcaron = 722),
                    (t.rcommaaccent = 389),
                    (t.Ntilde = 667),
                    (t.otilde = 500),
                    (t.Rcommaaccent = 611),
                    (t.Lcommaaccent = 556),
                    (t.Atilde = 611),
                    (t.Aogonek = 611),
                    (t.Aring = 611),
                    (t.Otilde = 722),
                    (t.zdotaccent = 389),
                    (t.Ecaron = 611),
                    (t.Iogonek = 333),
                    (t.kcommaaccent = 444),
                    (t.minus = 675),
                    (t.Icircumflex = 333),
                    (t.ncaron = 500),
                    (t.tcommaaccent = 278),
                    (t.logicalnot = 675),
                    (t.odieresis = 500),
                    (t.udieresis = 500),
                    (t.notequal = 549),
                    (t.gcommaaccent = 500),
                    (t.eth = 500),
                    (t.zcaron = 389),
                    (t.ncommaaccent = 500),
                    (t.onesuperior = 300),
                    (t.imacron = 278),
                    (t.Euro = 500);
                })),
                (t.ZapfDingbats = getLookupTableFactory(function (t) {
                  (t.space = 278),
                    (t.a1 = 974),
                    (t.a2 = 961),
                    (t.a202 = 974),
                    (t.a3 = 980),
                    (t.a4 = 719),
                    (t.a5 = 789),
                    (t.a119 = 790),
                    (t.a118 = 791),
                    (t.a117 = 690),
                    (t.a11 = 960),
                    (t.a12 = 939),
                    (t.a13 = 549),
                    (t.a14 = 855),
                    (t.a15 = 911),
                    (t.a16 = 933),
                    (t.a105 = 911),
                    (t.a17 = 945),
                    (t.a18 = 974),
                    (t.a19 = 755),
                    (t.a20 = 846),
                    (t.a21 = 762),
                    (t.a22 = 761),
                    (t.a23 = 571),
                    (t.a24 = 677),
                    (t.a25 = 763),
                    (t.a26 = 760),
                    (t.a27 = 759),
                    (t.a28 = 754),
                    (t.a6 = 494),
                    (t.a7 = 552),
                    (t.a8 = 537),
                    (t.a9 = 577),
                    (t.a10 = 692),
                    (t.a29 = 786),
                    (t.a30 = 788),
                    (t.a31 = 788),
                    (t.a32 = 790),
                    (t.a33 = 793),
                    (t.a34 = 794),
                    (t.a35 = 816),
                    (t.a36 = 823),
                    (t.a37 = 789),
                    (t.a38 = 841),
                    (t.a39 = 823),
                    (t.a40 = 833),
                    (t.a41 = 816),
                    (t.a42 = 831),
                    (t.a43 = 923),
                    (t.a44 = 744),
                    (t.a45 = 723),
                    (t.a46 = 749),
                    (t.a47 = 790),
                    (t.a48 = 792),
                    (t.a49 = 695),
                    (t.a50 = 776),
                    (t.a51 = 768),
                    (t.a52 = 792),
                    (t.a53 = 759),
                    (t.a54 = 707),
                    (t.a55 = 708),
                    (t.a56 = 682),
                    (t.a57 = 701),
                    (t.a58 = 826),
                    (t.a59 = 815),
                    (t.a60 = 789),
                    (t.a61 = 789),
                    (t.a62 = 707),
                    (t.a63 = 687),
                    (t.a64 = 696),
                    (t.a65 = 689),
                    (t.a66 = 786),
                    (t.a67 = 787),
                    (t.a68 = 713),
                    (t.a69 = 791),
                    (t.a70 = 785),
                    (t.a71 = 791),
                    (t.a72 = 873),
                    (t.a73 = 761),
                    (t.a74 = 762),
                    (t.a203 = 762),
                    (t.a75 = 759),
                    (t.a204 = 759),
                    (t.a76 = 892),
                    (t.a77 = 892),
                    (t.a78 = 788),
                    (t.a79 = 784),
                    (t.a81 = 438),
                    (t.a82 = 138),
                    (t.a83 = 277),
                    (t.a84 = 415),
                    (t.a97 = 392),
                    (t.a98 = 392),
                    (t.a99 = 668),
                    (t.a100 = 668),
                    (t.a89 = 390),
                    (t.a90 = 390),
                    (t.a93 = 317),
                    (t.a94 = 317),
                    (t.a91 = 276),
                    (t.a92 = 276),
                    (t.a205 = 509),
                    (t.a85 = 509),
                    (t.a206 = 410),
                    (t.a86 = 410),
                    (t.a87 = 234),
                    (t.a88 = 234),
                    (t.a95 = 334),
                    (t.a96 = 334),
                    (t.a101 = 732),
                    (t.a102 = 544),
                    (t.a103 = 544),
                    (t.a104 = 910),
                    (t.a106 = 667),
                    (t.a107 = 760),
                    (t.a108 = 760),
                    (t.a112 = 776),
                    (t.a111 = 595),
                    (t.a110 = 694),
                    (t.a109 = 626),
                    (t.a120 = 788),
                    (t.a121 = 788),
                    (t.a122 = 788),
                    (t.a123 = 788),
                    (t.a124 = 788),
                    (t.a125 = 788),
                    (t.a126 = 788),
                    (t.a127 = 788),
                    (t.a128 = 788),
                    (t.a129 = 788),
                    (t.a130 = 788),
                    (t.a131 = 788),
                    (t.a132 = 788),
                    (t.a133 = 788),
                    (t.a134 = 788),
                    (t.a135 = 788),
                    (t.a136 = 788),
                    (t.a137 = 788),
                    (t.a138 = 788),
                    (t.a139 = 788),
                    (t.a140 = 788),
                    (t.a141 = 788),
                    (t.a142 = 788),
                    (t.a143 = 788),
                    (t.a144 = 788),
                    (t.a145 = 788),
                    (t.a146 = 788),
                    (t.a147 = 788),
                    (t.a148 = 788),
                    (t.a149 = 788),
                    (t.a150 = 788),
                    (t.a151 = 788),
                    (t.a152 = 788),
                    (t.a153 = 788),
                    (t.a154 = 788),
                    (t.a155 = 788),
                    (t.a156 = 788),
                    (t.a157 = 788),
                    (t.a158 = 788),
                    (t.a159 = 788),
                    (t.a160 = 894),
                    (t.a161 = 838),
                    (t.a163 = 1016),
                    (t.a164 = 458),
                    (t.a196 = 748),
                    (t.a165 = 924),
                    (t.a192 = 748),
                    (t.a166 = 918),
                    (t.a167 = 927),
                    (t.a168 = 928),
                    (t.a169 = 928),
                    (t.a170 = 834),
                    (t.a171 = 873),
                    (t.a172 = 828),
                    (t.a173 = 924),
                    (t.a162 = 924),
                    (t.a174 = 917),
                    (t.a175 = 930),
                    (t.a176 = 931),
                    (t.a177 = 463),
                    (t.a178 = 883),
                    (t.a179 = 836),
                    (t.a193 = 836),
                    (t.a180 = 867),
                    (t.a199 = 867),
                    (t.a181 = 696),
                    (t.a200 = 696),
                    (t.a182 = 874),
                    (t.a201 = 874),
                    (t.a183 = 760),
                    (t.a184 = 946),
                    (t.a197 = 771),
                    (t.a185 = 865),
                    (t.a194 = 771),
                    (t.a198 = 888),
                    (t.a186 = 967),
                    (t.a195 = 888),
                    (t.a187 = 831),
                    (t.a188 = 873),
                    (t.a189 = 927);
                  (t.a190 = 970), (t.a191 = 918);
                }));
            });
          exports.getMetrics = getMetrics;
        })((root.pdfjsCoreMetrics = {}), root.pdfjsSharedUtil);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil) {
          var Uint32ArrayView = sharedUtil.Uint32ArrayView,
            MurmurHash3_64 = (function (seed) {
              function MurmurHash3_64(seed) {
                (this.h1 = seed ? 4294967295 & seed : 3285377520), (this.h2 = seed ? 4294967295 & seed : 3285377520);
              }
              var alwaysUseUint32ArrayView = !1;
              try {
                new Uint32Array(new Uint8Array(5).buffer, 0, 1);
              } catch (e) {
                alwaysUseUint32ArrayView = !0;
              }
              return (
                (MurmurHash3_64.prototype = {
                  update: function (input) {
                    var i,
                      useUint32ArrayView = alwaysUseUint32ArrayView;
                    if ("string" == typeof input) {
                      var data = new Uint8Array(2 * input.length),
                        length = 0;
                      for (i = 0; i < input.length; i++) {
                        var code = input.charCodeAt(i);
                        code <= 255
                          ? (data[length++] = code)
                          : ((data[length++] = code >>> 8), (data[length++] = 255 & code));
                      }
                    } else if (input instanceof Uint8Array) (data = input), (length = data.length);
                    else {
                      if (!("object" == typeof input && "length" in input))
                        throw new Error("Wrong data format in MurmurHash3_64_update. Input must be a string or array.");
                      (data = input), (length = data.length), (useUint32ArrayView = !0);
                    }
                    var blockCounts = length >> 2,
                      tailLength = length - 4 * blockCounts,
                      dataUint32 = useUint32ArrayView
                        ? new Uint32ArrayView(data, blockCounts)
                        : new Uint32Array(data.buffer, 0, blockCounts),
                      k1 = 0,
                      k2 = 0,
                      h1 = this.h1,
                      h2 = this.h2,
                      C1 = 3432918353,
                      C2 = 461845907;
                    for (i = 0; i < blockCounts; i++)
                      1 & i
                        ? ((k1 = dataUint32[i]),
                          (k1 = ((k1 * C1) & 4294901760) | ((11601 * k1) & 65535)),
                          (k1 = (k1 << 15) | (k1 >>> 17)),
                          (k1 = ((k1 * C2) & 4294901760) | ((13715 * k1) & 65535)),
                          (h1 ^= k1),
                          (h1 = (h1 << 13) | (h1 >>> 19)),
                          (h1 = 5 * h1 + 3864292196))
                        : ((k2 = dataUint32[i]),
                          (k2 = ((k2 * C1) & 4294901760) | ((11601 * k2) & 65535)),
                          (k2 = (k2 << 15) | (k2 >>> 17)),
                          (k2 = ((k2 * C2) & 4294901760) | ((13715 * k2) & 65535)),
                          (h2 ^= k2),
                          (h2 = (h2 << 13) | (h2 >>> 19)),
                          (h2 = 5 * h2 + 3864292196));
                    switch (((k1 = 0), tailLength)) {
                      case 3:
                        k1 ^= data[4 * blockCounts + 2] << 16;
                      case 2:
                        k1 ^= data[4 * blockCounts + 1] << 8;
                      case 1:
                        (k1 ^= data[4 * blockCounts]),
                          (k1 = ((k1 * C1) & 4294901760) | ((11601 * k1) & 65535)),
                          (k1 = (k1 << 15) | (k1 >>> 17)),
                          (k1 = ((k1 * C2) & 4294901760) | ((13715 * k1) & 65535)),
                          1 & blockCounts ? (h1 ^= k1) : (h2 ^= k1);
                    }
                    return (this.h1 = h1), (this.h2 = h2), this;
                  },
                  hexdigest: function () {
                    var h1 = this.h1,
                      h2 = this.h2;
                    (h1 ^= h2 >>> 1),
                      (h1 = ((3981806797 * h1) & 4294901760) | ((36045 * h1) & 65535)),
                      (h2 =
                        ((4283543511 * h2) & 4294901760) |
                        (((2950163797 * ((h2 << 16) | (h1 >>> 16))) & 4294901760) >>> 16)),
                      (h1 ^= h2 >>> 1),
                      (h1 = ((444984403 * h1) & 4294901760) | ((60499 * h1) & 65535)),
                      (h2 =
                        ((3301882366 * h2) & 4294901760) |
                        (((3120437893 * ((h2 << 16) | (h1 >>> 16))) & 4294901760) >>> 16)),
                      (h1 ^= h2 >>> 1);
                    for (var i = 0, arr = [h1, h2], str = ""; i < arr.length; i++) {
                      for (var hex = (arr[i] >>> 0).toString(16); hex.length < 8; ) hex = "0" + hex;
                      str += hex;
                    }
                    return str;
                  },
                }),
                MurmurHash3_64
              );
            })();
          exports.MurmurHash3_64 = MurmurHash3_64;
        })((root.pdfjsCoreMurmurHash3 = {}), root.pdfjsSharedUtil);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil) {
          function isName(v, name) {
            return v instanceof Name && (void 0 === name || v.name === name);
          }
          function isCmd(v, cmd) {
            return v instanceof Cmd && (void 0 === cmd || v.cmd === cmd);
          }
          function isDict(v, type) {
            return v instanceof Dict && (void 0 === type || isName(v.get("Type"), type));
          }
          function isRef(v) {
            return v instanceof Ref;
          }
          function isRefsEqual(v1, v2) {
            return v1.num === v2.num && v1.gen === v2.gen;
          }
          function isStream(v) {
            return "object" == typeof v && null !== v && void 0 !== v.getBytes;
          }
          var isArray = sharedUtil.isArray,
            Name = (function () {
              function Name(name) {
                this.name = name;
              }
              Name.prototype = {};
              var nameCache = Object.create(null);
              return (
                (Name.get = function (name) {
                  var nameValue = nameCache[name];
                  return nameValue || (nameCache[name] = new Name(name));
                }),
                Name
              );
            })(),
            Cmd = (function () {
              function Cmd(cmd) {
                this.cmd = cmd;
              }
              Cmd.prototype = {};
              var cmdCache = Object.create(null);
              return (
                (Cmd.get = function (cmd) {
                  var cmdValue = cmdCache[cmd];
                  return cmdValue || (cmdCache[cmd] = new Cmd(cmd));
                }),
                Cmd
              );
            })(),
            Dict = (function () {
              function Dict(xref) {
                (this.map = Object.create(null)),
                  (this.xref = xref),
                  (this.objId = null),
                  (this.__nonSerializable__ = nonSerializable);
              }
              var nonSerializable = function () {
                return nonSerializable;
              };
              return (
                (Dict.prototype = {
                  assignXref: function (newXref) {
                    this.xref = newXref;
                  },
                  get: function (key1, key2, key3) {
                    var value,
                      xref = this.xref;
                    return void 0 !== (value = this.map[key1]) || key1 in this.map || void 0 === key2
                      ? xref
                        ? xref.fetchIfRef(value)
                        : value
                      : void 0 !== (value = this.map[key2]) || key2 in this.map || void 0 === key3
                      ? xref
                        ? xref.fetchIfRef(value)
                        : value
                      : ((value = this.map[key3] || null), xref ? xref.fetchIfRef(value) : value);
                  },
                  getAsync: function (key1, key2, key3) {
                    var value,
                      xref = this.xref;
                    return void 0 !== (value = this.map[key1]) || key1 in this.map || void 0 === key2
                      ? xref
                        ? xref.fetchIfRefAsync(value)
                        : Promise.resolve(value)
                      : void 0 !== (value = this.map[key2]) || key2 in this.map || void 0 === key3
                      ? xref
                        ? xref.fetchIfRefAsync(value)
                        : Promise.resolve(value)
                      : ((value = this.map[key3] || null), xref ? xref.fetchIfRefAsync(value) : Promise.resolve(value));
                  },
                  getArray: function (key1, key2, key3) {
                    var value = this.get(key1, key2, key3),
                      xref = this.xref;
                    if (!isArray(value) || !xref) return value;
                    value = value.slice();
                    for (var i = 0, ii = value.length; i < ii; i++)
                      isRef(value[i]) && (value[i] = xref.fetch(value[i]));
                    return value;
                  },
                  getRaw: function (key) {
                    return this.map[key];
                  },
                  getKeys: function () {
                    return Object.keys(this.map);
                  },
                  set: function (key, value) {
                    this.map[key] = value;
                  },
                  has: function (key) {
                    return key in this.map;
                  },
                  forEach: function (callback) {
                    for (var key in this.map) callback(key, this.get(key));
                  },
                }),
                (Dict.empty = new Dict(null)),
                (Dict.merge = function (xref, dictArray) {
                  for (var mergedDict = new Dict(xref), i = 0, ii = dictArray.length; i < ii; i++) {
                    var dict = dictArray[i];
                    if (isDict(dict))
                      for (var keyName in dict.map)
                        mergedDict.map[keyName] || (mergedDict.map[keyName] = dict.map[keyName]);
                  }
                  return mergedDict;
                }),
                Dict
              );
            })(),
            Ref = (function () {
              function Ref(num, gen) {
                (this.num = num), (this.gen = gen);
              }
              return (
                (Ref.prototype = {
                  toString: function () {
                    var str = this.num + "R";
                    return 0 !== this.gen && (str += this.gen), str;
                  },
                }),
                Ref
              );
            })(),
            RefSet = (function () {
              function RefSet() {
                this.dict = Object.create(null);
              }
              return (
                (RefSet.prototype = {
                  has: function (ref) {
                    return ref.toString() in this.dict;
                  },
                  put: function (ref) {
                    this.dict[ref.toString()] = !0;
                  },
                  remove: function (ref) {
                    delete this.dict[ref.toString()];
                  },
                }),
                RefSet
              );
            })(),
            RefSetCache = (function () {
              function RefSetCache() {
                this.dict = Object.create(null);
              }
              return (
                (RefSetCache.prototype = {
                  get: function (ref) {
                    return this.dict[ref.toString()];
                  },
                  has: function (ref) {
                    return ref.toString() in this.dict;
                  },
                  put: function (ref, obj) {
                    this.dict[ref.toString()] = obj;
                  },
                  putAlias: function (ref, aliasRef) {
                    this.dict[ref.toString()] = this.get(aliasRef);
                  },
                  forEach: function (fn, thisArg) {
                    for (var i in this.dict) fn.call(thisArg, this.dict[i]);
                  },
                  clear: function () {
                    this.dict = Object.create(null);
                  },
                }),
                RefSetCache
              );
            })();
          (exports.Cmd = Cmd),
            (exports.Dict = Dict),
            (exports.Name = Name),
            (exports.Ref = Ref),
            (exports.RefSet = RefSet),
            (exports.RefSetCache = RefSetCache),
            (exports.isCmd = isCmd),
            (exports.isDict = isDict),
            (exports.isName = isName),
            (exports.isRef = isRef),
            (exports.isRefsEqual = isRefsEqual),
            (exports.isStream = isStream);
        })((root.pdfjsCorePrimitives = {}), root.pdfjsSharedUtil);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil) {
          var getLookupTableFactory = sharedUtil.getLookupTableFactory,
            getStdFontMap = getLookupTableFactory(function (t) {
              (t.ArialNarrow = "Helvetica"),
                (t["ArialNarrow-Bold"] = "Helvetica-Bold"),
                (t["ArialNarrow-BoldItalic"] = "Helvetica-BoldOblique"),
                (t["ArialNarrow-Italic"] = "Helvetica-Oblique"),
                (t.ArialBlack = "Helvetica"),
                (t["ArialBlack-Bold"] = "Helvetica-Bold"),
                (t["ArialBlack-BoldItalic"] = "Helvetica-BoldOblique"),
                (t["ArialBlack-Italic"] = "Helvetica-Oblique"),
                (t.Arial = "Helvetica"),
                (t["Arial-Bold"] = "Helvetica-Bold"),
                (t["Arial-BoldItalic"] = "Helvetica-BoldOblique"),
                (t["Arial-Italic"] = "Helvetica-Oblique"),
                (t["Arial-BoldItalicMT"] = "Helvetica-BoldOblique"),
                (t["Arial-BoldMT"] = "Helvetica-Bold"),
                (t["Arial-ItalicMT"] = "Helvetica-Oblique"),
                (t.ArialMT = "Helvetica"),
                (t["Courier-Bold"] = "Courier-Bold"),
                (t["Courier-BoldItalic"] = "Courier-BoldOblique"),
                (t["Courier-Italic"] = "Courier-Oblique"),
                (t.CourierNew = "Courier"),
                (t["CourierNew-Bold"] = "Courier-Bold"),
                (t["CourierNew-BoldItalic"] = "Courier-BoldOblique"),
                (t["CourierNew-Italic"] = "Courier-Oblique"),
                (t["CourierNewPS-BoldItalicMT"] = "Courier-BoldOblique"),
                (t["CourierNewPS-BoldMT"] = "Courier-Bold"),
                (t["CourierNewPS-ItalicMT"] = "Courier-Oblique"),
                (t.CourierNewPSMT = "Courier"),
                (t.Helvetica = "Helvetica"),
                (t["Helvetica-Bold"] = "Helvetica-Bold"),
                (t["Helvetica-BoldItalic"] = "Helvetica-BoldOblique"),
                (t["Helvetica-BoldOblique"] = "Helvetica-BoldOblique"),
                (t["Helvetica-Italic"] = "Helvetica-Oblique"),
                (t["Helvetica-Oblique"] = "Helvetica-Oblique"),
                (t["Symbol-Bold"] = "Symbol"),
                (t["Symbol-BoldItalic"] = "Symbol"),
                (t["Symbol-Italic"] = "Symbol"),
                (t.TimesNewRoman = "Times-Roman"),
                (t["TimesNewRoman-Bold"] = "Times-Bold"),
                (t["TimesNewRoman-BoldItalic"] = "Times-BoldItalic"),
                (t["TimesNewRoman-Italic"] = "Times-Italic"),
                (t.TimesNewRomanPS = "Times-Roman"),
                (t["TimesNewRomanPS-Bold"] = "Times-Bold"),
                (t["TimesNewRomanPS-BoldItalic"] = "Times-BoldItalic"),
                (t["TimesNewRomanPS-BoldItalicMT"] = "Times-BoldItalic"),
                (t["TimesNewRomanPS-BoldMT"] = "Times-Bold"),
                (t["TimesNewRomanPS-Italic"] = "Times-Italic"),
                (t["TimesNewRomanPS-ItalicMT"] = "Times-Italic"),
                (t.TimesNewRomanPSMT = "Times-Roman"),
                (t["TimesNewRomanPSMT-Bold"] = "Times-Bold"),
                (t["TimesNewRomanPSMT-BoldItalic"] = "Times-BoldItalic"),
                (t["TimesNewRomanPSMT-Italic"] = "Times-Italic");
            }),
            getNonStdFontMap = getLookupTableFactory(function (t) {
              (t.CenturyGothic = "Helvetica"),
                (t["CenturyGothic-Bold"] = "Helvetica-Bold"),
                (t["CenturyGothic-BoldItalic"] = "Helvetica-BoldOblique"),
                (t["CenturyGothic-Italic"] = "Helvetica-Oblique"),
                (t.ComicSansMS = "Comic Sans MS"),
                (t["ComicSansMS-Bold"] = "Comic Sans MS-Bold"),
                (t["ComicSansMS-BoldItalic"] = "Comic Sans MS-BoldItalic"),
                (t["ComicSansMS-Italic"] = "Comic Sans MS-Italic"),
                (t.LucidaConsole = "Courier"),
                (t["LucidaConsole-Bold"] = "Courier-Bold"),
                (t["LucidaConsole-BoldItalic"] = "Courier-BoldOblique"),
                (t["LucidaConsole-Italic"] = "Courier-Oblique"),
                (t["MS-Gothic"] = "MS Gothic"),
                (t["MS-Gothic-Bold"] = "MS Gothic-Bold"),
                (t["MS-Gothic-BoldItalic"] = "MS Gothic-BoldItalic"),
                (t["MS-Gothic-Italic"] = "MS Gothic-Italic"),
                (t["MS-Mincho"] = "MS Mincho"),
                (t["MS-Mincho-Bold"] = "MS Mincho-Bold"),
                (t["MS-Mincho-BoldItalic"] = "MS Mincho-BoldItalic"),
                (t["MS-Mincho-Italic"] = "MS Mincho-Italic"),
                (t["MS-PGothic"] = "MS PGothic"),
                (t["MS-PGothic-Bold"] = "MS PGothic-Bold"),
                (t["MS-PGothic-BoldItalic"] = "MS PGothic-BoldItalic"),
                (t["MS-PGothic-Italic"] = "MS PGothic-Italic"),
                (t["MS-PMincho"] = "MS PMincho"),
                (t["MS-PMincho-Bold"] = "MS PMincho-Bold"),
                (t["MS-PMincho-BoldItalic"] = "MS PMincho-BoldItalic"),
                (t["MS-PMincho-Italic"] = "MS PMincho-Italic"),
                (t.Wingdings = "ZapfDingbats");
            }),
            getSerifFonts = getLookupTableFactory(function (t) {
              (t["Adobe Jenson"] = !0),
                (t["Adobe Text"] = !0),
                (t.Albertus = !0),
                (t.Aldus = !0),
                (t.Alexandria = !0),
                (t.Algerian = !0),
                (t["American Typewriter"] = !0),
                (t.Antiqua = !0),
                (t.Apex = !0),
                (t.Arno = !0),
                (t.Aster = !0),
                (t.Aurora = !0),
                (t.Baskerville = !0),
                (t.Bell = !0),
                (t.Bembo = !0),
                (t["Bembo Schoolbook"] = !0),
                (t.Benguiat = !0),
                (t["Berkeley Old Style"] = !0),
                (t["Bernhard Modern"] = !0),
                (t["Berthold City"] = !0),
                (t.Bodoni = !0),
                (t["Bauer Bodoni"] = !0),
                (t["Book Antiqua"] = !0),
                (t.Bookman = !0),
                (t["Bordeaux Roman"] = !0),
                (t["Californian FB"] = !0),
                (t.Calisto = !0),
                (t.Calvert = !0),
                (t.Capitals = !0),
                (t.Cambria = !0),
                (t.Cartier = !0),
                (t.Caslon = !0),
                (t.Catull = !0),
                (t.Centaur = !0),
                (t["Century Old Style"] = !0),
                (t["Century Schoolbook"] = !0),
                (t.Chaparral = !0),
                (t["Charis SIL"] = !0),
                (t.Cheltenham = !0),
                (t["Cholla Slab"] = !0),
                (t.Clarendon = !0),
                (t.Clearface = !0),
                (t.Cochin = !0),
                (t.Colonna = !0),
                (t["Computer Modern"] = !0),
                (t["Concrete Roman"] = !0),
                (t.Constantia = !0),
                (t["Cooper Black"] = !0),
                (t.Corona = !0),
                (t.Ecotype = !0),
                (t.Egyptienne = !0),
                (t.Elephant = !0),
                (t.Excelsior = !0),
                (t.Fairfield = !0),
                (t["FF Scala"] = !0),
                (t.Folkard = !0),
                (t.Footlight = !0),
                (t.FreeSerif = !0),
                (t["Friz Quadrata"] = !0),
                (t.Garamond = !0),
                (t.Gentium = !0),
                (t.Georgia = !0),
                (t.Gloucester = !0),
                (t["Goudy Old Style"] = !0),
                (t["Goudy Schoolbook"] = !0),
                (t["Goudy Pro Font"] = !0),
                (t.Granjon = !0),
                (t["Guardian Egyptian"] = !0),
                (t.Heather = !0),
                (t.Hercules = !0),
                (t["High Tower Text"] = !0),
                (t.Hiroshige = !0),
                (t["Hoefler Text"] = !0),
                (t["Humana Serif"] = !0),
                (t.Imprint = !0),
                (t["Ionic No. 5"] = !0),
                (t.Janson = !0),
                (t.Joanna = !0),
                (t.Korinna = !0),
                (t.Lexicon = !0),
                (t["Liberation Serif"] = !0),
                (t["Linux Libertine"] = !0),
                (t.Literaturnaya = !0),
                (t.Lucida = !0),
                (t["Lucida Bright"] = !0),
                (t.Melior = !0),
                (t.Memphis = !0),
                (t.Miller = !0),
                (t.Minion = !0),
                (t.Modern = !0),
                (t["Mona Lisa"] = !0),
                (t["Mrs Eaves"] = !0),
                (t["MS Serif"] = !0),
                (t["Museo Slab"] = !0),
                (t["New York"] = !0),
                (t["Nimbus Roman"] = !0),
                (t["NPS Rawlinson Roadway"] = !0),
                (t.Palatino = !0),
                (t.Perpetua = !0),
                (t.Plantin = !0),
                (t["Plantin Schoolbook"] = !0),
                (t.Playbill = !0),
                (t["Poor Richard"] = !0),
                (t["Rawlinson Roadway"] = !0),
                (t.Renault = !0),
                (t.Requiem = !0),
                (t.Rockwell = !0),
                (t.Roman = !0),
                (t["Rotis Serif"] = !0),
                (t.Sabon = !0),
                (t.Scala = !0),
                (t.Seagull = !0),
                (t.Sistina = !0),
                (t.Souvenir = !0),
                (t.STIX = !0),
                (t["Stone Informal"] = !0),
                (t["Stone Serif"] = !0),
                (t.Sylfaen = !0),
                (t.Times = !0),
                (t.Trajan = !0),
                (t["Trinité"] = !0),
                (t["Trump Mediaeval"] = !0),
                (t.Utopia = !0),
                (t["Vale Type"] = !0),
                (t["Bitstream Vera"] = !0),
                (t["Vera Serif"] = !0),
                (t.Versailles = !0),
                (t.Wanted = !0),
                (t.Weiss = !0),
                (t["Wide Latin"] = !0),
                (t.Windsor = !0),
                (t.XITS = !0);
            }),
            getSymbolsFonts = getLookupTableFactory(function (t) {
              (t.Dingbats = !0), (t.Symbol = !0), (t.ZapfDingbats = !0);
            }),
            getGlyphMapForStandardFonts = getLookupTableFactory(function (t) {
              (t[2] = 10),
                (t[3] = 32),
                (t[4] = 33),
                (t[5] = 34),
                (t[6] = 35),
                (t[7] = 36),
                (t[8] = 37),
                (t[9] = 38),
                (t[10] = 39),
                (t[11] = 40),
                (t[12] = 41),
                (t[13] = 42),
                (t[14] = 43),
                (t[15] = 44),
                (t[16] = 45),
                (t[17] = 46),
                (t[18] = 47),
                (t[19] = 48),
                (t[20] = 49),
                (t[21] = 50),
                (t[22] = 51),
                (t[23] = 52),
                (t[24] = 53),
                (t[25] = 54),
                (t[26] = 55),
                (t[27] = 56),
                (t[28] = 57),
                (t[29] = 58),
                (t[30] = 894),
                (t[31] = 60),
                (t[32] = 61),
                (t[33] = 62),
                (t[34] = 63),
                (t[35] = 64),
                (t[36] = 65),
                (t[37] = 66),
                (t[38] = 67),
                (t[39] = 68),
                (t[40] = 69),
                (t[41] = 70),
                (t[42] = 71),
                (t[43] = 72),
                (t[44] = 73),
                (t[45] = 74),
                (t[46] = 75),
                (t[47] = 76),
                (t[48] = 77),
                (t[49] = 78),
                (t[50] = 79),
                (t[51] = 80),
                (t[52] = 81),
                (t[53] = 82),
                (t[54] = 83),
                (t[55] = 84),
                (t[56] = 85),
                (t[57] = 86),
                (t[58] = 87),
                (t[59] = 88),
                (t[60] = 89),
                (t[61] = 90),
                (t[62] = 91),
                (t[63] = 92),
                (t[64] = 93),
                (t[65] = 94),
                (t[66] = 95),
                (t[67] = 96),
                (t[68] = 97),
                (t[69] = 98),
                (t[70] = 99),
                (t[71] = 100),
                (t[72] = 101),
                (t[73] = 102),
                (t[74] = 103),
                (t[75] = 104),
                (t[76] = 105),
                (t[77] = 106),
                (t[78] = 107),
                (t[79] = 108),
                (t[80] = 109),
                (t[81] = 110),
                (t[82] = 111),
                (t[83] = 112),
                (t[84] = 113),
                (t[85] = 114),
                (t[86] = 115),
                (t[87] = 116),
                (t[88] = 117),
                (t[89] = 118),
                (t[90] = 119),
                (t[91] = 120),
                (t[92] = 121),
                (t[93] = 122),
                (t[94] = 123),
                (t[95] = 124),
                (t[96] = 125),
                (t[97] = 126),
                (t[98] = 196),
                (t[99] = 197),
                (t[100] = 199),
                (t[101] = 201),
                (t[102] = 209),
                (t[103] = 214),
                (t[104] = 220),
                (t[105] = 225),
                (t[106] = 224),
                (t[107] = 226),
                (t[108] = 228),
                (t[109] = 227),
                (t[110] = 229),
                (t[111] = 231),
                (t[112] = 233),
                (t[113] = 232),
                (t[114] = 234),
                (t[115] = 235),
                (t[116] = 237),
                (t[117] = 236),
                (t[118] = 238),
                (t[119] = 239),
                (t[120] = 241),
                (t[121] = 243),
                (t[122] = 242),
                (t[123] = 244),
                (t[124] = 246),
                (t[125] = 245),
                (t[126] = 250),
                (t[127] = 249),
                (t[128] = 251),
                (t[129] = 252),
                (t[130] = 8224),
                (t[131] = 176),
                (t[132] = 162),
                (t[133] = 163),
                (t[134] = 167),
                (t[135] = 8226),
                (t[136] = 182),
                (t[137] = 223),
                (t[138] = 174),
                (t[139] = 169),
                (t[140] = 8482),
                (t[141] = 180),
                (t[142] = 168),
                (t[143] = 8800),
                (t[144] = 198),
                (t[145] = 216),
                (t[146] = 8734),
                (t[147] = 177),
                (t[148] = 8804),
                (t[149] = 8805),
                (t[150] = 165),
                (t[151] = 181),
                (t[152] = 8706),
                (t[153] = 8721),
                (t[154] = 8719),
                (t[156] = 8747),
                (t[157] = 170),
                (t[158] = 186),
                (t[159] = 8486),
                (t[160] = 230),
                (t[161] = 248),
                (t[162] = 191),
                (t[163] = 161),
                (t[164] = 172),
                (t[165] = 8730),
                (t[166] = 402),
                (t[167] = 8776),
                (t[168] = 8710),
                (t[169] = 171),
                (t[170] = 187),
                (t[171] = 8230),
                (t[210] = 218),
                (t[223] = 711),
                (t[224] = 321),
                (t[225] = 322),
                (t[227] = 353),
                (t[229] = 382),
                (t[234] = 253),
                (t[252] = 263),
                (t[253] = 268),
                (t[254] = 269),
                (t[258] = 258),
                (t[260] = 260),
                (t[261] = 261),
                (t[265] = 280),
                (t[266] = 281),
                (t[268] = 283),
                (t[269] = 313),
                (t[275] = 323),
                (t[276] = 324),
                (t[278] = 328),
                (t[284] = 345),
                (t[285] = 346),
                (t[286] = 347),
                (t[292] = 367),
                (t[295] = 377),
                (t[296] = 378),
                (t[298] = 380),
                (t[305] = 963),
                (t[306] = 964),
                (t[307] = 966),
                (t[308] = 8215);
              (t[309] = 8252),
                (t[310] = 8319),
                (t[311] = 8359),
                (t[312] = 8592),
                (t[313] = 8593),
                (t[337] = 9552),
                (t[493] = 1039),
                (t[494] = 1040),
                (t[705] = 1524),
                (t[706] = 8362),
                (t[710] = 64288),
                (t[711] = 64298),
                (t[759] = 1617),
                (t[761] = 1776),
                (t[763] = 1778),
                (t[775] = 1652),
                (t[777] = 1764),
                (t[778] = 1780),
                (t[779] = 1781),
                (t[780] = 1782),
                (t[782] = 771),
                (t[783] = 64726),
                (t[786] = 8363),
                (t[788] = 8532),
                (t[790] = 768),
                (t[791] = 769),
                (t[792] = 768),
                (t[795] = 803),
                (t[797] = 64336),
                (t[798] = 64337),
                (t[799] = 64342),
                (t[800] = 64343),
                (t[801] = 64344),
                (t[802] = 64345),
                (t[803] = 64362),
                (t[804] = 64363),
                (t[805] = 64364),
                (t[2424] = 7821),
                (t[2425] = 7822),
                (t[2426] = 7823),
                (t[2427] = 7824),
                (t[2428] = 7825),
                (t[2429] = 7826),
                (t[2430] = 7827),
                (t[2433] = 7682),
                (t[2678] = 8045),
                (t[2679] = 8046),
                (t[2830] = 1552),
                (t[2838] = 686),
                (t[2840] = 751),
                (t[2842] = 753),
                (t[2843] = 754),
                (t[2844] = 755),
                (t[2846] = 757),
                (t[2856] = 767),
                (t[2857] = 848),
                (t[2858] = 849),
                (t[2862] = 853),
                (t[2863] = 854),
                (t[2864] = 855),
                (t[2865] = 861),
                (t[2866] = 862),
                (t[2906] = 7460),
                (t[2908] = 7462),
                (t[2909] = 7463),
                (t[2910] = 7464),
                (t[2912] = 7466),
                (t[2913] = 7467),
                (t[2914] = 7468),
                (t[2916] = 7470),
                (t[2917] = 7471),
                (t[2918] = 7472),
                (t[2920] = 7474),
                (t[2921] = 7475),
                (t[2922] = 7476),
                (t[2924] = 7478),
                (t[2925] = 7479),
                (t[2926] = 7480),
                (t[2928] = 7482),
                (t[2929] = 7483),
                (t[2930] = 7484),
                (t[2932] = 7486),
                (t[2933] = 7487),
                (t[2934] = 7488),
                (t[2936] = 7490),
                (t[2937] = 7491),
                (t[2938] = 7492),
                (t[2940] = 7494),
                (t[2941] = 7495),
                (t[2942] = 7496),
                (t[2944] = 7498),
                (t[2946] = 7500),
                (t[2948] = 7502),
                (t[2950] = 7504),
                (t[2951] = 7505),
                (t[2952] = 7506),
                (t[2954] = 7508),
                (t[2955] = 7509),
                (t[2956] = 7510),
                (t[2958] = 7512),
                (t[2959] = 7513),
                (t[2960] = 7514),
                (t[2962] = 7516),
                (t[2963] = 7517),
                (t[2964] = 7518),
                (t[2966] = 7520),
                (t[2967] = 7521),
                (t[2968] = 7522),
                (t[2970] = 7524),
                (t[2971] = 7525),
                (t[2972] = 7526),
                (t[2974] = 7528),
                (t[2975] = 7529),
                (t[2976] = 7530),
                (t[2978] = 1537),
                (t[2979] = 1538),
                (t[2980] = 1539),
                (t[2982] = 1549),
                (t[2983] = 1551),
                (t[2984] = 1552),
                (t[2986] = 1554),
                (t[2987] = 1555),
                (t[2988] = 1556),
                (t[2990] = 1623),
                (t[2991] = 1624),
                (t[2995] = 1775),
                (t[2999] = 1791),
                (t[3002] = 64290),
                (t[3003] = 64291),
                (t[3004] = 64292),
                (t[3006] = 64294),
                (t[3007] = 64295),
                (t[3008] = 64296),
                (t[3011] = 1900),
                (t[3014] = 8223),
                (t[3015] = 8244),
                (t[3017] = 7532),
                (t[3018] = 7533),
                (t[3019] = 7534),
                (t[3075] = 7590),
                (t[3076] = 7591),
                (t[3079] = 7594),
                (t[3080] = 7595),
                (t[3083] = 7598),
                (t[3084] = 7599),
                (t[3087] = 7602),
                (t[3088] = 7603),
                (t[3091] = 7606),
                (t[3092] = 7607),
                (t[3095] = 7610),
                (t[3096] = 7611),
                (t[3099] = 7614),
                (t[3100] = 7615),
                (t[3103] = 7618),
                (t[3104] = 7619),
                (t[3107] = 8337),
                (t[3108] = 8338),
                (t[3116] = 1884),
                (t[3119] = 1885),
                (t[3120] = 1885),
                (t[3123] = 1886),
                (t[3124] = 1886),
                (t[3127] = 1887),
                (t[3128] = 1887),
                (t[3131] = 1888),
                (t[3132] = 1888),
                (t[3135] = 1889),
                (t[3136] = 1889),
                (t[3139] = 1890),
                (t[3140] = 1890),
                (t[3143] = 1891),
                (t[3144] = 1891),
                (t[3147] = 1892),
                (t[3148] = 1892),
                (t[3153] = 580),
                (t[3154] = 581),
                (t[3157] = 584),
                (t[3158] = 585),
                (t[3161] = 588),
                (t[3162] = 589),
                (t[3165] = 891),
                (t[3166] = 892),
                (t[3169] = 1274),
                (t[3170] = 1275),
                (t[3173] = 1278),
                (t[3174] = 1279),
                (t[3181] = 7622),
                (t[3182] = 7623),
                (t[3282] = 11799),
                (t[3316] = 578),
                (t[3379] = 42785),
                (t[3393] = 1159),
                (t[3416] = 8377);
            }),
            getSupplementalGlyphMapForArialBlack = getLookupTableFactory(function (t) {
              (t[227] = 322), (t[264] = 261), (t[291] = 346);
            });
          (exports.getStdFontMap = getStdFontMap),
            (exports.getNonStdFontMap = getNonStdFontMap),
            (exports.getSerifFonts = getSerifFonts),
            (exports.getSymbolsFonts = getSymbolsFonts),
            (exports.getGlyphMapForStandardFonts = getGlyphMapForStandardFonts),
            (exports.getSupplementalGlyphMapForArialBlack = getSupplementalGlyphMapForArialBlack);
        })((root.pdfjsCoreStandardFonts = {}), root.pdfjsSharedUtil);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil) {
          function mapSpecialUnicodeValues(code) {
            return code >= 65520 && code <= 65535
              ? 0
              : code >= 62976 && code <= 63743
              ? getSpecialPUASymbols()[code] || code
              : code;
          }
          function getUnicodeForGlyph(name, glyphsUnicodeMap) {
            var unicode = glyphsUnicodeMap[name];
            if (void 0 !== unicode) return unicode;
            if (!name) return -1;
            if ("u" === name[0]) {
              var hexStr,
                nameLen = name.length;
              if (7 === nameLen && "n" === name[1] && "i" === name[2]) hexStr = name.substr(3);
              else {
                if (!(nameLen >= 5 && nameLen <= 7)) return -1;
                hexStr = name.substr(1);
              }
              if (hexStr === hexStr.toUpperCase() && (unicode = parseInt(hexStr, 16)) >= 0) return unicode;
            }
            return -1;
          }
          function getUnicodeRangeFor(value) {
            for (var i = 0, ii = UnicodeRanges.length; i < ii; i++) {
              var range = UnicodeRanges[i];
              if (value >= range.begin && value < range.end) return i;
            }
            return -1;
          }
          function isRTLRangeFor(value) {
            var range = UnicodeRanges[13];
            return (
              (value >= range.begin && value < range.end) ||
              ((range = UnicodeRanges[11]), value >= range.begin && value < range.end)
            );
          }
          function reverseIfRtl(chars) {
            var charsLength = chars.length;
            if (charsLength <= 1 || !isRTLRangeFor(chars.charCodeAt(0))) return chars;
            for (var s = "", ii = charsLength - 1; ii >= 0; ii--) s += chars[ii];
            return s;
          }
          var getLookupTableFactory = sharedUtil.getLookupTableFactory,
            getSpecialPUASymbols = getLookupTableFactory(function (t) {
              (t[63721] = 169),
                (t[63193] = 169),
                (t[63720] = 174),
                (t[63194] = 174),
                (t[63722] = 8482),
                (t[63195] = 8482),
                (t[63729] = 9127),
                (t[63730] = 9128),
                (t[63731] = 9129),
                (t[63740] = 9131),
                (t[63741] = 9132),
                (t[63742] = 9133),
                (t[63726] = 9121),
                (t[63727] = 9122),
                (t[63728] = 9123),
                (t[63737] = 9124),
                (t[63738] = 9125),
                (t[63739] = 9126),
                (t[63723] = 9115),
                (t[63724] = 9116),
                (t[63725] = 9117),
                (t[63734] = 9118),
                (t[63735] = 9119),
                (t[63736] = 9120);
            }),
            UnicodeRanges = [
              { begin: 0, end: 127 },
              { begin: 128, end: 255 },
              { begin: 256, end: 383 },
              { begin: 384, end: 591 },
              { begin: 592, end: 687 },
              { begin: 688, end: 767 },
              { begin: 768, end: 879 },
              { begin: 880, end: 1023 },
              { begin: 11392, end: 11519 },
              { begin: 1024, end: 1279 },
              { begin: 1328, end: 1423 },
              { begin: 1424, end: 1535 },
              { begin: 42240, end: 42559 },
              { begin: 1536, end: 1791 },
              { begin: 1984, end: 2047 },
              { begin: 2304, end: 2431 },
              { begin: 2432, end: 2559 },
              { begin: 2560, end: 2687 },
              { begin: 2688, end: 2815 },
              { begin: 2816, end: 2943 },
              { begin: 2944, end: 3071 },
              { begin: 3072, end: 3199 },
              { begin: 3200, end: 3327 },
              { begin: 3328, end: 3455 },
              { begin: 3584, end: 3711 },
              { begin: 3712, end: 3839 },
              { begin: 4256, end: 4351 },
              { begin: 6912, end: 7039 },
              { begin: 4352, end: 4607 },
              { begin: 7680, end: 7935 },
              { begin: 7936, end: 8191 },
              { begin: 8192, end: 8303 },
              { begin: 8304, end: 8351 },
              { begin: 8352, end: 8399 },
              { begin: 8400, end: 8447 },
              { begin: 8448, end: 8527 },
              { begin: 8528, end: 8591 },
              { begin: 8592, end: 8703 },
              { begin: 8704, end: 8959 },
              { begin: 8960, end: 9215 },
              { begin: 9216, end: 9279 },
              { begin: 9280, end: 9311 },
              { begin: 9312, end: 9471 },
              { begin: 9472, end: 9599 },
              { begin: 9600, end: 9631 },
              { begin: 9632, end: 9727 },
              { begin: 9728, end: 9983 },
              { begin: 9984, end: 10175 },
              { begin: 12288, end: 12351 },
              { begin: 12352, end: 12447 },
              { begin: 12448, end: 12543 },
              { begin: 12544, end: 12591 },
              { begin: 12592, end: 12687 },
              { begin: 43072, end: 43135 },
              { begin: 12800, end: 13055 },
              { begin: 13056, end: 13311 },
              { begin: 44032, end: 55215 },
              { begin: 55296, end: 57343 },
              { begin: 67840, end: 67871 },
              { begin: 19968, end: 40959 },
              { begin: 57344, end: 63743 },
              { begin: 12736, end: 12783 },
              { begin: 64256, end: 64335 },
              { begin: 64336, end: 65023 },
              { begin: 65056, end: 65071 },
              { begin: 65040, end: 65055 },
              { begin: 65104, end: 65135 },
              { begin: 65136, end: 65279 },
              { begin: 65280, end: 65519 },
              { begin: 65520, end: 65535 },
              { begin: 3840, end: 4095 },
              { begin: 1792, end: 1871 },
              { begin: 1920, end: 1983 },
              { begin: 3456, end: 3583 },
              { begin: 4096, end: 4255 },
              { begin: 4608, end: 4991 },
              { begin: 5024, end: 5119 },
              { begin: 5120, end: 5759 },
              { begin: 5760, end: 5791 },
              { begin: 5792, end: 5887 },
              { begin: 6016, end: 6143 },
              { begin: 6144, end: 6319 },
              { begin: 10240, end: 10495 },
              { begin: 40960, end: 42127 },
              { begin: 5888, end: 5919 },
              { begin: 66304, end: 66351 },
              { begin: 66352, end: 66383 },
              { begin: 66560, end: 66639 },
              { begin: 118784, end: 119039 },
              { begin: 119808, end: 120831 },
              { begin: 1044480, end: 1048573 },
              { begin: 65024, end: 65039 },
              { begin: 917504, end: 917631 },
              { begin: 6400, end: 6479 },
              { begin: 6480, end: 6527 },
              { begin: 6528, end: 6623 },
              { begin: 6656, end: 6687 },
              { begin: 11264, end: 11359 },
              { begin: 11568, end: 11647 },
              { begin: 19904, end: 19967 },
              { begin: 43008, end: 43055 },
              { begin: 65536, end: 65663 },
              { begin: 65856, end: 65935 },
              { begin: 66432, end: 66463 },
              { begin: 66464, end: 66527 },
              { begin: 66640, end: 66687 },
              { begin: 66688, end: 66735 },
              { begin: 67584, end: 67647 },
              { begin: 68096, end: 68191 },
              { begin: 119552, end: 119647 },
              { begin: 73728, end: 74751 },
              { begin: 119648, end: 119679 },
              { begin: 7040, end: 7103 },
              { begin: 7168, end: 7247 },
              { begin: 7248, end: 7295 },
              { begin: 43136, end: 43231 },
              { begin: 43264, end: 43311 },
              { begin: 43312, end: 43359 },
              { begin: 43520, end: 43615 },
              { begin: 65936, end: 65999 },
              { begin: 66e3, end: 66047 },
              { begin: 66208, end: 66271 },
              { begin: 127024, end: 127135 },
            ],
            getNormalizedUnicodes = getLookupTableFactory(function (t) {
              (t["¨"] = " ̈"),
                (t["¯"] = " ̄"),
                (t["´"] = " ́"),
                (t["µ"] = "μ"),
                (t["¸"] = " ̧"),
                (t["Ĳ"] = "IJ"),
                (t["ĳ"] = "ij"),
                (t["Ŀ"] = "L·"),
                (t["ŀ"] = "l·"),
                (t["ŉ"] = "ʼn"),
                (t["ſ"] = "s"),
                (t["Ǆ"] = "DŽ"),
                (t["ǅ"] = "Dž"),
                (t["ǆ"] = "dž"),
                (t["Ǉ"] = "LJ"),
                (t["ǈ"] = "Lj"),
                (t["ǉ"] = "lj"),
                (t["Ǌ"] = "NJ"),
                (t["ǋ"] = "Nj"),
                (t["ǌ"] = "nj"),
                (t["Ǳ"] = "DZ"),
                (t["ǲ"] = "Dz"),
                (t["ǳ"] = "dz"),
                (t["˘"] = " ̆"),
                (t["˙"] = " ̇"),
                (t["˚"] = " ̊"),
                (t["˛"] = " ̨"),
                (t["˜"] = " ̃"),
                (t["˝"] = " ̋"),
                (t["ͺ"] = " ͅ"),
                (t["΄"] = " ́"),
                (t["ϐ"] = "β"),
                (t["ϑ"] = "θ"),
                (t["ϒ"] = "Υ"),
                (t["ϕ"] = "φ"),
                (t["ϖ"] = "π"),
                (t["ϰ"] = "κ"),
                (t["ϱ"] = "ρ"),
                (t["ϲ"] = "ς"),
                (t["ϴ"] = "Θ"),
                (t["ϵ"] = "ε"),
                (t["Ϲ"] = "Σ"),
                (t["և"] = "եւ"),
                (t["ٵ"] = "اٴ"),
                (t["ٶ"] = "وٴ"),
                (t["ٷ"] = "ۇٴ"),
                (t["ٸ"] = "يٴ"),
                (t["ำ"] = "ํา"),
                (t["ຳ"] = "ໍາ"),
                (t["ໜ"] = "ຫນ"),
                (t["ໝ"] = "ຫມ"),
                (t["ཷ"] = "ྲཱྀ"),
                (t["ཹ"] = "ླཱྀ"),
                (t["ẚ"] = "aʾ"),
                (t["᾽"] = " ̓"),
                (t["᾿"] = " ̓"),
                (t["῀"] = " ͂"),
                (t["῾"] = " ̔"),
                (t[" "] = " "),
                (t[" "] = " "),
                (t[" "] = " "),
                (t[" "] = " "),
                (t[" "] = " "),
                (t[" "] = " "),
                (t[" "] = " "),
                (t[" "] = " "),
                (t["‗"] = " ̳"),
                (t["․"] = "."),
                (t["‥"] = ".."),
                (t["…"] = "..."),
                (t["″"] = "′′"),
                (t["‴"] = "′′′"),
                (t["‶"] = "‵‵"),
                (t["‷"] = "‵‵‵"),
                (t["‼"] = "!!"),
                (t["‾"] = " ̅"),
                (t["⁇"] = "??"),
                (t["⁈"] = "?!"),
                (t["⁉"] = "!?"),
                (t["⁗"] = "′′′′"),
                (t[" "] = " "),
                (t["₨"] = "Rs"),
                (t["℀"] = "a/c"),
                (t["℁"] = "a/s"),
                (t["℃"] = "°C"),
                (t["℅"] = "c/o"),
                (t["℆"] = "c/u"),
                (t["ℇ"] = "Ɛ"),
                (t["℉"] = "°F"),
                (t["№"] = "No"),
                (t["℡"] = "TEL"),
                (t["ℵ"] = "א"),
                (t["ℶ"] = "ב"),
                (t["ℷ"] = "ג"),
                (t["ℸ"] = "ד"),
                (t["℻"] = "FAX"),
                (t["Ⅰ"] = "I"),
                (t["Ⅱ"] = "II"),
                (t["Ⅲ"] = "III"),
                (t["Ⅳ"] = "IV"),
                (t["Ⅴ"] = "V"),
                (t["Ⅵ"] = "VI"),
                (t["Ⅶ"] = "VII"),
                (t["Ⅷ"] = "VIII"),
                (t["Ⅸ"] = "IX"),
                (t["Ⅹ"] = "X"),
                (t["Ⅺ"] = "XI"),
                (t["Ⅻ"] = "XII"),
                (t["Ⅼ"] = "L"),
                (t["Ⅽ"] = "C"),
                (t["Ⅾ"] = "D"),
                (t["Ⅿ"] = "M"),
                (t["ⅰ"] = "i"),
                (t["ⅱ"] = "ii"),
                (t["ⅲ"] = "iii"),
                (t["ⅳ"] = "iv"),
                (t["ⅴ"] = "v"),
                (t["ⅵ"] = "vi"),
                (t["ⅶ"] = "vii"),
                (t["ⅷ"] = "viii"),
                (t["ⅸ"] = "ix"),
                (t["ⅹ"] = "x"),
                (t["ⅺ"] = "xi"),
                (t["ⅻ"] = "xii"),
                (t["ⅼ"] = "l"),
                (t["ⅽ"] = "c"),
                (t["ⅾ"] = "d"),
                (t["ⅿ"] = "m"),
                (t["∬"] = "∫∫"),
                (t["∭"] = "∫∫∫"),
                (t["∯"] = "∮∮"),
                (t["∰"] = "∮∮∮"),
                (t["⑴"] = "(1)"),
                (t["⑵"] = "(2)"),
                (t["⑶"] = "(3)"),
                (t["⑷"] = "(4)"),
                (t["⑸"] = "(5)"),
                (t["⑹"] = "(6)"),
                (t["⑺"] = "(7)"),
                (t["⑻"] = "(8)"),
                (t["⑼"] = "(9)"),
                (t["⑽"] = "(10)"),
                (t["⑾"] = "(11)"),
                (t["⑿"] = "(12)"),
                (t["⒀"] = "(13)"),
                (t["⒁"] = "(14)"),
                (t["⒂"] = "(15)"),
                (t["⒃"] = "(16)"),
                (t["⒄"] = "(17)"),
                (t["⒅"] = "(18)"),
                (t["⒆"] = "(19)"),
                (t["⒇"] = "(20)"),
                (t["⒈"] = "1."),
                (t["⒉"] = "2."),
                (t["⒊"] = "3."),
                (t["⒋"] = "4."),
                (t["⒌"] = "5."),
                (t["⒍"] = "6."),
                (t["⒎"] = "7."),
                (t["⒏"] = "8."),
                (t["⒐"] = "9."),
                (t["⒑"] = "10."),
                (t["⒒"] = "11."),
                (t["⒓"] = "12."),
                (t["⒔"] = "13."),
                (t["⒕"] = "14."),
                (t["⒖"] = "15."),
                (t["⒗"] = "16."),
                (t["⒘"] = "17."),
                (t["⒙"] = "18."),
                (t["⒚"] = "19."),
                (t["⒛"] = "20."),
                (t["⒜"] = "(a)"),
                (t["⒝"] = "(b)"),
                (t["⒞"] = "(c)"),
                (t["⒟"] = "(d)"),
                (t["⒠"] = "(e)"),
                (t["⒡"] = "(f)"),
                (t["⒢"] = "(g)"),
                (t["⒣"] = "(h)"),
                (t["⒤"] = "(i)"),
                (t["⒥"] = "(j)"),
                (t["⒦"] = "(k)"),
                (t["⒧"] = "(l)"),
                (t["⒨"] = "(m)"),
                (t["⒩"] = "(n)"),
                (t["⒪"] = "(o)"),
                (t["⒫"] = "(p)"),
                (t["⒬"] = "(q)"),
                (t["⒭"] = "(r)"),
                (t["⒮"] = "(s)"),
                (t["⒯"] = "(t)"),
                (t["⒰"] = "(u)"),
                (t["⒱"] = "(v)"),
                (t["⒲"] = "(w)"),
                (t["⒳"] = "(x)"),
                (t["⒴"] = "(y)"),
                (t["⒵"] = "(z)"),
                (t["⨌"] = "∫∫∫∫"),
                (t["⩴"] = "::=");
              (t["⩵"] = "=="),
                (t["⩶"] = "==="),
                (t["⺟"] = "母"),
                (t["⻳"] = "龟"),
                (t["⼀"] = "一"),
                (t["⼁"] = "丨"),
                (t["⼂"] = "丶"),
                (t["⼃"] = "丿"),
                (t["⼄"] = "乙"),
                (t["⼅"] = "亅"),
                (t["⼆"] = "二"),
                (t["⼇"] = "亠"),
                (t["⼈"] = "人"),
                (t["⼉"] = "儿"),
                (t["⼊"] = "入"),
                (t["⼋"] = "八"),
                (t["⼌"] = "冂"),
                (t["⼍"] = "冖"),
                (t["⼎"] = "冫"),
                (t["⼏"] = "几"),
                (t["⼐"] = "凵"),
                (t["⼑"] = "刀"),
                (t["⼒"] = "力"),
                (t["⼓"] = "勹"),
                (t["⼔"] = "匕"),
                (t["⼕"] = "匚"),
                (t["⼖"] = "匸"),
                (t["⼗"] = "十"),
                (t["⼘"] = "卜"),
                (t["⼙"] = "卩"),
                (t["⼚"] = "厂"),
                (t["⼛"] = "厶"),
                (t["⼜"] = "又"),
                (t["⼝"] = "口"),
                (t["⼞"] = "囗"),
                (t["⼟"] = "土"),
                (t["⼠"] = "士"),
                (t["⼡"] = "夂"),
                (t["⼢"] = "夊"),
                (t["⼣"] = "夕"),
                (t["⼤"] = "大"),
                (t["⼥"] = "女"),
                (t["⼦"] = "子"),
                (t["⼧"] = "宀"),
                (t["⼨"] = "寸"),
                (t["⼩"] = "小"),
                (t["⼪"] = "尢"),
                (t["⼫"] = "尸"),
                (t["⼬"] = "屮"),
                (t["⼭"] = "山"),
                (t["⼮"] = "巛"),
                (t["⼯"] = "工"),
                (t["⼰"] = "己"),
                (t["⼱"] = "巾"),
                (t["⼲"] = "干"),
                (t["⼳"] = "幺"),
                (t["⼴"] = "广"),
                (t["⼵"] = "廴"),
                (t["⼶"] = "廾"),
                (t["⼷"] = "弋"),
                (t["⼸"] = "弓"),
                (t["⼹"] = "彐"),
                (t["⼺"] = "彡"),
                (t["⼻"] = "彳"),
                (t["⼼"] = "心"),
                (t["⼽"] = "戈"),
                (t["⼾"] = "戶"),
                (t["⼿"] = "手"),
                (t["⽀"] = "支"),
                (t["⽁"] = "攴"),
                (t["⽂"] = "文"),
                (t["⽃"] = "斗"),
                (t["⽄"] = "斤"),
                (t["⽅"] = "方"),
                (t["⽆"] = "无"),
                (t["⽇"] = "日"),
                (t["⽈"] = "曰"),
                (t["⽉"] = "月"),
                (t["⽊"] = "木"),
                (t["⽋"] = "欠"),
                (t["⽌"] = "止"),
                (t["⽍"] = "歹"),
                (t["⽎"] = "殳"),
                (t["⽏"] = "毋"),
                (t["⽐"] = "比"),
                (t["⽑"] = "毛"),
                (t["⽒"] = "氏"),
                (t["⽓"] = "气"),
                (t["⽔"] = "水"),
                (t["⽕"] = "火"),
                (t["⽖"] = "爪"),
                (t["⽗"] = "父"),
                (t["⽘"] = "爻"),
                (t["⽙"] = "爿"),
                (t["⽚"] = "片"),
                (t["⽛"] = "牙"),
                (t["⽜"] = "牛"),
                (t["⽝"] = "犬"),
                (t["⽞"] = "玄"),
                (t["⽟"] = "玉"),
                (t["⽠"] = "瓜"),
                (t["⽡"] = "瓦"),
                (t["⽢"] = "甘"),
                (t["⽣"] = "生"),
                (t["⽤"] = "用"),
                (t["⽥"] = "田"),
                (t["⽦"] = "疋"),
                (t["⽧"] = "疒"),
                (t["⽨"] = "癶"),
                (t["⽩"] = "白"),
                (t["⽪"] = "皮"),
                (t["⽫"] = "皿"),
                (t["⽬"] = "目"),
                (t["⽭"] = "矛"),
                (t["⽮"] = "矢"),
                (t["⽯"] = "石"),
                (t["⽰"] = "示"),
                (t["⽱"] = "禸"),
                (t["⽲"] = "禾"),
                (t["⽳"] = "穴"),
                (t["⽴"] = "立"),
                (t["⽵"] = "竹"),
                (t["⽶"] = "米"),
                (t["⽷"] = "糸"),
                (t["⽸"] = "缶"),
                (t["⽹"] = "网"),
                (t["⽺"] = "羊"),
                (t["⽻"] = "羽"),
                (t["⽼"] = "老"),
                (t["⽽"] = "而"),
                (t["⽾"] = "耒"),
                (t["⽿"] = "耳"),
                (t["⾀"] = "聿"),
                (t["⾁"] = "肉"),
                (t["⾂"] = "臣"),
                (t["⾃"] = "自"),
                (t["⾄"] = "至"),
                (t["⾅"] = "臼"),
                (t["⾆"] = "舌"),
                (t["⾇"] = "舛"),
                (t["⾈"] = "舟"),
                (t["⾉"] = "艮"),
                (t["⾊"] = "色"),
                (t["⾋"] = "艸"),
                (t["⾌"] = "虍"),
                (t["⾍"] = "虫"),
                (t["⾎"] = "血"),
                (t["⾏"] = "行"),
                (t["⾐"] = "衣"),
                (t["⾑"] = "襾"),
                (t["⾒"] = "見"),
                (t["⾓"] = "角"),
                (t["⾔"] = "言"),
                (t["⾕"] = "谷"),
                (t["⾖"] = "豆"),
                (t["⾗"] = "豕"),
                (t["⾘"] = "豸"),
                (t["⾙"] = "貝"),
                (t["⾚"] = "赤"),
                (t["⾛"] = "走"),
                (t["⾜"] = "足"),
                (t["⾝"] = "身"),
                (t["⾞"] = "車"),
                (t["⾟"] = "辛"),
                (t["⾠"] = "辰"),
                (t["⾡"] = "辵"),
                (t["⾢"] = "邑"),
                (t["⾣"] = "酉"),
                (t["⾤"] = "釆"),
                (t["⾥"] = "里"),
                (t["⾦"] = "金"),
                (t["⾧"] = "長"),
                (t["⾨"] = "門"),
                (t["⾩"] = "阜"),
                (t["⾪"] = "隶"),
                (t["⾫"] = "隹"),
                (t["⾬"] = "雨"),
                (t["⾭"] = "靑"),
                (t["⾮"] = "非"),
                (t["⾯"] = "面"),
                (t["⾰"] = "革"),
                (t["⾱"] = "韋"),
                (t["⾲"] = "韭"),
                (t["⾳"] = "音"),
                (t["⾴"] = "頁"),
                (t["⾵"] = "風"),
                (t["⾶"] = "飛"),
                (t["⾷"] = "食"),
                (t["⾸"] = "首"),
                (t["⾹"] = "香"),
                (t["⾺"] = "馬"),
                (t["⾻"] = "骨"),
                (t["⾼"] = "高"),
                (t["⾽"] = "髟"),
                (t["⾾"] = "鬥"),
                (t["⾿"] = "鬯"),
                (t["⿀"] = "鬲"),
                (t["⿁"] = "鬼"),
                (t["⿂"] = "魚"),
                (t["⿃"] = "鳥");
              (t["⿄"] = "鹵"),
                (t["⿅"] = "鹿"),
                (t["⿆"] = "麥"),
                (t["⿇"] = "麻"),
                (t["⿈"] = "黃"),
                (t["⿉"] = "黍"),
                (t["⿊"] = "黑"),
                (t["⿋"] = "黹"),
                (t["⿌"] = "黽"),
                (t["⿍"] = "鼎"),
                (t["⿎"] = "鼓"),
                (t["⿏"] = "鼠"),
                (t["⿐"] = "鼻"),
                (t["⿑"] = "齊"),
                (t["⿒"] = "齒"),
                (t["⿓"] = "龍"),
                (t["⿔"] = "龜"),
                (t["⿕"] = "龠"),
                (t["〶"] = "〒"),
                (t["〸"] = "十"),
                (t["〹"] = "卄"),
                (t["〺"] = "卅"),
                (t["゛"] = " ゙"),
                (t["゜"] = " ゚"),
                (t["ㄱ"] = "ᄀ"),
                (t["ㄲ"] = "ᄁ"),
                (t["ㄳ"] = "ᆪ"),
                (t["ㄴ"] = "ᄂ"),
                (t["ㄵ"] = "ᆬ"),
                (t["ㄶ"] = "ᆭ"),
                (t["ㄷ"] = "ᄃ"),
                (t["ㄸ"] = "ᄄ"),
                (t["ㄹ"] = "ᄅ"),
                (t["ㄺ"] = "ᆰ"),
                (t["ㄻ"] = "ᆱ"),
                (t["ㄼ"] = "ᆲ"),
                (t["ㄽ"] = "ᆳ"),
                (t["ㄾ"] = "ᆴ"),
                (t["ㄿ"] = "ᆵ"),
                (t["ㅀ"] = "ᄚ"),
                (t["ㅁ"] = "ᄆ"),
                (t["ㅂ"] = "ᄇ"),
                (t["ㅃ"] = "ᄈ"),
                (t["ㅄ"] = "ᄡ"),
                (t["ㅅ"] = "ᄉ"),
                (t["ㅆ"] = "ᄊ"),
                (t["ㅇ"] = "ᄋ"),
                (t["ㅈ"] = "ᄌ"),
                (t["ㅉ"] = "ᄍ"),
                (t["ㅊ"] = "ᄎ"),
                (t["ㅋ"] = "ᄏ"),
                (t["ㅌ"] = "ᄐ"),
                (t["ㅍ"] = "ᄑ"),
                (t["ㅎ"] = "ᄒ"),
                (t["ㅏ"] = "ᅡ"),
                (t["ㅐ"] = "ᅢ"),
                (t["ㅑ"] = "ᅣ"),
                (t["ㅒ"] = "ᅤ"),
                (t["ㅓ"] = "ᅥ"),
                (t["ㅔ"] = "ᅦ"),
                (t["ㅕ"] = "ᅧ"),
                (t["ㅖ"] = "ᅨ"),
                (t["ㅗ"] = "ᅩ"),
                (t["ㅘ"] = "ᅪ"),
                (t["ㅙ"] = "ᅫ"),
                (t["ㅚ"] = "ᅬ"),
                (t["ㅛ"] = "ᅭ"),
                (t["ㅜ"] = "ᅮ"),
                (t["ㅝ"] = "ᅯ"),
                (t["ㅞ"] = "ᅰ"),
                (t["ㅟ"] = "ᅱ"),
                (t["ㅠ"] = "ᅲ"),
                (t["ㅡ"] = "ᅳ"),
                (t["ㅢ"] = "ᅴ"),
                (t["ㅣ"] = "ᅵ"),
                (t["ㅤ"] = "ᅠ"),
                (t["ㅥ"] = "ᄔ"),
                (t["ㅦ"] = "ᄕ"),
                (t["ㅧ"] = "ᇇ"),
                (t["ㅨ"] = "ᇈ"),
                (t["ㅩ"] = "ᇌ"),
                (t["ㅪ"] = "ᇎ"),
                (t["ㅫ"] = "ᇓ"),
                (t["ㅬ"] = "ᇗ"),
                (t["ㅭ"] = "ᇙ"),
                (t["ㅮ"] = "ᄜ"),
                (t["ㅯ"] = "ᇝ"),
                (t["ㅰ"] = "ᇟ"),
                (t["ㅱ"] = "ᄝ"),
                (t["ㅲ"] = "ᄞ"),
                (t["ㅳ"] = "ᄠ"),
                (t["ㅴ"] = "ᄢ"),
                (t["ㅵ"] = "ᄣ"),
                (t["ㅶ"] = "ᄧ"),
                (t["ㅷ"] = "ᄩ"),
                (t["ㅸ"] = "ᄫ"),
                (t["ㅹ"] = "ᄬ"),
                (t["ㅺ"] = "ᄭ"),
                (t["ㅻ"] = "ᄮ"),
                (t["ㅼ"] = "ᄯ"),
                (t["ㅽ"] = "ᄲ"),
                (t["ㅾ"] = "ᄶ"),
                (t["ㅿ"] = "ᅀ"),
                (t["ㆀ"] = "ᅇ"),
                (t["ㆁ"] = "ᅌ"),
                (t["ㆂ"] = "ᇱ"),
                (t["ㆃ"] = "ᇲ"),
                (t["ㆄ"] = "ᅗ"),
                (t["ㆅ"] = "ᅘ"),
                (t["ㆆ"] = "ᅙ"),
                (t["ㆇ"] = "ᆄ"),
                (t["ㆈ"] = "ᆅ"),
                (t["ㆉ"] = "ᆈ"),
                (t["ㆊ"] = "ᆑ"),
                (t["ㆋ"] = "ᆒ"),
                (t["ㆌ"] = "ᆔ"),
                (t["ㆍ"] = "ᆞ"),
                (t["ㆎ"] = "ᆡ"),
                (t["㈀"] = "(ᄀ)"),
                (t["㈁"] = "(ᄂ)"),
                (t["㈂"] = "(ᄃ)"),
                (t["㈃"] = "(ᄅ)"),
                (t["㈄"] = "(ᄆ)"),
                (t["㈅"] = "(ᄇ)"),
                (t["㈆"] = "(ᄉ)"),
                (t["㈇"] = "(ᄋ)"),
                (t["㈈"] = "(ᄌ)"),
                (t["㈉"] = "(ᄎ)"),
                (t["㈊"] = "(ᄏ)"),
                (t["㈋"] = "(ᄐ)"),
                (t["㈌"] = "(ᄑ)"),
                (t["㈍"] = "(ᄒ)"),
                (t["㈎"] = "(가)"),
                (t["㈏"] = "(나)"),
                (t["㈐"] = "(다)"),
                (t["㈑"] = "(라)"),
                (t["㈒"] = "(마)"),
                (t["㈓"] = "(바)"),
                (t["㈔"] = "(사)"),
                (t["㈕"] = "(아)"),
                (t["㈖"] = "(자)"),
                (t["㈗"] = "(차)"),
                (t["㈘"] = "(카)"),
                (t["㈙"] = "(타)"),
                (t["㈚"] = "(파)"),
                (t["㈛"] = "(하)"),
                (t["㈜"] = "(주)"),
                (t["㈝"] = "(오전)"),
                (t["㈞"] = "(오후)"),
                (t["㈠"] = "(一)"),
                (t["㈡"] = "(二)"),
                (t["㈢"] = "(三)"),
                (t["㈣"] = "(四)"),
                (t["㈤"] = "(五)"),
                (t["㈥"] = "(六)"),
                (t["㈦"] = "(七)"),
                (t["㈧"] = "(八)"),
                (t["㈨"] = "(九)"),
                (t["㈩"] = "(十)"),
                (t["㈪"] = "(月)"),
                (t["㈫"] = "(火)"),
                (t["㈬"] = "(水)"),
                (t["㈭"] = "(木)"),
                (t["㈮"] = "(金)"),
                (t["㈯"] = "(土)"),
                (t["㈰"] = "(日)"),
                (t["㈱"] = "(株)"),
                (t["㈲"] = "(有)"),
                (t["㈳"] = "(社)"),
                (t["㈴"] = "(名)"),
                (t["㈵"] = "(特)"),
                (t["㈶"] = "(財)"),
                (t["㈷"] = "(祝)"),
                (t["㈸"] = "(労)"),
                (t["㈹"] = "(代)"),
                (t["㈺"] = "(呼)"),
                (t["㈻"] = "(学)"),
                (t["㈼"] = "(監)"),
                (t["㈽"] = "(企)"),
                (t["㈾"] = "(資)"),
                (t["㈿"] = "(協)"),
                (t["㉀"] = "(祭)"),
                (t["㉁"] = "(休)"),
                (t["㉂"] = "(自)"),
                (t["㉃"] = "(至)"),
                (t["㋀"] = "1月"),
                (t["㋁"] = "2月"),
                (t["㋂"] = "3月"),
                (t["㋃"] = "4月"),
                (t["㋄"] = "5月"),
                (t["㋅"] = "6月"),
                (t["㋆"] = "7月"),
                (t["㋇"] = "8月"),
                (t["㋈"] = "9月"),
                (t["㋉"] = "10月"),
                (t["㋊"] = "11月"),
                (t["㋋"] = "12月"),
                (t["㍘"] = "0点"),
                (t["㍙"] = "1点"),
                (t["㍚"] = "2点");
              (t["㍛"] = "3点"),
                (t["㍜"] = "4点"),
                (t["㍝"] = "5点"),
                (t["㍞"] = "6点"),
                (t["㍟"] = "7点"),
                (t["㍠"] = "8点"),
                (t["㍡"] = "9点"),
                (t["㍢"] = "10点"),
                (t["㍣"] = "11点"),
                (t["㍤"] = "12点"),
                (t["㍥"] = "13点"),
                (t["㍦"] = "14点"),
                (t["㍧"] = "15点"),
                (t["㍨"] = "16点"),
                (t["㍩"] = "17点"),
                (t["㍪"] = "18点"),
                (t["㍫"] = "19点"),
                (t["㍬"] = "20点"),
                (t["㍭"] = "21点"),
                (t["㍮"] = "22点"),
                (t["㍯"] = "23点"),
                (t["㍰"] = "24点"),
                (t["㏠"] = "1日"),
                (t["㏡"] = "2日"),
                (t["㏢"] = "3日"),
                (t["㏣"] = "4日"),
                (t["㏤"] = "5日"),
                (t["㏥"] = "6日"),
                (t["㏦"] = "7日"),
                (t["㏧"] = "8日"),
                (t["㏨"] = "9日"),
                (t["㏩"] = "10日"),
                (t["㏪"] = "11日"),
                (t["㏫"] = "12日"),
                (t["㏬"] = "13日"),
                (t["㏭"] = "14日"),
                (t["㏮"] = "15日"),
                (t["㏯"] = "16日"),
                (t["㏰"] = "17日"),
                (t["㏱"] = "18日"),
                (t["㏲"] = "19日"),
                (t["㏳"] = "20日"),
                (t["㏴"] = "21日"),
                (t["㏵"] = "22日"),
                (t["㏶"] = "23日"),
                (t["㏷"] = "24日"),
                (t["㏸"] = "25日"),
                (t["㏹"] = "26日"),
                (t["㏺"] = "27日"),
                (t["㏻"] = "28日"),
                (t["㏼"] = "29日"),
                (t["㏽"] = "30日"),
                (t["㏾"] = "31日"),
                (t["ﬀ"] = "ff"),
                (t["ﬁ"] = "fi"),
                (t["ﬂ"] = "fl"),
                (t["ﬃ"] = "ffi"),
                (t["ﬄ"] = "ffl"),
                (t["ﬅ"] = "ſt"),
                (t["ﬆ"] = "st"),
                (t["ﬓ"] = "մն"),
                (t["ﬔ"] = "մե"),
                (t["ﬕ"] = "մի"),
                (t["ﬖ"] = "վն"),
                (t["ﬗ"] = "մխ"),
                (t["ﭏ"] = "אל"),
                (t["ﭐ"] = "ٱ"),
                (t["ﭑ"] = "ٱ"),
                (t["ﭒ"] = "ٻ"),
                (t["ﭓ"] = "ٻ"),
                (t["ﭔ"] = "ٻ"),
                (t["ﭕ"] = "ٻ"),
                (t["ﭖ"] = "پ"),
                (t["ﭗ"] = "پ"),
                (t["ﭘ"] = "پ"),
                (t["ﭙ"] = "پ"),
                (t["ﭚ"] = "ڀ"),
                (t["ﭛ"] = "ڀ"),
                (t["ﭜ"] = "ڀ"),
                (t["ﭝ"] = "ڀ"),
                (t["ﭞ"] = "ٺ"),
                (t["ﭟ"] = "ٺ"),
                (t["ﭠ"] = "ٺ"),
                (t["ﭡ"] = "ٺ"),
                (t["ﭢ"] = "ٿ"),
                (t["ﭣ"] = "ٿ"),
                (t["ﭤ"] = "ٿ"),
                (t["ﭥ"] = "ٿ"),
                (t["ﭦ"] = "ٹ"),
                (t["ﭧ"] = "ٹ"),
                (t["ﭨ"] = "ٹ"),
                (t["ﭩ"] = "ٹ"),
                (t["ﭪ"] = "ڤ"),
                (t["ﭫ"] = "ڤ"),
                (t["ﭬ"] = "ڤ"),
                (t["ﭭ"] = "ڤ"),
                (t["ﭮ"] = "ڦ"),
                (t["ﭯ"] = "ڦ"),
                (t["ﭰ"] = "ڦ"),
                (t["ﭱ"] = "ڦ"),
                (t["ﭲ"] = "ڄ"),
                (t["ﭳ"] = "ڄ"),
                (t["ﭴ"] = "ڄ"),
                (t["ﭵ"] = "ڄ"),
                (t["ﭶ"] = "ڃ"),
                (t["ﭷ"] = "ڃ"),
                (t["ﭸ"] = "ڃ"),
                (t["ﭹ"] = "ڃ"),
                (t["ﭺ"] = "چ"),
                (t["ﭻ"] = "چ"),
                (t["ﭼ"] = "چ"),
                (t["ﭽ"] = "چ"),
                (t["ﭾ"] = "ڇ"),
                (t["ﭿ"] = "ڇ"),
                (t["ﮀ"] = "ڇ"),
                (t["ﮁ"] = "ڇ"),
                (t["ﮂ"] = "ڍ"),
                (t["ﮃ"] = "ڍ"),
                (t["ﮄ"] = "ڌ"),
                (t["ﮅ"] = "ڌ"),
                (t["ﮆ"] = "ڎ"),
                (t["ﮇ"] = "ڎ"),
                (t["ﮈ"] = "ڈ"),
                (t["ﮉ"] = "ڈ"),
                (t["ﮊ"] = "ژ"),
                (t["ﮋ"] = "ژ"),
                (t["ﮌ"] = "ڑ"),
                (t["ﮍ"] = "ڑ"),
                (t["ﮎ"] = "ک"),
                (t["ﮏ"] = "ک"),
                (t["ﮐ"] = "ک"),
                (t["ﮑ"] = "ک"),
                (t["ﮒ"] = "گ"),
                (t["ﮓ"] = "گ"),
                (t["ﮔ"] = "گ"),
                (t["ﮕ"] = "گ"),
                (t["ﮖ"] = "ڳ"),
                (t["ﮗ"] = "ڳ"),
                (t["ﮘ"] = "ڳ"),
                (t["ﮙ"] = "ڳ"),
                (t["ﮚ"] = "ڱ"),
                (t["ﮛ"] = "ڱ"),
                (t["ﮜ"] = "ڱ"),
                (t["ﮝ"] = "ڱ"),
                (t["ﮞ"] = "ں"),
                (t["ﮟ"] = "ں"),
                (t["ﮠ"] = "ڻ"),
                (t["ﮡ"] = "ڻ"),
                (t["ﮢ"] = "ڻ"),
                (t["ﮣ"] = "ڻ"),
                (t["ﮤ"] = "ۀ"),
                (t["ﮥ"] = "ۀ"),
                (t["ﮦ"] = "ہ"),
                (t["ﮧ"] = "ہ"),
                (t["ﮨ"] = "ہ"),
                (t["ﮩ"] = "ہ"),
                (t["ﮪ"] = "ھ"),
                (t["ﮫ"] = "ھ"),
                (t["ﮬ"] = "ھ"),
                (t["ﮭ"] = "ھ"),
                (t["ﮮ"] = "ے"),
                (t["ﮯ"] = "ے"),
                (t["ﮰ"] = "ۓ"),
                (t["ﮱ"] = "ۓ"),
                (t["ﯓ"] = "ڭ"),
                (t["ﯔ"] = "ڭ"),
                (t["ﯕ"] = "ڭ"),
                (t["ﯖ"] = "ڭ"),
                (t["ﯗ"] = "ۇ"),
                (t["ﯘ"] = "ۇ"),
                (t["ﯙ"] = "ۆ"),
                (t["ﯚ"] = "ۆ"),
                (t["ﯛ"] = "ۈ"),
                (t["ﯜ"] = "ۈ"),
                (t["ﯝ"] = "ٷ"),
                (t["ﯞ"] = "ۋ"),
                (t["ﯟ"] = "ۋ"),
                (t["ﯠ"] = "ۅ"),
                (t["ﯡ"] = "ۅ"),
                (t["ﯢ"] = "ۉ"),
                (t["ﯣ"] = "ۉ"),
                (t["ﯤ"] = "ې"),
                (t["ﯥ"] = "ې"),
                (t["ﯦ"] = "ې"),
                (t["ﯧ"] = "ې"),
                (t["ﯨ"] = "ى"),
                (t["ﯩ"] = "ى"),
                (t["ﯪ"] = "ئا"),
                (t["ﯫ"] = "ئا"),
                (t["ﯬ"] = "ئە"),
                (t["ﯭ"] = "ئە"),
                (t["ﯮ"] = "ئو"),
                (t["ﯯ"] = "ئو"),
                (t["ﯰ"] = "ئۇ"),
                (t["ﯱ"] = "ئۇ"),
                (t["ﯲ"] = "ئۆ"),
                (t["ﯳ"] = "ئۆ"),
                (t["ﯴ"] = "ئۈ"),
                (t["ﯵ"] = "ئۈ"),
                (t["ﯶ"] = "ئې");
              (t["ﯷ"] = "ئې"),
                (t["ﯸ"] = "ئې"),
                (t["ﯹ"] = "ئى"),
                (t["ﯺ"] = "ئى"),
                (t["ﯻ"] = "ئى"),
                (t["ﯼ"] = "ی"),
                (t["ﯽ"] = "ی"),
                (t["ﯾ"] = "ی"),
                (t["ﯿ"] = "ی"),
                (t["ﰀ"] = "ئج"),
                (t["ﰁ"] = "ئح"),
                (t["ﰂ"] = "ئم"),
                (t["ﰃ"] = "ئى"),
                (t["ﰄ"] = "ئي"),
                (t["ﰅ"] = "بج"),
                (t["ﰆ"] = "بح"),
                (t["ﰇ"] = "بخ"),
                (t["ﰈ"] = "بم"),
                (t["ﰉ"] = "بى"),
                (t["ﰊ"] = "بي"),
                (t["ﰋ"] = "تج"),
                (t["ﰌ"] = "تح"),
                (t["ﰍ"] = "تخ"),
                (t["ﰎ"] = "تم"),
                (t["ﰏ"] = "تى"),
                (t["ﰐ"] = "تي"),
                (t["ﰑ"] = "ثج"),
                (t["ﰒ"] = "ثم"),
                (t["ﰓ"] = "ثى"),
                (t["ﰔ"] = "ثي"),
                (t["ﰕ"] = "جح"),
                (t["ﰖ"] = "جم"),
                (t["ﰗ"] = "حج"),
                (t["ﰘ"] = "حم"),
                (t["ﰙ"] = "خج"),
                (t["ﰚ"] = "خح"),
                (t["ﰛ"] = "خم"),
                (t["ﰜ"] = "سج"),
                (t["ﰝ"] = "سح"),
                (t["ﰞ"] = "سخ"),
                (t["ﰟ"] = "سم"),
                (t["ﰠ"] = "صح"),
                (t["ﰡ"] = "صم"),
                (t["ﰢ"] = "ضج"),
                (t["ﰣ"] = "ضح"),
                (t["ﰤ"] = "ضخ"),
                (t["ﰥ"] = "ضم"),
                (t["ﰦ"] = "طح"),
                (t["ﰧ"] = "طم"),
                (t["ﰨ"] = "ظم"),
                (t["ﰩ"] = "عج"),
                (t["ﰪ"] = "عم"),
                (t["ﰫ"] = "غج"),
                (t["ﰬ"] = "غم"),
                (t["ﰭ"] = "فج"),
                (t["ﰮ"] = "فح"),
                (t["ﰯ"] = "فخ"),
                (t["ﰰ"] = "فم"),
                (t["ﰱ"] = "فى"),
                (t["ﰲ"] = "في"),
                (t["ﰳ"] = "قح"),
                (t["ﰴ"] = "قم"),
                (t["ﰵ"] = "قى"),
                (t["ﰶ"] = "قي"),
                (t["ﰷ"] = "كا"),
                (t["ﰸ"] = "كج"),
                (t["ﰹ"] = "كح"),
                (t["ﰺ"] = "كخ"),
                (t["ﰻ"] = "كل"),
                (t["ﰼ"] = "كم"),
                (t["ﰽ"] = "كى"),
                (t["ﰾ"] = "كي"),
                (t["ﰿ"] = "لج"),
                (t["ﱀ"] = "لح"),
                (t["ﱁ"] = "لخ"),
                (t["ﱂ"] = "لم"),
                (t["ﱃ"] = "لى"),
                (t["ﱄ"] = "لي"),
                (t["ﱅ"] = "مج"),
                (t["ﱆ"] = "مح"),
                (t["ﱇ"] = "مخ"),
                (t["ﱈ"] = "مم"),
                (t["ﱉ"] = "مى"),
                (t["ﱊ"] = "مي"),
                (t["ﱋ"] = "نج"),
                (t["ﱌ"] = "نح"),
                (t["ﱍ"] = "نخ"),
                (t["ﱎ"] = "نم"),
                (t["ﱏ"] = "نى"),
                (t["ﱐ"] = "ني"),
                (t["ﱑ"] = "هج"),
                (t["ﱒ"] = "هم"),
                (t["ﱓ"] = "هى"),
                (t["ﱔ"] = "هي"),
                (t["ﱕ"] = "يج"),
                (t["ﱖ"] = "يح"),
                (t["ﱗ"] = "يخ"),
                (t["ﱘ"] = "يم"),
                (t["ﱙ"] = "يى"),
                (t["ﱚ"] = "يي"),
                (t["ﱛ"] = "ذٰ"),
                (t["ﱜ"] = "رٰ"),
                (t["ﱝ"] = "ىٰ"),
                (t["ﱞ"] = " ٌّ"),
                (t["ﱟ"] = " ٍّ"),
                (t["ﱠ"] = " َّ"),
                (t["ﱡ"] = " ُّ"),
                (t["ﱢ"] = " ِّ"),
                (t["ﱣ"] = " ّٰ"),
                (t["ﱤ"] = "ئر"),
                (t["ﱥ"] = "ئز"),
                (t["ﱦ"] = "ئم"),
                (t["ﱧ"] = "ئن"),
                (t["ﱨ"] = "ئى"),
                (t["ﱩ"] = "ئي"),
                (t["ﱪ"] = "بر"),
                (t["ﱫ"] = "بز"),
                (t["ﱬ"] = "بم"),
                (t["ﱭ"] = "بن"),
                (t["ﱮ"] = "بى"),
                (t["ﱯ"] = "بي"),
                (t["ﱰ"] = "تر"),
                (t["ﱱ"] = "تز"),
                (t["ﱲ"] = "تم"),
                (t["ﱳ"] = "تن"),
                (t["ﱴ"] = "تى"),
                (t["ﱵ"] = "تي"),
                (t["ﱶ"] = "ثر"),
                (t["ﱷ"] = "ثز"),
                (t["ﱸ"] = "ثم"),
                (t["ﱹ"] = "ثن"),
                (t["ﱺ"] = "ثى"),
                (t["ﱻ"] = "ثي"),
                (t["ﱼ"] = "فى"),
                (t["ﱽ"] = "في"),
                (t["ﱾ"] = "قى"),
                (t["ﱿ"] = "قي"),
                (t["ﲀ"] = "كا"),
                (t["ﲁ"] = "كل"),
                (t["ﲂ"] = "كم"),
                (t["ﲃ"] = "كى"),
                (t["ﲄ"] = "كي"),
                (t["ﲅ"] = "لم"),
                (t["ﲆ"] = "لى"),
                (t["ﲇ"] = "لي"),
                (t["ﲈ"] = "ما"),
                (t["ﲉ"] = "مم"),
                (t["ﲊ"] = "نر"),
                (t["ﲋ"] = "نز"),
                (t["ﲌ"] = "نم"),
                (t["ﲍ"] = "نن"),
                (t["ﲎ"] = "نى"),
                (t["ﲏ"] = "ني"),
                (t["ﲐ"] = "ىٰ"),
                (t["ﲑ"] = "ير"),
                (t["ﲒ"] = "يز"),
                (t["ﲓ"] = "يم"),
                (t["ﲔ"] = "ين"),
                (t["ﲕ"] = "يى"),
                (t["ﲖ"] = "يي"),
                (t["ﲗ"] = "ئج"),
                (t["ﲘ"] = "ئح"),
                (t["ﲙ"] = "ئخ"),
                (t["ﲚ"] = "ئم"),
                (t["ﲛ"] = "ئه"),
                (t["ﲜ"] = "بج"),
                (t["ﲝ"] = "بح"),
                (t["ﲞ"] = "بخ"),
                (t["ﲟ"] = "بم"),
                (t["ﲠ"] = "به"),
                (t["ﲡ"] = "تج"),
                (t["ﲢ"] = "تح"),
                (t["ﲣ"] = "تخ"),
                (t["ﲤ"] = "تم"),
                (t["ﲥ"] = "ته"),
                (t["ﲦ"] = "ثم"),
                (t["ﲧ"] = "جح"),
                (t["ﲨ"] = "جم"),
                (t["ﲩ"] = "حج"),
                (t["ﲪ"] = "حم"),
                (t["ﲫ"] = "خج"),
                (t["ﲬ"] = "خم"),
                (t["ﲭ"] = "سج"),
                (t["ﲮ"] = "سح"),
                (t["ﲯ"] = "سخ"),
                (t["ﲰ"] = "سم"),
                (t["ﲱ"] = "صح"),
                (t["ﲲ"] = "صخ"),
                (t["ﲳ"] = "صم"),
                (t["ﲴ"] = "ضج"),
                (t["ﲵ"] = "ضح"),
                (t["ﲶ"] = "ضخ"),
                (t["ﲷ"] = "ضم"),
                (t["ﲸ"] = "طح"),
                (t["ﲹ"] = "ظم"),
                (t["ﲺ"] = "عج"),
                (t["ﲻ"] = "عم"),
                (t["ﲼ"] = "غج"),
                (t["ﲽ"] = "غم"),
                (t["ﲾ"] = "فج");
              (t["ﲿ"] = "فح"),
                (t["ﳀ"] = "فخ"),
                (t["ﳁ"] = "فم"),
                (t["ﳂ"] = "قح"),
                (t["ﳃ"] = "قم"),
                (t["ﳄ"] = "كج"),
                (t["ﳅ"] = "كح"),
                (t["ﳆ"] = "كخ"),
                (t["ﳇ"] = "كل"),
                (t["ﳈ"] = "كم"),
                (t["ﳉ"] = "لج"),
                (t["ﳊ"] = "لح"),
                (t["ﳋ"] = "لخ"),
                (t["ﳌ"] = "لم"),
                (t["ﳍ"] = "له"),
                (t["ﳎ"] = "مج"),
                (t["ﳏ"] = "مح"),
                (t["ﳐ"] = "مخ"),
                (t["ﳑ"] = "مم"),
                (t["ﳒ"] = "نج"),
                (t["ﳓ"] = "نح"),
                (t["ﳔ"] = "نخ"),
                (t["ﳕ"] = "نم"),
                (t["ﳖ"] = "نه"),
                (t["ﳗ"] = "هج"),
                (t["ﳘ"] = "هم"),
                (t["ﳙ"] = "هٰ"),
                (t["ﳚ"] = "يج"),
                (t["ﳛ"] = "يح"),
                (t["ﳜ"] = "يخ"),
                (t["ﳝ"] = "يم"),
                (t["ﳞ"] = "يه"),
                (t["ﳟ"] = "ئم"),
                (t["ﳠ"] = "ئه"),
                (t["ﳡ"] = "بم"),
                (t["ﳢ"] = "به"),
                (t["ﳣ"] = "تم"),
                (t["ﳤ"] = "ته"),
                (t["ﳥ"] = "ثم"),
                (t["ﳦ"] = "ثه"),
                (t["ﳧ"] = "سم"),
                (t["ﳨ"] = "سه"),
                (t["ﳩ"] = "شم"),
                (t["ﳪ"] = "شه"),
                (t["ﳫ"] = "كل"),
                (t["ﳬ"] = "كم"),
                (t["ﳭ"] = "لم"),
                (t["ﳮ"] = "نم"),
                (t["ﳯ"] = "نه"),
                (t["ﳰ"] = "يم"),
                (t["ﳱ"] = "يه"),
                (t["ﳲ"] = "ـَّ"),
                (t["ﳳ"] = "ـُّ"),
                (t["ﳴ"] = "ـِّ"),
                (t["ﳵ"] = "طى"),
                (t["ﳶ"] = "طي"),
                (t["ﳷ"] = "عى"),
                (t["ﳸ"] = "عي"),
                (t["ﳹ"] = "غى"),
                (t["ﳺ"] = "غي"),
                (t["ﳻ"] = "سى"),
                (t["ﳼ"] = "سي"),
                (t["ﳽ"] = "شى"),
                (t["ﳾ"] = "شي"),
                (t["ﳿ"] = "حى"),
                (t["ﴀ"] = "حي"),
                (t["ﴁ"] = "جى"),
                (t["ﴂ"] = "جي"),
                (t["ﴃ"] = "خى"),
                (t["ﴄ"] = "خي"),
                (t["ﴅ"] = "صى"),
                (t["ﴆ"] = "صي"),
                (t["ﴇ"] = "ضى"),
                (t["ﴈ"] = "ضي"),
                (t["ﴉ"] = "شج"),
                (t["ﴊ"] = "شح"),
                (t["ﴋ"] = "شخ"),
                (t["ﴌ"] = "شم"),
                (t["ﴍ"] = "شر"),
                (t["ﴎ"] = "سر"),
                (t["ﴏ"] = "صر"),
                (t["ﴐ"] = "ضر"),
                (t["ﴑ"] = "طى"),
                (t["ﴒ"] = "طي"),
                (t["ﴓ"] = "عى"),
                (t["ﴔ"] = "عي"),
                (t["ﴕ"] = "غى"),
                (t["ﴖ"] = "غي"),
                (t["ﴗ"] = "سى"),
                (t["ﴘ"] = "سي"),
                (t["ﴙ"] = "شى"),
                (t["ﴚ"] = "شي"),
                (t["ﴛ"] = "حى"),
                (t["ﴜ"] = "حي"),
                (t["ﴝ"] = "جى"),
                (t["ﴞ"] = "جي"),
                (t["ﴟ"] = "خى"),
                (t["ﴠ"] = "خي"),
                (t["ﴡ"] = "صى"),
                (t["ﴢ"] = "صي"),
                (t["ﴣ"] = "ضى"),
                (t["ﴤ"] = "ضي"),
                (t["ﴥ"] = "شج"),
                (t["ﴦ"] = "شح"),
                (t["ﴧ"] = "شخ"),
                (t["ﴨ"] = "شم"),
                (t["ﴩ"] = "شر"),
                (t["ﴪ"] = "سر"),
                (t["ﴫ"] = "صر"),
                (t["ﴬ"] = "ضر"),
                (t["ﴭ"] = "شج"),
                (t["ﴮ"] = "شح"),
                (t["ﴯ"] = "شخ"),
                (t["ﴰ"] = "شم"),
                (t["ﴱ"] = "سه"),
                (t["ﴲ"] = "شه"),
                (t["ﴳ"] = "طم"),
                (t["ﴴ"] = "سج"),
                (t["ﴵ"] = "سح"),
                (t["ﴶ"] = "سخ"),
                (t["ﴷ"] = "شج"),
                (t["ﴸ"] = "شح"),
                (t["ﴹ"] = "شخ"),
                (t["ﴺ"] = "طم"),
                (t["ﴻ"] = "ظم"),
                (t["ﴼ"] = "اً"),
                (t["ﴽ"] = "اً"),
                (t["ﵐ"] = "تجم"),
                (t["ﵑ"] = "تحج"),
                (t["ﵒ"] = "تحج"),
                (t["ﵓ"] = "تحم"),
                (t["ﵔ"] = "تخم"),
                (t["ﵕ"] = "تمج"),
                (t["ﵖ"] = "تمح"),
                (t["ﵗ"] = "تمخ"),
                (t["ﵘ"] = "جمح"),
                (t["ﵙ"] = "جمح"),
                (t["ﵚ"] = "حمي"),
                (t["ﵛ"] = "حمى"),
                (t["ﵜ"] = "سحج"),
                (t["ﵝ"] = "سجح"),
                (t["ﵞ"] = "سجى"),
                (t["ﵟ"] = "سمح"),
                (t["ﵠ"] = "سمح"),
                (t["ﵡ"] = "سمج"),
                (t["ﵢ"] = "سمم"),
                (t["ﵣ"] = "سمم"),
                (t["ﵤ"] = "صحح"),
                (t["ﵥ"] = "صحح"),
                (t["ﵦ"] = "صمم"),
                (t["ﵧ"] = "شحم"),
                (t["ﵨ"] = "شحم"),
                (t["ﵩ"] = "شجي"),
                (t["ﵪ"] = "شمخ"),
                (t["ﵫ"] = "شمخ"),
                (t["ﵬ"] = "شمم"),
                (t["ﵭ"] = "شمم"),
                (t["ﵮ"] = "ضحى"),
                (t["ﵯ"] = "ضخم"),
                (t["ﵰ"] = "ضخم"),
                (t["ﵱ"] = "طمح"),
                (t["ﵲ"] = "طمح"),
                (t["ﵳ"] = "طمم"),
                (t["ﵴ"] = "طمي"),
                (t["ﵵ"] = "عجم"),
                (t["ﵶ"] = "عمم"),
                (t["ﵷ"] = "عمم"),
                (t["ﵸ"] = "عمى"),
                (t["ﵹ"] = "غمم"),
                (t["ﵺ"] = "غمي"),
                (t["ﵻ"] = "غمى"),
                (t["ﵼ"] = "فخم"),
                (t["ﵽ"] = "فخم"),
                (t["ﵾ"] = "قمح"),
                (t["ﵿ"] = "قمم"),
                (t["ﶀ"] = "لحم"),
                (t["ﶁ"] = "لحي"),
                (t["ﶂ"] = "لحى"),
                (t["ﶃ"] = "لجج"),
                (t["ﶄ"] = "لجج"),
                (t["ﶅ"] = "لخم"),
                (t["ﶆ"] = "لخم"),
                (t["ﶇ"] = "لمح"),
                (t["ﶈ"] = "لمح"),
                (t["ﶉ"] = "محج"),
                (t["ﶊ"] = "محم"),
                (t["ﶋ"] = "محي"),
                (t["ﶌ"] = "مجح"),
                (t["ﶍ"] = "مجم"),
                (t["ﶎ"] = "مخج"),
                (t["ﶏ"] = "مخم"),
                (t["ﶒ"] = "مجخ"),
                (t["ﶓ"] = "همج"),
                (t["ﶔ"] = "همم"),
                (t["ﶕ"] = "نحم"),
                (t["ﶖ"] = "نحى"),
                (t["ﶗ"] = "نجم"),
                (t["ﶘ"] = "نجم"),
                (t["ﶙ"] = "نجى"),
                (t["ﶚ"] = "نمي");
              (t["ﶛ"] = "نمى"),
                (t["ﶜ"] = "يمم"),
                (t["ﶝ"] = "يمم"),
                (t["ﶞ"] = "بخي"),
                (t["ﶟ"] = "تجي"),
                (t["ﶠ"] = "تجى"),
                (t["ﶡ"] = "تخي"),
                (t["ﶢ"] = "تخى"),
                (t["ﶣ"] = "تمي"),
                (t["ﶤ"] = "تمى"),
                (t["ﶥ"] = "جمي"),
                (t["ﶦ"] = "جحى"),
                (t["ﶧ"] = "جمى"),
                (t["ﶨ"] = "سخى"),
                (t["ﶩ"] = "صحي"),
                (t["ﶪ"] = "شحي"),
                (t["ﶫ"] = "ضحي"),
                (t["ﶬ"] = "لجي"),
                (t["ﶭ"] = "لمي"),
                (t["ﶮ"] = "يحي"),
                (t["ﶯ"] = "يجي"),
                (t["ﶰ"] = "يمي"),
                (t["ﶱ"] = "ممي"),
                (t["ﶲ"] = "قمي"),
                (t["ﶳ"] = "نحي"),
                (t["ﶴ"] = "قمح"),
                (t["ﶵ"] = "لحم"),
                (t["ﶶ"] = "عمي"),
                (t["ﶷ"] = "كمي"),
                (t["ﶸ"] = "نجح"),
                (t["ﶹ"] = "مخي"),
                (t["ﶺ"] = "لجم"),
                (t["ﶻ"] = "كمم"),
                (t["ﶼ"] = "لجم"),
                (t["ﶽ"] = "نجح"),
                (t["ﶾ"] = "جحي"),
                (t["ﶿ"] = "حجي"),
                (t["ﷀ"] = "مجي"),
                (t["ﷁ"] = "فمي"),
                (t["ﷂ"] = "بحي"),
                (t["ﷃ"] = "كمم"),
                (t["ﷄ"] = "عجم"),
                (t["ﷅ"] = "صمم"),
                (t["ﷆ"] = "سخي"),
                (t["ﷇ"] = "نجي"),
                (t["﹉"] = "‾"),
                (t["﹊"] = "‾"),
                (t["﹋"] = "‾"),
                (t["﹌"] = "‾"),
                (t["﹍"] = "_"),
                (t["﹎"] = "_"),
                (t["﹏"] = "_"),
                (t["ﺀ"] = "ء"),
                (t["ﺁ"] = "آ"),
                (t["ﺂ"] = "آ"),
                (t["ﺃ"] = "أ"),
                (t["ﺄ"] = "أ"),
                (t["ﺅ"] = "ؤ"),
                (t["ﺆ"] = "ؤ"),
                (t["ﺇ"] = "إ"),
                (t["ﺈ"] = "إ"),
                (t["ﺉ"] = "ئ"),
                (t["ﺊ"] = "ئ"),
                (t["ﺋ"] = "ئ"),
                (t["ﺌ"] = "ئ"),
                (t["ﺍ"] = "ا"),
                (t["ﺎ"] = "ا"),
                (t["ﺏ"] = "ب"),
                (t["ﺐ"] = "ب"),
                (t["ﺑ"] = "ب"),
                (t["ﺒ"] = "ب"),
                (t["ﺓ"] = "ة"),
                (t["ﺔ"] = "ة"),
                (t["ﺕ"] = "ت"),
                (t["ﺖ"] = "ت"),
                (t["ﺗ"] = "ت"),
                (t["ﺘ"] = "ت"),
                (t["ﺙ"] = "ث"),
                (t["ﺚ"] = "ث"),
                (t["ﺛ"] = "ث"),
                (t["ﺜ"] = "ث"),
                (t["ﺝ"] = "ج"),
                (t["ﺞ"] = "ج"),
                (t["ﺟ"] = "ج"),
                (t["ﺠ"] = "ج"),
                (t["ﺡ"] = "ح"),
                (t["ﺢ"] = "ح"),
                (t["ﺣ"] = "ح"),
                (t["ﺤ"] = "ح"),
                (t["ﺥ"] = "خ"),
                (t["ﺦ"] = "خ"),
                (t["ﺧ"] = "خ"),
                (t["ﺨ"] = "خ"),
                (t["ﺩ"] = "د"),
                (t["ﺪ"] = "د"),
                (t["ﺫ"] = "ذ"),
                (t["ﺬ"] = "ذ"),
                (t["ﺭ"] = "ر"),
                (t["ﺮ"] = "ر"),
                (t["ﺯ"] = "ز"),
                (t["ﺰ"] = "ز"),
                (t["ﺱ"] = "س"),
                (t["ﺲ"] = "س"),
                (t["ﺳ"] = "س"),
                (t["ﺴ"] = "س"),
                (t["ﺵ"] = "ش"),
                (t["ﺶ"] = "ش"),
                (t["ﺷ"] = "ش"),
                (t["ﺸ"] = "ش"),
                (t["ﺹ"] = "ص"),
                (t["ﺺ"] = "ص"),
                (t["ﺻ"] = "ص"),
                (t["ﺼ"] = "ص"),
                (t["ﺽ"] = "ض"),
                (t["ﺾ"] = "ض"),
                (t["ﺿ"] = "ض"),
                (t["ﻀ"] = "ض"),
                (t["ﻁ"] = "ط"),
                (t["ﻂ"] = "ط"),
                (t["ﻃ"] = "ط"),
                (t["ﻄ"] = "ط"),
                (t["ﻅ"] = "ظ"),
                (t["ﻆ"] = "ظ"),
                (t["ﻇ"] = "ظ"),
                (t["ﻈ"] = "ظ"),
                (t["ﻉ"] = "ع"),
                (t["ﻊ"] = "ع"),
                (t["ﻋ"] = "ع"),
                (t["ﻌ"] = "ع"),
                (t["ﻍ"] = "غ"),
                (t["ﻎ"] = "غ"),
                (t["ﻏ"] = "غ"),
                (t["ﻐ"] = "غ"),
                (t["ﻑ"] = "ف"),
                (t["ﻒ"] = "ف"),
                (t["ﻓ"] = "ف"),
                (t["ﻔ"] = "ف"),
                (t["ﻕ"] = "ق"),
                (t["ﻖ"] = "ق"),
                (t["ﻗ"] = "ق"),
                (t["ﻘ"] = "ق"),
                (t["ﻙ"] = "ك"),
                (t["ﻚ"] = "ك"),
                (t["ﻛ"] = "ك"),
                (t["ﻜ"] = "ك"),
                (t["ﻝ"] = "ل"),
                (t["ﻞ"] = "ل"),
                (t["ﻟ"] = "ل"),
                (t["ﻠ"] = "ل"),
                (t["ﻡ"] = "م"),
                (t["ﻢ"] = "م"),
                (t["ﻣ"] = "م"),
                (t["ﻤ"] = "م"),
                (t["ﻥ"] = "ن"),
                (t["ﻦ"] = "ن"),
                (t["ﻧ"] = "ن"),
                (t["ﻨ"] = "ن"),
                (t["ﻩ"] = "ه"),
                (t["ﻪ"] = "ه"),
                (t["ﻫ"] = "ه"),
                (t["ﻬ"] = "ه"),
                (t["ﻭ"] = "و"),
                (t["ﻮ"] = "و"),
                (t["ﻯ"] = "ى"),
                (t["ﻰ"] = "ى"),
                (t["ﻱ"] = "ي"),
                (t["ﻲ"] = "ي"),
                (t["ﻳ"] = "ي"),
                (t["ﻴ"] = "ي"),
                (t["ﻵ"] = "لآ"),
                (t["ﻶ"] = "لآ"),
                (t["ﻷ"] = "لأ"),
                (t["ﻸ"] = "لأ"),
                (t["ﻹ"] = "لإ"),
                (t["ﻺ"] = "لإ"),
                (t["ﻻ"] = "لا"),
                (t["ﻼ"] = "لا");
            });
          (exports.mapSpecialUnicodeValues = mapSpecialUnicodeValues),
            (exports.reverseIfRtl = reverseIfRtl),
            (exports.getUnicodeRangeFor = getUnicodeRangeFor),
            (exports.getNormalizedUnicodes = getNormalizedUnicodes),
            (exports.getUnicodeForGlyph = getUnicodeForGlyph);
        })((root.pdfjsCoreUnicode = {}), root.pdfjsSharedUtil);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, corePrimitives, coreJbig2, coreJpg, coreJpx) {
          var Util = sharedUtil.Util,
            error = sharedUtil.error,
            info = sharedUtil.info,
            isInt = sharedUtil.isInt,
            isArray = sharedUtil.isArray,
            createObjectURL = sharedUtil.createObjectURL,
            shadow = sharedUtil.shadow,
            warn = sharedUtil.warn,
            isSpace = sharedUtil.isSpace,
            Dict = corePrimitives.Dict,
            isDict = corePrimitives.isDict,
            Jbig2Image = coreJbig2.Jbig2Image,
            JpegImage = coreJpg.JpegImage,
            JpxImage = coreJpx.JpxImage,
            Stream = (function () {
              function Stream(arrayBuffer, start, length, dict) {
                (this.bytes = arrayBuffer instanceof Uint8Array ? arrayBuffer : new Uint8Array(arrayBuffer)),
                  (this.start = start || 0),
                  (this.pos = this.start),
                  (this.end = start + length || this.bytes.length),
                  (this.dict = dict);
              }
              return (
                (Stream.prototype = {
                  get length() {
                    return this.end - this.start;
                  },
                  get isEmpty() {
                    return 0 === this.length;
                  },
                  getByte: function () {
                    return this.pos >= this.end ? -1 : this.bytes[this.pos++];
                  },
                  getUint16: function () {
                    var b0 = this.getByte(),
                      b1 = this.getByte();
                    return -1 === b0 || -1 === b1 ? -1 : (b0 << 8) + b1;
                  },
                  getInt32: function () {
                    return (this.getByte() << 24) + (this.getByte() << 16) + (this.getByte() << 8) + this.getByte();
                  },
                  getBytes: function (length) {
                    var bytes = this.bytes,
                      pos = this.pos,
                      strEnd = this.end;
                    if (!length) return bytes.subarray(pos, strEnd);
                    var end = pos + length;
                    return end > strEnd && (end = strEnd), (this.pos = end), bytes.subarray(pos, end);
                  },
                  peekByte: function () {
                    var peekedByte = this.getByte();
                    return this.pos--, peekedByte;
                  },
                  peekBytes: function (length) {
                    var bytes = this.getBytes(length);
                    return (this.pos -= bytes.length), bytes;
                  },
                  skip: function (n) {
                    n || (n = 1), (this.pos += n);
                  },
                  reset: function () {
                    this.pos = this.start;
                  },
                  moveStart: function () {
                    this.start = this.pos;
                  },
                  makeSubStream: function (start, length, dict) {
                    return new Stream(this.bytes.buffer, start, length, dict);
                  },
                  isStream: !0,
                }),
                Stream
              );
            })(),
            StringStream = (function () {
              function StringStream(str) {
                for (var length = str.length, bytes = new Uint8Array(length), n = 0; n < length; ++n)
                  bytes[n] = str.charCodeAt(n);
                Stream.call(this, bytes);
              }
              return (StringStream.prototype = Stream.prototype), StringStream;
            })(),
            DecodeStream = (function () {
              function DecodeStream(maybeMinBufferLength) {
                if (
                  ((this.pos = 0),
                  (this.bufferLength = 0),
                  (this.eof = !1),
                  (this.buffer = emptyBuffer),
                  (this.minBufferLength = 512),
                  maybeMinBufferLength)
                )
                  for (; this.minBufferLength < maybeMinBufferLength; ) this.minBufferLength *= 2;
              }
              var emptyBuffer = new Uint8Array(0);
              return (
                (DecodeStream.prototype = {
                  get isEmpty() {
                    for (; !this.eof && 0 === this.bufferLength; ) this.readBlock();
                    return 0 === this.bufferLength;
                  },
                  ensureBuffer: function (requested) {
                    var buffer = this.buffer;
                    if (requested <= buffer.byteLength) return buffer;
                    for (var size = this.minBufferLength; size < requested; ) size *= 2;
                    var buffer2 = new Uint8Array(size);
                    return buffer2.set(buffer), (this.buffer = buffer2);
                  },
                  getByte: function () {
                    for (var pos = this.pos; this.bufferLength <= pos; ) {
                      if (this.eof) return -1;
                      this.readBlock();
                    }
                    return this.buffer[this.pos++];
                  },
                  getUint16: function () {
                    var b0 = this.getByte(),
                      b1 = this.getByte();
                    return -1 === b0 || -1 === b1 ? -1 : (b0 << 8) + b1;
                  },
                  getInt32: function () {
                    return (this.getByte() << 24) + (this.getByte() << 16) + (this.getByte() << 8) + this.getByte();
                  },
                  getBytes: function (length) {
                    var end,
                      pos = this.pos;
                    if (length) {
                      for (this.ensureBuffer(pos + length), end = pos + length; !this.eof && this.bufferLength < end; )
                        this.readBlock();
                      var bufEnd = this.bufferLength;
                      end > bufEnd && (end = bufEnd);
                    } else {
                      for (; !this.eof; ) this.readBlock();
                      end = this.bufferLength;
                    }
                    return (this.pos = end), this.buffer.subarray(pos, end);
                  },
                  peekByte: function () {
                    var peekedByte = this.getByte();
                    return this.pos--, peekedByte;
                  },
                  peekBytes: function (length) {
                    var bytes = this.getBytes(length);
                    return (this.pos -= bytes.length), bytes;
                  },
                  makeSubStream: function (start, length, dict) {
                    for (var end = start + length; this.bufferLength <= end && !this.eof; ) this.readBlock();
                    return new Stream(this.buffer, start, length, dict);
                  },
                  skip: function (n) {
                    n || (n = 1), (this.pos += n);
                  },
                  reset: function () {
                    this.pos = 0;
                  },
                  getBaseStreams: function () {
                    return this.str && this.str.getBaseStreams ? this.str.getBaseStreams() : [];
                  },
                }),
                DecodeStream
              );
            })(),
            StreamsSequenceStream = (function () {
              function StreamsSequenceStream(streams) {
                (this.streams = streams), DecodeStream.call(this, null);
              }
              return (
                (StreamsSequenceStream.prototype = Object.create(DecodeStream.prototype)),
                (StreamsSequenceStream.prototype.readBlock = function () {
                  var streams = this.streams;
                  if (0 === streams.length) return void (this.eof = !0);
                  var stream = streams.shift(),
                    chunk = stream.getBytes(),
                    bufferLength = this.bufferLength,
                    newLength = bufferLength + chunk.length;
                  this.ensureBuffer(newLength).set(chunk, bufferLength), (this.bufferLength = newLength);
                }),
                (StreamsSequenceStream.prototype.getBaseStreams = function () {
                  for (var baseStreams = [], i = 0, ii = this.streams.length; i < ii; i++) {
                    var stream = this.streams[i];
                    stream.getBaseStreams && Util.appendToArray(baseStreams, stream.getBaseStreams());
                  }
                  return baseStreams;
                }),
                StreamsSequenceStream
              );
            })(),
            FlateStream = (function () {
              function FlateStream(str, maybeLength) {
                (this.str = str), (this.dict = str.dict);
                var cmf = str.getByte(),
                  flg = str.getByte();
                (-1 !== cmf && -1 !== flg) || error("Invalid header in flate stream: " + cmf + ", " + flg),
                  8 != (15 & cmf) && error("Unknown compression method in flate stream: " + cmf + ", " + flg),
                  ((cmf << 8) + flg) % 31 != 0 && error("Bad FCHECK in flate stream: " + cmf + ", " + flg),
                  32 & flg && error("FDICT bit set in flate stream: " + cmf + ", " + flg),
                  (this.codeSize = 0),
                  (this.codeBuf = 0),
                  DecodeStream.call(this, maybeLength);
              }
              var codeLenCodeMap = new Int32Array([16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15]),
                lengthDecode = new Int32Array([
                  3,
                  4,
                  5,
                  6,
                  7,
                  8,
                  9,
                  10,
                  65547,
                  65549,
                  65551,
                  65553,
                  131091,
                  131095,
                  131099,
                  131103,
                  196643,
                  196651,
                  196659,
                  196667,
                  262211,
                  262227,
                  262243,
                  262259,
                  327811,
                  327843,
                  327875,
                  327907,
                  258,
                  258,
                  258,
                ]),
                distDecode = new Int32Array([
                  1,
                  2,
                  3,
                  4,
                  65541,
                  65543,
                  131081,
                  131085,
                  196625,
                  196633,
                  262177,
                  262193,
                  327745,
                  327777,
                  393345,
                  393409,
                  459009,
                  459137,
                  524801,
                  525057,
                  590849,
                  591361,
                  657409,
                  658433,
                  724993,
                  727041,
                  794625,
                  798721,
                  868353,
                  876545,
                ]),
                fixedLitCodeTab = [
                  new Int32Array([
                    459008,
                    524368,
                    524304,
                    524568,
                    459024,
                    524400,
                    524336,
                    590016,
                    459016,
                    524384,
                    524320,
                    589984,
                    524288,
                    524416,
                    524352,
                    590048,
                    459012,
                    524376,
                    524312,
                    589968,
                    459028,
                    524408,
                    524344,
                    590032,
                    459020,
                    524392,
                    524328,
                    59e4,
                    524296,
                    524424,
                    524360,
                    590064,
                    459010,
                    524372,
                    524308,
                    524572,
                    459026,
                    524404,
                    524340,
                    590024,
                    459018,
                    524388,
                    524324,
                    589992,
                    524292,
                    524420,
                    524356,
                    590056,
                    459014,
                    524380,
                    524316,
                    589976,
                    459030,
                    524412,
                    524348,
                    590040,
                    459022,
                    524396,
                    524332,
                    590008,
                    524300,
                    524428,
                    524364,
                    590072,
                    459009,
                    524370,
                    524306,
                    524570,
                    459025,
                    524402,
                    524338,
                    590020,
                    459017,
                    524386,
                    524322,
                    589988,
                    524290,
                    524418,
                    524354,
                    590052,
                    459013,
                    524378,
                    524314,
                    589972,
                    459029,
                    524410,
                    524346,
                    590036,
                    459021,
                    524394,
                    524330,
                    590004,
                    524298,
                    524426,
                    524362,
                    590068,
                    459011,
                    524374,
                    524310,
                    524574,
                    459027,
                    524406,
                    524342,
                    590028,
                    459019,
                    524390,
                    524326,
                    589996,
                    524294,
                    524422,
                    524358,
                    590060,
                    459015,
                    524382,
                    524318,
                    589980,
                    459031,
                    524414,
                    524350,
                    590044,
                    459023,
                    524398,
                    524334,
                    590012,
                    524302,
                    524430,
                    524366,
                    590076,
                    459008,
                    524369,
                    524305,
                    524569,
                    459024,
                    524401,
                    524337,
                    590018,
                    459016,
                    524385,
                    524321,
                    589986,
                    524289,
                    524417,
                    524353,
                    590050,
                    459012,
                    524377,
                    524313,
                    589970,
                    459028,
                    524409,
                    524345,
                    590034,
                    459020,
                    524393,
                    524329,
                    590002,
                    524297,
                    524425,
                    524361,
                    590066,
                    459010,
                    524373,
                    524309,
                    524573,
                    459026,
                    524405,
                    524341,
                    590026,
                    459018,
                    524389,
                    524325,
                    589994,
                    524293,
                    524421,
                    524357,
                    590058,
                    459014,
                    524381,
                    524317,
                    589978,
                    459030,
                    524413,
                    524349,
                    590042,
                    459022,
                    524397,
                    524333,
                    590010,
                    524301,
                    524429,
                    524365,
                    590074,
                    459009,
                    524371,
                    524307,
                    524571,
                    459025,
                    524403,
                    524339,
                    590022,
                    459017,
                    524387,
                    524323,
                    589990,
                    524291,
                    524419,
                    524355,
                    590054,
                    459013,
                    524379,
                    524315,
                    589974,
                    459029,
                    524411,
                    524347,
                    590038,
                    459021,
                    524395,
                    524331,
                    590006,
                    524299,
                    524427,
                    524363,
                    590070,
                    459011,
                    524375,
                    524311,
                    524575,
                    459027,
                    524407,
                    524343,
                    590030,
                    459019,
                    524391,
                    524327,
                    589998,
                    524295,
                    524423,
                    524359,
                    590062,
                    459015,
                    524383,
                    524319,
                    589982,
                    459031,
                    524415,
                    524351,
                    590046,
                    459023,
                    524399,
                    524335,
                    590014,
                    524303,
                    524431,
                    524367,
                    590078,
                    459008,
                    524368,
                    524304,
                    524568,
                    459024,
                    524400,
                    524336,
                    590017,
                    459016,
                    524384,
                    524320,
                    589985,
                    524288,
                    524416,
                    524352,
                    590049,
                    459012,
                    524376,
                    524312,
                    589969,
                    459028,
                    524408,
                    524344,
                    590033,
                    459020,
                    524392,
                    524328,
                    590001,
                    524296,
                    524424,
                    524360,
                    590065,
                    459010,
                    524372,
                    524308,
                    524572,
                    459026,
                    524404,
                    524340,
                    590025,
                    459018,
                    524388,
                    524324,
                    589993,
                    524292,
                    524420,
                    524356,
                    590057,
                    459014,
                    524380,
                    524316,
                    589977,
                    459030,
                    524412,
                    524348,
                    590041,
                    459022,
                    524396,
                    524332,
                    590009,
                    524300,
                    524428,
                    524364,
                    590073,
                    459009,
                    524370,
                    524306,
                    524570,
                    459025,
                    524402,
                    524338,
                    590021,
                    459017,
                    524386,
                    524322,
                    589989,
                    524290,
                    524418,
                    524354,
                    590053,
                    459013,
                    524378,
                    524314,
                    589973,
                    459029,
                    524410,
                    524346,
                    590037,
                    459021,
                    524394,
                    524330,
                    590005,
                    524298,
                    524426,
                    524362,
                    590069,
                    459011,
                    524374,
                    524310,
                    524574,
                    459027,
                    524406,
                    524342,
                    590029,
                    459019,
                    524390,
                    524326,
                    589997,
                    524294,
                    524422,
                    524358,
                    590061,
                    459015,
                    524382,
                    524318,
                    589981,
                    459031,
                    524414,
                    524350,
                    590045,
                    459023,
                    524398,
                    524334,
                    590013,
                    524302,
                    524430,
                    524366,
                    590077,
                    459008,
                    524369,
                    524305,
                    524569,
                    459024,
                    524401,
                    524337,
                    590019,
                    459016,
                    524385,
                    524321,
                    589987,
                    524289,
                    524417,
                    524353,
                    590051,
                    459012,
                    524377,
                    524313,
                    589971,
                    459028,
                    524409,
                    524345,
                    590035,
                    459020,
                    524393,
                    524329,
                    590003,
                    524297,
                    524425,
                    524361,
                    590067,
                    459010,
                    524373,
                    524309,
                    524573,
                    459026,
                    524405,
                    524341,
                    590027,
                    459018,
                    524389,
                    524325,
                    589995,
                    524293,
                    524421,
                    524357,
                    590059,
                    459014,
                    524381,
                    524317,
                    589979,
                    459030,
                    524413,
                    524349,
                    590043,
                    459022,
                    524397,
                    524333,
                    590011,
                    524301,
                    524429,
                    524365,
                    590075,
                    459009,
                    524371,
                    524307,
                    524571,
                    459025,
                    524403,
                    524339,
                    590023,
                    459017,
                    524387,
                    524323,
                    589991,
                    524291,
                    524419,
                    524355,
                    590055,
                    459013,
                    524379,
                    524315,
                    589975,
                    459029,
                    524411,
                    524347,
                    590039,
                    459021,
                    524395,
                    524331,
                    590007,
                    524299,
                    524427,
                    524363,
                    590071,
                    459011,
                    524375,
                    524311,
                    524575,
                    459027,
                    524407,
                    524343,
                    590031,
                    459019,
                    524391,
                    524327,
                    589999,
                    524295,
                    524423,
                    524359,
                    590063,
                    459015,
                    524383,
                    524319,
                    589983,
                    459031,
                    524415,
                    524351,
                    590047,
                    459023,
                    524399,
                    524335,
                    590015,
                    524303,
                    524431,
                    524367,
                    590079,
                  ]),
                  9,
                ],
                fixedDistCodeTab = [
                  new Int32Array([
                    327680,
                    327696,
                    327688,
                    327704,
                    327684,
                    327700,
                    327692,
                    327708,
                    327682,
                    327698,
                    327690,
                    327706,
                    327686,
                    327702,
                    327694,
                    0,
                    327681,
                    327697,
                    327689,
                    327705,
                    327685,
                    327701,
                    327693,
                    327709,
                    327683,
                    327699,
                    327691,
                    327707,
                    327687,
                    327703,
                    327695,
                    0,
                  ]),
                  5,
                ];
              return (
                (FlateStream.prototype = Object.create(DecodeStream.prototype)),
                (FlateStream.prototype.getBits = function (bits) {
                  for (var b, str = this.str, codeSize = this.codeSize, codeBuf = this.codeBuf; codeSize < bits; )
                    -1 === (b = str.getByte()) && error("Bad encoding in flate stream"),
                      (codeBuf |= b << codeSize),
                      (codeSize += 8);
                  return (
                    (b = codeBuf & ((1 << bits) - 1)),
                    (this.codeBuf = codeBuf >> bits),
                    (this.codeSize = codeSize -= bits),
                    b
                  );
                }),
                (FlateStream.prototype.getCode = function (table) {
                  for (
                    var b,
                      str = this.str,
                      codes = table[0],
                      maxLen = table[1],
                      codeSize = this.codeSize,
                      codeBuf = this.codeBuf;
                    codeSize < maxLen && -1 !== (b = str.getByte());

                  )
                    (codeBuf |= b << codeSize), (codeSize += 8);
                  var code = codes[codeBuf & ((1 << maxLen) - 1)],
                    codeLen = code >> 16,
                    codeVal = 65535 & code;
                  return (
                    (codeLen < 1 || codeSize < codeLen) && error("Bad encoding in flate stream"),
                    (this.codeBuf = codeBuf >> codeLen),
                    (this.codeSize = codeSize - codeLen),
                    codeVal
                  );
                }),
                (FlateStream.prototype.generateHuffmanTable = function (lengths) {
                  var i,
                    n = lengths.length,
                    maxLen = 0;
                  for (i = 0; i < n; ++i) lengths[i] > maxLen && (maxLen = lengths[i]);
                  for (
                    var size = 1 << maxLen, codes = new Int32Array(size), len = 1, code = 0, skip = 2;
                    len <= maxLen;
                    ++len, code <<= 1, skip <<= 1
                  )
                    for (var val = 0; val < n; ++val)
                      if (lengths[val] === len) {
                        var code2 = 0,
                          t = code;
                        for (i = 0; i < len; ++i) (code2 = (code2 << 1) | (1 & t)), (t >>= 1);
                        for (i = code2; i < size; i += skip) codes[i] = (len << 16) | val;
                        ++code;
                      }
                  return [codes, maxLen];
                }),
                (FlateStream.prototype.readBlock = function () {
                  var buffer,
                    len,
                    str = this.str,
                    hdr = this.getBits(3);
                  if ((1 & hdr && (this.eof = !0), 0 !== (hdr >>= 1))) {
                    var litCodeTable, distCodeTable;
                    if (1 === hdr) (litCodeTable = fixedLitCodeTab), (distCodeTable = fixedDistCodeTab);
                    else if (2 === hdr) {
                      var i,
                        numLitCodes = this.getBits(5) + 257,
                        numDistCodes = this.getBits(5) + 1,
                        numCodeLenCodes = this.getBits(4) + 4,
                        codeLenCodeLengths = new Uint8Array(codeLenCodeMap.length);
                      for (i = 0; i < numCodeLenCodes; ++i) codeLenCodeLengths[codeLenCodeMap[i]] = this.getBits(3);
                      var codeLenCodeTab = this.generateHuffmanTable(codeLenCodeLengths);
                      (len = 0), (i = 0);
                      for (
                        var bitsLength,
                          bitsOffset,
                          what,
                          codes = numLitCodes + numDistCodes,
                          codeLengths = new Uint8Array(codes);
                        i < codes;

                      ) {
                        var code = this.getCode(codeLenCodeTab);
                        if (16 === code) (bitsLength = 2), (bitsOffset = 3), (what = len);
                        else if (17 === code) (bitsLength = 3), (bitsOffset = 3), (what = len = 0);
                        else {
                          if (18 !== code) {
                            codeLengths[i++] = len = code;
                            continue;
                          }
                          (bitsLength = 7), (bitsOffset = 11), (what = len = 0);
                        }
                        for (var repeatLength = this.getBits(bitsLength) + bitsOffset; repeatLength-- > 0; )
                          codeLengths[i++] = what;
                      }
                      (litCodeTable = this.generateHuffmanTable(codeLengths.subarray(0, numLitCodes))),
                        (distCodeTable = this.generateHuffmanTable(codeLengths.subarray(numLitCodes, codes)));
                    } else error("Unknown block type in flate stream");
                    buffer = this.buffer;
                    for (var limit = buffer ? buffer.length : 0, pos = this.bufferLength; ; ) {
                      var code1 = this.getCode(litCodeTable);
                      if (code1 < 256)
                        pos + 1 >= limit && ((buffer = this.ensureBuffer(pos + 1)), (limit = buffer.length)),
                          (buffer[pos++] = code1);
                      else {
                        if (256 === code1) return void (this.bufferLength = pos);
                        (code1 -= 257), (code1 = lengthDecode[code1]);
                        var code2 = code1 >> 16;
                        code2 > 0 && (code2 = this.getBits(code2)),
                          (len = (65535 & code1) + code2),
                          (code1 = this.getCode(distCodeTable)),
                          (code1 = distDecode[code1]),
                          (code2 = code1 >> 16),
                          code2 > 0 && (code2 = this.getBits(code2));
                        var dist = (65535 & code1) + code2;
                        pos + len >= limit && ((buffer = this.ensureBuffer(pos + len)), (limit = buffer.length));
                        for (var k = 0; k < len; ++k, ++pos) buffer[pos] = buffer[pos - dist];
                      }
                    }
                  } else {
                    var b;
                    -1 === (b = str.getByte()) && error("Bad block header in flate stream");
                    var blockLen = b;
                    -1 === (b = str.getByte()) && error("Bad block header in flate stream"),
                      (blockLen |= b << 8),
                      -1 === (b = str.getByte()) && error("Bad block header in flate stream");
                    var check = b;
                    -1 === (b = str.getByte()) && error("Bad block header in flate stream"),
                      (check |= b << 8),
                      check === (65535 & ~blockLen) ||
                        (0 === blockLen && 0 === check) ||
                        error("Bad uncompressed block length in flate stream"),
                      (this.codeBuf = 0),
                      (this.codeSize = 0);
                    var bufferLength = this.bufferLength;
                    buffer = this.ensureBuffer(bufferLength + blockLen);
                    var end = bufferLength + blockLen;
                    if (((this.bufferLength = end), 0 === blockLen)) -1 === str.peekByte() && (this.eof = !0);
                    else
                      for (var n = bufferLength; n < end; ++n) {
                        if (-1 === (b = str.getByte())) {
                          this.eof = !0;
                          break;
                        }
                        buffer[n] = b;
                      }
                  }
                }),
                FlateStream
              );
            })(),
            PredictorStream = (function () {
              function PredictorStream(str, maybeLength, params) {
                if (!isDict(params)) return str;
                var predictor = (this.predictor = params.get("Predictor") || 1);
                if (predictor <= 1) return str;
                2 !== predictor && (predictor < 10 || predictor > 15) && error("Unsupported predictor: " + predictor),
                  (this.readBlock = 2 === predictor ? this.readBlockTiff : this.readBlockPng),
                  (this.str = str),
                  (this.dict = str.dict);
                var colors = (this.colors = params.get("Colors") || 1),
                  bits = (this.bits = params.get("BitsPerComponent") || 8),
                  columns = (this.columns = params.get("Columns") || 1);
                return (
                  (this.pixBytes = (colors * bits + 7) >> 3),
                  (this.rowBytes = (columns * colors * bits + 7) >> 3),
                  DecodeStream.call(this, maybeLength),
                  this
                );
              }
              return (
                (PredictorStream.prototype = Object.create(DecodeStream.prototype)),
                (PredictorStream.prototype.readBlockTiff = function () {
                  var rowBytes = this.rowBytes,
                    bufferLength = this.bufferLength,
                    buffer = this.ensureBuffer(bufferLength + rowBytes),
                    bits = this.bits,
                    colors = this.colors,
                    rawBytes = this.str.getBytes(rowBytes);
                  if (((this.eof = !rawBytes.length), !this.eof)) {
                    var i,
                      inbuf = 0,
                      outbuf = 0,
                      inbits = 0,
                      outbits = 0,
                      pos = bufferLength;
                    if (1 === bits)
                      for (i = 0; i < rowBytes; ++i) {
                        var c = rawBytes[i];
                        (inbuf = (inbuf << 8) | c), (buffer[pos++] = 255 & (c ^ (inbuf >> colors))), (inbuf &= 65535);
                      }
                    else if (8 === bits) {
                      for (i = 0; i < colors; ++i) buffer[pos++] = rawBytes[i];
                      for (; i < rowBytes; ++i) (buffer[pos] = buffer[pos - colors] + rawBytes[i]), pos++;
                    } else {
                      var compArray = new Uint8Array(colors + 1),
                        bitMask = (1 << bits) - 1,
                        j = 0,
                        k = bufferLength,
                        columns = this.columns;
                      for (i = 0; i < columns; ++i)
                        for (var kk = 0; kk < colors; ++kk)
                          inbits < bits && ((inbuf = (inbuf << 8) | (255 & rawBytes[j++])), (inbits += 8)),
                            (compArray[kk] = (compArray[kk] + (inbuf >> (inbits - bits))) & bitMask),
                            (inbits -= bits),
                            (outbuf = (outbuf << bits) | compArray[kk]),
                            (outbits += bits) >= 8 && ((buffer[k++] = (outbuf >> (outbits - 8)) & 255), (outbits -= 8));
                      outbits > 0 && (buffer[k++] = (outbuf << (8 - outbits)) + (inbuf & ((1 << (8 - outbits)) - 1)));
                    }
                    this.bufferLength += rowBytes;
                  }
                }),
                (PredictorStream.prototype.readBlockPng = function () {
                  var rowBytes = this.rowBytes,
                    pixBytes = this.pixBytes,
                    predictor = this.str.getByte(),
                    rawBytes = this.str.getBytes(rowBytes);
                  if (((this.eof = !rawBytes.length), !this.eof)) {
                    var bufferLength = this.bufferLength,
                      buffer = this.ensureBuffer(bufferLength + rowBytes),
                      prevRow = buffer.subarray(bufferLength - rowBytes, bufferLength);
                    0 === prevRow.length && (prevRow = new Uint8Array(rowBytes));
                    var i,
                      up,
                      c,
                      j = bufferLength;
                    switch (predictor) {
                      case 0:
                        for (i = 0; i < rowBytes; ++i) buffer[j++] = rawBytes[i];
                        break;
                      case 1:
                        for (i = 0; i < pixBytes; ++i) buffer[j++] = rawBytes[i];
                        for (; i < rowBytes; ++i) (buffer[j] = (buffer[j - pixBytes] + rawBytes[i]) & 255), j++;
                        break;
                      case 2:
                        for (i = 0; i < rowBytes; ++i) buffer[j++] = (prevRow[i] + rawBytes[i]) & 255;
                        break;
                      case 3:
                        for (i = 0; i < pixBytes; ++i) buffer[j++] = (prevRow[i] >> 1) + rawBytes[i];
                        for (; i < rowBytes; ++i)
                          (buffer[j] = (((prevRow[i] + buffer[j - pixBytes]) >> 1) + rawBytes[i]) & 255), j++;
                        break;
                      case 4:
                        for (i = 0; i < pixBytes; ++i) (up = prevRow[i]), (c = rawBytes[i]), (buffer[j++] = up + c);
                        for (; i < rowBytes; ++i) {
                          up = prevRow[i];
                          var upLeft = prevRow[i - pixBytes],
                            left = buffer[j - pixBytes],
                            p = left + up - upLeft,
                            pa = p - left;
                          pa < 0 && (pa = -pa);
                          var pb = p - up;
                          pb < 0 && (pb = -pb);
                          var pc = p - upLeft;
                          pc < 0 && (pc = -pc),
                            (c = rawBytes[i]),
                            (buffer[j++] = pa <= pb && pa <= pc ? left + c : pb <= pc ? up + c : upLeft + c);
                        }
                        break;
                      default:
                        error("Unsupported predictor: " + predictor);
                    }
                    this.bufferLength += rowBytes;
                  }
                }),
                PredictorStream
              );
            })(),
            JpegStream = (function () {
              function JpegStream(stream, maybeLength, dict) {
                for (var ch; -1 !== (ch = stream.getByte()); )
                  if (255 === ch) {
                    stream.skip(-1);
                    break;
                  }
                (this.stream = stream),
                  (this.maybeLength = maybeLength),
                  (this.dict = dict),
                  DecodeStream.call(this, maybeLength);
              }
              return (
                (JpegStream.prototype = Object.create(DecodeStream.prototype)),
                Object.defineProperty(JpegStream.prototype, "bytes", {
                  get: function () {
                    return shadow(this, "bytes", this.stream.getBytes(this.maybeLength));
                  },
                  configurable: !0,
                }),
                (JpegStream.prototype.ensureBuffer = function (req) {
                  if (!this.bufferLength) {
                    var jpegImage = new JpegImage(),
                      decodeArr = this.dict.getArray("Decode", "D");
                    if (this.forceRGB && isArray(decodeArr)) {
                      for (
                        var bitsPerComponent = this.dict.get("BitsPerComponent") || 8,
                          decodeArrLength = decodeArr.length,
                          transform = new Int32Array(decodeArrLength),
                          transformNeeded = !1,
                          maxValue = (1 << bitsPerComponent) - 1,
                          i = 0;
                        i < decodeArrLength;
                        i += 2
                      )
                        (transform[i] = (256 * (decodeArr[i + 1] - decodeArr[i])) | 0),
                          (transform[i + 1] = (decodeArr[i] * maxValue) | 0),
                          (256 === transform[i] && 0 === transform[i + 1]) || (transformNeeded = !0);
                      transformNeeded && (jpegImage.decodeTransform = transform);
                    }
                    var decodeParams = this.dict.get("DecodeParms", "DP");
                    if (isDict(decodeParams)) {
                      var colorTransform = decodeParams.get("ColorTransform");
                      isInt(colorTransform) && (jpegImage.colorTransform = colorTransform);
                    }
                    jpegImage.parse(this.bytes);
                    var data = jpegImage.getData(this.drawWidth, this.drawHeight, this.forceRGB);
                    (this.buffer = data), (this.bufferLength = data.length), (this.eof = !0);
                  }
                }),
                (JpegStream.prototype.getBytes = function (length) {
                  return this.ensureBuffer(), this.buffer;
                }),
                (JpegStream.prototype.getIR = function (forceDataSchema) {
                  return createObjectURL(this.bytes, "image/jpeg", forceDataSchema);
                }),
                JpegStream
              );
            })(),
            JpxStream = (function () {
              function JpxStream(stream, maybeLength, dict) {
                (this.stream = stream),
                  (this.maybeLength = maybeLength),
                  (this.dict = dict),
                  DecodeStream.call(this, maybeLength);
              }
              return (
                (JpxStream.prototype = Object.create(DecodeStream.prototype)),
                Object.defineProperty(JpxStream.prototype, "bytes", {
                  get: function () {
                    return shadow(this, "bytes", this.stream.getBytes(this.maybeLength));
                  },
                  configurable: !0,
                }),
                (JpxStream.prototype.ensureBuffer = function (req) {
                  if (!this.bufferLength) {
                    var jpxImage = new JpxImage();
                    jpxImage.parse(this.bytes);
                    var width = jpxImage.width,
                      height = jpxImage.height,
                      componentsCount = jpxImage.componentsCount,
                      tileCount = jpxImage.tiles.length;
                    if (1 === tileCount) this.buffer = jpxImage.tiles[0].items;
                    else {
                      for (var data = new Uint8Array(width * height * componentsCount), k = 0; k < tileCount; k++)
                        for (
                          var tileComponents = jpxImage.tiles[k],
                            tileWidth = tileComponents.width,
                            tileHeight = tileComponents.height,
                            tileLeft = tileComponents.left,
                            tileTop = tileComponents.top,
                            src = tileComponents.items,
                            srcPosition = 0,
                            dataPosition = (width * tileTop + tileLeft) * componentsCount,
                            imgRowSize = width * componentsCount,
                            tileRowSize = tileWidth * componentsCount,
                            j = 0;
                          j < tileHeight;
                          j++
                        ) {
                          var rowBytes = src.subarray(srcPosition, srcPosition + tileRowSize);
                          data.set(rowBytes, dataPosition), (srcPosition += tileRowSize), (dataPosition += imgRowSize);
                        }
                      this.buffer = data;
                    }
                    (this.bufferLength = this.buffer.length), (this.eof = !0);
                  }
                }),
                JpxStream
              );
            })(),
            Jbig2Stream = (function () {
              function Jbig2Stream(stream, maybeLength, dict) {
                (this.stream = stream),
                  (this.maybeLength = maybeLength),
                  (this.dict = dict),
                  DecodeStream.call(this, maybeLength);
              }
              return (
                (Jbig2Stream.prototype = Object.create(DecodeStream.prototype)),
                Object.defineProperty(Jbig2Stream.prototype, "bytes", {
                  get: function () {
                    return shadow(this, "bytes", this.stream.getBytes(this.maybeLength));
                  },
                  configurable: !0,
                }),
                (Jbig2Stream.prototype.ensureBuffer = function (req) {
                  if (!this.bufferLength) {
                    var jbig2Image = new Jbig2Image(),
                      chunks = [],
                      decodeParams = this.dict.getArray("DecodeParms", "DP");
                    if (
                      (isArray(decodeParams) &&
                        (decodeParams.length > 1 &&
                          warn("JBIG2 - 'DecodeParms' array with multiple elements not supported."),
                        (decodeParams = decodeParams[0])),
                      decodeParams && decodeParams.has("JBIG2Globals"))
                    ) {
                      var globalsStream = decodeParams.get("JBIG2Globals"),
                        globals = globalsStream.getBytes();
                      chunks.push({ data: globals, start: 0, end: globals.length });
                    }
                    chunks.push({ data: this.bytes, start: 0, end: this.bytes.length });
                    for (
                      var data = jbig2Image.parseChunks(chunks), dataLength = data.length, i = 0;
                      i < dataLength;
                      i++
                    )
                      data[i] ^= 255;
                    (this.buffer = data), (this.bufferLength = dataLength), (this.eof = !0);
                  }
                }),
                Jbig2Stream
              );
            })(),
            DecryptStream = (function () {
              function DecryptStream(str, maybeLength, decrypt) {
                (this.str = str),
                  (this.dict = str.dict),
                  (this.decrypt = decrypt),
                  (this.nextChunk = null),
                  (this.initialized = !1),
                  DecodeStream.call(this, maybeLength);
              }
              return (
                (DecryptStream.prototype = Object.create(DecodeStream.prototype)),
                (DecryptStream.prototype.readBlock = function () {
                  var chunk;
                  if (
                    (this.initialized
                      ? (chunk = this.nextChunk)
                      : ((chunk = this.str.getBytes(512)), (this.initialized = !0)),
                    !chunk || 0 === chunk.length)
                  )
                    return void (this.eof = !0);
                  this.nextChunk = this.str.getBytes(512);
                  var hasMoreData = this.nextChunk && this.nextChunk.length > 0;
                  chunk = (0, this.decrypt)(chunk, !hasMoreData);
                  var i,
                    bufferLength = this.bufferLength,
                    n = chunk.length,
                    buffer = this.ensureBuffer(bufferLength + n);
                  for (i = 0; i < n; i++) buffer[bufferLength++] = chunk[i];
                  this.bufferLength = bufferLength;
                }),
                DecryptStream
              );
            })(),
            Ascii85Stream = (function () {
              function Ascii85Stream(str, maybeLength) {
                (this.str = str),
                  (this.dict = str.dict),
                  (this.input = new Uint8Array(5)),
                  maybeLength && (maybeLength *= 0.8),
                  DecodeStream.call(this, maybeLength);
              }
              return (
                (Ascii85Stream.prototype = Object.create(DecodeStream.prototype)),
                (Ascii85Stream.prototype.readBlock = function () {
                  for (var str = this.str, c = str.getByte(); isSpace(c); ) c = str.getByte();
                  if (-1 === c || 126 === c) return void (this.eof = !0);
                  var buffer,
                    i,
                    bufferLength = this.bufferLength;
                  if (122 === c) {
                    for (buffer = this.ensureBuffer(bufferLength + 4), i = 0; i < 4; ++i) buffer[bufferLength + i] = 0;
                    this.bufferLength += 4;
                  } else {
                    var input = this.input;
                    for (input[0] = c, i = 1; i < 5; ++i) {
                      for (c = str.getByte(); isSpace(c); ) c = str.getByte();
                      if (((input[i] = c), -1 === c || 126 === c)) break;
                    }
                    if (((buffer = this.ensureBuffer(bufferLength + i - 1)), (this.bufferLength += i - 1), i < 5)) {
                      for (; i < 5; ++i) input[i] = 117;
                      this.eof = !0;
                    }
                    var t = 0;
                    for (i = 0; i < 5; ++i) t = 85 * t + (input[i] - 33);
                    for (i = 3; i >= 0; --i) (buffer[bufferLength + i] = 255 & t), (t >>= 8);
                  }
                }),
                Ascii85Stream
              );
            })(),
            AsciiHexStream = (function () {
              function AsciiHexStream(str, maybeLength) {
                (this.str = str),
                  (this.dict = str.dict),
                  (this.firstDigit = -1),
                  maybeLength && (maybeLength *= 0.5),
                  DecodeStream.call(this, maybeLength);
              }
              return (
                (AsciiHexStream.prototype = Object.create(DecodeStream.prototype)),
                (AsciiHexStream.prototype.readBlock = function () {
                  var bytes = this.str.getBytes(8e3);
                  if (!bytes.length) return void (this.eof = !0);
                  for (
                    var maxDecodeLength = (bytes.length + 1) >> 1,
                      buffer = this.ensureBuffer(this.bufferLength + maxDecodeLength),
                      bufferLength = this.bufferLength,
                      firstDigit = this.firstDigit,
                      i = 0,
                      ii = bytes.length;
                    i < ii;
                    i++
                  ) {
                    var digit,
                      ch = bytes[i];
                    if (ch >= 48 && ch <= 57) digit = 15 & ch;
                    else {
                      if (!((ch >= 65 && ch <= 70) || (ch >= 97 && ch <= 102))) {
                        if (62 === ch) {
                          this.eof = !0;
                          break;
                        }
                        continue;
                      }
                      digit = 9 + (15 & ch);
                    }
                    firstDigit < 0
                      ? (firstDigit = digit)
                      : ((buffer[bufferLength++] = (firstDigit << 4) | digit), (firstDigit = -1));
                  }
                  firstDigit >= 0 && this.eof && ((buffer[bufferLength++] = firstDigit << 4), (firstDigit = -1)),
                    (this.firstDigit = firstDigit),
                    (this.bufferLength = bufferLength);
                }),
                AsciiHexStream
              );
            })(),
            RunLengthStream = (function () {
              function RunLengthStream(str, maybeLength) {
                (this.str = str), (this.dict = str.dict), DecodeStream.call(this, maybeLength);
              }
              return (
                (RunLengthStream.prototype = Object.create(DecodeStream.prototype)),
                (RunLengthStream.prototype.readBlock = function () {
                  var repeatHeader = this.str.getBytes(2);
                  if (!repeatHeader || repeatHeader.length < 2 || 128 === repeatHeader[0]) return void (this.eof = !0);
                  var buffer,
                    bufferLength = this.bufferLength,
                    n = repeatHeader[0];
                  if (n < 128) {
                    if (
                      ((buffer = this.ensureBuffer(bufferLength + n + 1)),
                      (buffer[bufferLength++] = repeatHeader[1]),
                      n > 0)
                    ) {
                      var source = this.str.getBytes(n);
                      buffer.set(source, bufferLength), (bufferLength += n);
                    }
                  } else {
                    n = 257 - n;
                    var b = repeatHeader[1];
                    buffer = this.ensureBuffer(bufferLength + n + 1);
                    for (var i = 0; i < n; i++) buffer[bufferLength++] = b;
                  }
                  this.bufferLength = bufferLength;
                }),
                RunLengthStream
              );
            })(),
            CCITTFaxStream = (function () {
              function CCITTFaxStream(str, maybeLength, params) {
                (this.str = str),
                  (this.dict = str.dict),
                  (params = params || Dict.empty),
                  (this.encoding = params.get("K") || 0),
                  (this.eoline = params.get("EndOfLine") || !1),
                  (this.byteAlign = params.get("EncodedByteAlign") || !1),
                  (this.columns = params.get("Columns") || 1728),
                  (this.rows = params.get("Rows") || 0);
                var eoblock = params.get("EndOfBlock");
                (null !== eoblock && void 0 !== eoblock) || (eoblock = !0),
                  (this.eoblock = eoblock),
                  (this.black = params.get("BlackIs1") || !1),
                  (this.codingLine = new Uint32Array(this.columns + 1)),
                  (this.refLine = new Uint32Array(this.columns + 2)),
                  (this.codingLine[0] = this.columns),
                  (this.codingPos = 0),
                  (this.row = 0),
                  (this.nextLine2D = this.encoding < 0),
                  (this.inputBits = 0),
                  (this.inputBuf = 0),
                  (this.outputBits = 0);
                for (var code1; 0 === (code1 = this.lookBits(12)); ) this.eatBits(1);
                1 === code1 && this.eatBits(12),
                  this.encoding > 0 && ((this.nextLine2D = !this.lookBits(1)), this.eatBits(1)),
                  DecodeStream.call(this, maybeLength);
              }
              var twoDimTable = [
                  [-1, -1],
                  [-1, -1],
                  [7, 8],
                  [7, 7],
                  [6, 6],
                  [6, 6],
                  [6, 5],
                  [6, 5],
                  [4, 0],
                  [4, 0],
                  [4, 0],
                  [4, 0],
                  [4, 0],
                  [4, 0],
                  [4, 0],
                  [4, 0],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 3],
                  [3, 3],
                  [3, 3],
                  [3, 3],
                  [3, 3],
                  [3, 3],
                  [3, 3],
                  [3, 3],
                  [3, 3],
                  [3, 3],
                  [3, 3],
                  [3, 3],
                  [3, 3],
                  [3, 3],
                  [3, 3],
                  [3, 3],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                  [1, 2],
                ],
                whiteTable1 = [
                  [-1, -1],
                  [12, -2],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [11, 1792],
                  [11, 1792],
                  [12, 1984],
                  [12, 2048],
                  [12, 2112],
                  [12, 2176],
                  [12, 2240],
                  [12, 2304],
                  [11, 1856],
                  [11, 1856],
                  [11, 1920],
                  [11, 1920],
                  [12, 2368],
                  [12, 2432],
                  [12, 2496],
                  [12, 2560],
                ],
                whiteTable2 = [
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [8, 29],
                  [8, 29],
                  [8, 30],
                  [8, 30],
                  [8, 45],
                  [8, 45],
                  [8, 46],
                  [8, 46],
                  [7, 22],
                  [7, 22],
                  [7, 22],
                  [7, 22],
                  [7, 23],
                  [7, 23],
                  [7, 23],
                  [7, 23],
                  [8, 47],
                  [8, 47],
                  [8, 48],
                  [8, 48],
                  [6, 13],
                  [6, 13],
                  [6, 13],
                  [6, 13],
                  [6, 13],
                  [6, 13],
                  [6, 13],
                  [6, 13],
                  [7, 20],
                  [7, 20],
                  [7, 20],
                  [7, 20],
                  [8, 33],
                  [8, 33],
                  [8, 34],
                  [8, 34],
                  [8, 35],
                  [8, 35],
                  [8, 36],
                  [8, 36],
                  [8, 37],
                  [8, 37],
                  [8, 38],
                  [8, 38],
                  [7, 19],
                  [7, 19],
                  [7, 19],
                  [7, 19],
                  [8, 31],
                  [8, 31],
                  [8, 32],
                  [8, 32],
                  [6, 1],
                  [6, 1],
                  [6, 1],
                  [6, 1],
                  [6, 1],
                  [6, 1],
                  [6, 1],
                  [6, 1],
                  [6, 12],
                  [6, 12],
                  [6, 12],
                  [6, 12],
                  [6, 12],
                  [6, 12],
                  [6, 12],
                  [6, 12],
                  [8, 53],
                  [8, 53],
                  [8, 54],
                  [8, 54],
                  [7, 26],
                  [7, 26],
                  [7, 26],
                  [7, 26],
                  [8, 39],
                  [8, 39],
                  [8, 40],
                  [8, 40],
                  [8, 41],
                  [8, 41],
                  [8, 42],
                  [8, 42],
                  [8, 43],
                  [8, 43],
                  [8, 44],
                  [8, 44],
                  [7, 21],
                  [7, 21],
                  [7, 21],
                  [7, 21],
                  [7, 28],
                  [7, 28],
                  [7, 28],
                  [7, 28],
                  [8, 61],
                  [8, 61],
                  [8, 62],
                  [8, 62],
                  [8, 63],
                  [8, 63],
                  [8, 0],
                  [8, 0],
                  [8, 320],
                  [8, 320],
                  [8, 384],
                  [8, 384],
                  [5, 10],
                  [5, 10],
                  [5, 10],
                  [5, 10],
                  [5, 10],
                  [5, 10],
                  [5, 10],
                  [5, 10],
                  [5, 10],
                  [5, 10],
                  [5, 10],
                  [5, 10],
                  [5, 10],
                  [5, 10],
                  [5, 10],
                  [5, 10],
                  [5, 11],
                  [5, 11],
                  [5, 11],
                  [5, 11],
                  [5, 11],
                  [5, 11],
                  [5, 11],
                  [5, 11],
                  [5, 11],
                  [5, 11],
                  [5, 11],
                  [5, 11],
                  [5, 11],
                  [5, 11],
                  [5, 11],
                  [5, 11],
                  [7, 27],
                  [7, 27],
                  [7, 27],
                  [7, 27],
                  [8, 59],
                  [8, 59],
                  [8, 60],
                  [8, 60],
                  [9, 1472],
                  [9, 1536],
                  [9, 1600],
                  [9, 1728],
                  [7, 18],
                  [7, 18],
                  [7, 18],
                  [7, 18],
                  [7, 24],
                  [7, 24],
                  [7, 24],
                  [7, 24],
                  [8, 49],
                  [8, 49],
                  [8, 50],
                  [8, 50],
                  [8, 51],
                  [8, 51],
                  [8, 52],
                  [8, 52],
                  [7, 25],
                  [7, 25],
                  [7, 25],
                  [7, 25],
                  [8, 55],
                  [8, 55],
                  [8, 56],
                  [8, 56],
                  [8, 57],
                  [8, 57],
                  [8, 58],
                  [8, 58],
                  [6, 192],
                  [6, 192],
                  [6, 192],
                  [6, 192],
                  [6, 192],
                  [6, 192],
                  [6, 192],
                  [6, 192],
                  [6, 1664],
                  [6, 1664],
                  [6, 1664],
                  [6, 1664],
                  [6, 1664],
                  [6, 1664],
                  [6, 1664],
                  [6, 1664],
                  [8, 448],
                  [8, 448],
                  [8, 512],
                  [8, 512],
                  [9, 704],
                  [9, 768],
                  [8, 640],
                  [8, 640],
                  [8, 576],
                  [8, 576],
                  [9, 832],
                  [9, 896],
                  [9, 960],
                  [9, 1024],
                  [9, 1088],
                  [9, 1152],
                  [9, 1216],
                  [9, 1280],
                  [9, 1344],
                  [9, 1408],
                  [7, 256],
                  [7, 256],
                  [7, 256],
                  [7, 256],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 2],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [4, 3],
                  [5, 128],
                  [5, 128],
                  [5, 128],
                  [5, 128],
                  [5, 128],
                  [5, 128],
                  [5, 128],
                  [5, 128],
                  [5, 128],
                  [5, 128],
                  [5, 128],
                  [5, 128],
                  [5, 128],
                  [5, 128],
                  [5, 128],
                  [5, 128],
                  [5, 8],
                  [5, 8],
                  [5, 8],
                  [5, 8],
                  [5, 8],
                  [5, 8],
                  [5, 8],
                  [5, 8],
                  [5, 8],
                  [5, 8],
                  [5, 8],
                  [5, 8],
                  [5, 8],
                  [5, 8],
                  [5, 8],
                  [5, 8],
                  [5, 9],
                  [5, 9],
                  [5, 9],
                  [5, 9],
                  [5, 9],
                  [5, 9],
                  [5, 9],
                  [5, 9],
                  [5, 9],
                  [5, 9],
                  [5, 9],
                  [5, 9],
                  [5, 9],
                  [5, 9],
                  [5, 9],
                  [5, 9],
                  [6, 16],
                  [6, 16],
                  [6, 16],
                  [6, 16],
                  [6, 16],
                  [6, 16],
                  [6, 16],
                  [6, 16],
                  [6, 17],
                  [6, 17],
                  [6, 17],
                  [6, 17],
                  [6, 17],
                  [6, 17],
                  [6, 17],
                  [6, 17],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 4],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [6, 14],
                  [6, 14],
                  [6, 14],
                  [6, 14],
                  [6, 14],
                  [6, 14],
                  [6, 14],
                  [6, 14],
                  [6, 15],
                  [6, 15],
                  [6, 15],
                  [6, 15],
                  [6, 15],
                  [6, 15],
                  [6, 15],
                  [6, 15],
                  [5, 64],
                  [5, 64],
                  [5, 64],
                  [5, 64],
                  [5, 64],
                  [5, 64],
                  [5, 64],
                  [5, 64],
                  [5, 64],
                  [5, 64],
                  [5, 64],
                  [5, 64],
                  [5, 64],
                  [5, 64],
                  [5, 64],
                  [5, 64],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                  [4, 7],
                ],
                blackTable1 = [
                  [-1, -1],
                  [-1, -1],
                  [12, -2],
                  [12, -2],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [11, 1792],
                  [11, 1792],
                  [11, 1792],
                  [11, 1792],
                  [12, 1984],
                  [12, 1984],
                  [12, 2048],
                  [12, 2048],
                  [12, 2112],
                  [12, 2112],
                  [12, 2176],
                  [12, 2176],
                  [12, 2240],
                  [12, 2240],
                  [12, 2304],
                  [12, 2304],
                  [11, 1856],
                  [11, 1856],
                  [11, 1856],
                  [11, 1856],
                  [11, 1920],
                  [11, 1920],
                  [11, 1920],
                  [11, 1920],
                  [12, 2368],
                  [12, 2368],
                  [12, 2432],
                  [12, 2432],
                  [12, 2496],
                  [12, 2496],
                  [12, 2560],
                  [12, 2560],
                  [10, 18],
                  [10, 18],
                  [10, 18],
                  [10, 18],
                  [10, 18],
                  [10, 18],
                  [10, 18],
                  [10, 18],
                  [12, 52],
                  [12, 52],
                  [13, 640],
                  [13, 704],
                  [13, 768],
                  [13, 832],
                  [12, 55],
                  [12, 55],
                  [12, 56],
                  [12, 56],
                  [13, 1280],
                  [13, 1344],
                  [13, 1408],
                  [13, 1472],
                  [12, 59],
                  [12, 59],
                  [12, 60],
                  [12, 60],
                  [13, 1536],
                  [13, 1600],
                  [11, 24],
                  [11, 24],
                  [11, 24],
                  [11, 24],
                  [11, 25],
                  [11, 25],
                  [11, 25],
                  [11, 25],
                  [13, 1664],
                  [13, 1728],
                  [12, 320],
                  [12, 320],
                  [12, 384],
                  [12, 384],
                  [12, 448],
                  [12, 448],
                  [13, 512],
                  [13, 576],
                  [12, 53],
                  [12, 53],
                  [12, 54],
                  [12, 54],
                  [13, 896],
                  [13, 960],
                  [13, 1024],
                  [13, 1088],
                  [13, 1152],
                  [13, 1216],
                  [10, 64],
                  [10, 64],
                  [10, 64],
                  [10, 64],
                  [10, 64],
                  [10, 64],
                  [10, 64],
                  [10, 64],
                ],
                blackTable2 = [
                  [8, 13],
                  [8, 13],
                  [8, 13],
                  [8, 13],
                  [8, 13],
                  [8, 13],
                  [8, 13],
                  [8, 13],
                  [8, 13],
                  [8, 13],
                  [8, 13],
                  [8, 13],
                  [8, 13],
                  [8, 13],
                  [8, 13],
                  [8, 13],
                  [11, 23],
                  [11, 23],
                  [12, 50],
                  [12, 51],
                  [12, 44],
                  [12, 45],
                  [12, 46],
                  [12, 47],
                  [12, 57],
                  [12, 58],
                  [12, 61],
                  [12, 256],
                  [10, 16],
                  [10, 16],
                  [10, 16],
                  [10, 16],
                  [10, 17],
                  [10, 17],
                  [10, 17],
                  [10, 17],
                  [12, 48],
                  [12, 49],
                  [12, 62],
                  [12, 63],
                  [12, 30],
                  [12, 31],
                  [12, 32],
                  [12, 33],
                  [12, 40],
                  [12, 41],
                  [11, 22],
                  [11, 22],
                  [8, 14],
                  [8, 14],
                  [8, 14],
                  [8, 14],
                  [8, 14],
                  [8, 14],
                  [8, 14],
                  [8, 14],
                  [8, 14],
                  [8, 14],
                  [8, 14],
                  [8, 14],
                  [8, 14],
                  [8, 14],
                  [8, 14],
                  [8, 14],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 10],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [7, 11],
                  [9, 15],
                  [9, 15],
                  [9, 15],
                  [9, 15],
                  [9, 15],
                  [9, 15],
                  [9, 15],
                  [9, 15],
                  [12, 128],
                  [12, 192],
                  [12, 26],
                  [12, 27],
                  [12, 28],
                  [12, 29],
                  [11, 19],
                  [11, 19],
                  [11, 20],
                  [11, 20],
                  [12, 34],
                  [12, 35],
                  [12, 36],
                  [12, 37],
                  [12, 38],
                  [12, 39],
                  [11, 21],
                  [11, 21],
                  [12, 42],
                  [12, 43],
                  [10, 0],
                  [10, 0],
                  [10, 0],
                  [10, 0],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                  [7, 12],
                ],
                blackTable3 = [
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [-1, -1],
                  [6, 9],
                  [6, 8],
                  [5, 7],
                  [5, 7],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 6],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [4, 5],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 1],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [3, 4],
                  [2, 3],
                  [2, 3],
                  [2, 3],
                  [2, 3],
                  [2, 3],
                  [2, 3],
                  [2, 3],
                  [2, 3],
                  [2, 3],
                  [2, 3],
                  [2, 3],
                  [2, 3],
                  [2, 3],
                  [2, 3],
                  [2, 3],
                  [2, 3],
                  [2, 2],
                  [2, 2],
                  [2, 2],
                  [2, 2],
                  [2, 2],
                  [2, 2],
                  [2, 2],
                  [2, 2],
                  [2, 2],
                  [2, 2],
                  [2, 2],
                  [2, 2],
                  [2, 2],
                  [2, 2],
                  [2, 2],
                  [2, 2],
                ];
              return (
                (CCITTFaxStream.prototype = Object.create(DecodeStream.prototype)),
                (CCITTFaxStream.prototype.readBlock = function () {
                  for (; !this.eof; ) {
                    var c = this.lookChar();
                    this.ensureBuffer(this.bufferLength + 1), (this.buffer[this.bufferLength++] = c);
                  }
                }),
                (CCITTFaxStream.prototype.addPixels = function (a1, blackPixels) {
                  var codingLine = this.codingLine,
                    codingPos = this.codingPos;
                  a1 > codingLine[codingPos] &&
                    (a1 > this.columns && (info("row is wrong length"), (this.err = !0), (a1 = this.columns)),
                    (1 & codingPos) ^ blackPixels && ++codingPos,
                    (codingLine[codingPos] = a1)),
                    (this.codingPos = codingPos);
                }),
                (CCITTFaxStream.prototype.addPixelsNeg = function (a1, blackPixels) {
                  var codingLine = this.codingLine,
                    codingPos = this.codingPos;
                  if (a1 > codingLine[codingPos])
                    a1 > this.columns && (info("row is wrong length"), (this.err = !0), (a1 = this.columns)),
                      (1 & codingPos) ^ blackPixels && ++codingPos,
                      (codingLine[codingPos] = a1);
                  else if (a1 < codingLine[codingPos]) {
                    for (
                      a1 < 0 && (info("invalid code"), (this.err = !0), (a1 = 0));
                      codingPos > 0 && a1 < codingLine[codingPos - 1];

                    )
                      --codingPos;
                    codingLine[codingPos] = a1;
                  }
                  this.codingPos = codingPos;
                }),
                (CCITTFaxStream.prototype.lookChar = function () {
                  var refPos,
                    blackPixels,
                    bits,
                    i,
                    refLine = this.refLine,
                    codingLine = this.codingLine,
                    columns = this.columns;
                  if (0 === this.outputBits) {
                    if (this.eof) return null;
                    this.err = !1;
                    var code1, code2, code3;
                    if (this.nextLine2D) {
                      for (i = 0; codingLine[i] < columns; ++i) refLine[i] = codingLine[i];
                      for (
                        refLine[i++] = columns,
                          refLine[i] = columns,
                          codingLine[0] = 0,
                          this.codingPos = 0,
                          refPos = 0,
                          blackPixels = 0;
                        codingLine[this.codingPos] < columns;

                      )
                        switch ((code1 = this.getTwoDimCode())) {
                          case 0:
                            this.addPixels(refLine[refPos + 1], blackPixels),
                              refLine[refPos + 1] < columns && (refPos += 2);
                            break;
                          case 1:
                            if (((code1 = code2 = 0), blackPixels)) {
                              do {
                                code1 += code3 = this.getBlackCode();
                              } while (code3 >= 64);
                              do {
                                code2 += code3 = this.getWhiteCode();
                              } while (code3 >= 64);
                            } else {
                              do {
                                code1 += code3 = this.getWhiteCode();
                              } while (code3 >= 64);
                              do {
                                code2 += code3 = this.getBlackCode();
                              } while (code3 >= 64);
                            }
                            for (
                              this.addPixels(codingLine[this.codingPos] + code1, blackPixels),
                                codingLine[this.codingPos] < columns &&
                                  this.addPixels(codingLine[this.codingPos] + code2, 1 ^ blackPixels);
                              refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns;

                            )
                              refPos += 2;
                            break;
                          case 7:
                            if (
                              (this.addPixels(refLine[refPos] + 3, blackPixels),
                              (blackPixels ^= 1),
                              codingLine[this.codingPos] < columns)
                            )
                              for (
                                ++refPos;
                                refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns;

                              )
                                refPos += 2;
                            break;
                          case 5:
                            if (
                              (this.addPixels(refLine[refPos] + 2, blackPixels),
                              (blackPixels ^= 1),
                              codingLine[this.codingPos] < columns)
                            )
                              for (
                                ++refPos;
                                refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns;

                              )
                                refPos += 2;
                            break;
                          case 3:
                            if (
                              (this.addPixels(refLine[refPos] + 1, blackPixels),
                              (blackPixels ^= 1),
                              codingLine[this.codingPos] < columns)
                            )
                              for (
                                ++refPos;
                                refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns;

                              )
                                refPos += 2;
                            break;
                          case 2:
                            if (
                              (this.addPixels(refLine[refPos], blackPixels),
                              (blackPixels ^= 1),
                              codingLine[this.codingPos] < columns)
                            )
                              for (
                                ++refPos;
                                refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns;

                              )
                                refPos += 2;
                            break;
                          case 8:
                            if (
                              (this.addPixelsNeg(refLine[refPos] - 3, blackPixels),
                              (blackPixels ^= 1),
                              codingLine[this.codingPos] < columns)
                            )
                              for (
                                refPos > 0 ? --refPos : ++refPos;
                                refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns;

                              )
                                refPos += 2;
                            break;
                          case 6:
                            if (
                              (this.addPixelsNeg(refLine[refPos] - 2, blackPixels),
                              (blackPixels ^= 1),
                              codingLine[this.codingPos] < columns)
                            )
                              for (
                                refPos > 0 ? --refPos : ++refPos;
                                refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns;

                              )
                                refPos += 2;
                            break;
                          case 4:
                            if (
                              (this.addPixelsNeg(refLine[refPos] - 1, blackPixels),
                              (blackPixels ^= 1),
                              codingLine[this.codingPos] < columns)
                            )
                              for (
                                refPos > 0 ? --refPos : ++refPos;
                                refLine[refPos] <= codingLine[this.codingPos] && refLine[refPos] < columns;

                              )
                                refPos += 2;
                            break;
                          case -1:
                            this.addPixels(columns, 0), (this.eof = !0);
                            break;
                          default:
                            info("bad 2d code"), this.addPixels(columns, 0), (this.err = !0);
                        }
                    } else
                      for (
                        codingLine[0] = 0, this.codingPos = 0, blackPixels = 0;
                        codingLine[this.codingPos] < columns;

                      ) {
                        if (((code1 = 0), blackPixels))
                          do {
                            code1 += code3 = this.getBlackCode();
                          } while (code3 >= 64);
                        else
                          do {
                            code1 += code3 = this.getWhiteCode();
                          } while (code3 >= 64);
                        this.addPixels(codingLine[this.codingPos] + code1, blackPixels), (blackPixels ^= 1);
                      }
                    var gotEOL = !1;
                    if ((this.byteAlign && (this.inputBits &= -8), this.eoblock || this.row !== this.rows - 1)) {
                      if (((code1 = this.lookBits(12)), this.eoline))
                        for (; -1 !== code1 && 1 !== code1; ) this.eatBits(1), (code1 = this.lookBits(12));
                      else for (; 0 === code1; ) this.eatBits(1), (code1 = this.lookBits(12));
                      1 === code1 ? (this.eatBits(12), (gotEOL = !0)) : -1 === code1 && (this.eof = !0);
                    } else this.eof = !0;
                    if (
                      (!this.eof && this.encoding > 0 && ((this.nextLine2D = !this.lookBits(1)), this.eatBits(1)),
                      this.eoblock && gotEOL && this.byteAlign)
                    ) {
                      if (1 === (code1 = this.lookBits(12))) {
                        if (
                          (this.eatBits(12),
                          this.encoding > 0 && (this.lookBits(1), this.eatBits(1)),
                          this.encoding >= 0)
                        )
                          for (i = 0; i < 4; ++i)
                            (code1 = this.lookBits(12)),
                              1 !== code1 && info("bad rtc code: " + code1),
                              this.eatBits(12),
                              this.encoding > 0 && (this.lookBits(1), this.eatBits(1));
                        this.eof = !0;
                      }
                    } else if (this.err && this.eoline) {
                      for (;;) {
                        if (-1 === (code1 = this.lookBits(13))) return (this.eof = !0), null;
                        if (code1 >> 1 == 1) break;
                        this.eatBits(1);
                      }
                      this.eatBits(12), this.encoding > 0 && (this.eatBits(1), (this.nextLine2D = !(1 & code1)));
                    }
                    codingLine[0] > 0
                      ? (this.outputBits = codingLine[(this.codingPos = 0)])
                      : (this.outputBits = codingLine[(this.codingPos = 1)]),
                      this.row++;
                  }
                  var c;
                  if (this.outputBits >= 8)
                    (c = 1 & this.codingPos ? 0 : 255),
                      (this.outputBits -= 8),
                      0 === this.outputBits &&
                        codingLine[this.codingPos] < columns &&
                        (this.codingPos++,
                        (this.outputBits = codingLine[this.codingPos] - codingLine[this.codingPos - 1]));
                  else {
                    (bits = 8), (c = 0);
                    do {
                      this.outputBits > bits
                        ? ((c <<= bits),
                          1 & this.codingPos || (c |= 255 >> (8 - bits)),
                          (this.outputBits -= bits),
                          (bits = 0))
                        : ((c <<= this.outputBits),
                          1 & this.codingPos || (c |= 255 >> (8 - this.outputBits)),
                          (bits -= this.outputBits),
                          (this.outputBits = 0),
                          codingLine[this.codingPos] < columns
                            ? (this.codingPos++,
                              (this.outputBits = codingLine[this.codingPos] - codingLine[this.codingPos - 1]))
                            : bits > 0 && ((c <<= bits), (bits = 0)));
                    } while (bits);
                  }
                  return this.black && (c ^= 255), c;
                }),
                (CCITTFaxStream.prototype.findTableCode = function (start, end, table, limit) {
                  for (var limitValue = limit || 0, i = start; i <= end; ++i) {
                    var code = this.lookBits(i);
                    if (-1 === code) return [!0, 1, !1];
                    if ((i < end && (code <<= end - i), !limitValue || code >= limitValue)) {
                      var p = table[code - limitValue];
                      if (p[0] === i) return this.eatBits(i), [!0, p[1], !0];
                    }
                  }
                  return [!1, 0, !1];
                }),
                (CCITTFaxStream.prototype.getTwoDimCode = function () {
                  var p,
                    code = 0;
                  if (this.eoblock) {
                    if (((code = this.lookBits(7)), (p = twoDimTable[code]) && p[0] > 0))
                      return this.eatBits(p[0]), p[1];
                  } else {
                    var result = this.findTableCode(1, 7, twoDimTable);
                    if (result[0] && result[2]) return result[1];
                  }
                  return info("Bad two dim code"), -1;
                }),
                (CCITTFaxStream.prototype.getWhiteCode = function () {
                  var p,
                    code = 0;
                  if (this.eoblock) {
                    if (-1 === (code = this.lookBits(12))) return 1;
                    if (((p = code >> 5 == 0 ? whiteTable1[code] : whiteTable2[code >> 3]), p[0] > 0))
                      return this.eatBits(p[0]), p[1];
                  } else {
                    var result = this.findTableCode(1, 9, whiteTable2);
                    if (result[0]) return result[1];
                    if (((result = this.findTableCode(11, 12, whiteTable1)), result[0])) return result[1];
                  }
                  return info("bad white code"), this.eatBits(1), 1;
                }),
                (CCITTFaxStream.prototype.getBlackCode = function () {
                  var code, p;
                  if (this.eoblock) {
                    if (-1 === (code = this.lookBits(13))) return 1;
                    if (
                      ((p =
                        code >> 7 == 0
                          ? blackTable1[code]
                          : code >> 9 == 0 && code >> 7 != 0
                          ? blackTable2[(code >> 1) - 64]
                          : blackTable3[code >> 7]),
                      p[0] > 0)
                    )
                      return this.eatBits(p[0]), p[1];
                  } else {
                    var result = this.findTableCode(2, 6, blackTable3);
                    if (result[0]) return result[1];
                    if (((result = this.findTableCode(7, 12, blackTable2, 64)), result[0])) return result[1];
                    if (((result = this.findTableCode(10, 13, blackTable1)), result[0])) return result[1];
                  }
                  return info("bad black code"), this.eatBits(1), 1;
                }),
                (CCITTFaxStream.prototype.lookBits = function (n) {
                  for (var c; this.inputBits < n; ) {
                    if (-1 === (c = this.str.getByte()))
                      return 0 === this.inputBits ? -1 : (this.inputBuf << (n - this.inputBits)) & (65535 >> (16 - n));
                    (this.inputBuf = (this.inputBuf << 8) | c), (this.inputBits += 8);
                  }
                  return (this.inputBuf >> (this.inputBits - n)) & (65535 >> (16 - n));
                }),
                (CCITTFaxStream.prototype.eatBits = function (n) {
                  (this.inputBits -= n) < 0 && (this.inputBits = 0);
                }),
                CCITTFaxStream
              );
            })(),
            LZWStream = (function () {
              function LZWStream(str, maybeLength, earlyChange) {
                (this.str = str), (this.dict = str.dict), (this.cachedData = 0), (this.bitsCached = 0);
                for (
                  var lzwState = {
                      earlyChange: earlyChange,
                      codeLength: 9,
                      nextCode: 258,
                      dictionaryValues: new Uint8Array(4096),
                      dictionaryLengths: new Uint16Array(4096),
                      dictionaryPrevCodes: new Uint16Array(4096),
                      currentSequence: new Uint8Array(4096),
                      currentSequenceLength: 0,
                    },
                    i = 0;
                  i < 256;
                  ++i
                )
                  (lzwState.dictionaryValues[i] = i), (lzwState.dictionaryLengths[i] = 1);
                (this.lzwState = lzwState), DecodeStream.call(this, maybeLength);
              }
              return (
                (LZWStream.prototype = Object.create(DecodeStream.prototype)),
                (LZWStream.prototype.readBits = function (n) {
                  for (var bitsCached = this.bitsCached, cachedData = this.cachedData; bitsCached < n; ) {
                    var c = this.str.getByte();
                    if (-1 === c) return (this.eof = !0), null;
                    (cachedData = (cachedData << 8) | c), (bitsCached += 8);
                  }
                  return (
                    (this.bitsCached = bitsCached -= n),
                    (this.cachedData = cachedData),
                    (this.lastCode = null),
                    (cachedData >>> bitsCached) & ((1 << n) - 1)
                  );
                }),
                (LZWStream.prototype.readBlock = function () {
                  var i,
                    j,
                    q,
                    estimatedDecodedSize = 1024,
                    lzwState = this.lzwState;
                  if (lzwState) {
                    var earlyChange = lzwState.earlyChange,
                      nextCode = lzwState.nextCode,
                      dictionaryValues = lzwState.dictionaryValues,
                      dictionaryLengths = lzwState.dictionaryLengths,
                      dictionaryPrevCodes = lzwState.dictionaryPrevCodes,
                      codeLength = lzwState.codeLength,
                      prevCode = lzwState.prevCode,
                      currentSequence = lzwState.currentSequence,
                      currentSequenceLength = lzwState.currentSequenceLength,
                      decodedLength = 0,
                      currentBufferLength = this.bufferLength,
                      buffer = this.ensureBuffer(this.bufferLength + estimatedDecodedSize);
                    for (i = 0; i < 512; i++) {
                      var code = this.readBits(codeLength),
                        hasPrev = currentSequenceLength > 0;
                      if (code < 256) (currentSequence[0] = code), (currentSequenceLength = 1);
                      else {
                        if (!(code >= 258)) {
                          if (256 === code) {
                            (codeLength = 9), (nextCode = 258), (currentSequenceLength = 0);
                            continue;
                          }
                          (this.eof = !0), delete this.lzwState;
                          break;
                        }
                        if (code < nextCode)
                          for (
                            currentSequenceLength = dictionaryLengths[code], j = currentSequenceLength - 1, q = code;
                            j >= 0;
                            j--
                          )
                            (currentSequence[j] = dictionaryValues[q]), (q = dictionaryPrevCodes[q]);
                        else currentSequence[currentSequenceLength++] = currentSequence[0];
                      }
                      if (
                        (hasPrev &&
                          ((dictionaryPrevCodes[nextCode] = prevCode),
                          (dictionaryLengths[nextCode] = dictionaryLengths[prevCode] + 1),
                          (dictionaryValues[nextCode] = currentSequence[0]),
                          nextCode++,
                          (codeLength =
                            (nextCode + earlyChange) & (nextCode + earlyChange - 1)
                              ? codeLength
                              : 0 | Math.min(Math.log(nextCode + earlyChange) / 0.6931471805599453 + 1, 12))),
                        (prevCode = code),
                        (decodedLength += currentSequenceLength),
                        estimatedDecodedSize < decodedLength)
                      ) {
                        do {
                          estimatedDecodedSize += 512;
                        } while (estimatedDecodedSize < decodedLength);
                        buffer = this.ensureBuffer(this.bufferLength + estimatedDecodedSize);
                      }
                      for (j = 0; j < currentSequenceLength; j++) buffer[currentBufferLength++] = currentSequence[j];
                    }
                    (lzwState.nextCode = nextCode),
                      (lzwState.codeLength = codeLength),
                      (lzwState.prevCode = prevCode),
                      (lzwState.currentSequenceLength = currentSequenceLength),
                      (this.bufferLength = currentBufferLength);
                  }
                }),
                LZWStream
              );
            })(),
            NullStream = (function () {
              function NullStream() {
                Stream.call(this, new Uint8Array(0));
              }
              return (NullStream.prototype = Stream.prototype), NullStream;
            })();
          (exports.Ascii85Stream = Ascii85Stream),
            (exports.AsciiHexStream = AsciiHexStream),
            (exports.CCITTFaxStream = CCITTFaxStream),
            (exports.DecryptStream = DecryptStream),
            (exports.DecodeStream = DecodeStream),
            (exports.FlateStream = FlateStream),
            (exports.Jbig2Stream = Jbig2Stream),
            (exports.JpegStream = JpegStream),
            (exports.JpxStream = JpxStream),
            (exports.NullStream = NullStream),
            (exports.PredictorStream = PredictorStream),
            (exports.RunLengthStream = RunLengthStream),
            (exports.Stream = Stream),
            (exports.StreamsSequenceStream = StreamsSequenceStream),
            (exports.StringStream = StringStream),
            (exports.LZWStream = LZWStream);
        })(
          (root.pdfjsCoreStream = {}),
          root.pdfjsSharedUtil,
          root.pdfjsCorePrimitives,
          root.pdfjsCoreJbig2,
          root.pdfjsCoreJpg,
          root.pdfjsCoreJpx
        );
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, corePrimitives, coreStream) {
          var PasswordException = sharedUtil.PasswordException,
            PasswordResponses = sharedUtil.PasswordResponses,
            bytesToString = sharedUtil.bytesToString,
            error = sharedUtil.error,
            isInt = sharedUtil.isInt,
            stringToBytes = sharedUtil.stringToBytes,
            utf8StringToString = sharedUtil.utf8StringToString,
            warn = sharedUtil.warn,
            Name = corePrimitives.Name,
            isName = corePrimitives.isName,
            isDict = corePrimitives.isDict,
            DecryptStream = coreStream.DecryptStream,
            ARCFourCipher = (function () {
              function ARCFourCipher(key) {
                (this.a = 0), (this.b = 0);
                var i,
                  tmp,
                  s = new Uint8Array(256),
                  j = 0,
                  keyLength = key.length;
                for (i = 0; i < 256; ++i) s[i] = i;
                for (i = 0; i < 256; ++i)
                  (tmp = s[i]), (j = (j + tmp + key[i % keyLength]) & 255), (s[i] = s[j]), (s[j] = tmp);
                this.s = s;
              }
              return (
                (ARCFourCipher.prototype = {
                  encryptBlock: function (data) {
                    var i,
                      tmp,
                      tmp2,
                      n = data.length,
                      a = this.a,
                      b = this.b,
                      s = this.s,
                      output = new Uint8Array(n);
                    for (i = 0; i < n; ++i)
                      (a = (a + 1) & 255),
                        (tmp = s[a]),
                        (b = (b + tmp) & 255),
                        (tmp2 = s[b]),
                        (s[a] = tmp2),
                        (s[b] = tmp),
                        (output[i] = data[i] ^ s[(tmp + tmp2) & 255]);
                    return (this.a = a), (this.b = b), output;
                  },
                }),
                (ARCFourCipher.prototype.decryptBlock = ARCFourCipher.prototype.encryptBlock),
                ARCFourCipher
              );
            })(),
            calculateMD5 = (function () {
              function hash(data, offset, length) {
                var i,
                  j,
                  n,
                  h0 = 1732584193,
                  h1 = -271733879,
                  h2 = -1732584194,
                  h3 = 271733878,
                  paddedLength = (length + 72) & -64,
                  padded = new Uint8Array(paddedLength);
                for (i = 0; i < length; ++i) padded[i] = data[offset++];
                for (padded[i++] = 128, n = paddedLength - 8; i < n; ) padded[i++] = 0;
                (padded[i++] = (length << 3) & 255),
                  (padded[i++] = (length >> 5) & 255),
                  (padded[i++] = (length >> 13) & 255),
                  (padded[i++] = (length >> 21) & 255),
                  (padded[i++] = (length >>> 29) & 255),
                  (padded[i++] = 0),
                  (padded[i++] = 0),
                  (padded[i++] = 0);
                var w = new Int32Array(16);
                for (i = 0; i < paddedLength; ) {
                  for (j = 0; j < 16; ++j, i += 4)
                    w[j] = padded[i] | (padded[i + 1] << 8) | (padded[i + 2] << 16) | (padded[i + 3] << 24);
                  var f,
                    g,
                    a = h0,
                    b = h1,
                    c = h2,
                    d = h3;
                  for (j = 0; j < 64; ++j) {
                    j < 16
                      ? ((f = (b & c) | (~b & d)), (g = j))
                      : j < 32
                      ? ((f = (d & b) | (~d & c)), (g = (5 * j + 1) & 15))
                      : j < 48
                      ? ((f = b ^ c ^ d), (g = (3 * j + 5) & 15))
                      : ((f = c ^ (b | ~d)), (g = (7 * j) & 15));
                    var tmp = d,
                      rotateArg = (a + f + k[j] + w[g]) | 0,
                      rotate = r[j];
                    (d = c),
                      (c = b),
                      (b = (b + ((rotateArg << rotate) | (rotateArg >>> (32 - rotate)))) | 0),
                      (a = tmp);
                  }
                  (h0 = (h0 + a) | 0), (h1 = (h1 + b) | 0), (h2 = (h2 + c) | 0), (h3 = (h3 + d) | 0);
                }
                return new Uint8Array([
                  255 & h0,
                  (h0 >> 8) & 255,
                  (h0 >> 16) & 255,
                  (h0 >>> 24) & 255,
                  255 & h1,
                  (h1 >> 8) & 255,
                  (h1 >> 16) & 255,
                  (h1 >>> 24) & 255,
                  255 & h2,
                  (h2 >> 8) & 255,
                  (h2 >> 16) & 255,
                  (h2 >>> 24) & 255,
                  255 & h3,
                  (h3 >> 8) & 255,
                  (h3 >> 16) & 255,
                  (h3 >>> 24) & 255,
                ]);
              }
              var r = new Uint8Array([
                  7,
                  12,
                  17,
                  22,
                  7,
                  12,
                  17,
                  22,
                  7,
                  12,
                  17,
                  22,
                  7,
                  12,
                  17,
                  22,
                  5,
                  9,
                  14,
                  20,
                  5,
                  9,
                  14,
                  20,
                  5,
                  9,
                  14,
                  20,
                  5,
                  9,
                  14,
                  20,
                  4,
                  11,
                  16,
                  23,
                  4,
                  11,
                  16,
                  23,
                  4,
                  11,
                  16,
                  23,
                  4,
                  11,
                  16,
                  23,
                  6,
                  10,
                  15,
                  21,
                  6,
                  10,
                  15,
                  21,
                  6,
                  10,
                  15,
                  21,
                  6,
                  10,
                  15,
                  21,
                ]),
                k = new Int32Array([
                  -680876936,
                  -389564586,
                  606105819,
                  -1044525330,
                  -176418897,
                  1200080426,
                  -1473231341,
                  -45705983,
                  1770035416,
                  -1958414417,
                  -42063,
                  -1990404162,
                  1804603682,
                  -40341101,
                  -1502002290,
                  1236535329,
                  -165796510,
                  -1069501632,
                  643717713,
                  -373897302,
                  -701558691,
                  38016083,
                  -660478335,
                  -405537848,
                  568446438,
                  -1019803690,
                  -187363961,
                  1163531501,
                  -1444681467,
                  -51403784,
                  1735328473,
                  -1926607734,
                  -378558,
                  -2022574463,
                  1839030562,
                  -35309556,
                  -1530992060,
                  1272893353,
                  -155497632,
                  -1094730640,
                  681279174,
                  -358537222,
                  -722521979,
                  76029189,
                  -640364487,
                  -421815835,
                  530742520,
                  -995338651,
                  -198630844,
                  1126891415,
                  -1416354905,
                  -57434055,
                  1700485571,
                  -1894986606,
                  -1051523,
                  -2054922799,
                  1873313359,
                  -30611744,
                  -1560198380,
                  1309151649,
                  -145523070,
                  -1120210379,
                  718787259,
                  -343485551,
                ]);
              return hash;
            })(),
            Word64 = (function () {
              function Word64(highInteger, lowInteger) {
                (this.high = 0 | highInteger), (this.low = 0 | lowInteger);
              }
              return (
                (Word64.prototype = {
                  and: function (word) {
                    (this.high &= word.high), (this.low &= word.low);
                  },
                  xor: function (word) {
                    (this.high ^= word.high), (this.low ^= word.low);
                  },
                  or: function (word) {
                    (this.high |= word.high), (this.low |= word.low);
                  },
                  shiftRight: function (places) {
                    places >= 32
                      ? ((this.low = (this.high >>> (places - 32)) | 0), (this.high = 0))
                      : ((this.low = (this.low >>> places) | (this.high << (32 - places))),
                        (this.high = (this.high >>> places) | 0));
                  },
                  shiftLeft: function (places) {
                    places >= 32
                      ? ((this.high = this.low << (places - 32)), (this.low = 0))
                      : ((this.high = (this.high << places) | (this.low >>> (32 - places))),
                        (this.low = this.low << places));
                  },
                  rotateRight: function (places) {
                    var low, high;
                    32 & places ? ((high = this.low), (low = this.high)) : ((low = this.low), (high = this.high)),
                      (places &= 31),
                      (this.low = (low >>> places) | (high << (32 - places))),
                      (this.high = (high >>> places) | (low << (32 - places)));
                  },
                  not: function () {
                    (this.high = ~this.high), (this.low = ~this.low);
                  },
                  add: function (word) {
                    var lowAdd = (this.low >>> 0) + (word.low >>> 0),
                      highAdd = (this.high >>> 0) + (word.high >>> 0);
                    lowAdd > 4294967295 && (highAdd += 1), (this.low = 0 | lowAdd), (this.high = 0 | highAdd);
                  },
                  copyTo: function (bytes, offset) {
                    (bytes[offset] = (this.high >>> 24) & 255),
                      (bytes[offset + 1] = (this.high >> 16) & 255),
                      (bytes[offset + 2] = (this.high >> 8) & 255),
                      (bytes[offset + 3] = 255 & this.high),
                      (bytes[offset + 4] = (this.low >>> 24) & 255),
                      (bytes[offset + 5] = (this.low >> 16) & 255),
                      (bytes[offset + 6] = (this.low >> 8) & 255),
                      (bytes[offset + 7] = 255 & this.low);
                  },
                  assign: function (word) {
                    (this.high = word.high), (this.low = word.low);
                  },
                }),
                Word64
              );
            })(),
            calculateSHA256 = (function () {
              function rotr(x, n) {
                return (x >>> n) | (x << (32 - n));
              }
              function ch(x, y, z) {
                return (x & y) ^ (~x & z);
              }
              function maj(x, y, z) {
                return (x & y) ^ (x & z) ^ (y & z);
              }
              function sigma(x) {
                return rotr(x, 2) ^ rotr(x, 13) ^ rotr(x, 22);
              }
              function sigmaPrime(x) {
                return rotr(x, 6) ^ rotr(x, 11) ^ rotr(x, 25);
              }
              function littleSigma(x) {
                return rotr(x, 7) ^ rotr(x, 18) ^ (x >>> 3);
              }
              function littleSigmaPrime(x) {
                return rotr(x, 17) ^ rotr(x, 19) ^ (x >>> 10);
              }
              function hash(data, offset, length) {
                var i,
                  j,
                  n,
                  h0 = 1779033703,
                  h1 = 3144134277,
                  h2 = 1013904242,
                  h3 = 2773480762,
                  h4 = 1359893119,
                  h5 = 2600822924,
                  h6 = 528734635,
                  h7 = 1541459225,
                  paddedLength = 64 * Math.ceil((length + 9) / 64),
                  padded = new Uint8Array(paddedLength);
                for (i = 0; i < length; ++i) padded[i] = data[offset++];
                for (padded[i++] = 128, n = paddedLength - 8; i < n; ) padded[i++] = 0;
                (padded[i++] = 0),
                  (padded[i++] = 0),
                  (padded[i++] = 0),
                  (padded[i++] = (length >>> 29) & 255),
                  (padded[i++] = (length >> 21) & 255),
                  (padded[i++] = (length >> 13) & 255),
                  (padded[i++] = (length >> 5) & 255),
                  (padded[i++] = (length << 3) & 255);
                var w = new Uint32Array(64);
                for (i = 0; i < paddedLength; ) {
                  for (j = 0; j < 16; ++j)
                    (w[j] = (padded[i] << 24) | (padded[i + 1] << 16) | (padded[i + 2] << 8) | padded[i + 3]), (i += 4);
                  for (j = 16; j < 64; ++j)
                    w[j] = (littleSigmaPrime(w[j - 2]) + w[j - 7] + littleSigma(w[j - 15]) + w[j - 16]) | 0;
                  var t1,
                    t2,
                    a = h0,
                    b = h1,
                    c = h2,
                    d = h3,
                    e = h4,
                    f = h5,
                    g = h6,
                    h = h7;
                  for (j = 0; j < 64; ++j)
                    (t1 = h + sigmaPrime(e) + ch(e, f, g) + k[j] + w[j]),
                      (t2 = sigma(a) + maj(a, b, c)),
                      (h = g),
                      (g = f),
                      (f = e),
                      (e = (d + t1) | 0),
                      (d = c),
                      (c = b),
                      (b = a),
                      (a = (t1 + t2) | 0);
                  (h0 = (h0 + a) | 0),
                    (h1 = (h1 + b) | 0),
                    (h2 = (h2 + c) | 0),
                    (h3 = (h3 + d) | 0),
                    (h4 = (h4 + e) | 0),
                    (h5 = (h5 + f) | 0),
                    (h6 = (h6 + g) | 0),
                    (h7 = (h7 + h) | 0);
                }
                return new Uint8Array([
                  (h0 >> 24) & 255,
                  (h0 >> 16) & 255,
                  (h0 >> 8) & 255,
                  255 & h0,
                  (h1 >> 24) & 255,
                  (h1 >> 16) & 255,
                  (h1 >> 8) & 255,
                  255 & h1,
                  (h2 >> 24) & 255,
                  (h2 >> 16) & 255,
                  (h2 >> 8) & 255,
                  255 & h2,
                  (h3 >> 24) & 255,
                  (h3 >> 16) & 255,
                  (h3 >> 8) & 255,
                  255 & h3,
                  (h4 >> 24) & 255,
                  (h4 >> 16) & 255,
                  (h4 >> 8) & 255,
                  255 & h4,
                  (h5 >> 24) & 255,
                  (h5 >> 16) & 255,
                  (h5 >> 8) & 255,
                  255 & h5,
                  (h6 >> 24) & 255,
                  (h6 >> 16) & 255,
                  (h6 >> 8) & 255,
                  255 & h6,
                  (h7 >> 24) & 255,
                  (h7 >> 16) & 255,
                  (h7 >> 8) & 255,
                  255 & h7,
                ]);
              }
              var k = [
                1116352408,
                1899447441,
                3049323471,
                3921009573,
                961987163,
                1508970993,
                2453635748,
                2870763221,
                3624381080,
                310598401,
                607225278,
                1426881987,
                1925078388,
                2162078206,
                2614888103,
                3248222580,
                3835390401,
                4022224774,
                264347078,
                604807628,
                770255983,
                1249150122,
                1555081692,
                1996064986,
                2554220882,
                2821834349,
                2952996808,
                3210313671,
                3336571891,
                3584528711,
                113926993,
                338241895,
                666307205,
                773529912,
                1294757372,
                1396182291,
                1695183700,
                1986661051,
                2177026350,
                2456956037,
                2730485921,
                2820302411,
                3259730800,
                3345764771,
                3516065817,
                3600352804,
                4094571909,
                275423344,
                430227734,
                506948616,
                659060556,
                883997877,
                958139571,
                1322822218,
                1537002063,
                1747873779,
                1955562222,
                2024104815,
                2227730452,
                2361852424,
                2428436474,
                2756734187,
                3204031479,
                3329325298,
              ];
              return hash;
            })(),
            calculateSHA512 = (function () {
              function ch(result, x, y, z, tmp) {
                result.assign(x), result.and(y), tmp.assign(x), tmp.not(), tmp.and(z), result.xor(tmp);
              }
              function maj(result, x, y, z, tmp) {
                result.assign(x),
                  result.and(y),
                  tmp.assign(x),
                  tmp.and(z),
                  result.xor(tmp),
                  tmp.assign(y),
                  tmp.and(z),
                  result.xor(tmp);
              }
              function sigma(result, x, tmp) {
                result.assign(x),
                  result.rotateRight(28),
                  tmp.assign(x),
                  tmp.rotateRight(34),
                  result.xor(tmp),
                  tmp.assign(x),
                  tmp.rotateRight(39),
                  result.xor(tmp);
              }
              function sigmaPrime(result, x, tmp) {
                result.assign(x),
                  result.rotateRight(14),
                  tmp.assign(x),
                  tmp.rotateRight(18),
                  result.xor(tmp),
                  tmp.assign(x),
                  tmp.rotateRight(41),
                  result.xor(tmp);
              }
              function littleSigma(result, x, tmp) {
                result.assign(x),
                  result.rotateRight(1),
                  tmp.assign(x),
                  tmp.rotateRight(8),
                  result.xor(tmp),
                  tmp.assign(x),
                  tmp.shiftRight(7),
                  result.xor(tmp);
              }
              function littleSigmaPrime(result, x, tmp) {
                result.assign(x),
                  result.rotateRight(19),
                  tmp.assign(x),
                  tmp.rotateRight(61),
                  result.xor(tmp),
                  tmp.assign(x),
                  tmp.shiftRight(6),
                  result.xor(tmp);
              }
              function hash(data, offset, length, mode384) {
                mode384 = !!mode384;
                var h0, h1, h2, h3, h4, h5, h6, h7;
                mode384
                  ? ((h0 = new Word64(3418070365, 3238371032)),
                    (h1 = new Word64(1654270250, 914150663)),
                    (h2 = new Word64(2438529370, 812702999)),
                    (h3 = new Word64(355462360, 4144912697)),
                    (h4 = new Word64(1731405415, 4290775857)),
                    (h5 = new Word64(2394180231, 1750603025)),
                    (h6 = new Word64(3675008525, 1694076839)),
                    (h7 = new Word64(1203062813, 3204075428)))
                  : ((h0 = new Word64(1779033703, 4089235720)),
                    (h1 = new Word64(3144134277, 2227873595)),
                    (h2 = new Word64(1013904242, 4271175723)),
                    (h3 = new Word64(2773480762, 1595750129)),
                    (h4 = new Word64(1359893119, 2917565137)),
                    (h5 = new Word64(2600822924, 725511199)),
                    (h6 = new Word64(528734635, 4215389547)),
                    (h7 = new Word64(1541459225, 327033209)));
                var i,
                  j,
                  n,
                  paddedLength = 128 * Math.ceil((length + 17) / 128),
                  padded = new Uint8Array(paddedLength);
                for (i = 0; i < length; ++i) padded[i] = data[offset++];
                for (padded[i++] = 128, n = paddedLength - 16; i < n; ) padded[i++] = 0;
                (padded[i++] = 0),
                  (padded[i++] = 0),
                  (padded[i++] = 0),
                  (padded[i++] = 0),
                  (padded[i++] = 0),
                  (padded[i++] = 0),
                  (padded[i++] = 0),
                  (padded[i++] = 0),
                  (padded[i++] = 0),
                  (padded[i++] = 0),
                  (padded[i++] = 0),
                  (padded[i++] = (length >>> 29) & 255),
                  (padded[i++] = (length >> 21) & 255),
                  (padded[i++] = (length >> 13) & 255),
                  (padded[i++] = (length >> 5) & 255),
                  (padded[i++] = (length << 3) & 255);
                var w = new Array(80);
                for (i = 0; i < 80; i++) w[i] = new Word64(0, 0);
                var tmp3,
                  a = new Word64(0, 0),
                  b = new Word64(0, 0),
                  c = new Word64(0, 0),
                  d = new Word64(0, 0),
                  e = new Word64(0, 0),
                  f = new Word64(0, 0),
                  g = new Word64(0, 0),
                  h = new Word64(0, 0),
                  t1 = new Word64(0, 0),
                  t2 = new Word64(0, 0),
                  tmp1 = new Word64(0, 0),
                  tmp2 = new Word64(0, 0);
                for (i = 0; i < paddedLength; ) {
                  for (j = 0; j < 16; ++j)
                    (w[j].high = (padded[i] << 24) | (padded[i + 1] << 16) | (padded[i + 2] << 8) | padded[i + 3]),
                      (w[j].low = (padded[i + 4] << 24) | (padded[i + 5] << 16) | (padded[i + 6] << 8) | padded[i + 7]),
                      (i += 8);
                  for (j = 16; j < 80; ++j)
                    (tmp3 = w[j]),
                      littleSigmaPrime(tmp3, w[j - 2], tmp2),
                      tmp3.add(w[j - 7]),
                      littleSigma(tmp1, w[j - 15], tmp2),
                      tmp3.add(tmp1),
                      tmp3.add(w[j - 16]);
                  for (
                    a.assign(h0),
                      b.assign(h1),
                      c.assign(h2),
                      d.assign(h3),
                      e.assign(h4),
                      f.assign(h5),
                      g.assign(h6),
                      h.assign(h7),
                      j = 0;
                    j < 80;
                    ++j
                  )
                    t1.assign(h),
                      sigmaPrime(tmp1, e, tmp2),
                      t1.add(tmp1),
                      ch(tmp1, e, f, g, tmp2),
                      t1.add(tmp1),
                      t1.add(k[j]),
                      t1.add(w[j]),
                      sigma(t2, a, tmp2),
                      maj(tmp1, a, b, c, tmp2),
                      t2.add(tmp1),
                      (tmp3 = h),
                      (h = g),
                      (g = f),
                      (f = e),
                      d.add(t1),
                      (e = d),
                      (d = c),
                      (c = b),
                      (b = a),
                      tmp3.assign(t1),
                      tmp3.add(t2),
                      (a = tmp3);
                  h0.add(a), h1.add(b), h2.add(c), h3.add(d), h4.add(e), h5.add(f), h6.add(g), h7.add(h);
                }
                var result;
                return (
                  mode384
                    ? ((result = new Uint8Array(48)),
                      h0.copyTo(result, 0),
                      h1.copyTo(result, 8),
                      h2.copyTo(result, 16),
                      h3.copyTo(result, 24),
                      h4.copyTo(result, 32),
                      h5.copyTo(result, 40))
                    : ((result = new Uint8Array(64)),
                      h0.copyTo(result, 0),
                      h1.copyTo(result, 8),
                      h2.copyTo(result, 16),
                      h3.copyTo(result, 24),
                      h4.copyTo(result, 32),
                      h5.copyTo(result, 40),
                      h6.copyTo(result, 48),
                      h7.copyTo(result, 56)),
                  result
                );
              }
              var k = [
                new Word64(1116352408, 3609767458),
                new Word64(1899447441, 602891725),
                new Word64(3049323471, 3964484399),
                new Word64(3921009573, 2173295548),
                new Word64(961987163, 4081628472),
                new Word64(1508970993, 3053834265),
                new Word64(2453635748, 2937671579),
                new Word64(2870763221, 3664609560),
                new Word64(3624381080, 2734883394),
                new Word64(310598401, 1164996542),
                new Word64(607225278, 1323610764),
                new Word64(1426881987, 3590304994),
                new Word64(1925078388, 4068182383),
                new Word64(2162078206, 991336113),
                new Word64(2614888103, 633803317),
                new Word64(3248222580, 3479774868),
                new Word64(3835390401, 2666613458),
                new Word64(4022224774, 944711139),
                new Word64(264347078, 2341262773),
                new Word64(604807628, 2007800933),
                new Word64(770255983, 1495990901),
                new Word64(1249150122, 1856431235),
                new Word64(1555081692, 3175218132),
                new Word64(1996064986, 2198950837),
                new Word64(2554220882, 3999719339),
                new Word64(2821834349, 766784016),
                new Word64(2952996808, 2566594879),
                new Word64(3210313671, 3203337956),
                new Word64(3336571891, 1034457026),
                new Word64(3584528711, 2466948901),
                new Word64(113926993, 3758326383),
                new Word64(338241895, 168717936),
                new Word64(666307205, 1188179964),
                new Word64(773529912, 1546045734),
                new Word64(1294757372, 1522805485),
                new Word64(1396182291, 2643833823),
                new Word64(1695183700, 2343527390),
                new Word64(1986661051, 1014477480),
                new Word64(2177026350, 1206759142),
                new Word64(2456956037, 344077627),
                new Word64(2730485921, 1290863460),
                new Word64(2820302411, 3158454273),
                new Word64(3259730800, 3505952657),
                new Word64(3345764771, 106217008),
                new Word64(3516065817, 3606008344),
                new Word64(3600352804, 1432725776),
                new Word64(4094571909, 1467031594),
                new Word64(275423344, 851169720),
                new Word64(430227734, 3100823752),
                new Word64(506948616, 1363258195),
                new Word64(659060556, 3750685593),
                new Word64(883997877, 3785050280),
                new Word64(958139571, 3318307427),
                new Word64(1322822218, 3812723403),
                new Word64(1537002063, 2003034995),
                new Word64(1747873779, 3602036899),
                new Word64(1955562222, 1575990012),
                new Word64(2024104815, 1125592928),
                new Word64(2227730452, 2716904306),
                new Word64(2361852424, 442776044),
                new Word64(2428436474, 593698344),
                new Word64(2756734187, 3733110249),
                new Word64(3204031479, 2999351573),
                new Word64(3329325298, 3815920427),
                new Word64(3391569614, 3928383900),
                new Word64(3515267271, 566280711),
                new Word64(3940187606, 3454069534),
                new Word64(4118630271, 4000239992),
                new Word64(116418474, 1914138554),
                new Word64(174292421, 2731055270),
                new Word64(289380356, 3203993006),
                new Word64(460393269, 320620315),
                new Word64(685471733, 587496836),
                new Word64(852142971, 1086792851),
                new Word64(1017036298, 365543100),
                new Word64(1126000580, 2618297676),
                new Word64(1288033470, 3409855158),
                new Word64(1501505948, 4234509866),
                new Word64(1607167915, 987167468),
                new Word64(1816402316, 1246189591),
              ];
              return hash;
            })(),
            calculateSHA384 = (function () {
              function hash(data, offset, length) {
                return calculateSHA512(data, offset, length, !0);
              }
              return hash;
            })(),
            NullCipher = (function () {
              function NullCipher() {}
              return (
                (NullCipher.prototype = {
                  decryptBlock: function (data) {
                    return data;
                  },
                }),
                NullCipher
              );
            })(),
            AES128Cipher = (function () {
              function expandKey128(cipherKey) {
                var result = new Uint8Array(176);
                result.set(cipherKey);
                for (var j = 16, i = 1; j < 176; ++i) {
                  var t1 = result[j - 3],
                    t2 = result[j - 2],
                    t3 = result[j - 1],
                    t4 = result[j - 4];
                  (t1 = s[t1]), (t2 = s[t2]), (t3 = s[t3]), (t4 = s[t4]), (t1 ^= rcon[i]);
                  for (var n = 0; n < 4; ++n)
                    (result[j] = t1 ^= result[j - 16]),
                      j++,
                      (result[j] = t2 ^= result[j - 16]),
                      j++,
                      (result[j] = t3 ^= result[j - 16]),
                      j++,
                      (result[j] = t4 ^= result[j - 16]),
                      j++;
                }
                return result;
              }
              function decrypt128(input, key) {
                var state = new Uint8Array(16);
                state.set(input);
                var i, j, k, t, u, v;
                for (j = 0, k = 160; j < 16; ++j, ++k) state[j] ^= key[k];
                for (i = 9; i >= 1; --i) {
                  for (
                    t = state[13],
                      state[13] = state[9],
                      state[9] = state[5],
                      state[5] = state[1],
                      state[1] = t,
                      t = state[14],
                      u = state[10],
                      state[14] = state[6],
                      state[10] = state[2],
                      state[6] = t,
                      state[2] = u,
                      t = state[15],
                      u = state[11],
                      v = state[7],
                      state[15] = state[3],
                      state[11] = t,
                      state[7] = u,
                      state[3] = v,
                      j = 0;
                    j < 16;
                    ++j
                  )
                    state[j] = inv_s[state[j]];
                  for (j = 0, k = 16 * i; j < 16; ++j, ++k) state[j] ^= key[k];
                  for (j = 0; j < 16; j += 4) {
                    var s0 = mix[state[j]],
                      s1 = mix[state[j + 1]],
                      s2 = mix[state[j + 2]],
                      s3 = mix[state[j + 3]];
                    (t = s0 ^ (s1 >>> 8) ^ (s1 << 24) ^ (s2 >>> 16) ^ (s2 << 16) ^ (s3 >>> 24) ^ (s3 << 8)),
                      (state[j] = (t >>> 24) & 255),
                      (state[j + 1] = (t >> 16) & 255),
                      (state[j + 2] = (t >> 8) & 255),
                      (state[j + 3] = 255 & t);
                  }
                }
                for (
                  t = state[13],
                    state[13] = state[9],
                    state[9] = state[5],
                    state[5] = state[1],
                    state[1] = t,
                    t = state[14],
                    u = state[10],
                    state[14] = state[6],
                    state[10] = state[2],
                    state[6] = t,
                    state[2] = u,
                    t = state[15],
                    u = state[11],
                    v = state[7],
                    state[15] = state[3],
                    state[11] = t,
                    state[7] = u,
                    state[3] = v,
                    j = 0;
                  j < 16;
                  ++j
                )
                  (state[j] = inv_s[state[j]]), (state[j] ^= key[j]);
                return state;
              }
              function encrypt128(input, key) {
                var t,
                  u,
                  v,
                  k,
                  state = new Uint8Array(16);
                for (state.set(input), j = 0; j < 16; ++j) state[j] ^= key[j];
                for (i = 1; i < 10; i++) {
                  for (j = 0; j < 16; ++j) state[j] = s[state[j]];
                  (v = state[1]),
                    (state[1] = state[5]),
                    (state[5] = state[9]),
                    (state[9] = state[13]),
                    (state[13] = v),
                    (v = state[2]),
                    (u = state[6]),
                    (state[2] = state[10]),
                    (state[6] = state[14]),
                    (state[10] = v),
                    (state[14] = u),
                    (v = state[3]),
                    (u = state[7]),
                    (t = state[11]),
                    (state[3] = state[15]),
                    (state[7] = v),
                    (state[11] = u),
                    (state[15] = t);
                  for (var j = 0; j < 16; j += 4) {
                    var s0 = state[j + 0],
                      s1 = state[j + 1],
                      s2 = state[j + 2],
                      s3 = state[j + 3];
                    (t = s0 ^ s1 ^ s2 ^ s3),
                      (state[j + 0] ^= t ^ mixCol[s0 ^ s1]),
                      (state[j + 1] ^= t ^ mixCol[s1 ^ s2]),
                      (state[j + 2] ^= t ^ mixCol[s2 ^ s3]),
                      (state[j + 3] ^= t ^ mixCol[s3 ^ s0]);
                  }
                  for (j = 0, k = 16 * i; j < 16; ++j, ++k) state[j] ^= key[k];
                }
                for (j = 0; j < 16; ++j) state[j] = s[state[j]];
                for (
                  v = state[1],
                    state[1] = state[5],
                    state[5] = state[9],
                    state[9] = state[13],
                    state[13] = v,
                    v = state[2],
                    u = state[6],
                    state[2] = state[10],
                    state[6] = state[14],
                    state[10] = v,
                    state[14] = u,
                    v = state[3],
                    u = state[7],
                    t = state[11],
                    state[3] = state[15],
                    state[7] = v,
                    state[11] = u,
                    state[15] = t,
                    j = 0,
                    k = 160;
                  j < 16;
                  ++j, ++k
                )
                  state[j] ^= key[k];
                return state;
              }
              function AES128Cipher(key) {
                (this.key = expandKey128(key)), (this.buffer = new Uint8Array(16)), (this.bufferPosition = 0);
              }
              function decryptBlock2(data, finalize) {
                var i,
                  j,
                  ii,
                  sourceLength = data.length,
                  buffer = this.buffer,
                  bufferLength = this.bufferPosition,
                  result = [],
                  iv = this.iv;
                for (i = 0; i < sourceLength; ++i)
                  if (((buffer[bufferLength] = data[i]), !(++bufferLength < 16))) {
                    var plain = decrypt128(buffer, this.key);
                    for (j = 0; j < 16; ++j) plain[j] ^= iv[j];
                    (iv = buffer), result.push(plain), (buffer = new Uint8Array(16)), (bufferLength = 0);
                  }
                if (((this.buffer = buffer), (this.bufferLength = bufferLength), (this.iv = iv), 0 === result.length))
                  return new Uint8Array([]);
                var outputLength = 16 * result.length;
                if (finalize) {
                  var lastBlock = result[result.length - 1],
                    psLen = lastBlock[15];
                  if (psLen <= 16) {
                    for (i = 15, ii = 16 - psLen; i >= ii; --i)
                      if (lastBlock[i] !== psLen) {
                        psLen = 0;
                        break;
                      }
                    (outputLength -= psLen), (result[result.length - 1] = lastBlock.subarray(0, 16 - psLen));
                  }
                }
                var output = new Uint8Array(outputLength);
                for (i = 0, j = 0, ii = result.length; i < ii; ++i, j += 16) output.set(result[i], j);
                return output;
              }
              for (
                var rcon = new Uint8Array([
                    141,
                    1,
                    2,
                    4,
                    8,
                    16,
                    32,
                    64,
                    128,
                    27,
                    54,
                    108,
                    216,
                    171,
                    77,
                    154,
                    47,
                    94,
                    188,
                    99,
                    198,
                    151,
                    53,
                    106,
                    212,
                    179,
                    125,
                    250,
                    239,
                    197,
                    145,
                    57,
                    114,
                    228,
                    211,
                    189,
                    97,
                    194,
                    159,
                    37,
                    74,
                    148,
                    51,
                    102,
                    204,
                    131,
                    29,
                    58,
                    116,
                    232,
                    203,
                    141,
                    1,
                    2,
                    4,
                    8,
                    16,
                    32,
                    64,
                    128,
                    27,
                    54,
                    108,
                    216,
                    171,
                    77,
                    154,
                    47,
                    94,
                    188,
                    99,
                    198,
                    151,
                    53,
                    106,
                    212,
                    179,
                    125,
                    250,
                    239,
                    197,
                    145,
                    57,
                    114,
                    228,
                    211,
                    189,
                    97,
                    194,
                    159,
                    37,
                    74,
                    148,
                    51,
                    102,
                    204,
                    131,
                    29,
                    58,
                    116,
                    232,
                    203,
                    141,
                    1,
                    2,
                    4,
                    8,
                    16,
                    32,
                    64,
                    128,
                    27,
                    54,
                    108,
                    216,
                    171,
                    77,
                    154,
                    47,
                    94,
                    188,
                    99,
                    198,
                    151,
                    53,
                    106,
                    212,
                    179,
                    125,
                    250,
                    239,
                    197,
                    145,
                    57,
                    114,
                    228,
                    211,
                    189,
                    97,
                    194,
                    159,
                    37,
                    74,
                    148,
                    51,
                    102,
                    204,
                    131,
                    29,
                    58,
                    116,
                    232,
                    203,
                    141,
                    1,
                    2,
                    4,
                    8,
                    16,
                    32,
                    64,
                    128,
                    27,
                    54,
                    108,
                    216,
                    171,
                    77,
                    154,
                    47,
                    94,
                    188,
                    99,
                    198,
                    151,
                    53,
                    106,
                    212,
                    179,
                    125,
                    250,
                    239,
                    197,
                    145,
                    57,
                    114,
                    228,
                    211,
                    189,
                    97,
                    194,
                    159,
                    37,
                    74,
                    148,
                    51,
                    102,
                    204,
                    131,
                    29,
                    58,
                    116,
                    232,
                    203,
                    141,
                    1,
                    2,
                    4,
                    8,
                    16,
                    32,
                    64,
                    128,
                    27,
                    54,
                    108,
                    216,
                    171,
                    77,
                    154,
                    47,
                    94,
                    188,
                    99,
                    198,
                    151,
                    53,
                    106,
                    212,
                    179,
                    125,
                    250,
                    239,
                    197,
                    145,
                    57,
                    114,
                    228,
                    211,
                    189,
                    97,
                    194,
                    159,
                    37,
                    74,
                    148,
                    51,
                    102,
                    204,
                    131,
                    29,
                    58,
                    116,
                    232,
                    203,
                    141,
                  ]),
                  s = new Uint8Array([
                    99,
                    124,
                    119,
                    123,
                    242,
                    107,
                    111,
                    197,
                    48,
                    1,
                    103,
                    43,
                    254,
                    215,
                    171,
                    118,
                    202,
                    130,
                    201,
                    125,
                    250,
                    89,
                    71,
                    240,
                    173,
                    212,
                    162,
                    175,
                    156,
                    164,
                    114,
                    192,
                    183,
                    253,
                    147,
                    38,
                    54,
                    63,
                    247,
                    204,
                    52,
                    165,
                    229,
                    241,
                    113,
                    216,
                    49,
                    21,
                    4,
                    199,
                    35,
                    195,
                    24,
                    150,
                    5,
                    154,
                    7,
                    18,
                    128,
                    226,
                    235,
                    39,
                    178,
                    117,
                    9,
                    131,
                    44,
                    26,
                    27,
                    110,
                    90,
                    160,
                    82,
                    59,
                    214,
                    179,
                    41,
                    227,
                    47,
                    132,
                    83,
                    209,
                    0,
                    237,
                    32,
                    252,
                    177,
                    91,
                    106,
                    203,
                    190,
                    57,
                    74,
                    76,
                    88,
                    207,
                    208,
                    239,
                    170,
                    251,
                    67,
                    77,
                    51,
                    133,
                    69,
                    249,
                    2,
                    127,
                    80,
                    60,
                    159,
                    168,
                    81,
                    163,
                    64,
                    143,
                    146,
                    157,
                    56,
                    245,
                    188,
                    182,
                    218,
                    33,
                    16,
                    255,
                    243,
                    210,
                    205,
                    12,
                    19,
                    236,
                    95,
                    151,
                    68,
                    23,
                    196,
                    167,
                    126,
                    61,
                    100,
                    93,
                    25,
                    115,
                    96,
                    129,
                    79,
                    220,
                    34,
                    42,
                    144,
                    136,
                    70,
                    238,
                    184,
                    20,
                    222,
                    94,
                    11,
                    219,
                    224,
                    50,
                    58,
                    10,
                    73,
                    6,
                    36,
                    92,
                    194,
                    211,
                    172,
                    98,
                    145,
                    149,
                    228,
                    121,
                    231,
                    200,
                    55,
                    109,
                    141,
                    213,
                    78,
                    169,
                    108,
                    86,
                    244,
                    234,
                    101,
                    122,
                    174,
                    8,
                    186,
                    120,
                    37,
                    46,
                    28,
                    166,
                    180,
                    198,
                    232,
                    221,
                    116,
                    31,
                    75,
                    189,
                    139,
                    138,
                    112,
                    62,
                    181,
                    102,
                    72,
                    3,
                    246,
                    14,
                    97,
                    53,
                    87,
                    185,
                    134,
                    193,
                    29,
                    158,
                    225,
                    248,
                    152,
                    17,
                    105,
                    217,
                    142,
                    148,
                    155,
                    30,
                    135,
                    233,
                    206,
                    85,
                    40,
                    223,
                    140,
                    161,
                    137,
                    13,
                    191,
                    230,
                    66,
                    104,
                    65,
                    153,
                    45,
                    15,
                    176,
                    84,
                    187,
                    22,
                  ]),
                  inv_s = new Uint8Array([
                    82,
                    9,
                    106,
                    213,
                    48,
                    54,
                    165,
                    56,
                    191,
                    64,
                    163,
                    158,
                    129,
                    243,
                    215,
                    251,
                    124,
                    227,
                    57,
                    130,
                    155,
                    47,
                    255,
                    135,
                    52,
                    142,
                    67,
                    68,
                    196,
                    222,
                    233,
                    203,
                    84,
                    123,
                    148,
                    50,
                    166,
                    194,
                    35,
                    61,
                    238,
                    76,
                    149,
                    11,
                    66,
                    250,
                    195,
                    78,
                    8,
                    46,
                    161,
                    102,
                    40,
                    217,
                    36,
                    178,
                    118,
                    91,
                    162,
                    73,
                    109,
                    139,
                    209,
                    37,
                    114,
                    248,
                    246,
                    100,
                    134,
                    104,
                    152,
                    22,
                    212,
                    164,
                    92,
                    204,
                    93,
                    101,
                    182,
                    146,
                    108,
                    112,
                    72,
                    80,
                    253,
                    237,
                    185,
                    218,
                    94,
                    21,
                    70,
                    87,
                    167,
                    141,
                    157,
                    132,
                    144,
                    216,
                    171,
                    0,
                    140,
                    188,
                    211,
                    10,
                    247,
                    228,
                    88,
                    5,
                    184,
                    179,
                    69,
                    6,
                    208,
                    44,
                    30,
                    143,
                    202,
                    63,
                    15,
                    2,
                    193,
                    175,
                    189,
                    3,
                    1,
                    19,
                    138,
                    107,
                    58,
                    145,
                    17,
                    65,
                    79,
                    103,
                    220,
                    234,
                    151,
                    242,
                    207,
                    206,
                    240,
                    180,
                    230,
                    115,
                    150,
                    172,
                    116,
                    34,
                    231,
                    173,
                    53,
                    133,
                    226,
                    249,
                    55,
                    232,
                    28,
                    117,
                    223,
                    110,
                    71,
                    241,
                    26,
                    113,
                    29,
                    41,
                    197,
                    137,
                    111,
                    183,
                    98,
                    14,
                    170,
                    24,
                    190,
                    27,
                    252,
                    86,
                    62,
                    75,
                    198,
                    210,
                    121,
                    32,
                    154,
                    219,
                    192,
                    254,
                    120,
                    205,
                    90,
                    244,
                    31,
                    221,
                    168,
                    51,
                    136,
                    7,
                    199,
                    49,
                    177,
                    18,
                    16,
                    89,
                    39,
                    128,
                    236,
                    95,
                    96,
                    81,
                    127,
                    169,
                    25,
                    181,
                    74,
                    13,
                    45,
                    229,
                    122,
                    159,
                    147,
                    201,
                    156,
                    239,
                    160,
                    224,
                    59,
                    77,
                    174,
                    42,
                    245,
                    176,
                    200,
                    235,
                    187,
                    60,
                    131,
                    83,
                    153,
                    97,
                    23,
                    43,
                    4,
                    126,
                    186,
                    119,
                    214,
                    38,
                    225,
                    105,
                    20,
                    99,
                    85,
                    33,
                    12,
                    125,
                  ]),
                  mixCol = new Uint8Array(256),
                  i = 0;
                i < 256;
                i++
              )
                mixCol[i] = i < 128 ? i << 1 : (i << 1) ^ 27;
              var mix = new Uint32Array([
                0,
                235474187,
                470948374,
                303765277,
                941896748,
                908933415,
                607530554,
                708780849,
                1883793496,
                2118214995,
                1817866830,
                1649639237,
                1215061108,
                1181045119,
                1417561698,
                1517767529,
                3767586992,
                4003061179,
                4236429990,
                4069246893,
                3635733660,
                3602770327,
                3299278474,
                3400528769,
                2430122216,
                2664543715,
                2362090238,
                2193862645,
                2835123396,
                2801107407,
                3035535058,
                3135740889,
                3678124923,
                3576870512,
                3341394285,
                3374361702,
                3810496343,
                3977675356,
                4279080257,
                4043610186,
                2876494627,
                2776292904,
                3076639029,
                3110650942,
                2472011535,
                2640243204,
                2403728665,
                2169303058,
                1001089995,
                899835584,
                666464733,
                699432150,
                59727847,
                226906860,
                530400753,
                294930682,
                1273168787,
                1172967064,
                1475418501,
                1509430414,
                1942435775,
                2110667444,
                1876241833,
                1641816226,
                2910219766,
                2743034109,
                2976151520,
                3211623147,
                2505202138,
                2606453969,
                2302690252,
                2269728455,
                3711829422,
                3543599269,
                3240894392,
                3475313331,
                3843699074,
                3943906441,
                4178062228,
                4144047775,
                1306967366,
                1139781709,
                1374988112,
                1610459739,
                1975683434,
                2076935265,
                1775276924,
                1742315127,
                1034867998,
                866637845,
                566021896,
                800440835,
                92987698,
                193195065,
                429456164,
                395441711,
                1984812685,
                2017778566,
                1784663195,
                1683407248,
                1315562145,
                1080094634,
                1383856311,
                1551037884,
                101039829,
                135050206,
                437757123,
                337553864,
                1042385657,
                807962610,
                573804783,
                742039012,
                2531067453,
                2564033334,
                2328828971,
                2227573024,
                2935566865,
                2700099354,
                3001755655,
                3168937228,
                3868552805,
                3902563182,
                4203181171,
                4102977912,
                3736164937,
                3501741890,
                3265478751,
                3433712980,
                1106041591,
                1340463100,
                1576976609,
                1408749034,
                2043211483,
                2009195472,
                1708848333,
                1809054150,
                832877231,
                1068351396,
                766945465,
                599762354,
                159417987,
                126454664,
                361929877,
                463180190,
                2709260871,
                2943682380,
                3178106961,
                3009879386,
                2572697195,
                2538681184,
                2236228733,
                2336434550,
                3509871135,
                3745345300,
                3441850377,
                3274667266,
                3910161971,
                3877198648,
                4110568485,
                4211818798,
                2597806476,
                2497604743,
                2261089178,
                2295101073,
                2733856160,
                2902087851,
                3202437046,
                2968011453,
                3936291284,
                3835036895,
                4136440770,
                4169408201,
                3535486456,
                3702665459,
                3467192302,
                3231722213,
                2051518780,
                1951317047,
                1716890410,
                1750902305,
                1113818384,
                1282050075,
                1584504582,
                1350078989,
                168810852,
                67556463,
                371049330,
                404016761,
                841739592,
                1008918595,
                775550814,
                540080725,
                3969562369,
                3801332234,
                4035489047,
                4269907996,
                3569255213,
                3669462566,
                3366754619,
                3332740144,
                2631065433,
                2463879762,
                2160117071,
                2395588676,
                2767645557,
                2868897406,
                3102011747,
                3069049960,
                202008497,
                33778362,
                270040487,
                504459436,
                875451293,
                975658646,
                675039627,
                641025152,
                2084704233,
                1917518562,
                1615861247,
                1851332852,
                1147550661,
                1248802510,
                1484005843,
                1451044056,
                933301370,
                967311729,
                733156972,
                632953703,
                260388950,
                25965917,
                328671808,
                496906059,
                1206477858,
                1239443753,
                1543208500,
                1441952575,
                2144161806,
                1908694277,
                1675577880,
                1842759443,
                3610369226,
                3644379585,
                3408119516,
                3307916247,
                4011190502,
                3776767469,
                4077384432,
                4245618683,
                2809771154,
                2842737049,
                3144396420,
                3043140495,
                2673705150,
                2438237621,
                2203032232,
                2370213795,
              ]);
              return (
                (AES128Cipher.prototype = {
                  decryptBlock: function (data, finalize) {
                    var i,
                      sourceLength = data.length,
                      buffer = this.buffer,
                      bufferLength = this.bufferPosition;
                    for (i = 0; bufferLength < 16 && i < sourceLength; ++i, ++bufferLength)
                      buffer[bufferLength] = data[i];
                    return bufferLength < 16
                      ? ((this.bufferLength = bufferLength), new Uint8Array([]))
                      : ((this.iv = buffer),
                        (this.buffer = new Uint8Array(16)),
                        (this.bufferLength = 0),
                        (this.decryptBlock = decryptBlock2),
                        this.decryptBlock(data.subarray(16), finalize));
                  },
                  encrypt: function (data, iv) {
                    var i,
                      j,
                      ii,
                      sourceLength = data.length,
                      buffer = this.buffer,
                      bufferLength = this.bufferPosition,
                      result = [];
                    for (iv || (iv = new Uint8Array(16)), i = 0; i < sourceLength; ++i)
                      if (((buffer[bufferLength] = data[i]), !(++bufferLength < 16))) {
                        for (j = 0; j < 16; ++j) buffer[j] ^= iv[j];
                        var cipher = encrypt128(buffer, this.key);
                        (iv = cipher), result.push(cipher), (buffer = new Uint8Array(16)), (bufferLength = 0);
                      }
                    if (
                      ((this.buffer = buffer), (this.bufferLength = bufferLength), (this.iv = iv), 0 === result.length)
                    )
                      return new Uint8Array([]);
                    var outputLength = 16 * result.length,
                      output = new Uint8Array(outputLength);
                    for (i = 0, j = 0, ii = result.length; i < ii; ++i, j += 16) output.set(result[i], j);
                    return output;
                  },
                }),
                AES128Cipher
              );
            })(),
            AES256Cipher = (function () {
              function expandKey256(cipherKey) {
                var result = new Uint8Array(240),
                  r = 1;
                result.set(cipherKey);
                for (var j = 32, i = 1; j < 240; ++i) {
                  if (j % 32 == 16) (t1 = s[t1]), (t2 = s[t2]), (t3 = s[t3]), (t4 = s[t4]);
                  else if (j % 32 == 0) {
                    var t1 = result[j - 3],
                      t2 = result[j - 2],
                      t3 = result[j - 1],
                      t4 = result[j - 4];
                    (t1 = s[t1]),
                      (t2 = s[t2]),
                      (t3 = s[t3]),
                      (t4 = s[t4]),
                      (t1 ^= r),
                      (r <<= 1) >= 256 && (r = 255 & (27 ^ r));
                  }
                  for (var n = 0; n < 4; ++n)
                    (result[j] = t1 ^= result[j - 32]),
                      j++,
                      (result[j] = t2 ^= result[j - 32]),
                      j++,
                      (result[j] = t3 ^= result[j - 32]),
                      j++,
                      (result[j] = t4 ^= result[j - 32]),
                      j++;
                }
                return result;
              }
              function decrypt256(input, key) {
                var state = new Uint8Array(16);
                state.set(input);
                var i, j, k, t, u, v;
                for (j = 0, k = 224; j < 16; ++j, ++k) state[j] ^= key[k];
                for (i = 13; i >= 1; --i) {
                  for (
                    t = state[13],
                      state[13] = state[9],
                      state[9] = state[5],
                      state[5] = state[1],
                      state[1] = t,
                      t = state[14],
                      u = state[10],
                      state[14] = state[6],
                      state[10] = state[2],
                      state[6] = t,
                      state[2] = u,
                      t = state[15],
                      u = state[11],
                      v = state[7],
                      state[15] = state[3],
                      state[11] = t,
                      state[7] = u,
                      state[3] = v,
                      j = 0;
                    j < 16;
                    ++j
                  )
                    state[j] = inv_s[state[j]];
                  for (j = 0, k = 16 * i; j < 16; ++j, ++k) state[j] ^= key[k];
                  for (j = 0; j < 16; j += 4) {
                    var s0 = mix[state[j]],
                      s1 = mix[state[j + 1]],
                      s2 = mix[state[j + 2]],
                      s3 = mix[state[j + 3]];
                    (t = s0 ^ (s1 >>> 8) ^ (s1 << 24) ^ (s2 >>> 16) ^ (s2 << 16) ^ (s3 >>> 24) ^ (s3 << 8)),
                      (state[j] = (t >>> 24) & 255),
                      (state[j + 1] = (t >> 16) & 255),
                      (state[j + 2] = (t >> 8) & 255),
                      (state[j + 3] = 255 & t);
                  }
                }
                for (
                  t = state[13],
                    state[13] = state[9],
                    state[9] = state[5],
                    state[5] = state[1],
                    state[1] = t,
                    t = state[14],
                    u = state[10],
                    state[14] = state[6],
                    state[10] = state[2],
                    state[6] = t,
                    state[2] = u,
                    t = state[15],
                    u = state[11],
                    v = state[7],
                    state[15] = state[3],
                    state[11] = t,
                    state[7] = u,
                    state[3] = v,
                    j = 0;
                  j < 16;
                  ++j
                )
                  (state[j] = inv_s[state[j]]), (state[j] ^= key[j]);
                return state;
              }
              function encrypt256(input, key) {
                var t,
                  u,
                  v,
                  k,
                  state = new Uint8Array(16);
                for (state.set(input), j = 0; j < 16; ++j) state[j] ^= key[j];
                for (i = 1; i < 14; i++) {
                  for (j = 0; j < 16; ++j) state[j] = s[state[j]];
                  (v = state[1]),
                    (state[1] = state[5]),
                    (state[5] = state[9]),
                    (state[9] = state[13]),
                    (state[13] = v),
                    (v = state[2]),
                    (u = state[6]),
                    (state[2] = state[10]),
                    (state[6] = state[14]),
                    (state[10] = v),
                    (state[14] = u),
                    (v = state[3]),
                    (u = state[7]),
                    (t = state[11]),
                    (state[3] = state[15]),
                    (state[7] = v),
                    (state[11] = u),
                    (state[15] = t);
                  for (var j = 0; j < 16; j += 4) {
                    var s0 = state[j + 0],
                      s1 = state[j + 1],
                      s2 = state[j + 2],
                      s3 = state[j + 3];
                    (t = s0 ^ s1 ^ s2 ^ s3),
                      (state[j + 0] ^= t ^ mixCol[s0 ^ s1]),
                      (state[j + 1] ^= t ^ mixCol[s1 ^ s2]),
                      (state[j + 2] ^= t ^ mixCol[s2 ^ s3]),
                      (state[j + 3] ^= t ^ mixCol[s3 ^ s0]);
                  }
                  for (j = 0, k = 16 * i; j < 16; ++j, ++k) state[j] ^= key[k];
                }
                for (j = 0; j < 16; ++j) state[j] = s[state[j]];
                for (
                  v = state[1],
                    state[1] = state[5],
                    state[5] = state[9],
                    state[9] = state[13],
                    state[13] = v,
                    v = state[2],
                    u = state[6],
                    state[2] = state[10],
                    state[6] = state[14],
                    state[10] = v,
                    state[14] = u,
                    v = state[3],
                    u = state[7],
                    t = state[11],
                    state[3] = state[15],
                    state[7] = v,
                    state[11] = u,
                    state[15] = t,
                    j = 0,
                    k = 224;
                  j < 16;
                  ++j, ++k
                )
                  state[j] ^= key[k];
                return state;
              }
              function AES256Cipher(key) {
                (this.key = expandKey256(key)), (this.buffer = new Uint8Array(16)), (this.bufferPosition = 0);
              }
              function decryptBlock2(data, finalize) {
                var i,
                  j,
                  ii,
                  sourceLength = data.length,
                  buffer = this.buffer,
                  bufferLength = this.bufferPosition,
                  result = [],
                  iv = this.iv;
                for (i = 0; i < sourceLength; ++i)
                  if (((buffer[bufferLength] = data[i]), !(++bufferLength < 16))) {
                    var plain = decrypt256(buffer, this.key);
                    for (j = 0; j < 16; ++j) plain[j] ^= iv[j];
                    (iv = buffer), result.push(plain), (buffer = new Uint8Array(16)), (bufferLength = 0);
                  }
                if (((this.buffer = buffer), (this.bufferLength = bufferLength), (this.iv = iv), 0 === result.length))
                  return new Uint8Array([]);
                var outputLength = 16 * result.length;
                if (finalize) {
                  var lastBlock = result[result.length - 1],
                    psLen = lastBlock[15];
                  if (psLen <= 16) {
                    for (i = 15, ii = 16 - psLen; i >= ii; --i)
                      if (lastBlock[i] !== psLen) {
                        psLen = 0;
                        break;
                      }
                    (outputLength -= psLen), (result[result.length - 1] = lastBlock.subarray(0, 16 - psLen));
                  }
                }
                var output = new Uint8Array(outputLength);
                for (i = 0, j = 0, ii = result.length; i < ii; ++i, j += 16) output.set(result[i], j);
                return output;
              }
              for (
                var s =
                    (new Uint8Array([
                      141,
                      1,
                      2,
                      4,
                      8,
                      16,
                      32,
                      64,
                      128,
                      27,
                      54,
                      108,
                      216,
                      171,
                      77,
                      154,
                      47,
                      94,
                      188,
                      99,
                      198,
                      151,
                      53,
                      106,
                      212,
                      179,
                      125,
                      250,
                      239,
                      197,
                      145,
                      57,
                      114,
                      228,
                      211,
                      189,
                      97,
                      194,
                      159,
                      37,
                      74,
                      148,
                      51,
                      102,
                      204,
                      131,
                      29,
                      58,
                      116,
                      232,
                      203,
                      141,
                      1,
                      2,
                      4,
                      8,
                      16,
                      32,
                      64,
                      128,
                      27,
                      54,
                      108,
                      216,
                      171,
                      77,
                      154,
                      47,
                      94,
                      188,
                      99,
                      198,
                      151,
                      53,
                      106,
                      212,
                      179,
                      125,
                      250,
                      239,
                      197,
                      145,
                      57,
                      114,
                      228,
                      211,
                      189,
                      97,
                      194,
                      159,
                      37,
                      74,
                      148,
                      51,
                      102,
                      204,
                      131,
                      29,
                      58,
                      116,
                      232,
                      203,
                      141,
                      1,
                      2,
                      4,
                      8,
                      16,
                      32,
                      64,
                      128,
                      27,
                      54,
                      108,
                      216,
                      171,
                      77,
                      154,
                      47,
                      94,
                      188,
                      99,
                      198,
                      151,
                      53,
                      106,
                      212,
                      179,
                      125,
                      250,
                      239,
                      197,
                      145,
                      57,
                      114,
                      228,
                      211,
                      189,
                      97,
                      194,
                      159,
                      37,
                      74,
                      148,
                      51,
                      102,
                      204,
                      131,
                      29,
                      58,
                      116,
                      232,
                      203,
                      141,
                      1,
                      2,
                      4,
                      8,
                      16,
                      32,
                      64,
                      128,
                      27,
                      54,
                      108,
                      216,
                      171,
                      77,
                      154,
                      47,
                      94,
                      188,
                      99,
                      198,
                      151,
                      53,
                      106,
                      212,
                      179,
                      125,
                      250,
                      239,
                      197,
                      145,
                      57,
                      114,
                      228,
                      211,
                      189,
                      97,
                      194,
                      159,
                      37,
                      74,
                      148,
                      51,
                      102,
                      204,
                      131,
                      29,
                      58,
                      116,
                      232,
                      203,
                      141,
                      1,
                      2,
                      4,
                      8,
                      16,
                      32,
                      64,
                      128,
                      27,
                      54,
                      108,
                      216,
                      171,
                      77,
                      154,
                      47,
                      94,
                      188,
                      99,
                      198,
                      151,
                      53,
                      106,
                      212,
                      179,
                      125,
                      250,
                      239,
                      197,
                      145,
                      57,
                      114,
                      228,
                      211,
                      189,
                      97,
                      194,
                      159,
                      37,
                      74,
                      148,
                      51,
                      102,
                      204,
                      131,
                      29,
                      58,
                      116,
                      232,
                      203,
                      141,
                    ]),
                    new Uint8Array([
                      99,
                      124,
                      119,
                      123,
                      242,
                      107,
                      111,
                      197,
                      48,
                      1,
                      103,
                      43,
                      254,
                      215,
                      171,
                      118,
                      202,
                      130,
                      201,
                      125,
                      250,
                      89,
                      71,
                      240,
                      173,
                      212,
                      162,
                      175,
                      156,
                      164,
                      114,
                      192,
                      183,
                      253,
                      147,
                      38,
                      54,
                      63,
                      247,
                      204,
                      52,
                      165,
                      229,
                      241,
                      113,
                      216,
                      49,
                      21,
                      4,
                      199,
                      35,
                      195,
                      24,
                      150,
                      5,
                      154,
                      7,
                      18,
                      128,
                      226,
                      235,
                      39,
                      178,
                      117,
                      9,
                      131,
                      44,
                      26,
                      27,
                      110,
                      90,
                      160,
                      82,
                      59,
                      214,
                      179,
                      41,
                      227,
                      47,
                      132,
                      83,
                      209,
                      0,
                      237,
                      32,
                      252,
                      177,
                      91,
                      106,
                      203,
                      190,
                      57,
                      74,
                      76,
                      88,
                      207,
                      208,
                      239,
                      170,
                      251,
                      67,
                      77,
                      51,
                      133,
                      69,
                      249,
                      2,
                      127,
                      80,
                      60,
                      159,
                      168,
                      81,
                      163,
                      64,
                      143,
                      146,
                      157,
                      56,
                      245,
                      188,
                      182,
                      218,
                      33,
                      16,
                      255,
                      243,
                      210,
                      205,
                      12,
                      19,
                      236,
                      95,
                      151,
                      68,
                      23,
                      196,
                      167,
                      126,
                      61,
                      100,
                      93,
                      25,
                      115,
                      96,
                      129,
                      79,
                      220,
                      34,
                      42,
                      144,
                      136,
                      70,
                      238,
                      184,
                      20,
                      222,
                      94,
                      11,
                      219,
                      224,
                      50,
                      58,
                      10,
                      73,
                      6,
                      36,
                      92,
                      194,
                      211,
                      172,
                      98,
                      145,
                      149,
                      228,
                      121,
                      231,
                      200,
                      55,
                      109,
                      141,
                      213,
                      78,
                      169,
                      108,
                      86,
                      244,
                      234,
                      101,
                      122,
                      174,
                      8,
                      186,
                      120,
                      37,
                      46,
                      28,
                      166,
                      180,
                      198,
                      232,
                      221,
                      116,
                      31,
                      75,
                      189,
                      139,
                      138,
                      112,
                      62,
                      181,
                      102,
                      72,
                      3,
                      246,
                      14,
                      97,
                      53,
                      87,
                      185,
                      134,
                      193,
                      29,
                      158,
                      225,
                      248,
                      152,
                      17,
                      105,
                      217,
                      142,
                      148,
                      155,
                      30,
                      135,
                      233,
                      206,
                      85,
                      40,
                      223,
                      140,
                      161,
                      137,
                      13,
                      191,
                      230,
                      66,
                      104,
                      65,
                      153,
                      45,
                      15,
                      176,
                      84,
                      187,
                      22,
                    ])),
                  inv_s = new Uint8Array([
                    82,
                    9,
                    106,
                    213,
                    48,
                    54,
                    165,
                    56,
                    191,
                    64,
                    163,
                    158,
                    129,
                    243,
                    215,
                    251,
                    124,
                    227,
                    57,
                    130,
                    155,
                    47,
                    255,
                    135,
                    52,
                    142,
                    67,
                    68,
                    196,
                    222,
                    233,
                    203,
                    84,
                    123,
                    148,
                    50,
                    166,
                    194,
                    35,
                    61,
                    238,
                    76,
                    149,
                    11,
                    66,
                    250,
                    195,
                    78,
                    8,
                    46,
                    161,
                    102,
                    40,
                    217,
                    36,
                    178,
                    118,
                    91,
                    162,
                    73,
                    109,
                    139,
                    209,
                    37,
                    114,
                    248,
                    246,
                    100,
                    134,
                    104,
                    152,
                    22,
                    212,
                    164,
                    92,
                    204,
                    93,
                    101,
                    182,
                    146,
                    108,
                    112,
                    72,
                    80,
                    253,
                    237,
                    185,
                    218,
                    94,
                    21,
                    70,
                    87,
                    167,
                    141,
                    157,
                    132,
                    144,
                    216,
                    171,
                    0,
                    140,
                    188,
                    211,
                    10,
                    247,
                    228,
                    88,
                    5,
                    184,
                    179,
                    69,
                    6,
                    208,
                    44,
                    30,
                    143,
                    202,
                    63,
                    15,
                    2,
                    193,
                    175,
                    189,
                    3,
                    1,
                    19,
                    138,
                    107,
                    58,
                    145,
                    17,
                    65,
                    79,
                    103,
                    220,
                    234,
                    151,
                    242,
                    207,
                    206,
                    240,
                    180,
                    230,
                    115,
                    150,
                    172,
                    116,
                    34,
                    231,
                    173,
                    53,
                    133,
                    226,
                    249,
                    55,
                    232,
                    28,
                    117,
                    223,
                    110,
                    71,
                    241,
                    26,
                    113,
                    29,
                    41,
                    197,
                    137,
                    111,
                    183,
                    98,
                    14,
                    170,
                    24,
                    190,
                    27,
                    252,
                    86,
                    62,
                    75,
                    198,
                    210,
                    121,
                    32,
                    154,
                    219,
                    192,
                    254,
                    120,
                    205,
                    90,
                    244,
                    31,
                    221,
                    168,
                    51,
                    136,
                    7,
                    199,
                    49,
                    177,
                    18,
                    16,
                    89,
                    39,
                    128,
                    236,
                    95,
                    96,
                    81,
                    127,
                    169,
                    25,
                    181,
                    74,
                    13,
                    45,
                    229,
                    122,
                    159,
                    147,
                    201,
                    156,
                    239,
                    160,
                    224,
                    59,
                    77,
                    174,
                    42,
                    245,
                    176,
                    200,
                    235,
                    187,
                    60,
                    131,
                    83,
                    153,
                    97,
                    23,
                    43,
                    4,
                    126,
                    186,
                    119,
                    214,
                    38,
                    225,
                    105,
                    20,
                    99,
                    85,
                    33,
                    12,
                    125,
                  ]),
                  mixCol = new Uint8Array(256),
                  i = 0;
                i < 256;
                i++
              )
                mixCol[i] = i < 128 ? i << 1 : (i << 1) ^ 27;
              var mix = new Uint32Array([
                0,
                235474187,
                470948374,
                303765277,
                941896748,
                908933415,
                607530554,
                708780849,
                1883793496,
                2118214995,
                1817866830,
                1649639237,
                1215061108,
                1181045119,
                1417561698,
                1517767529,
                3767586992,
                4003061179,
                4236429990,
                4069246893,
                3635733660,
                3602770327,
                3299278474,
                3400528769,
                2430122216,
                2664543715,
                2362090238,
                2193862645,
                2835123396,
                2801107407,
                3035535058,
                3135740889,
                3678124923,
                3576870512,
                3341394285,
                3374361702,
                3810496343,
                3977675356,
                4279080257,
                4043610186,
                2876494627,
                2776292904,
                3076639029,
                3110650942,
                2472011535,
                2640243204,
                2403728665,
                2169303058,
                1001089995,
                899835584,
                666464733,
                699432150,
                59727847,
                226906860,
                530400753,
                294930682,
                1273168787,
                1172967064,
                1475418501,
                1509430414,
                1942435775,
                2110667444,
                1876241833,
                1641816226,
                2910219766,
                2743034109,
                2976151520,
                3211623147,
                2505202138,
                2606453969,
                2302690252,
                2269728455,
                3711829422,
                3543599269,
                3240894392,
                3475313331,
                3843699074,
                3943906441,
                4178062228,
                4144047775,
                1306967366,
                1139781709,
                1374988112,
                1610459739,
                1975683434,
                2076935265,
                1775276924,
                1742315127,
                1034867998,
                866637845,
                566021896,
                800440835,
                92987698,
                193195065,
                429456164,
                395441711,
                1984812685,
                2017778566,
                1784663195,
                1683407248,
                1315562145,
                1080094634,
                1383856311,
                1551037884,
                101039829,
                135050206,
                437757123,
                337553864,
                1042385657,
                807962610,
                573804783,
                742039012,
                2531067453,
                2564033334,
                2328828971,
                2227573024,
                2935566865,
                2700099354,
                3001755655,
                3168937228,
                3868552805,
                3902563182,
                4203181171,
                4102977912,
                3736164937,
                3501741890,
                3265478751,
                3433712980,
                1106041591,
                1340463100,
                1576976609,
                1408749034,
                2043211483,
                2009195472,
                1708848333,
                1809054150,
                832877231,
                1068351396,
                766945465,
                599762354,
                159417987,
                126454664,
                361929877,
                463180190,
                2709260871,
                2943682380,
                3178106961,
                3009879386,
                2572697195,
                2538681184,
                2236228733,
                2336434550,
                3509871135,
                3745345300,
                3441850377,
                3274667266,
                3910161971,
                3877198648,
                4110568485,
                4211818798,
                2597806476,
                2497604743,
                2261089178,
                2295101073,
                2733856160,
                2902087851,
                3202437046,
                2968011453,
                3936291284,
                3835036895,
                4136440770,
                4169408201,
                3535486456,
                3702665459,
                3467192302,
                3231722213,
                2051518780,
                1951317047,
                1716890410,
                1750902305,
                1113818384,
                1282050075,
                1584504582,
                1350078989,
                168810852,
                67556463,
                371049330,
                404016761,
                841739592,
                1008918595,
                775550814,
                540080725,
                3969562369,
                3801332234,
                4035489047,
                4269907996,
                3569255213,
                3669462566,
                3366754619,
                3332740144,
                2631065433,
                2463879762,
                2160117071,
                2395588676,
                2767645557,
                2868897406,
                3102011747,
                3069049960,
                202008497,
                33778362,
                270040487,
                504459436,
                875451293,
                975658646,
                675039627,
                641025152,
                2084704233,
                1917518562,
                1615861247,
                1851332852,
                1147550661,
                1248802510,
                1484005843,
                1451044056,
                933301370,
                967311729,
                733156972,
                632953703,
                260388950,
                25965917,
                328671808,
                496906059,
                1206477858,
                1239443753,
                1543208500,
                1441952575,
                2144161806,
                1908694277,
                1675577880,
                1842759443,
                3610369226,
                3644379585,
                3408119516,
                3307916247,
                4011190502,
                3776767469,
                4077384432,
                4245618683,
                2809771154,
                2842737049,
                3144396420,
                3043140495,
                2673705150,
                2438237621,
                2203032232,
                2370213795,
              ]);
              return (
                (AES256Cipher.prototype = {
                  decryptBlock: function (data, finalize, iv) {
                    var i,
                      sourceLength = data.length,
                      buffer = this.buffer,
                      bufferLength = this.bufferPosition;
                    if (iv) this.iv = iv;
                    else {
                      for (i = 0; bufferLength < 16 && i < sourceLength; ++i, ++bufferLength)
                        buffer[bufferLength] = data[i];
                      if (bufferLength < 16) return (this.bufferLength = bufferLength), new Uint8Array([]);
                      (this.iv = buffer), (data = data.subarray(16));
                    }
                    return (
                      (this.buffer = new Uint8Array(16)),
                      (this.bufferLength = 0),
                      (this.decryptBlock = decryptBlock2),
                      this.decryptBlock(data, finalize)
                    );
                  },
                  encrypt: function (data, iv) {
                    var i,
                      j,
                      ii,
                      sourceLength = data.length,
                      buffer = this.buffer,
                      bufferLength = this.bufferPosition,
                      result = [];
                    for (iv || (iv = new Uint8Array(16)), i = 0; i < sourceLength; ++i)
                      if (((buffer[bufferLength] = data[i]), !(++bufferLength < 16))) {
                        for (j = 0; j < 16; ++j) buffer[j] ^= iv[j];
                        var cipher = encrypt256(buffer, this.key);
                        (this.iv = cipher), result.push(cipher), (buffer = new Uint8Array(16)), (bufferLength = 0);
                      }
                    if (
                      ((this.buffer = buffer), (this.bufferLength = bufferLength), (this.iv = iv), 0 === result.length)
                    )
                      return new Uint8Array([]);
                    var outputLength = 16 * result.length,
                      output = new Uint8Array(outputLength);
                    for (i = 0, j = 0, ii = result.length; i < ii; ++i, j += 16) output.set(result[i], j);
                    return output;
                  },
                }),
                AES256Cipher
              );
            })(),
            PDF17 = (function () {
              function compareByteArrays(array1, array2) {
                if (array1.length !== array2.length) return !1;
                for (var i = 0; i < array1.length; i++) if (array1[i] !== array2[i]) return !1;
                return !0;
              }
              function PDF17() {}
              return (
                (PDF17.prototype = {
                  checkOwnerPassword: function (password, ownerValidationSalt, userBytes, ownerPassword) {
                    var hashData = new Uint8Array(password.length + 56);
                    return (
                      hashData.set(password, 0),
                      hashData.set(ownerValidationSalt, password.length),
                      hashData.set(userBytes, password.length + ownerValidationSalt.length),
                      compareByteArrays(calculateSHA256(hashData, 0, hashData.length), ownerPassword)
                    );
                  },
                  checkUserPassword: function (password, userValidationSalt, userPassword) {
                    var hashData = new Uint8Array(password.length + 8);
                    return (
                      hashData.set(password, 0),
                      hashData.set(userValidationSalt, password.length),
                      compareByteArrays(calculateSHA256(hashData, 0, hashData.length), userPassword)
                    );
                  },
                  getOwnerKey: function (password, ownerKeySalt, userBytes, ownerEncryption) {
                    var hashData = new Uint8Array(password.length + 56);
                    hashData.set(password, 0),
                      hashData.set(ownerKeySalt, password.length),
                      hashData.set(userBytes, password.length + ownerKeySalt.length);
                    var key = calculateSHA256(hashData, 0, hashData.length);
                    return new AES256Cipher(key).decryptBlock(ownerEncryption, !1, new Uint8Array(16));
                  },
                  getUserKey: function (password, userKeySalt, userEncryption) {
                    var hashData = new Uint8Array(password.length + 8);
                    hashData.set(password, 0), hashData.set(userKeySalt, password.length);
                    var key = calculateSHA256(hashData, 0, hashData.length);
                    return new AES256Cipher(key).decryptBlock(userEncryption, !1, new Uint8Array(16));
                  },
                }),
                PDF17
              );
            })(),
            PDF20 = (function () {
              function concatArrays(array1, array2) {
                var t = new Uint8Array(array1.length + array2.length);
                return t.set(array1, 0), t.set(array2, array1.length), t;
              }
              function calculatePDF20Hash(password, input, userBytes) {
                for (
                  var k = calculateSHA256(input, 0, input.length).subarray(0, 32), e = [0], i = 0;
                  i < 64 || e[e.length - 1] > i - 32;

                ) {
                  var arrayLength = password.length + k.length + userBytes.length,
                    k1 = new Uint8Array(64 * arrayLength),
                    array = concatArrays(password, k);
                  array = concatArrays(array, userBytes);
                  for (var j = 0, pos = 0; j < 64; j++, pos += arrayLength) k1.set(array, pos);
                  e = new AES128Cipher(k.subarray(0, 16)).encrypt(k1, k.subarray(16, 32));
                  for (var remainder = 0, z = 0; z < 16; z++)
                    (remainder *= 1), (remainder %= 3), (remainder += (e[z] >>> 0) % 3), (remainder %= 3);
                  0 === remainder
                    ? (k = calculateSHA256(e, 0, e.length))
                    : 1 === remainder
                    ? (k = calculateSHA384(e, 0, e.length))
                    : 2 === remainder && (k = calculateSHA512(e, 0, e.length)),
                    i++;
                }
                return k.subarray(0, 32);
              }
              function PDF20() {}
              function compareByteArrays(array1, array2) {
                if (array1.length !== array2.length) return !1;
                for (var i = 0; i < array1.length; i++) if (array1[i] !== array2[i]) return !1;
                return !0;
              }
              return (
                (PDF20.prototype = {
                  hash: function (password, concatBytes, userBytes) {
                    return calculatePDF20Hash(password, concatBytes, userBytes);
                  },
                  checkOwnerPassword: function (password, ownerValidationSalt, userBytes, ownerPassword) {
                    var hashData = new Uint8Array(password.length + 56);
                    return (
                      hashData.set(password, 0),
                      hashData.set(ownerValidationSalt, password.length),
                      hashData.set(userBytes, password.length + ownerValidationSalt.length),
                      compareByteArrays(calculatePDF20Hash(password, hashData, userBytes), ownerPassword)
                    );
                  },
                  checkUserPassword: function (password, userValidationSalt, userPassword) {
                    var hashData = new Uint8Array(password.length + 8);
                    return (
                      hashData.set(password, 0),
                      hashData.set(userValidationSalt, password.length),
                      compareByteArrays(calculatePDF20Hash(password, hashData, []), userPassword)
                    );
                  },
                  getOwnerKey: function (password, ownerKeySalt, userBytes, ownerEncryption) {
                    var hashData = new Uint8Array(password.length + 56);
                    hashData.set(password, 0),
                      hashData.set(ownerKeySalt, password.length),
                      hashData.set(userBytes, password.length + ownerKeySalt.length);
                    var key = calculatePDF20Hash(password, hashData, userBytes);
                    return new AES256Cipher(key).decryptBlock(ownerEncryption, !1, new Uint8Array(16));
                  },
                  getUserKey: function (password, userKeySalt, userEncryption) {
                    var hashData = new Uint8Array(password.length + 8);
                    hashData.set(password, 0), hashData.set(userKeySalt, password.length);
                    var key = calculatePDF20Hash(password, hashData, []);
                    return new AES256Cipher(key).decryptBlock(userEncryption, !1, new Uint8Array(16));
                  },
                }),
                PDF20
              );
            })(),
            CipherTransform = (function () {
              function CipherTransform(stringCipherConstructor, streamCipherConstructor) {
                (this.stringCipherConstructor = stringCipherConstructor),
                  (this.streamCipherConstructor = streamCipherConstructor);
              }
              return (
                (CipherTransform.prototype = {
                  createStream: function (stream, length) {
                    var cipher = new this.streamCipherConstructor();
                    return new DecryptStream(stream, length, function (data, finalize) {
                      return cipher.decryptBlock(data, finalize);
                    });
                  },
                  decryptString: function (s) {
                    var cipher = new this.stringCipherConstructor(),
                      data = stringToBytes(s);
                    return (data = cipher.decryptBlock(data, !0)), bytesToString(data);
                  },
                }),
                CipherTransform
              );
            })(),
            CipherTransformFactory = (function () {
              function createEncryptionKey20(
                revision,
                password,
                ownerPassword,
                ownerValidationSalt,
                ownerKeySalt,
                uBytes,
                userPassword,
                userValidationSalt,
                userKeySalt,
                ownerEncryption,
                userEncryption,
                perms
              ) {
                if (password) {
                  var passwordLength = Math.min(127, password.length);
                  password = password.subarray(0, passwordLength);
                } else password = [];
                var pdfAlgorithm;
                return (
                  (pdfAlgorithm = 6 === revision ? new PDF20() : new PDF17()),
                  pdfAlgorithm.checkUserPassword(password, userValidationSalt, userPassword)
                    ? pdfAlgorithm.getUserKey(password, userKeySalt, userEncryption)
                    : password.length &&
                      pdfAlgorithm.checkOwnerPassword(password, ownerValidationSalt, uBytes, ownerPassword)
                    ? pdfAlgorithm.getOwnerKey(password, ownerKeySalt, uBytes, ownerEncryption)
                    : null
                );
              }
              function prepareKeyData(
                fileId,
                password,
                ownerPassword,
                userPassword,
                flags,
                revision,
                keyLength,
                encryptMetadata
              ) {
                var j,
                  n,
                  hashDataSize = 40 + ownerPassword.length + fileId.length,
                  hashData = new Uint8Array(hashDataSize),
                  i = 0;
                if (password) for (n = Math.min(32, password.length); i < n; ++i) hashData[i] = password[i];
                for (j = 0; i < 32; ) hashData[i++] = defaultPasswordBytes[j++];
                for (j = 0, n = ownerPassword.length; j < n; ++j) hashData[i++] = ownerPassword[j];
                for (
                  hashData[i++] = 255 & flags,
                    hashData[i++] = (flags >> 8) & 255,
                    hashData[i++] = (flags >> 16) & 255,
                    hashData[i++] = (flags >>> 24) & 255,
                    j = 0,
                    n = fileId.length;
                  j < n;
                  ++j
                )
                  hashData[i++] = fileId[j];
                revision >= 4 &&
                  !encryptMetadata &&
                  ((hashData[i++] = 255), (hashData[i++] = 255), (hashData[i++] = 255), (hashData[i++] = 255));
                var hash = calculateMD5(hashData, 0, i),
                  keyLengthInBytes = keyLength >> 3;
                if (revision >= 3) for (j = 0; j < 50; ++j) hash = calculateMD5(hash, 0, keyLengthInBytes);
                var cipher,
                  checkData,
                  encryptionKey = hash.subarray(0, keyLengthInBytes);
                if (revision >= 3) {
                  for (i = 0; i < 32; ++i) hashData[i] = defaultPasswordBytes[i];
                  for (j = 0, n = fileId.length; j < n; ++j) hashData[i++] = fileId[j];
                  (cipher = new ARCFourCipher(encryptionKey)),
                    (checkData = cipher.encryptBlock(calculateMD5(hashData, 0, i))),
                    (n = encryptionKey.length);
                  var k,
                    derivedKey = new Uint8Array(n);
                  for (j = 1; j <= 19; ++j) {
                    for (k = 0; k < n; ++k) derivedKey[k] = encryptionKey[k] ^ j;
                    (cipher = new ARCFourCipher(derivedKey)), (checkData = cipher.encryptBlock(checkData));
                  }
                  for (j = 0, n = checkData.length; j < n; ++j) if (userPassword[j] !== checkData[j]) return null;
                } else
                  for (
                    cipher = new ARCFourCipher(encryptionKey),
                      checkData = cipher.encryptBlock(defaultPasswordBytes),
                      j = 0,
                      n = checkData.length;
                    j < n;
                    ++j
                  )
                    if (userPassword[j] !== checkData[j]) return null;
                return encryptionKey;
              }
              function decodeUserPassword(password, ownerPassword, revision, keyLength) {
                var j,
                  n,
                  hashData = new Uint8Array(32),
                  i = 0;
                for (n = Math.min(32, password.length); i < n; ++i) hashData[i] = password[i];
                for (j = 0; i < 32; ) hashData[i++] = defaultPasswordBytes[j++];
                var hash = calculateMD5(hashData, 0, i),
                  keyLengthInBytes = keyLength >> 3;
                if (revision >= 3) for (j = 0; j < 50; ++j) hash = calculateMD5(hash, 0, hash.length);
                var cipher, userPassword;
                if (revision >= 3) {
                  userPassword = ownerPassword;
                  var k,
                    derivedKey = new Uint8Array(keyLengthInBytes);
                  for (j = 19; j >= 0; j--) {
                    for (k = 0; k < keyLengthInBytes; ++k) derivedKey[k] = hash[k] ^ j;
                    (cipher = new ARCFourCipher(derivedKey)), (userPassword = cipher.encryptBlock(userPassword));
                  }
                } else
                  (cipher = new ARCFourCipher(hash.subarray(0, keyLengthInBytes))),
                    (userPassword = cipher.encryptBlock(ownerPassword));
                return userPassword;
              }
              function CipherTransformFactory(dict, fileId, password) {
                var filter = dict.get("Filter");
                isName(filter, "Standard") || error("unknown encryption method"), (this.dict = dict);
                var algorithm = dict.get("V");
                (!isInt(algorithm) || (1 !== algorithm && 2 !== algorithm && 4 !== algorithm && 5 !== algorithm)) &&
                  error("unsupported encryption algorithm"),
                  (this.algorithm = algorithm);
                var keyLength = dict.get("Length");
                if (!keyLength)
                  if (algorithm <= 3) keyLength = 40;
                  else {
                    var cfDict = dict.get("CF"),
                      streamCryptoName = dict.get("StmF");
                    if (isDict(cfDict) && isName(streamCryptoName)) {
                      var handlerDict = cfDict.get(streamCryptoName.name);
                      (keyLength = (handlerDict && handlerDict.get("Length")) || 128),
                        keyLength < 40 && (keyLength <<= 3);
                    }
                  }
                (!isInt(keyLength) || keyLength < 40 || keyLength % 8 != 0) && error("invalid key length");
                var ownerPassword = stringToBytes(dict.get("O")).subarray(0, 32),
                  userPassword = stringToBytes(dict.get("U")).subarray(0, 32),
                  flags = dict.get("P"),
                  revision = dict.get("R"),
                  encryptMetadata = (4 === algorithm || 5 === algorithm) && !1 !== dict.get("EncryptMetadata");
                this.encryptMetadata = encryptMetadata;
                var passwordBytes,
                  fileIdBytes = stringToBytes(fileId);
                if (password) {
                  if (6 === revision)
                    try {
                      password = utf8StringToString(password);
                    } catch (ex) {
                      warn("CipherTransformFactory: Unable to convert UTF8 encoded password.");
                    }
                  passwordBytes = stringToBytes(password);
                }
                var encryptionKey;
                if (5 !== algorithm)
                  encryptionKey = prepareKeyData(
                    fileIdBytes,
                    passwordBytes,
                    ownerPassword,
                    userPassword,
                    flags,
                    revision,
                    keyLength,
                    encryptMetadata
                  );
                else {
                  encryptionKey = createEncryptionKey20(
                    revision,
                    passwordBytes,
                    ownerPassword,
                    stringToBytes(dict.get("O")).subarray(32, 40),
                    stringToBytes(dict.get("O")).subarray(40, 48),
                    stringToBytes(dict.get("U")).subarray(0, 48),
                    userPassword,
                    stringToBytes(dict.get("U")).subarray(32, 40),
                    stringToBytes(dict.get("U")).subarray(40, 48),
                    stringToBytes(dict.get("OE")),
                    stringToBytes(dict.get("UE")),
                    stringToBytes(dict.get("Perms"))
                  );
                }
                if (!encryptionKey && !password)
                  throw new PasswordException("No password given", PasswordResponses.NEED_PASSWORD);
                if (!encryptionKey && password) {
                  encryptionKey = prepareKeyData(
                    fileIdBytes,
                    decodeUserPassword(passwordBytes, ownerPassword, revision, keyLength),
                    ownerPassword,
                    userPassword,
                    flags,
                    revision,
                    keyLength,
                    encryptMetadata
                  );
                }
                if (!encryptionKey)
                  throw new PasswordException("Incorrect Password", PasswordResponses.INCORRECT_PASSWORD);
                (this.encryptionKey = encryptionKey),
                  algorithm >= 4 &&
                    ((this.cf = dict.get("CF")),
                    (this.stmf = dict.get("StmF") || identityName),
                    (this.strf = dict.get("StrF") || identityName),
                    (this.eff = dict.get("EFF") || this.stmf));
              }
              function buildObjectKey(num, gen, encryptionKey, isAes) {
                var i,
                  n,
                  key = new Uint8Array(encryptionKey.length + 9);
                for (i = 0, n = encryptionKey.length; i < n; ++i) key[i] = encryptionKey[i];
                return (
                  (key[i++] = 255 & num),
                  (key[i++] = (num >> 8) & 255),
                  (key[i++] = (num >> 16) & 255),
                  (key[i++] = 255 & gen),
                  (key[i++] = (gen >> 8) & 255),
                  isAes && ((key[i++] = 115), (key[i++] = 65), (key[i++] = 108), (key[i++] = 84)),
                  calculateMD5(key, 0, i).subarray(0, Math.min(encryptionKey.length + 5, 16))
                );
              }
              function buildCipherConstructor(cf, name, num, gen, key) {
                var cfm,
                  cryptFilter = cf.get(name.name);
                return (
                  null !== cryptFilter && void 0 !== cryptFilter && (cfm = cryptFilter.get("CFM")),
                  cfm && "None" !== cfm.name
                    ? "V2" === cfm.name
                      ? function () {
                          return new ARCFourCipher(buildObjectKey(num, gen, key, !1));
                        }
                      : "AESV2" === cfm.name
                      ? function () {
                          return new AES128Cipher(buildObjectKey(num, gen, key, !0));
                        }
                      : "AESV3" === cfm.name
                      ? function () {
                          return new AES256Cipher(key);
                        }
                      : void error("Unknown crypto method")
                    : function () {
                        return new NullCipher();
                      }
                );
              }
              var defaultPasswordBytes = new Uint8Array([
                  40,
                  191,
                  78,
                  94,
                  78,
                  117,
                  138,
                  65,
                  100,
                  0,
                  78,
                  86,
                  255,
                  250,
                  1,
                  8,
                  46,
                  46,
                  0,
                  182,
                  208,
                  104,
                  62,
                  128,
                  47,
                  12,
                  169,
                  254,
                  100,
                  83,
                  105,
                  122,
                ]),
                identityName = Name.get("Identity");
              return (
                (CipherTransformFactory.prototype = {
                  createCipherTransform: function (num, gen) {
                    if (4 === this.algorithm || 5 === this.algorithm)
                      return new CipherTransform(
                        buildCipherConstructor(this.cf, this.stmf, num, gen, this.encryptionKey),
                        buildCipherConstructor(this.cf, this.strf, num, gen, this.encryptionKey)
                      );
                    var key = buildObjectKey(num, gen, this.encryptionKey, !1),
                      cipherConstructor = function () {
                        return new ARCFourCipher(key);
                      };
                    return new CipherTransform(cipherConstructor, cipherConstructor);
                  },
                }),
                CipherTransformFactory
              );
            })();
          (exports.AES128Cipher = AES128Cipher),
            (exports.AES256Cipher = AES256Cipher),
            (exports.ARCFourCipher = ARCFourCipher),
            (exports.CipherTransformFactory = CipherTransformFactory),
            (exports.PDF17 = PDF17),
            (exports.PDF20 = PDF20),
            (exports.calculateMD5 = calculateMD5),
            (exports.calculateSHA256 = calculateSHA256),
            (exports.calculateSHA384 = calculateSHA384),
            (exports.calculateSHA512 = calculateSHA512);
        })((root.pdfjsCoreCrypto = {}), root.pdfjsSharedUtil, root.pdfjsCorePrimitives, root.pdfjsCoreStream);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, coreStream, coreGlyphList, coreEncodings, coreCFFParser) {
          var Util = sharedUtil.Util,
            bytesToString = sharedUtil.bytesToString,
            error = sharedUtil.error,
            Stream = coreStream.Stream,
            getGlyphsUnicode = coreGlyphList.getGlyphsUnicode,
            StandardEncoding = coreEncodings.StandardEncoding,
            CFFParser = coreCFFParser.CFFParser,
            FontRendererFactory = (function () {
              function getLong(data, offset) {
                return (data[offset] << 24) | (data[offset + 1] << 16) | (data[offset + 2] << 8) | data[offset + 3];
              }
              function getUshort(data, offset) {
                return (data[offset] << 8) | data[offset + 1];
              }
              function parseCmap(data, start, end) {
                var ranges,
                  p,
                  i,
                  offset = 1 === getUshort(data, start + 2) ? getLong(data, start + 8) : getLong(data, start + 16),
                  format = getUshort(data, start + offset);
                if (4 === format) {
                  getUshort(data, start + offset + 2);
                  var segCount = getUshort(data, start + offset + 6) >> 1;
                  for (p = start + offset + 14, ranges = [], i = 0; i < segCount; i++, p += 2)
                    ranges[i] = { end: getUshort(data, p) };
                  for (p += 2, i = 0; i < segCount; i++, p += 2) ranges[i].start = getUshort(data, p);
                  for (i = 0; i < segCount; i++, p += 2) ranges[i].idDelta = getUshort(data, p);
                  for (i = 0; i < segCount; i++, p += 2) {
                    var idOffset = getUshort(data, p);
                    if (0 !== idOffset) {
                      ranges[i].ids = [];
                      for (var j = 0, jj = ranges[i].end - ranges[i].start + 1; j < jj; j++)
                        (ranges[i].ids[j] = getUshort(data, p + idOffset)), (idOffset += 2);
                    }
                  }
                  return ranges;
                }
                if (12 === format) {
                  getLong(data, start + offset + 4);
                  var groups = getLong(data, start + offset + 12);
                  for (p = start + offset + 16, ranges = [], i = 0; i < groups; i++)
                    ranges.push({
                      start: getLong(data, p),
                      end: getLong(data, p + 4),
                      idDelta: getLong(data, p + 8) - getLong(data, p),
                    }),
                      (p += 12);
                  return ranges;
                }
                error("not supported cmap: " + format);
              }
              function parseCff(data, start, end, seacAnalysisEnabled) {
                var properties = {},
                  parser = new CFFParser(new Stream(data, start, end - start), properties, seacAnalysisEnabled),
                  cff = parser.parse();
                return {
                  glyphs: cff.charStrings.objects,
                  subrs:
                    cff.topDict.privateDict &&
                    cff.topDict.privateDict.subrsIndex &&
                    cff.topDict.privateDict.subrsIndex.objects,
                  gsubrs: cff.globalSubrIndex && cff.globalSubrIndex.objects,
                };
              }
              function parseGlyfTable(glyf, loca, isGlyphLocationsLong) {
                var itemSize, itemDecode;
                isGlyphLocationsLong
                  ? ((itemSize = 4),
                    (itemDecode = function (data, offset) {
                      return (
                        (data[offset] << 24) | (data[offset + 1] << 16) | (data[offset + 2] << 8) | data[offset + 3]
                      );
                    }))
                  : ((itemSize = 2),
                    (itemDecode = function (data, offset) {
                      return (data[offset] << 9) | (data[offset + 1] << 1);
                    }));
                for (var glyphs = [], startOffset = itemDecode(loca, 0), j = itemSize; j < loca.length; j += itemSize) {
                  var endOffset = itemDecode(loca, j);
                  glyphs.push(glyf.subarray(startOffset, endOffset)), (startOffset = endOffset);
                }
                return glyphs;
              }
              function lookupCmap(ranges, unicode) {
                for (var code = unicode.charCodeAt(0), gid = 0, l = 0, r = ranges.length - 1; l < r; ) {
                  var c = (l + r + 1) >> 1;
                  code < ranges[c].start ? (r = c - 1) : (l = c);
                }
                return (
                  ranges[l].start <= code &&
                    code <= ranges[l].end &&
                    (gid =
                      (ranges[l].idDelta + (ranges[l].ids ? ranges[l].ids[code - ranges[l].start] : code)) & 65535),
                  { charCode: code, glyphId: gid }
                );
              }
              function compileGlyf(code, cmds, font) {
                function quadraticCurveTo(xa, ya, x, y) {
                  cmds.push({ cmd: "quadraticCurveTo", args: [xa, ya, x, y] });
                }
                var flags,
                  i = 0,
                  numberOfContours = ((code[i] << 24) | (code[i + 1] << 16)) >> 16,
                  x = 0,
                  y = 0;
                if (((i += 10), numberOfContours < 0))
                  do {
                    flags = (code[i] << 8) | code[i + 1];
                    var glyphIndex = (code[i + 2] << 8) | code[i + 3];
                    i += 4;
                    var arg1, arg2;
                    1 & flags
                      ? ((arg1 = ((code[i] << 24) | (code[i + 1] << 16)) >> 16),
                        (arg2 = ((code[i + 2] << 24) | (code[i + 3] << 16)) >> 16),
                        (i += 4))
                      : ((arg1 = code[i++]), (arg2 = code[i++])),
                      2 & flags ? ((x = arg1), (y = arg2)) : ((x = 0), (y = 0));
                    var scaleX = 1,
                      scaleY = 1,
                      scale01 = 0,
                      scale10 = 0;
                    8 & flags
                      ? ((scaleX = scaleY = ((code[i] << 24) | (code[i + 1] << 16)) / 1073741824), (i += 2))
                      : 64 & flags
                      ? ((scaleX = ((code[i] << 24) | (code[i + 1] << 16)) / 1073741824),
                        (scaleY = ((code[i + 2] << 24) | (code[i + 3] << 16)) / 1073741824),
                        (i += 4))
                      : 128 & flags &&
                        ((scaleX = ((code[i] << 24) | (code[i + 1] << 16)) / 1073741824),
                        (scale01 = ((code[i + 2] << 24) | (code[i + 3] << 16)) / 1073741824),
                        (scale10 = ((code[i + 4] << 24) | (code[i + 5] << 16)) / 1073741824),
                        (scaleY = ((code[i + 6] << 24) | (code[i + 7] << 16)) / 1073741824),
                        (i += 8));
                    var subglyph = font.glyphs[glyphIndex];
                    subglyph &&
                      (cmds.push({ cmd: "save" }),
                      cmds.push({ cmd: "transform", args: [scaleX, scale01, scale10, scaleY, x, y] }),
                      compileGlyf(subglyph, cmds, font),
                      cmds.push({ cmd: "restore" }));
                  } while (32 & flags);
                else {
                  var j,
                    jj,
                    endPtsOfContours = [];
                  for (j = 0; j < numberOfContours; j++) endPtsOfContours.push((code[i] << 8) | code[i + 1]), (i += 2);
                  i += 2 + ((code[i] << 8) | code[i + 1]);
                  for (
                    var numberOfPoints = endPtsOfContours[endPtsOfContours.length - 1] + 1, points = [];
                    points.length < numberOfPoints;

                  ) {
                    flags = code[i++];
                    var repeat = 1;
                    for (8 & flags && (repeat += code[i++]); repeat-- > 0; ) points.push({ flags: flags });
                  }
                  for (j = 0; j < numberOfPoints; j++) {
                    switch (18 & points[j].flags) {
                      case 0:
                        (x += ((code[i] << 24) | (code[i + 1] << 16)) >> 16), (i += 2);
                        break;
                      case 2:
                        x -= code[i++];
                        break;
                      case 18:
                        x += code[i++];
                    }
                    points[j].x = x;
                  }
                  for (j = 0; j < numberOfPoints; j++) {
                    switch (36 & points[j].flags) {
                      case 0:
                        (y += ((code[i] << 24) | (code[i + 1] << 16)) >> 16), (i += 2);
                        break;
                      case 4:
                        y -= code[i++];
                        break;
                      case 36:
                        y += code[i++];
                    }
                    points[j].y = y;
                  }
                  var startPoint = 0;
                  for (i = 0; i < numberOfContours; i++) {
                    var endPoint = endPtsOfContours[i],
                      contour = points.slice(startPoint, endPoint + 1);
                    if (1 & contour[0].flags) contour.push(contour[0]);
                    else if (1 & contour[contour.length - 1].flags) contour.unshift(contour[contour.length - 1]);
                    else {
                      var p = {
                        flags: 1,
                        x: (contour[0].x + contour[contour.length - 1].x) / 2,
                        y: (contour[0].y + contour[contour.length - 1].y) / 2,
                      };
                      contour.unshift(p), contour.push(p);
                    }
                    for (
                      (function (x, y) {
                        cmds.push({ cmd: "moveTo", args: [x, y] });
                      })(contour[0].x, contour[0].y),
                        j = 1,
                        jj = contour.length;
                      j < jj;
                      j++
                    )
                      1 & contour[j].flags
                        ? (function (x, y) {
                            cmds.push({ cmd: "lineTo", args: [x, y] });
                          })(contour[j].x, contour[j].y)
                        : 1 & contour[j + 1].flags
                        ? (quadraticCurveTo(contour[j].x, contour[j].y, contour[j + 1].x, contour[j + 1].y), j++)
                        : quadraticCurveTo(
                            contour[j].x,
                            contour[j].y,
                            (contour[j].x + contour[j + 1].x) / 2,
                            (contour[j].y + contour[j + 1].y) / 2
                          );
                    startPoint = endPoint + 1;
                  }
                }
              }
              function compileCharString(code, cmds, font) {
                function moveTo(x, y) {
                  cmds.push({ cmd: "moveTo", args: [x, y] });
                }
                function lineTo(x, y) {
                  cmds.push({ cmd: "lineTo", args: [x, y] });
                }
                function bezierCurveTo(x1, y1, x2, y2, x, y) {
                  cmds.push({ cmd: "bezierCurveTo", args: [x1, y1, x2, y2, x, y] });
                }
                function parse(code) {
                  for (var i = 0; i < code.length; ) {
                    var xa,
                      xb,
                      ya,
                      yb,
                      y1,
                      y2,
                      y3,
                      n,
                      subrCode,
                      stackClean = !1,
                      v = code[i++];
                    switch (v) {
                      case 1:
                      case 3:
                        (stems += stack.length >> 1), (stackClean = !0);
                        break;
                      case 4:
                        (y += stack.pop()), moveTo(x, y), (stackClean = !0);
                        break;
                      case 5:
                        for (; stack.length > 0; ) (x += stack.shift()), (y += stack.shift()), lineTo(x, y);
                        break;
                      case 6:
                        for (; stack.length > 0 && ((x += stack.shift()), lineTo(x, y), 0 !== stack.length); )
                          (y += stack.shift()), lineTo(x, y);
                        break;
                      case 7:
                        for (; stack.length > 0 && ((y += stack.shift()), lineTo(x, y), 0 !== stack.length); )
                          (x += stack.shift()), lineTo(x, y);
                        break;
                      case 8:
                        for (; stack.length > 0; )
                          (xa = x + stack.shift()),
                            (ya = y + stack.shift()),
                            (xb = xa + stack.shift()),
                            (yb = ya + stack.shift()),
                            (x = xb + stack.shift()),
                            (y = yb + stack.shift()),
                            bezierCurveTo(xa, ya, xb, yb, x, y);
                        break;
                      case 10:
                        (n = stack.pop() + font.subrsBias), (subrCode = font.subrs[n]), subrCode && parse(subrCode);
                        break;
                      case 11:
                        return;
                      case 12:
                        switch ((v = code[i++])) {
                          case 34:
                            (xa = x + stack.shift()),
                              (xb = xa + stack.shift()),
                              (y1 = y + stack.shift()),
                              (x = xb + stack.shift()),
                              bezierCurveTo(xa, y, xb, y1, x, y1),
                              (xa = x + stack.shift()),
                              (xb = xa + stack.shift()),
                              (x = xb + stack.shift()),
                              bezierCurveTo(xa, y1, xb, y, x, y);
                            break;
                          case 35:
                            (xa = x + stack.shift()),
                              (ya = y + stack.shift()),
                              (xb = xa + stack.shift()),
                              (yb = ya + stack.shift()),
                              (x = xb + stack.shift()),
                              (y = yb + stack.shift()),
                              bezierCurveTo(xa, ya, xb, yb, x, y),
                              (xa = x + stack.shift()),
                              (ya = y + stack.shift()),
                              (xb = xa + stack.shift()),
                              (yb = ya + stack.shift()),
                              (x = xb + stack.shift()),
                              (y = yb + stack.shift()),
                              bezierCurveTo(xa, ya, xb, yb, x, y),
                              stack.pop();
                            break;
                          case 36:
                            (xa = x + stack.shift()),
                              (y1 = y + stack.shift()),
                              (xb = xa + stack.shift()),
                              (y2 = y1 + stack.shift()),
                              (x = xb + stack.shift()),
                              bezierCurveTo(xa, y1, xb, y2, x, y2),
                              (xa = x + stack.shift()),
                              (xb = xa + stack.shift()),
                              (y3 = y2 + stack.shift()),
                              (x = xb + stack.shift()),
                              bezierCurveTo(xa, y2, xb, y3, x, y);
                            break;
                          case 37:
                            var x0 = x,
                              y0 = y;
                            (xa = x + stack.shift()),
                              (ya = y + stack.shift()),
                              (xb = xa + stack.shift()),
                              (yb = ya + stack.shift()),
                              (x = xb + stack.shift()),
                              (y = yb + stack.shift()),
                              bezierCurveTo(xa, ya, xb, yb, x, y),
                              (xa = x + stack.shift()),
                              (ya = y + stack.shift()),
                              (xb = xa + stack.shift()),
                              (yb = ya + stack.shift()),
                              (x = xb),
                              (y = yb),
                              Math.abs(x - x0) > Math.abs(y - y0) ? (x += stack.shift()) : (y += stack.shift()),
                              bezierCurveTo(xa, ya, xb, yb, x, y);
                            break;
                          default:
                            error("unknown operator: 12 " + v);
                        }
                        break;
                      case 14:
                        if (stack.length >= 4) {
                          var achar = stack.pop(),
                            bchar = stack.pop();
                          (y = stack.pop()),
                            (x = stack.pop()),
                            cmds.push({ cmd: "save" }),
                            cmds.push({ cmd: "translate", args: [x, y] });
                          var cmap = lookupCmap(
                            font.cmap,
                            String.fromCharCode(font.glyphNameMap[StandardEncoding[achar]])
                          );
                          compileCharString(font.glyphs[cmap.glyphId], cmds, font),
                            cmds.push({ cmd: "restore" }),
                            (cmap = lookupCmap(
                              font.cmap,
                              String.fromCharCode(font.glyphNameMap[StandardEncoding[bchar]])
                            )),
                            compileCharString(font.glyphs[cmap.glyphId], cmds, font);
                        }
                        return;
                      case 18:
                        (stems += stack.length >> 1), (stackClean = !0);
                        break;
                      case 19:
                      case 20:
                        (stems += stack.length >> 1), (i += (stems + 7) >> 3), (stackClean = !0);
                        break;
                      case 21:
                        (y += stack.pop()), (x += stack.pop()), moveTo(x, y), (stackClean = !0);
                        break;
                      case 22:
                        (x += stack.pop()), moveTo(x, y), (stackClean = !0);
                        break;
                      case 23:
                        (stems += stack.length >> 1), (stackClean = !0);
                        break;
                      case 24:
                        for (; stack.length > 2; )
                          (xa = x + stack.shift()),
                            (ya = y + stack.shift()),
                            (xb = xa + stack.shift()),
                            (yb = ya + stack.shift()),
                            (x = xb + stack.shift()),
                            (y = yb + stack.shift()),
                            bezierCurveTo(xa, ya, xb, yb, x, y);
                        (x += stack.shift()), (y += stack.shift()), lineTo(x, y);
                        break;
                      case 25:
                        for (; stack.length > 6; ) (x += stack.shift()), (y += stack.shift()), lineTo(x, y);
                        (xa = x + stack.shift()),
                          (ya = y + stack.shift()),
                          (xb = xa + stack.shift()),
                          (yb = ya + stack.shift()),
                          (x = xb + stack.shift()),
                          (y = yb + stack.shift()),
                          bezierCurveTo(xa, ya, xb, yb, x, y);
                        break;
                      case 26:
                        for (stack.length % 2 && (x += stack.shift()); stack.length > 0; )
                          (xa = x),
                            (ya = y + stack.shift()),
                            (xb = xa + stack.shift()),
                            (yb = ya + stack.shift()),
                            (x = xb),
                            (y = yb + stack.shift()),
                            bezierCurveTo(xa, ya, xb, yb, x, y);
                        break;
                      case 27:
                        for (stack.length % 2 && (y += stack.shift()); stack.length > 0; )
                          (xa = x + stack.shift()),
                            (ya = y),
                            (xb = xa + stack.shift()),
                            (yb = ya + stack.shift()),
                            (x = xb + stack.shift()),
                            (y = yb),
                            bezierCurveTo(xa, ya, xb, yb, x, y);
                        break;
                      case 28:
                        stack.push(((code[i] << 24) | (code[i + 1] << 16)) >> 16), (i += 2);
                        break;
                      case 29:
                        (n = stack.pop() + font.gsubrsBias), (subrCode = font.gsubrs[n]), subrCode && parse(subrCode);
                        break;
                      case 30:
                        for (
                          ;
                          stack.length > 0 &&
                          ((xa = x),
                          (ya = y + stack.shift()),
                          (xb = xa + stack.shift()),
                          (yb = ya + stack.shift()),
                          (x = xb + stack.shift()),
                          (y = yb + (1 === stack.length ? stack.shift() : 0)),
                          bezierCurveTo(xa, ya, xb, yb, x, y),
                          0 !== stack.length);

                        )
                          (xa = x + stack.shift()),
                            (ya = y),
                            (xb = xa + stack.shift()),
                            (yb = ya + stack.shift()),
                            (y = yb + stack.shift()),
                            (x = xb + (1 === stack.length ? stack.shift() : 0)),
                            bezierCurveTo(xa, ya, xb, yb, x, y);
                        break;
                      case 31:
                        for (
                          ;
                          stack.length > 0 &&
                          ((xa = x + stack.shift()),
                          (ya = y),
                          (xb = xa + stack.shift()),
                          (yb = ya + stack.shift()),
                          (y = yb + stack.shift()),
                          (x = xb + (1 === stack.length ? stack.shift() : 0)),
                          bezierCurveTo(xa, ya, xb, yb, x, y),
                          0 !== stack.length);

                        )
                          (xa = x),
                            (ya = y + stack.shift()),
                            (xb = xa + stack.shift()),
                            (yb = ya + stack.shift()),
                            (x = xb + stack.shift()),
                            (y = yb + (1 === stack.length ? stack.shift() : 0)),
                            bezierCurveTo(xa, ya, xb, yb, x, y);
                        break;
                      default:
                        v < 32 && error("unknown operator: " + v),
                          v < 247
                            ? stack.push(v - 139)
                            : v < 251
                            ? stack.push(256 * (v - 247) + code[i++] + 108)
                            : v < 255
                            ? stack.push(256 * -(v - 251) - code[i++] - 108)
                            : (stack.push(
                                ((code[i] << 24) | (code[i + 1] << 16) | (code[i + 2] << 8) | code[i + 3]) / 65536
                              ),
                              (i += 4));
                    }
                    stackClean && (stack.length = 0);
                  }
                }
                var stack = [],
                  x = 0,
                  y = 0,
                  stems = 0;
                parse(code);
              }
              function CompiledFont(fontMatrix) {
                (this.compiledGlyphs = Object.create(null)),
                  (this.compiledCharCodeToGlyphId = Object.create(null)),
                  (this.fontMatrix = fontMatrix);
              }
              function TrueTypeCompiled(glyphs, cmap, fontMatrix) {
                (fontMatrix = fontMatrix || [488e-6, 0, 0, 488e-6, 0, 0]),
                  CompiledFont.call(this, fontMatrix),
                  (this.glyphs = glyphs),
                  (this.cmap = cmap);
              }
              function Type2Compiled(cffInfo, cmap, fontMatrix, glyphNameMap) {
                (fontMatrix = fontMatrix || [0.001, 0, 0, 0.001, 0, 0]),
                  CompiledFont.call(this, fontMatrix),
                  (this.glyphs = cffInfo.glyphs),
                  (this.gsubrs = cffInfo.gsubrs || []),
                  (this.subrs = cffInfo.subrs || []),
                  (this.cmap = cmap),
                  (this.glyphNameMap = glyphNameMap || getGlyphsUnicode()),
                  (this.gsubrsBias = this.gsubrs.length < 1240 ? 107 : this.gsubrs.length < 33900 ? 1131 : 32768),
                  (this.subrsBias = this.subrs.length < 1240 ? 107 : this.subrs.length < 33900 ? 1131 : 32768);
              }
              return (
                (CompiledFont.prototype = {
                  getPathJs: function (unicode) {
                    var cmap = lookupCmap(this.cmap, unicode),
                      fn = this.compiledGlyphs[cmap.glyphId];
                    return (
                      fn ||
                        ((fn = this.compileGlyph(this.glyphs[cmap.glyphId])), (this.compiledGlyphs[cmap.glyphId] = fn)),
                      void 0 === this.compiledCharCodeToGlyphId[cmap.charCode] &&
                        (this.compiledCharCodeToGlyphId[cmap.charCode] = cmap.glyphId),
                      fn
                    );
                  },
                  compileGlyph: function (code) {
                    if (!code || 0 === code.length || 14 === code[0]) return "";
                    var cmds = [];
                    return (
                      cmds.push({ cmd: "save" }),
                      cmds.push({ cmd: "transform", args: this.fontMatrix.slice() }),
                      cmds.push({ cmd: "scale", args: ["size", "-size"] }),
                      this.compileGlyphImpl(code, cmds),
                      cmds.push({ cmd: "restore" }),
                      cmds
                    );
                  },
                  compileGlyphImpl: function () {
                    error("Children classes should implement this.");
                  },
                  hasBuiltPath: function (unicode) {
                    var cmap = lookupCmap(this.cmap, unicode);
                    return (
                      void 0 !== this.compiledGlyphs[cmap.glyphId] &&
                      void 0 !== this.compiledCharCodeToGlyphId[cmap.charCode]
                    );
                  },
                }),
                Util.inherit(TrueTypeCompiled, CompiledFont, {
                  compileGlyphImpl: function (code, cmds) {
                    compileGlyf(code, cmds, this);
                  },
                }),
                Util.inherit(Type2Compiled, CompiledFont, {
                  compileGlyphImpl: function (code, cmds) {
                    compileCharString(code, cmds, this);
                  },
                }),
                {
                  create: function (font, seacAnalysisEnabled) {
                    for (
                      var cmap,
                        glyf,
                        loca,
                        cff,
                        indexToLocFormat,
                        unitsPerEm,
                        data = new Uint8Array(font.data),
                        numTables = getUshort(data, 4),
                        i = 0,
                        p = 12;
                      i < numTables;
                      i++, p += 16
                    ) {
                      var tag = bytesToString(data.subarray(p, p + 4)),
                        offset = getLong(data, p + 8),
                        length = getLong(data, p + 12);
                      switch (tag) {
                        case "cmap":
                          cmap = parseCmap(data, offset, offset + length);
                          break;
                        case "glyf":
                          glyf = data.subarray(offset, offset + length);
                          break;
                        case "loca":
                          loca = data.subarray(offset, offset + length);
                          break;
                        case "head":
                          (unitsPerEm = getUshort(data, offset + 18)),
                            (indexToLocFormat = getUshort(data, offset + 50));
                          break;
                        case "CFF ":
                          cff = parseCff(data, offset, offset + length, seacAnalysisEnabled);
                      }
                    }
                    if (glyf) {
                      var fontMatrix = unitsPerEm ? [1 / unitsPerEm, 0, 0, 1 / unitsPerEm, 0, 0] : font.fontMatrix;
                      return new TrueTypeCompiled(parseGlyfTable(glyf, loca, indexToLocFormat), cmap, fontMatrix);
                    }
                    return new Type2Compiled(cff, cmap, font.fontMatrix, font.glyphNameMap);
                  },
                }
              );
            })();
          exports.FontRendererFactory = FontRendererFactory;
        })(
          (root.pdfjsCoreFontRenderer = {}),
          root.pdfjsSharedUtil,
          root.pdfjsCoreStream,
          root.pdfjsCoreGlyphList,
          root.pdfjsCoreEncodings,
          root.pdfjsCoreCFFParser
        );
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, corePrimitives, coreStream) {
          function isEOF(v) {
            return v === EOF;
          }
          var MissingDataException = sharedUtil.MissingDataException,
            StreamType = sharedUtil.StreamType,
            assert = sharedUtil.assert,
            error = sharedUtil.error,
            info = sharedUtil.info,
            isArray = sharedUtil.isArray,
            isInt = sharedUtil.isInt,
            isNum = sharedUtil.isNum,
            isString = sharedUtil.isString,
            warn = sharedUtil.warn,
            Cmd = corePrimitives.Cmd,
            Dict = corePrimitives.Dict,
            Name = corePrimitives.Name,
            Ref = corePrimitives.Ref,
            isCmd = corePrimitives.isCmd,
            isDict = corePrimitives.isDict,
            isName = corePrimitives.isName,
            Ascii85Stream = coreStream.Ascii85Stream,
            AsciiHexStream = coreStream.AsciiHexStream,
            CCITTFaxStream = coreStream.CCITTFaxStream,
            FlateStream = coreStream.FlateStream,
            Jbig2Stream = coreStream.Jbig2Stream,
            JpegStream = coreStream.JpegStream,
            JpxStream = coreStream.JpxStream,
            LZWStream = coreStream.LZWStream,
            NullStream = coreStream.NullStream,
            PredictorStream = coreStream.PredictorStream,
            RunLengthStream = coreStream.RunLengthStream,
            EOF = {},
            Parser = (function () {
              function Parser(lexer, allowStreams, xref, recoveryMode) {
                (this.lexer = lexer),
                  (this.allowStreams = allowStreams),
                  (this.xref = xref),
                  (this.recoveryMode = recoveryMode || !1),
                  (this.imageCache = Object.create(null)),
                  this.refill();
              }
              return (
                (Parser.prototype = {
                  refill: function () {
                    (this.buf1 = this.lexer.getObj()), (this.buf2 = this.lexer.getObj());
                  },
                  shift: function () {
                    isCmd(this.buf2, "ID")
                      ? ((this.buf1 = this.buf2), (this.buf2 = null))
                      : ((this.buf1 = this.buf2), (this.buf2 = this.lexer.getObj()));
                  },
                  tryShift: function () {
                    try {
                      return this.shift(), !0;
                    } catch (e) {
                      if (e instanceof MissingDataException) throw e;
                      return !1;
                    }
                  },
                  getObj: function (cipherTransform) {
                    var buf1 = this.buf1;
                    if ((this.shift(), buf1 instanceof Cmd))
                      switch (buf1.cmd) {
                        case "BI":
                          return this.makeInlineImage(cipherTransform);
                        case "[":
                          for (var array = []; !isCmd(this.buf1, "]") && !isEOF(this.buf1); )
                            array.push(this.getObj(cipherTransform));
                          return isEOF(this.buf1)
                            ? (this.recoveryMode || error("End of file inside array"), array)
                            : (this.shift(), array);
                        case "<<":
                          for (var dict = new Dict(this.xref); !isCmd(this.buf1, ">>") && !isEOF(this.buf1); )
                            if (isName(this.buf1)) {
                              var key = this.buf1.name;
                              if ((this.shift(), isEOF(this.buf1))) break;
                              dict.set(key, this.getObj(cipherTransform));
                            } else info("Malformed dictionary: key must be a name object"), this.shift();
                          return isEOF(this.buf1)
                            ? (this.recoveryMode || error("End of file inside dictionary"), dict)
                            : isCmd(this.buf2, "stream")
                            ? this.allowStreams
                              ? this.makeStream(dict, cipherTransform)
                              : dict
                            : (this.shift(), dict);
                        default:
                          return buf1;
                      }
                    if (isInt(buf1)) {
                      var num = buf1;
                      if (isInt(this.buf1) && isCmd(this.buf2, "R")) {
                        var ref = new Ref(num, this.buf1);
                        return this.shift(), this.shift(), ref;
                      }
                      return num;
                    }
                    if (isString(buf1)) {
                      var str = buf1;
                      return cipherTransform && (str = cipherTransform.decryptString(str)), str;
                    }
                    return buf1;
                  },
                  findDefaultInlineStreamEnd: function (stream) {
                    for (
                      var ch, i, n, followingBytes, startPos = stream.pos, state = 0;
                      -1 !== (ch = stream.getByte());

                    )
                      if (0 === state) state = 69 === ch ? 1 : 0;
                      else if (1 === state) state = 73 === ch ? 2 : 0;
                      else if ((assert(2 === state), 32 === ch || 10 === ch || 13 === ch)) {
                        for (n = 5, followingBytes = stream.peekBytes(n), i = 0; i < n; i++)
                          if (10 !== (ch = followingBytes[i]) && 13 !== ch && (ch < 32 || ch > 127)) {
                            state = 0;
                            break;
                          }
                        if (2 === state) break;
                      } else state = 0;
                    return stream.pos - 4 - startPos;
                  },
                  findDCTDecodeInlineStreamEnd: function (stream) {
                    for (
                      var b, markerLength, length, startPos = stream.pos, foundEOI = !1;
                      -1 !== (b = stream.getByte());

                    )
                      if (255 === b) {
                        switch (stream.getByte()) {
                          case 0:
                            break;
                          case 255:
                            stream.skip(-1);
                            break;
                          case 217:
                            foundEOI = !0;
                            break;
                          case 192:
                          case 193:
                          case 194:
                          case 195:
                          case 197:
                          case 198:
                          case 199:
                          case 201:
                          case 202:
                          case 203:
                          case 205:
                          case 206:
                          case 207:
                          case 196:
                          case 204:
                          case 218:
                          case 219:
                          case 220:
                          case 221:
                          case 222:
                          case 223:
                          case 224:
                          case 225:
                          case 226:
                          case 227:
                          case 228:
                          case 229:
                          case 230:
                          case 231:
                          case 232:
                          case 233:
                          case 234:
                          case 235:
                          case 236:
                          case 237:
                          case 238:
                          case 239:
                          case 254:
                            (markerLength = stream.getUint16()),
                              markerLength > 2 ? stream.skip(markerLength - 2) : stream.skip(-2);
                        }
                        if (foundEOI) break;
                      }
                    return (
                      (length = stream.pos - startPos),
                      -1 === b
                        ? (warn("Inline DCTDecode image stream: EOI marker not found, searching for /EI/ instead."),
                          stream.skip(-length),
                          this.findDefaultInlineStreamEnd(stream))
                        : (this.inlineStreamSkipEI(stream), length)
                    );
                  },
                  findASCII85DecodeInlineStreamEnd: function (stream) {
                    for (var ch, length, startPos = stream.pos; -1 !== (ch = stream.getByte()); )
                      if (126 === ch && 62 === stream.peekByte()) {
                        stream.skip();
                        break;
                      }
                    return (
                      (length = stream.pos - startPos),
                      -1 === ch
                        ? (warn("Inline ASCII85Decode image stream: EOD marker not found, searching for /EI/ instead."),
                          stream.skip(-length),
                          this.findDefaultInlineStreamEnd(stream))
                        : (this.inlineStreamSkipEI(stream), length)
                    );
                  },
                  findASCIIHexDecodeInlineStreamEnd: function (stream) {
                    for (var ch, length, startPos = stream.pos; -1 !== (ch = stream.getByte()) && 62 !== ch; );
                    return (
                      (length = stream.pos - startPos),
                      -1 === ch
                        ? (warn(
                            "Inline ASCIIHexDecode image stream: EOD marker not found, searching for /EI/ instead."
                          ),
                          stream.skip(-length),
                          this.findDefaultInlineStreamEnd(stream))
                        : (this.inlineStreamSkipEI(stream), length)
                    );
                  },
                  inlineStreamSkipEI: function (stream) {
                    for (var ch, state = 0; -1 !== (ch = stream.getByte()); )
                      if (0 === state) state = 69 === ch ? 1 : 0;
                      else if (1 === state) state = 73 === ch ? 2 : 0;
                      else if (2 === state) break;
                  },
                  makeInlineImage: function (cipherTransform) {
                    for (
                      var lexer = this.lexer, stream = lexer.stream, dict = new Dict(this.xref);
                      !isCmd(this.buf1, "ID") && !isEOF(this.buf1);

                    ) {
                      isName(this.buf1) || error("Dictionary key must be a name object");
                      var key = this.buf1.name;
                      if ((this.shift(), isEOF(this.buf1))) break;
                      dict.set(key, this.getObj(cipherTransform));
                    }
                    var filterName,
                      filter = dict.get("Filter", "F");
                    isName(filter)
                      ? (filterName = filter.name)
                      : isArray(filter) && isName(filter[0]) && (filterName = filter[0].name);
                    var length,
                      i,
                      ii,
                      startPos = stream.pos;
                    length =
                      "DCTDecode" === filterName || "DCT" === filterName
                        ? this.findDCTDecodeInlineStreamEnd(stream)
                        : "ASCII85Decide" === filterName || "A85" === filterName
                        ? this.findASCII85DecodeInlineStreamEnd(stream)
                        : "ASCIIHexDecode" === filterName || "AHx" === filterName
                        ? this.findASCIIHexDecodeInlineStreamEnd(stream)
                        : this.findDefaultInlineStreamEnd(stream);
                    var adler32,
                      imageStream = stream.makeSubStream(startPos, length, dict);
                    if (length < 1e3) {
                      var imageBytes = imageStream.getBytes();
                      imageStream.reset();
                      var a = 1,
                        b = 0;
                      for (i = 0, ii = imageBytes.length; i < ii; ++i) (a += 255 & imageBytes[i]), (b += a);
                      if (((adler32 = (b % 65521 << 16) | a % 65521), this.imageCache.adler32 === adler32))
                        return (
                          (this.buf2 = Cmd.get("EI")),
                          this.shift(),
                          this.imageCache[adler32].reset(),
                          this.imageCache[adler32]
                        );
                    }
                    return (
                      cipherTransform && (imageStream = cipherTransform.createStream(imageStream, length)),
                      (imageStream = this.filter(imageStream, dict, length)),
                      (imageStream.dict = dict),
                      void 0 !== adler32 &&
                        ((imageStream.cacheKey = "inline_" + length + "_" + adler32),
                        (this.imageCache[adler32] = imageStream)),
                      (this.buf2 = Cmd.get("EI")),
                      this.shift(),
                      imageStream
                    );
                  },
                  makeStream: function (dict, cipherTransform) {
                    var lexer = this.lexer,
                      stream = lexer.stream;
                    lexer.skipToNextLine();
                    var pos = stream.pos - 1,
                      length = dict.get("Length");
                    if (
                      (isInt(length) || (info("Bad " + length + " attribute in stream"), (length = 0)),
                      (stream.pos = pos + length),
                      lexer.nextChar(),
                      this.tryShift() && isCmd(this.buf2, "endstream"))
                    )
                      this.shift();
                    else {
                      stream.pos = pos;
                      for (
                        var i,
                          j,
                          ENDSTREAM_SIGNATURE = [101, 110, 100, 115, 116, 114, 101, 97, 109],
                          skipped = 0,
                          found = !1;
                        stream.pos < stream.end;

                      ) {
                        var scanBytes = stream.peekBytes(2048),
                          scanLength = scanBytes.length - 9;
                        if (scanLength <= 0) break;
                        for (found = !1, i = 0; i < scanLength; ) {
                          for (j = 0; j < 9 && scanBytes[i + j] === ENDSTREAM_SIGNATURE[j]; ) j++;
                          if (j >= 9) {
                            found = !0;
                            break;
                          }
                          i++;
                        }
                        if (found) {
                          (skipped += i), (stream.pos += i);
                          break;
                        }
                        (skipped += scanLength), (stream.pos += scanLength);
                      }
                      found || error("Missing endstream"),
                        (length = skipped),
                        lexer.nextChar(),
                        this.shift(),
                        this.shift();
                    }
                    return (
                      this.shift(),
                      (stream = stream.makeSubStream(pos, length, dict)),
                      cipherTransform && (stream = cipherTransform.createStream(stream, length)),
                      (stream = this.filter(stream, dict, length)),
                      (stream.dict = dict),
                      stream
                    );
                  },
                  filter: function (stream, dict, length) {
                    var filter = dict.get("Filter", "F"),
                      params = dict.get("DecodeParms", "DP");
                    if (isName(filter)) return this.makeFilter(stream, filter.name, length, params);
                    var maybeLength = length;
                    if (isArray(filter))
                      for (var filterArray = filter, paramsArray = params, i = 0, ii = filterArray.length; i < ii; ++i)
                        (filter = filterArray[i]),
                          isName(filter) || error("Bad filter name: " + filter),
                          (params = null),
                          isArray(paramsArray) && i in paramsArray && (params = paramsArray[i]),
                          (stream = this.makeFilter(stream, filter.name, maybeLength, params)),
                          (maybeLength = null);
                    return stream;
                  },
                  makeFilter: function (stream, name, maybeLength, params) {
                    if (0 === stream.dict.get("Length") && !maybeLength)
                      return warn('Empty "' + name + '" stream.'), new NullStream(stream);
                    try {
                      params && this.xref && (params = this.xref.fetchIfRef(params));
                      var xrefStreamStats = this.xref.stats.streamTypes;
                      if ("FlateDecode" === name || "Fl" === name)
                        return (
                          (xrefStreamStats[StreamType.FLATE] = !0),
                          params
                            ? new PredictorStream(new FlateStream(stream, maybeLength), maybeLength, params)
                            : new FlateStream(stream, maybeLength)
                        );
                      if ("LZWDecode" === name || "LZW" === name) {
                        xrefStreamStats[StreamType.LZW] = !0;
                        var earlyChange = 1;
                        return params
                          ? (params.has("EarlyChange") && (earlyChange = params.get("EarlyChange")),
                            new PredictorStream(new LZWStream(stream, maybeLength, earlyChange), maybeLength, params))
                          : new LZWStream(stream, maybeLength, earlyChange);
                      }
                      return "DCTDecode" === name || "DCT" === name
                        ? ((xrefStreamStats[StreamType.DCT] = !0), new JpegStream(stream, maybeLength, stream.dict))
                        : "JPXDecode" === name || "JPX" === name
                        ? ((xrefStreamStats[StreamType.JPX] = !0), new JpxStream(stream, maybeLength, stream.dict))
                        : "ASCII85Decode" === name || "A85" === name
                        ? ((xrefStreamStats[StreamType.A85] = !0), new Ascii85Stream(stream, maybeLength))
                        : "ASCIIHexDecode" === name || "AHx" === name
                        ? ((xrefStreamStats[StreamType.AHX] = !0), new AsciiHexStream(stream, maybeLength))
                        : "CCITTFaxDecode" === name || "CCF" === name
                        ? ((xrefStreamStats[StreamType.CCF] = !0), new CCITTFaxStream(stream, maybeLength, params))
                        : "RunLengthDecode" === name || "RL" === name
                        ? ((xrefStreamStats[StreamType.RL] = !0), new RunLengthStream(stream, maybeLength))
                        : "JBIG2Decode" === name
                        ? ((xrefStreamStats[StreamType.JBIG] = !0), new Jbig2Stream(stream, maybeLength, stream.dict))
                        : (warn('filter "' + name + '" not supported yet'), stream);
                    } catch (ex) {
                      if (ex instanceof MissingDataException) throw ex;
                      return warn('Invalid stream: "' + ex + '"'), new NullStream(stream);
                    }
                  },
                }),
                Parser
              );
            })(),
            Lexer = (function () {
              function Lexer(stream, knownCommands) {
                (this.stream = stream), this.nextChar(), (this.strBuf = []), (this.knownCommands = knownCommands);
              }
              function toHexDigit(ch) {
                return ch >= 48 && ch <= 57
                  ? 15 & ch
                  : (ch >= 65 && ch <= 70) || (ch >= 97 && ch <= 102)
                  ? 9 + (15 & ch)
                  : -1;
              }
              var specialChars = [
                1,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                1,
                1,
                0,
                1,
                1,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                1,
                0,
                0,
                0,
                0,
                2,
                0,
                0,
                2,
                2,
                0,
                0,
                0,
                0,
                0,
                2,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                2,
                0,
                2,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                2,
                0,
                2,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                2,
                0,
                2,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
                0,
              ];
              return (
                (Lexer.prototype = {
                  nextChar: function () {
                    return (this.currentChar = this.stream.getByte());
                  },
                  peekChar: function () {
                    return this.stream.peekByte();
                  },
                  getNumber: function () {
                    var ch = this.currentChar,
                      eNotation = !1,
                      divideBy = 0,
                      sign = 1;
                    if (
                      (45 === ch
                        ? ((sign = -1), 45 === (ch = this.nextChar()) && (ch = this.nextChar()))
                        : 43 === ch && (ch = this.nextChar()),
                      46 === ch && ((divideBy = 10), (ch = this.nextChar())),
                      ch < 48 || ch > 57)
                    )
                      return error("Invalid number: " + String.fromCharCode(ch)), 0;
                    for (var baseValue = ch - 48, powerValue = 0, powerValueSign = 1; (ch = this.nextChar()) >= 0; )
                      if (48 <= ch && ch <= 57) {
                        var currentDigit = ch - 48;
                        eNotation
                          ? (powerValue = 10 * powerValue + currentDigit)
                          : (0 !== divideBy && (divideBy *= 10), (baseValue = 10 * baseValue + currentDigit));
                      } else if (46 === ch) {
                        if (0 !== divideBy) break;
                        divideBy = 1;
                      } else if (45 === ch) warn("Badly formatted number");
                      else {
                        if (69 !== ch && 101 !== ch) break;
                        if (43 === (ch = this.peekChar()) || 45 === ch)
                          (powerValueSign = 45 === ch ? -1 : 1), this.nextChar();
                        else if (ch < 48 || ch > 57) break;
                        eNotation = !0;
                      }
                    return (
                      0 !== divideBy && (baseValue /= divideBy),
                      eNotation && (baseValue *= Math.pow(10, powerValueSign * powerValue)),
                      sign * baseValue
                    );
                  },
                  getString: function () {
                    var numParen = 1,
                      done = !1,
                      strBuf = this.strBuf;
                    strBuf.length = 0;
                    for (var ch = this.nextChar(); ; ) {
                      var charBuffered = !1;
                      switch (0 | ch) {
                        case -1:
                          warn("Unterminated string"), (done = !0);
                          break;
                        case 40:
                          ++numParen, strBuf.push("(");
                          break;
                        case 41:
                          0 == --numParen ? (this.nextChar(), (done = !0)) : strBuf.push(")");
                          break;
                        case 92:
                          switch ((ch = this.nextChar())) {
                            case -1:
                              warn("Unterminated string"), (done = !0);
                              break;
                            case 110:
                              strBuf.push("\n");
                              break;
                            case 114:
                              strBuf.push("\r");
                              break;
                            case 116:
                              strBuf.push("\t");
                              break;
                            case 98:
                              strBuf.push("\b");
                              break;
                            case 102:
                              strBuf.push("\f");
                              break;
                            case 92:
                            case 40:
                            case 41:
                              strBuf.push(String.fromCharCode(ch));
                              break;
                            case 48:
                            case 49:
                            case 50:
                            case 51:
                            case 52:
                            case 53:
                            case 54:
                            case 55:
                              var x = 15 & ch;
                              (ch = this.nextChar()),
                                (charBuffered = !0),
                                ch >= 48 &&
                                  ch <= 55 &&
                                  ((x = (x << 3) + (15 & ch)),
                                  (ch = this.nextChar()) >= 48 &&
                                    ch <= 55 &&
                                    ((charBuffered = !1), (x = (x << 3) + (15 & ch)))),
                                strBuf.push(String.fromCharCode(x));
                              break;
                            case 13:
                              10 === this.peekChar() && this.nextChar();
                              break;
                            case 10:
                              break;
                            default:
                              strBuf.push(String.fromCharCode(ch));
                          }
                          break;
                        default:
                          strBuf.push(String.fromCharCode(ch));
                      }
                      if (done) break;
                      charBuffered || (ch = this.nextChar());
                    }
                    return strBuf.join("");
                  },
                  getName: function () {
                    var ch,
                      previousCh,
                      strBuf = this.strBuf;
                    for (strBuf.length = 0; (ch = this.nextChar()) >= 0 && !specialChars[ch]; )
                      if (35 === ch) {
                        if (((ch = this.nextChar()), specialChars[ch])) {
                          warn("Lexer_getName: NUMBER SIGN (#) should be followed by a hexadecimal number."),
                            strBuf.push("#");
                          break;
                        }
                        var x = toHexDigit(ch);
                        if (-1 !== x) {
                          (previousCh = ch), (ch = this.nextChar());
                          var x2 = toHexDigit(ch);
                          if (-1 === x2) {
                            if (
                              (warn(
                                "Lexer_getName: Illegal digit (" + String.fromCharCode(ch) + ") in hexadecimal number."
                              ),
                              strBuf.push("#", String.fromCharCode(previousCh)),
                              specialChars[ch])
                            )
                              break;
                            strBuf.push(String.fromCharCode(ch));
                            continue;
                          }
                          strBuf.push(String.fromCharCode((x << 4) | x2));
                        } else strBuf.push("#", String.fromCharCode(ch));
                      } else strBuf.push(String.fromCharCode(ch));
                    return (
                      strBuf.length > 127 && warn("name token is longer than allowed by the spec: " + strBuf.length),
                      Name.get(strBuf.join(""))
                    );
                  },
                  getHexString: function () {
                    var strBuf = this.strBuf;
                    strBuf.length = 0;
                    for (var firstDigit, secondDigit, ch = this.currentChar, isFirstHex = !0; ; ) {
                      if (ch < 0) {
                        warn("Unterminated hex string");
                        break;
                      }
                      if (62 === ch) {
                        this.nextChar();
                        break;
                      }
                      if (1 !== specialChars[ch]) {
                        if (isFirstHex) {
                          if (-1 === (firstDigit = toHexDigit(ch))) {
                            warn('Ignoring invalid character "' + ch + '" in hex string'), (ch = this.nextChar());
                            continue;
                          }
                        } else {
                          if (-1 === (secondDigit = toHexDigit(ch))) {
                            warn('Ignoring invalid character "' + ch + '" in hex string'), (ch = this.nextChar());
                            continue;
                          }
                          strBuf.push(String.fromCharCode((firstDigit << 4) | secondDigit));
                        }
                        (isFirstHex = !isFirstHex), (ch = this.nextChar());
                      } else ch = this.nextChar();
                    }
                    return strBuf.join("");
                  },
                  getObj: function () {
                    for (var comment = !1, ch = this.currentChar; ; ) {
                      if (ch < 0) return EOF;
                      if (comment) (10 !== ch && 13 !== ch) || (comment = !1);
                      else if (37 === ch) comment = !0;
                      else if (1 !== specialChars[ch]) break;
                      ch = this.nextChar();
                    }
                    switch (0 | ch) {
                      case 48:
                      case 49:
                      case 50:
                      case 51:
                      case 52:
                      case 53:
                      case 54:
                      case 55:
                      case 56:
                      case 57:
                      case 43:
                      case 45:
                      case 46:
                        return this.getNumber();
                      case 40:
                        return this.getString();
                      case 47:
                        return this.getName();
                      case 91:
                        return this.nextChar(), Cmd.get("[");
                      case 93:
                        return this.nextChar(), Cmd.get("]");
                      case 60:
                        return (
                          (ch = this.nextChar()), 60 === ch ? (this.nextChar(), Cmd.get("<<")) : this.getHexString()
                        );
                      case 62:
                        return (ch = this.nextChar()), 62 === ch ? (this.nextChar(), Cmd.get(">>")) : Cmd.get(">");
                      case 123:
                        return this.nextChar(), Cmd.get("{");
                      case 125:
                        return this.nextChar(), Cmd.get("}");
                      case 41:
                        error("Illegal character: " + ch);
                    }
                    for (
                      var str = String.fromCharCode(ch),
                        knownCommands = this.knownCommands,
                        knownCommandFound = knownCommands && void 0 !== knownCommands[str];
                      (ch = this.nextChar()) >= 0 && !specialChars[ch];

                    ) {
                      var possibleCommand = str + String.fromCharCode(ch);
                      if (knownCommandFound && void 0 === knownCommands[possibleCommand]) break;
                      128 === str.length && error("Command token too long: " + str.length),
                        (str = possibleCommand),
                        (knownCommandFound = knownCommands && void 0 !== knownCommands[str]);
                    }
                    return "true" === str || ("false" !== str && ("null" === str ? null : Cmd.get(str)));
                  },
                  skipToNextLine: function () {
                    for (var ch = this.currentChar; ch >= 0; ) {
                      if (13 === ch) {
                        (ch = this.nextChar()), 10 === ch && this.nextChar();
                        break;
                      }
                      if (10 === ch) {
                        this.nextChar();
                        break;
                      }
                      ch = this.nextChar();
                    }
                  },
                }),
                Lexer
              );
            })(),
            Linearization = {
              create: function (stream) {
                function getInt(name, allowZeroValue) {
                  var obj = linDict.get(name);
                  if (isInt(obj) && (allowZeroValue ? obj >= 0 : obj > 0)) return obj;
                  throw new Error('The "' + name + '" parameter in the linearization dictionary is invalid.');
                }
                var obj,
                  length,
                  parser = new Parser(new Lexer(stream), !1, null),
                  obj1 = parser.getObj(),
                  obj2 = parser.getObj(),
                  obj3 = parser.getObj(),
                  linDict = parser.getObj();
                if (
                  !(
                    isInt(obj1) &&
                    isInt(obj2) &&
                    isCmd(obj3, "obj") &&
                    isDict(linDict) &&
                    isNum((obj = linDict.get("Linearized"))) &&
                    obj > 0
                  )
                )
                  return null;
                if ((length = getInt("L")) !== stream.length)
                  throw new Error(
                    'The "L" parameter in the linearization dictionary does not equal the stream length.'
                  );
                return {
                  length: length,
                  hints: (function () {
                    var hintsLength,
                      item,
                      hints = linDict.get("H");
                    if (isArray(hints) && (2 === (hintsLength = hints.length) || 4 === hintsLength)) {
                      for (var index = 0; index < hintsLength; index++)
                        if (!(isInt((item = hints[index])) && item > 0))
                          throw new Error("Hint (" + index + ") in the linearization dictionary is invalid.");
                      return hints;
                    }
                    throw new Error("Hint array in the linearization dictionary is invalid.");
                  })(),
                  objectNumberFirst: getInt("O"),
                  endFirst: getInt("E"),
                  numPages: getInt("N"),
                  mainXRefEntriesOffset: getInt("T"),
                  pageFirst: linDict.has("P") ? getInt("P", !0) : 0,
                };
              },
            };
          (exports.EOF = EOF),
            (exports.Lexer = Lexer),
            (exports.Linearization = Linearization),
            (exports.Parser = Parser),
            (exports.isEOF = isEOF);
        })((root.pdfjsCoreParser = {}), root.pdfjsSharedUtil, root.pdfjsCorePrimitives, root.pdfjsCoreStream);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, coreStream, coreEncodings) {
          var warn = sharedUtil.warn,
            isSpace = sharedUtil.isSpace,
            Stream = coreStream.Stream,
            getEncoding = coreEncodings.getEncoding,
            Type1CharString = (function () {
              function Type1CharString() {
                (this.width = 0), (this.lsb = 0), (this.flexing = !1), (this.output = []), (this.stack = []);
              }
              var COMMAND_MAP = {
                hstem: [1],
                vstem: [3],
                vmoveto: [4],
                rlineto: [5],
                hlineto: [6],
                vlineto: [7],
                rrcurveto: [8],
                callsubr: [10],
                flex: [12, 35],
                drop: [12, 18],
                endchar: [14],
                rmoveto: [21],
                hmoveto: [22],
                vhcurveto: [30],
                hvcurveto: [31],
              };
              return (
                (Type1CharString.prototype = {
                  convert: function (encoded, subrs, seacAnalysisEnabled) {
                    for (var wx, sbx, subrNumber, count = encoded.length, error = !1, i = 0; i < count; i++) {
                      var value = encoded[i];
                      if (value < 32) {
                        switch ((12 === value && (value = (value << 8) + encoded[++i]), value)) {
                          case 1:
                          case 3:
                            this.stack = [];
                            break;
                          case 4:
                            if (this.flexing) {
                              if (this.stack.length < 1) {
                                error = !0;
                                break;
                              }
                              var dy = this.stack.pop();
                              this.stack.push(0, dy);
                              break;
                            }
                            error = this.executeCommand(1, COMMAND_MAP.vmoveto);
                            break;
                          case 5:
                            error = this.executeCommand(2, COMMAND_MAP.rlineto);
                            break;
                          case 6:
                            error = this.executeCommand(1, COMMAND_MAP.hlineto);
                            break;
                          case 7:
                            error = this.executeCommand(1, COMMAND_MAP.vlineto);
                            break;
                          case 8:
                            error = this.executeCommand(6, COMMAND_MAP.rrcurveto);
                            break;
                          case 9:
                            this.stack = [];
                            break;
                          case 10:
                            if (this.stack.length < 1) {
                              error = !0;
                              break;
                            }
                            (subrNumber = this.stack.pop()),
                              (error = this.convert(subrs[subrNumber], subrs, seacAnalysisEnabled));
                            break;
                          case 11:
                            return error;
                          case 13:
                            if (this.stack.length < 2) {
                              error = !0;
                              break;
                            }
                            (wx = this.stack.pop()),
                              (sbx = this.stack.pop()),
                              (this.lsb = sbx),
                              (this.width = wx),
                              this.stack.push(wx, sbx),
                              (error = this.executeCommand(2, COMMAND_MAP.hmoveto));
                            break;
                          case 14:
                            this.output.push(COMMAND_MAP.endchar[0]);
                            break;
                          case 21:
                            if (this.flexing) break;
                            error = this.executeCommand(2, COMMAND_MAP.rmoveto);
                            break;
                          case 22:
                            if (this.flexing) {
                              this.stack.push(0);
                              break;
                            }
                            error = this.executeCommand(1, COMMAND_MAP.hmoveto);
                            break;
                          case 30:
                            error = this.executeCommand(4, COMMAND_MAP.vhcurveto);
                            break;
                          case 31:
                            error = this.executeCommand(4, COMMAND_MAP.hvcurveto);
                            break;
                          case 3072:
                          case 3073:
                          case 3074:
                            this.stack = [];
                            break;
                          case 3078:
                            seacAnalysisEnabled
                              ? ((this.seac = this.stack.splice(-4, 4)),
                                (error = this.executeCommand(0, COMMAND_MAP.endchar)))
                              : (error = this.executeCommand(4, COMMAND_MAP.endchar));
                            break;
                          case 3079:
                            if (this.stack.length < 4) {
                              error = !0;
                              break;
                            }
                            this.stack.pop();
                            wx = this.stack.pop();
                            var sby = this.stack.pop();
                            (sbx = this.stack.pop()),
                              (this.lsb = sbx),
                              (this.width = wx),
                              this.stack.push(wx, sbx, sby),
                              (error = this.executeCommand(3, COMMAND_MAP.rmoveto));
                            break;
                          case 3084:
                            if (this.stack.length < 2) {
                              error = !0;
                              break;
                            }
                            var num2 = this.stack.pop(),
                              num1 = this.stack.pop();
                            this.stack.push(num1 / num2);
                            break;
                          case 3088:
                            if (this.stack.length < 2) {
                              error = !0;
                              break;
                            }
                            subrNumber = this.stack.pop();
                            var numArgs = this.stack.pop();
                            if (0 === subrNumber && 3 === numArgs) {
                              var flexArgs = this.stack.splice(this.stack.length - 17, 17);
                              this.stack.push(
                                flexArgs[2] + flexArgs[0],
                                flexArgs[3] + flexArgs[1],
                                flexArgs[4],
                                flexArgs[5],
                                flexArgs[6],
                                flexArgs[7],
                                flexArgs[8],
                                flexArgs[9],
                                flexArgs[10],
                                flexArgs[11],
                                flexArgs[12],
                                flexArgs[13],
                                flexArgs[14]
                              ),
                                (error = this.executeCommand(13, COMMAND_MAP.flex, !0)),
                                (this.flexing = !1),
                                this.stack.push(flexArgs[15], flexArgs[16]);
                            } else 1 === subrNumber && 0 === numArgs && (this.flexing = !0);
                            break;
                          case 3089:
                            break;
                          case 3105:
                            this.stack = [];
                            break;
                          default:
                            warn('Unknown type 1 charstring command of "' + value + '"');
                        }
                        if (error) break;
                      } else
                        value <= 246
                          ? (value -= 139)
                          : (value =
                              value <= 250
                                ? 256 * (value - 247) + encoded[++i] + 108
                                : value <= 254
                                ? -256 * (value - 251) - encoded[++i] - 108
                                : ((255 & encoded[++i]) << 24) |
                                  ((255 & encoded[++i]) << 16) |
                                  ((255 & encoded[++i]) << 8) |
                                  ((255 & encoded[++i]) << 0)),
                          this.stack.push(value);
                    }
                    return error;
                  },
                  executeCommand: function (howManyArgs, command, keepStack) {
                    var stackLength = this.stack.length;
                    if (howManyArgs > stackLength) return !0;
                    for (var start = stackLength - howManyArgs, i = start; i < stackLength; i++) {
                      var value = this.stack[i];
                      value === (0 | value)
                        ? this.output.push(28, (value >> 8) & 255, 255 & value)
                        : ((value = (65536 * value) | 0),
                          this.output.push(
                            255,
                            (value >> 24) & 255,
                            (value >> 16) & 255,
                            (value >> 8) & 255,
                            255 & value
                          ));
                    }
                    return (
                      this.output.push.apply(this.output, command),
                      keepStack ? this.stack.splice(start, howManyArgs) : (this.stack.length = 0),
                      !1
                    );
                  },
                }),
                Type1CharString
              );
            })(),
            Type1Parser = (function () {
              function isHexDigit(code) {
                return (code >= 48 && code <= 57) || (code >= 65 && code <= 70) || (code >= 97 && code <= 102);
              }
              function decrypt(data, key, discardNumber) {
                if (discardNumber >= data.length) return new Uint8Array(0);
                var i,
                  j,
                  r = 0 | key;
                for (i = 0; i < discardNumber; i++) r = (52845 * (data[i] + r) + 22719) & 65535;
                var count = data.length - discardNumber,
                  decrypted = new Uint8Array(count);
                for (i = discardNumber, j = 0; j < count; i++, j++) {
                  var value = data[i];
                  (decrypted[j] = value ^ (r >> 8)), (r = (52845 * (value + r) + 22719) & 65535);
                }
                return decrypted;
              }
              function decryptAscii(data, key, discardNumber) {
                var i,
                  j,
                  r = 0 | key,
                  count = data.length,
                  maybeLength = count >>> 1,
                  decrypted = new Uint8Array(maybeLength);
                for (i = 0, j = 0; i < count; i++) {
                  var digit1 = data[i];
                  if (isHexDigit(digit1)) {
                    i++;
                    for (var digit2; i < count && !isHexDigit((digit2 = data[i])); ) i++;
                    if (i < count) {
                      var value = parseInt(String.fromCharCode(digit1, digit2), 16);
                      (decrypted[j++] = value ^ (r >> 8)), (r = (52845 * (value + r) + 22719) & 65535);
                    }
                  }
                }
                return Array.prototype.slice.call(decrypted, discardNumber, j);
              }
              function isSpecial(c) {
                return 47 === c || 91 === c || 93 === c || 123 === c || 125 === c || 40 === c || 41 === c;
              }
              function Type1Parser(stream, encrypted, seacAnalysisEnabled) {
                if (encrypted) {
                  var data = stream.getBytes(),
                    isBinary = !(
                      isHexDigit(data[0]) &&
                      isHexDigit(data[1]) &&
                      isHexDigit(data[2]) &&
                      isHexDigit(data[3])
                    );
                  stream = new Stream(
                    isBinary ? decrypt(data, EEXEC_ENCRYPT_KEY, 4) : decryptAscii(data, EEXEC_ENCRYPT_KEY, 4)
                  );
                }
                (this.seacAnalysisEnabled = !!seacAnalysisEnabled), (this.stream = stream), this.nextChar();
              }
              var EEXEC_ENCRYPT_KEY = 55665;
              return (
                (Type1Parser.prototype = {
                  readNumberArray: function () {
                    this.getToken();
                    for (var array = []; ; ) {
                      var token = this.getToken();
                      if (null === token || "]" === token || "}" === token) break;
                      array.push(parseFloat(token || 0));
                    }
                    return array;
                  },
                  readNumber: function () {
                    var token = this.getToken();
                    return parseFloat(token || 0);
                  },
                  readInt: function () {
                    var token = this.getToken();
                    return 0 | parseInt(token || 0, 10);
                  },
                  readBoolean: function () {
                    return "true" === this.getToken() ? 1 : 0;
                  },
                  nextChar: function () {
                    return (this.currentChar = this.stream.getByte());
                  },
                  getToken: function () {
                    for (var comment = !1, ch = this.currentChar; ; ) {
                      if (-1 === ch) return null;
                      if (comment) (10 !== ch && 13 !== ch) || (comment = !1);
                      else if (37 === ch) comment = !0;
                      else if (!isSpace(ch)) break;
                      ch = this.nextChar();
                    }
                    if (isSpecial(ch)) return this.nextChar(), String.fromCharCode(ch);
                    var token = "";
                    do {
                      (token += String.fromCharCode(ch)), (ch = this.nextChar());
                    } while (ch >= 0 && !isSpace(ch) && !isSpecial(ch));
                    return token;
                  },
                  extractFontProgram: function () {
                    var stream = this.stream,
                      subrs = [],
                      charstrings = [],
                      privateData = Object.create(null);
                    privateData.lenIV = 4;
                    for (
                      var token,
                        length,
                        data,
                        lenIV,
                        encoded,
                        program = { subrs: [], charstrings: [], properties: { privateData: privateData } };
                      null !== (token = this.getToken());

                    )
                      if ("/" === token)
                        switch ((token = this.getToken())) {
                          case "CharStrings":
                            for (this.getToken(), this.getToken(), this.getToken(), this.getToken(); ; ) {
                              if (null === (token = this.getToken()) || "end" === token) break;
                              if ("/" === token) {
                                var glyph = this.getToken();
                                (length = this.readInt()),
                                  this.getToken(),
                                  (data = stream.makeSubStream(stream.pos, length)),
                                  (lenIV = program.properties.privateData.lenIV),
                                  (encoded = decrypt(data.getBytes(), 4330, lenIV)),
                                  stream.skip(length),
                                  this.nextChar(),
                                  (token = this.getToken()),
                                  "noaccess" === token && this.getToken(),
                                  charstrings.push({ glyph: glyph, encoded: encoded });
                              }
                            }
                            break;
                          case "Subrs":
                            this.readInt();
                            for (this.getToken(); "dup" === (token = this.getToken()); ) {
                              var index = this.readInt();
                              (length = this.readInt()),
                                this.getToken(),
                                (data = stream.makeSubStream(stream.pos, length)),
                                (lenIV = program.properties.privateData.lenIV),
                                (encoded = decrypt(data.getBytes(), 4330, lenIV)),
                                stream.skip(length),
                                this.nextChar(),
                                (token = this.getToken()),
                                "noaccess" === token && this.getToken(),
                                (subrs[index] = encoded);
                            }
                            break;
                          case "BlueValues":
                          case "OtherBlues":
                          case "FamilyBlues":
                          case "FamilyOtherBlues":
                            var blueArray = this.readNumberArray();
                            blueArray.length > 0 && blueArray.length, 1;
                            break;
                          case "StemSnapH":
                          case "StemSnapV":
                            program.properties.privateData[token] = this.readNumberArray();
                            break;
                          case "StdHW":
                          case "StdVW":
                            program.properties.privateData[token] = this.readNumberArray()[0];
                            break;
                          case "BlueShift":
                          case "lenIV":
                          case "BlueFuzz":
                          case "BlueScale":
                          case "LanguageGroup":
                          case "ExpansionFactor":
                            program.properties.privateData[token] = this.readNumber();
                            break;
                          case "ForceBold":
                            program.properties.privateData[token] = this.readBoolean();
                        }
                    for (var i = 0; i < charstrings.length; i++) {
                      (glyph = charstrings[i].glyph), (encoded = charstrings[i].encoded);
                      var charString = new Type1CharString(),
                        error = charString.convert(encoded, subrs, this.seacAnalysisEnabled),
                        output = charString.output;
                      error && (output = [14]),
                        program.charstrings.push({
                          glyphName: glyph,
                          charstring: output,
                          width: charString.width,
                          lsb: charString.lsb,
                          seac: charString.seac,
                        });
                    }
                    return program;
                  },
                  extractFontHeader: function (properties) {
                    for (var token; null !== (token = this.getToken()); )
                      if ("/" === token)
                        switch ((token = this.getToken())) {
                          case "FontMatrix":
                            var matrix = this.readNumberArray();
                            properties.fontMatrix = matrix;
                            break;
                          case "Encoding":
                            var encoding,
                              encodingArg = this.getToken();
                            if (/^\d+$/.test(encodingArg)) {
                              encoding = [];
                              var size = 0 | parseInt(encodingArg, 10);
                              this.getToken();
                              for (var j = 0; j < size; j++) {
                                for (token = this.getToken(); "dup" !== token && "def" !== token; )
                                  if (null === (token = this.getToken())) return;
                                if ("def" === token) break;
                                var index = this.readInt();
                                this.getToken();
                                var glyph = this.getToken();
                                (encoding[index] = glyph), this.getToken();
                              }
                            } else encoding = getEncoding(encodingArg);
                            properties.builtInEncoding = encoding;
                            break;
                          case "FontBBox":
                            var fontBBox = this.readNumberArray();
                            (properties.ascent = fontBBox[3]),
                              (properties.descent = fontBBox[1]),
                              (properties.ascentScaled = !0);
                        }
                  },
                }),
                Type1Parser
              );
            })();
          exports.Type1Parser = Type1Parser;
        })((root.pdfjsCoreType1Parser = {}), root.pdfjsSharedUtil, root.pdfjsCoreStream, root.pdfjsCoreEncodings);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, corePrimitives, coreStream, coreParser) {
          var Util = sharedUtil.Util,
            assert = sharedUtil.assert,
            warn = sharedUtil.warn,
            error = sharedUtil.error,
            isInt = sharedUtil.isInt,
            isString = sharedUtil.isString,
            MissingDataException = sharedUtil.MissingDataException,
            isName = corePrimitives.isName,
            isCmd = corePrimitives.isCmd,
            isStream = corePrimitives.isStream,
            StringStream = coreStream.StringStream,
            Lexer = coreParser.Lexer,
            isEOF = coreParser.isEOF,
            BUILT_IN_CMAPS = [
              "Adobe-GB1-UCS2",
              "Adobe-CNS1-UCS2",
              "Adobe-Japan1-UCS2",
              "Adobe-Korea1-UCS2",
              "78-EUC-H",
              "78-EUC-V",
              "78-H",
              "78-RKSJ-H",
              "78-RKSJ-V",
              "78-V",
              "78ms-RKSJ-H",
              "78ms-RKSJ-V",
              "83pv-RKSJ-H",
              "90ms-RKSJ-H",
              "90ms-RKSJ-V",
              "90msp-RKSJ-H",
              "90msp-RKSJ-V",
              "90pv-RKSJ-H",
              "90pv-RKSJ-V",
              "Add-H",
              "Add-RKSJ-H",
              "Add-RKSJ-V",
              "Add-V",
              "Adobe-CNS1-0",
              "Adobe-CNS1-1",
              "Adobe-CNS1-2",
              "Adobe-CNS1-3",
              "Adobe-CNS1-4",
              "Adobe-CNS1-5",
              "Adobe-CNS1-6",
              "Adobe-GB1-0",
              "Adobe-GB1-1",
              "Adobe-GB1-2",
              "Adobe-GB1-3",
              "Adobe-GB1-4",
              "Adobe-GB1-5",
              "Adobe-Japan1-0",
              "Adobe-Japan1-1",
              "Adobe-Japan1-2",
              "Adobe-Japan1-3",
              "Adobe-Japan1-4",
              "Adobe-Japan1-5",
              "Adobe-Japan1-6",
              "Adobe-Korea1-0",
              "Adobe-Korea1-1",
              "Adobe-Korea1-2",
              "B5-H",
              "B5-V",
              "B5pc-H",
              "B5pc-V",
              "CNS-EUC-H",
              "CNS-EUC-V",
              "CNS1-H",
              "CNS1-V",
              "CNS2-H",
              "CNS2-V",
              "ETHK-B5-H",
              "ETHK-B5-V",
              "ETen-B5-H",
              "ETen-B5-V",
              "ETenms-B5-H",
              "ETenms-B5-V",
              "EUC-H",
              "EUC-V",
              "Ext-H",
              "Ext-RKSJ-H",
              "Ext-RKSJ-V",
              "Ext-V",
              "GB-EUC-H",
              "GB-EUC-V",
              "GB-H",
              "GB-V",
              "GBK-EUC-H",
              "GBK-EUC-V",
              "GBK2K-H",
              "GBK2K-V",
              "GBKp-EUC-H",
              "GBKp-EUC-V",
              "GBT-EUC-H",
              "GBT-EUC-V",
              "GBT-H",
              "GBT-V",
              "GBTpc-EUC-H",
              "GBTpc-EUC-V",
              "GBpc-EUC-H",
              "GBpc-EUC-V",
              "H",
              "HKdla-B5-H",
              "HKdla-B5-V",
              "HKdlb-B5-H",
              "HKdlb-B5-V",
              "HKgccs-B5-H",
              "HKgccs-B5-V",
              "HKm314-B5-H",
              "HKm314-B5-V",
              "HKm471-B5-H",
              "HKm471-B5-V",
              "HKscs-B5-H",
              "HKscs-B5-V",
              "Hankaku",
              "Hiragana",
              "KSC-EUC-H",
              "KSC-EUC-V",
              "KSC-H",
              "KSC-Johab-H",
              "KSC-Johab-V",
              "KSC-V",
              "KSCms-UHC-H",
              "KSCms-UHC-HW-H",
              "KSCms-UHC-HW-V",
              "KSCms-UHC-V",
              "KSCpc-EUC-H",
              "KSCpc-EUC-V",
              "Katakana",
              "NWP-H",
              "NWP-V",
              "RKSJ-H",
              "RKSJ-V",
              "Roman",
              "UniCNS-UCS2-H",
              "UniCNS-UCS2-V",
              "UniCNS-UTF16-H",
              "UniCNS-UTF16-V",
              "UniCNS-UTF32-H",
              "UniCNS-UTF32-V",
              "UniCNS-UTF8-H",
              "UniCNS-UTF8-V",
              "UniGB-UCS2-H",
              "UniGB-UCS2-V",
              "UniGB-UTF16-H",
              "UniGB-UTF16-V",
              "UniGB-UTF32-H",
              "UniGB-UTF32-V",
              "UniGB-UTF8-H",
              "UniGB-UTF8-V",
              "UniJIS-UCS2-H",
              "UniJIS-UCS2-HW-H",
              "UniJIS-UCS2-HW-V",
              "UniJIS-UCS2-V",
              "UniJIS-UTF16-H",
              "UniJIS-UTF16-V",
              "UniJIS-UTF32-H",
              "UniJIS-UTF32-V",
              "UniJIS-UTF8-H",
              "UniJIS-UTF8-V",
              "UniJIS2004-UTF16-H",
              "UniJIS2004-UTF16-V",
              "UniJIS2004-UTF32-H",
              "UniJIS2004-UTF32-V",
              "UniJIS2004-UTF8-H",
              "UniJIS2004-UTF8-V",
              "UniJISPro-UCS2-HW-V",
              "UniJISPro-UCS2-V",
              "UniJISPro-UTF8-V",
              "UniJISX0213-UTF32-H",
              "UniJISX0213-UTF32-V",
              "UniJISX02132004-UTF32-H",
              "UniJISX02132004-UTF32-V",
              "UniKS-UCS2-H",
              "UniKS-UCS2-V",
              "UniKS-UTF16-H",
              "UniKS-UTF16-V",
              "UniKS-UTF32-H",
              "UniKS-UTF32-V",
              "UniKS-UTF8-H",
              "UniKS-UTF8-V",
              "V",
              "WP-Symbol",
            ],
            CMap = (function () {
              function CMap(builtInCMap) {
                (this.codespaceRanges = [[], [], [], []]),
                  (this.numCodespaceRanges = 0),
                  (this._map = []),
                  (this.name = ""),
                  (this.vertical = !1),
                  (this.useCMap = null),
                  (this.builtInCMap = builtInCMap);
              }
              return (
                (CMap.prototype = {
                  addCodespaceRange: function (n, low, high) {
                    this.codespaceRanges[n - 1].push(low, high), this.numCodespaceRanges++;
                  },
                  mapCidRange: function (low, high, dstLow) {
                    for (; low <= high; ) this._map[low++] = dstLow++;
                  },
                  mapBfRange: function (low, high, dstLow) {
                    for (var lastByte = dstLow.length - 1; low <= high; )
                      (this._map[low++] = dstLow),
                        (dstLow = dstLow.substr(0, lastByte) + String.fromCharCode(dstLow.charCodeAt(lastByte) + 1));
                  },
                  mapBfRangeToArray: function (low, high, array) {
                    for (var i = 0, ii = array.length; low <= high && i < ii; ) (this._map[low] = array[i++]), ++low;
                  },
                  mapOne: function (src, dst) {
                    this._map[src] = dst;
                  },
                  lookup: function (code) {
                    return this._map[code];
                  },
                  contains: function (code) {
                    return void 0 !== this._map[code];
                  },
                  forEach: function (callback) {
                    var i,
                      map = this._map,
                      length = map.length;
                    if (length <= 65536) for (i = 0; i < length; i++) void 0 !== map[i] && callback(i, map[i]);
                    else for (i in this._map) callback(i, map[i]);
                  },
                  charCodeOf: function (value) {
                    return this._map.indexOf(value);
                  },
                  getMap: function () {
                    return this._map;
                  },
                  readCharCode: function (str, offset, out) {
                    for (
                      var c = 0,
                        codespaceRanges = this.codespaceRanges,
                        codespaceRangesLen = this.codespaceRanges.length,
                        n = 0;
                      n < codespaceRangesLen;
                      n++
                    ) {
                      c = ((c << 8) | str.charCodeAt(offset + n)) >>> 0;
                      for (var codespaceRange = codespaceRanges[n], k = 0, kk = codespaceRange.length; k < kk; ) {
                        var low = codespaceRange[k++],
                          high = codespaceRange[k++];
                        if (c >= low && c <= high) return (out.charcode = c), void (out.length = n + 1);
                      }
                    }
                    (out.charcode = 0), (out.length = 1);
                  },
                  get length() {
                    return this._map.length;
                  },
                  get isIdentityCMap() {
                    if ("Identity-H" !== this.name && "Identity-V" !== this.name) return !1;
                    if (65536 !== this._map.length) return !1;
                    for (var i = 0; i < 65536; i++) if (this._map[i] !== i) return !1;
                    return !0;
                  },
                }),
                CMap
              );
            })(),
            IdentityCMap = (function () {
              function IdentityCMap(vertical, n) {
                CMap.call(this), (this.vertical = vertical), this.addCodespaceRange(n, 0, 65535);
              }
              return (
                Util.inherit(IdentityCMap, CMap, {}),
                (IdentityCMap.prototype = {
                  addCodespaceRange: CMap.prototype.addCodespaceRange,
                  mapCidRange: function (low, high, dstLow) {
                    error("should not call mapCidRange");
                  },
                  mapBfRange: function (low, high, dstLow) {
                    error("should not call mapBfRange");
                  },
                  mapBfRangeToArray: function (low, high, array) {
                    error("should not call mapBfRangeToArray");
                  },
                  mapOne: function (src, dst) {
                    error("should not call mapCidOne");
                  },
                  lookup: function (code) {
                    return isInt(code) && code <= 65535 ? code : void 0;
                  },
                  contains: function (code) {
                    return isInt(code) && code <= 65535;
                  },
                  forEach: function (callback) {
                    for (var i = 0; i <= 65535; i++) callback(i, i);
                  },
                  charCodeOf: function (value) {
                    return isInt(value) && value <= 65535 ? value : -1;
                  },
                  getMap: function () {
                    for (var map = new Array(65536), i = 0; i <= 65535; i++) map[i] = i;
                    return map;
                  },
                  readCharCode: CMap.prototype.readCharCode,
                  get length() {
                    return 65536;
                  },
                  get isIdentityCMap() {
                    error("should not access .isIdentityCMap");
                  },
                }),
                IdentityCMap
              );
            })(),
            BinaryCMapReader = (function () {
              function fetchBinaryData(url) {
                return new Promise(function (resolve, reject) {
                  var request = new XMLHttpRequest();
                  request.open("GET", url, !0),
                    (request.responseType = "arraybuffer"),
                    (request.onreadystatechange = function () {
                      request.readyState === XMLHttpRequest.DONE &&
                        (!request.response || (200 !== request.status && 0 !== request.status)
                          ? reject(new Error("Unable to get binary cMap at: " + url))
                          : resolve(new Uint8Array(request.response)));
                    }),
                    request.send(null);
                });
              }
              function hexToInt(a, size) {
                for (var n = 0, i = 0; i <= size; i++) n = (n << 8) | a[i];
                return n >>> 0;
              }
              function hexToStr(a, size) {
                return 1 === size
                  ? String.fromCharCode(a[0], a[1])
                  : 3 === size
                  ? String.fromCharCode(a[0], a[1], a[2], a[3])
                  : String.fromCharCode.apply(null, a.subarray(0, size + 1));
              }
              function addHex(a, b, size) {
                for (var c = 0, i = size; i >= 0; i--) (c += a[i] + b[i]), (a[i] = 255 & c), (c >>= 8);
              }
              function incHex(a, size) {
                for (var c = 1, i = size; i >= 0 && c > 0; i--) (c += a[i]), (a[i] = 255 & c), (c >>= 8);
              }
              function BinaryCMapStream(data) {
                (this.buffer = data),
                  (this.pos = 0),
                  (this.end = data.length),
                  (this.tmpBuf = new Uint8Array(MAX_ENCODED_NUM_SIZE));
              }
              function processBinaryCMap(url, cMap, extend) {
                return fetchBinaryData(url).then(function (data) {
                  var stream = new BinaryCMapStream(data),
                    header = stream.readByte();
                  cMap.vertical = !!(1 & header);
                  for (
                    var code,
                      b,
                      useCMap = null,
                      start = new Uint8Array(MAX_NUM_SIZE),
                      end = new Uint8Array(MAX_NUM_SIZE),
                      char = new Uint8Array(MAX_NUM_SIZE),
                      charCode = new Uint8Array(MAX_NUM_SIZE),
                      tmp = new Uint8Array(MAX_NUM_SIZE);
                    (b = stream.readByte()) >= 0;

                  ) {
                    var type = b >> 5;
                    if (7 !== type) {
                      var sequence = !!(16 & b),
                        dataSize = 15 & b;
                      assert(dataSize + 1 <= MAX_NUM_SIZE);
                      var i,
                        subitemsCount = stream.readNumber();
                      switch (type) {
                        case 0:
                          for (
                            stream.readHex(start, dataSize),
                              stream.readHexNumber(end, dataSize),
                              addHex(end, start, dataSize),
                              cMap.addCodespaceRange(dataSize + 1, hexToInt(start, dataSize), hexToInt(end, dataSize)),
                              i = 1;
                            i < subitemsCount;
                            i++
                          )
                            incHex(end, dataSize),
                              stream.readHexNumber(start, dataSize),
                              addHex(start, end, dataSize),
                              stream.readHexNumber(end, dataSize),
                              addHex(end, start, dataSize),
                              cMap.addCodespaceRange(dataSize + 1, hexToInt(start, dataSize), hexToInt(end, dataSize));
                          break;
                        case 1:
                          for (
                            stream.readHex(start, dataSize),
                              stream.readHexNumber(end, dataSize),
                              addHex(end, start, dataSize),
                              code = stream.readNumber(),
                              i = 1;
                            i < subitemsCount;
                            i++
                          )
                            incHex(end, dataSize),
                              stream.readHexNumber(start, dataSize),
                              addHex(start, end, dataSize),
                              stream.readHexNumber(end, dataSize),
                              addHex(end, start, dataSize),
                              (code = stream.readNumber());
                          break;
                        case 2:
                          for (
                            stream.readHex(char, dataSize),
                              code = stream.readNumber(),
                              cMap.mapOne(hexToInt(char, dataSize), code),
                              i = 1;
                            i < subitemsCount;
                            i++
                          )
                            incHex(char, dataSize),
                              sequence || (stream.readHexNumber(tmp, dataSize), addHex(char, tmp, dataSize)),
                              (code = stream.readSigned() + (code + 1)),
                              cMap.mapOne(hexToInt(char, dataSize), code);
                          break;
                        case 3:
                          for (
                            stream.readHex(start, dataSize),
                              stream.readHexNumber(end, dataSize),
                              addHex(end, start, dataSize),
                              code = stream.readNumber(),
                              cMap.mapCidRange(hexToInt(start, dataSize), hexToInt(end, dataSize), code),
                              i = 1;
                            i < subitemsCount;
                            i++
                          )
                            incHex(end, dataSize),
                              sequence
                                ? start.set(end)
                                : (stream.readHexNumber(start, dataSize), addHex(start, end, dataSize)),
                              stream.readHexNumber(end, dataSize),
                              addHex(end, start, dataSize),
                              (code = stream.readNumber()),
                              cMap.mapCidRange(hexToInt(start, dataSize), hexToInt(end, dataSize), code);
                          break;
                        case 4:
                          for (
                            stream.readHex(char, 1),
                              stream.readHex(charCode, dataSize),
                              cMap.mapOne(hexToInt(char, 1), hexToStr(charCode, dataSize)),
                              i = 1;
                            i < subitemsCount;
                            i++
                          )
                            incHex(char, 1),
                              sequence || (stream.readHexNumber(tmp, 1), addHex(char, tmp, 1)),
                              incHex(charCode, dataSize),
                              stream.readHexSigned(tmp, dataSize),
                              addHex(charCode, tmp, dataSize),
                              cMap.mapOne(hexToInt(char, 1), hexToStr(charCode, dataSize));
                          break;
                        case 5:
                          for (
                            stream.readHex(start, 1),
                              stream.readHexNumber(end, 1),
                              addHex(end, start, 1),
                              stream.readHex(charCode, dataSize),
                              cMap.mapBfRange(hexToInt(start, 1), hexToInt(end, 1), hexToStr(charCode, dataSize)),
                              i = 1;
                            i < subitemsCount;
                            i++
                          )
                            incHex(end, 1),
                              sequence ? start.set(end) : (stream.readHexNumber(start, 1), addHex(start, end, 1)),
                              stream.readHexNumber(end, 1),
                              addHex(end, start, 1),
                              stream.readHex(charCode, dataSize),
                              cMap.mapBfRange(hexToInt(start, 1), hexToInt(end, 1), hexToStr(charCode, dataSize));
                          break;
                        default:
                          error("Unknown type: " + type);
                      }
                    } else
                      switch (31 & b) {
                        case 0:
                          stream.readString();
                          break;
                        case 1:
                          useCMap = stream.readString();
                      }
                  }
                  return useCMap ? extend(useCMap) : cMap;
                });
              }
              function BinaryCMapReader() {}
              var MAX_NUM_SIZE = 16,
                MAX_ENCODED_NUM_SIZE = 19;
              return (
                (BinaryCMapStream.prototype = {
                  readByte: function () {
                    return this.pos >= this.end ? -1 : this.buffer[this.pos++];
                  },
                  readNumber: function () {
                    var last,
                      n = 0;
                    do {
                      var b = this.readByte();
                      b < 0 && error("unexpected EOF in bcmap"), (last = !(128 & b)), (n = (n << 7) | (127 & b));
                    } while (!last);
                    return n;
                  },
                  readSigned: function () {
                    var n = this.readNumber();
                    return 1 & n ? ~(n >>> 1) : n >>> 1;
                  },
                  readHex: function (num, size) {
                    num.set(this.buffer.subarray(this.pos, this.pos + size + 1)), (this.pos += size + 1);
                  },
                  readHexNumber: function (num, size) {
                    var last,
                      stack = this.tmpBuf,
                      sp = 0;
                    do {
                      var b = this.readByte();
                      b < 0 && error("unexpected EOF in bcmap"), (last = !(128 & b)), (stack[sp++] = 127 & b);
                    } while (!last);
                    for (var i = size, buffer = 0, bufferSize = 0; i >= 0; ) {
                      for (; bufferSize < 8 && stack.length > 0; )
                        (buffer = (stack[--sp] << bufferSize) | buffer), (bufferSize += 7);
                      (num[i] = 255 & buffer), i--, (buffer >>= 8), (bufferSize -= 8);
                    }
                  },
                  readHexSigned: function (num, size) {
                    this.readHexNumber(num, size);
                    for (var sign = 1 & num[size] ? 255 : 0, c = 0, i = 0; i <= size; i++)
                      (c = ((1 & c) << 8) | num[i]), (num[i] = (c >> 1) ^ sign);
                  },
                  readString: function () {
                    for (var len = this.readNumber(), s = "", i = 0; i < len; i++)
                      s += String.fromCharCode(this.readNumber());
                    return s;
                  },
                }),
                (BinaryCMapReader.prototype = { read: processBinaryCMap }),
                BinaryCMapReader
              );
            })(),
            CMapFactory = (function () {
              function strToInt(str) {
                for (var a = 0, i = 0; i < str.length; i++) a = (a << 8) | str.charCodeAt(i);
                return a >>> 0;
              }
              function expectString(obj) {
                isString(obj) || error("Malformed CMap: expected string.");
              }
              function expectInt(obj) {
                isInt(obj) || error("Malformed CMap: expected int.");
              }
              function parseBfChar(cMap, lexer) {
                for (;;) {
                  var obj = lexer.getObj();
                  if (isEOF(obj)) break;
                  if (isCmd(obj, "endbfchar")) return;
                  expectString(obj);
                  var src = strToInt(obj);
                  (obj = lexer.getObj()), expectString(obj);
                  var dst = obj;
                  cMap.mapOne(src, dst);
                }
              }
              function parseBfRange(cMap, lexer) {
                for (;;) {
                  var obj = lexer.getObj();
                  if (isEOF(obj)) break;
                  if (isCmd(obj, "endbfrange")) return;
                  expectString(obj);
                  var low = strToInt(obj);
                  (obj = lexer.getObj()), expectString(obj);
                  var high = strToInt(obj);
                  if (((obj = lexer.getObj()), isInt(obj) || isString(obj))) {
                    var dstLow = isInt(obj) ? String.fromCharCode(obj) : obj;
                    cMap.mapBfRange(low, high, dstLow);
                  } else {
                    if (!isCmd(obj, "[")) break;
                    obj = lexer.getObj();
                    for (var array = []; !isCmd(obj, "]") && !isEOF(obj); ) array.push(obj), (obj = lexer.getObj());
                    cMap.mapBfRangeToArray(low, high, array);
                  }
                }
                error("Invalid bf range.");
              }
              function parseCidChar(cMap, lexer) {
                for (;;) {
                  var obj = lexer.getObj();
                  if (isEOF(obj)) break;
                  if (isCmd(obj, "endcidchar")) return;
                  expectString(obj);
                  var src = strToInt(obj);
                  (obj = lexer.getObj()), expectInt(obj);
                  var dst = obj;
                  cMap.mapOne(src, dst);
                }
              }
              function parseCidRange(cMap, lexer) {
                for (;;) {
                  var obj = lexer.getObj();
                  if (isEOF(obj)) break;
                  if (isCmd(obj, "endcidrange")) return;
                  expectString(obj);
                  var low = strToInt(obj);
                  (obj = lexer.getObj()), expectString(obj);
                  var high = strToInt(obj);
                  (obj = lexer.getObj()), expectInt(obj);
                  var dstLow = obj;
                  cMap.mapCidRange(low, high, dstLow);
                }
              }
              function parseCodespaceRange(cMap, lexer) {
                for (;;) {
                  var obj = lexer.getObj();
                  if (isEOF(obj)) break;
                  if (isCmd(obj, "endcodespacerange")) return;
                  if (!isString(obj)) break;
                  var low = strToInt(obj);
                  if (((obj = lexer.getObj()), !isString(obj))) break;
                  var high = strToInt(obj);
                  cMap.addCodespaceRange(obj.length, low, high);
                }
                error("Invalid codespace range.");
              }
              function parseWMode(cMap, lexer) {
                var obj = lexer.getObj();
                isInt(obj) && (cMap.vertical = !!obj);
              }
              function parseCMapName(cMap, lexer) {
                var obj = lexer.getObj();
                isName(obj) && isString(obj.name) && (cMap.name = obj.name);
              }
              function parseCMap(cMap, lexer, builtInCMapParams, useCMap) {
                var previous, embededUseCMap;
                objLoop: for (;;)
                  try {
                    var obj = lexer.getObj();
                    if (isEOF(obj)) break;
                    if (isName(obj))
                      "WMode" === obj.name
                        ? parseWMode(cMap, lexer)
                        : "CMapName" === obj.name && parseCMapName(cMap, lexer),
                        (previous = obj);
                    else if (isCmd(obj))
                      switch (obj.cmd) {
                        case "endcmap":
                          break objLoop;
                        case "usecmap":
                          isName(previous) && (embededUseCMap = previous.name);
                          break;
                        case "begincodespacerange":
                          parseCodespaceRange(cMap, lexer);
                          break;
                        case "beginbfchar":
                          parseBfChar(cMap, lexer);
                          break;
                        case "begincidchar":
                          parseCidChar(cMap, lexer);
                          break;
                        case "beginbfrange":
                          parseBfRange(cMap, lexer);
                          break;
                        case "begincidrange":
                          parseCidRange(cMap, lexer);
                      }
                  } catch (ex) {
                    if (ex instanceof MissingDataException) throw ex;
                    warn("Invalid cMap data: " + ex);
                    continue;
                  }
                return (
                  !useCMap && embededUseCMap && (useCMap = embededUseCMap),
                  useCMap ? extendCMap(cMap, builtInCMapParams, useCMap) : Promise.resolve(cMap)
                );
              }
              function extendCMap(cMap, builtInCMapParams, useCMap) {
                return createBuiltInCMap(useCMap, builtInCMapParams).then(function (newCMap) {
                  if (((cMap.useCMap = newCMap), 0 === cMap.numCodespaceRanges)) {
                    for (
                      var useCodespaceRanges = cMap.useCMap.codespaceRanges, i = 0;
                      i < useCodespaceRanges.length;
                      i++
                    )
                      cMap.codespaceRanges[i] = useCodespaceRanges[i].slice();
                    cMap.numCodespaceRanges = cMap.useCMap.numCodespaceRanges;
                  }
                  return (
                    cMap.useCMap.forEach(function (key, value) {
                      cMap.contains(key) || cMap.mapOne(key, cMap.useCMap.lookup(key));
                    }),
                    cMap
                  );
                });
              }
              function parseBinaryCMap(name, builtInCMapParams) {
                var url = builtInCMapParams.url + name + ".bcmap",
                  cMap = new CMap(!0);
                return new BinaryCMapReader().read(url, cMap, function (useCMap) {
                  return extendCMap(cMap, builtInCMapParams, useCMap);
                });
              }
              function createBuiltInCMap(name, builtInCMapParams) {
                return "Identity-H" === name
                  ? Promise.resolve(new IdentityCMap(!1, 2))
                  : "Identity-V" === name
                  ? Promise.resolve(new IdentityCMap(!0, 2))
                  : -1 === BUILT_IN_CMAPS.indexOf(name)
                  ? Promise.reject(new Error("Unknown cMap name: " + name))
                  : (assert(builtInCMapParams, "built-in cMap parameters are not provided"),
                    builtInCMapParams.packed
                      ? parseBinaryCMap(name, builtInCMapParams)
                      : new Promise(function (resolve, reject) {
                          var url = builtInCMapParams.url + name,
                            request = new XMLHttpRequest();
                          (request.onreadystatechange = function () {
                            if (request.readyState === XMLHttpRequest.DONE)
                              if (200 === request.status || 0 === request.status) {
                                var cMap = new CMap(!0),
                                  lexer = new Lexer(new StringStream(request.responseText));
                                parseCMap(cMap, lexer, builtInCMapParams, null).then(function (parsedCMap) {
                                  resolve(parsedCMap);
                                });
                              } else reject(new Error("Unable to get cMap at: " + url));
                          }),
                            request.open("GET", url, !0),
                            request.send(null);
                        }));
              }
              return {
                create: function (encoding, builtInCMapParams, useCMap) {
                  if (isName(encoding)) return createBuiltInCMap(encoding.name, builtInCMapParams);
                  if (isStream(encoding)) {
                    return parseCMap(new CMap(), new Lexer(encoding), builtInCMapParams, useCMap).then(function (
                      parsedCMap
                    ) {
                      return parsedCMap.isIdentityCMap
                        ? createBuiltInCMap(parsedCMap.name, builtInCMapParams)
                        : parsedCMap;
                    });
                  }
                  return Promise.reject(new Error("Encoding required."));
                },
              };
            })();
          (exports.CMap = CMap), (exports.CMapFactory = CMapFactory), (exports.IdentityCMap = IdentityCMap);
        })(
          (root.pdfjsCoreCMap = {}),
          root.pdfjsSharedUtil,
          root.pdfjsCorePrimitives,
          root.pdfjsCoreStream,
          root.pdfjsCoreParser
        );
      })(this),
      (function (root, factory) {
        !(function (
          exports,
          sharedUtil,
          corePrimitives,
          coreStream,
          coreGlyphList,
          coreFontRenderer,
          coreEncodings,
          coreStandardFonts,
          coreUnicode,
          coreType1Parser,
          coreCFFParser
        ) {
          function adjustWidths(properties) {
            if (properties.fontMatrix && properties.fontMatrix[0] !== FONT_IDENTITY_MATRIX[0]) {
              var scale = 0.001 / properties.fontMatrix[0],
                glyphsWidths = properties.widths;
              for (var glyph in glyphsWidths) glyphsWidths[glyph] *= scale;
              properties.defaultWidth *= scale;
            }
          }
          function adjustToUnicode(properties, builtInEncoding) {
            if (
              !properties.hasIncludedToUnicodeMap &&
              !(
                properties.hasEncoding ||
                builtInEncoding === properties.defaultEncoding ||
                properties.toUnicode instanceof IdentityToUnicodeMap
              )
            ) {
              var toUnicode = [],
                glyphsUnicodeMap = getGlyphsUnicode();
              for (var charCode in builtInEncoding) {
                var glyphName = builtInEncoding[charCode],
                  unicode = getUnicodeForGlyph(glyphName, glyphsUnicodeMap);
                -1 !== unicode && (toUnicode[charCode] = String.fromCharCode(unicode));
              }
              properties.toUnicode.amend(toUnicode);
            }
          }
          function getFontType(type, subtype) {
            switch (type) {
              case "Type1":
                return "Type1C" === subtype ? FontType.TYPE1C : FontType.TYPE1;
              case "CIDFontType0":
                return "CIDFontType0C" === subtype ? FontType.CIDFONTTYPE0C : FontType.CIDFONTTYPE0;
              case "OpenType":
                return FontType.OPENTYPE;
              case "TrueType":
                return FontType.TRUETYPE;
              case "CIDFontType2":
                return FontType.CIDFONTTYPE2;
              case "MMType1":
                return FontType.MMTYPE1;
              case "Type0":
                return FontType.TYPE0;
              default:
                return FontType.UNKNOWN;
            }
          }
          function recoverGlyphName(name, glyphsUnicodeMap) {
            if (void 0 !== glyphsUnicodeMap[name]) return name;
            var unicode = getUnicodeForGlyph(name, glyphsUnicodeMap);
            if (-1 !== unicode) for (var key in glyphsUnicodeMap) if (glyphsUnicodeMap[key] === unicode) return key;
            return info("Unable to recover a standard glyph name for: " + name), name;
          }
          function type1FontGlyphMapping(properties, builtInEncoding, glyphNames) {
            var glyphId,
              charCode,
              baseEncoding,
              charCodeToGlyphId = Object.create(null);
            if (properties.baseEncodingName)
              for (
                baseEncoding = getEncoding(properties.baseEncodingName), charCode = 0;
                charCode < baseEncoding.length;
                charCode++
              )
                (glyphId = glyphNames.indexOf(baseEncoding[charCode])),
                  (charCodeToGlyphId[charCode] = glyphId >= 0 ? glyphId : 0);
            else if (properties.flags & FontFlags.Symbolic)
              for (charCode in builtInEncoding) charCodeToGlyphId[charCode] = builtInEncoding[charCode];
            else
              for (baseEncoding = StandardEncoding, charCode = 0; charCode < baseEncoding.length; charCode++)
                (glyphId = glyphNames.indexOf(baseEncoding[charCode])),
                  (charCodeToGlyphId[charCode] = glyphId >= 0 ? glyphId : 0);
            var glyphsUnicodeMap,
              differences = properties.differences;
            if (differences)
              for (charCode in differences) {
                var glyphName = differences[charCode];
                if (-1 === (glyphId = glyphNames.indexOf(glyphName))) {
                  glyphsUnicodeMap || (glyphsUnicodeMap = getGlyphsUnicode());
                  var standardGlyphName = recoverGlyphName(glyphName, glyphsUnicodeMap);
                  standardGlyphName !== glyphName && (glyphId = glyphNames.indexOf(standardGlyphName));
                }
                charCodeToGlyphId[charCode] = glyphId >= 0 ? glyphId : 0;
              }
            return charCodeToGlyphId;
          }
          var FONT_IDENTITY_MATRIX = sharedUtil.FONT_IDENTITY_MATRIX,
            FontType = sharedUtil.FontType,
            assert = sharedUtil.assert,
            bytesToString = sharedUtil.bytesToString,
            error = sharedUtil.error,
            info = sharedUtil.info,
            isArray = sharedUtil.isArray,
            isInt = sharedUtil.isInt,
            isNum = sharedUtil.isNum,
            readUint32 = sharedUtil.readUint32,
            shadow = sharedUtil.shadow,
            string32 = sharedUtil.string32,
            warn = sharedUtil.warn,
            MissingDataException = sharedUtil.MissingDataException,
            isSpace = sharedUtil.isSpace,
            Stream = coreStream.Stream,
            getGlyphsUnicode = coreGlyphList.getGlyphsUnicode,
            getDingbatsGlyphsUnicode = coreGlyphList.getDingbatsGlyphsUnicode,
            FontRendererFactory = coreFontRenderer.FontRendererFactory,
            StandardEncoding = coreEncodings.StandardEncoding,
            MacRomanEncoding = coreEncodings.MacRomanEncoding,
            SymbolSetEncoding = coreEncodings.SymbolSetEncoding,
            ZapfDingbatsEncoding = coreEncodings.ZapfDingbatsEncoding,
            getEncoding = coreEncodings.getEncoding,
            getStdFontMap = coreStandardFonts.getStdFontMap,
            getNonStdFontMap = coreStandardFonts.getNonStdFontMap,
            getGlyphMapForStandardFonts = coreStandardFonts.getGlyphMapForStandardFonts,
            getSupplementalGlyphMapForArialBlack = coreStandardFonts.getSupplementalGlyphMapForArialBlack,
            getUnicodeRangeFor = coreUnicode.getUnicodeRangeFor,
            mapSpecialUnicodeValues = coreUnicode.mapSpecialUnicodeValues,
            getUnicodeForGlyph = coreUnicode.getUnicodeForGlyph,
            Type1Parser = coreType1Parser.Type1Parser,
            CFFStandardStrings = coreCFFParser.CFFStandardStrings,
            CFFParser = coreCFFParser.CFFParser,
            CFFCompiler = coreCFFParser.CFFCompiler,
            CFF = coreCFFParser.CFF,
            CFFHeader = coreCFFParser.CFFHeader,
            CFFTopDict = coreCFFParser.CFFTopDict,
            CFFPrivateDict = coreCFFParser.CFFPrivateDict,
            CFFStrings = coreCFFParser.CFFStrings,
            CFFIndex = coreCFFParser.CFFIndex,
            CFFCharset = coreCFFParser.CFFCharset,
            PRIVATE_USE_OFFSET_START = 57344,
            PRIVATE_USE_OFFSET_END = 63743,
            SKIP_PRIVATE_USE_RANGE_F000_TO_F01F = !1,
            PDF_GLYPH_SPACE_UNITS = 1e3,
            SEAC_ANALYSIS_ENABLED = !1,
            FontFlags = {
              FixedPitch: 1,
              Serif: 2,
              Symbolic: 4,
              Script: 8,
              Nonsymbolic: 32,
              Italic: 64,
              AllCap: 65536,
              SmallCap: 131072,
              ForceBold: 262144,
            },
            MacStandardGlyphOrdering = [
              ".notdef",
              ".null",
              "nonmarkingreturn",
              "space",
              "exclam",
              "quotedbl",
              "numbersign",
              "dollar",
              "percent",
              "ampersand",
              "quotesingle",
              "parenleft",
              "parenright",
              "asterisk",
              "plus",
              "comma",
              "hyphen",
              "period",
              "slash",
              "zero",
              "one",
              "two",
              "three",
              "four",
              "five",
              "six",
              "seven",
              "eight",
              "nine",
              "colon",
              "semicolon",
              "less",
              "equal",
              "greater",
              "question",
              "at",
              "A",
              "B",
              "C",
              "D",
              "E",
              "F",
              "G",
              "H",
              "I",
              "J",
              "K",
              "L",
              "M",
              "N",
              "O",
              "P",
              "Q",
              "R",
              "S",
              "T",
              "U",
              "V",
              "W",
              "X",
              "Y",
              "Z",
              "bracketleft",
              "backslash",
              "bracketright",
              "asciicircum",
              "underscore",
              "grave",
              "a",
              "b",
              "c",
              "d",
              "e",
              "f",
              "g",
              "h",
              "i",
              "j",
              "k",
              "l",
              "m",
              "n",
              "o",
              "p",
              "q",
              "r",
              "s",
              "t",
              "u",
              "v",
              "w",
              "x",
              "y",
              "z",
              "braceleft",
              "bar",
              "braceright",
              "asciitilde",
              "Adieresis",
              "Aring",
              "Ccedilla",
              "Eacute",
              "Ntilde",
              "Odieresis",
              "Udieresis",
              "aacute",
              "agrave",
              "acircumflex",
              "adieresis",
              "atilde",
              "aring",
              "ccedilla",
              "eacute",
              "egrave",
              "ecircumflex",
              "edieresis",
              "iacute",
              "igrave",
              "icircumflex",
              "idieresis",
              "ntilde",
              "oacute",
              "ograve",
              "ocircumflex",
              "odieresis",
              "otilde",
              "uacute",
              "ugrave",
              "ucircumflex",
              "udieresis",
              "dagger",
              "degree",
              "cent",
              "sterling",
              "section",
              "bullet",
              "paragraph",
              "germandbls",
              "registered",
              "copyright",
              "trademark",
              "acute",
              "dieresis",
              "notequal",
              "AE",
              "Oslash",
              "infinity",
              "plusminus",
              "lessequal",
              "greaterequal",
              "yen",
              "mu",
              "partialdiff",
              "summation",
              "product",
              "pi",
              "integral",
              "ordfeminine",
              "ordmasculine",
              "Omega",
              "ae",
              "oslash",
              "questiondown",
              "exclamdown",
              "logicalnot",
              "radical",
              "florin",
              "approxequal",
              "Delta",
              "guillemotleft",
              "guillemotright",
              "ellipsis",
              "nonbreakingspace",
              "Agrave",
              "Atilde",
              "Otilde",
              "OE",
              "oe",
              "endash",
              "emdash",
              "quotedblleft",
              "quotedblright",
              "quoteleft",
              "quoteright",
              "divide",
              "lozenge",
              "ydieresis",
              "Ydieresis",
              "fraction",
              "currency",
              "guilsinglleft",
              "guilsinglright",
              "fi",
              "fl",
              "daggerdbl",
              "periodcentered",
              "quotesinglbase",
              "quotedblbase",
              "perthousand",
              "Acircumflex",
              "Ecircumflex",
              "Aacute",
              "Edieresis",
              "Egrave",
              "Iacute",
              "Icircumflex",
              "Idieresis",
              "Igrave",
              "Oacute",
              "Ocircumflex",
              "apple",
              "Ograve",
              "Uacute",
              "Ucircumflex",
              "Ugrave",
              "dotlessi",
              "circumflex",
              "tilde",
              "macron",
              "breve",
              "dotaccent",
              "ring",
              "cedilla",
              "hungarumlaut",
              "ogonek",
              "caron",
              "Lslash",
              "lslash",
              "Scaron",
              "scaron",
              "Zcaron",
              "zcaron",
              "brokenbar",
              "Eth",
              "eth",
              "Yacute",
              "yacute",
              "Thorn",
              "thorn",
              "minus",
              "multiply",
              "onesuperior",
              "twosuperior",
              "threesuperior",
              "onehalf",
              "onequarter",
              "threequarters",
              "franc",
              "Gbreve",
              "gbreve",
              "Idotaccent",
              "Scedilla",
              "scedilla",
              "Cacute",
              "cacute",
              "Ccaron",
              "ccaron",
              "dcroat",
            ],
            Glyph = (function () {
              function Glyph(fontChar, unicode, accent, width, vmetric, operatorListId, isSpace, isInFont) {
                (this.fontChar = fontChar),
                  (this.unicode = unicode),
                  (this.accent = accent),
                  (this.width = width),
                  (this.vmetric = vmetric),
                  (this.operatorListId = operatorListId),
                  (this.isSpace = isSpace),
                  (this.isInFont = isInFont);
              }
              return (
                (Glyph.prototype.matchesForCache = function (
                  fontChar,
                  unicode,
                  accent,
                  width,
                  vmetric,
                  operatorListId,
                  isSpace,
                  isInFont
                ) {
                  return (
                    this.fontChar === fontChar &&
                    this.unicode === unicode &&
                    this.accent === accent &&
                    this.width === width &&
                    this.vmetric === vmetric &&
                    this.operatorListId === operatorListId &&
                    this.isSpace === isSpace &&
                    this.isInFont === isInFont
                  );
                }),
                Glyph
              );
            })(),
            ToUnicodeMap = (function () {
              function ToUnicodeMap(cmap) {
                this._map = cmap;
              }
              return (
                (ToUnicodeMap.prototype = {
                  get length() {
                    return this._map.length;
                  },
                  forEach: function (callback) {
                    for (var charCode in this._map) callback(charCode, this._map[charCode].charCodeAt(0));
                  },
                  has: function (i) {
                    return void 0 !== this._map[i];
                  },
                  get: function (i) {
                    return this._map[i];
                  },
                  charCodeOf: function (v) {
                    return this._map.indexOf(v);
                  },
                  amend: function (map) {
                    for (var charCode in map) this._map[charCode] = map[charCode];
                  },
                }),
                ToUnicodeMap
              );
            })(),
            IdentityToUnicodeMap = (function () {
              function IdentityToUnicodeMap(firstChar, lastChar) {
                (this.firstChar = firstChar), (this.lastChar = lastChar);
              }
              return (
                (IdentityToUnicodeMap.prototype = {
                  get length() {
                    return this.lastChar + 1 - this.firstChar;
                  },
                  forEach: function (callback) {
                    for (var i = this.firstChar, ii = this.lastChar; i <= ii; i++) callback(i, i);
                  },
                  has: function (i) {
                    return this.firstChar <= i && i <= this.lastChar;
                  },
                  get: function (i) {
                    if (this.firstChar <= i && i <= this.lastChar) return String.fromCharCode(i);
                  },
                  charCodeOf: function (v) {
                    return isInt(v) && v >= this.firstChar && v <= this.lastChar ? v : -1;
                  },
                  amend: function (map) {
                    error("Should not call amend()");
                  },
                }),
                IdentityToUnicodeMap
              );
            })(),
            OpenTypeFileBuilder = (function () {
              function writeInt16(dest, offset, num) {
                (dest[offset] = (num >> 8) & 255), (dest[offset + 1] = 255 & num);
              }
              function writeInt32(dest, offset, num) {
                (dest[offset] = (num >> 24) & 255),
                  (dest[offset + 1] = (num >> 16) & 255),
                  (dest[offset + 2] = (num >> 8) & 255),
                  (dest[offset + 3] = 255 & num);
              }
              function writeData(dest, offset, data) {
                var i, ii;
                if (data instanceof Uint8Array) dest.set(data, offset);
                else if ("string" == typeof data)
                  for (i = 0, ii = data.length; i < ii; i++) dest[offset++] = 255 & data.charCodeAt(i);
                else for (i = 0, ii = data.length; i < ii; i++) dest[offset++] = 255 & data[i];
              }
              function OpenTypeFileBuilder(sfnt) {
                (this.sfnt = sfnt), (this.tables = Object.create(null));
              }
              OpenTypeFileBuilder.getSearchParams = function (entriesCount, entrySize) {
                for (var maxPower2 = 1, log2 = 0; (maxPower2 ^ entriesCount) > maxPower2; ) (maxPower2 <<= 1), log2++;
                var searchRange = maxPower2 * entrySize;
                return { range: searchRange, entry: log2, rangeShift: entrySize * entriesCount - searchRange };
              };
              return (
                (OpenTypeFileBuilder.prototype = {
                  toArray: function () {
                    var sfnt = this.sfnt,
                      tables = this.tables,
                      tablesNames = Object.keys(tables);
                    tablesNames.sort();
                    var i,
                      j,
                      jj,
                      table,
                      tableName,
                      numTables = tablesNames.length,
                      offset = 12 + 16 * numTables,
                      tableOffsets = [offset];
                    for (i = 0; i < numTables; i++) {
                      table = tables[tablesNames[i]];
                      (offset += ((table.length + 3) & -4) >>> 0), tableOffsets.push(offset);
                    }
                    var file = new Uint8Array(offset);
                    for (i = 0; i < numTables; i++)
                      (table = tables[tablesNames[i]]), writeData(file, tableOffsets[i], table);
                    "true" === sfnt && (sfnt = string32(65536)),
                      (file[0] = 255 & sfnt.charCodeAt(0)),
                      (file[1] = 255 & sfnt.charCodeAt(1)),
                      (file[2] = 255 & sfnt.charCodeAt(2)),
                      (file[3] = 255 & sfnt.charCodeAt(3)),
                      writeInt16(file, 4, numTables);
                    var searchParams = OpenTypeFileBuilder.getSearchParams(numTables, 16);
                    for (
                      writeInt16(file, 6, searchParams.range),
                        writeInt16(file, 8, searchParams.entry),
                        writeInt16(file, 10, searchParams.rangeShift),
                        offset = 12,
                        i = 0;
                      i < numTables;
                      i++
                    ) {
                      (tableName = tablesNames[i]),
                        (file[offset] = 255 & tableName.charCodeAt(0)),
                        (file[offset + 1] = 255 & tableName.charCodeAt(1)),
                        (file[offset + 2] = 255 & tableName.charCodeAt(2)),
                        (file[offset + 3] = 255 & tableName.charCodeAt(3));
                      var checksum = 0;
                      for (j = tableOffsets[i], jj = tableOffsets[i + 1]; j < jj; j += 4) {
                        checksum = (checksum + readUint32(file, j)) >>> 0;
                      }
                      writeInt32(file, offset + 4, checksum),
                        writeInt32(file, offset + 8, tableOffsets[i]),
                        writeInt32(file, offset + 12, tables[tableName].length),
                        (offset += 16);
                    }
                    return file;
                  },
                  addTable: function (tag, data) {
                    if (tag in this.tables) throw new Error("Table " + tag + " already exists");
                    this.tables[tag] = data;
                  },
                }),
                OpenTypeFileBuilder
              );
            })(),
            ProblematicCharRanges = new Int32Array([
              0,
              32,
              127,
              161,
              173,
              174,
              1536,
              1920,
              2208,
              4256,
              6016,
              6144,
              7168,
              7248,
              8192,
              8208,
              8209,
              8210,
              8232,
              8240,
              8287,
              8304,
              9676,
              9677,
              12288,
              12289,
              43616,
              43648,
              65520,
              65536,
            ]),
            Font = (function () {
              function Font(name, file, properties) {
                var charCode, glyphName, unicode;
                (this.name = name),
                  (this.loadedName = properties.loadedName),
                  (this.isType3Font = properties.isType3Font),
                  (this.sizes = []),
                  (this.missingFile = !1),
                  (this.glyphCache = Object.create(null));
                var names = name.split("+");
                (names = names.length > 1 ? names[1] : names[0]),
                  (names = names.split(/[-,_]/g)[0]),
                  (this.isSerifFont = !!(properties.flags & FontFlags.Serif)),
                  (this.isSymbolicFont = !!(properties.flags & FontFlags.Symbolic)),
                  (this.isMonospace = !!(properties.flags & FontFlags.FixedPitch));
                var type = properties.type,
                  subtype = properties.subtype;
                if (
                  ((this.type = type),
                  (this.fallbackName = this.isMonospace ? "monospace" : this.isSerifFont ? "serif" : "sans-serif"),
                  (this.differences = properties.differences),
                  (this.widths = properties.widths),
                  (this.defaultWidth = properties.defaultWidth),
                  (this.composite = properties.composite),
                  (this.wideChars = properties.wideChars),
                  (this.cMap = properties.cMap),
                  (this.ascent = properties.ascent / PDF_GLYPH_SPACE_UNITS),
                  (this.descent = properties.descent / PDF_GLYPH_SPACE_UNITS),
                  (this.fontMatrix = properties.fontMatrix),
                  (this.bbox = properties.bbox),
                  (this.toUnicode = properties.toUnicode),
                  (this.toFontChar = []),
                  "Type3" === properties.type)
                ) {
                  for (charCode = 0; charCode < 256; charCode++)
                    this.toFontChar[charCode] = this.differences[charCode] || properties.defaultEncoding[charCode];
                  return void (this.fontType = FontType.TYPE3);
                }
                (this.cidEncoding = properties.cidEncoding),
                  (this.vertical = properties.vertical),
                  this.vertical &&
                    ((this.vmetrics = properties.vmetrics), (this.defaultVMetrics = properties.defaultVMetrics));
                var glyphsUnicodeMap;
                if (!file || file.isEmpty) {
                  file && warn('Font file is empty in "' + name + '" (' + this.loadedName + ")"),
                    (this.missingFile = !0);
                  var fontName = name.replace(/[,_]/g, "-"),
                    stdFontMap = getStdFontMap(),
                    nonStdFontMap = getNonStdFontMap(),
                    isStandardFont =
                      !!stdFontMap[fontName] || !(!nonStdFontMap[fontName] || !stdFontMap[nonStdFontMap[fontName]]);
                  if (
                    ((fontName = stdFontMap[fontName] || nonStdFontMap[fontName] || fontName),
                    (this.bold = -1 !== fontName.search(/bold/gi)),
                    (this.italic = -1 !== fontName.search(/oblique/gi) || -1 !== fontName.search(/italic/gi)),
                    (this.black = -1 !== name.search(/Black/g)),
                    (this.remeasure = Object.keys(this.widths).length > 0),
                    isStandardFont && "CIDFontType2" === type && 0 === properties.cidEncoding.indexOf("Identity-"))
                  ) {
                    var GlyphMapForStandardFonts = getGlyphMapForStandardFonts(),
                      map = [];
                    for (charCode in GlyphMapForStandardFonts) map[+charCode] = GlyphMapForStandardFonts[charCode];
                    if (/ArialBlack/i.test(name)) {
                      var SupplementalGlyphMapForArialBlack = getSupplementalGlyphMapForArialBlack();
                      for (charCode in SupplementalGlyphMapForArialBlack)
                        map[+charCode] = SupplementalGlyphMapForArialBlack[charCode];
                    }
                    this.toUnicode instanceof IdentityToUnicodeMap ||
                      this.toUnicode.forEach(function (charCode, unicodeCharCode) {
                        map[+charCode] = unicodeCharCode;
                      }),
                      (this.toFontChar = map),
                      (this.toUnicode = new ToUnicodeMap(map));
                  } else
                    /Symbol/i.test(fontName)
                      ? (this.toFontChar = buildToFontChar(
                          SymbolSetEncoding,
                          getGlyphsUnicode(),
                          properties.differences
                        ))
                      : /Dingbats/i.test(fontName)
                      ? (/Wingdings/i.test(name) && warn("Non-embedded Wingdings font, falling back to ZapfDingbats."),
                        (this.toFontChar = buildToFontChar(
                          ZapfDingbatsEncoding,
                          getDingbatsGlyphsUnicode(),
                          properties.differences
                        )))
                      : isStandardFont
                      ? (this.toFontChar = buildToFontChar(
                          properties.defaultEncoding,
                          getGlyphsUnicode(),
                          properties.differences
                        ))
                      : ((glyphsUnicodeMap = getGlyphsUnicode()),
                        this.toUnicode.forEach(
                          function (charCode, unicodeCharCode) {
                            this.composite ||
                              ((glyphName = properties.differences[charCode] || properties.defaultEncoding[charCode]),
                              -1 !== (unicode = getUnicodeForGlyph(glyphName, glyphsUnicodeMap)) &&
                                (unicodeCharCode = unicode)),
                              (this.toFontChar[charCode] = unicodeCharCode);
                          }.bind(this)
                        ));
                  return (
                    (this.loadedName = fontName.split("-")[0]),
                    (this.loading = !1),
                    void (this.fontType = getFontType(type, subtype))
                  );
                }
                "Type1C" === subtype &&
                  ("Type1" !== type && "MMType1" !== type
                    ? isTrueTypeFile(file)
                      ? (subtype = "TrueType")
                      : (type = "Type1")
                    : isOpenTypeFile(file) && (type = subtype = "OpenType")),
                  "CIDFontType0C" === subtype && "CIDFontType0" !== type && (type = "CIDFontType0"),
                  "OpenType" === subtype && (type = "OpenType"),
                  "CIDFontType0" === type &&
                    (isType1File(file)
                      ? (subtype = "CIDFontType0")
                      : isOpenTypeFile(file)
                      ? (type = subtype = "OpenType")
                      : (subtype = "CIDFontType0C"));
                var data;
                switch (type) {
                  case "MMType1":
                    info("MMType1 font (" + name + "), falling back to Type1.");
                  case "Type1":
                  case "CIDFontType0":
                    this.mimetype = "font/opentype";
                    var cff =
                      "Type1C" === subtype || "CIDFontType0C" === subtype
                        ? new CFFFont(file, properties)
                        : new Type1Font(name, file, properties);
                    adjustWidths(properties), (data = this.convert(name, cff, properties));
                    break;
                  case "OpenType":
                  case "TrueType":
                  case "CIDFontType2":
                    (this.mimetype = "font/opentype"),
                      (data = this.checkAndRepair(name, file, properties)),
                      this.isOpenType && (adjustWidths(properties), (type = "OpenType"));
                    break;
                  default:
                    error("Font " + type + " is not supported");
                }
                (this.data = data),
                  (this.fontType = getFontType(type, subtype)),
                  (this.fontMatrix = properties.fontMatrix),
                  (this.widths = properties.widths),
                  (this.defaultWidth = properties.defaultWidth),
                  (this.toUnicode = properties.toUnicode),
                  (this.encoding = properties.baseEncoding),
                  (this.seacMap = properties.seacMap),
                  (this.loading = !0);
              }
              function int16(b0, b1) {
                return (b0 << 8) + b1;
              }
              function signedInt16(b0, b1) {
                var value = (b0 << 8) + b1;
                return 32768 & value ? value - 65536 : value;
              }
              function int32(b0, b1, b2, b3) {
                return (b0 << 24) + (b1 << 16) + (b2 << 8) + b3;
              }
              function string16(value) {
                return String.fromCharCode((value >> 8) & 255, 255 & value);
              }
              function safeString16(value) {
                return (
                  (value = value > 32767 ? 32767 : value < -32768 ? -32768 : value),
                  String.fromCharCode((value >> 8) & 255, 255 & value)
                );
              }
              function isTrueTypeFile(file) {
                var header = file.peekBytes(4);
                return 65536 === readUint32(header, 0);
              }
              function isOpenTypeFile(file) {
                var header = file.peekBytes(4);
                return "OTTO" === bytesToString(header);
              }
              function isType1File(file) {
                var header = file.peekBytes(2);
                return (37 === header[0] && 33 === header[1]) || (128 === header[0] && 1 === header[1]);
              }
              function buildToFontChar(encoding, glyphsUnicodeMap, differences) {
                for (var unicode, toFontChar = [], i = 0, ii = encoding.length; i < ii; i++)
                  -1 !== (unicode = getUnicodeForGlyph(encoding[i], glyphsUnicodeMap)) && (toFontChar[i] = unicode);
                for (var charCode in differences)
                  -1 !== (unicode = getUnicodeForGlyph(differences[charCode], glyphsUnicodeMap)) &&
                    (toFontChar[+charCode] = unicode);
                return toFontChar;
              }
              function isProblematicUnicodeLocation(code) {
                for (var i = 0, j = ProblematicCharRanges.length - 1; i < j; ) {
                  var c = (i + j + 1) >> 1;
                  code < ProblematicCharRanges[c] ? (j = c - 1) : (i = c);
                }
                return !(1 & i);
              }
              function adjustMapping(charCodeToGlyphId, properties) {
                var toUnicode = properties.toUnicode,
                  isSymbolic = !!(properties.flags & FontFlags.Symbolic),
                  isIdentityUnicode = properties.toUnicode instanceof IdentityToUnicodeMap,
                  newMap = Object.create(null),
                  toFontChar = [],
                  usedFontCharCodes = [],
                  nextAvailableFontCharCode = PRIVATE_USE_OFFSET_START;
                for (var originalCharCode in charCodeToGlyphId) {
                  originalCharCode |= 0;
                  var glyphId = charCodeToGlyphId[originalCharCode],
                    fontCharCode = originalCharCode;
                  if (!isIdentityUnicode && toUnicode.has(originalCharCode)) {
                    var unicode = toUnicode.get(fontCharCode);
                    1 === unicode.length && (fontCharCode = unicode.charCodeAt(0));
                  }
                  if (
                    (void 0 !== usedFontCharCodes[fontCharCode] ||
                      isProblematicUnicodeLocation(fontCharCode) ||
                      (isSymbolic && isIdentityUnicode)) &&
                    nextAvailableFontCharCode <= PRIVATE_USE_OFFSET_END
                  )
                    do {
                      (fontCharCode = nextAvailableFontCharCode++),
                        SKIP_PRIVATE_USE_RANGE_F000_TO_F01F &&
                          61440 === fontCharCode &&
                          ((fontCharCode = 61472), (nextAvailableFontCharCode = fontCharCode + 1));
                    } while (
                      void 0 !== usedFontCharCodes[fontCharCode] &&
                      nextAvailableFontCharCode <= PRIVATE_USE_OFFSET_END
                    );
                  (newMap[fontCharCode] = glyphId),
                    (toFontChar[originalCharCode] = fontCharCode),
                    (usedFontCharCodes[fontCharCode] = !0);
                }
                return {
                  toFontChar: toFontChar,
                  charCodeToGlyphId: newMap,
                  nextAvailableFontCharCode: nextAvailableFontCharCode,
                };
              }
              function getRanges(glyphs, numGlyphs) {
                var codes = [];
                for (var charCode in glyphs)
                  glyphs[charCode] >= numGlyphs ||
                    codes.push({ fontCharCode: 0 | charCode, glyphId: glyphs[charCode] });
                codes.sort(function (a, b) {
                  return a.fontCharCode - b.fontCharCode;
                });
                for (var ranges = [], length = codes.length, n = 0; n < length; ) {
                  var start = codes[n].fontCharCode,
                    codeIndices = [codes[n].glyphId];
                  ++n;
                  for (
                    var end = start;
                    n < length &&
                    end + 1 === codes[n].fontCharCode &&
                    (codeIndices.push(codes[n].glyphId), ++end, ++n, 65535 !== end);

                  );
                  ranges.push([start, end, codeIndices]);
                }
                return ranges;
              }
              function createCmapTable(glyphs, numGlyphs) {
                var i,
                  ii,
                  j,
                  jj,
                  ranges = getRanges(glyphs, numGlyphs),
                  numTables = ranges[ranges.length - 1][1] > 65535 ? 2 : 1,
                  cmap = "\0\0" + string16(numTables) + "\0\0" + string32(4 + 8 * numTables);
                for (i = ranges.length - 1; i >= 0 && !(ranges[i][0] <= 65535); --i);
                var bmpLength = i + 1;
                ranges[i][0] < 65535 && 65535 === ranges[i][1] && (ranges[i][1] = 65534);
                var range,
                  start,
                  end,
                  codes,
                  trailingRangesCount = ranges[i][1] < 65535 ? 1 : 0,
                  segCount = bmpLength + trailingRangesCount,
                  searchParams = OpenTypeFileBuilder.getSearchParams(segCount, 2),
                  startCount = "",
                  endCount = "",
                  idDeltas = "",
                  idRangeOffsets = "",
                  glyphsIds = "",
                  bias = 0;
                for (i = 0, ii = bmpLength; i < ii; i++) {
                  (range = ranges[i]),
                    (start = range[0]),
                    (end = range[1]),
                    (startCount += string16(start)),
                    (endCount += string16(end)),
                    (codes = range[2]);
                  var contiguous = !0;
                  for (j = 1, jj = codes.length; j < jj; ++j)
                    if (codes[j] !== codes[j - 1] + 1) {
                      contiguous = !1;
                      break;
                    }
                  if (contiguous) {
                    (idDeltas += string16((codes[0] - start) & 65535)), (idRangeOffsets += string16(0));
                  } else {
                    var offset = 2 * (segCount - i) + 2 * bias;
                    for (
                      bias += end - start + 1,
                        idDeltas += string16(0),
                        idRangeOffsets += string16(offset),
                        j = 0,
                        jj = codes.length;
                      j < jj;
                      ++j
                    )
                      glyphsIds += string16(codes[j]);
                  }
                }
                trailingRangesCount > 0 &&
                  ((endCount += "ÿÿ"), (startCount += "ÿÿ"), (idDeltas += "\0"), (idRangeOffsets += "\0\0"));
                var format314 =
                    "\0\0" +
                    string16(2 * segCount) +
                    string16(searchParams.range) +
                    string16(searchParams.entry) +
                    string16(searchParams.rangeShift) +
                    endCount +
                    "\0\0" +
                    startCount +
                    idDeltas +
                    idRangeOffsets +
                    glyphsIds,
                  format31012 = "",
                  header31012 = "";
                if (numTables > 1) {
                  for (
                    cmap += "\0\0\n" + string32(4 + 8 * numTables + 4 + format314.length),
                      format31012 = "",
                      i = 0,
                      ii = ranges.length;
                    i < ii;
                    i++
                  ) {
                    (range = ranges[i]), (start = range[0]), (codes = range[2]);
                    var code = codes[0];
                    for (j = 1, jj = codes.length; j < jj; ++j)
                      codes[j] !== codes[j - 1] + 1 &&
                        ((end = range[0] + j - 1),
                        (format31012 += string32(start) + string32(end) + string32(code)),
                        (start = end + 1),
                        (code = codes[j]));
                    format31012 += string32(start) + string32(range[1]) + string32(code);
                  }
                  header31012 =
                    "\0\f\0\0" + string32(format31012.length + 16) + "\0\0\0\0" + string32(format31012.length / 12);
                }
                return cmap + "\0" + string16(format314.length + 4) + format314 + header31012 + format31012;
              }
              function validateOS2Table(os2) {
                var stream = new Stream(os2.data),
                  version = stream.getUint16();
                stream.getBytes(60);
                var selection = stream.getUint16();
                return (
                  !(version < 4 && 768 & selection) &&
                  !(stream.getUint16() > stream.getUint16()) &&
                  (stream.getBytes(6), 0 !== stream.getUint16() && ((os2.data[8] = os2.data[9] = 0), !0))
                );
              }
              function createOS2Table(properties, charstrings, override) {
                override = override || { unitsPerEm: 0, yMax: 0, yMin: 0, ascent: 0, descent: 0 };
                var ulUnicodeRange1 = 0,
                  ulUnicodeRange2 = 0,
                  ulUnicodeRange3 = 0,
                  ulUnicodeRange4 = 0,
                  firstCharIndex = null,
                  lastCharIndex = 0;
                if (charstrings)
                  for (var code in charstrings) {
                    (code |= 0),
                      (firstCharIndex > code || !firstCharIndex) && (firstCharIndex = code),
                      lastCharIndex < code && (lastCharIndex = code);
                    var position = getUnicodeRangeFor(code);
                    position < 32
                      ? (ulUnicodeRange1 |= 1 << position)
                      : position < 64
                      ? (ulUnicodeRange2 |= 1 << (position - 32))
                      : position < 96
                      ? (ulUnicodeRange3 |= 1 << (position - 64))
                      : position < 123
                      ? (ulUnicodeRange4 |= 1 << (position - 96))
                      : error("Unicode ranges Bits > 123 are reserved for internal usage");
                  }
                else (firstCharIndex = 0), (lastCharIndex = 255);
                var bbox = properties.bbox || [0, 0, 0, 0],
                  unitsPerEm = override.unitsPerEm || 1 / (properties.fontMatrix || FONT_IDENTITY_MATRIX)[0],
                  scale = properties.ascentScaled ? 1 : unitsPerEm / PDF_GLYPH_SPACE_UNITS,
                  typoAscent = override.ascent || Math.round(scale * (properties.ascent || bbox[3])),
                  typoDescent = override.descent || Math.round(scale * (properties.descent || bbox[1]));
                typoDescent > 0 && properties.descent > 0 && bbox[1] < 0 && (typoDescent = -typoDescent);
                var winAscent = override.yMax || typoAscent,
                  winDescent = -override.yMin || -typoDescent;
                return (
                  "\0$ô\0\0\0»\0\0\0»\0\0ß\x001\0\0\0\0" +
                  String.fromCharCode(properties.fixedPitch ? 9 : 0) +
                  "\0\0\0\0\0\0" +
                  string32(ulUnicodeRange1) +
                  string32(ulUnicodeRange2) +
                  string32(ulUnicodeRange3) +
                  string32(ulUnicodeRange4) +
                  "*21*" +
                  string16(properties.italicAngle ? 1 : 0) +
                  string16(firstCharIndex || properties.firstChar) +
                  string16(lastCharIndex || properties.lastChar) +
                  string16(typoAscent) +
                  string16(typoDescent) +
                  "\0d" +
                  string16(winAscent) +
                  string16(winDescent) +
                  "\0\0\0\0\0\0\0\0" +
                  string16(properties.xHeight) +
                  string16(properties.capHeight) +
                  string16(0) +
                  string16(firstCharIndex || properties.firstChar) +
                  "\0"
                );
              }
              function createPostTable(properties) {
                var angle = Math.floor(properties.italicAngle * Math.pow(2, 16));
                return (
                  "\0\0\0" +
                  string32(angle) +
                  "\0\0\0\0" +
                  string32(properties.fixedPitch) +
                  "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0"
                );
              }
              function createNameTable(name, proto) {
                proto || (proto = [[], []]);
                var i,
                  ii,
                  j,
                  jj,
                  str,
                  strings = [
                    proto[0][0] || "Original licence",
                    proto[0][1] || name,
                    proto[0][2] || "Unknown",
                    proto[0][3] || "uniqueID",
                    proto[0][4] || name,
                    proto[0][5] || "Version 0.11",
                    proto[0][6] || "",
                    proto[0][7] || "Unknown",
                    proto[0][8] || "Unknown",
                    proto[0][9] || "Unknown",
                  ],
                  stringsUnicode = [];
                for (i = 0, ii = strings.length; i < ii; i++) {
                  str = proto[1][i] || strings[i];
                  var strBufUnicode = [];
                  for (j = 0, jj = str.length; j < jj; j++) strBufUnicode.push(string16(str.charCodeAt(j)));
                  stringsUnicode.push(strBufUnicode.join(""));
                }
                var names = [strings, stringsUnicode],
                  platforms = ["\0", "\0"],
                  encodings = ["\0\0", "\0"],
                  languages = ["\0\0", "\t"],
                  namesRecordCount = strings.length * platforms.length,
                  nameTable = "\0\0" + string16(namesRecordCount) + string16(12 * namesRecordCount + 6),
                  strOffset = 0;
                for (i = 0, ii = platforms.length; i < ii; i++) {
                  var strs = names[i];
                  for (j = 0, jj = strs.length; j < jj; j++) {
                    str = strs[j];
                    (nameTable +=
                      platforms[i] +
                      encodings[i] +
                      languages[i] +
                      string16(j) +
                      string16(str.length) +
                      string16(strOffset)),
                      (strOffset += str.length);
                  }
                }
                return (nameTable += strings.join("") + stringsUnicode.join(""));
              }
              return (
                (Font.getFontID = (function () {
                  var ID = 1;
                  return function () {
                    return String(ID++);
                  };
                })()),
                (Font.prototype = {
                  name: null,
                  font: null,
                  mimetype: null,
                  encoding: null,
                  get renderer() {
                    var renderer = FontRendererFactory.create(this, SEAC_ANALYSIS_ENABLED);
                    return shadow(this, "renderer", renderer);
                  },
                  exportData: function () {
                    var data = {};
                    for (var i in this) this.hasOwnProperty(i) && (data[i] = this[i]);
                    return data;
                  },
                  checkAndRepair: function (name, font, properties) {
                    function sanitizeGlyph(source, sourceStart, sourceEnd, dest, destStart, hintsValid) {
                      if (sourceEnd - sourceStart <= 12) return 0;
                      var glyf = source.subarray(sourceStart, sourceEnd),
                        contoursCount = (glyf[0] << 8) | glyf[1];
                      if (32768 & contoursCount) return dest.set(glyf, destStart), glyf.length;
                      var i,
                        j = 10,
                        flagsCount = 0;
                      for (i = 0; i < contoursCount; i++) {
                        (flagsCount = ((glyf[j] << 8) | glyf[j + 1]) + 1), (j += 2);
                      }
                      var instructionsStart = j,
                        instructionsLength = (glyf[j] << 8) | glyf[j + 1];
                      j += 2 + instructionsLength;
                      var instructionsEnd = j,
                        coordinatesLength = 0;
                      for (i = 0; i < flagsCount; i++) {
                        var flag = glyf[j++];
                        192 & flag && (glyf[j - 1] = 63 & flag);
                        var xyLength = (2 & flag ? 1 : 16 & flag ? 0 : 2) + (4 & flag ? 1 : 32 & flag ? 0 : 2);
                        if (((coordinatesLength += xyLength), 8 & flag)) {
                          var repeat = glyf[j++];
                          (i += repeat), (coordinatesLength += repeat * xyLength);
                        }
                      }
                      if (0 === coordinatesLength) return 0;
                      var glyphDataLength = j + coordinatesLength;
                      return glyphDataLength > glyf.length
                        ? 0
                        : !hintsValid && instructionsLength > 0
                        ? (dest.set(glyf.subarray(0, instructionsStart), destStart),
                          dest.set([0, 0], destStart + instructionsStart),
                          dest.set(glyf.subarray(instructionsEnd, glyphDataLength), destStart + instructionsStart + 2),
                          (glyphDataLength -= instructionsLength),
                          glyf.length - glyphDataLength > 3 && (glyphDataLength = (glyphDataLength + 3) & -4),
                          glyphDataLength)
                        : glyf.length - glyphDataLength > 3
                        ? ((glyphDataLength = (glyphDataLength + 3) & -4),
                          dest.set(glyf.subarray(0, glyphDataLength), destStart),
                          glyphDataLength)
                        : (dest.set(glyf, destStart), glyf.length);
                    }
                    function sanitizeTTProgram(table, ttContext) {
                      for (
                        var j,
                          n,
                          b,
                          funcId,
                          pc,
                          data = table.data,
                          i = 0,
                          lastEndf = 0,
                          lastDeff = 0,
                          stack = [],
                          callstack = [],
                          functionsCalled = [],
                          tooComplexToFollowFunctions = ttContext.tooComplexToFollowFunctions,
                          inFDEF = !1,
                          ifLevel = 0,
                          inELSE = 0,
                          ii = data.length;
                        i < ii;

                      ) {
                        var op = data[i++];
                        if (64 === op)
                          if (((n = data[i++]), inFDEF || inELSE)) i += n;
                          else for (j = 0; j < n; j++) stack.push(data[i++]);
                        else if (65 === op)
                          if (((n = data[i++]), inFDEF || inELSE)) i += 2 * n;
                          else for (j = 0; j < n; j++) (b = data[i++]), stack.push((b << 8) | data[i++]);
                        else if (176 == (248 & op))
                          if (((n = op - 176 + 1), inFDEF || inELSE)) i += n;
                          else for (j = 0; j < n; j++) stack.push(data[i++]);
                        else if (184 == (248 & op))
                          if (((n = op - 184 + 1), inFDEF || inELSE)) i += 2 * n;
                          else for (j = 0; j < n; j++) (b = data[i++]), stack.push((b << 8) | data[i++]);
                        else if (43 !== op || tooComplexToFollowFunctions)
                          if (44 !== op || tooComplexToFollowFunctions) {
                            if (45 === op)
                              if (inFDEF) (inFDEF = !1), (lastEndf = i);
                              else {
                                if (!(pc = callstack.pop()))
                                  return warn("TT: ENDF bad stack"), void (ttContext.hintsValid = !1);
                                (funcId = functionsCalled.pop()),
                                  (data = pc.data),
                                  (i = pc.i),
                                  (ttContext.functionsStackDeltas[funcId] = stack.length - pc.stackTop);
                              }
                            else if (137 === op)
                              (inFDEF || inELSE) &&
                                (warn("TT: nested IDEFs not allowed"), (tooComplexToFollowFunctions = !0)),
                                (inFDEF = !0),
                                (lastDeff = i);
                            else if (88 === op) ++ifLevel;
                            else if (27 === op) inELSE = ifLevel;
                            else if (89 === op) inELSE === ifLevel && (inELSE = 0), --ifLevel;
                            else if (28 === op && !inFDEF && !inELSE) {
                              var offset = stack[stack.length - 1];
                              offset > 0 && (i += offset - 1);
                            }
                          } else
                            (inFDEF || inELSE) &&
                              (warn("TT: nested FDEFs not allowed"), (tooComplexToFollowFunctions = !0)),
                              (inFDEF = !0),
                              (lastDeff = i),
                              (funcId = stack.pop()),
                              (ttContext.functionsDefined[funcId] = { data: data, i: i });
                        else if (!inFDEF && !inELSE)
                          if (
                            ((funcId = stack[stack.length - 1]),
                            (ttContext.functionsUsed[funcId] = !0),
                            funcId in ttContext.functionsStackDeltas)
                          )
                            stack.length += ttContext.functionsStackDeltas[funcId];
                          else if (funcId in ttContext.functionsDefined && functionsCalled.indexOf(funcId) < 0) {
                            if (
                              (callstack.push({ data: data, i: i, stackTop: stack.length - 1 }),
                              functionsCalled.push(funcId),
                              !(pc = ttContext.functionsDefined[funcId]))
                            )
                              return warn("TT: CALL non-existent function"), void (ttContext.hintsValid = !1);
                            (data = pc.data), (i = pc.i);
                          }
                        if (!inFDEF && !inELSE) {
                          var stackDelta =
                            op <= 142 ? TTOpsStackDeltas[op] : op >= 192 && op <= 223 ? -1 : op >= 224 ? -2 : 0;
                          for (
                            op >= 113 && op <= 117 && (n = stack.pop()) === n && (stackDelta = 2 * -n);
                            stackDelta < 0 && stack.length > 0;

                          )
                            stack.pop(), stackDelta++;
                          for (; stackDelta > 0; ) stack.push(NaN), stackDelta--;
                        }
                      }
                      ttContext.tooComplexToFollowFunctions = tooComplexToFollowFunctions;
                      var content = [data];
                      i > data.length && content.push(new Uint8Array(i - data.length)),
                        lastDeff > lastEndf &&
                          (warn("TT: complementing a missing function tail"), content.push(new Uint8Array([34, 45]))),
                        foldTTTable(table, content);
                    }
                    function checkInvalidFunctions(ttContext, maxFunctionDefs) {
                      if (!ttContext.tooComplexToFollowFunctions) {
                        if (ttContext.functionsDefined.length > maxFunctionDefs)
                          return warn("TT: more functions defined than expected"), void (ttContext.hintsValid = !1);
                        for (var j = 0, jj = ttContext.functionsUsed.length; j < jj; j++) {
                          if (j > maxFunctionDefs)
                            return warn("TT: invalid function id: " + j), void (ttContext.hintsValid = !1);
                          if (ttContext.functionsUsed[j] && !ttContext.functionsDefined[j])
                            return warn("TT: undefined function: " + j), void (ttContext.hintsValid = !1);
                        }
                      }
                    }
                    function foldTTTable(table, content) {
                      if (content.length > 1) {
                        var j,
                          jj,
                          newLength = 0;
                        for (j = 0, jj = content.length; j < jj; j++) newLength += content[j].length;
                        newLength = (newLength + 3) & -4;
                        var result = new Uint8Array(newLength),
                          pos = 0;
                        for (j = 0, jj = content.length; j < jj; j++)
                          result.set(content[j], pos), (pos += content[j].length);
                        (table.data = result), (table.length = newLength);
                      }
                    }
                    function hasGlyph(glyphId, charCode, widthCode) {
                      return (
                        !missingGlyphs[glyphId] ||
                        !!(!skipToUnicode && charCode >= 0 && toUnicode.has(charCode)) ||
                        !!(widths && widthCode >= 0 && isNum(widths[widthCode]))
                      );
                    }
                    var TTOpsStackDeltas = [
                      0,
                      0,
                      0,
                      0,
                      0,
                      0,
                      0,
                      0,
                      -2,
                      -2,
                      -2,
                      -2,
                      0,
                      0,
                      -2,
                      -5,
                      -1,
                      -1,
                      -1,
                      -1,
                      -1,
                      -1,
                      -1,
                      -1,
                      0,
                      0,
                      -1,
                      0,
                      -1,
                      -1,
                      -1,
                      -1,
                      1,
                      -1,
                      -999,
                      0,
                      1,
                      0,
                      -1,
                      -2,
                      0,
                      -1,
                      -2,
                      -1,
                      -1,
                      0,
                      -1,
                      -1,
                      0,
                      0,
                      -999,
                      -999,
                      -1,
                      -1,
                      -1,
                      -1,
                      -2,
                      -999,
                      -2,
                      -2,
                      -999,
                      0,
                      -2,
                      -2,
                      0,
                      0,
                      -2,
                      0,
                      -2,
                      0,
                      0,
                      0,
                      -2,
                      -1,
                      -1,
                      1,
                      1,
                      0,
                      0,
                      -1,
                      -1,
                      -1,
                      -1,
                      -1,
                      -1,
                      -1,
                      0,
                      0,
                      -1,
                      0,
                      -1,
                      -1,
                      0,
                      -999,
                      -1,
                      -1,
                      -1,
                      -1,
                      -1,
                      -1,
                      0,
                      0,
                      0,
                      0,
                      0,
                      0,
                      0,
                      0,
                      0,
                      0,
                      0,
                      0,
                      -2,
                      -999,
                      -999,
                      -999,
                      -999,
                      -999,
                      -1,
                      -1,
                      -2,
                      -2,
                      0,
                      0,
                      0,
                      0,
                      -1,
                      -1,
                      -999,
                      -2,
                      -2,
                      0,
                      0,
                      -1,
                      -2,
                      -2,
                      0,
                      0,
                      0,
                      -1,
                      -1,
                      -1,
                      -2,
                    ];
                    font = new Stream(new Uint8Array(font.getBytes()));
                    var cff,
                      cffFile,
                      VALID_TABLES = [
                        "OS/2",
                        "cmap",
                        "head",
                        "hhea",
                        "hmtx",
                        "maxp",
                        "name",
                        "post",
                        "loca",
                        "glyf",
                        "fpgm",
                        "prep",
                        "cvt ",
                        "CFF ",
                      ],
                      header = (function (ttf) {
                        return {
                          version: bytesToString(ttf.getBytes(4)),
                          numTables: ttf.getUint16(),
                          searchRange: ttf.getUint16(),
                          entrySelector: ttf.getUint16(),
                          rangeShift: ttf.getUint16(),
                        };
                      })(font),
                      numTables = header.numTables,
                      tables = Object.create(null);
                    (tables["OS/2"] = null),
                      (tables.cmap = null),
                      (tables.head = null),
                      (tables.hhea = null),
                      (tables.hmtx = null),
                      (tables.maxp = null),
                      (tables.name = null),
                      (tables.post = null);
                    for (var table, i = 0; i < numTables; i++)
                      (table = (function (file) {
                        var tag = bytesToString(file.getBytes(4)),
                          checksum = file.getInt32() >>> 0,
                          offset = file.getInt32() >>> 0,
                          length = file.getInt32() >>> 0,
                          previousPosition = file.pos;
                        (file.pos = file.start ? file.start : 0), file.skip(offset);
                        var data = file.getBytes(length);
                        return (
                          (file.pos = previousPosition),
                          "head" === tag && ((data[8] = data[9] = data[10] = data[11] = 0), (data[17] |= 32)),
                          { tag: tag, checksum: checksum, length: length, offset: offset, data: data }
                        );
                      })(font)),
                        VALID_TABLES.indexOf(table.tag) < 0 || (0 !== table.length && (tables[table.tag] = table));
                    var isTrueType = !tables["CFF "];
                    if (isTrueType)
                      tables.loca || error('Required "loca" table is not found'),
                        tables.glyf ||
                          (warn('Required "glyf" table is not found -- trying to recover.'),
                          (tables.glyf = { tag: "glyf", data: new Uint8Array(0) })),
                        (this.isOpenType = !1);
                    else {
                      if (
                        ("OTTO" === header.version && "CIDFontType2" !== properties.type) ||
                        !tables.head ||
                        !tables.hhea ||
                        !tables.maxp ||
                        !tables.post
                      )
                        return (
                          (cffFile = new Stream(tables["CFF "].data)),
                          (cff = new CFFFont(cffFile, properties)),
                          adjustWidths(properties),
                          this.convert(name, cff, properties)
                        );
                      delete tables.glyf,
                        delete tables.loca,
                        delete tables.fpgm,
                        delete tables.prep,
                        delete tables["cvt "],
                        (this.isOpenType = !0);
                    }
                    tables.maxp || error('Required "maxp" table is not found'),
                      (font.pos = (font.start || 0) + tables.maxp.offset);
                    var version = font.getInt32(),
                      numGlyphs = font.getUint16(),
                      maxFunctionDefs = 0;
                    if (version >= 65536 && tables.maxp.length >= 22) {
                      font.pos += 8;
                      font.getUint16() > 2 && ((tables.maxp.data[14] = 0), (tables.maxp.data[15] = 2)),
                        (font.pos += 4),
                        (maxFunctionDefs = font.getUint16());
                    }
                    var dupFirstEntry = !1;
                    "CIDFontType2" === properties.type &&
                      properties.toUnicode &&
                      properties.toUnicode.get(0) > "\0" &&
                      ((dupFirstEntry = !0),
                      numGlyphs++,
                      (tables.maxp.data[4] = numGlyphs >> 8),
                      (tables.maxp.data[5] = 255 & numGlyphs));
                    var hintsValid = (function (fpgm, prep, cvt, maxFunctionDefs) {
                      var ttContext = {
                        functionsDefined: [],
                        functionsUsed: [],
                        functionsStackDeltas: [],
                        tooComplexToFollowFunctions: !1,
                        hintsValid: !0,
                      };
                      if (
                        (fpgm && sanitizeTTProgram(fpgm, ttContext),
                        prep && sanitizeTTProgram(prep, ttContext),
                        fpgm && checkInvalidFunctions(ttContext, maxFunctionDefs),
                        cvt && 1 & cvt.length)
                      ) {
                        var cvtData = new Uint8Array(cvt.length + 1);
                        cvtData.set(cvt.data), (cvt.data = cvtData);
                      }
                      return ttContext.hintsValid;
                    })(tables.fpgm, tables.prep, tables["cvt "], maxFunctionDefs);
                    hintsValid || (delete tables.fpgm, delete tables.prep, delete tables["cvt "]),
                      (function (font, header, metrics, numGlyphs) {
                        if (!header) return void (metrics && (metrics.data = null));
                        (font.pos = (font.start ? font.start : 0) + header.offset), (font.pos += header.length - 2);
                        var numOfMetrics = font.getUint16();
                        numOfMetrics > numGlyphs &&
                          (info(
                            "The numOfMetrics (" +
                              numOfMetrics +
                              ") should not be greater than the numGlyphs (" +
                              numGlyphs +
                              ")"
                          ),
                          (numOfMetrics = numGlyphs),
                          (header.data[34] = (65280 & numOfMetrics) >> 8),
                          (header.data[35] = 255 & numOfMetrics));
                        var numOfSidebearings = numGlyphs - numOfMetrics,
                          numMissing = numOfSidebearings - ((metrics.length - 4 * numOfMetrics) >> 1);
                        if (numMissing > 0) {
                          var entries = new Uint8Array(metrics.length + 2 * numMissing);
                          entries.set(metrics.data), (metrics.data = entries);
                        }
                      })(font, tables.hhea, tables.hmtx, numGlyphs),
                      tables.head || error('Required "head" table is not found'),
                      (function (head, numGlyphs, locaLength) {
                        var data = head.data,
                          version = int32(data[0], data[1], data[2], data[3]);
                        version >> 16 != 1 &&
                          (info("Attempting to fix invalid version in head table: " + version),
                          (data[0] = 0),
                          (data[1] = 1),
                          (data[2] = 0),
                          (data[3] = 0));
                        var indexToLocFormat = int16(data[50], data[51]);
                        if (indexToLocFormat < 0 || indexToLocFormat > 1) {
                          info("Attempting to fix invalid indexToLocFormat in head table: " + indexToLocFormat);
                          var numGlyphsPlusOne = numGlyphs + 1;
                          locaLength === numGlyphsPlusOne << 1
                            ? ((data[50] = 0), (data[51] = 0))
                            : locaLength === numGlyphsPlusOne << 2
                            ? ((data[50] = 0), (data[51] = 1))
                            : warn("Could not fix indexToLocFormat: " + indexToLocFormat);
                        }
                      })(tables.head, numGlyphs, isTrueType ? tables.loca.length : 0);
                    var missingGlyphs = Object.create(null);
                    if (isTrueType) {
                      var isGlyphLocationsLong = int16(tables.head.data[50], tables.head.data[51]);
                      missingGlyphs = (function (
                        loca,
                        glyf,
                        numGlyphs,
                        isGlyphLocationsLong,
                        hintsValid,
                        dupFirstEntry
                      ) {
                        var itemSize, itemDecode, itemEncode;
                        isGlyphLocationsLong
                          ? ((itemSize = 4),
                            (itemDecode = function (data, offset) {
                              return (
                                (data[offset] << 24) |
                                (data[offset + 1] << 16) |
                                (data[offset + 2] << 8) |
                                data[offset + 3]
                              );
                            }),
                            (itemEncode = function (data, offset, value) {
                              (data[offset] = (value >>> 24) & 255),
                                (data[offset + 1] = (value >> 16) & 255),
                                (data[offset + 2] = (value >> 8) & 255),
                                (data[offset + 3] = 255 & value);
                            }))
                          : ((itemSize = 2),
                            (itemDecode = function (data, offset) {
                              return (data[offset] << 9) | (data[offset + 1] << 1);
                            }),
                            (itemEncode = function (data, offset, value) {
                              (data[offset] = (value >> 9) & 255), (data[offset + 1] = (value >> 1) & 255);
                            }));
                        var locaData = loca.data,
                          locaDataSize = itemSize * (1 + numGlyphs);
                        locaData.length !== locaDataSize &&
                          ((locaData = new Uint8Array(locaDataSize)),
                          locaData.set(loca.data.subarray(0, locaDataSize)),
                          (loca.data = locaData));
                        var oldGlyfData = glyf.data,
                          oldGlyfDataLength = oldGlyfData.length,
                          newGlyfData = new Uint8Array(oldGlyfDataLength),
                          startOffset = itemDecode(locaData, 0),
                          writeOffset = 0,
                          missingGlyphData = Object.create(null);
                        itemEncode(locaData, 0, writeOffset);
                        var i, j;
                        for (i = 0, j = itemSize; i < numGlyphs; i++, j += itemSize) {
                          var endOffset = itemDecode(locaData, j);
                          if (
                            (endOffset > oldGlyfDataLength &&
                              ((oldGlyfDataLength + 3) & -4) === endOffset &&
                              (endOffset = oldGlyfDataLength),
                            endOffset > oldGlyfDataLength)
                          )
                            itemEncode(locaData, j, writeOffset), (startOffset = endOffset);
                          else {
                            startOffset === endOffset && (missingGlyphData[i] = !0);
                            (writeOffset += sanitizeGlyph(
                              oldGlyfData,
                              startOffset,
                              endOffset,
                              newGlyfData,
                              writeOffset,
                              hintsValid
                            )),
                              itemEncode(locaData, j, writeOffset),
                              (startOffset = endOffset);
                          }
                        }
                        if (0 === writeOffset) {
                          var simpleGlyph = new Uint8Array([0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 49, 0]);
                          for (i = 0, j = itemSize; i < numGlyphs; i++, j += itemSize)
                            itemEncode(locaData, j, simpleGlyph.length);
                          return (glyf.data = simpleGlyph), missingGlyphData;
                        }
                        if (dupFirstEntry) {
                          var firstEntryLength = itemDecode(locaData, itemSize);
                          newGlyfData.length > firstEntryLength + writeOffset
                            ? (glyf.data = newGlyfData.subarray(0, firstEntryLength + writeOffset))
                            : ((glyf.data = new Uint8Array(firstEntryLength + writeOffset)),
                              glyf.data.set(newGlyfData.subarray(0, writeOffset))),
                            glyf.data.set(newGlyfData.subarray(0, firstEntryLength), writeOffset),
                            itemEncode(loca.data, locaData.length - itemSize, writeOffset + firstEntryLength);
                        } else glyf.data = newGlyfData.subarray(0, writeOffset);
                        return missingGlyphData;
                      })(tables.loca, tables.glyf, numGlyphs, isGlyphLocationsLong, hintsValid, dupFirstEntry);
                    }
                    tables.hhea || error('Required "hhea" table is not found'),
                      0 === tables.hhea.data[10] &&
                        0 === tables.hhea.data[11] &&
                        ((tables.hhea.data[10] = 255), (tables.hhea.data[11] = 255));
                    var metricsOverride = {
                      unitsPerEm: int16(tables.head.data[18], tables.head.data[19]),
                      yMax: int16(tables.head.data[42], tables.head.data[43]),
                      yMin: signedInt16(tables.head.data[38], tables.head.data[39]),
                      ascent: int16(tables.hhea.data[4], tables.hhea.data[5]),
                      descent: signedInt16(tables.hhea.data[6], tables.hhea.data[7]),
                    };
                    if (
                      ((this.ascent = metricsOverride.ascent / metricsOverride.unitsPerEm),
                      (this.descent = metricsOverride.descent / metricsOverride.unitsPerEm),
                      tables.post)
                    ) {
                      (function (post, properties, maxpNumGlyphs) {
                        var start = (font.start ? font.start : 0) + post.offset;
                        font.pos = start;
                        var length = post.length,
                          end = start + length,
                          version = font.getInt32();
                        font.getBytes(28);
                        var glyphNames,
                          i,
                          valid = !0;
                        switch (version) {
                          case 65536:
                            glyphNames = MacStandardGlyphOrdering;
                            break;
                          case 131072:
                            var numGlyphs = font.getUint16();
                            if (numGlyphs !== maxpNumGlyphs) {
                              valid = !1;
                              break;
                            }
                            var glyphNameIndexes = [];
                            for (i = 0; i < numGlyphs; ++i) {
                              var index = font.getUint16();
                              if (index >= 32768) {
                                valid = !1;
                                break;
                              }
                              glyphNameIndexes.push(index);
                            }
                            if (!valid) break;
                            for (var customNames = [], strBuf = []; font.pos < end; ) {
                              var stringLength = font.getByte();
                              for (strBuf.length = stringLength, i = 0; i < stringLength; ++i)
                                strBuf[i] = String.fromCharCode(font.getByte());
                              customNames.push(strBuf.join(""));
                            }
                            for (glyphNames = [], i = 0; i < numGlyphs; ++i) {
                              var j = glyphNameIndexes[i];
                              j < 258
                                ? glyphNames.push(MacStandardGlyphOrdering[j])
                                : glyphNames.push(customNames[j - 258]);
                            }
                            break;
                          case 196608:
                            break;
                          default:
                            warn("Unknown/unsupported post table version " + version),
                              (valid = !1),
                              properties.defaultEncoding && (glyphNames = properties.defaultEncoding);
                        }
                        return (properties.glyphNames = glyphNames), valid;
                      })(tables.post, properties, numGlyphs) || (tables.post = null);
                    }
                    var charCode,
                      charCodeToGlyphId = [],
                      toUnicode = properties.toUnicode,
                      widths = properties.widths,
                      skipToUnicode = toUnicode instanceof IdentityToUnicodeMap || 65536 === toUnicode.length;
                    if ("CIDFontType2" === properties.type) {
                      var cidToGidMap = properties.cidToGidMap || [],
                        isCidToGidMapEmpty = 0 === cidToGidMap.length;
                      properties.cMap.forEach(function (charCode, cid) {
                        assert(cid <= 65535, "Max size of CID is 65,535");
                        var glyphId = -1;
                        isCidToGidMapEmpty
                          ? (glyphId = cid)
                          : void 0 !== cidToGidMap[cid] && (glyphId = cidToGidMap[cid]),
                          glyphId >= 0 &&
                            glyphId < numGlyphs &&
                            hasGlyph(glyphId, charCode, cid) &&
                            (charCodeToGlyphId[charCode] = glyphId);
                      }),
                        !dupFirstEntry ||
                          (!isCidToGidMapEmpty && charCodeToGlyphId[0]) ||
                          (charCodeToGlyphId[0] = numGlyphs - 1);
                    } else {
                      var cmapTable = (function (cmap, font, isSymbolicFont, hasEncoding) {
                          if (!cmap)
                            return (
                              warn("No cmap table available."),
                              { platformId: -1, encodingId: -1, mappings: [], hasShortCmap: !1 }
                            );
                          var segment,
                            start = (font.start ? font.start : 0) + cmap.offset;
                          font.pos = start;
                          for (
                            var potentialTable, numTables = (font.getUint16(), font.getUint16()), canBreak = !1, i = 0;
                            i < numTables;
                            i++
                          ) {
                            var platformId = font.getUint16(),
                              encodingId = font.getUint16(),
                              offset = font.getInt32() >>> 0,
                              useTable = !1;
                            if (
                              (0 === platformId && 0 === encodingId
                                ? (useTable = !0)
                                : 1 === platformId && 0 === encodingId
                                ? (useTable = !0)
                                : 3 !== platformId ||
                                  1 !== encodingId ||
                                  ((isSymbolicFont || !hasEncoding) && potentialTable)
                                ? isSymbolicFont &&
                                  3 === platformId &&
                                  0 === encodingId &&
                                  ((useTable = !0), (canBreak = !0))
                                : ((useTable = !0), isSymbolicFont || (canBreak = !0)),
                              useTable &&
                                (potentialTable = { platformId: platformId, encodingId: encodingId, offset: offset }),
                              canBreak)
                            )
                              break;
                          }
                          if (
                            (potentialTable && (font.pos = start + potentialTable.offset),
                            !potentialTable || -1 === font.peekByte())
                          )
                            return (
                              warn("Could not find a preferred cmap table."),
                              { platformId: -1, encodingId: -1, mappings: [], hasShortCmap: !1 }
                            );
                          var j,
                            glyphId,
                            format = font.getUint16(),
                            hasShortCmap = (font.getUint16(), font.getUint16(), !1),
                            mappings = [];
                          if (0 === format) {
                            for (j = 0; j < 256; j++) {
                              var index = font.getByte();
                              index && mappings.push({ charCode: j, glyphId: index });
                            }
                            hasShortCmap = !0;
                          } else if (4 === format) {
                            var segCount = font.getUint16() >> 1;
                            font.getBytes(6);
                            var segIndex,
                              segments = [];
                            for (segIndex = 0; segIndex < segCount; segIndex++)
                              segments.push({ end: font.getUint16() });
                            for (font.getUint16(), segIndex = 0; segIndex < segCount; segIndex++)
                              segments[segIndex].start = font.getUint16();
                            for (segIndex = 0; segIndex < segCount; segIndex++)
                              segments[segIndex].delta = font.getUint16();
                            var offsetsCount = 0;
                            for (segIndex = 0; segIndex < segCount; segIndex++) {
                              segment = segments[segIndex];
                              var rangeOffset = font.getUint16();
                              if (rangeOffset) {
                                var offsetIndex = (rangeOffset >> 1) - (segCount - segIndex);
                                (segment.offsetIndex = offsetIndex),
                                  (offsetsCount = Math.max(
                                    offsetsCount,
                                    offsetIndex + segment.end - segment.start + 1
                                  ));
                              } else segment.offsetIndex = -1;
                            }
                            var offsets = [];
                            for (j = 0; j < offsetsCount; j++) offsets.push(font.getUint16());
                            for (segIndex = 0; segIndex < segCount; segIndex++) {
                              (segment = segments[segIndex]), (start = segment.start);
                              var end = segment.end,
                                delta = segment.delta;
                              for (offsetIndex = segment.offsetIndex, j = start; j <= end; j++)
                                65535 !== j &&
                                  ((glyphId = offsetIndex < 0 ? j : offsets[offsetIndex + j - start]),
                                  0 !== (glyphId = (glyphId + delta) & 65535) &&
                                    mappings.push({ charCode: j, glyphId: glyphId }));
                            }
                          } else {
                            if (6 !== format)
                              return (
                                warn("cmap table has unsupported format: " + format),
                                { platformId: -1, encodingId: -1, mappings: [], hasShortCmap: !1 }
                              );
                            var firstCode = font.getUint16(),
                              entryCount = font.getUint16();
                            for (j = 0; j < entryCount; j++) {
                              glyphId = font.getUint16();
                              var charCode = firstCode + j;
                              mappings.push({ charCode: charCode, glyphId: glyphId });
                            }
                          }
                          for (
                            mappings.sort(function (a, b) {
                              return a.charCode - b.charCode;
                            }),
                              i = 1;
                            i < mappings.length;
                            i++
                          )
                            mappings[i - 1].charCode === mappings[i].charCode && (mappings.splice(i, 1), i--);
                          return {
                            platformId: potentialTable.platformId,
                            encodingId: potentialTable.encodingId,
                            mappings: mappings,
                            hasShortCmap: hasShortCmap,
                          };
                        })(tables.cmap, font, this.isSymbolicFont, properties.hasEncoding),
                        cmapPlatformId = cmapTable.platformId,
                        cmapEncodingId = cmapTable.encodingId,
                        cmapMappings = cmapTable.mappings,
                        cmapMappingsLength = cmapMappings.length;
                      if (
                        (properties.hasEncoding &&
                          ((3 === cmapPlatformId && 1 === cmapEncodingId) ||
                            (1 === cmapPlatformId && 0 === cmapEncodingId))) ||
                        (-1 === cmapPlatformId && -1 === cmapEncodingId && getEncoding(properties.baseEncodingName))
                      ) {
                        var baseEncoding = [];
                        ("MacRomanEncoding" !== properties.baseEncodingName &&
                          "WinAnsiEncoding" !== properties.baseEncodingName) ||
                          (baseEncoding = getEncoding(properties.baseEncodingName));
                        var glyphsUnicodeMap = getGlyphsUnicode();
                        for (charCode = 0; charCode < 256; charCode++) {
                          var glyphName, standardGlyphName;
                          if (
                            (glyphName =
                              this.differences && charCode in this.differences
                                ? this.differences[charCode]
                                : charCode in baseEncoding && "" !== baseEncoding[charCode]
                                ? baseEncoding[charCode]
                                : StandardEncoding[charCode])
                          ) {
                            standardGlyphName = recoverGlyphName(glyphName, glyphsUnicodeMap);
                            var unicodeOrCharCode,
                              isUnicode = !1;
                            3 === cmapPlatformId && 1 === cmapEncodingId
                              ? ((unicodeOrCharCode = glyphsUnicodeMap[standardGlyphName]), (isUnicode = !0))
                              : 1 === cmapPlatformId &&
                                0 === cmapEncodingId &&
                                (unicodeOrCharCode = MacRomanEncoding.indexOf(standardGlyphName));
                            var found = !1;
                            for (i = 0; i < cmapMappingsLength; ++i)
                              if (cmapMappings[i].charCode === unicodeOrCharCode) {
                                var code = isUnicode ? charCode : unicodeOrCharCode;
                                if (hasGlyph(cmapMappings[i].glyphId, code, -1)) {
                                  (charCodeToGlyphId[charCode] = cmapMappings[i].glyphId), (found = !0);
                                  break;
                                }
                              }
                            if (!found && properties.glyphNames) {
                              var glyphId = properties.glyphNames.indexOf(glyphName);
                              -1 === glyphId &&
                                standardGlyphName !== glyphName &&
                                (glyphId = properties.glyphNames.indexOf(standardGlyphName)),
                                glyphId > 0 &&
                                  hasGlyph(glyphId, -1, -1) &&
                                  ((charCodeToGlyphId[charCode] = glyphId), (found = !0));
                            }
                            found || (charCodeToGlyphId[charCode] = 0);
                          }
                        }
                      } else if (0 === cmapPlatformId && 0 === cmapEncodingId)
                        for (i = 0; i < cmapMappingsLength; ++i)
                          charCodeToGlyphId[cmapMappings[i].charCode] = cmapMappings[i].glyphId;
                      else
                        for (i = 0; i < cmapMappingsLength; ++i)
                          (charCode = 255 & cmapMappings[i].charCode),
                            (charCodeToGlyphId[charCode] = cmapMappings[i].glyphId);
                    }
                    0 === charCodeToGlyphId.length && (charCodeToGlyphId[0] = 0);
                    var newMapping = adjustMapping(charCodeToGlyphId, properties);
                    if (
                      ((this.toFontChar = newMapping.toFontChar),
                      (tables.cmap = { tag: "cmap", data: createCmapTable(newMapping.charCodeToGlyphId, numGlyphs) }),
                      (tables["OS/2"] && validateOS2Table(tables["OS/2"])) ||
                        (tables["OS/2"] = {
                          tag: "OS/2",
                          data: createOS2Table(properties, newMapping.charCodeToGlyphId, metricsOverride),
                        }),
                      tables.post || (tables.post = { tag: "post", data: createPostTable(properties) }),
                      !isTrueType)
                    )
                      try {
                        cffFile = new Stream(tables["CFF "].data);
                        cff = new CFFParser(cffFile, properties, SEAC_ANALYSIS_ENABLED).parse();
                        var compiler = new CFFCompiler(cff);
                        tables["CFF "].data = compiler.compile();
                      } catch (e) {
                        warn("Failed to compile font " + properties.loadedName);
                      }
                    if (tables.name) {
                      var namePrototype = (function (nameTable) {
                        var start = (font.start ? font.start : 0) + nameTable.offset;
                        font.pos = start;
                        var names = [[], []],
                          length = nameTable.length,
                          end = start + length;
                        if (0 !== font.getUint16() || length < 6) return names;
                        var i,
                          ii,
                          numRecords = font.getUint16(),
                          stringsStart = font.getUint16(),
                          records = [];
                        for (i = 0; i < numRecords && font.pos + 12 <= end; i++) {
                          var r = {
                            platform: font.getUint16(),
                            encoding: font.getUint16(),
                            language: font.getUint16(),
                            name: font.getUint16(),
                            length: font.getUint16(),
                            offset: font.getUint16(),
                          };
                          ((1 === r.platform && 0 === r.encoding && 0 === r.language) ||
                            (3 === r.platform && 1 === r.encoding && 1033 === r.language)) &&
                            records.push(r);
                        }
                        for (i = 0, ii = records.length; i < ii; i++) {
                          var record = records[i];
                          if (!(record.length <= 0)) {
                            var pos = start + stringsStart + record.offset;
                            if (!(pos + record.length > end)) {
                              font.pos = pos;
                              var nameIndex = record.name;
                              if (record.encoding) {
                                for (var str = "", j = 0, jj = record.length; j < jj; j += 2)
                                  str += String.fromCharCode(font.getUint16());
                                names[1][nameIndex] = str;
                              } else names[0][nameIndex] = bytesToString(font.getBytes(record.length));
                            }
                          }
                        }
                        return names;
                      })(tables.name);
                      tables.name.data = createNameTable(name, namePrototype);
                    } else tables.name = { tag: "name", data: createNameTable(this.name) };
                    var builder = new OpenTypeFileBuilder(header.version);
                    for (var tableTag in tables) builder.addTable(tableTag, tables[tableTag].data);
                    return builder.toArray();
                  },
                  convert: function (fontName, font, properties) {
                    function createCharCode(charCodeToGlyphId, glyphId) {
                      for (var charCode in charCodeToGlyphId)
                        if (glyphId === charCodeToGlyphId[charCode]) return 0 | charCode;
                      return (
                        (newMapping.charCodeToGlyphId[newMapping.nextAvailableFontCharCode] = glyphId),
                        newMapping.nextAvailableFontCharCode++
                      );
                    }
                    (properties.fixedPitch = !1),
                      properties.builtInEncoding && adjustToUnicode(properties, properties.builtInEncoding);
                    var mapping = font.getGlyphMapping(properties),
                      newMapping = adjustMapping(mapping, properties);
                    this.toFontChar = newMapping.toFontChar;
                    var numGlyphs = font.numGlyphs,
                      seacs = font.seacs;
                    if (SEAC_ANALYSIS_ENABLED && seacs && seacs.length) {
                      var matrix = properties.fontMatrix || FONT_IDENTITY_MATRIX,
                        charset = font.getCharset(),
                        seacMap = Object.create(null);
                      for (var glyphId in seacs) {
                        glyphId |= 0;
                        var seac = seacs[glyphId],
                          baseGlyphName = StandardEncoding[seac[2]],
                          accentGlyphName = StandardEncoding[seac[3]],
                          baseGlyphId = charset.indexOf(baseGlyphName),
                          accentGlyphId = charset.indexOf(accentGlyphName);
                        if (!(baseGlyphId < 0 || accentGlyphId < 0)) {
                          var accentOffset = {
                              x: seac[0] * matrix[0] + seac[1] * matrix[2] + matrix[4],
                              y: seac[0] * matrix[1] + seac[1] * matrix[3] + matrix[5],
                            },
                            charCodes = (function (charCodeToGlyphId, glyphId) {
                              var charCodes = null;
                              for (var charCode in charCodeToGlyphId)
                                glyphId === charCodeToGlyphId[charCode] &&
                                  (charCodes || (charCodes = []), charCodes.push(0 | charCode));
                              return charCodes;
                            })(mapping, glyphId);
                          if (charCodes)
                            for (var i = 0, ii = charCodes.length; i < ii; i++) {
                              var charCode = charCodes[i],
                                charCodeToGlyphId = newMapping.charCodeToGlyphId,
                                baseFontCharCode = createCharCode(charCodeToGlyphId, baseGlyphId),
                                accentFontCharCode = createCharCode(charCodeToGlyphId, accentGlyphId);
                              seacMap[charCode] = {
                                baseFontCharCode: baseFontCharCode,
                                accentFontCharCode: accentFontCharCode,
                                accentOffset: accentOffset,
                              };
                            }
                        }
                      }
                      properties.seacMap = seacMap;
                    }
                    var unitsPerEm = 1 / (properties.fontMatrix || FONT_IDENTITY_MATRIX)[0],
                      builder = new OpenTypeFileBuilder("OTTO");
                    return (
                      builder.addTable("CFF ", font.data),
                      builder.addTable("OS/2", createOS2Table(properties, newMapping.charCodeToGlyphId)),
                      builder.addTable("cmap", createCmapTable(newMapping.charCodeToGlyphId, numGlyphs)),
                      builder.addTable(
                        "head",
                        "\0\0\0\0\0\0\0\0\0\0_<õ\0\0" +
                          safeString16(unitsPerEm) +
                          "\0\0\0\0\v~'\0\0\0\0\v~'\0\0" +
                          safeString16(properties.descent) +
                          "ÿ" +
                          safeString16(properties.ascent) +
                          string16(properties.italicAngle ? 2 : 0) +
                          "\0\0\0\0\0\0\0"
                      ),
                      builder.addTable(
                        "hhea",
                        "\0\0\0" +
                          safeString16(properties.ascent) +
                          safeString16(properties.descent) +
                          "\0\0ÿÿ\0\0\0\0\0\0" +
                          safeString16(properties.capHeight) +
                          safeString16(Math.tan(properties.italicAngle) * properties.xHeight) +
                          "\0\0\0\0\0\0\0\0\0\0\0\0" +
                          string16(numGlyphs)
                      ),
                      builder.addTable(
                        "hmtx",
                        (function () {
                          for (
                            var charstrings = font.charstrings,
                              cffWidths = font.cff ? font.cff.widths : null,
                              hmtx = "\0\0\0\0",
                              i = 1,
                              ii = numGlyphs;
                            i < ii;
                            i++
                          ) {
                            var width = 0;
                            if (charstrings) {
                              var charstring = charstrings[i - 1];
                              width = "width" in charstring ? charstring.width : 0;
                            } else cffWidths && (width = Math.ceil(cffWidths[i] || 0));
                            hmtx += string16(width) + string16(0);
                          }
                          return hmtx;
                        })()
                      ),
                      builder.addTable("maxp", "\0\0P\0" + string16(numGlyphs)),
                      builder.addTable("name", createNameTable(fontName)),
                      builder.addTable("post", createPostTable(properties)),
                      builder.toArray()
                    );
                  },
                  get spaceWidth() {
                    if ("_shadowWidth" in this) return this._shadowWidth;
                    for (
                      var width,
                        possibleSpaceReplacements = ["space", "minus", "one", "i", "I"],
                        i = 0,
                        ii = possibleSpaceReplacements.length;
                      i < ii;
                      i++
                    ) {
                      var glyphName = possibleSpaceReplacements[i];
                      if (glyphName in this.widths) {
                        width = this.widths[glyphName];
                        break;
                      }
                      var glyphsUnicodeMap = getGlyphsUnicode(),
                        glyphUnicode = glyphsUnicodeMap[glyphName],
                        charcode = 0;
                      if (
                        (this.composite &&
                          this.cMap.contains(glyphUnicode) &&
                          (charcode = this.cMap.lookup(glyphUnicode)),
                        !charcode && this.toUnicode && (charcode = this.toUnicode.charCodeOf(glyphUnicode)),
                        charcode <= 0 && (charcode = glyphUnicode),
                        (width = this.widths[charcode]))
                      )
                        break;
                    }
                    return (width = width || this.defaultWidth), (this._shadowWidth = width), width;
                  },
                  charToGlyph: function (charcode, isSpace) {
                    var fontCharCode,
                      width,
                      operatorListId,
                      widthCode = charcode;
                    this.cMap && this.cMap.contains(charcode) && (widthCode = this.cMap.lookup(charcode)),
                      (width = this.widths[widthCode]),
                      (width = isNum(width) ? width : this.defaultWidth);
                    var vmetric = this.vmetrics && this.vmetrics[widthCode],
                      unicode = this.toUnicode.get(charcode) || charcode;
                    "number" == typeof unicode && (unicode = String.fromCharCode(unicode));
                    var isInFont = charcode in this.toFontChar;
                    (fontCharCode = this.toFontChar[charcode] || charcode),
                      this.missingFile && (fontCharCode = mapSpecialUnicodeValues(fontCharCode)),
                      this.isType3Font && (operatorListId = fontCharCode);
                    var accent = null;
                    if (this.seacMap && this.seacMap[charcode]) {
                      isInFont = !0;
                      var seac = this.seacMap[charcode];
                      (fontCharCode = seac.baseFontCharCode),
                        (accent = {
                          fontChar: String.fromCharCode(seac.accentFontCharCode),
                          offset: seac.accentOffset,
                        });
                    }
                    var fontChar = String.fromCharCode(fontCharCode),
                      glyph = this.glyphCache[charcode];
                    return (
                      (glyph &&
                        glyph.matchesForCache(
                          fontChar,
                          unicode,
                          accent,
                          width,
                          vmetric,
                          operatorListId,
                          isSpace,
                          isInFont
                        )) ||
                        ((glyph = new Glyph(
                          fontChar,
                          unicode,
                          accent,
                          width,
                          vmetric,
                          operatorListId,
                          isSpace,
                          isInFont
                        )),
                        (this.glyphCache[charcode] = glyph)),
                      glyph
                    );
                  },
                  charsToGlyphs: function (chars) {
                    var glyphs,
                      glyph,
                      charcode,
                      charsCache = this.charsCache;
                    if (charsCache && (glyphs = charsCache[chars])) return glyphs;
                    charsCache || (charsCache = this.charsCache = Object.create(null)), (glyphs = []);
                    var ii,
                      charsCacheKey = chars,
                      i = 0;
                    if (this.cMap)
                      for (var c = Object.create(null); i < chars.length; ) {
                        this.cMap.readCharCode(chars, i, c), (charcode = c.charcode);
                        var length = c.length;
                        i += length;
                        var isSpace = 1 === length && 32 === chars.charCodeAt(i - 1);
                        (glyph = this.charToGlyph(charcode, isSpace)), glyphs.push(glyph);
                      }
                    else
                      for (i = 0, ii = chars.length; i < ii; ++i)
                        (charcode = chars.charCodeAt(i)),
                          (glyph = this.charToGlyph(charcode, 32 === charcode)),
                          glyphs.push(glyph);
                    return (charsCache[charsCacheKey] = glyphs);
                  },
                }),
                Font
              );
            })(),
            ErrorFont = (function () {
              function ErrorFont(error) {
                (this.error = error), (this.loadedName = "g_font_error"), (this.loading = !1);
              }
              return (
                (ErrorFont.prototype = {
                  charsToGlyphs: function () {
                    return [];
                  },
                  exportData: function () {
                    return { error: this.error };
                  },
                }),
                ErrorFont
              );
            })(),
            Type1Font = (function () {
              function findBlock(streamBytes, signature, startIndex) {
                for (
                  var j,
                    streamBytesLength = streamBytes.length,
                    signatureLength = signature.length,
                    scanLength = streamBytesLength - signatureLength,
                    i = startIndex,
                    found = !1;
                  i < scanLength;

                ) {
                  for (j = 0; j < signatureLength && streamBytes[i + j] === signature[j]; ) j++;
                  if (j >= signatureLength) {
                    for (i += j; i < streamBytesLength && isSpace(streamBytes[i]); ) i++;
                    found = !0;
                    break;
                  }
                  i++;
                }
                return { found: found, length: i };
              }
              function getHeaderBlock(stream, suggestedLength) {
                var headerBytes,
                  headerBytesLength,
                  block,
                  EEXEC_SIGNATURE = [101, 101, 120, 101, 99],
                  streamStartPos = stream.pos;
                try {
                  (headerBytes = stream.getBytes(suggestedLength)), (headerBytesLength = headerBytes.length);
                } catch (ex) {
                  if (ex instanceof MissingDataException) throw ex;
                }
                if (
                  headerBytesLength === suggestedLength &&
                  ((block = findBlock(headerBytes, EEXEC_SIGNATURE, suggestedLength - 2 * EEXEC_SIGNATURE.length)),
                  block.found && block.length === suggestedLength)
                )
                  return { stream: new Stream(headerBytes), length: suggestedLength };
                warn('Invalid "Length1" property in Type1 font -- trying to recover.'), (stream.pos = streamStartPos);
                for (var actualLength; ; ) {
                  if (((block = findBlock(stream.peekBytes(2048), EEXEC_SIGNATURE, 0)), 0 === block.length)) break;
                  if (((stream.pos += block.length), block.found)) {
                    actualLength = stream.pos - streamStartPos;
                    break;
                  }
                }
                return (
                  (stream.pos = streamStartPos),
                  actualLength
                    ? { stream: new Stream(stream.getBytes(actualLength)), length: actualLength }
                    : (warn('Unable to recover "Length1" property in Type1 font -- using as is.'),
                      { stream: new Stream(stream.getBytes(suggestedLength)), length: suggestedLength })
                );
              }
              function getEexecBlock(stream, suggestedLength) {
                var eexecBytes = stream.getBytes();
                return { stream: new Stream(eexecBytes), length: eexecBytes.length };
              }
              function Type1Font(name, file, properties) {
                var headerBlockLength = properties.length1,
                  eexecBlockLength = properties.length2,
                  pfbHeader = file.peekBytes(6),
                  pfbHeaderPresent = 128 === pfbHeader[0] && 1 === pfbHeader[1];
                pfbHeaderPresent &&
                  (file.skip(6),
                  (headerBlockLength =
                    (pfbHeader[5] << 24) | (pfbHeader[4] << 16) | (pfbHeader[3] << 8) | pfbHeader[2]));
                var headerBlock = getHeaderBlock(file, headerBlockLength);
                (headerBlockLength = headerBlock.length),
                  new Type1Parser(headerBlock.stream, !1, SEAC_ANALYSIS_ENABLED).extractFontHeader(properties),
                  pfbHeaderPresent &&
                    ((pfbHeader = file.getBytes(6)),
                    (eexecBlockLength =
                      (pfbHeader[5] << 24) | (pfbHeader[4] << 16) | (pfbHeader[3] << 8) | pfbHeader[2]));
                var eexecBlock = getEexecBlock(file, eexecBlockLength);
                eexecBlockLength = eexecBlock.length;
                var eexecBlockParser = new Type1Parser(eexecBlock.stream, !0, SEAC_ANALYSIS_ENABLED),
                  data = eexecBlockParser.extractFontProgram();
                for (var info in data.properties) properties[info] = data.properties[info];
                var charstrings = data.charstrings,
                  type2Charstrings = this.getType2Charstrings(charstrings),
                  subrs = this.getType2Subrs(data.subrs);
                (this.charstrings = charstrings),
                  (this.data = this.wrap(name, type2Charstrings, this.charstrings, subrs, properties)),
                  (this.seacs = this.getSeacs(data.charstrings));
              }
              return (
                (Type1Font.prototype = {
                  get numGlyphs() {
                    return this.charstrings.length + 1;
                  },
                  getCharset: function () {
                    for (
                      var charset = [".notdef"], charstrings = this.charstrings, glyphId = 0;
                      glyphId < charstrings.length;
                      glyphId++
                    )
                      charset.push(charstrings[glyphId].glyphName);
                    return charset;
                  },
                  getGlyphMapping: function (properties) {
                    var glyphId,
                      charstrings = this.charstrings,
                      glyphNames = [".notdef"];
                    for (glyphId = 0; glyphId < charstrings.length; glyphId++)
                      glyphNames.push(charstrings[glyphId].glyphName);
                    var encoding = properties.builtInEncoding;
                    if (encoding) {
                      var builtInEncoding = Object.create(null);
                      for (var charCode in encoding)
                        (glyphId = glyphNames.indexOf(encoding[charCode])) >= 0 &&
                          (builtInEncoding[charCode] = glyphId);
                    }
                    return type1FontGlyphMapping(properties, builtInEncoding, glyphNames);
                  },
                  getSeacs: function (charstrings) {
                    var i,
                      ii,
                      seacMap = [];
                    for (i = 0, ii = charstrings.length; i < ii; i++) {
                      var charstring = charstrings[i];
                      charstring.seac && (seacMap[i + 1] = charstring.seac);
                    }
                    return seacMap;
                  },
                  getType2Charstrings: function (type1Charstrings) {
                    for (var type2Charstrings = [], i = 0, ii = type1Charstrings.length; i < ii; i++)
                      type2Charstrings.push(type1Charstrings[i].charstring);
                    return type2Charstrings;
                  },
                  getType2Subrs: function (type1Subrs) {
                    var bias = 0,
                      count = type1Subrs.length;
                    bias = count < 1133 ? 107 : count < 33769 ? 1131 : 32768;
                    var i,
                      type2Subrs = [];
                    for (i = 0; i < bias; i++) type2Subrs.push([11]);
                    for (i = 0; i < count; i++) type2Subrs.push(type1Subrs[i]);
                    return type2Subrs;
                  },
                  wrap: function (name, glyphs, charstrings, subrs, properties) {
                    var cff = new CFF();
                    (cff.header = new CFFHeader(1, 0, 4, 4)), (cff.names = [name]);
                    var topDict = new CFFTopDict();
                    topDict.setByName("version", 391),
                      topDict.setByName("Notice", 392),
                      topDict.setByName("FullName", 393),
                      topDict.setByName("FamilyName", 394),
                      topDict.setByName("Weight", 395),
                      topDict.setByName("Encoding", null),
                      topDict.setByName("FontMatrix", properties.fontMatrix),
                      topDict.setByName("FontBBox", properties.bbox),
                      topDict.setByName("charset", null),
                      topDict.setByName("CharStrings", null),
                      topDict.setByName("Private", null),
                      (cff.topDict = topDict);
                    var strings = new CFFStrings();
                    strings.add("Version 0.11"),
                      strings.add("See original notice"),
                      strings.add(name),
                      strings.add(name),
                      strings.add("Medium"),
                      (cff.strings = strings),
                      (cff.globalSubrIndex = new CFFIndex());
                    var i,
                      ii,
                      count = glyphs.length,
                      charsetArray = [0];
                    for (i = 0; i < count; i++) {
                      var index = CFFStandardStrings.indexOf(charstrings[i].glyphName);
                      -1 === index && (index = 0), charsetArray.push((index >> 8) & 255, 255 & index);
                    }
                    cff.charset = new CFFCharset(!1, 0, [], charsetArray);
                    var charStringsIndex = new CFFIndex();
                    for (charStringsIndex.add([139, 14]), i = 0; i < count; i++) {
                      var glyph = glyphs[i];
                      0 !== glyph.length ? charStringsIndex.add(glyph) : charStringsIndex.add([139, 14]);
                    }
                    cff.charStrings = charStringsIndex;
                    var privateDict = new CFFPrivateDict();
                    privateDict.setByName("Subrs", null);
                    var fields = [
                      "BlueValues",
                      "OtherBlues",
                      "FamilyBlues",
                      "FamilyOtherBlues",
                      "StemSnapH",
                      "StemSnapV",
                      "BlueShift",
                      "BlueFuzz",
                      "BlueScale",
                      "LanguageGroup",
                      "ExpansionFactor",
                      "ForceBold",
                      "StdHW",
                      "StdVW",
                    ];
                    for (i = 0, ii = fields.length; i < ii; i++) {
                      var field = fields[i];
                      if (field in properties.privateData) {
                        var value = properties.privateData[field];
                        if (isArray(value)) for (var j = value.length - 1; j > 0; j--) value[j] -= value[j - 1];
                        privateDict.setByName(field, value);
                      }
                    }
                    cff.topDict.privateDict = privateDict;
                    var subrIndex = new CFFIndex();
                    for (i = 0, ii = subrs.length; i < ii; i++) subrIndex.add(subrs[i]);
                    return (privateDict.subrsIndex = subrIndex), new CFFCompiler(cff).compile();
                  },
                }),
                Type1Font
              );
            })(),
            CFFFont = (function () {
              function CFFFont(file, properties) {
                this.properties = properties;
                var parser = new CFFParser(file, properties, SEAC_ANALYSIS_ENABLED);
                this.cff = parser.parse();
                var compiler = new CFFCompiler(this.cff);
                this.seacs = this.cff.seacs;
                try {
                  this.data = compiler.compile();
                } catch (e) {
                  warn("Failed to compile font " + properties.loadedName), (this.data = file);
                }
              }
              return (
                (CFFFont.prototype = {
                  get numGlyphs() {
                    return this.cff.charStrings.count;
                  },
                  getCharset: function () {
                    return this.cff.charset.charset;
                  },
                  getGlyphMapping: function () {
                    var charCodeToGlyphId,
                      glyphId,
                      cff = this.cff,
                      properties = this.properties,
                      charsets = cff.charset.charset;
                    if (properties.composite) {
                      if (((charCodeToGlyphId = Object.create(null)), cff.isCIDFont))
                        for (glyphId = 0; glyphId < charsets.length; glyphId++) {
                          var cid = charsets[glyphId],
                            charCode = properties.cMap.charCodeOf(cid);
                          charCodeToGlyphId[charCode] = glyphId;
                        }
                      else
                        for (glyphId = 0; glyphId < cff.charStrings.count; glyphId++)
                          charCodeToGlyphId[glyphId] = glyphId;
                      return charCodeToGlyphId;
                    }
                    return (charCodeToGlyphId = type1FontGlyphMapping(
                      properties,
                      cff.encoding ? cff.encoding.encoding : null,
                      charsets
                    ));
                  },
                }),
                CFFFont
              );
            })();
          !(function () {
            "undefined" != typeof navigator && /Windows/.test(navigator.userAgent) && (SEAC_ANALYSIS_ENABLED = !0);
          })(),
            (function () {
              "undefined" != typeof navigator &&
                /Windows.*Chrome/.test(navigator.userAgent) &&
                (SKIP_PRIVATE_USE_RANGE_F000_TO_F01F = !0);
            })(),
            (exports.SEAC_ANALYSIS_ENABLED = SEAC_ANALYSIS_ENABLED),
            (exports.ErrorFont = ErrorFont),
            (exports.Font = Font),
            (exports.FontFlags = FontFlags),
            (exports.IdentityToUnicodeMap = IdentityToUnicodeMap),
            (exports.ToUnicodeMap = ToUnicodeMap),
            (exports.getFontType = getFontType);
        })(
          (root.pdfjsCoreFonts = {}),
          root.pdfjsSharedUtil,
          root.pdfjsCorePrimitives,
          root.pdfjsCoreStream,
          root.pdfjsCoreGlyphList,
          root.pdfjsCoreFontRenderer,
          root.pdfjsCoreEncodings,
          root.pdfjsCoreStandardFonts,
          root.pdfjsCoreUnicode,
          root.pdfjsCoreType1Parser,
          root.pdfjsCoreCFFParser
        );
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, coreParser) {
          var error = sharedUtil.error,
            isSpace = sharedUtil.isSpace,
            EOF = coreParser.EOF,
            PostScriptParser = (function () {
              function PostScriptParser(lexer) {
                (this.lexer = lexer), (this.operators = []), (this.token = null), (this.prev = null);
              }
              return (
                (PostScriptParser.prototype = {
                  nextToken: function () {
                    (this.prev = this.token), (this.token = this.lexer.getToken());
                  },
                  accept: function (type) {
                    return this.token.type === type && (this.nextToken(), !0);
                  },
                  expect: function (type) {
                    if (this.accept(type)) return !0;
                    error("Unexpected symbol: found " + this.token.type + " expected " + type + ".");
                  },
                  parse: function () {
                    return (
                      this.nextToken(),
                      this.expect(PostScriptTokenTypes.LBRACE),
                      this.parseBlock(),
                      this.expect(PostScriptTokenTypes.RBRACE),
                      this.operators
                    );
                  },
                  parseBlock: function () {
                    for (;;)
                      if (this.accept(PostScriptTokenTypes.NUMBER)) this.operators.push(this.prev.value);
                      else if (this.accept(PostScriptTokenTypes.OPERATOR)) this.operators.push(this.prev.value);
                      else {
                        if (!this.accept(PostScriptTokenTypes.LBRACE)) return;
                        this.parseCondition();
                      }
                  },
                  parseCondition: function () {
                    var conditionLocation = this.operators.length;
                    if (
                      (this.operators.push(null, null),
                      this.parseBlock(),
                      this.expect(PostScriptTokenTypes.RBRACE),
                      this.accept(PostScriptTokenTypes.IF))
                    )
                      (this.operators[conditionLocation] = this.operators.length),
                        (this.operators[conditionLocation + 1] = "jz");
                    else if (this.accept(PostScriptTokenTypes.LBRACE)) {
                      var jumpLocation = this.operators.length;
                      this.operators.push(null, null);
                      var endOfTrue = this.operators.length;
                      this.parseBlock(),
                        this.expect(PostScriptTokenTypes.RBRACE),
                        this.expect(PostScriptTokenTypes.IFELSE),
                        (this.operators[jumpLocation] = this.operators.length),
                        (this.operators[jumpLocation + 1] = "j"),
                        (this.operators[conditionLocation] = endOfTrue),
                        (this.operators[conditionLocation + 1] = "jz");
                    } else error("PS Function: error parsing conditional.");
                  },
                }),
                PostScriptParser
              );
            })(),
            PostScriptTokenTypes = { LBRACE: 0, RBRACE: 1, NUMBER: 2, OPERATOR: 3, IF: 4, IFELSE: 5 },
            PostScriptToken = (function () {
              function PostScriptToken(type, value) {
                (this.type = type), (this.value = value);
              }
              var opCache = Object.create(null);
              return (
                (PostScriptToken.getOperator = function (op) {
                  var opValue = opCache[op];
                  return opValue || (opCache[op] = new PostScriptToken(PostScriptTokenTypes.OPERATOR, op));
                }),
                (PostScriptToken.LBRACE = new PostScriptToken(PostScriptTokenTypes.LBRACE, "{")),
                (PostScriptToken.RBRACE = new PostScriptToken(PostScriptTokenTypes.RBRACE, "}")),
                (PostScriptToken.IF = new PostScriptToken(PostScriptTokenTypes.IF, "IF")),
                (PostScriptToken.IFELSE = new PostScriptToken(PostScriptTokenTypes.IFELSE, "IFELSE")),
                PostScriptToken
              );
            })(),
            PostScriptLexer = (function () {
              function PostScriptLexer(stream) {
                (this.stream = stream), this.nextChar(), (this.strBuf = []);
              }
              return (
                (PostScriptLexer.prototype = {
                  nextChar: function () {
                    return (this.currentChar = this.stream.getByte());
                  },
                  getToken: function () {
                    for (var comment = !1, ch = this.currentChar; ; ) {
                      if (ch < 0) return EOF;
                      if (comment) (10 !== ch && 13 !== ch) || (comment = !1);
                      else if (37 === ch) comment = !0;
                      else if (!isSpace(ch)) break;
                      ch = this.nextChar();
                    }
                    switch (0 | ch) {
                      case 48:
                      case 49:
                      case 50:
                      case 51:
                      case 52:
                      case 53:
                      case 54:
                      case 55:
                      case 56:
                      case 57:
                      case 43:
                      case 45:
                      case 46:
                        return new PostScriptToken(PostScriptTokenTypes.NUMBER, this.getNumber());
                      case 123:
                        return this.nextChar(), PostScriptToken.LBRACE;
                      case 125:
                        return this.nextChar(), PostScriptToken.RBRACE;
                    }
                    var strBuf = this.strBuf;
                    for (
                      strBuf.length = 0, strBuf[0] = String.fromCharCode(ch);
                      (ch = this.nextChar()) >= 0 && ((ch >= 65 && ch <= 90) || (ch >= 97 && ch <= 122));

                    )
                      strBuf.push(String.fromCharCode(ch));
                    var str = strBuf.join("");
                    switch (str.toLowerCase()) {
                      case "if":
                        return PostScriptToken.IF;
                      case "ifelse":
                        return PostScriptToken.IFELSE;
                      default:
                        return PostScriptToken.getOperator(str);
                    }
                  },
                  getNumber: function () {
                    var ch = this.currentChar,
                      strBuf = this.strBuf;
                    for (
                      strBuf.length = 0, strBuf[0] = String.fromCharCode(ch);
                      (ch = this.nextChar()) >= 0 && ((ch >= 48 && ch <= 57) || 45 === ch || 46 === ch);

                    )
                      strBuf.push(String.fromCharCode(ch));
                    var value = parseFloat(strBuf.join(""));
                    return isNaN(value) && error("Invalid floating point number: " + value), value;
                  },
                }),
                PostScriptLexer
              );
            })();
          (exports.PostScriptLexer = PostScriptLexer), (exports.PostScriptParser = PostScriptParser);
        })((root.pdfjsCorePsParser = {}), root.pdfjsSharedUtil, root.pdfjsCoreParser);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, corePrimitives, corePsParser) {
          function isPDFFunction(v) {
            var fnDict;
            if ("object" != typeof v) return !1;
            if (isDict(v)) fnDict = v;
            else {
              if (!isStream(v)) return !1;
              fnDict = v.dict;
            }
            return fnDict.has("FunctionType");
          }
          var error = sharedUtil.error,
            info = sharedUtil.info,
            isArray = sharedUtil.isArray,
            isBool = sharedUtil.isBool,
            isDict = corePrimitives.isDict,
            isStream = corePrimitives.isStream,
            PostScriptLexer = corePsParser.PostScriptLexer,
            PostScriptParser = corePsParser.PostScriptParser,
            PDFFunction = (function () {
              return {
                getSampleArray: function (size, outputSize, bps, str) {
                  var i,
                    ii,
                    length = 1;
                  for (i = 0, ii = size.length; i < ii; i++) length *= size[i];
                  length *= outputSize;
                  var array = new Array(length),
                    codeSize = 0,
                    codeBuf = 0,
                    sampleMul = 1 / (Math.pow(2, bps) - 1),
                    strBytes = str.getBytes((length * bps + 7) / 8),
                    strIdx = 0;
                  for (i = 0; i < length; i++) {
                    for (; codeSize < bps; ) (codeBuf <<= 8), (codeBuf |= strBytes[strIdx++]), (codeSize += 8);
                    (codeSize -= bps), (array[i] = (codeBuf >> codeSize) * sampleMul), (codeBuf &= (1 << codeSize) - 1);
                  }
                  return array;
                },
                getIR: function (xref, fn) {
                  var dict = fn.dict;
                  dict || (dict = fn);
                  var types = [
                      this.constructSampled,
                      null,
                      this.constructInterpolated,
                      this.constructStiched,
                      this.constructPostScript,
                    ],
                    typeNum = dict.get("FunctionType"),
                    typeFn = types[typeNum];
                  return typeFn || error("Unknown type of function"), typeFn.call(this, fn, dict, xref);
                },
                fromIR: function (IR) {
                  switch (IR[0]) {
                    case 0:
                      return this.constructSampledFromIR(IR);
                    case 2:
                      return this.constructInterpolatedFromIR(IR);
                    case 3:
                      return this.constructStichedFromIR(IR);
                    default:
                      return this.constructPostScriptFromIR(IR);
                  }
                },
                parse: function (xref, fn) {
                  var IR = this.getIR(xref, fn);
                  return this.fromIR(IR);
                },
                parseArray: function (xref, fnObj) {
                  if (!isArray(fnObj)) return this.parse(xref, fnObj);
                  for (var fnArray = [], j = 0, jj = fnObj.length; j < jj; j++) {
                    var obj = xref.fetchIfRef(fnObj[j]);
                    fnArray.push(PDFFunction.parse(xref, obj));
                  }
                  return function (src, srcOffset, dest, destOffset) {
                    for (var i = 0, ii = fnArray.length; i < ii; i++) fnArray[i](src, srcOffset, dest, destOffset + i);
                  };
                },
                constructSampled: function (str, dict) {
                  function toMultiArray(arr) {
                    for (var inputLength = arr.length, out = [], index = 0, i = 0; i < inputLength; i += 2)
                      (out[index] = [arr[i], arr[i + 1]]), ++index;
                    return out;
                  }
                  var domain = dict.getArray("Domain"),
                    range = dict.getArray("Range");
                  (domain && range) || error("No domain or range");
                  var inputSize = domain.length / 2,
                    outputSize = range.length / 2;
                  (domain = toMultiArray(domain)), (range = toMultiArray(range));
                  var size = dict.get("Size"),
                    bps = dict.get("BitsPerSample"),
                    order = dict.get("Order") || 1;
                  1 !== order && info("No support for cubic spline interpolation: " + order);
                  var encode = dict.getArray("Encode");
                  if (!encode) {
                    encode = [];
                    for (var i = 0; i < inputSize; ++i) encode.push(0), encode.push(size[i] - 1);
                  }
                  encode = toMultiArray(encode);
                  var decode = dict.getArray("Decode");
                  return (
                    (decode = decode ? toMultiArray(decode) : range),
                    [
                      0,
                      inputSize,
                      domain,
                      encode,
                      decode,
                      this.getSampleArray(size, outputSize, bps, str),
                      size,
                      outputSize,
                      Math.pow(2, bps) - 1,
                      range,
                    ]
                  );
                },
                constructSampledFromIR: function (IR) {
                  function interpolate(x, xmin, xmax, ymin, ymax) {
                    return ymin + ((ymax - ymin) / (xmax - xmin)) * (x - xmin);
                  }
                  return function (src, srcOffset, dest, destOffset) {
                    var i,
                      j,
                      m = IR[1],
                      domain = IR[2],
                      encode = IR[3],
                      decode = IR[4],
                      samples = IR[5],
                      size = IR[6],
                      n = IR[7],
                      range = IR[9],
                      cubeVertices = 1 << m,
                      cubeN = new Float64Array(cubeVertices),
                      cubeVertex = new Uint32Array(cubeVertices);
                    for (j = 0; j < cubeVertices; j++) cubeN[j] = 1;
                    var k = n,
                      pos = 1;
                    for (i = 0; i < m; ++i) {
                      var domain_2i = domain[i][0],
                        domain_2i_1 = domain[i][1],
                        xi = Math.min(Math.max(src[srcOffset + i], domain_2i), domain_2i_1),
                        e = interpolate(xi, domain_2i, domain_2i_1, encode[i][0], encode[i][1]),
                        size_i = size[i];
                      e = Math.min(Math.max(e, 0), size_i - 1);
                      var e0 = e < size_i - 1 ? Math.floor(e) : e - 1,
                        n0 = e0 + 1 - e,
                        n1 = e - e0,
                        offset0 = e0 * k,
                        offset1 = offset0 + k;
                      for (j = 0; j < cubeVertices; j++)
                        j & pos
                          ? ((cubeN[j] *= n1), (cubeVertex[j] += offset1))
                          : ((cubeN[j] *= n0), (cubeVertex[j] += offset0));
                      (k *= size_i), (pos <<= 1);
                    }
                    for (j = 0; j < n; ++j) {
                      var rj = 0;
                      for (i = 0; i < cubeVertices; i++) rj += samples[cubeVertex[i] + j] * cubeN[i];
                      (rj = interpolate(rj, 0, 1, decode[j][0], decode[j][1])),
                        (dest[destOffset + j] = Math.min(Math.max(rj, range[j][0]), range[j][1]));
                    }
                  };
                },
                constructInterpolated: function (str, dict) {
                  var c0 = dict.getArray("C0") || [0],
                    c1 = dict.getArray("C1") || [1],
                    n = dict.get("N");
                  (isArray(c0) && isArray(c1)) || error("Illegal dictionary for interpolated function");
                  for (var length = c0.length, diff = [], i = 0; i < length; ++i) diff.push(c1[i] - c0[i]);
                  return [2, c0, diff, n];
                },
                constructInterpolatedFromIR: function (IR) {
                  var c0 = IR[1],
                    diff = IR[2],
                    n = IR[3],
                    length = diff.length;
                  return function (src, srcOffset, dest, destOffset) {
                    for (var x = 1 === n ? src[srcOffset] : Math.pow(src[srcOffset], n), j = 0; j < length; ++j)
                      dest[destOffset + j] = c0[j] + x * diff[j];
                  };
                },
                constructStiched: function (fn, dict, xref) {
                  var domain = dict.getArray("Domain");
                  domain || error("No domain"), 1 != domain.length / 2 && error("Bad domain for stiched function");
                  for (var fnRefs = dict.get("Functions"), fns = [], i = 0, ii = fnRefs.length; i < ii; ++i)
                    fns.push(PDFFunction.getIR(xref, xref.fetchIfRef(fnRefs[i])));
                  return [3, domain, dict.getArray("Bounds"), dict.getArray("Encode"), fns];
                },
                constructStichedFromIR: function (IR) {
                  for (
                    var domain = IR[1],
                      bounds = IR[2],
                      encode = IR[3],
                      fnsIR = IR[4],
                      fns = [],
                      tmpBuf = new Float32Array(1),
                      i = 0,
                      ii = fnsIR.length;
                    i < ii;
                    i++
                  )
                    fns.push(PDFFunction.fromIR(fnsIR[i]));
                  return function (src, srcOffset, dest, destOffset) {
                    for (
                      var v = (function (v, min, max) {
                          return v > max ? (v = max) : v < min && (v = min), v;
                        })(src[srcOffset], domain[0], domain[1]),
                        i = 0,
                        ii = bounds.length;
                      i < ii && !(v < bounds[i]);
                      ++i
                    );
                    var dmin = domain[0];
                    i > 0 && (dmin = bounds[i - 1]);
                    var dmax = domain[1];
                    i < bounds.length && (dmax = bounds[i]);
                    var rmin = encode[2 * i],
                      rmax = encode[2 * i + 1];
                    (tmpBuf[0] = dmin === dmax ? rmin : rmin + ((v - dmin) * (rmax - rmin)) / (dmax - dmin)),
                      fns[i](tmpBuf, 0, dest, destOffset);
                  };
                },
                constructPostScript: function (fn, dict, xref) {
                  var domain = dict.getArray("Domain"),
                    range = dict.getArray("Range");
                  domain || error("No domain."), range || error("No range.");
                  var lexer = new PostScriptLexer(fn);
                  return [4, domain, range, new PostScriptParser(lexer).parse()];
                },
                constructPostScriptFromIR: function (IR) {
                  var domain = IR[1],
                    range = IR[2],
                    code = IR[3],
                    compiled = new PostScriptCompiler().compile(code, domain, range);
                  if (compiled) return new Function("src", "srcOffset", "dest", "destOffset", compiled);
                  info("Unable to compile PS function");
                  var numOutputs = range.length >> 1,
                    numInputs = domain.length >> 1,
                    evaluator = new PostScriptEvaluator(code),
                    cache = Object.create(null),
                    cache_available = 8192,
                    tmpBuf = new Float32Array(numInputs);
                  return function (src, srcOffset, dest, destOffset) {
                    var i,
                      value,
                      key = "",
                      input = tmpBuf;
                    for (i = 0; i < numInputs; i++)
                      (value = src[srcOffset + i]), (input[i] = value), (key += value + "_");
                    var cachedValue = cache[key];
                    if (void 0 !== cachedValue) return void dest.set(cachedValue, destOffset);
                    var output = new Float32Array(numOutputs),
                      stack = evaluator.execute(input),
                      stackIndex = stack.length - numOutputs;
                    for (i = 0; i < numOutputs; i++) {
                      value = stack[stackIndex + i];
                      var bound = range[2 * i];
                      value < bound ? (value = bound) : ((bound = range[2 * i + 1]), value > bound && (value = bound)),
                        (output[i] = value);
                    }
                    cache_available > 0 && (cache_available--, (cache[key] = output)), dest.set(output, destOffset);
                  };
                },
              };
            })(),
            PostScriptStack = (function () {
              function PostScriptStack(initialStack) {
                this.stack = initialStack ? Array.prototype.slice.call(initialStack, 0) : [];
              }
              return (
                (PostScriptStack.prototype = {
                  push: function (value) {
                    this.stack.length >= 100 && error("PostScript function stack overflow."), this.stack.push(value);
                  },
                  pop: function () {
                    return this.stack.length <= 0 && error("PostScript function stack underflow."), this.stack.pop();
                  },
                  copy: function (n) {
                    this.stack.length + n >= 100 && error("PostScript function stack overflow.");
                    for (var stack = this.stack, i = stack.length - n, j = n - 1; j >= 0; j--, i++)
                      stack.push(stack[i]);
                  },
                  index: function (n) {
                    this.push(this.stack[this.stack.length - n - 1]);
                  },
                  roll: function (n, p) {
                    var i,
                      j,
                      t,
                      stack = this.stack,
                      l = stack.length - n,
                      r = stack.length - 1,
                      c = l + (p - Math.floor(p / n) * n);
                    for (i = l, j = r; i < j; i++, j--) (t = stack[i]), (stack[i] = stack[j]), (stack[j] = t);
                    for (i = l, j = c - 1; i < j; i++, j--) (t = stack[i]), (stack[i] = stack[j]), (stack[j] = t);
                    for (i = c, j = r; i < j; i++, j--) (t = stack[i]), (stack[i] = stack[j]), (stack[j] = t);
                  },
                }),
                PostScriptStack
              );
            })(),
            PostScriptEvaluator = (function () {
              function PostScriptEvaluator(operators) {
                this.operators = operators;
              }
              return (
                (PostScriptEvaluator.prototype = {
                  execute: function (initialStack) {
                    for (
                      var operator,
                        a,
                        b,
                        stack = new PostScriptStack(initialStack),
                        counter = 0,
                        operators = this.operators,
                        length = operators.length;
                      counter < length;

                    )
                      if ("number" != typeof (operator = operators[counter++]))
                        switch (operator) {
                          case "jz":
                            (b = stack.pop()), (a = stack.pop()), a || (counter = b);
                            break;
                          case "j":
                            (a = stack.pop()), (counter = a);
                            break;
                          case "abs":
                            (a = stack.pop()), stack.push(Math.abs(a));
                            break;
                          case "add":
                            (b = stack.pop()), (a = stack.pop()), stack.push(a + b);
                            break;
                          case "and":
                            (b = stack.pop()),
                              (a = stack.pop()),
                              isBool(a) && isBool(b) ? stack.push(a && b) : stack.push(a & b);
                            break;
                          case "atan":
                            (a = stack.pop()), stack.push(Math.atan(a));
                            break;
                          case "bitshift":
                            (b = stack.pop()), (a = stack.pop()), a > 0 ? stack.push(a << b) : stack.push(a >> b);
                            break;
                          case "ceiling":
                            (a = stack.pop()), stack.push(Math.ceil(a));
                            break;
                          case "copy":
                            (a = stack.pop()), stack.copy(a);
                            break;
                          case "cos":
                            (a = stack.pop()), stack.push(Math.cos(a));
                            break;
                          case "cvi":
                            (a = 0 | stack.pop()), stack.push(a);
                            break;
                          case "cvr":
                            break;
                          case "div":
                            (b = stack.pop()), (a = stack.pop()), stack.push(a / b);
                            break;
                          case "dup":
                            stack.copy(1);
                            break;
                          case "eq":
                            (b = stack.pop()), (a = stack.pop()), stack.push(a === b);
                            break;
                          case "exch":
                            stack.roll(2, 1);
                            break;
                          case "exp":
                            (b = stack.pop()), (a = stack.pop()), stack.push(Math.pow(a, b));
                            break;
                          case "false":
                            stack.push(!1);
                            break;
                          case "floor":
                            (a = stack.pop()), stack.push(Math.floor(a));
                            break;
                          case "ge":
                            (b = stack.pop()), (a = stack.pop()), stack.push(a >= b);
                            break;
                          case "gt":
                            (b = stack.pop()), (a = stack.pop()), stack.push(a > b);
                            break;
                          case "idiv":
                            (b = stack.pop()), (a = stack.pop()), stack.push((a / b) | 0);
                            break;
                          case "index":
                            (a = stack.pop()), stack.index(a);
                            break;
                          case "le":
                            (b = stack.pop()), (a = stack.pop()), stack.push(a <= b);
                            break;
                          case "ln":
                            (a = stack.pop()), stack.push(Math.log(a));
                            break;
                          case "log":
                            (a = stack.pop()), stack.push(Math.log(a) / Math.LN10);
                            break;
                          case "lt":
                            (b = stack.pop()), (a = stack.pop()), stack.push(a < b);
                            break;
                          case "mod":
                            (b = stack.pop()), (a = stack.pop()), stack.push(a % b);
                            break;
                          case "mul":
                            (b = stack.pop()), (a = stack.pop()), stack.push(a * b);
                            break;
                          case "ne":
                            (b = stack.pop()), (a = stack.pop()), stack.push(a !== b);
                            break;
                          case "neg":
                            (a = stack.pop()), stack.push(-a);
                            break;
                          case "not":
                            (a = stack.pop()), isBool(a) ? stack.push(!a) : stack.push(~a);
                            break;
                          case "or":
                            (b = stack.pop()),
                              (a = stack.pop()),
                              isBool(a) && isBool(b) ? stack.push(a || b) : stack.push(a | b);
                            break;
                          case "pop":
                            stack.pop();
                            break;
                          case "roll":
                            (b = stack.pop()), (a = stack.pop()), stack.roll(a, b);
                            break;
                          case "round":
                            (a = stack.pop()), stack.push(Math.round(a));
                            break;
                          case "sin":
                            (a = stack.pop()), stack.push(Math.sin(a));
                            break;
                          case "sqrt":
                            (a = stack.pop()), stack.push(Math.sqrt(a));
                            break;
                          case "sub":
                            (b = stack.pop()), (a = stack.pop()), stack.push(a - b);
                            break;
                          case "true":
                            stack.push(!0);
                            break;
                          case "truncate":
                            (a = stack.pop()), (a = a < 0 ? Math.ceil(a) : Math.floor(a)), stack.push(a);
                            break;
                          case "xor":
                            (b = stack.pop()),
                              (a = stack.pop()),
                              isBool(a) && isBool(b) ? stack.push(a !== b) : stack.push(a ^ b);
                            break;
                          default:
                            error("Unknown operator " + operator);
                        }
                      else stack.push(operator);
                    return stack.stack;
                  },
                }),
                PostScriptEvaluator
              );
            })(),
            PostScriptCompiler = (function () {
              function AstNode(type) {
                this.type = type;
              }
              function AstArgument(index, min, max) {
                AstNode.call(this, "args"), (this.index = index), (this.min = min), (this.max = max);
              }
              function AstLiteral(number) {
                AstNode.call(this, "literal"), (this.number = number), (this.min = number), (this.max = number);
              }
              function AstBinaryOperation(op, arg1, arg2, min, max) {
                AstNode.call(this, "binary"),
                  (this.op = op),
                  (this.arg1 = arg1),
                  (this.arg2 = arg2),
                  (this.min = min),
                  (this.max = max);
              }
              function AstMin(arg, max) {
                AstNode.call(this, "max"), (this.arg = arg), (this.min = arg.min), (this.max = max);
              }
              function AstVariable(index, min, max) {
                AstNode.call(this, "var"), (this.index = index), (this.min = min), (this.max = max);
              }
              function AstVariableDefinition(variable, arg) {
                AstNode.call(this, "definition"), (this.variable = variable), (this.arg = arg);
              }
              function ExpressionBuilderVisitor() {
                this.parts = [];
              }
              function buildAddOperation(num1, num2) {
                return "literal" === num2.type && 0 === num2.number
                  ? num1
                  : "literal" === num1.type && 0 === num1.number
                  ? num2
                  : "literal" === num2.type && "literal" === num1.type
                  ? new AstLiteral(num1.number + num2.number)
                  : new AstBinaryOperation("+", num1, num2, num1.min + num2.min, num1.max + num2.max);
              }
              function buildMulOperation(num1, num2) {
                if ("literal" === num2.type) {
                  if (0 === num2.number) return new AstLiteral(0);
                  if (1 === num2.number) return num1;
                  if ("literal" === num1.type) return new AstLiteral(num1.number * num2.number);
                }
                if ("literal" === num1.type) {
                  if (0 === num1.number) return new AstLiteral(0);
                  if (1 === num1.number) return num2;
                }
                return new AstBinaryOperation(
                  "*",
                  num1,
                  num2,
                  Math.min(num1.min * num2.min, num1.min * num2.max, num1.max * num2.min, num1.max * num2.max),
                  Math.max(num1.min * num2.min, num1.min * num2.max, num1.max * num2.min, num1.max * num2.max)
                );
              }
              function buildSubOperation(num1, num2) {
                if ("literal" === num2.type) {
                  if (0 === num2.number) return num1;
                  if ("literal" === num1.type) return new AstLiteral(num1.number - num2.number);
                }
                return "binary" === num2.type &&
                  "-" === num2.op &&
                  "literal" === num1.type &&
                  1 === num1.number &&
                  "literal" === num2.arg1.type &&
                  1 === num2.arg1.number
                  ? num2.arg2
                  : new AstBinaryOperation("-", num1, num2, num1.min - num2.max, num1.max - num2.min);
              }
              function buildMinOperation(num1, max) {
                return num1.min >= max ? new AstLiteral(max) : num1.max <= max ? num1 : new AstMin(num1, max);
              }
              function PostScriptCompiler() {}
              return (
                (AstNode.prototype.visit = function (visitor) {
                  throw new Error("abstract method");
                }),
                (AstArgument.prototype = Object.create(AstNode.prototype)),
                (AstArgument.prototype.visit = function (visitor) {
                  visitor.visitArgument(this);
                }),
                (AstLiteral.prototype = Object.create(AstNode.prototype)),
                (AstLiteral.prototype.visit = function (visitor) {
                  visitor.visitLiteral(this);
                }),
                (AstBinaryOperation.prototype = Object.create(AstNode.prototype)),
                (AstBinaryOperation.prototype.visit = function (visitor) {
                  visitor.visitBinaryOperation(this);
                }),
                (AstMin.prototype = Object.create(AstNode.prototype)),
                (AstMin.prototype.visit = function (visitor) {
                  visitor.visitMin(this);
                }),
                (AstVariable.prototype = Object.create(AstNode.prototype)),
                (AstVariable.prototype.visit = function (visitor) {
                  visitor.visitVariable(this);
                }),
                (AstVariableDefinition.prototype = Object.create(AstNode.prototype)),
                (AstVariableDefinition.prototype.visit = function (visitor) {
                  visitor.visitVariableDefinition(this);
                }),
                (ExpressionBuilderVisitor.prototype = {
                  visitArgument: function (arg) {
                    this.parts.push(
                      "Math.max(",
                      arg.min,
                      ", Math.min(",
                      arg.max,
                      ", src[srcOffset + ",
                      arg.index,
                      "]))"
                    );
                  },
                  visitVariable: function (variable) {
                    this.parts.push("v", variable.index);
                  },
                  visitLiteral: function (literal) {
                    this.parts.push(literal.number);
                  },
                  visitBinaryOperation: function (operation) {
                    this.parts.push("("),
                      operation.arg1.visit(this),
                      this.parts.push(" ", operation.op, " "),
                      operation.arg2.visit(this),
                      this.parts.push(")");
                  },
                  visitVariableDefinition: function (definition) {
                    this.parts.push("var "),
                      definition.variable.visit(this),
                      this.parts.push(" = "),
                      definition.arg.visit(this),
                      this.parts.push(";");
                  },
                  visitMin: function (max) {
                    this.parts.push("Math.min("), max.arg.visit(this), this.parts.push(", ", max.max, ")");
                  },
                  toString: function () {
                    return this.parts.join("");
                  },
                }),
                (PostScriptCompiler.prototype = {
                  compile: function (code, domain, range) {
                    var i,
                      ii,
                      n,
                      j,
                      num1,
                      num2,
                      ast1,
                      ast2,
                      tmpVar,
                      item,
                      stack = [],
                      instructions = [],
                      inputSize = domain.length >> 1,
                      outputSize = range.length >> 1,
                      lastRegister = 0;
                    for (i = 0; i < inputSize; i++) stack.push(new AstArgument(i, domain[2 * i], domain[2 * i + 1]));
                    for (i = 0, ii = code.length; i < ii; i++)
                      if ("number" != typeof (item = code[i]))
                        switch (item) {
                          case "add":
                            if (stack.length < 2) return null;
                            (num2 = stack.pop()), (num1 = stack.pop()), stack.push(buildAddOperation(num1, num2));
                            break;
                          case "cvr":
                            if (stack.length < 1) return null;
                            break;
                          case "mul":
                            if (stack.length < 2) return null;
                            (num2 = stack.pop()), (num1 = stack.pop()), stack.push(buildMulOperation(num1, num2));
                            break;
                          case "sub":
                            if (stack.length < 2) return null;
                            (num2 = stack.pop()), (num1 = stack.pop()), stack.push(buildSubOperation(num1, num2));
                            break;
                          case "exch":
                            if (stack.length < 2) return null;
                            (ast1 = stack.pop()), (ast2 = stack.pop()), stack.push(ast1, ast2);
                            break;
                          case "pop":
                            if (stack.length < 1) return null;
                            stack.pop();
                            break;
                          case "index":
                            if (stack.length < 1) return null;
                            if (((num1 = stack.pop()), "literal" !== num1.type)) return null;
                            if ((n = num1.number) < 0 || (0 | n) !== n || stack.length < n) return null;
                            if (
                              ((ast1 = stack[stack.length - n - 1]), "literal" === ast1.type || "var" === ast1.type)
                            ) {
                              stack.push(ast1);
                              break;
                            }
                            (tmpVar = new AstVariable(lastRegister++, ast1.min, ast1.max)),
                              (stack[stack.length - n - 1] = tmpVar),
                              stack.push(tmpVar),
                              instructions.push(new AstVariableDefinition(tmpVar, ast1));
                            break;
                          case "dup":
                            if (stack.length < 1) return null;
                            if (
                              "number" == typeof code[i + 1] &&
                              "gt" === code[i + 2] &&
                              code[i + 3] === i + 7 &&
                              "jz" === code[i + 4] &&
                              "pop" === code[i + 5] &&
                              code[i + 6] === code[i + 1]
                            ) {
                              (num1 = stack.pop()), stack.push(buildMinOperation(num1, code[i + 1])), (i += 6);
                              break;
                            }
                            if (((ast1 = stack[stack.length - 1]), "literal" === ast1.type || "var" === ast1.type)) {
                              stack.push(ast1);
                              break;
                            }
                            (tmpVar = new AstVariable(lastRegister++, ast1.min, ast1.max)),
                              (stack[stack.length - 1] = tmpVar),
                              stack.push(tmpVar),
                              instructions.push(new AstVariableDefinition(tmpVar, ast1));
                            break;
                          case "roll":
                            if (stack.length < 2) return null;
                            if (
                              ((num2 = stack.pop()),
                              (num1 = stack.pop()),
                              "literal" !== num2.type || "literal" !== num1.type)
                            )
                              return null;
                            if (
                              ((j = num2.number),
                              (n = num1.number) <= 0 || (0 | n) !== n || (0 | j) !== j || stack.length < n)
                            )
                              return null;
                            if (0 === (j = ((j % n) + n) % n)) break;
                            Array.prototype.push.apply(stack, stack.splice(stack.length - n, n - j));
                            break;
                          default:
                            return null;
                        }
                      else stack.push(new AstLiteral(item));
                    if (stack.length !== outputSize) return null;
                    var result = [];
                    return (
                      instructions.forEach(function (instruction) {
                        var statementBuilder = new ExpressionBuilderVisitor();
                        instruction.visit(statementBuilder), result.push(statementBuilder.toString());
                      }),
                      stack.forEach(function (expr, i) {
                        var statementBuilder = new ExpressionBuilderVisitor();
                        expr.visit(statementBuilder);
                        var min = range[2 * i],
                          max = range[2 * i + 1],
                          out = [statementBuilder.toString()];
                        min > expr.min && (out.unshift("Math.max(", min, ", "), out.push(")")),
                          max < expr.max && (out.unshift("Math.min(", max, ", "), out.push(")")),
                          out.unshift("dest[destOffset + ", i, "] = "),
                          out.push(";"),
                          result.push(out.join(""));
                      }),
                      result.join("\n")
                    );
                  },
                }),
                PostScriptCompiler
              );
            })();
          (exports.isPDFFunction = isPDFFunction),
            (exports.PDFFunction = PDFFunction),
            (exports.PostScriptEvaluator = PostScriptEvaluator),
            (exports.PostScriptCompiler = PostScriptCompiler);
        })((root.pdfjsCoreFunction = {}), root.pdfjsSharedUtil, root.pdfjsCorePrimitives, root.pdfjsCorePsParser);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, corePrimitives, coreFunction) {
          var error = sharedUtil.error,
            info = sharedUtil.info,
            isArray = sharedUtil.isArray,
            isString = sharedUtil.isString,
            shadow = sharedUtil.shadow,
            warn = sharedUtil.warn,
            isDict = corePrimitives.isDict,
            isName = corePrimitives.isName,
            isStream = corePrimitives.isStream,
            PDFFunction = coreFunction.PDFFunction,
            ColorSpace = (function () {
              function resizeRgbImage(src, bpc, w1, h1, w2, h2, alpha01, dest) {
                alpha01 = 1 !== alpha01 ? 0 : alpha01;
                var i,
                  j,
                  py,
                  oldIndex,
                  xRatio = w1 / w2,
                  yRatio = h1 / h2,
                  newIndex = 0,
                  xScaled = new Uint16Array(w2),
                  w1Scanline = 3 * w1;
                for (i = 0; i < w2; i++) xScaled[i] = 3 * Math.floor(i * xRatio);
                for (i = 0; i < h2; i++)
                  for (py = Math.floor(i * yRatio) * w1Scanline, j = 0; j < w2; j++)
                    (oldIndex = py + xScaled[j]),
                      (dest[newIndex++] = src[oldIndex++]),
                      (dest[newIndex++] = src[oldIndex++]),
                      (dest[newIndex++] = src[oldIndex++]),
                      (newIndex += alpha01);
              }
              function ColorSpace() {
                error("should not call ColorSpace constructor");
              }
              return (
                (ColorSpace.prototype = {
                  getRgb: function (src, srcOffset) {
                    var rgb = new Uint8Array(3);
                    return this.getRgbItem(src, srcOffset, rgb, 0), rgb;
                  },
                  getRgbItem: function (src, srcOffset, dest, destOffset) {
                    error("Should not call ColorSpace.getRgbItem");
                  },
                  getRgbBuffer: function (src, srcOffset, count, dest, destOffset, bits, alpha01) {
                    error("Should not call ColorSpace.getRgbBuffer");
                  },
                  getOutputLength: function (inputLength, alpha01) {
                    error("Should not call ColorSpace.getOutputLength");
                  },
                  isPassthrough: function (bits) {
                    return !1;
                  },
                  fillRgb: function (
                    dest,
                    originalWidth,
                    originalHeight,
                    width,
                    height,
                    actualHeight,
                    bpc,
                    comps,
                    alpha01
                  ) {
                    var i,
                      ii,
                      count = originalWidth * originalHeight,
                      rgbBuf = null,
                      numComponentColors = 1 << bpc,
                      needsResizing = originalHeight !== height || originalWidth !== width;
                    if (this.isPassthrough(bpc)) rgbBuf = comps;
                    else if (
                      1 === this.numComps &&
                      count > numComponentColors &&
                      "DeviceGray" !== this.name &&
                      "DeviceRGB" !== this.name
                    ) {
                      var key,
                        allColors = bpc <= 8 ? new Uint8Array(numComponentColors) : new Uint16Array(numComponentColors);
                      for (i = 0; i < numComponentColors; i++) allColors[i] = i;
                      var colorMap = new Uint8Array(3 * numComponentColors);
                      this.getRgbBuffer(allColors, 0, numComponentColors, colorMap, 0, bpc, 0);
                      var destPos, rgbPos;
                      if (needsResizing)
                        for (rgbBuf = new Uint8Array(3 * count), rgbPos = 0, i = 0; i < count; ++i)
                          (key = 3 * comps[i]),
                            (rgbBuf[rgbPos++] = colorMap[key]),
                            (rgbBuf[rgbPos++] = colorMap[key + 1]),
                            (rgbBuf[rgbPos++] = colorMap[key + 2]);
                      else
                        for (destPos = 0, i = 0; i < count; ++i)
                          (key = 3 * comps[i]),
                            (dest[destPos++] = colorMap[key]),
                            (dest[destPos++] = colorMap[key + 1]),
                            (dest[destPos++] = colorMap[key + 2]),
                            (destPos += alpha01);
                    } else
                      needsResizing
                        ? ((rgbBuf = new Uint8Array(3 * count)), this.getRgbBuffer(comps, 0, count, rgbBuf, 0, bpc, 0))
                        : this.getRgbBuffer(comps, 0, width * actualHeight, dest, 0, bpc, alpha01);
                    if (rgbBuf)
                      if (needsResizing)
                        resizeRgbImage(rgbBuf, bpc, originalWidth, originalHeight, width, height, alpha01, dest);
                      else
                        for (rgbPos = 0, destPos = 0, i = 0, ii = width * actualHeight; i < ii; i++)
                          (dest[destPos++] = rgbBuf[rgbPos++]),
                            (dest[destPos++] = rgbBuf[rgbPos++]),
                            (dest[destPos++] = rgbBuf[rgbPos++]),
                            (destPos += alpha01);
                  },
                  usesZeroToOneRange: !0,
                }),
                (ColorSpace.parse = function (cs, xref, res) {
                  var IR = ColorSpace.parseToIR(cs, xref, res);
                  return IR instanceof AlternateCS ? IR : ColorSpace.fromIR(IR);
                }),
                (ColorSpace.fromIR = function (IR) {
                  var whitePoint,
                    blackPoint,
                    gamma,
                    name = isArray(IR) ? IR[0] : IR;
                  switch (name) {
                    case "DeviceGrayCS":
                      return this.singletons.gray;
                    case "DeviceRgbCS":
                      return this.singletons.rgb;
                    case "DeviceCmykCS":
                      return this.singletons.cmyk;
                    case "CalGrayCS":
                      return (
                        (whitePoint = IR[1]),
                        (blackPoint = IR[2]),
                        (gamma = IR[3]),
                        new CalGrayCS(whitePoint, blackPoint, gamma)
                      );
                    case "CalRGBCS":
                      (whitePoint = IR[1]), (blackPoint = IR[2]), (gamma = IR[3]);
                      var matrix = IR[4];
                      return new CalRGBCS(whitePoint, blackPoint, gamma, matrix);
                    case "PatternCS":
                      var basePatternCS = IR[1];
                      return (
                        basePatternCS && (basePatternCS = ColorSpace.fromIR(basePatternCS)),
                        new PatternCS(basePatternCS)
                      );
                    case "IndexedCS":
                      var baseIndexedCS = IR[1],
                        hiVal = IR[2],
                        lookup = IR[3];
                      return new IndexedCS(ColorSpace.fromIR(baseIndexedCS), hiVal, lookup);
                    case "AlternateCS":
                      var numComps = IR[1],
                        alt = IR[2],
                        tintFnIR = IR[3];
                      return new AlternateCS(numComps, ColorSpace.fromIR(alt), PDFFunction.fromIR(tintFnIR));
                    case "LabCS":
                      (whitePoint = IR[1]), (blackPoint = IR[2]);
                      var range = IR[3];
                      return new LabCS(whitePoint, blackPoint, range);
                    default:
                      error("Unknown name " + name);
                  }
                  return null;
                }),
                (ColorSpace.parseToIR = function (cs, xref, res) {
                  if (isName(cs)) {
                    var colorSpaces = res.get("ColorSpace");
                    if (isDict(colorSpaces)) {
                      var refcs = colorSpaces.get(cs.name);
                      refcs && (cs = refcs);
                    }
                  }
                  cs = xref.fetchIfRef(cs);
                  var mode;
                  if (isName(cs))
                    switch (((mode = cs.name), (this.mode = mode), mode)) {
                      case "DeviceGray":
                      case "G":
                        return "DeviceGrayCS";
                      case "DeviceRGB":
                      case "RGB":
                        return "DeviceRgbCS";
                      case "DeviceCMYK":
                      case "CMYK":
                        return "DeviceCmykCS";
                      case "Pattern":
                        return ["PatternCS", null];
                      default:
                        error("unrecognized colorspace " + mode);
                    }
                  else if (isArray(cs)) {
                    (mode = xref.fetchIfRef(cs[0]).name), (this.mode = mode);
                    var numComps, params, alt, whitePoint, blackPoint, gamma;
                    switch (mode) {
                      case "DeviceGray":
                      case "G":
                        return "DeviceGrayCS";
                      case "DeviceRGB":
                      case "RGB":
                        return "DeviceRgbCS";
                      case "DeviceCMYK":
                      case "CMYK":
                        return "DeviceCmykCS";
                      case "CalGray":
                        return (
                          (params = xref.fetchIfRef(cs[1])),
                          (whitePoint = params.getArray("WhitePoint")),
                          (blackPoint = params.getArray("BlackPoint")),
                          (gamma = params.get("Gamma")),
                          ["CalGrayCS", whitePoint, blackPoint, gamma]
                        );
                      case "CalRGB":
                        (params = xref.fetchIfRef(cs[1])),
                          (whitePoint = params.getArray("WhitePoint")),
                          (blackPoint = params.getArray("BlackPoint")),
                          (gamma = params.getArray("Gamma"));
                        var matrix = params.getArray("Matrix");
                        return ["CalRGBCS", whitePoint, blackPoint, gamma, matrix];
                      case "ICCBased":
                        var stream = xref.fetchIfRef(cs[1]),
                          dict = stream.dict;
                        if (((numComps = dict.get("N")), (alt = dict.get("Alternate")))) {
                          var altIR = ColorSpace.parseToIR(alt, xref, res),
                            altCS = ColorSpace.fromIR(altIR);
                          if (altCS.numComps === numComps) return altIR;
                          warn("ICCBased color space: Ignoring incorrect /Alternate entry.");
                        }
                        if (1 === numComps) return "DeviceGrayCS";
                        if (3 === numComps) return "DeviceRgbCS";
                        if (4 === numComps) return "DeviceCmykCS";
                        break;
                      case "Pattern":
                        var basePatternCS = cs[1] || null;
                        return (
                          basePatternCS && (basePatternCS = ColorSpace.parseToIR(basePatternCS, xref, res)),
                          ["PatternCS", basePatternCS]
                        );
                      case "Indexed":
                      case "I":
                        var baseIndexedCS = ColorSpace.parseToIR(cs[1], xref, res),
                          hiVal = xref.fetchIfRef(cs[2]) + 1,
                          lookup = xref.fetchIfRef(cs[3]);
                        return (
                          isStream(lookup) && (lookup = lookup.getBytes()), ["IndexedCS", baseIndexedCS, hiVal, lookup]
                        );
                      case "Separation":
                      case "DeviceN":
                        var name = xref.fetchIfRef(cs[1]);
                        (numComps = 1),
                          isName(name) ? (numComps = 1) : isArray(name) && (numComps = name.length),
                          (alt = ColorSpace.parseToIR(cs[2], xref, res));
                        var tintFnIR = PDFFunction.getIR(xref, xref.fetchIfRef(cs[3]));
                        return ["AlternateCS", numComps, alt, tintFnIR];
                      case "Lab":
                        (params = xref.fetchIfRef(cs[1])),
                          (whitePoint = params.getArray("WhitePoint")),
                          (blackPoint = params.getArray("BlackPoint"));
                        var range = params.getArray("Range");
                        return ["LabCS", whitePoint, blackPoint, range];
                      default:
                        error('unimplemented color space object "' + mode + '"');
                    }
                  } else error('unrecognized color space object: "' + cs + '"');
                  return null;
                }),
                (ColorSpace.isDefaultDecode = function (decode, n) {
                  if (!isArray(decode)) return !0;
                  if (2 * n !== decode.length) return warn("The decode map is not the correct length"), !0;
                  for (var i = 0, ii = decode.length; i < ii; i += 2)
                    if (0 !== decode[i] || 1 !== decode[i + 1]) return !1;
                  return !0;
                }),
                (ColorSpace.singletons = {
                  get gray() {
                    return shadow(this, "gray", new DeviceGrayCS());
                  },
                  get rgb() {
                    return shadow(this, "rgb", new DeviceRgbCS());
                  },
                  get cmyk() {
                    return shadow(this, "cmyk", new DeviceCmykCS());
                  },
                }),
                ColorSpace
              );
            })(),
            AlternateCS = (function () {
              function AlternateCS(numComps, base, tintFn) {
                (this.name = "Alternate"), (this.numComps = numComps), (this.defaultColor = new Float32Array(numComps));
                for (var i = 0; i < numComps; ++i) this.defaultColor[i] = 1;
                (this.base = base), (this.tintFn = tintFn), (this.tmpBuf = new Float32Array(base.numComps));
              }
              return (
                (AlternateCS.prototype = {
                  getRgb: ColorSpace.prototype.getRgb,
                  getRgbItem: function (src, srcOffset, dest, destOffset) {
                    var tmpBuf = this.tmpBuf;
                    this.tintFn(src, srcOffset, tmpBuf, 0), this.base.getRgbItem(tmpBuf, 0, dest, destOffset);
                  },
                  getRgbBuffer: function (src, srcOffset, count, dest, destOffset, bits, alpha01) {
                    var i,
                      j,
                      tintFn = this.tintFn,
                      base = this.base,
                      scale = 1 / ((1 << bits) - 1),
                      baseNumComps = base.numComps,
                      usesZeroToOneRange = base.usesZeroToOneRange,
                      isPassthrough = (base.isPassthrough(8) || !usesZeroToOneRange) && 0 === alpha01,
                      pos = isPassthrough ? destOffset : 0,
                      baseBuf = isPassthrough ? dest : new Uint8Array(baseNumComps * count),
                      numComps = this.numComps,
                      scaled = new Float32Array(numComps),
                      tinted = new Float32Array(baseNumComps);
                    if (usesZeroToOneRange)
                      for (i = 0; i < count; i++) {
                        for (j = 0; j < numComps; j++) scaled[j] = src[srcOffset++] * scale;
                        for (tintFn(scaled, 0, tinted, 0), j = 0; j < baseNumComps; j++)
                          baseBuf[pos++] = 255 * tinted[j];
                      }
                    else
                      for (i = 0; i < count; i++) {
                        for (j = 0; j < numComps; j++) scaled[j] = src[srcOffset++] * scale;
                        tintFn(scaled, 0, tinted, 0), base.getRgbItem(tinted, 0, baseBuf, pos), (pos += baseNumComps);
                      }
                    isPassthrough || base.getRgbBuffer(baseBuf, 0, count, dest, destOffset, 8, alpha01);
                  },
                  getOutputLength: function (inputLength, alpha01) {
                    return this.base.getOutputLength((inputLength * this.base.numComps) / this.numComps, alpha01);
                  },
                  isPassthrough: ColorSpace.prototype.isPassthrough,
                  fillRgb: ColorSpace.prototype.fillRgb,
                  isDefaultDecode: function (decodeMap) {
                    return ColorSpace.isDefaultDecode(decodeMap, this.numComps);
                  },
                  usesZeroToOneRange: !0,
                }),
                AlternateCS
              );
            })(),
            PatternCS = (function () {
              function PatternCS(baseCS) {
                (this.name = "Pattern"), (this.base = baseCS);
              }
              return (PatternCS.prototype = {}), PatternCS;
            })(),
            IndexedCS = (function () {
              function IndexedCS(base, highVal, lookup) {
                (this.name = "Indexed"),
                  (this.numComps = 1),
                  (this.defaultColor = new Uint8Array([0])),
                  (this.base = base),
                  (this.highVal = highVal);
                var lookupArray,
                  baseNumComps = base.numComps,
                  length = baseNumComps * highVal;
                if (isStream(lookup)) {
                  lookupArray = new Uint8Array(length);
                  var bytes = lookup.getBytes(length);
                  lookupArray.set(bytes);
                } else if (isString(lookup)) {
                  lookupArray = new Uint8Array(length);
                  for (var i = 0; i < length; ++i) lookupArray[i] = lookup.charCodeAt(i);
                } else
                  lookup instanceof Uint8Array || lookup instanceof Array
                    ? (lookupArray = lookup)
                    : error("Unrecognized lookup table: " + lookup);
                this.lookup = lookupArray;
              }
              return (
                (IndexedCS.prototype = {
                  getRgb: ColorSpace.prototype.getRgb,
                  getRgbItem: function (src, srcOffset, dest, destOffset) {
                    var numComps = this.base.numComps,
                      start = src[srcOffset] * numComps;
                    this.base.getRgbItem(this.lookup, start, dest, destOffset);
                  },
                  getRgbBuffer: function (src, srcOffset, count, dest, destOffset, bits, alpha01) {
                    for (
                      var base = this.base,
                        numComps = base.numComps,
                        outputDelta = base.getOutputLength(numComps, alpha01),
                        lookup = this.lookup,
                        i = 0;
                      i < count;
                      ++i
                    ) {
                      var lookupPos = src[srcOffset++] * numComps;
                      base.getRgbBuffer(lookup, lookupPos, 1, dest, destOffset, 8, alpha01),
                        (destOffset += outputDelta);
                    }
                  },
                  getOutputLength: function (inputLength, alpha01) {
                    return this.base.getOutputLength(inputLength * this.base.numComps, alpha01);
                  },
                  isPassthrough: ColorSpace.prototype.isPassthrough,
                  fillRgb: ColorSpace.prototype.fillRgb,
                  isDefaultDecode: function (decodeMap) {
                    return !0;
                  },
                  usesZeroToOneRange: !0,
                }),
                IndexedCS
              );
            })(),
            DeviceGrayCS = (function () {
              function DeviceGrayCS() {
                (this.name = "DeviceGray"), (this.numComps = 1), (this.defaultColor = new Float32Array([0]));
              }
              return (
                (DeviceGrayCS.prototype = {
                  getRgb: ColorSpace.prototype.getRgb,
                  getRgbItem: function (src, srcOffset, dest, destOffset) {
                    var c = (255 * src[srcOffset]) | 0;
                    (c = c < 0 ? 0 : c > 255 ? 255 : c),
                      (dest[destOffset] = dest[destOffset + 1] = dest[destOffset + 2] = c);
                  },
                  getRgbBuffer: function (src, srcOffset, count, dest, destOffset, bits, alpha01) {
                    for (var scale = 255 / ((1 << bits) - 1), j = srcOffset, q = destOffset, i = 0; i < count; ++i) {
                      var c = (scale * src[j++]) | 0;
                      (dest[q++] = c), (dest[q++] = c), (dest[q++] = c), (q += alpha01);
                    }
                  },
                  getOutputLength: function (inputLength, alpha01) {
                    return inputLength * (3 + alpha01);
                  },
                  isPassthrough: ColorSpace.prototype.isPassthrough,
                  fillRgb: ColorSpace.prototype.fillRgb,
                  isDefaultDecode: function (decodeMap) {
                    return ColorSpace.isDefaultDecode(decodeMap, this.numComps);
                  },
                  usesZeroToOneRange: !0,
                }),
                DeviceGrayCS
              );
            })(),
            DeviceRgbCS = (function () {
              function DeviceRgbCS() {
                (this.name = "DeviceRGB"), (this.numComps = 3), (this.defaultColor = new Float32Array([0, 0, 0]));
              }
              return (
                (DeviceRgbCS.prototype = {
                  getRgb: ColorSpace.prototype.getRgb,
                  getRgbItem: function (src, srcOffset, dest, destOffset) {
                    var r = (255 * src[srcOffset]) | 0,
                      g = (255 * src[srcOffset + 1]) | 0,
                      b = (255 * src[srcOffset + 2]) | 0;
                    (dest[destOffset] = r < 0 ? 0 : r > 255 ? 255 : r),
                      (dest[destOffset + 1] = g < 0 ? 0 : g > 255 ? 255 : g),
                      (dest[destOffset + 2] = b < 0 ? 0 : b > 255 ? 255 : b);
                  },
                  getRgbBuffer: function (src, srcOffset, count, dest, destOffset, bits, alpha01) {
                    if (8 === bits && 0 === alpha01)
                      return void dest.set(src.subarray(srcOffset, srcOffset + 3 * count), destOffset);
                    for (var scale = 255 / ((1 << bits) - 1), j = srcOffset, q = destOffset, i = 0; i < count; ++i)
                      (dest[q++] = (scale * src[j++]) | 0),
                        (dest[q++] = (scale * src[j++]) | 0),
                        (dest[q++] = (scale * src[j++]) | 0),
                        (q += alpha01);
                  },
                  getOutputLength: function (inputLength, alpha01) {
                    return ((inputLength * (3 + alpha01)) / 3) | 0;
                  },
                  isPassthrough: function (bits) {
                    return 8 === bits;
                  },
                  fillRgb: ColorSpace.prototype.fillRgb,
                  isDefaultDecode: function (decodeMap) {
                    return ColorSpace.isDefaultDecode(decodeMap, this.numComps);
                  },
                  usesZeroToOneRange: !0,
                }),
                DeviceRgbCS
              );
            })(),
            DeviceCmykCS = (function () {
              function convertToRgb(src, srcOffset, srcScale, dest, destOffset) {
                var c = src[srcOffset + 0] * srcScale,
                  m = src[srcOffset + 1] * srcScale,
                  y = src[srcOffset + 2] * srcScale,
                  k = src[srcOffset + 3] * srcScale,
                  r =
                    (c *
                      (-4.387332384609988 * c +
                        54.48615194189176 * m +
                        18.82290502165302 * y +
                        212.25662451639585 * k -
                        285.2331026137004) +
                      m *
                        (1.7149763477362134 * m -
                          5.6096736904047315 * y +
                          -17.873870861415444 * k -
                          5.497006427196366) +
                      y * (-2.5217340131683033 * y - 21.248923337353073 * k + 17.5119270841813) +
                      k * (-21.86122147463605 * k - 189.48180835922747) +
                      255) |
                    0,
                  g =
                    (c *
                      (8.841041422036149 * c +
                        60.118027045597366 * m +
                        6.871425592049007 * y +
                        31.159100130055922 * k -
                        79.2970844816548) +
                      m *
                        (-15.310361306967817 * m +
                          17.575251261109482 * y +
                          131.35250912493976 * k -
                          190.9453302588951) +
                      y * (4.444339102852739 * y + 9.8632861493405 * k - 24.86741582555878) +
                      k * (-20.737325471181034 * k - 187.80453709719578) +
                      255) |
                    0,
                  b =
                    (c *
                      (0.8842522430003296 * c +
                        8.078677503112928 * m +
                        30.89978309703729 * y -
                        0.23883238689178934 * k -
                        14.183576799673286) +
                      m *
                        (10.49593273432072 * m + 63.02378494754052 * y + 50.606957656360734 * k - 112.23884253719248) +
                      y * (0.03296041114873217 * y + 115.60384449646641 * k - 193.58209356861505) +
                      k * (-22.33816807309886 * k - 180.12613974708367) +
                      255) |
                    0;
                (dest[destOffset] = r > 255 ? 255 : r < 0 ? 0 : r),
                  (dest[destOffset + 1] = g > 255 ? 255 : g < 0 ? 0 : g),
                  (dest[destOffset + 2] = b > 255 ? 255 : b < 0 ? 0 : b);
              }
              function DeviceCmykCS() {
                (this.name = "DeviceCMYK"), (this.numComps = 4), (this.defaultColor = new Float32Array([0, 0, 0, 1]));
              }
              return (
                (DeviceCmykCS.prototype = {
                  getRgb: ColorSpace.prototype.getRgb,
                  getRgbItem: function (src, srcOffset, dest, destOffset) {
                    convertToRgb(src, srcOffset, 1, dest, destOffset);
                  },
                  getRgbBuffer: function (src, srcOffset, count, dest, destOffset, bits, alpha01) {
                    for (var scale = 1 / ((1 << bits) - 1), i = 0; i < count; i++)
                      convertToRgb(src, srcOffset, scale, dest, destOffset),
                        (srcOffset += 4),
                        (destOffset += 3 + alpha01);
                  },
                  getOutputLength: function (inputLength, alpha01) {
                    return ((inputLength / 4) * (3 + alpha01)) | 0;
                  },
                  isPassthrough: ColorSpace.prototype.isPassthrough,
                  fillRgb: ColorSpace.prototype.fillRgb,
                  isDefaultDecode: function (decodeMap) {
                    return ColorSpace.isDefaultDecode(decodeMap, this.numComps);
                  },
                  usesZeroToOneRange: !0,
                }),
                DeviceCmykCS
              );
            })(),
            CalGrayCS = (function () {
              function CalGrayCS(whitePoint, blackPoint, gamma) {
                (this.name = "CalGray"),
                  (this.numComps = 1),
                  (this.defaultColor = new Float32Array([0])),
                  whitePoint || error("WhitePoint missing - required for color space CalGray"),
                  (blackPoint = blackPoint || [0, 0, 0]),
                  (gamma = gamma || 1),
                  (this.XW = whitePoint[0]),
                  (this.YW = whitePoint[1]),
                  (this.ZW = whitePoint[2]),
                  (this.XB = blackPoint[0]),
                  (this.YB = blackPoint[1]),
                  (this.ZB = blackPoint[2]),
                  (this.G = gamma),
                  (this.XW < 0 || this.ZW < 0 || 1 !== this.YW) &&
                    error("Invalid WhitePoint components for " + this.name + ", no fallback available"),
                  (this.XB < 0 || this.YB < 0 || this.ZB < 0) &&
                    (info("Invalid BlackPoint for " + this.name + ", falling back to default"),
                    (this.XB = this.YB = this.ZB = 0)),
                  (0 === this.XB && 0 === this.YB && 0 === this.ZB) ||
                    warn(
                      this.name +
                        ", BlackPoint: XB: " +
                        this.XB +
                        ", YB: " +
                        this.YB +
                        ", ZB: " +
                        this.ZB +
                        ", only default values are supported."
                    ),
                  this.G < 1 &&
                    (info("Invalid Gamma: " + this.G + " for " + this.name + ", falling back to default"),
                    (this.G = 1));
              }
              function convertToRgb(cs, src, srcOffset, dest, destOffset, scale) {
                var A = src[srcOffset] * scale,
                  AG = Math.pow(A, cs.G),
                  L = cs.YW * AG,
                  val = 0 | Math.max(295.8 * Math.pow(L, 0.3333333333333333) - 40.8, 0);
                (dest[destOffset] = val), (dest[destOffset + 1] = val), (dest[destOffset + 2] = val);
              }
              return (
                (CalGrayCS.prototype = {
                  getRgb: ColorSpace.prototype.getRgb,
                  getRgbItem: function (src, srcOffset, dest, destOffset) {
                    convertToRgb(this, src, srcOffset, dest, destOffset, 1);
                  },
                  getRgbBuffer: function (src, srcOffset, count, dest, destOffset, bits, alpha01) {
                    for (var scale = 1 / ((1 << bits) - 1), i = 0; i < count; ++i)
                      convertToRgb(this, src, srcOffset, dest, destOffset, scale),
                        (srcOffset += 1),
                        (destOffset += 3 + alpha01);
                  },
                  getOutputLength: function (inputLength, alpha01) {
                    return inputLength * (3 + alpha01);
                  },
                  isPassthrough: ColorSpace.prototype.isPassthrough,
                  fillRgb: ColorSpace.prototype.fillRgb,
                  isDefaultDecode: function (decodeMap) {
                    return ColorSpace.isDefaultDecode(decodeMap, this.numComps);
                  },
                  usesZeroToOneRange: !0,
                }),
                CalGrayCS
              );
            })(),
            CalRGBCS = (function () {
              function CalRGBCS(whitePoint, blackPoint, gamma, matrix) {
                (this.name = "CalRGB"),
                  (this.numComps = 3),
                  (this.defaultColor = new Float32Array(3)),
                  whitePoint || error("WhitePoint missing - required for color space CalRGB"),
                  (blackPoint = blackPoint || new Float32Array(3)),
                  (gamma = gamma || new Float32Array([1, 1, 1])),
                  (matrix = matrix || new Float32Array([1, 0, 0, 0, 1, 0, 0, 0, 1]));
                var XW = whitePoint[0],
                  YW = whitePoint[1],
                  ZW = whitePoint[2];
                this.whitePoint = whitePoint;
                var XB = blackPoint[0],
                  YB = blackPoint[1],
                  ZB = blackPoint[2];
                (this.blackPoint = blackPoint),
                  (this.GR = gamma[0]),
                  (this.GG = gamma[1]),
                  (this.GB = gamma[2]),
                  (this.MXA = matrix[0]),
                  (this.MYA = matrix[1]),
                  (this.MZA = matrix[2]),
                  (this.MXB = matrix[3]),
                  (this.MYB = matrix[4]),
                  (this.MZB = matrix[5]),
                  (this.MXC = matrix[6]),
                  (this.MYC = matrix[7]),
                  (this.MZC = matrix[8]),
                  (XW < 0 || ZW < 0 || 1 !== YW) &&
                    error("Invalid WhitePoint components for " + this.name + ", no fallback available"),
                  (XB < 0 || YB < 0 || ZB < 0) &&
                    (info(
                      "Invalid BlackPoint for " +
                        this.name +
                        " [" +
                        XB +
                        ", " +
                        YB +
                        ", " +
                        ZB +
                        "], falling back to default"
                    ),
                    (this.blackPoint = new Float32Array(3))),
                  (this.GR < 0 || this.GG < 0 || this.GB < 0) &&
                    (info(
                      "Invalid Gamma [" +
                        this.GR +
                        ", " +
                        this.GG +
                        ", " +
                        this.GB +
                        "] for " +
                        this.name +
                        ", falling back to default"
                    ),
                    (this.GR = this.GG = this.GB = 1)),
                  (this.MXA < 0 ||
                    this.MYA < 0 ||
                    this.MZA < 0 ||
                    this.MXB < 0 ||
                    this.MYB < 0 ||
                    this.MZB < 0 ||
                    this.MXC < 0 ||
                    this.MYC < 0 ||
                    this.MZC < 0) &&
                    (info(
                      "Invalid Matrix for " +
                        this.name +
                        " [" +
                        this.MXA +
                        ", " +
                        this.MYA +
                        ", " +
                        this.MZA +
                        this.MXB +
                        ", " +
                        this.MYB +
                        ", " +
                        this.MZB +
                        this.MXC +
                        ", " +
                        this.MYC +
                        ", " +
                        this.MZC +
                        "], falling back to default"
                    ),
                    (this.MXA = this.MYB = this.MZC = 1),
                    (this.MXB = this.MYA = this.MZA = this.MXC = this.MYC = this.MZB = 0));
              }
              function matrixProduct(a, b, result) {
                (result[0] = a[0] * b[0] + a[1] * b[1] + a[2] * b[2]),
                  (result[1] = a[3] * b[0] + a[4] * b[1] + a[5] * b[2]),
                  (result[2] = a[6] * b[0] + a[7] * b[1] + a[8] * b[2]);
              }
              function convertToFlat(sourceWhitePoint, LMS, result) {
                (result[0] = (1 * LMS[0]) / sourceWhitePoint[0]),
                  (result[1] = (1 * LMS[1]) / sourceWhitePoint[1]),
                  (result[2] = (1 * LMS[2]) / sourceWhitePoint[2]);
              }
              function convertToD65(sourceWhitePoint, LMS, result) {
                (result[0] = (0.95047 * LMS[0]) / sourceWhitePoint[0]),
                  (result[1] = (1 * LMS[1]) / sourceWhitePoint[1]),
                  (result[2] = (1.08883 * LMS[2]) / sourceWhitePoint[2]);
              }
              function sRGBTransferFunction(color) {
                return color <= 0.0031308
                  ? adjustToRange(0, 1, 12.92 * color)
                  : adjustToRange(0, 1, 1.055 * Math.pow(color, 1 / 2.4) - 0.055);
              }
              function adjustToRange(min, max, value) {
                return Math.max(min, Math.min(max, value));
              }
              function decodeL(L) {
                return L < 0 ? -decodeL(-L) : L > 8 ? Math.pow((L + 16) / 116, 3) : L * DECODE_L_CONSTANT;
              }
              function compensateBlackPoint(sourceBlackPoint, XYZ_Flat, result) {
                if (0 === sourceBlackPoint[0] && 0 === sourceBlackPoint[1] && 0 === sourceBlackPoint[2])
                  return (result[0] = XYZ_Flat[0]), (result[1] = XYZ_Flat[1]), void (result[2] = XYZ_Flat[2]);
                var zeroDecodeL = decodeL(0),
                  X_DST = zeroDecodeL,
                  X_SRC = decodeL(sourceBlackPoint[0]),
                  Y_DST = zeroDecodeL,
                  Y_SRC = decodeL(sourceBlackPoint[1]),
                  Z_DST = zeroDecodeL,
                  Z_SRC = decodeL(sourceBlackPoint[2]),
                  X_Scale = (1 - X_DST) / (1 - X_SRC),
                  X_Offset = 1 - X_Scale,
                  Y_Scale = (1 - Y_DST) / (1 - Y_SRC),
                  Y_Offset = 1 - Y_Scale,
                  Z_Scale = (1 - Z_DST) / (1 - Z_SRC),
                  Z_Offset = 1 - Z_Scale;
                (result[0] = XYZ_Flat[0] * X_Scale + X_Offset),
                  (result[1] = XYZ_Flat[1] * Y_Scale + Y_Offset),
                  (result[2] = XYZ_Flat[2] * Z_Scale + Z_Offset);
              }
              function normalizeWhitePointToFlat(sourceWhitePoint, XYZ_In, result) {
                if (1 === sourceWhitePoint[0] && 1 === sourceWhitePoint[2])
                  return (result[0] = XYZ_In[0]), (result[1] = XYZ_In[1]), void (result[2] = XYZ_In[2]);
                var LMS = result;
                matrixProduct(BRADFORD_SCALE_MATRIX, XYZ_In, LMS);
                var LMS_Flat = tempNormalizeMatrix;
                convertToFlat(sourceWhitePoint, LMS, LMS_Flat),
                  matrixProduct(BRADFORD_SCALE_INVERSE_MATRIX, LMS_Flat, result);
              }
              function normalizeWhitePointToD65(sourceWhitePoint, XYZ_In, result) {
                var LMS = result;
                matrixProduct(BRADFORD_SCALE_MATRIX, XYZ_In, LMS);
                var LMS_D65 = tempNormalizeMatrix;
                convertToD65(sourceWhitePoint, LMS, LMS_D65),
                  matrixProduct(BRADFORD_SCALE_INVERSE_MATRIX, LMS_D65, result);
              }
              function convertToRgb(cs, src, srcOffset, dest, destOffset, scale) {
                var A = adjustToRange(0, 1, src[srcOffset] * scale),
                  B = adjustToRange(0, 1, src[srcOffset + 1] * scale),
                  C = adjustToRange(0, 1, src[srcOffset + 2] * scale),
                  AGR = Math.pow(A, cs.GR),
                  BGG = Math.pow(B, cs.GG),
                  CGB = Math.pow(C, cs.GB),
                  X = cs.MXA * AGR + cs.MXB * BGG + cs.MXC * CGB,
                  Y = cs.MYA * AGR + cs.MYB * BGG + cs.MYC * CGB,
                  Z = cs.MZA * AGR + cs.MZB * BGG + cs.MZC * CGB,
                  XYZ = tempConvertMatrix1;
                (XYZ[0] = X), (XYZ[1] = Y), (XYZ[2] = Z);
                var XYZ_Flat = tempConvertMatrix2;
                normalizeWhitePointToFlat(cs.whitePoint, XYZ, XYZ_Flat);
                var XYZ_Black = tempConvertMatrix1;
                compensateBlackPoint(cs.blackPoint, XYZ_Flat, XYZ_Black);
                var XYZ_D65 = tempConvertMatrix2;
                normalizeWhitePointToD65(FLAT_WHITEPOINT_MATRIX, XYZ_Black, XYZ_D65);
                var SRGB = tempConvertMatrix1;
                matrixProduct(SRGB_D65_XYZ_TO_RGB_MATRIX, XYZ_D65, SRGB);
                var sR = sRGBTransferFunction(SRGB[0]),
                  sG = sRGBTransferFunction(SRGB[1]),
                  sB = sRGBTransferFunction(SRGB[2]);
                (dest[destOffset] = Math.round(255 * sR)),
                  (dest[destOffset + 1] = Math.round(255 * sG)),
                  (dest[destOffset + 2] = Math.round(255 * sB));
              }
              var BRADFORD_SCALE_MATRIX = new Float32Array([
                  0.8951,
                  0.2664,
                  -0.1614,
                  -0.7502,
                  1.7135,
                  0.0367,
                  0.0389,
                  -0.0685,
                  1.0296,
                ]),
                BRADFORD_SCALE_INVERSE_MATRIX = new Float32Array([
                  0.9869929,
                  -0.1470543,
                  0.1599627,
                  0.4323053,
                  0.5183603,
                  0.0492912,
                  -0.0085287,
                  0.0400428,
                  0.9684867,
                ]),
                SRGB_D65_XYZ_TO_RGB_MATRIX = new Float32Array([
                  3.2404542,
                  -1.5371385,
                  -0.4985314,
                  -0.969266,
                  1.8760108,
                  0.041556,
                  0.0556434,
                  -0.2040259,
                  1.0572252,
                ]),
                FLAT_WHITEPOINT_MATRIX = new Float32Array([1, 1, 1]),
                tempNormalizeMatrix = new Float32Array(3),
                tempConvertMatrix1 = new Float32Array(3),
                tempConvertMatrix2 = new Float32Array(3),
                DECODE_L_CONSTANT = Math.pow(24 / 116, 3) / 8;
              return (
                (CalRGBCS.prototype = {
                  getRgb: function (src, srcOffset) {
                    var rgb = new Uint8Array(3);
                    return this.getRgbItem(src, srcOffset, rgb, 0), rgb;
                  },
                  getRgbItem: function (src, srcOffset, dest, destOffset) {
                    convertToRgb(this, src, srcOffset, dest, destOffset, 1);
                  },
                  getRgbBuffer: function (src, srcOffset, count, dest, destOffset, bits, alpha01) {
                    for (var scale = 1 / ((1 << bits) - 1), i = 0; i < count; ++i)
                      convertToRgb(this, src, srcOffset, dest, destOffset, scale),
                        (srcOffset += 3),
                        (destOffset += 3 + alpha01);
                  },
                  getOutputLength: function (inputLength, alpha01) {
                    return ((inputLength * (3 + alpha01)) / 3) | 0;
                  },
                  isPassthrough: ColorSpace.prototype.isPassthrough,
                  fillRgb: ColorSpace.prototype.fillRgb,
                  isDefaultDecode: function (decodeMap) {
                    return ColorSpace.isDefaultDecode(decodeMap, this.numComps);
                  },
                  usesZeroToOneRange: !0,
                }),
                CalRGBCS
              );
            })(),
            LabCS = (function () {
              function LabCS(whitePoint, blackPoint, range) {
                (this.name = "Lab"),
                  (this.numComps = 3),
                  (this.defaultColor = new Float32Array([0, 0, 0])),
                  whitePoint || error("WhitePoint missing - required for color space Lab"),
                  (blackPoint = blackPoint || [0, 0, 0]),
                  (range = range || [-100, 100, -100, 100]),
                  (this.XW = whitePoint[0]),
                  (this.YW = whitePoint[1]),
                  (this.ZW = whitePoint[2]),
                  (this.amin = range[0]),
                  (this.amax = range[1]),
                  (this.bmin = range[2]),
                  (this.bmax = range[3]),
                  (this.XB = blackPoint[0]),
                  (this.YB = blackPoint[1]),
                  (this.ZB = blackPoint[2]),
                  (this.XW < 0 || this.ZW < 0 || 1 !== this.YW) &&
                    error("Invalid WhitePoint components, no fallback available"),
                  (this.XB < 0 || this.YB < 0 || this.ZB < 0) &&
                    (info("Invalid BlackPoint, falling back to default"), (this.XB = this.YB = this.ZB = 0)),
                  (this.amin > this.amax || this.bmin > this.bmax) &&
                    (info("Invalid Range, falling back to defaults"),
                    (this.amin = -100),
                    (this.amax = 100),
                    (this.bmin = -100),
                    (this.bmax = 100));
              }
              function fn_g(x) {
                return x >= 6 / 29 ? x * x * x : (108 / 841) * (x - 4 / 29);
              }
              function decode(value, high1, low2, high2) {
                return low2 + (value * (high2 - low2)) / high1;
              }
              function convertToRgb(cs, src, srcOffset, maxVal, dest, destOffset) {
                var Ls = src[srcOffset],
                  as = src[srcOffset + 1],
                  bs = src[srcOffset + 2];
                !1 !== maxVal &&
                  ((Ls = decode(Ls, maxVal, 0, 100)),
                  (as = decode(as, maxVal, cs.amin, cs.amax)),
                  (bs = decode(bs, maxVal, cs.bmin, cs.bmax))),
                  (as = as > cs.amax ? cs.amax : as < cs.amin ? cs.amin : as),
                  (bs = bs > cs.bmax ? cs.bmax : bs < cs.bmin ? cs.bmin : bs);
                var r,
                  g,
                  b,
                  M = (Ls + 16) / 116,
                  L = M + as / 500,
                  N = M - bs / 200,
                  X = cs.XW * fn_g(L),
                  Y = cs.YW * fn_g(M),
                  Z = cs.ZW * fn_g(N);
                cs.ZW < 1
                  ? ((r = 3.1339 * X + -1.617 * Y + -0.4906 * Z),
                    (g = -0.9785 * X + 1.916 * Y + 0.0333 * Z),
                    (b = 0.072 * X + -0.229 * Y + 1.4057 * Z))
                  : ((r = 3.2406 * X + -1.5372 * Y + -0.4986 * Z),
                    (g = -0.9689 * X + 1.8758 * Y + 0.0415 * Z),
                    (b = 0.0557 * X + -0.204 * Y + 1.057 * Z)),
                  (dest[destOffset] = r <= 0 ? 0 : r >= 1 ? 255 : (255 * Math.sqrt(r)) | 0),
                  (dest[destOffset + 1] = g <= 0 ? 0 : g >= 1 ? 255 : (255 * Math.sqrt(g)) | 0),
                  (dest[destOffset + 2] = b <= 0 ? 0 : b >= 1 ? 255 : (255 * Math.sqrt(b)) | 0);
              }
              return (
                (LabCS.prototype = {
                  getRgb: ColorSpace.prototype.getRgb,
                  getRgbItem: function (src, srcOffset, dest, destOffset) {
                    convertToRgb(this, src, srcOffset, !1, dest, destOffset);
                  },
                  getRgbBuffer: function (src, srcOffset, count, dest, destOffset, bits, alpha01) {
                    for (var maxVal = (1 << bits) - 1, i = 0; i < count; i++)
                      convertToRgb(this, src, srcOffset, maxVal, dest, destOffset),
                        (srcOffset += 3),
                        (destOffset += 3 + alpha01);
                  },
                  getOutputLength: function (inputLength, alpha01) {
                    return ((inputLength * (3 + alpha01)) / 3) | 0;
                  },
                  isPassthrough: ColorSpace.prototype.isPassthrough,
                  fillRgb: ColorSpace.prototype.fillRgb,
                  isDefaultDecode: function (decodeMap) {
                    return !0;
                  },
                  usesZeroToOneRange: !1,
                }),
                LabCS
              );
            })();
          exports.ColorSpace = ColorSpace;
        })((root.pdfjsCoreColorSpace = {}), root.pdfjsSharedUtil, root.pdfjsCorePrimitives, root.pdfjsCoreFunction);
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, corePrimitives, coreColorSpace, coreStream, coreJpx) {
          var ImageKind = sharedUtil.ImageKind,
            assert = sharedUtil.assert,
            error = sharedUtil.error,
            info = sharedUtil.info,
            isArray = sharedUtil.isArray,
            warn = sharedUtil.warn,
            Name = corePrimitives.Name,
            isStream = corePrimitives.isStream,
            ColorSpace = coreColorSpace.ColorSpace,
            DecodeStream = coreStream.DecodeStream,
            JpegStream = coreStream.JpegStream,
            JpxImage = coreJpx.JpxImage,
            PDFImage = (function () {
              function handleImageData(image, nativeDecoder) {
                return nativeDecoder && nativeDecoder.canDecode(image)
                  ? nativeDecoder.decode(image)
                  : Promise.resolve(image);
              }
              function decodeAndClamp(value, addend, coefficient, max) {
                return (value = addend + value * coefficient), value < 0 ? 0 : value > max ? max : value;
              }
              function resizeImageMask(src, bpc, w1, h1, w2, h2) {
                var i,
                  j,
                  py,
                  oldIndex,
                  length = w2 * h2,
                  dest =
                    bpc <= 8 ? new Uint8Array(length) : bpc <= 16 ? new Uint16Array(length) : new Uint32Array(length),
                  xRatio = w1 / w2,
                  yRatio = h1 / h2,
                  newIndex = 0,
                  xScaled = new Uint16Array(w2),
                  w1Scanline = w1;
                for (i = 0; i < w2; i++) xScaled[i] = Math.floor(i * xRatio);
                for (i = 0; i < h2; i++)
                  for (py = Math.floor(i * yRatio) * w1Scanline, j = 0; j < w2; j++)
                    (oldIndex = py + xScaled[j]), (dest[newIndex++] = src[oldIndex]);
                return dest;
              }
              function PDFImage(xref, res, image, inline, smask, mask, isMask) {
                this.image = image;
                var dict = image.dict;
                if (dict.has("Filter")) {
                  var filter = dict.get("Filter").name;
                  if ("JPXDecode" === filter) {
                    var jpxImage = new JpxImage();
                    jpxImage.parseImageProperties(image.stream),
                      image.stream.reset(),
                      (image.bitsPerComponent = jpxImage.bitsPerComponent),
                      (image.numComps = jpxImage.componentsCount);
                  } else "JBIG2Decode" === filter && ((image.bitsPerComponent = 1), (image.numComps = 1));
                }
                (this.width = dict.get("Width", "W")),
                  (this.height = dict.get("Height", "H")),
                  (this.width < 1 || this.height < 1) &&
                    error("Invalid image width: " + this.width + " or height: " + this.height),
                  (this.interpolate = dict.get("Interpolate", "I") || !1),
                  (this.imageMask = dict.get("ImageMask", "IM") || !1),
                  (this.matte = dict.get("Matte") || !1);
                var bitsPerComponent = image.bitsPerComponent;
                if (
                  (bitsPerComponent ||
                    (bitsPerComponent = dict.get("BitsPerComponent", "BPC")) ||
                    (this.imageMask
                      ? (bitsPerComponent = 1)
                      : error("Bits per component missing in image: " + this.imageMask)),
                  (this.bpc = bitsPerComponent),
                  !this.imageMask)
                ) {
                  var colorSpace = dict.get("ColorSpace", "CS");
                  if (!colorSpace)
                    switch ((info("JPX images (which do not require color spaces)"), image.numComps)) {
                      case 1:
                        colorSpace = Name.get("DeviceGray");
                        break;
                      case 3:
                        colorSpace = Name.get("DeviceRGB");
                        break;
                      case 4:
                        colorSpace = Name.get("DeviceCMYK");
                        break;
                      default:
                        error("JPX images with " + this.numComps + " color components not supported.");
                    }
                  (this.colorSpace = ColorSpace.parse(colorSpace, xref, res)),
                    (this.numComps = this.colorSpace.numComps);
                }
                if (
                  ((this.decode = dict.getArray("Decode", "D")),
                  (this.needsDecode = !1),
                  this.decode &&
                    ((this.colorSpace && !this.colorSpace.isDefaultDecode(this.decode)) ||
                      (isMask && !ColorSpace.isDefaultDecode(this.decode, 1))))
                ) {
                  this.needsDecode = !0;
                  var max = (1 << bitsPerComponent) - 1;
                  (this.decodeCoefficients = []), (this.decodeAddends = []);
                  for (var i = 0, j = 0; i < this.decode.length; i += 2, ++j) {
                    var dmin = this.decode[i],
                      dmax = this.decode[i + 1];
                    (this.decodeCoefficients[j] = dmax - dmin), (this.decodeAddends[j] = max * dmin);
                  }
                }
                if (smask) this.smask = new PDFImage(xref, res, smask, !1);
                else if (mask)
                  if (isStream(mask)) {
                    var maskDict = mask.dict,
                      imageMask = maskDict.get("ImageMask", "IM");
                    imageMask
                      ? (this.mask = new PDFImage(xref, res, mask, !1, null, null, !0))
                      : warn("Ignoring /Mask in image without /ImageMask.");
                  } else this.mask = mask;
              }
              return (
                (PDFImage.buildImage = function (handler, xref, res, image, inline, nativeDecoder) {
                  var smaskPromise,
                    maskPromise,
                    imagePromise = handleImageData(image, nativeDecoder),
                    smask = image.dict.get("SMask"),
                    mask = image.dict.get("Mask");
                  return (
                    smask
                      ? ((smaskPromise = handleImageData(smask, nativeDecoder)), (maskPromise = Promise.resolve(null)))
                      : ((smaskPromise = Promise.resolve(null)),
                        mask
                          ? isStream(mask)
                            ? (maskPromise = handleImageData(mask, nativeDecoder))
                            : isArray(mask)
                            ? (maskPromise = Promise.resolve(mask))
                            : (warn("Unsupported mask format."), (maskPromise = Promise.resolve(null)))
                          : (maskPromise = Promise.resolve(null))),
                    Promise.all([imagePromise, smaskPromise, maskPromise]).then(function (results) {
                      var imageData = results[0],
                        smaskData = results[1],
                        maskData = results[2];
                      return new PDFImage(xref, res, imageData, inline, smaskData, maskData);
                    })
                  );
                }),
                (PDFImage.createMask = function (imgArray, width, height, imageIsFromDecodeStream, inverseDecode) {
                  var data,
                    i,
                    computedLength = ((width + 7) >> 3) * height,
                    actualLength = imgArray.byteLength,
                    haveFullData = computedLength === actualLength;
                  if (!imageIsFromDecodeStream || (inverseDecode && !haveFullData))
                    if (inverseDecode)
                      for (
                        data = new Uint8Array(computedLength), data.set(imgArray), i = actualLength;
                        i < computedLength;
                        i++
                      )
                        data[i] = 255;
                    else (data = new Uint8Array(actualLength)), data.set(imgArray);
                  else data = imgArray;
                  if (inverseDecode) for (i = 0; i < actualLength; i++) data[i] = ~data[i];
                  return { data: data, width: width, height: height };
                }),
                (PDFImage.prototype = {
                  get drawWidth() {
                    return Math.max(
                      this.width,
                      (this.smask && this.smask.width) || 0,
                      (this.mask && this.mask.width) || 0
                    );
                  },
                  get drawHeight() {
                    return Math.max(
                      this.height,
                      (this.smask && this.smask.height) || 0,
                      (this.mask && this.mask.height) || 0
                    );
                  },
                  decodeBuffer: function (buffer) {
                    var i,
                      ii,
                      bpc = this.bpc,
                      numComps = this.numComps,
                      decodeAddends = this.decodeAddends,
                      decodeCoefficients = this.decodeCoefficients,
                      max = (1 << bpc) - 1;
                    if (1 !== bpc) {
                      var index = 0;
                      for (i = 0, ii = this.width * this.height; i < ii; i++)
                        for (var j = 0; j < numComps; j++)
                          (buffer[index] = decodeAndClamp(buffer[index], decodeAddends[j], decodeCoefficients[j], max)),
                            index++;
                    } else for (i = 0, ii = buffer.length; i < ii; i++) buffer[i] = +!buffer[i];
                  },
                  getComponents: function (buffer) {
                    var bpc = this.bpc;
                    if (8 === bpc) return buffer;
                    var ii,
                      buf,
                      width = this.width,
                      height = this.height,
                      numComps = this.numComps,
                      length = width * height * numComps,
                      bufferPos = 0,
                      output =
                        bpc <= 8
                          ? new Uint8Array(length)
                          : bpc <= 16
                          ? new Uint16Array(length)
                          : new Uint32Array(length),
                      rowComps = width * numComps,
                      max = (1 << bpc) - 1,
                      i = 0;
                    if (1 === bpc)
                      for (var mask, loop1End, loop2End, j = 0; j < height; j++) {
                        for (loop1End = i + (-8 & rowComps), loop2End = i + rowComps; i < loop1End; )
                          (buf = buffer[bufferPos++]),
                            (output[i] = (buf >> 7) & 1),
                            (output[i + 1] = (buf >> 6) & 1),
                            (output[i + 2] = (buf >> 5) & 1),
                            (output[i + 3] = (buf >> 4) & 1),
                            (output[i + 4] = (buf >> 3) & 1),
                            (output[i + 5] = (buf >> 2) & 1),
                            (output[i + 6] = (buf >> 1) & 1),
                            (output[i + 7] = 1 & buf),
                            (i += 8);
                        if (i < loop2End)
                          for (buf = buffer[bufferPos++], mask = 128; i < loop2End; )
                            (output[i++] = +!!(buf & mask)), (mask >>= 1);
                      }
                    else {
                      var bits = 0;
                      for (buf = 0, i = 0, ii = length; i < ii; ++i) {
                        for (i % rowComps == 0 && ((buf = 0), (bits = 0)); bits < bpc; )
                          (buf = (buf << 8) | buffer[bufferPos++]), (bits += 8);
                        var remainingBits = bits - bpc,
                          value = buf >> remainingBits;
                        (output[i] = value < 0 ? 0 : value > max ? max : value),
                          (buf &= (1 << remainingBits) - 1),
                          (bits = remainingBits);
                      }
                    }
                    return output;
                  },
                  fillOpacity: function (rgbaBuf, width, height, actualHeight, image) {
                    var alphaBuf,
                      sw,
                      sh,
                      i,
                      ii,
                      j,
                      smask = this.smask,
                      mask = this.mask;
                    if (smask)
                      (sw = smask.width),
                        (sh = smask.height),
                        (alphaBuf = new Uint8Array(sw * sh)),
                        smask.fillGrayBuffer(alphaBuf),
                        (sw === width && sh === height) ||
                          (alphaBuf = resizeImageMask(alphaBuf, smask.bpc, sw, sh, width, height));
                    else if (mask)
                      if (mask instanceof PDFImage) {
                        for (
                          sw = mask.width,
                            sh = mask.height,
                            alphaBuf = new Uint8Array(sw * sh),
                            mask.numComps = 1,
                            mask.fillGrayBuffer(alphaBuf),
                            i = 0,
                            ii = sw * sh;
                          i < ii;
                          ++i
                        )
                          alphaBuf[i] = 255 - alphaBuf[i];
                        (sw === width && sh === height) ||
                          (alphaBuf = resizeImageMask(alphaBuf, mask.bpc, sw, sh, width, height));
                      } else if (isArray(mask)) {
                        alphaBuf = new Uint8Array(width * height);
                        var numComps = this.numComps;
                        for (i = 0, ii = width * height; i < ii; ++i) {
                          var opacity = 0,
                            imageOffset = i * numComps;
                          for (j = 0; j < numComps; ++j) {
                            var color = image[imageOffset + j],
                              maskOffset = 2 * j;
                            if (color < mask[maskOffset] || color > mask[maskOffset + 1]) {
                              opacity = 255;
                              break;
                            }
                          }
                          alphaBuf[i] = opacity;
                        }
                      } else error("Unknown mask format.");
                    if (alphaBuf)
                      for (i = 0, j = 3, ii = width * actualHeight; i < ii; ++i, j += 4) rgbaBuf[j] = alphaBuf[i];
                    else for (i = 0, j = 3, ii = width * actualHeight; i < ii; ++i, j += 4) rgbaBuf[j] = 255;
                  },
                  undoPreblend: function (buffer, width, height) {
                    var matte = this.smask && this.smask.matte;
                    if (matte)
                      for (
                        var r,
                          g,
                          b,
                          matteRgb = this.colorSpace.getRgb(matte, 0),
                          matteR = matteRgb[0],
                          matteG = matteRgb[1],
                          matteB = matteRgb[2],
                          length = width * height * 4,
                          i = 0;
                        i < length;
                        i += 4
                      ) {
                        var alpha = buffer[i + 3];
                        if (0 !== alpha) {
                          var k = 255 / alpha;
                          (r = (buffer[i] - matteR) * k + matteR),
                            (g = (buffer[i + 1] - matteG) * k + matteG),
                            (b = (buffer[i + 2] - matteB) * k + matteB),
                            (buffer[i] = r <= 0 ? 0 : r >= 255 ? 255 : 0 | r),
                            (buffer[i + 1] = g <= 0 ? 0 : g >= 255 ? 255 : 0 | g),
                            (buffer[i + 2] = b <= 0 ? 0 : b >= 255 ? 255 : 0 | b);
                        } else (buffer[i] = 255), (buffer[i + 1] = 255), (buffer[i + 2] = 255);
                      }
                  },
                  createImageData: function (forceRGBA) {
                    var imgArray,
                      drawWidth = this.drawWidth,
                      drawHeight = this.drawHeight,
                      imgData = { width: drawWidth, height: drawHeight },
                      numComps = this.numComps,
                      originalWidth = this.width,
                      originalHeight = this.height,
                      bpc = this.bpc,
                      rowBytes = (originalWidth * numComps * bpc + 7) >> 3;
                    if (!forceRGBA) {
                      var kind;
                      if (
                        ("DeviceGray" === this.colorSpace.name && 1 === bpc
                          ? (kind = ImageKind.GRAYSCALE_1BPP)
                          : "DeviceRGB" !== this.colorSpace.name ||
                            8 !== bpc ||
                            this.needsDecode ||
                            (kind = ImageKind.RGB_24BPP),
                        kind &&
                          !this.smask &&
                          !this.mask &&
                          drawWidth === originalWidth &&
                          drawHeight === originalHeight)
                      ) {
                        if (
                          ((imgData.kind = kind),
                          (imgArray = this.getImageBytes(originalHeight * rowBytes)),
                          this.image instanceof DecodeStream)
                        )
                          imgData.data = imgArray;
                        else {
                          var newArray = new Uint8Array(imgArray.length);
                          newArray.set(imgArray), (imgData.data = newArray);
                        }
                        if (this.needsDecode) {
                          assert(kind === ImageKind.GRAYSCALE_1BPP);
                          for (var buffer = imgData.data, i = 0, ii = buffer.length; i < ii; i++) buffer[i] ^= 255;
                        }
                        return imgData;
                      }
                      if (
                        this.image instanceof JpegStream &&
                        !this.smask &&
                        !this.mask &&
                        ("DeviceGray" === this.colorSpace.name ||
                          "DeviceRGB" === this.colorSpace.name ||
                          "DeviceCMYK" === this.colorSpace.name)
                      )
                        return (
                          (imgData.kind = ImageKind.RGB_24BPP),
                          (imgData.data = this.getImageBytes(originalHeight * rowBytes, drawWidth, drawHeight, !0)),
                          imgData
                        );
                    }
                    imgArray = this.getImageBytes(originalHeight * rowBytes);
                    var alpha01,
                      maybeUndoPreblend,
                      actualHeight = 0 | (((imgArray.length / rowBytes) * drawHeight) / originalHeight),
                      comps = this.getComponents(imgArray);
                    return (
                      forceRGBA || this.smask || this.mask
                        ? ((imgData.kind = ImageKind.RGBA_32BPP),
                          (imgData.data = new Uint8Array(drawWidth * drawHeight * 4)),
                          (alpha01 = 1),
                          (maybeUndoPreblend = !0),
                          this.fillOpacity(imgData.data, drawWidth, drawHeight, actualHeight, comps))
                        : ((imgData.kind = ImageKind.RGB_24BPP),
                          (imgData.data = new Uint8Array(drawWidth * drawHeight * 3)),
                          (alpha01 = 0),
                          (maybeUndoPreblend = !1)),
                      this.needsDecode && this.decodeBuffer(comps),
                      this.colorSpace.fillRgb(
                        imgData.data,
                        originalWidth,
                        originalHeight,
                        drawWidth,
                        drawHeight,
                        actualHeight,
                        bpc,
                        comps,
                        alpha01
                      ),
                      maybeUndoPreblend && this.undoPreblend(imgData.data, drawWidth, actualHeight),
                      imgData
                    );
                  },
                  fillGrayBuffer: function (buffer) {
                    var numComps = this.numComps;
                    1 !== numComps && error("Reading gray scale from a color image: " + numComps);
                    var i,
                      length,
                      width = this.width,
                      height = this.height,
                      bpc = this.bpc,
                      rowBytes = (width * numComps * bpc + 7) >> 3,
                      imgArray = this.getImageBytes(height * rowBytes),
                      comps = this.getComponents(imgArray);
                    if (1 !== bpc) {
                      this.needsDecode && this.decodeBuffer(comps), (length = width * height);
                      var scale = 255 / ((1 << bpc) - 1);
                      for (i = 0; i < length; ++i) buffer[i] = (scale * comps[i]) | 0;
                    } else if (((length = width * height), this.needsDecode))
                      for (i = 0; i < length; ++i) buffer[i] = (comps[i] - 1) & 255;
                    else for (i = 0; i < length; ++i) buffer[i] = 255 & -comps[i];
                  },
                  getImageBytes: function (length, drawWidth, drawHeight, forceRGB) {
                    return (
                      this.image.reset(),
                      (this.image.drawWidth = drawWidth || this.width),
                      (this.image.drawHeight = drawHeight || this.height),
                      (this.image.forceRGB = !!forceRGB),
                      this.image.getBytes(length)
                    );
                  },
                }),
                PDFImage
              );
            })();
          exports.PDFImage = PDFImage;
        })(
          (root.pdfjsCoreImage = {}),
          root.pdfjsSharedUtil,
          root.pdfjsCorePrimitives,
          root.pdfjsCoreColorSpace,
          root.pdfjsCoreStream,
          root.pdfjsCoreJpx
        );
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, corePrimitives, coreCrypto, coreParser, coreChunkedStream, coreColorSpace) {
          var InvalidPDFException = sharedUtil.InvalidPDFException,
            MissingDataException = sharedUtil.MissingDataException,
            XRefParseException = sharedUtil.XRefParseException,
            assert = sharedUtil.assert,
            bytesToString = sharedUtil.bytesToString,
            createPromiseCapability = sharedUtil.createPromiseCapability,
            error = sharedUtil.error,
            info = sharedUtil.info,
            isArray = sharedUtil.isArray,
            isInt = sharedUtil.isInt,
            isString = sharedUtil.isString,
            shadow = sharedUtil.shadow,
            stringToPDFString = sharedUtil.stringToPDFString,
            stringToUTF8String = sharedUtil.stringToUTF8String,
            warn = sharedUtil.warn,
            isValidUrl = sharedUtil.isValidUrl,
            Util = sharedUtil.Util,
            Ref = corePrimitives.Ref,
            RefSet = corePrimitives.RefSet,
            RefSetCache = corePrimitives.RefSetCache,
            isName = corePrimitives.isName,
            isCmd = corePrimitives.isCmd,
            isDict = corePrimitives.isDict,
            isRef = corePrimitives.isRef,
            isRefsEqual = corePrimitives.isRefsEqual,
            isStream = corePrimitives.isStream,
            CipherTransformFactory = coreCrypto.CipherTransformFactory,
            Lexer = coreParser.Lexer,
            Parser = coreParser.Parser,
            ChunkedStream = coreChunkedStream.ChunkedStream,
            ColorSpace = coreColorSpace.ColorSpace,
            Catalog = (function () {
              function Catalog(pdfManager, xref, pageFactory) {
                (this.pdfManager = pdfManager),
                  (this.xref = xref),
                  (this.catDict = xref.getCatalogObj()),
                  (this.fontCache = new RefSetCache()),
                  assert(isDict(this.catDict), "catalog object is not a dictionary"),
                  (this.pageFactory = pageFactory),
                  (this.pagePromises = []);
              }
              return (
                (Catalog.prototype = {
                  get metadata() {
                    var streamRef = this.catDict.getRaw("Metadata");
                    if (!isRef(streamRef)) return shadow(this, "metadata", null);
                    var metadata,
                      encryptMetadata = !!this.xref.encrypt && this.xref.encrypt.encryptMetadata,
                      stream = this.xref.fetch(streamRef, !encryptMetadata);
                    if (stream && isDict(stream.dict)) {
                      var type = stream.dict.get("Type"),
                        subtype = stream.dict.get("Subtype");
                      if (isName(type, "Metadata") && isName(subtype, "XML"))
                        try {
                          metadata = stringToUTF8String(bytesToString(stream.getBytes()));
                        } catch (e) {
                          info("Skipping invalid metadata.");
                        }
                    }
                    return shadow(this, "metadata", metadata);
                  },
                  get toplevelPagesDict() {
                    var pagesObj = this.catDict.get("Pages");
                    return (
                      assert(isDict(pagesObj), "invalid top-level pages dictionary"),
                      shadow(this, "toplevelPagesDict", pagesObj)
                    );
                  },
                  get documentOutline() {
                    var obj = null;
                    try {
                      obj = this.readDocumentOutline();
                    } catch (ex) {
                      if (ex instanceof MissingDataException) throw ex;
                      warn("Unable to read document outline");
                    }
                    return shadow(this, "documentOutline", obj);
                  },
                  readDocumentOutline: function () {
                    var obj = this.catDict.get("Outlines");
                    if (!isDict(obj)) return null;
                    if (((obj = obj.getRaw("First")), !isRef(obj))) return null;
                    var root = { items: [] },
                      queue = [{ obj: obj, parent: root }],
                      processed = new RefSet();
                    processed.put(obj);
                    for (var xref = this.xref, blackColor = new Uint8Array(3); queue.length > 0; ) {
                      var i = queue.shift(),
                        outlineDict = xref.fetchIfRef(i.obj);
                      if (null !== outlineDict) {
                        assert(outlineDict.has("Title"), "Invalid outline item");
                        var actionDict = outlineDict.get("A"),
                          dest = null,
                          url = null;
                        if (actionDict) {
                          var destEntry = actionDict.get("D");
                          if (destEntry) dest = destEntry;
                          else {
                            var uriEntry = actionDict.get("URI");
                            isString(uriEntry) && isValidUrl(uriEntry, !1) && (url = uriEntry);
                          }
                        } else
                          outlineDict.has("Dest") &&
                            ((dest = outlineDict.getRaw("Dest")), isName(dest) && (dest = dest.name));
                        var title = outlineDict.get("Title"),
                          flags = outlineDict.get("F") || 0,
                          color = outlineDict.getArray("C"),
                          rgbColor = blackColor;
                        !isArray(color) ||
                          3 !== color.length ||
                          (0 === color[0] && 0 === color[1] && 0 === color[2]) ||
                          (rgbColor = ColorSpace.singletons.rgb.getRgb(color, 0));
                        var outlineItem = {
                          dest: dest,
                          url: url,
                          title: stringToPDFString(title),
                          color: rgbColor,
                          count: outlineDict.get("Count"),
                          bold: !!(2 & flags),
                          italic: !!(1 & flags),
                          items: [],
                        };
                        i.parent.items.push(outlineItem),
                          (obj = outlineDict.getRaw("First")),
                          isRef(obj) &&
                            !processed.has(obj) &&
                            (queue.push({ obj: obj, parent: outlineItem }), processed.put(obj)),
                          (obj = outlineDict.getRaw("Next")),
                          isRef(obj) &&
                            !processed.has(obj) &&
                            (queue.push({ obj: obj, parent: i.parent }), processed.put(obj));
                      }
                    }
                    return root.items.length > 0 ? root.items : null;
                  },
                  get numPages() {
                    var obj = this.toplevelPagesDict.get("Count");
                    return (
                      assert(isInt(obj), "page count in top level pages object is not an integer"),
                      shadow(this, "num", obj)
                    );
                  },
                  get destinations() {
                    function fetchDestination(dest) {
                      return isDict(dest) ? dest.get("D") : dest;
                    }
                    var nameTreeRef,
                      nameDictionaryRef,
                      xref = this.xref,
                      dests = {},
                      obj = this.catDict.get("Names");
                    if (
                      (obj && obj.has("Dests")
                        ? (nameTreeRef = obj.getRaw("Dests"))
                        : this.catDict.has("Dests") && (nameDictionaryRef = this.catDict.get("Dests")),
                      nameDictionaryRef &&
                        ((obj = nameDictionaryRef),
                        obj.forEach(function (key, value) {
                          value && (dests[key] = fetchDestination(value));
                        })),
                      nameTreeRef)
                    ) {
                      var nameTree = new NameTree(nameTreeRef, xref),
                        names = nameTree.getAll();
                      for (var name in names) dests[name] = fetchDestination(names[name]);
                    }
                    return shadow(this, "destinations", dests);
                  },
                  getDestination: function (destinationId) {
                    function fetchDestination(dest) {
                      return isDict(dest) ? dest.get("D") : dest;
                    }
                    var nameTreeRef,
                      nameDictionaryRef,
                      xref = this.xref,
                      dest = null,
                      obj = this.catDict.get("Names");
                    if (
                      (obj && obj.has("Dests")
                        ? (nameTreeRef = obj.getRaw("Dests"))
                        : this.catDict.has("Dests") && (nameDictionaryRef = this.catDict.get("Dests")),
                      nameDictionaryRef)
                    ) {
                      var value = nameDictionaryRef.get(destinationId);
                      value && (dest = fetchDestination(value));
                    }
                    if (nameTreeRef) {
                      dest = fetchDestination(new NameTree(nameTreeRef, xref).get(destinationId));
                    }
                    return dest;
                  },
                  get pageLabels() {
                    var obj = null;
                    try {
                      obj = this.readPageLabels();
                    } catch (ex) {
                      if (ex instanceof MissingDataException) throw ex;
                      warn("Unable to read page labels.");
                    }
                    return shadow(this, "pageLabels", obj);
                  },
                  readPageLabels: function () {
                    var obj = this.catDict.getRaw("PageLabels");
                    if (!obj) return null;
                    for (
                      var pageLabels = new Array(this.numPages),
                        style = null,
                        prefix = "",
                        start = 1,
                        numberTree = new NumberTree(obj, this.xref),
                        nums = numberTree.getAll(),
                        currentLabel = "",
                        currentIndex = 1,
                        i = 0,
                        ii = this.numPages;
                      i < ii;
                      i++
                    ) {
                      if (i in nums) {
                        var labelDict = nums[i];
                        assert(isDict(labelDict), "The PageLabel is not a dictionary.");
                        var type = labelDict.get("Type");
                        assert(!type || isName(type, "PageLabel"), "Invalid type in PageLabel dictionary.");
                        var s = labelDict.get("S");
                        assert(!s || isName(s), "Invalid style in PageLabel dictionary."),
                          (style = s ? s.name : null),
                          (prefix = labelDict.get("P") || ""),
                          assert(isString(prefix), "Invalid prefix in PageLabel dictionary."),
                          (start = labelDict.get("St") || 1),
                          assert(isInt(start), "Invalid start in PageLabel dictionary."),
                          (currentIndex = start);
                      }
                      switch (style) {
                        case "D":
                          currentLabel = currentIndex;
                          break;
                        case "R":
                        case "r":
                          currentLabel = Util.toRoman(currentIndex, "r" === style);
                          break;
                        case "A":
                        case "a":
                          for (
                            var baseCharCode = "a" === style ? 97 : 65,
                              letterIndex = currentIndex - 1,
                              character = String.fromCharCode(baseCharCode + (letterIndex % 26)),
                              charBuf = [],
                              j = 0,
                              jj = (letterIndex / 26) | 0;
                            j <= jj;
                            j++
                          )
                            charBuf.push(character);
                          currentLabel = charBuf.join("");
                          break;
                        default:
                          assert(!style, 'Invalid style "' + style + '" in PageLabel dictionary.');
                      }
                      (pageLabels[i] = prefix + currentLabel), (currentLabel = ""), currentIndex++;
                    }
                    return pageLabels;
                  },
                  get attachments() {
                    var nameTreeRef,
                      xref = this.xref,
                      attachments = null,
                      obj = this.catDict.get("Names");
                    if ((obj && (nameTreeRef = obj.getRaw("EmbeddedFiles")), nameTreeRef)) {
                      var nameTree = new NameTree(nameTreeRef, xref),
                        names = nameTree.getAll();
                      for (var name in names) {
                        var fs = new FileSpec(names[name], xref);
                        attachments || (attachments = Object.create(null)),
                          (attachments[stringToPDFString(name)] = fs.serializable);
                      }
                    }
                    return shadow(this, "attachments", attachments);
                  },
                  get javaScript() {
                    function appendIfJavaScriptDict(jsDict) {
                      var type = jsDict.get("S");
                      if (isName(type, "JavaScript")) {
                        var js = jsDict.get("JS");
                        if (isStream(js)) js = bytesToString(js.getBytes());
                        else if (!isString(js)) return;
                        javaScript.push(stringToPDFString(js));
                      }
                    }
                    var xref = this.xref,
                      obj = this.catDict.get("Names"),
                      javaScript = [];
                    if (obj && obj.has("JavaScript")) {
                      var nameTree = new NameTree(obj.getRaw("JavaScript"), xref),
                        names = nameTree.getAll();
                      for (var name in names) {
                        var jsDict = names[name];
                        isDict(jsDict) && appendIfJavaScriptDict(jsDict);
                      }
                    }
                    var openactionDict = this.catDict.get("OpenAction");
                    if (isDict(openactionDict, "Action")) {
                      var actionType = openactionDict.get("S");
                      if (isName(actionType, "Named")) {
                        var action = openactionDict.get("N");
                        isName(action, "Print") && javaScript.push("print({});");
                      } else appendIfJavaScriptDict(openactionDict);
                    }
                    return shadow(this, "javaScript", javaScript);
                  },
                  cleanup: function () {
                    var promises = [];
                    return (
                      this.fontCache.forEach(function (promise) {
                        promises.push(promise);
                      }),
                      Promise.all(promises).then(
                        function (translatedFonts) {
                          for (var i = 0, ii = translatedFonts.length; i < ii; i++) {
                            delete translatedFonts[i].dict.translated;
                          }
                          this.fontCache.clear();
                        }.bind(this)
                      )
                    );
                  },
                  getPage: function (pageIndex) {
                    return (
                      pageIndex in this.pagePromises ||
                        (this.pagePromises[pageIndex] = this.getPageDict(pageIndex).then(
                          function (a) {
                            var dict = a[0],
                              ref = a[1];
                            return this.pageFactory.createPage(pageIndex, dict, ref, this.fontCache);
                          }.bind(this)
                        )),
                      this.pagePromises[pageIndex]
                    );
                  },
                  getPageDict: function (pageIndex) {
                    function next() {
                      for (; nodesToVisit.length; ) {
                        var currentNode = nodesToVisit.pop();
                        if (isRef(currentNode))
                          return void xref.fetchAsync(currentNode).then(function (obj) {
                            if (isDict(obj, "Page") || (isDict(obj) && !obj.has("Kids")))
                              return void (pageIndex === currentPageIndex
                                ? capability.resolve([obj, currentNode])
                                : (currentPageIndex++, next()));
                            nodesToVisit.push(obj), next();
                          }, capability.reject);
                        assert(isDict(currentNode), "page dictionary kid reference points to wrong type of object");
                        var count = currentNode.get("Count");
                        if ((0 === count && (checkAllKids = !0), currentPageIndex + count <= pageIndex))
                          currentPageIndex += count;
                        else {
                          var kids = currentNode.get("Kids");
                          if (
                            (assert(isArray(kids), "page dictionary kids object is not an array"),
                            checkAllKids || count !== kids.length)
                          )
                            for (var last = kids.length - 1; last >= 0; last--) nodesToVisit.push(kids[last]);
                          else (nodesToVisit = [kids[pageIndex - currentPageIndex]]), (currentPageIndex = pageIndex);
                        }
                      }
                      capability.reject("Page index " + pageIndex + " not found.");
                    }
                    var capability = createPromiseCapability(),
                      nodesToVisit = [this.catDict.getRaw("Pages")],
                      currentPageIndex = 0,
                      xref = this.xref,
                      checkAllKids = !1;
                    return next(), capability.promise;
                  },
                  getPageIndex: function (pageRef) {
                    function pagesBeforeRef(kidRef) {
                      var parentRef,
                        total = 0;
                      return xref
                        .fetchAsync(kidRef)
                        .then(function (node) {
                          if (
                            isRefsEqual(kidRef, pageRef) &&
                            !isDict(node, "Page") &&
                            (!isDict(node) || node.has("Type") || !node.has("Contents"))
                          )
                            throw new Error("The reference does not point to a /Page Dict.");
                          return node
                            ? (assert(isDict(node), "node must be a Dict."),
                              (parentRef = node.getRaw("Parent")),
                              node.getAsync("Parent"))
                            : null;
                        })
                        .then(function (parent) {
                          return parent
                            ? (assert(isDict(parent), "parent must be a Dict."), parent.getAsync("Kids"))
                            : null;
                        })
                        .then(function (kids) {
                          if (!kids) return null;
                          for (var kidPromises = [], found = !1, i = 0; i < kids.length; i++) {
                            var kid = kids[i];
                            if ((assert(isRef(kid), "kid must be a Ref."), kid.num === kidRef.num)) {
                              found = !0;
                              break;
                            }
                            kidPromises.push(
                              xref.fetchAsync(kid).then(function (kid) {
                                if (kid.has("Count")) {
                                  var count = kid.get("Count");
                                  total += count;
                                } else total++;
                              })
                            );
                          }
                          return (
                            found || error("kid ref not found in parents kids"),
                            Promise.all(kidPromises).then(function () {
                              return [total, parentRef];
                            })
                          );
                        });
                    }
                    function next(ref) {
                      return pagesBeforeRef(ref).then(function (args) {
                        if (!args) return total;
                        var count = args[0],
                          parentRef = args[1];
                        return (total += count), next(parentRef);
                      });
                    }
                    var xref = this.xref,
                      total = 0;
                    return next(pageRef);
                  },
                }),
                Catalog
              );
            })(),
            XRef = (function () {
              function XRef(stream, password) {
                (this.stream = stream),
                  (this.entries = []),
                  (this.xrefstms = Object.create(null)),
                  (this.cache = []),
                  (this.password = password),
                  (this.stats = { streamTypes: [], fontTypes: [] });
              }
              return (
                (XRef.prototype = {
                  setStartXRef: function (startXRef) {
                    this.startXRefQueue = [startXRef];
                  },
                  parse: function (recoveryMode) {
                    var trailerDict;
                    recoveryMode
                      ? (warn("Indexing all PDF objects"), (trailerDict = this.indexObjects()))
                      : (trailerDict = this.readXRef()),
                      trailerDict.assignXref(this),
                      (this.trailer = trailerDict);
                    var encrypt = trailerDict.get("Encrypt");
                    if (encrypt) {
                      var ids = trailerDict.get("ID"),
                        fileId = ids && ids.length ? ids[0] : "";
                      this.encrypt = new CipherTransformFactory(encrypt, fileId, this.password);
                    }
                    (this.root = trailerDict.get("Root")) || error("Invalid root reference");
                  },
                  processXRefTable: function (parser) {
                    "tableState" in this ||
                      (this.tableState = {
                        entryNum: 0,
                        streamPos: parser.lexer.stream.pos,
                        parserBuf1: parser.buf1,
                        parserBuf2: parser.buf2,
                      });
                    var obj = this.readXRefTable(parser);
                    isCmd(obj, "trailer") || error("Invalid XRef table: could not find trailer dictionary");
                    var dict = parser.getObj();
                    return (
                      !isDict(dict) && dict.dict && (dict = dict.dict),
                      isDict(dict) || error("Invalid XRef table: could not parse trailer dictionary"),
                      delete this.tableState,
                      dict
                    );
                  },
                  readXRefTable: function (parser) {
                    var stream = parser.lexer.stream,
                      tableState = this.tableState;
                    (stream.pos = tableState.streamPos),
                      (parser.buf1 = tableState.parserBuf1),
                      (parser.buf2 = tableState.parserBuf2);
                    for (var obj; ; ) {
                      if (!("firstEntryNum" in tableState && "entryCount" in tableState)) {
                        if (isCmd((obj = parser.getObj()), "trailer")) break;
                        (tableState.firstEntryNum = obj), (tableState.entryCount = parser.getObj());
                      }
                      var first = tableState.firstEntryNum,
                        count = tableState.entryCount;
                      (isInt(first) && isInt(count)) || error("Invalid XRef table: wrong types in subsection header");
                      for (var i = tableState.entryNum; i < count; i++) {
                        (tableState.streamPos = stream.pos),
                          (tableState.entryNum = i),
                          (tableState.parserBuf1 = parser.buf1),
                          (tableState.parserBuf2 = parser.buf2);
                        var entry = {};
                        (entry.offset = parser.getObj()), (entry.gen = parser.getObj());
                        var type = parser.getObj();
                        isCmd(type, "f") ? (entry.free = !0) : isCmd(type, "n") && (entry.uncompressed = !0),
                          (isInt(entry.offset) && isInt(entry.gen) && (entry.free || entry.uncompressed)) ||
                            error("Invalid entry in XRef subsection: " + first + ", " + count),
                          0 === i && entry.free && 1 === first && (first = 0),
                          this.entries[i + first] || (this.entries[i + first] = entry);
                      }
                      (tableState.entryNum = 0),
                        (tableState.streamPos = stream.pos),
                        (tableState.parserBuf1 = parser.buf1),
                        (tableState.parserBuf2 = parser.buf2),
                        delete tableState.firstEntryNum,
                        delete tableState.entryCount;
                    }
                    return (
                      this.entries[0] && !this.entries[0].free && error("Invalid XRef table: unexpected first object"),
                      obj
                    );
                  },
                  processXRefStream: function (stream) {
                    if (!("streamState" in this)) {
                      var streamParameters = stream.dict,
                        byteWidths = streamParameters.get("W"),
                        range = streamParameters.get("Index");
                      range || (range = [0, streamParameters.get("Size")]),
                        (this.streamState = {
                          entryRanges: range,
                          byteWidths: byteWidths,
                          entryNum: 0,
                          streamPos: stream.pos,
                        });
                    }
                    return this.readXRefStream(stream), delete this.streamState, stream.dict;
                  },
                  readXRefStream: function (stream) {
                    var i,
                      j,
                      streamState = this.streamState;
                    stream.pos = streamState.streamPos;
                    for (
                      var byteWidths = streamState.byteWidths,
                        typeFieldWidth = byteWidths[0],
                        offsetFieldWidth = byteWidths[1],
                        generationFieldWidth = byteWidths[2],
                        entryRanges = streamState.entryRanges;
                      entryRanges.length > 0;

                    ) {
                      var first = entryRanges[0],
                        n = entryRanges[1];
                      for (
                        (isInt(first) && isInt(n)) || error("Invalid XRef range fields: " + first + ", " + n),
                          (isInt(typeFieldWidth) && isInt(offsetFieldWidth) && isInt(generationFieldWidth)) ||
                            error("Invalid XRef entry fields length: " + first + ", " + n),
                          i = streamState.entryNum;
                        i < n;
                        ++i
                      ) {
                        (streamState.entryNum = i), (streamState.streamPos = stream.pos);
                        var type = 0,
                          offset = 0,
                          generation = 0;
                        for (j = 0; j < typeFieldWidth; ++j) type = (type << 8) | stream.getByte();
                        for (0 === typeFieldWidth && (type = 1), j = 0; j < offsetFieldWidth; ++j)
                          offset = (offset << 8) | stream.getByte();
                        for (j = 0; j < generationFieldWidth; ++j) generation = (generation << 8) | stream.getByte();
                        var entry = {};
                        switch (((entry.offset = offset), (entry.gen = generation), type)) {
                          case 0:
                            entry.free = !0;
                            break;
                          case 1:
                            entry.uncompressed = !0;
                            break;
                          case 2:
                            break;
                          default:
                            error("Invalid XRef entry type: " + type);
                        }
                        this.entries[first + i] || (this.entries[first + i] = entry);
                      }
                      (streamState.entryNum = 0), (streamState.streamPos = stream.pos), entryRanges.splice(0, 2);
                    }
                  },
                  indexObjects: function () {
                    function skipUntil(data, offset, what) {
                      for (var length = what.length, dataLength = data.length, skipped = 0; offset < dataLength; ) {
                        for (var i = 0; i < length && data[offset + i] === what[i]; ) ++i;
                        if (i >= length) break;
                        offset++, skipped++;
                      }
                      return skipped;
                    }
                    var LF = 10,
                      CR = 13,
                      LT = 60,
                      objRegExp = /^(\d+)\s+(\d+)\s+obj\b/,
                      trailerBytes = new Uint8Array([116, 114, 97, 105, 108, 101, 114]),
                      startxrefBytes = new Uint8Array([115, 116, 97, 114, 116, 120, 114, 101, 102]),
                      endobjBytes = new Uint8Array([101, 110, 100, 111, 98, 106]),
                      xrefBytes = new Uint8Array([47, 88, 82, 101, 102]);
                    this.entries.length = 0;
                    var stream = this.stream;
                    stream.pos = 0;
                    for (
                      var buffer = stream.getBytes(),
                        position = stream.start,
                        length = buffer.length,
                        trailers = [],
                        xrefStms = [];
                      position < length;

                    ) {
                      var ch = buffer[position];
                      if (9 !== ch && ch !== LF && ch !== CR && 32 !== ch)
                        if (37 !== ch) {
                          var m,
                            token = (function (data, offset) {
                              for (
                                var token = "", ch = data[offset];
                                ch !== LF && ch !== CR && ch !== LT && !(++offset >= data.length);

                              )
                                (token += String.fromCharCode(ch)), (ch = data[offset]);
                              return token;
                            })(buffer, position);
                          if (0 !== token.indexOf("xref") || (4 !== token.length && !/\s/.test(token[4])))
                            if ((m = objRegExp.exec(token))) {
                              void 0 === this.entries[m[1]] &&
                                (this.entries[m[1]] = {
                                  offset: position - stream.start,
                                  gen: 0 | m[2],
                                  uncompressed: !0,
                                });
                              var contentLength = skipUntil(buffer, position, endobjBytes) + 7,
                                content = buffer.subarray(position, position + contentLength),
                                xrefTagOffset = skipUntil(content, 0, xrefBytes);
                              xrefTagOffset < contentLength &&
                                content[xrefTagOffset + 5] < 64 &&
                                (xrefStms.push(position - stream.start), (this.xrefstms[position - stream.start] = 1)),
                                (position += contentLength);
                            } else
                              0 !== token.indexOf("trailer") || (7 !== token.length && !/\s/.test(token[7]))
                                ? (position += token.length + 1)
                                : (trailers.push(position), (position += skipUntil(buffer, position, startxrefBytes)));
                          else
                            (position += skipUntil(buffer, position, trailerBytes)),
                              trailers.push(position),
                              (position += skipUntil(buffer, position, startxrefBytes));
                        } else
                          do {
                            if (++position >= length) break;
                            ch = buffer[position];
                          } while (ch !== LF && ch !== CR);
                      else ++position;
                    }
                    var i, ii;
                    for (i = 0, ii = xrefStms.length; i < ii; ++i)
                      this.startXRefQueue.push(xrefStms[i]), this.readXRef(!0);
                    var dict;
                    for (i = 0, ii = trailers.length; i < ii; ++i) {
                      stream.pos = trailers[i];
                      var parser = new Parser(new Lexer(stream), !0, this, !0),
                        obj = parser.getObj();
                      if (isCmd(obj, "trailer") && ((dict = parser.getObj()), isDict(dict) && dict.has("ID")))
                        return dict;
                    }
                    if (dict) return dict;
                    throw new InvalidPDFException("Invalid PDF structure");
                  },
                  readXRef: function (recoveryMode) {
                    var stream = this.stream;
                    try {
                      for (; this.startXRefQueue.length; ) {
                        var startXRef = this.startXRefQueue[0];
                        stream.pos = startXRef + stream.start;
                        var dict,
                          parser = new Parser(new Lexer(stream), !0, this),
                          obj = parser.getObj();
                        if (isCmd(obj, "xref")) {
                          if (
                            ((dict = this.processXRefTable(parser)),
                            this.topDict || (this.topDict = dict),
                            (obj = dict.get("XRefStm")),
                            isInt(obj))
                          ) {
                            var pos = obj;
                            pos in this.xrefstms || ((this.xrefstms[pos] = 1), this.startXRefQueue.push(pos));
                          }
                        } else
                          isInt(obj)
                            ? ((isInt(parser.getObj()) &&
                                isCmd(parser.getObj(), "obj") &&
                                isStream((obj = parser.getObj()))) ||
                                error("Invalid XRef stream"),
                              (dict = this.processXRefStream(obj)),
                              this.topDict || (this.topDict = dict),
                              dict || error("Failed to read XRef stream"))
                            : error("Invalid XRef stream header");
                        (obj = dict.get("Prev")),
                          isInt(obj) ? this.startXRefQueue.push(obj) : isRef(obj) && this.startXRefQueue.push(obj.num),
                          this.startXRefQueue.shift();
                      }
                      return this.topDict;
                    } catch (e) {
                      if (e instanceof MissingDataException) throw e;
                      info("(while reading XRef): " + e);
                    }
                    if (!recoveryMode) throw new XRefParseException();
                  },
                  getEntry: function (i) {
                    var xrefEntry = this.entries[i];
                    return xrefEntry && !xrefEntry.free && xrefEntry.offset ? xrefEntry : null;
                  },
                  fetchIfRef: function (obj) {
                    return isRef(obj) ? this.fetch(obj) : obj;
                  },
                  fetch: function (ref, suppressEncryption) {
                    assert(isRef(ref), "ref object is not a reference");
                    var num = ref.num;
                    if (num in this.cache) {
                      return this.cache[num];
                    }
                    var xrefEntry = this.getEntry(num);
                    return null === xrefEntry
                      ? (this.cache[num] = null)
                      : ((xrefEntry = xrefEntry.uncompressed
                          ? this.fetchUncompressed(ref, xrefEntry, suppressEncryption)
                          : this.fetchCompressed(xrefEntry, suppressEncryption)),
                        isDict(xrefEntry)
                          ? (xrefEntry.objId = ref.toString())
                          : isStream(xrefEntry) && (xrefEntry.dict.objId = ref.toString()),
                        xrefEntry);
                  },
                  fetchUncompressed: function (ref, xrefEntry, suppressEncryption) {
                    var gen = ref.gen,
                      num = ref.num;
                    xrefEntry.gen !== gen && error("inconsistent generation in XRef");
                    var stream = this.stream.makeSubStream(xrefEntry.offset + this.stream.start),
                      parser = new Parser(new Lexer(stream), !0, this),
                      obj1 = parser.getObj(),
                      obj2 = parser.getObj(),
                      obj3 = parser.getObj();
                    if (
                      ((isInt(obj1) &&
                        parseInt(obj1, 10) === num &&
                        isInt(obj2) &&
                        parseInt(obj2, 10) === gen &&
                        isCmd(obj3)) ||
                        error("bad XRef entry"),
                      !isCmd(obj3, "obj"))
                    ) {
                      if (0 === obj3.cmd.indexOf("obj") && ((num = parseInt(obj3.cmd.substring(3), 10)), !isNaN(num)))
                        return num;
                      error("bad XRef entry");
                    }
                    return (
                      (xrefEntry =
                        this.encrypt && !suppressEncryption
                          ? parser.getObj(this.encrypt.createCipherTransform(num, gen))
                          : parser.getObj()),
                      isStream(xrefEntry) || (this.cache[num] = xrefEntry),
                      xrefEntry
                    );
                  },
                  fetchCompressed: function (xrefEntry, suppressEncryption) {
                    var tableOffset = xrefEntry.offset,
                      stream = this.fetch(new Ref(tableOffset, 0));
                    isStream(stream) || error("bad ObjStm stream");
                    var first = stream.dict.get("First"),
                      n = stream.dict.get("N");
                    (isInt(first) && isInt(n)) || error("invalid first and n parameters for ObjStm stream");
                    var parser = new Parser(new Lexer(stream), !1, this);
                    parser.allowStreams = !0;
                    var i,
                      num,
                      entries = [],
                      nums = [];
                    for (i = 0; i < n; ++i) {
                      (num = parser.getObj()),
                        isInt(num) || error("invalid object number in the ObjStm stream: " + num),
                        nums.push(num);
                      var offset = parser.getObj();
                      isInt(offset) || error("invalid object offset in the ObjStm stream: " + offset);
                    }
                    for (i = 0; i < n; ++i) {
                      entries.push(parser.getObj()), isCmd(parser.buf1, "endobj") && parser.shift(), (num = nums[i]);
                      var entry = this.entries[num];
                      entry && entry.offset === tableOffset && entry.gen === i && (this.cache[num] = entries[i]);
                    }
                    return (
                      (xrefEntry = entries[xrefEntry.gen]),
                      void 0 === xrefEntry && error("bad XRef entry for compressed object"),
                      xrefEntry
                    );
                  },
                  fetchIfRefAsync: function (obj) {
                    return isRef(obj) ? this.fetchAsync(obj) : Promise.resolve(obj);
                  },
                  fetchAsync: function (ref, suppressEncryption) {
                    var streamManager = this.stream.manager,
                      xref = this;
                    return new Promise(function tryFetch(resolve, reject) {
                      try {
                        resolve(xref.fetch(ref, suppressEncryption));
                      } catch (e) {
                        if (e instanceof MissingDataException)
                          return void streamManager.requestRange(e.begin, e.end).then(function () {
                            tryFetch(resolve, reject);
                          }, reject);
                        reject(e);
                      }
                    });
                  },
                  getCatalogObj: function () {
                    return this.root;
                  },
                }),
                XRef
              );
            })(),
            NameOrNumberTree = (function () {
              function NameOrNumberTree(root, xref) {
                throw new Error("Cannot initialize NameOrNumberTree.");
              }
              return (
                (NameOrNumberTree.prototype = {
                  getAll: function () {
                    var dict = Object.create(null);
                    if (!this.root) return dict;
                    var xref = this.xref,
                      processed = new RefSet();
                    processed.put(this.root);
                    for (var queue = [this.root]; queue.length > 0; ) {
                      var i,
                        n,
                        obj = xref.fetchIfRef(queue.shift());
                      if (isDict(obj))
                        if (obj.has("Kids")) {
                          var kids = obj.get("Kids");
                          for (i = 0, n = kids.length; i < n; i++) {
                            var kid = kids[i];
                            assert(!processed.has(kid), 'Duplicate entry in "' + this._type + '" tree.'),
                              queue.push(kid),
                              processed.put(kid);
                          }
                        } else {
                          var entries = obj.get(this._type);
                          if (isArray(entries))
                            for (i = 0, n = entries.length; i < n; i += 2)
                              dict[xref.fetchIfRef(entries[i])] = xref.fetchIfRef(entries[i + 1]);
                        }
                    }
                    return dict;
                  },
                  get: function (key) {
                    if (!this.root) return null;
                    for (
                      var l, r, m, xref = this.xref, kidsOrEntries = xref.fetchIfRef(this.root), loopCount = 0;
                      kidsOrEntries.has("Kids");

                    ) {
                      if (++loopCount > 10)
                        return warn('Search depth limit reached for "' + this._type + '" tree.'), null;
                      var kids = kidsOrEntries.get("Kids");
                      if (!isArray(kids)) return null;
                      for (l = 0, r = kids.length - 1; l <= r; ) {
                        m = (l + r) >> 1;
                        var kid = xref.fetchIfRef(kids[m]),
                          limits = kid.get("Limits");
                        if (key < xref.fetchIfRef(limits[0])) r = m - 1;
                        else {
                          if (!(key > xref.fetchIfRef(limits[1]))) {
                            kidsOrEntries = xref.fetchIfRef(kids[m]);
                            break;
                          }
                          l = m + 1;
                        }
                      }
                      if (l > r) return null;
                    }
                    var entries = kidsOrEntries.get(this._type);
                    if (isArray(entries))
                      for (l = 0, r = entries.length - 2; l <= r; ) {
                        m = (l + r) & -2;
                        var currentKey = xref.fetchIfRef(entries[m]);
                        if (key < currentKey) r = m - 2;
                        else {
                          if (!(key > currentKey)) return xref.fetchIfRef(entries[m + 1]);
                          l = m + 2;
                        }
                      }
                    return null;
                  },
                }),
                NameOrNumberTree
              );
            })(),
            NameTree = (function () {
              function NameTree(root, xref) {
                (this.root = root), (this.xref = xref), (this._type = "Names");
              }
              return Util.inherit(NameTree, NameOrNumberTree, {}), NameTree;
            })(),
            NumberTree = (function () {
              function NumberTree(root, xref) {
                (this.root = root), (this.xref = xref), (this._type = "Nums");
              }
              return Util.inherit(NumberTree, NameOrNumberTree, {}), NumberTree;
            })(),
            FileSpec = (function () {
              function FileSpec(root, xref) {
                root &&
                  isDict(root) &&
                  ((this.xref = xref),
                  (this.root = root),
                  root.has("FS") && (this.fs = root.get("FS")),
                  (this.description = root.has("Desc") ? stringToPDFString(root.get("Desc")) : ""),
                  root.has("RF") && warn("Related file specifications are not supported"),
                  (this.contentAvailable = !0),
                  root.has("EF") ||
                    ((this.contentAvailable = !1), warn("Non-embedded file specifications are not supported")));
              }
              function pickPlatformItem(dict) {
                return dict.has("UF")
                  ? dict.get("UF")
                  : dict.has("F")
                  ? dict.get("F")
                  : dict.has("Unix")
                  ? dict.get("Unix")
                  : dict.has("Mac")
                  ? dict.get("Mac")
                  : dict.has("DOS")
                  ? dict.get("DOS")
                  : null;
              }
              return (
                (FileSpec.prototype = {
                  get filename() {
                    if (!this._filename && this.root) {
                      var filename = pickPlatformItem(this.root) || "unnamed";
                      this._filename = stringToPDFString(filename)
                        .replace(/\\\\/g, "\\")
                        .replace(/\\\//g, "/")
                        .replace(/\\/g, "/");
                    }
                    return this._filename;
                  },
                  get content() {
                    if (!this.contentAvailable) return null;
                    !this.contentRef && this.root && (this.contentRef = pickPlatformItem(this.root.get("EF")));
                    var content = null;
                    if (this.contentRef) {
                      var xref = this.xref,
                        fileObj = xref.fetchIfRef(this.contentRef);
                      fileObj && isStream(fileObj)
                        ? (content = fileObj.getBytes())
                        : warn("Embedded file specification points to non-existing/invalid content");
                    } else warn("Embedded file specification does not have a content");
                    return content;
                  },
                  get serializable() {
                    return { filename: this.filename, content: this.content };
                  },
                }),
                FileSpec
              );
            })(),
            ObjectLoader = (function () {
              function mayHaveChildren(value) {
                return isRef(value) || isDict(value) || isArray(value) || isStream(value);
              }
              function addChildren(node, nodesToVisit) {
                var value;
                if (isDict(node) || isStream(node)) {
                  var map;
                  map = isDict(node) ? node.map : node.dict.map;
                  for (var key in map) (value = map[key]), mayHaveChildren(value) && nodesToVisit.push(value);
                } else if (isArray(node))
                  for (var i = 0, ii = node.length; i < ii; i++)
                    (value = node[i]), mayHaveChildren(value) && nodesToVisit.push(value);
              }
              function ObjectLoader(obj, keys, xref) {
                (this.obj = obj),
                  (this.keys = keys),
                  (this.xref = xref),
                  (this.refSet = null),
                  (this.capability = null);
              }
              return (
                (ObjectLoader.prototype = {
                  load: function () {
                    var keys = this.keys;
                    if (
                      ((this.capability = createPromiseCapability()),
                      !(this.xref.stream instanceof ChunkedStream) || 0 === this.xref.stream.getMissingChunks().length)
                    )
                      return this.capability.resolve(), this.capability.promise;
                    this.refSet = new RefSet();
                    for (var nodesToVisit = [], i = 0; i < keys.length; i++) nodesToVisit.push(this.obj[keys[i]]);
                    return this._walk(nodesToVisit), this.capability.promise;
                  },
                  _walk: function (nodesToVisit) {
                    for (var nodesToRevisit = [], pendingRequests = []; nodesToVisit.length; ) {
                      var currentNode = nodesToVisit.pop();
                      if (isRef(currentNode)) {
                        if (this.refSet.has(currentNode)) continue;
                        try {
                          var ref = currentNode;
                          this.refSet.put(ref), (currentNode = this.xref.fetch(currentNode));
                        } catch (e) {
                          if (!(e instanceof MissingDataException)) throw e;
                          nodesToRevisit.push(currentNode), pendingRequests.push({ begin: e.begin, end: e.end });
                        }
                      }
                      if (currentNode && currentNode.getBaseStreams) {
                        for (
                          var baseStreams = currentNode.getBaseStreams(), foundMissingData = !1, i = 0;
                          i < baseStreams.length;
                          i++
                        ) {
                          var stream = baseStreams[i];
                          stream.getMissingChunks &&
                            stream.getMissingChunks().length &&
                            ((foundMissingData = !0), pendingRequests.push({ begin: stream.start, end: stream.end }));
                        }
                        foundMissingData && nodesToRevisit.push(currentNode);
                      }
                      addChildren(currentNode, nodesToVisit);
                    }
                    if (pendingRequests.length)
                      return void this.xref.stream.manager.requestRanges(pendingRequests).then(
                        function () {
                          nodesToVisit = nodesToRevisit;
                          for (var i = 0; i < nodesToRevisit.length; i++) {
                            var node = nodesToRevisit[i];
                            isRef(node) && this.refSet.remove(node);
                          }
                          this._walk(nodesToVisit);
                        }.bind(this),
                        this.capability.reject
                      );
                    (this.refSet = null), this.capability.resolve();
                  },
                }),
                ObjectLoader
              );
            })();
          (exports.Catalog = Catalog),
            (exports.ObjectLoader = ObjectLoader),
            (exports.XRef = XRef),
            (exports.FileSpec = FileSpec);
        })(
          (root.pdfjsCoreObj = {}),
          root.pdfjsSharedUtil,
          root.pdfjsCorePrimitives,
          root.pdfjsCoreCrypto,
          root.pdfjsCoreParser,
          root.pdfjsCoreChunkedStream,
          root.pdfjsCoreColorSpace
        );
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, corePrimitives, coreFunction, coreColorSpace) {
          function getTilingPatternIR(operatorList, dict, args) {
            return [
              "TilingPattern",
              args,
              operatorList,
              dict.getArray("Matrix"),
              dict.getArray("BBox"),
              dict.get("XStep"),
              dict.get("YStep"),
              dict.get("PaintType"),
              dict.get("TilingType"),
            ];
          }
          var UNSUPPORTED_FEATURES = sharedUtil.UNSUPPORTED_FEATURES,
            MissingDataException = sharedUtil.MissingDataException,
            Util = sharedUtil.Util,
            assert = sharedUtil.assert,
            error = sharedUtil.error,
            info = sharedUtil.info,
            warn = sharedUtil.warn,
            isStream = corePrimitives.isStream,
            PDFFunction = coreFunction.PDFFunction,
            ColorSpace = coreColorSpace.ColorSpace,
            ShadingType = {
              FUNCTION_BASED: 1,
              AXIAL: 2,
              RADIAL: 3,
              FREE_FORM_MESH: 4,
              LATTICE_FORM_MESH: 5,
              COONS_PATCH_MESH: 6,
              TENSOR_PATCH_MESH: 7,
            },
            Pattern = (function () {
              function Pattern() {
                error("should not call Pattern constructor");
              }
              return (
                (Pattern.prototype = {
                  getPattern: function (ctx) {
                    error("Should not call Pattern.getStyle: " + ctx);
                  },
                }),
                (Pattern.parseShading = function (shading, matrix, xref, res, handler) {
                  var dict = isStream(shading) ? shading.dict : shading,
                    type = dict.get("ShadingType");
                  try {
                    switch (type) {
                      case ShadingType.AXIAL:
                      case ShadingType.RADIAL:
                        return new Shadings.RadialAxial(dict, matrix, xref, res);
                      case ShadingType.FREE_FORM_MESH:
                      case ShadingType.LATTICE_FORM_MESH:
                      case ShadingType.COONS_PATCH_MESH:
                      case ShadingType.TENSOR_PATCH_MESH:
                        return new Shadings.Mesh(shading, matrix, xref, res);
                      default:
                        throw new Error("Unsupported ShadingType: " + type);
                    }
                  } catch (ex) {
                    if (ex instanceof MissingDataException) throw ex;
                    return (
                      handler.send("UnsupportedFeature", { featureId: UNSUPPORTED_FEATURES.shadingPattern }),
                      warn(ex),
                      new Shadings.Dummy()
                    );
                  }
                }),
                Pattern
              );
            })(),
            Shadings = {};
          (Shadings.SMALL_NUMBER = 1e-6),
            (Shadings.RadialAxial = (function () {
              function RadialAxial(dict, matrix, xref, res) {
                (this.matrix = matrix),
                  (this.coordsArr = dict.getArray("Coords")),
                  (this.shadingType = dict.get("ShadingType")),
                  (this.type = "Pattern");
                var cs = dict.get("ColorSpace", "CS");
                (cs = ColorSpace.parse(cs, xref, res)), (this.cs = cs);
                var t0 = 0,
                  t1 = 1;
                if (dict.has("Domain")) {
                  var domainArr = dict.getArray("Domain");
                  (t0 = domainArr[0]), (t1 = domainArr[1]);
                }
                var extendStart = !1,
                  extendEnd = !1;
                if (dict.has("Extend")) {
                  var extendArr = dict.getArray("Extend");
                  (extendStart = extendArr[0]), (extendEnd = extendArr[1]);
                }
                if (!(this.shadingType !== ShadingType.RADIAL || (extendStart && extendEnd))) {
                  var x1 = this.coordsArr[0],
                    y1 = this.coordsArr[1],
                    r1 = this.coordsArr[2],
                    x2 = this.coordsArr[3],
                    y2 = this.coordsArr[4],
                    r2 = this.coordsArr[5],
                    distance = Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
                  r1 <= r2 + distance && r2 <= r1 + distance && warn("Unsupported radial gradient.");
                }
                (this.extendStart = extendStart), (this.extendEnd = extendEnd);
                var fnObj = dict.get("Function"),
                  fn = PDFFunction.parseArray(xref, fnObj),
                  diff = t1 - t0,
                  step = diff / 10,
                  colorStops = (this.colorStops = []);
                if (t0 >= t1 || step <= 0) return void info("Bad shading domain.");
                for (
                  var rgbColor, color = new Float32Array(cs.numComps), ratio = new Float32Array(1), i = t0;
                  i <= t1;
                  i += step
                ) {
                  (ratio[0] = i), fn(ratio, 0, color, 0), (rgbColor = cs.getRgb(color, 0));
                  var cssColor = Util.makeCssRgb(rgbColor[0], rgbColor[1], rgbColor[2]);
                  colorStops.push([(i - t0) / diff, cssColor]);
                }
                var background = "transparent";
                dict.has("Background") &&
                  ((rgbColor = cs.getRgb(dict.get("Background"), 0)),
                  (background = Util.makeCssRgb(rgbColor[0], rgbColor[1], rgbColor[2]))),
                  extendStart || (colorStops.unshift([0, background]), (colorStops[1][0] += Shadings.SMALL_NUMBER)),
                  extendEnd ||
                    ((colorStops[colorStops.length - 1][0] -= Shadings.SMALL_NUMBER), colorStops.push([1, background])),
                  (this.colorStops = colorStops);
              }
              return (
                (RadialAxial.prototype = {
                  getIR: function () {
                    var type,
                      p0,
                      p1,
                      r0,
                      r1,
                      coordsArr = this.coordsArr,
                      shadingType = this.shadingType;
                    shadingType === ShadingType.AXIAL
                      ? ((p0 = [coordsArr[0], coordsArr[1]]),
                        (p1 = [coordsArr[2], coordsArr[3]]),
                        (r0 = null),
                        (r1 = null),
                        (type = "axial"))
                      : shadingType === ShadingType.RADIAL
                      ? ((p0 = [coordsArr[0], coordsArr[1]]),
                        (p1 = [coordsArr[3], coordsArr[4]]),
                        (r0 = coordsArr[2]),
                        (r1 = coordsArr[5]),
                        (type = "radial"))
                      : error("getPattern type unknown: " + shadingType);
                    var matrix = this.matrix;
                    if (
                      matrix &&
                      ((p0 = Util.applyTransform(p0, matrix)),
                      (p1 = Util.applyTransform(p1, matrix)),
                      shadingType === ShadingType.RADIAL)
                    ) {
                      var scale = Util.singularValueDecompose2dScale(matrix);
                      (r0 *= scale[0]), (r1 *= scale[1]);
                    }
                    return ["RadialAxial", type, this.colorStops, p0, p1, r0, r1];
                  },
                }),
                RadialAxial
              );
            })()),
            (Shadings.Mesh = (function () {
              function MeshStreamReader(stream, context) {
                (this.stream = stream), (this.context = context), (this.buffer = 0), (this.bufferLength = 0);
                var numComps = context.numComps;
                this.tmpCompsBuf = new Float32Array(numComps);
                var csNumComps = context.colorSpace.numComps;
                this.tmpCsCompsBuf = context.colorFn ? new Float32Array(csNumComps) : this.tmpCompsBuf;
              }
              function decodeType4Shading(mesh, reader) {
                for (
                  var coords = mesh.coords, colors = mesh.colors, operators = [], ps = [], verticesLeft = 0;
                  reader.hasData;

                ) {
                  var f = reader.readFlag(),
                    coord = reader.readCoordinate(),
                    color = reader.readComponents();
                  if (0 === verticesLeft) {
                    switch ((assert(0 <= f && f <= 2, "Unknown type4 flag"), f)) {
                      case 0:
                        verticesLeft = 3;
                        break;
                      case 1:
                        ps.push(ps[ps.length - 2], ps[ps.length - 1]), (verticesLeft = 1);
                        break;
                      case 2:
                        ps.push(ps[ps.length - 3], ps[ps.length - 1]), (verticesLeft = 1);
                    }
                    operators.push(f);
                  }
                  ps.push(coords.length), coords.push(coord), colors.push(color), verticesLeft--, reader.align();
                }
                mesh.figures.push({ type: "triangles", coords: new Int32Array(ps), colors: new Int32Array(ps) });
              }
              function decodeType5Shading(mesh, reader, verticesPerRow) {
                for (var coords = mesh.coords, colors = mesh.colors, ps = []; reader.hasData; ) {
                  var coord = reader.readCoordinate(),
                    color = reader.readComponents();
                  ps.push(coords.length), coords.push(coord), colors.push(color);
                }
                mesh.figures.push({
                  type: "lattice",
                  coords: new Int32Array(ps),
                  colors: new Int32Array(ps),
                  verticesPerRow: verticesPerRow,
                });
              }
              function buildFigureFromPatch(mesh, index) {
                var figure = mesh.figures[index];
                assert("patch" === figure.type, "Unexpected patch mesh figure");
                var coords = mesh.coords,
                  colors = mesh.colors,
                  pi = figure.coords,
                  ci = figure.colors,
                  figureMinX = Math.min(coords[pi[0]][0], coords[pi[3]][0], coords[pi[12]][0], coords[pi[15]][0]),
                  figureMinY = Math.min(coords[pi[0]][1], coords[pi[3]][1], coords[pi[12]][1], coords[pi[15]][1]),
                  figureMaxX = Math.max(coords[pi[0]][0], coords[pi[3]][0], coords[pi[12]][0], coords[pi[15]][0]),
                  figureMaxY = Math.max(coords[pi[0]][1], coords[pi[3]][1], coords[pi[12]][1], coords[pi[15]][1]),
                  splitXBy = Math.ceil(
                    ((figureMaxX - figureMinX) * TRIANGLE_DENSITY) / (mesh.bounds[2] - mesh.bounds[0])
                  );
                splitXBy = Math.max(MIN_SPLIT_PATCH_CHUNKS_AMOUNT, Math.min(MAX_SPLIT_PATCH_CHUNKS_AMOUNT, splitXBy));
                var splitYBy = Math.ceil(
                  ((figureMaxY - figureMinY) * TRIANGLE_DENSITY) / (mesh.bounds[3] - mesh.bounds[1])
                );
                splitYBy = Math.max(MIN_SPLIT_PATCH_CHUNKS_AMOUNT, Math.min(MAX_SPLIT_PATCH_CHUNKS_AMOUNT, splitYBy));
                for (
                  var verticesPerRow = splitXBy + 1,
                    figureCoords = new Int32Array((splitYBy + 1) * verticesPerRow),
                    figureColors = new Int32Array((splitYBy + 1) * verticesPerRow),
                    k = 0,
                    cl = new Uint8Array(3),
                    cr = new Uint8Array(3),
                    c0 = colors[ci[0]],
                    c1 = colors[ci[1]],
                    c2 = colors[ci[2]],
                    c3 = colors[ci[3]],
                    bRow = getB(splitYBy),
                    bCol = getB(splitXBy),
                    row = 0;
                  row <= splitYBy;
                  row++
                ) {
                  (cl[0] = ((c0[0] * (splitYBy - row) + c2[0] * row) / splitYBy) | 0),
                    (cl[1] = ((c0[1] * (splitYBy - row) + c2[1] * row) / splitYBy) | 0),
                    (cl[2] = ((c0[2] * (splitYBy - row) + c2[2] * row) / splitYBy) | 0),
                    (cr[0] = ((c1[0] * (splitYBy - row) + c3[0] * row) / splitYBy) | 0),
                    (cr[1] = ((c1[1] * (splitYBy - row) + c3[1] * row) / splitYBy) | 0),
                    (cr[2] = ((c1[2] * (splitYBy - row) + c3[2] * row) / splitYBy) | 0);
                  for (var col = 0; col <= splitXBy; col++, k++)
                    if ((0 !== row && row !== splitYBy) || (0 !== col && col !== splitXBy)) {
                      for (var x = 0, y = 0, q = 0, i = 0; i <= 3; i++)
                        for (var j = 0; j <= 3; j++, q++) {
                          var m = bRow[row][i] * bCol[col][j];
                          (x += coords[pi[q]][0] * m), (y += coords[pi[q]][1] * m);
                        }
                      (figureCoords[k] = coords.length), coords.push([x, y]), (figureColors[k] = colors.length);
                      var newColor = new Uint8Array(3);
                      (newColor[0] = ((cl[0] * (splitXBy - col) + cr[0] * col) / splitXBy) | 0),
                        (newColor[1] = ((cl[1] * (splitXBy - col) + cr[1] * col) / splitXBy) | 0),
                        (newColor[2] = ((cl[2] * (splitXBy - col) + cr[2] * col) / splitXBy) | 0),
                        colors.push(newColor);
                    }
                }
                (figureCoords[0] = pi[0]),
                  (figureColors[0] = ci[0]),
                  (figureCoords[splitXBy] = pi[3]),
                  (figureColors[splitXBy] = ci[1]),
                  (figureCoords[verticesPerRow * splitYBy] = pi[12]),
                  (figureColors[verticesPerRow * splitYBy] = ci[2]),
                  (figureCoords[verticesPerRow * splitYBy + splitXBy] = pi[15]),
                  (figureColors[verticesPerRow * splitYBy + splitXBy] = ci[3]),
                  (mesh.figures[index] = {
                    type: "lattice",
                    coords: figureCoords,
                    colors: figureColors,
                    verticesPerRow: verticesPerRow,
                  });
              }
              function decodeType6Shading(mesh, reader) {
                for (
                  var coords = mesh.coords, colors = mesh.colors, ps = new Int32Array(16), cs = new Int32Array(4);
                  reader.hasData;

                ) {
                  var f = reader.readFlag();
                  assert(0 <= f && f <= 3, "Unknown type6 flag");
                  var i,
                    ii,
                    pi = coords.length;
                  for (i = 0, ii = 0 !== f ? 8 : 12; i < ii; i++) coords.push(reader.readCoordinate());
                  var ci = colors.length;
                  for (i = 0, ii = 0 !== f ? 2 : 4; i < ii; i++) colors.push(reader.readComponents());
                  var tmp1, tmp2, tmp3, tmp4;
                  switch (f) {
                    case 0:
                      (ps[12] = pi + 3),
                        (ps[13] = pi + 4),
                        (ps[14] = pi + 5),
                        (ps[15] = pi + 6),
                        (ps[8] = pi + 2),
                        (ps[11] = pi + 7),
                        (ps[4] = pi + 1),
                        (ps[7] = pi + 8),
                        (ps[0] = pi),
                        (ps[1] = pi + 11),
                        (ps[2] = pi + 10),
                        (ps[3] = pi + 9),
                        (cs[2] = ci + 1),
                        (cs[3] = ci + 2),
                        (cs[0] = ci),
                        (cs[1] = ci + 3);
                      break;
                    case 1:
                      (tmp1 = ps[12]),
                        (tmp2 = ps[13]),
                        (tmp3 = ps[14]),
                        (tmp4 = ps[15]),
                        (ps[12] = tmp4),
                        (ps[13] = pi + 0),
                        (ps[14] = pi + 1),
                        (ps[15] = pi + 2),
                        (ps[8] = tmp3),
                        (ps[11] = pi + 3),
                        (ps[4] = tmp2),
                        (ps[7] = pi + 4),
                        (ps[0] = tmp1),
                        (ps[1] = pi + 7),
                        (ps[2] = pi + 6),
                        (ps[3] = pi + 5),
                        (tmp1 = cs[2]),
                        (tmp2 = cs[3]),
                        (cs[2] = tmp2),
                        (cs[3] = ci),
                        (cs[0] = tmp1),
                        (cs[1] = ci + 1);
                      break;
                    case 2:
                      (tmp1 = ps[15]),
                        (tmp2 = ps[11]),
                        (ps[12] = ps[3]),
                        (ps[13] = pi + 0),
                        (ps[14] = pi + 1),
                        (ps[15] = pi + 2),
                        (ps[8] = ps[7]),
                        (ps[11] = pi + 3),
                        (ps[4] = tmp2),
                        (ps[7] = pi + 4),
                        (ps[0] = tmp1),
                        (ps[1] = pi + 7),
                        (ps[2] = pi + 6),
                        (ps[3] = pi + 5),
                        (tmp1 = cs[3]),
                        (cs[2] = cs[1]),
                        (cs[3] = ci),
                        (cs[0] = tmp1),
                        (cs[1] = ci + 1);
                      break;
                    case 3:
                      (ps[12] = ps[0]),
                        (ps[13] = pi + 0),
                        (ps[14] = pi + 1),
                        (ps[15] = pi + 2),
                        (ps[8] = ps[1]),
                        (ps[11] = pi + 3),
                        (ps[4] = ps[2]),
                        (ps[7] = pi + 4),
                        (ps[0] = ps[3]),
                        (ps[1] = pi + 7),
                        (ps[2] = pi + 6),
                        (ps[3] = pi + 5),
                        (cs[2] = cs[0]),
                        (cs[3] = ci),
                        (cs[0] = cs[1]),
                        (cs[1] = ci + 1);
                  }
                  (ps[5] = coords.length),
                    coords.push([
                      (-4 * coords[ps[0]][0] -
                        coords[ps[15]][0] +
                        6 * (coords[ps[4]][0] + coords[ps[1]][0]) -
                        2 * (coords[ps[12]][0] + coords[ps[3]][0]) +
                        3 * (coords[ps[13]][0] + coords[ps[7]][0])) /
                        9,
                      (-4 * coords[ps[0]][1] -
                        coords[ps[15]][1] +
                        6 * (coords[ps[4]][1] + coords[ps[1]][1]) -
                        2 * (coords[ps[12]][1] + coords[ps[3]][1]) +
                        3 * (coords[ps[13]][1] + coords[ps[7]][1])) /
                        9,
                    ]),
                    (ps[6] = coords.length),
                    coords.push([
                      (-4 * coords[ps[3]][0] -
                        coords[ps[12]][0] +
                        6 * (coords[ps[2]][0] + coords[ps[7]][0]) -
                        2 * (coords[ps[0]][0] + coords[ps[15]][0]) +
                        3 * (coords[ps[4]][0] + coords[ps[14]][0])) /
                        9,
                      (-4 * coords[ps[3]][1] -
                        coords[ps[12]][1] +
                        6 * (coords[ps[2]][1] + coords[ps[7]][1]) -
                        2 * (coords[ps[0]][1] + coords[ps[15]][1]) +
                        3 * (coords[ps[4]][1] + coords[ps[14]][1])) /
                        9,
                    ]),
                    (ps[9] = coords.length),
                    coords.push([
                      (-4 * coords[ps[12]][0] -
                        coords[ps[3]][0] +
                        6 * (coords[ps[8]][0] + coords[ps[13]][0]) -
                        2 * (coords[ps[0]][0] + coords[ps[15]][0]) +
                        3 * (coords[ps[11]][0] + coords[ps[1]][0])) /
                        9,
                      (-4 * coords[ps[12]][1] -
                        coords[ps[3]][1] +
                        6 * (coords[ps[8]][1] + coords[ps[13]][1]) -
                        2 * (coords[ps[0]][1] + coords[ps[15]][1]) +
                        3 * (coords[ps[11]][1] + coords[ps[1]][1])) /
                        9,
                    ]),
                    (ps[10] = coords.length),
                    coords.push([
                      (-4 * coords[ps[15]][0] -
                        coords[ps[0]][0] +
                        6 * (coords[ps[11]][0] + coords[ps[14]][0]) -
                        2 * (coords[ps[12]][0] + coords[ps[3]][0]) +
                        3 * (coords[ps[2]][0] + coords[ps[8]][0])) /
                        9,
                      (-4 * coords[ps[15]][1] -
                        coords[ps[0]][1] +
                        6 * (coords[ps[11]][1] + coords[ps[14]][1]) -
                        2 * (coords[ps[12]][1] + coords[ps[3]][1]) +
                        3 * (coords[ps[2]][1] + coords[ps[8]][1])) /
                        9,
                    ]),
                    mesh.figures.push({ type: "patch", coords: new Int32Array(ps), colors: new Int32Array(cs) });
                }
              }
              function decodeType7Shading(mesh, reader) {
                for (
                  var coords = mesh.coords, colors = mesh.colors, ps = new Int32Array(16), cs = new Int32Array(4);
                  reader.hasData;

                ) {
                  var f = reader.readFlag();
                  assert(0 <= f && f <= 3, "Unknown type7 flag");
                  var i,
                    ii,
                    pi = coords.length;
                  for (i = 0, ii = 0 !== f ? 12 : 16; i < ii; i++) coords.push(reader.readCoordinate());
                  var ci = colors.length;
                  for (i = 0, ii = 0 !== f ? 2 : 4; i < ii; i++) colors.push(reader.readComponents());
                  var tmp1, tmp2, tmp3, tmp4;
                  switch (f) {
                    case 0:
                      (ps[12] = pi + 3),
                        (ps[13] = pi + 4),
                        (ps[14] = pi + 5),
                        (ps[15] = pi + 6),
                        (ps[8] = pi + 2),
                        (ps[9] = pi + 13),
                        (ps[10] = pi + 14),
                        (ps[11] = pi + 7),
                        (ps[4] = pi + 1),
                        (ps[5] = pi + 12),
                        (ps[6] = pi + 15),
                        (ps[7] = pi + 8),
                        (ps[0] = pi),
                        (ps[1] = pi + 11),
                        (ps[2] = pi + 10),
                        (ps[3] = pi + 9),
                        (cs[2] = ci + 1),
                        (cs[3] = ci + 2),
                        (cs[0] = ci),
                        (cs[1] = ci + 3);
                      break;
                    case 1:
                      (tmp1 = ps[12]),
                        (tmp2 = ps[13]),
                        (tmp3 = ps[14]),
                        (tmp4 = ps[15]),
                        (ps[12] = tmp4),
                        (ps[13] = pi + 0),
                        (ps[14] = pi + 1),
                        (ps[15] = pi + 2),
                        (ps[8] = tmp3),
                        (ps[9] = pi + 9),
                        (ps[10] = pi + 10),
                        (ps[11] = pi + 3),
                        (ps[4] = tmp2),
                        (ps[5] = pi + 8),
                        (ps[6] = pi + 11),
                        (ps[7] = pi + 4),
                        (ps[0] = tmp1),
                        (ps[1] = pi + 7),
                        (ps[2] = pi + 6),
                        (ps[3] = pi + 5),
                        (tmp1 = cs[2]),
                        (tmp2 = cs[3]),
                        (cs[2] = tmp2),
                        (cs[3] = ci),
                        (cs[0] = tmp1),
                        (cs[1] = ci + 1);
                      break;
                    case 2:
                      (tmp1 = ps[15]),
                        (tmp2 = ps[11]),
                        (ps[12] = ps[3]),
                        (ps[13] = pi + 0),
                        (ps[14] = pi + 1),
                        (ps[15] = pi + 2),
                        (ps[8] = ps[7]),
                        (ps[9] = pi + 9),
                        (ps[10] = pi + 10),
                        (ps[11] = pi + 3),
                        (ps[4] = tmp2),
                        (ps[5] = pi + 8),
                        (ps[6] = pi + 11),
                        (ps[7] = pi + 4),
                        (ps[0] = tmp1),
                        (ps[1] = pi + 7),
                        (ps[2] = pi + 6),
                        (ps[3] = pi + 5),
                        (tmp1 = cs[3]),
                        (cs[2] = cs[1]),
                        (cs[3] = ci),
                        (cs[0] = tmp1),
                        (cs[1] = ci + 1);
                      break;
                    case 3:
                      (ps[12] = ps[0]),
                        (ps[13] = pi + 0),
                        (ps[14] = pi + 1),
                        (ps[15] = pi + 2),
                        (ps[8] = ps[1]),
                        (ps[9] = pi + 9),
                        (ps[10] = pi + 10),
                        (ps[11] = pi + 3),
                        (ps[4] = ps[2]),
                        (ps[5] = pi + 8),
                        (ps[6] = pi + 11),
                        (ps[7] = pi + 4),
                        (ps[0] = ps[3]),
                        (ps[1] = pi + 7),
                        (ps[2] = pi + 6),
                        (ps[3] = pi + 5),
                        (cs[2] = cs[0]),
                        (cs[3] = ci),
                        (cs[0] = cs[1]),
                        (cs[1] = ci + 1);
                  }
                  mesh.figures.push({ type: "patch", coords: new Int32Array(ps), colors: new Int32Array(cs) });
                }
              }
              function updateBounds(mesh) {
                for (
                  var minX = mesh.coords[0][0],
                    minY = mesh.coords[0][1],
                    maxX = minX,
                    maxY = minY,
                    i = 1,
                    ii = mesh.coords.length;
                  i < ii;
                  i++
                ) {
                  var x = mesh.coords[i][0],
                    y = mesh.coords[i][1];
                  (minX = minX > x ? x : minX),
                    (minY = minY > y ? y : minY),
                    (maxX = maxX < x ? x : maxX),
                    (maxY = maxY < y ? y : maxY);
                }
                mesh.bounds = [minX, minY, maxX, maxY];
              }
              function packData(mesh) {
                var i,
                  ii,
                  j,
                  jj,
                  coords = mesh.coords,
                  coordsPacked = new Float32Array(2 * coords.length);
                for (i = 0, j = 0, ii = coords.length; i < ii; i++) {
                  var xy = coords[i];
                  (coordsPacked[j++] = xy[0]), (coordsPacked[j++] = xy[1]);
                }
                mesh.coords = coordsPacked;
                var colors = mesh.colors,
                  colorsPacked = new Uint8Array(3 * colors.length);
                for (i = 0, j = 0, ii = colors.length; i < ii; i++) {
                  var c = colors[i];
                  (colorsPacked[j++] = c[0]), (colorsPacked[j++] = c[1]), (colorsPacked[j++] = c[2]);
                }
                mesh.colors = colorsPacked;
                var figures = mesh.figures;
                for (i = 0, ii = figures.length; i < ii; i++) {
                  var figure = figures[i],
                    ps = figure.coords,
                    cs = figure.colors;
                  for (j = 0, jj = ps.length; j < jj; j++) (ps[j] *= 2), (cs[j] *= 3);
                }
              }
              function Mesh(stream, matrix, xref, res) {
                assert(isStream(stream), "Mesh data is not a stream");
                var dict = stream.dict;
                (this.matrix = matrix),
                  (this.shadingType = dict.get("ShadingType")),
                  (this.type = "Pattern"),
                  (this.bbox = dict.getArray("BBox"));
                var cs = dict.get("ColorSpace", "CS");
                (cs = ColorSpace.parse(cs, xref, res)),
                  (this.cs = cs),
                  (this.background = dict.has("Background") ? cs.getRgb(dict.get("Background"), 0) : null);
                var fnObj = dict.get("Function"),
                  fn = fnObj ? PDFFunction.parseArray(xref, fnObj) : null;
                (this.coords = []), (this.colors = []), (this.figures = []);
                var decodeContext = {
                    bitsPerCoordinate: dict.get("BitsPerCoordinate"),
                    bitsPerComponent: dict.get("BitsPerComponent"),
                    bitsPerFlag: dict.get("BitsPerFlag"),
                    decode: dict.getArray("Decode"),
                    colorFn: fn,
                    colorSpace: cs,
                    numComps: fn ? 1 : cs.numComps,
                  },
                  reader = new MeshStreamReader(stream, decodeContext),
                  patchMesh = !1;
                switch (this.shadingType) {
                  case ShadingType.FREE_FORM_MESH:
                    decodeType4Shading(this, reader);
                    break;
                  case ShadingType.LATTICE_FORM_MESH:
                    var verticesPerRow = 0 | dict.get("VerticesPerRow");
                    assert(verticesPerRow >= 2, "Invalid VerticesPerRow"),
                      decodeType5Shading(this, reader, verticesPerRow);
                    break;
                  case ShadingType.COONS_PATCH_MESH:
                    decodeType6Shading(this, reader), (patchMesh = !0);
                    break;
                  case ShadingType.TENSOR_PATCH_MESH:
                    decodeType7Shading(this, reader), (patchMesh = !0);
                    break;
                  default:
                    error("Unsupported mesh type.");
                }
                if (patchMesh) {
                  updateBounds(this);
                  for (var i = 0, ii = this.figures.length; i < ii; i++) buildFigureFromPatch(this, i);
                }
                updateBounds(this), packData(this);
              }
              MeshStreamReader.prototype = {
                get hasData() {
                  if (this.stream.end) return this.stream.pos < this.stream.end;
                  if (this.bufferLength > 0) return !0;
                  var nextByte = this.stream.getByte();
                  return !(nextByte < 0) && ((this.buffer = nextByte), (this.bufferLength = 8), !0);
                },
                readBits: function (n) {
                  var buffer = this.buffer,
                    bufferLength = this.bufferLength;
                  if (32 === n) {
                    if (0 === bufferLength)
                      return (
                        ((this.stream.getByte() << 24) |
                          (this.stream.getByte() << 16) |
                          (this.stream.getByte() << 8) |
                          this.stream.getByte()) >>>
                        0
                      );
                    buffer =
                      (buffer << 24) |
                      (this.stream.getByte() << 16) |
                      (this.stream.getByte() << 8) |
                      this.stream.getByte();
                    var nextByte = this.stream.getByte();
                    return (
                      (this.buffer = nextByte & ((1 << bufferLength) - 1)),
                      ((buffer << (8 - bufferLength)) | ((255 & nextByte) >> bufferLength)) >>> 0
                    );
                  }
                  if (8 === n && 0 === bufferLength) return this.stream.getByte();
                  for (; bufferLength < n; ) (buffer = (buffer << 8) | this.stream.getByte()), (bufferLength += 8);
                  return (
                    (bufferLength -= n),
                    (this.bufferLength = bufferLength),
                    (this.buffer = buffer & ((1 << bufferLength) - 1)),
                    buffer >> bufferLength
                  );
                },
                align: function () {
                  (this.buffer = 0), (this.bufferLength = 0);
                },
                readFlag: function () {
                  return this.readBits(this.context.bitsPerFlag);
                },
                readCoordinate: function () {
                  var bitsPerCoordinate = this.context.bitsPerCoordinate,
                    xi = this.readBits(bitsPerCoordinate),
                    yi = this.readBits(bitsPerCoordinate),
                    decode = this.context.decode,
                    scale = bitsPerCoordinate < 32 ? 1 / ((1 << bitsPerCoordinate) - 1) : 2.3283064365386963e-10;
                  return [
                    xi * scale * (decode[1] - decode[0]) + decode[0],
                    yi * scale * (decode[3] - decode[2]) + decode[2],
                  ];
                },
                readComponents: function () {
                  for (
                    var numComps = this.context.numComps,
                      bitsPerComponent = this.context.bitsPerComponent,
                      scale = bitsPerComponent < 32 ? 1 / ((1 << bitsPerComponent) - 1) : 2.3283064365386963e-10,
                      decode = this.context.decode,
                      components = this.tmpCompsBuf,
                      i = 0,
                      j = 4;
                    i < numComps;
                    i++, j += 2
                  ) {
                    var ci = this.readBits(bitsPerComponent);
                    components[i] = ci * scale * (decode[j + 1] - decode[j]) + decode[j];
                  }
                  var color = this.tmpCsCompsBuf;
                  return (
                    this.context.colorFn && this.context.colorFn(components, 0, color, 0),
                    this.context.colorSpace.getRgb(color, 0)
                  );
                },
              };
              var MIN_SPLIT_PATCH_CHUNKS_AMOUNT = 3,
                MAX_SPLIT_PATCH_CHUNKS_AMOUNT = 20,
                TRIANGLE_DENSITY = 20,
                getB = (function () {
                  function buildB(count) {
                    for (var lut = [], i = 0; i <= count; i++) {
                      var t = i / count,
                        t_ = 1 - t;
                      lut.push(new Float32Array([t_ * t_ * t_, 3 * t * t_ * t_, 3 * t * t * t_, t * t * t]));
                    }
                    return lut;
                  }
                  var cache = [];
                  return function (count) {
                    return cache[count] || (cache[count] = buildB(count)), cache[count];
                  };
                })();
              return (
                (Mesh.prototype = {
                  getIR: function () {
                    return [
                      "Mesh",
                      this.shadingType,
                      this.coords,
                      this.colors,
                      this.figures,
                      this.bounds,
                      this.matrix,
                      this.bbox,
                      this.background,
                    ];
                  },
                }),
                Mesh
              );
            })()),
            (Shadings.Dummy = (function () {
              function Dummy() {
                this.type = "Pattern";
              }
              return (
                (Dummy.prototype = {
                  getIR: function () {
                    return ["Dummy"];
                  },
                }),
                Dummy
              );
            })()),
            (exports.Pattern = Pattern),
            (exports.getTilingPatternIR = getTilingPatternIR);
        })(
          (root.pdfjsCorePattern = {}),
          root.pdfjsSharedUtil,
          root.pdfjsCorePrimitives,
          root.pdfjsCoreFunction,
          root.pdfjsCoreColorSpace
        );
      })(this),
      (function (root, factory) {
        !(function (
          exports,
          sharedUtil,
          corePrimitives,
          coreStream,
          coreParser,
          coreImage,
          coreColorSpace,
          coreMurmurHash3,
          coreFonts,
          coreFunction,
          corePattern,
          coreCMap,
          coreMetrics,
          coreBidi,
          coreEncodings,
          coreStandardFonts,
          coreUnicode,
          coreGlyphList
        ) {
          var FONT_IDENTITY_MATRIX = sharedUtil.FONT_IDENTITY_MATRIX,
            IDENTITY_MATRIX = sharedUtil.IDENTITY_MATRIX,
            UNSUPPORTED_FEATURES = sharedUtil.UNSUPPORTED_FEATURES,
            ImageKind = sharedUtil.ImageKind,
            OPS = sharedUtil.OPS,
            TextRenderingMode = sharedUtil.TextRenderingMode,
            Util = sharedUtil.Util,
            assert = sharedUtil.assert,
            createPromiseCapability = sharedUtil.createPromiseCapability,
            error = sharedUtil.error,
            info = sharedUtil.info,
            isArray = sharedUtil.isArray,
            isNum = sharedUtil.isNum,
            isString = sharedUtil.isString,
            getLookupTableFactory = sharedUtil.getLookupTableFactory,
            warn = sharedUtil.warn,
            Dict = corePrimitives.Dict,
            Name = corePrimitives.Name,
            isCmd = corePrimitives.isCmd,
            isDict = corePrimitives.isDict,
            isName = corePrimitives.isName,
            isRef = corePrimitives.isRef,
            isStream = corePrimitives.isStream,
            DecodeStream = coreStream.DecodeStream,
            JpegStream = coreStream.JpegStream,
            Stream = coreStream.Stream,
            Lexer = coreParser.Lexer,
            Parser = coreParser.Parser,
            isEOF = coreParser.isEOF,
            PDFImage = coreImage.PDFImage,
            ColorSpace = coreColorSpace.ColorSpace,
            MurmurHash3_64 = coreMurmurHash3.MurmurHash3_64,
            ErrorFont = coreFonts.ErrorFont,
            FontFlags = coreFonts.FontFlags,
            Font = coreFonts.Font,
            IdentityToUnicodeMap = coreFonts.IdentityToUnicodeMap,
            ToUnicodeMap = coreFonts.ToUnicodeMap,
            getFontType = coreFonts.getFontType,
            isPDFFunction = coreFunction.isPDFFunction,
            PDFFunction = coreFunction.PDFFunction,
            Pattern = corePattern.Pattern,
            getTilingPatternIR = corePattern.getTilingPatternIR,
            CMapFactory = coreCMap.CMapFactory,
            IdentityCMap = coreCMap.IdentityCMap,
            getMetrics = coreMetrics.getMetrics,
            bidi = coreBidi.bidi,
            WinAnsiEncoding = coreEncodings.WinAnsiEncoding,
            StandardEncoding = coreEncodings.StandardEncoding,
            MacRomanEncoding = coreEncodings.MacRomanEncoding,
            SymbolSetEncoding = coreEncodings.SymbolSetEncoding,
            ZapfDingbatsEncoding = coreEncodings.ZapfDingbatsEncoding,
            getEncoding = coreEncodings.getEncoding,
            getStdFontMap = coreStandardFonts.getStdFontMap,
            getSerifFonts = coreStandardFonts.getSerifFonts,
            getSymbolsFonts = coreStandardFonts.getSymbolsFonts,
            getNormalizedUnicodes = coreUnicode.getNormalizedUnicodes,
            reverseIfRtl = coreUnicode.reverseIfRtl,
            getUnicodeForGlyph = coreUnicode.getUnicodeForGlyph,
            getGlyphsUnicode = coreGlyphList.getGlyphsUnicode,
            PartialEvaluator = (function () {
              function NativeImageDecoder(xref, resources, handler, forceDataSchema) {
                (this.xref = xref),
                  (this.resources = resources),
                  (this.handler = handler),
                  (this.forceDataSchema = forceDataSchema);
              }
              function PartialEvaluator(
                pdfManager,
                xref,
                handler,
                pageIndex,
                uniquePrefix,
                idCounters,
                fontCache,
                options
              ) {
                (this.pdfManager = pdfManager),
                  (this.xref = xref),
                  (this.handler = handler),
                  (this.pageIndex = pageIndex),
                  (this.uniquePrefix = uniquePrefix),
                  (this.idCounters = idCounters),
                  (this.fontCache = fontCache),
                  (this.options = options || DefaultPartialEvaluatorOptions);
              }
              function TimeSlotManager() {
                this.reset();
              }
              var DefaultPartialEvaluatorOptions = {
                forceDataSchema: !1,
                maxImageSize: -1,
                disableFontFace: !1,
                cMapOptions: { url: null, packed: !1 },
              };
              (NativeImageDecoder.prototype = {
                canDecode: function (image) {
                  return (
                    image instanceof JpegStream && NativeImageDecoder.isDecodable(image, this.xref, this.resources)
                  );
                },
                decode: function (image) {
                  var dict = image.dict,
                    colorSpace = dict.get("ColorSpace", "CS");
                  colorSpace = ColorSpace.parse(colorSpace, this.xref, this.resources);
                  var numComps = colorSpace.numComps;
                  return this.handler
                    .sendWithPromise("JpegDecode", [image.getIR(this.forceDataSchema), numComps])
                    .then(function (message) {
                      var data = message.data;
                      return new Stream(data, 0, data.length, image.dict);
                    });
                },
              }),
                (NativeImageDecoder.isSupported = function (image, xref, res) {
                  var dict = image.dict;
                  if (dict.has("DecodeParms") || dict.has("DP")) return !1;
                  var cs = ColorSpace.parse(dict.get("ColorSpace", "CS"), xref, res);
                  return (
                    ("DeviceGray" === cs.name || "DeviceRGB" === cs.name) &&
                    cs.isDefaultDecode(dict.getArray("Decode", "D"))
                  );
                }),
                (NativeImageDecoder.isDecodable = function (image, xref, res) {
                  var dict = image.dict;
                  if (dict.has("DecodeParms") || dict.has("DP")) return !1;
                  var cs = ColorSpace.parse(dict.get("ColorSpace", "CS"), xref, res);
                  return (1 === cs.numComps || 3 === cs.numComps) && cs.isDefaultDecode(dict.getArray("Decode", "D"));
                });
              TimeSlotManager.prototype = {
                check: function () {
                  return !(++this.checked < 100) && ((this.checked = 0), this.endTime <= Date.now());
                },
                reset: function () {
                  (this.endTime = Date.now() + 20), (this.checked = 0);
                },
              };
              var deferred = Promise.resolve();
              return (
                (PartialEvaluator.prototype = {
                  hasBlendModes: function (resources) {
                    if (!isDict(resources)) return !1;
                    var processed = Object.create(null);
                    resources.objId && (processed[resources.objId] = !0);
                    for (var nodes = [resources], xref = this.xref; nodes.length; ) {
                      var key,
                        i,
                        ii,
                        node = nodes.shift(),
                        graphicStates = node.get("ExtGState");
                      if (isDict(graphicStates)) {
                        var graphicStatesKeys = graphicStates.getKeys();
                        for (i = 0, ii = graphicStatesKeys.length; i < ii; i++) {
                          key = graphicStatesKeys[i];
                          var graphicState = graphicStates.get(key),
                            bm = graphicState.get("BM");
                          if (isName(bm) && "Normal" !== bm.name) return !0;
                        }
                      }
                      var xObjects = node.get("XObject");
                      if (isDict(xObjects)) {
                        var xObjectsKeys = xObjects.getKeys();
                        for (i = 0, ii = xObjectsKeys.length; i < ii; i++) {
                          key = xObjectsKeys[i];
                          var xObject = xObjects.getRaw(key);
                          if (isRef(xObject)) {
                            if (processed[xObject.toString()]) continue;
                            xObject = xref.fetch(xObject);
                          }
                          if (isStream(xObject)) {
                            if (xObject.dict.objId) {
                              if (processed[xObject.dict.objId]) continue;
                              processed[xObject.dict.objId] = !0;
                            }
                            var xResources = xObject.dict.get("Resources");
                            !isDict(xResources) ||
                              (xResources.objId && processed[xResources.objId]) ||
                              (nodes.push(xResources), xResources.objId && (processed[xResources.objId] = !0));
                          }
                        }
                      }
                    }
                    return !1;
                  },
                  buildFormXObject: function (resources, xobj, smask, operatorList, task, initialState) {
                    var matrix = xobj.dict.getArray("Matrix"),
                      bbox = xobj.dict.getArray("BBox"),
                      group = xobj.dict.get("Group");
                    if (group) {
                      var colorSpace,
                        groupOptions = { matrix: matrix, bbox: bbox, smask: smask, isolated: !1, knockout: !1 },
                        groupSubtype = group.get("S");
                      isName(groupSubtype, "Transparency") &&
                        ((groupOptions.isolated = group.get("I") || !1),
                        (groupOptions.knockout = group.get("K") || !1),
                        (colorSpace = group.has("CS")
                          ? ColorSpace.parse(group.get("CS"), this.xref, resources)
                          : null)),
                        smask &&
                          smask.backdrop &&
                          ((colorSpace = colorSpace || ColorSpace.singletons.rgb),
                          (smask.backdrop = colorSpace.getRgb(smask.backdrop, 0))),
                        operatorList.addOp(OPS.beginGroup, [groupOptions]);
                    }
                    return (
                      operatorList.addOp(OPS.paintFormXObjectBegin, [matrix, bbox]),
                      this.getOperatorList(
                        xobj,
                        task,
                        xobj.dict.get("Resources") || resources,
                        operatorList,
                        initialState
                      ).then(function () {
                        operatorList.addOp(OPS.paintFormXObjectEnd, []),
                          group && operatorList.addOp(OPS.endGroup, [groupOptions]);
                      })
                    );
                  },
                  buildPaintImageXObject: function (resources, image, inline, operatorList, cacheKey, imageCache) {
                    var self = this,
                      dict = image.dict,
                      w = dict.get("Width", "W"),
                      h = dict.get("Height", "H");
                    if (!(w && isNum(w) && h && isNum(h)))
                      return void warn("Image dimensions are missing, or not numbers.");
                    var maxImageSize = this.options.maxImageSize;
                    if (-1 !== maxImageSize && w * h > maxImageSize)
                      return void warn("Image exceeded maximum allowed size and was removed.");
                    var imgData,
                      args,
                      imageMask = dict.get("ImageMask", "IM") || !1;
                    if (imageMask) {
                      var width = dict.get("Width", "W"),
                        height = dict.get("Height", "H"),
                        bitStrideLength = (width + 7) >> 3,
                        imgArray = image.getBytes(bitStrideLength * height),
                        decode = dict.getArray("Decode", "D"),
                        inverseDecode = !!decode && decode[0] > 0;
                      return (
                        (imgData = PDFImage.createMask(
                          imgArray,
                          width,
                          height,
                          image instanceof DecodeStream,
                          inverseDecode
                        )),
                        (imgData.cached = !0),
                        (args = [imgData]),
                        operatorList.addOp(OPS.paintImageMaskXObject, args),
                        void (cacheKey && (imageCache[cacheKey] = { fn: OPS.paintImageMaskXObject, args: args }))
                      );
                    }
                    var softMask = dict.get("SMask", "SM") || !1,
                      mask = dict.get("Mask") || !1;
                    if (inline && !softMask && !mask && !(image instanceof JpegStream) && w + h < 200) {
                      return (
                        (imgData = new PDFImage(this.xref, resources, image, inline, null, null).createImageData(!0)),
                        void operatorList.addOp(OPS.paintInlineImageXObject, [imgData])
                      );
                    }
                    var uniquePrefix = this.uniquePrefix || "",
                      objId = "img_" + uniquePrefix + ++this.idCounters.obj;
                    if (
                      (operatorList.addDependency(objId),
                      (args = [objId, w, h]),
                      !softMask &&
                        !mask &&
                        image instanceof JpegStream &&
                        NativeImageDecoder.isSupported(image, this.xref, resources))
                    )
                      return (
                        operatorList.addOp(OPS.paintJpegXObject, args),
                        void this.handler.send("obj", [
                          objId,
                          this.pageIndex,
                          "JpegStream",
                          image.getIR(this.options.forceDataSchema),
                        ])
                      );
                    var nativeImageDecoder = null;
                    (image instanceof JpegStream || mask instanceof JpegStream || softMask instanceof JpegStream) &&
                      (nativeImageDecoder = new NativeImageDecoder(
                        self.xref,
                        resources,
                        self.handler,
                        self.options.forceDataSchema
                      )),
                      PDFImage.buildImage(self.handler, self.xref, resources, image, inline, nativeImageDecoder)
                        .then(function (imageObj) {
                          var imgData = imageObj.createImageData(!1);
                          self.handler.send("obj", [objId, self.pageIndex, "Image", imgData], [imgData.data.buffer]);
                        })
                        .then(void 0, function (reason) {
                          warn("Unable to decode image: " + reason),
                            self.handler.send("obj", [objId, self.pageIndex, "Image", null]);
                        }),
                      operatorList.addOp(OPS.paintImageXObject, args),
                      cacheKey && (imageCache[cacheKey] = { fn: OPS.paintImageXObject, args: args });
                  },
                  handleSMask: function (smask, resources, operatorList, task, stateManager) {
                    var smaskContent = smask.get("G"),
                      smaskOptions = { subtype: smask.get("S").name, backdrop: smask.get("BC") },
                      transferObj = smask.get("TR");
                    if (isPDFFunction(transferObj)) {
                      for (
                        var transferFn = PDFFunction.parse(this.xref, transferObj),
                          transferMap = new Uint8Array(256),
                          tmp = new Float32Array(1),
                          i = 0;
                        i < 256;
                        i++
                      )
                        (tmp[0] = i / 255), transferFn(tmp, 0, tmp, 0), (transferMap[i] = (255 * tmp[0]) | 0);
                      smaskOptions.transferMap = transferMap;
                    }
                    return this.buildFormXObject(
                      resources,
                      smaskContent,
                      smaskOptions,
                      operatorList,
                      task,
                      stateManager.state.clone()
                    );
                  },
                  handleTilingType: function (fn, args, resources, pattern, patternDict, operatorList, task) {
                    var tilingOpList = new OperatorList(),
                      resourcesArray = [patternDict.get("Resources"), resources],
                      patternResources = Dict.merge(this.xref, resourcesArray);
                    return this.getOperatorList(pattern, task, patternResources, tilingOpList).then(function () {
                      operatorList.addDependencies(tilingOpList.dependencies),
                        operatorList.addOp(
                          fn,
                          getTilingPatternIR(
                            { fnArray: tilingOpList.fnArray, argsArray: tilingOpList.argsArray },
                            patternDict,
                            args
                          )
                        );
                    });
                  },
                  handleSetFont: function (resources, fontArgs, fontRef, operatorList, task, state) {
                    var fontName;
                    fontArgs && ((fontArgs = fontArgs.slice()), (fontName = fontArgs[0].name));
                    var self = this;
                    return this.loadFont(fontName, fontRef, this.xref, resources)
                      .then(function (translated) {
                        return translated.font.isType3Font
                          ? translated.loadType3Data(self, resources, operatorList, task).then(
                              function () {
                                return translated;
                              },
                              function (reason) {
                                return (
                                  self.handler.send("UnsupportedFeature", { featureId: UNSUPPORTED_FEATURES.font }),
                                  new TranslatedFont(
                                    "g_font_error",
                                    new ErrorFont("Type3 font load error: " + reason),
                                    translated.font
                                  )
                                );
                              }
                            )
                          : translated;
                      })
                      .then(function (translated) {
                        return (state.font = translated.font), translated.send(self.handler), translated.loadedName;
                      });
                  },
                  handleText: function (chars, state) {
                    var font = state.font,
                      glyphs = font.charsToGlyphs(chars),
                      isAddToPathSet = !!(state.textRenderingMode & TextRenderingMode.ADD_TO_PATH_FLAG);
                    if (font.data && (isAddToPathSet || this.options.disableFontFace))
                      for (
                        var buildPath = function (fontChar) {
                            if (!font.renderer.hasBuiltPath(fontChar)) {
                              var path = font.renderer.getPathJs(fontChar);
                              this.handler.send("commonobj", [font.loadedName + "_path_" + fontChar, "FontPath", path]);
                            }
                          }.bind(this),
                          i = 0,
                          ii = glyphs.length;
                        i < ii;
                        i++
                      ) {
                        var glyph = glyphs[i];
                        buildPath(glyph.fontChar);
                        var accent = glyph.accent;
                        accent && accent.fontChar && buildPath(accent.fontChar);
                      }
                    return glyphs;
                  },
                  setGState: function (resources, gState, operatorList, task, xref, stateManager) {
                    for (
                      var gStateObj = [],
                        gStateKeys = gState.getKeys(),
                        self = this,
                        promise = Promise.resolve(),
                        i = 0,
                        ii = gStateKeys.length;
                      i < ii;
                      i++
                    ) {
                      var key = gStateKeys[i],
                        value = gState.get(key);
                      switch (key) {
                        case "Type":
                          break;
                        case "LW":
                        case "LC":
                        case "LJ":
                        case "ML":
                        case "D":
                        case "RI":
                        case "FL":
                        case "CA":
                        case "ca":
                          gStateObj.push([key, value]);
                          break;
                        case "Font":
                          promise = promise.then(function () {
                            return self
                              .handleSetFont(resources, null, value[0], operatorList, task, stateManager.state)
                              .then(function (loadedName) {
                                operatorList.addDependency(loadedName), gStateObj.push([key, [loadedName, value[1]]]);
                              });
                          });
                          break;
                        case "BM":
                          gStateObj.push([key, value]);
                          break;
                        case "SMask":
                          if (isName(value, "None")) {
                            gStateObj.push([key, !1]);
                            break;
                          }
                          isDict(value)
                            ? ((promise = promise.then(
                                function (dict) {
                                  return self.handleSMask(dict, resources, operatorList, task, stateManager);
                                }.bind(this, value)
                              )),
                              gStateObj.push([key, !0]))
                            : warn("Unsupported SMask type");
                          break;
                        case "OP":
                        case "op":
                        case "OPM":
                        case "BG":
                        case "BG2":
                        case "UCR":
                        case "UCR2":
                        case "TR":
                        case "TR2":
                        case "HT":
                        case "SM":
                        case "SA":
                        case "AIS":
                        case "TK":
                          info("graphic state operator " + key);
                          break;
                        default:
                          info("Unknown graphic state operator " + key);
                      }
                    }
                    return promise.then(function () {
                      gStateObj.length > 0 && operatorList.addOp(OPS.setGState, [gStateObj]);
                    });
                  },
                  loadFont: function (fontName, font, xref, resources) {
                    function errorFont() {
                      return Promise.resolve(
                        new TranslatedFont(
                          "g_font_error",
                          new ErrorFont("Font " + fontName + " is not available"),
                          font
                        )
                      );
                    }
                    var fontRef;
                    if (font) assert(isRef(font)), (fontRef = font);
                    else {
                      var fontRes = resources.get("Font");
                      if (!fontRes) return warn("fontRes not available"), errorFont();
                      fontRef = fontRes.getRaw(fontName);
                    }
                    if (!fontRef) return warn("fontRef not available"), errorFont();
                    if (this.fontCache.has(fontRef)) return this.fontCache.get(fontRef);
                    if (((font = xref.fetchIfRef(fontRef)), !isDict(font))) return errorFont();
                    if (font.translated) return font.translated;
                    var fontID,
                      fontCapability = createPromiseCapability(),
                      preEvaluatedFont = this.preEvaluateFont(font, xref),
                      descriptor = preEvaluatedFont.descriptor,
                      fontRefIsRef = isRef(fontRef);
                    if ((fontRefIsRef && (fontID = fontRef.toString()), isDict(descriptor))) {
                      descriptor.fontAliases || (descriptor.fontAliases = Object.create(null));
                      var fontAliases = descriptor.fontAliases,
                        hash = preEvaluatedFont.hash;
                      if (fontAliases[hash]) {
                        var aliasFontRef = fontAliases[hash].aliasRef;
                        if (fontRefIsRef && aliasFontRef && this.fontCache.has(aliasFontRef))
                          return this.fontCache.putAlias(fontRef, aliasFontRef), this.fontCache.get(fontRef);
                      } else fontAliases[hash] = { fontID: Font.getFontID() };
                      fontRefIsRef && (fontAliases[hash].aliasRef = fontRef), (fontID = fontAliases[hash].fontID);
                    }
                    fontRefIsRef
                      ? this.fontCache.put(fontRef, fontCapability.promise)
                      : (fontID || (fontID = (this.uniquePrefix || "F_") + ++this.idCounters.obj),
                        this.fontCache.put("id_" + fontID, fontCapability.promise)),
                      assert(fontID, 'The "fontID" must be defined.'),
                      (font.loadedName = "g_" + this.pdfManager.docId + "_f" + fontID),
                      (font.translated = fontCapability.promise);
                    var translatedPromise;
                    try {
                      translatedPromise = this.translateFont(preEvaluatedFont, xref);
                    } catch (e) {
                      translatedPromise = Promise.reject(e);
                    }
                    var self = this;
                    return (
                      translatedPromise.then(
                        function (translatedFont) {
                          if (void 0 !== translatedFont.fontType) {
                            xref.stats.fontTypes[translatedFont.fontType] = !0;
                          }
                          fontCapability.resolve(new TranslatedFont(font.loadedName, translatedFont, font));
                        },
                        function (reason) {
                          self.handler.send("UnsupportedFeature", { featureId: UNSUPPORTED_FEATURES.font });
                          try {
                            var descriptor = preEvaluatedFont.descriptor,
                              fontFile3 = descriptor && descriptor.get("FontFile3"),
                              subtype = fontFile3 && fontFile3.get("Subtype"),
                              fontType = getFontType(preEvaluatedFont.type, subtype && subtype.name);
                            xref.stats.fontTypes[fontType] = !0;
                          } catch (ex) {}
                          fontCapability.resolve(
                            new TranslatedFont(
                              font.loadedName,
                              new ErrorFont(reason instanceof Error ? reason.message : reason),
                              font
                            )
                          );
                        }
                      ),
                      fontCapability.promise
                    );
                  },
                  buildPath: function (operatorList, fn, args) {
                    var lastIndex = operatorList.length - 1;
                    if ((args || (args = []), lastIndex < 0 || operatorList.fnArray[lastIndex] !== OPS.constructPath))
                      operatorList.addOp(OPS.constructPath, [[fn], args]);
                    else {
                      var opArgs = operatorList.argsArray[lastIndex];
                      opArgs[0].push(fn), Array.prototype.push.apply(opArgs[1], args);
                    }
                  },
                  handleColorN: function (operatorList, fn, args, cs, patterns, resources, task, xref) {
                    var pattern,
                      patternName = args[args.length - 1];
                    if (isName(patternName) && (pattern = patterns.get(patternName.name))) {
                      var dict = isStream(pattern) ? pattern.dict : pattern,
                        typeNum = dict.get("PatternType");
                      if (1 === typeNum) {
                        var color = cs.base ? cs.base.getRgb(args, 0) : null;
                        return this.handleTilingType(fn, color, resources, pattern, dict, operatorList, task);
                      }
                      if (2 === typeNum) {
                        var shading = dict.get("Shading"),
                          matrix = dict.getArray("Matrix");
                        return (
                          (pattern = Pattern.parseShading(shading, matrix, xref, resources, this.handler)),
                          operatorList.addOp(fn, pattern.getIR()),
                          Promise.resolve()
                        );
                      }
                      return Promise.reject("Unknown PatternType: " + typeNum);
                    }
                    return operatorList.addOp(fn, args), Promise.resolve();
                  },
                  getOperatorList: function (stream, task, resources, operatorList, initialState) {
                    var self = this,
                      xref = this.xref,
                      imageCache = Object.create(null);
                    assert(operatorList), (resources = resources || Dict.empty);
                    var xobjs = resources.get("XObject") || Dict.empty,
                      patterns = resources.get("Pattern") || Dict.empty,
                      stateManager = new StateManager(initialState || new EvalState()),
                      preprocessor = new EvaluatorPreprocessor(stream, xref, stateManager),
                      timeSlotManager = new TimeSlotManager();
                    return new Promise(function promiseBody(resolve, reject) {
                      var next = function (promise) {
                        promise.then(function () {
                          try {
                            promiseBody(resolve, reject);
                          } catch (ex) {
                            reject(ex);
                          }
                        }, reject);
                      };
                      task.ensureNotTerminated(), timeSlotManager.reset();
                      for (
                        var stop, i, ii, cs, operation = {};
                        !(stop = timeSlotManager.check()) && ((operation.args = null), preprocessor.read(operation));

                      ) {
                        var args = operation.args,
                          fn = operation.fn;
                        switch (0 | fn) {
                          case OPS.paintXObject:
                            if (args[0].code) break;
                            var name = args[0].name;
                            if (!name) {
                              warn("XObject must be referred to by name.");
                              continue;
                            }
                            if (void 0 !== imageCache[name]) {
                              operatorList.addOp(imageCache[name].fn, imageCache[name].args), (args = null);
                              continue;
                            }
                            var xobj = xobjs.get(name);
                            if (xobj) {
                              assert(isStream(xobj), "XObject should be a stream");
                              var type = xobj.dict.get("Subtype");
                              if ((assert(isName(type), "XObject should have a Name subtype"), "Form" === type.name))
                                return (
                                  stateManager.save(),
                                  void next(
                                    self
                                      .buildFormXObject(
                                        resources,
                                        xobj,
                                        null,
                                        operatorList,
                                        task,
                                        stateManager.state.clone()
                                      )
                                      .then(function () {
                                        stateManager.restore();
                                      })
                                  )
                                );
                              if ("Image" === type.name) {
                                self.buildPaintImageXObject(resources, xobj, !1, operatorList, name, imageCache),
                                  (args = null);
                                continue;
                              }
                              if ("PS" === type.name) {
                                info("Ignored XObject subtype PS");
                                continue;
                              }
                              error("Unhandled XObject subtype " + type.name);
                            }
                            break;
                          case OPS.setFont:
                            var fontSize = args[1];
                            return void next(
                              self
                                .handleSetFont(resources, args, null, operatorList, task, stateManager.state)
                                .then(function (loadedName) {
                                  operatorList.addDependency(loadedName),
                                    operatorList.addOp(OPS.setFont, [loadedName, fontSize]);
                                })
                            );
                          case OPS.endInlineImage:
                            var cacheKey = args[0].cacheKey;
                            if (cacheKey) {
                              var cacheEntry = imageCache[cacheKey];
                              if (void 0 !== cacheEntry) {
                                operatorList.addOp(cacheEntry.fn, cacheEntry.args), (args = null);
                                continue;
                              }
                            }
                            self.buildPaintImageXObject(resources, args[0], !0, operatorList, cacheKey, imageCache),
                              (args = null);
                            continue;
                          case OPS.showText:
                            args[0] = self.handleText(args[0], stateManager.state);
                            break;
                          case OPS.showSpacedText:
                            var arr = args[0],
                              combinedGlyphs = [],
                              arrLength = arr.length,
                              state = stateManager.state;
                            for (i = 0; i < arrLength; ++i) {
                              var arrItem = arr[i];
                              isString(arrItem)
                                ? Array.prototype.push.apply(combinedGlyphs, self.handleText(arrItem, state))
                                : isNum(arrItem) && combinedGlyphs.push(arrItem);
                            }
                            (args[0] = combinedGlyphs), (fn = OPS.showText);
                            break;
                          case OPS.nextLineShowText:
                            operatorList.addOp(OPS.nextLine),
                              (args[0] = self.handleText(args[0], stateManager.state)),
                              (fn = OPS.showText);
                            break;
                          case OPS.nextLineSetSpacingShowText:
                            operatorList.addOp(OPS.nextLine),
                              operatorList.addOp(OPS.setWordSpacing, [args.shift()]),
                              operatorList.addOp(OPS.setCharSpacing, [args.shift()]),
                              (args[0] = self.handleText(args[0], stateManager.state)),
                              (fn = OPS.showText);
                            break;
                          case OPS.setTextRenderingMode:
                            stateManager.state.textRenderingMode = args[0];
                            break;
                          case OPS.setFillColorSpace:
                            stateManager.state.fillColorSpace = ColorSpace.parse(args[0], xref, resources);
                            continue;
                          case OPS.setStrokeColorSpace:
                            stateManager.state.strokeColorSpace = ColorSpace.parse(args[0], xref, resources);
                            continue;
                          case OPS.setFillColor:
                            (cs = stateManager.state.fillColorSpace),
                              (args = cs.getRgb(args, 0)),
                              (fn = OPS.setFillRGBColor);
                            break;
                          case OPS.setStrokeColor:
                            (cs = stateManager.state.strokeColorSpace),
                              (args = cs.getRgb(args, 0)),
                              (fn = OPS.setStrokeRGBColor);
                            break;
                          case OPS.setFillGray:
                            (stateManager.state.fillColorSpace = ColorSpace.singletons.gray),
                              (args = ColorSpace.singletons.gray.getRgb(args, 0)),
                              (fn = OPS.setFillRGBColor);
                            break;
                          case OPS.setStrokeGray:
                            (stateManager.state.strokeColorSpace = ColorSpace.singletons.gray),
                              (args = ColorSpace.singletons.gray.getRgb(args, 0)),
                              (fn = OPS.setStrokeRGBColor);
                            break;
                          case OPS.setFillCMYKColor:
                            (stateManager.state.fillColorSpace = ColorSpace.singletons.cmyk),
                              (args = ColorSpace.singletons.cmyk.getRgb(args, 0)),
                              (fn = OPS.setFillRGBColor);
                            break;
                          case OPS.setStrokeCMYKColor:
                            (stateManager.state.strokeColorSpace = ColorSpace.singletons.cmyk),
                              (args = ColorSpace.singletons.cmyk.getRgb(args, 0)),
                              (fn = OPS.setStrokeRGBColor);
                            break;
                          case OPS.setFillRGBColor:
                            (stateManager.state.fillColorSpace = ColorSpace.singletons.rgb),
                              (args = ColorSpace.singletons.rgb.getRgb(args, 0));
                            break;
                          case OPS.setStrokeRGBColor:
                            (stateManager.state.strokeColorSpace = ColorSpace.singletons.rgb),
                              (args = ColorSpace.singletons.rgb.getRgb(args, 0));
                            break;
                          case OPS.setFillColorN:
                            if (((cs = stateManager.state.fillColorSpace), "Pattern" === cs.name))
                              return void next(
                                self.handleColorN(
                                  operatorList,
                                  OPS.setFillColorN,
                                  args,
                                  cs,
                                  patterns,
                                  resources,
                                  task,
                                  xref
                                )
                              );
                            (args = cs.getRgb(args, 0)), (fn = OPS.setFillRGBColor);
                            break;
                          case OPS.setStrokeColorN:
                            if (((cs = stateManager.state.strokeColorSpace), "Pattern" === cs.name))
                              return void next(
                                self.handleColorN(
                                  operatorList,
                                  OPS.setStrokeColorN,
                                  args,
                                  cs,
                                  patterns,
                                  resources,
                                  task,
                                  xref
                                )
                              );
                            (args = cs.getRgb(args, 0)), (fn = OPS.setStrokeRGBColor);
                            break;
                          case OPS.shadingFill:
                            var shadingRes = resources.get("Shading");
                            shadingRes || error("No shading resource found");
                            var shading = shadingRes.get(args[0].name);
                            shading || error("No shading object found");
                            (args = [Pattern.parseShading(shading, null, xref, resources, self.handler).getIR()]),
                              (fn = OPS.shadingFill);
                            break;
                          case OPS.setGState:
                            var dictName = args[0],
                              extGState = resources.get("ExtGState");
                            if (!isDict(extGState) || !extGState.has(dictName.name)) break;
                            var gState = extGState.get(dictName.name);
                            return void next(self.setGState(resources, gState, operatorList, task, xref, stateManager));
                          case OPS.moveTo:
                          case OPS.lineTo:
                          case OPS.curveTo:
                          case OPS.curveTo2:
                          case OPS.curveTo3:
                          case OPS.closePath:
                          case OPS.rectangle:
                            self.buildPath(operatorList, fn, args);
                            continue;
                          case OPS.markPoint:
                          case OPS.markPointProps:
                          case OPS.beginMarkedContent:
                          case OPS.beginMarkedContentProps:
                          case OPS.endMarkedContent:
                          case OPS.beginCompat:
                          case OPS.endCompat:
                            continue;
                          default:
                            if (null !== args) {
                              for (i = 0, ii = args.length; i < ii && !(args[i] instanceof Dict); i++);
                              if (i < ii) {
                                warn("getOperatorList - ignoring operator: " + fn);
                                continue;
                              }
                            }
                        }
                        operatorList.addOp(fn, args);
                      }
                      if (stop) return void next(deferred);
                      for (i = 0, ii = preprocessor.savedStatesDepth; i < ii; i++) operatorList.addOp(OPS.restore, []);
                      resolve();
                    });
                  },
                  getTextContent: function (
                    stream,
                    task,
                    resources,
                    stateManager,
                    normalizeWhitespace,
                    combineTextItems
                  ) {
                    function ensureTextContentItem() {
                      if (textContentItem.initialized) return textContentItem;
                      var font = textState.font;
                      font.loadedName in textContent.styles ||
                        (textContent.styles[font.loadedName] = {
                          fontFamily: font.fallbackName,
                          ascent: font.ascent,
                          descent: font.descent,
                          vertical: font.vertical,
                        }),
                        (textContentItem.fontName = font.loadedName);
                      var tsm = [
                        textState.fontSize * textState.textHScale,
                        0,
                        0,
                        textState.fontSize,
                        0,
                        textState.textRise,
                      ];
                      if (
                        font.isType3Font &&
                        textState.fontMatrix !== FONT_IDENTITY_MATRIX &&
                        1 === textState.fontSize
                      ) {
                        var glyphHeight = font.bbox[3] - font.bbox[1];
                        glyphHeight > 0 && ((glyphHeight *= textState.fontMatrix[3]), (tsm[3] *= glyphHeight));
                      }
                      var trm = Util.transform(textState.ctm, Util.transform(textState.textMatrix, tsm));
                      (textContentItem.transform = trm),
                        font.vertical
                          ? ((textContentItem.width = Math.sqrt(trm[0] * trm[0] + trm[1] * trm[1])),
                            (textContentItem.height = 0),
                            (textContentItem.vertical = !0))
                          : ((textContentItem.width = 0),
                            (textContentItem.height = Math.sqrt(trm[2] * trm[2] + trm[3] * trm[3])),
                            (textContentItem.vertical = !1));
                      var a = textState.textLineMatrix[0],
                        b = textState.textLineMatrix[1],
                        scaleLineX = Math.sqrt(a * a + b * b);
                      (a = textState.ctm[0]), (b = textState.ctm[1]);
                      var scaleCtmX = Math.sqrt(a * a + b * b);
                      (textContentItem.textAdvanceScale = scaleCtmX * scaleLineX),
                        (textContentItem.lastAdvanceWidth = 0),
                        (textContentItem.lastAdvanceHeight = 0);
                      var spaceWidth = (font.spaceWidth / 1e3) * textState.fontSize;
                      return (
                        spaceWidth
                          ? ((textContentItem.spaceWidth = spaceWidth),
                            (textContentItem.fakeSpaceMin = spaceWidth * SPACE_FACTOR),
                            (textContentItem.fakeMultiSpaceMin = spaceWidth * MULTI_SPACE_FACTOR),
                            (textContentItem.fakeMultiSpaceMax = spaceWidth * MULTI_SPACE_FACTOR_MAX),
                            (textContentItem.textRunBreakAllowed = !font.isMonospace))
                          : ((textContentItem.spaceWidth = 0),
                            (textContentItem.fakeSpaceMin = 1 / 0),
                            (textContentItem.fakeMultiSpaceMin = 1 / 0),
                            (textContentItem.fakeMultiSpaceMax = 0),
                            (textContentItem.textRunBreakAllowed = !1)),
                        (textContentItem.initialized = !0),
                        textContentItem
                      );
                    }
                    function replaceWhitespace(str) {
                      for (
                        var code, i = 0, ii = str.length;
                        i < ii && (code = str.charCodeAt(i)) >= 32 && code <= 127;

                      )
                        i++;
                      return i < ii ? str.replace(WhitespaceRegexp, " ") : str;
                    }
                    function runBidiTransform(textChunk) {
                      var str = textChunk.str.join(""),
                        bidiResult = bidi(str, -1, textChunk.vertical);
                      return {
                        str: normalizeWhitespace ? replaceWhitespace(bidiResult.str) : bidiResult.str,
                        dir: bidiResult.dir,
                        width: textChunk.width,
                        height: textChunk.height,
                        transform: textChunk.transform,
                        fontName: textChunk.fontName,
                      };
                    }
                    function handleSetFont(fontName, fontRef) {
                      return self.loadFont(fontName, fontRef, xref, resources).then(function (translated) {
                        (textState.font = translated.font),
                          (textState.fontMatrix = translated.font.fontMatrix || FONT_IDENTITY_MATRIX);
                      });
                    }
                    function buildTextContentItem(chars) {
                      for (
                        var font = textState.font,
                          textChunk = ensureTextContentItem(),
                          width = 0,
                          height = 0,
                          glyphs = font.charsToGlyphs(chars),
                          defaultVMetrics = font.defaultVMetrics,
                          i = 0;
                        i < glyphs.length;
                        i++
                      ) {
                        var glyph = glyphs[i],
                          glyphWidth = null;
                        font.vertical
                          ? glyph.vmetric
                            ? ((glyphWidth = glyph.vmetric[0]), glyph.vmetric[1], glyph.vmetric[2])
                            : ((glyphWidth = glyph.width), 0.5 * glyph.width, defaultVMetrics[2])
                          : (glyphWidth = glyph.width);
                        var glyphUnicode = glyph.unicode,
                          NormalizedUnicodes = getNormalizedUnicodes();
                        void 0 !== NormalizedUnicodes[glyphUnicode] &&
                          (glyphUnicode = NormalizedUnicodes[glyphUnicode]),
                          (glyphUnicode = reverseIfRtl(glyphUnicode));
                        var charSpacing = textState.charSpacing;
                        if (glyph.isSpace) {
                          var wordSpacing = textState.wordSpacing;
                          (charSpacing += wordSpacing), wordSpacing > 0 && addFakeSpaces(wordSpacing, textChunk.str);
                        }
                        var tx = 0,
                          ty = 0;
                        if (font.vertical) {
                          (ty = glyphWidth * textState.fontMatrix[0] * textState.fontSize + charSpacing),
                            (height += ty);
                        } else {
                          (tx =
                            (glyphWidth * textState.fontMatrix[0] * textState.fontSize + charSpacing) *
                            textState.textHScale),
                            (width += tx);
                        }
                        textState.translateTextMatrix(tx, ty), textChunk.str.push(glyphUnicode);
                      }
                      return (
                        font.vertical
                          ? ((textChunk.lastAdvanceHeight = height),
                            (textChunk.height += Math.abs(height * textChunk.textAdvanceScale)))
                          : ((textChunk.lastAdvanceWidth = width),
                            (textChunk.width += width * textChunk.textAdvanceScale)),
                        textChunk
                      );
                    }
                    function addFakeSpaces(width, strBuf) {
                      if (!(width < textContentItem.fakeSpaceMin)) {
                        if (width < textContentItem.fakeMultiSpaceMin) return void strBuf.push(" ");
                        for (var fakeSpaces = Math.round(width / textContentItem.spaceWidth); fakeSpaces-- > 0; )
                          strBuf.push(" ");
                      }
                    }
                    function flushTextContentItem() {
                      textContentItem.initialized &&
                        (textContent.items.push(runBidiTransform(textContentItem)),
                        (textContentItem.initialized = !1),
                        (textContentItem.str.length = 0));
                    }
                    stateManager = stateManager || new StateManager(new TextState());
                    var WhitespaceRegexp = /\s/g,
                      textContent = { items: [], styles: Object.create(null) },
                      textContentItem = {
                        initialized: !1,
                        str: [],
                        width: 0,
                        height: 0,
                        vertical: !1,
                        lastAdvanceWidth: 0,
                        lastAdvanceHeight: 0,
                        textAdvanceScale: 0,
                        spaceWidth: 0,
                        fakeSpaceMin: 1 / 0,
                        fakeMultiSpaceMin: 1 / 0,
                        fakeMultiSpaceMax: -0,
                        textRunBreakAllowed: !1,
                        transform: null,
                        fontName: null,
                      },
                      SPACE_FACTOR = 0.3,
                      MULTI_SPACE_FACTOR = 1.5,
                      MULTI_SPACE_FACTOR_MAX = 4,
                      self = this,
                      xref = this.xref;
                    resources = xref.fetchIfRef(resources) || Dict.empty;
                    var textState,
                      xobjs = null,
                      xobjsCache = Object.create(null),
                      preprocessor = new EvaluatorPreprocessor(stream, xref, stateManager),
                      timeSlotManager = new TimeSlotManager();
                    return new Promise(function promiseBody(resolve, reject) {
                      var next = function (promise) {
                        promise.then(function () {
                          try {
                            promiseBody(resolve, reject);
                          } catch (ex) {
                            reject(ex);
                          }
                        }, reject);
                      };
                      task.ensureNotTerminated(), timeSlotManager.reset();
                      for (
                        var stop, operation = {}, args = [];
                        !(stop = timeSlotManager.check()) &&
                        ((args.length = 0), (operation.args = args), preprocessor.read(operation));

                      ) {
                        textState = stateManager.state;
                        var fn = operation.fn;
                        args = operation.args;
                        var advance, diff;
                        switch (0 | fn) {
                          case OPS.setFont:
                            var fontNameArg = args[0].name,
                              fontSizeArg = args[1];
                            if (
                              textState.font &&
                              fontNameArg === textState.fontName &&
                              fontSizeArg === textState.fontSize
                            )
                              break;
                            return (
                              flushTextContentItem(),
                              (textState.fontName = fontNameArg),
                              (textState.fontSize = fontSizeArg),
                              void next(handleSetFont(fontNameArg, null))
                            );
                          case OPS.setTextRise:
                            flushTextContentItem(), (textState.textRise = args[0]);
                            break;
                          case OPS.setHScale:
                            flushTextContentItem(), (textState.textHScale = args[0] / 100);
                            break;
                          case OPS.setLeading:
                            flushTextContentItem(), (textState.leading = args[0]);
                            break;
                          case OPS.moveText:
                            var isSameTextLine =
                              !!textState.font && 0 === (textState.font.vertical ? args[0] : args[1]);
                            if (
                              ((advance = args[0] - args[1]),
                              combineTextItems &&
                                isSameTextLine &&
                                textContentItem.initialized &&
                                advance > 0 &&
                                advance <= textContentItem.fakeMultiSpaceMax)
                            ) {
                              textState.translateTextLineMatrix(args[0], args[1]),
                                (textContentItem.width += args[0] - textContentItem.lastAdvanceWidth),
                                (textContentItem.height += args[1] - textContentItem.lastAdvanceHeight),
                                (diff =
                                  args[0] -
                                  textContentItem.lastAdvanceWidth -
                                  (args[1] - textContentItem.lastAdvanceHeight)),
                                addFakeSpaces(diff, textContentItem.str);
                              break;
                            }
                            flushTextContentItem(),
                              textState.translateTextLineMatrix(args[0], args[1]),
                              (textState.textMatrix = textState.textLineMatrix.slice());
                            break;
                          case OPS.setLeadingMoveText:
                            flushTextContentItem(),
                              (textState.leading = -args[1]),
                              textState.translateTextLineMatrix(args[0], args[1]),
                              (textState.textMatrix = textState.textLineMatrix.slice());
                            break;
                          case OPS.nextLine:
                            flushTextContentItem(), textState.carriageReturn();
                            break;
                          case OPS.setTextMatrix:
                            if (
                              ((advance = textState.calcTextLineMatrixAdvance(
                                args[0],
                                args[1],
                                args[2],
                                args[3],
                                args[4],
                                args[5]
                              )),
                              combineTextItems &&
                                null !== advance &&
                                textContentItem.initialized &&
                                advance.value > 0 &&
                                advance.value <= textContentItem.fakeMultiSpaceMax)
                            ) {
                              textState.translateTextLineMatrix(advance.width, advance.height),
                                (textContentItem.width += advance.width - textContentItem.lastAdvanceWidth),
                                (textContentItem.height += advance.height - textContentItem.lastAdvanceHeight),
                                (diff =
                                  advance.width -
                                  textContentItem.lastAdvanceWidth -
                                  (advance.height - textContentItem.lastAdvanceHeight)),
                                addFakeSpaces(diff, textContentItem.str);
                              break;
                            }
                            flushTextContentItem(),
                              textState.setTextMatrix(args[0], args[1], args[2], args[3], args[4], args[5]),
                              textState.setTextLineMatrix(args[0], args[1], args[2], args[3], args[4], args[5]);
                            break;
                          case OPS.setCharSpacing:
                            textState.charSpacing = args[0];
                            break;
                          case OPS.setWordSpacing:
                            textState.wordSpacing = args[0];
                            break;
                          case OPS.beginText:
                            flushTextContentItem(),
                              (textState.textMatrix = IDENTITY_MATRIX.slice()),
                              (textState.textLineMatrix = IDENTITY_MATRIX.slice());
                            break;
                          case OPS.showSpacedText:
                            for (var offset, items = args[0], j = 0, jj = items.length; j < jj; j++)
                              if ("string" == typeof items[j]) buildTextContentItem(items[j]);
                              else {
                                ensureTextContentItem(), (advance = (items[j] * textState.fontSize) / 1e3);
                                var breakTextRun = !1;
                                textState.font.vertical
                                  ? ((offset =
                                      advance *
                                      (textState.textHScale * textState.textMatrix[2] + textState.textMatrix[3])),
                                    textState.translateTextMatrix(0, advance),
                                    (breakTextRun =
                                      textContentItem.textRunBreakAllowed &&
                                      advance > textContentItem.fakeMultiSpaceMax) ||
                                      (textContentItem.height += offset))
                                  : ((advance = -advance),
                                    (offset =
                                      advance *
                                      (textState.textHScale * textState.textMatrix[0] + textState.textMatrix[1])),
                                    textState.translateTextMatrix(advance, 0),
                                    (breakTextRun =
                                      textContentItem.textRunBreakAllowed &&
                                      advance > textContentItem.fakeMultiSpaceMax) ||
                                      (textContentItem.width += offset)),
                                  breakTextRun
                                    ? flushTextContentItem()
                                    : advance > 0 && addFakeSpaces(advance, textContentItem.str);
                              }
                            break;
                          case OPS.showText:
                            buildTextContentItem(args[0]);
                            break;
                          case OPS.nextLineShowText:
                            flushTextContentItem(), textState.carriageReturn(), buildTextContentItem(args[0]);
                            break;
                          case OPS.nextLineSetSpacingShowText:
                            flushTextContentItem(),
                              (textState.wordSpacing = args[0]),
                              (textState.charSpacing = args[1]),
                              textState.carriageReturn(),
                              buildTextContentItem(args[2]);
                            break;
                          case OPS.paintXObject:
                            if ((flushTextContentItem(), args[0].code)) break;
                            xobjs || (xobjs = resources.get("XObject") || Dict.empty);
                            var name = args[0].name;
                            if (xobjsCache.key === name) {
                              xobjsCache.texts &&
                                (Util.appendToArray(textContent.items, xobjsCache.texts.items),
                                Util.extendObj(textContent.styles, xobjsCache.texts.styles));
                              break;
                            }
                            var xobj = xobjs.get(name);
                            if (!xobj) break;
                            assert(isStream(xobj), "XObject should be a stream");
                            var type = xobj.dict.get("Subtype");
                            if ((assert(isName(type), "XObject should have a Name subtype"), "Form" !== type.name)) {
                              (xobjsCache.key = name), (xobjsCache.texts = null);
                              break;
                            }
                            stateManager.save();
                            var matrix = xobj.dict.getArray("Matrix");
                            return (
                              isArray(matrix) && 6 === matrix.length && stateManager.transform(matrix),
                              void next(
                                self
                                  .getTextContent(
                                    xobj,
                                    task,
                                    xobj.dict.get("Resources") || resources,
                                    stateManager,
                                    normalizeWhitespace,
                                    combineTextItems
                                  )
                                  .then(function (formTextContent) {
                                    Util.appendToArray(textContent.items, formTextContent.items),
                                      Util.extendObj(textContent.styles, formTextContent.styles),
                                      stateManager.restore(),
                                      (xobjsCache.key = name),
                                      (xobjsCache.texts = formTextContent);
                                  })
                              )
                            );
                          case OPS.setGState:
                            flushTextContentItem();
                            var dictName = args[0],
                              extGState = resources.get("ExtGState");
                            if (!isDict(extGState) || !isName(dictName)) break;
                            var gState = extGState.get(dictName.name);
                            if (!isDict(gState)) break;
                            var gStateFont = gState.get("Font");
                            if (gStateFont)
                              return (
                                (textState.fontName = null),
                                (textState.fontSize = gStateFont[1]),
                                void next(handleSetFont(null, gStateFont[0]))
                              );
                        }
                      }
                      if (stop) return void next(deferred);
                      flushTextContentItem(), resolve(textContent);
                    });
                  },
                  extractDataStructures: function (dict, baseDict, xref, properties) {
                    var toUnicode = dict.get("ToUnicode") || baseDict.get("ToUnicode"),
                      toUnicodePromise = toUnicode ? this.readToUnicode(toUnicode) : Promise.resolve(void 0);
                    if (properties.composite) {
                      var cidSystemInfo = dict.get("CIDSystemInfo");
                      isDict(cidSystemInfo) &&
                        (properties.cidSystemInfo = {
                          registry: cidSystemInfo.get("Registry"),
                          ordering: cidSystemInfo.get("Ordering"),
                          supplement: cidSystemInfo.get("Supplement"),
                        });
                      var cidToGidMap = dict.get("CIDToGIDMap");
                      isStream(cidToGidMap) && (properties.cidToGidMap = this.readCidToGidMap(cidToGidMap));
                    }
                    var encoding,
                      differences = [],
                      baseEncodingName = null;
                    if (dict.has("Encoding")) {
                      if (((encoding = dict.get("Encoding")), isDict(encoding))) {
                        if (
                          ((baseEncodingName = encoding.get("BaseEncoding")),
                          (baseEncodingName = isName(baseEncodingName) ? baseEncodingName.name : null),
                          encoding.has("Differences"))
                        )
                          for (
                            var diffEncoding = encoding.get("Differences"), index = 0, j = 0, jj = diffEncoding.length;
                            j < jj;
                            j++
                          ) {
                            var data = xref.fetchIfRef(diffEncoding[j]);
                            isNum(data)
                              ? (index = data)
                              : isName(data)
                              ? (differences[index++] = data.name)
                              : error("Invalid entry in 'Differences' array: " + data);
                          }
                      } else
                        isName(encoding)
                          ? (baseEncodingName = encoding.name)
                          : error("Encoding is not a Name nor a Dict");
                      "MacRomanEncoding" !== baseEncodingName &&
                        "MacExpertEncoding" !== baseEncodingName &&
                        "WinAnsiEncoding" !== baseEncodingName &&
                        (baseEncodingName = null);
                    }
                    return (
                      baseEncodingName
                        ? (properties.defaultEncoding = getEncoding(baseEncodingName).slice())
                        : ((encoding = "TrueType" === properties.type ? WinAnsiEncoding : StandardEncoding),
                          properties.flags & FontFlags.Symbolic &&
                            ((encoding = MacRomanEncoding),
                            properties.file ||
                              (/Symbol/i.test(properties.name)
                                ? (encoding = SymbolSetEncoding)
                                : /Dingbats/i.test(properties.name) && (encoding = ZapfDingbatsEncoding))),
                          (properties.defaultEncoding = encoding)),
                      (properties.differences = differences),
                      (properties.baseEncodingName = baseEncodingName),
                      (properties.hasEncoding = !!baseEncodingName || differences.length > 0),
                      (properties.dict = dict),
                      toUnicodePromise
                        .then(
                          function (toUnicode) {
                            return (properties.toUnicode = toUnicode), this.buildToUnicode(properties);
                          }.bind(this)
                        )
                        .then(function (toUnicode) {
                          return (properties.toUnicode = toUnicode), properties;
                        })
                    );
                  },
                  buildToUnicode: function (properties) {
                    if (
                      ((properties.hasIncludedToUnicodeMap = !!properties.toUnicode && properties.toUnicode.length > 0),
                      properties.hasIncludedToUnicodeMap)
                    )
                      return Promise.resolve(properties.toUnicode);
                    var toUnicode, charcode, glyphName;
                    if (!properties.composite) {
                      toUnicode = [];
                      var encoding = properties.defaultEncoding.slice(),
                        baseEncodingName = properties.baseEncodingName,
                        differences = properties.differences;
                      for (charcode in differences)
                        ".notdef" !== (glyphName = differences[charcode]) && (encoding[charcode] = glyphName);
                      var glyphsUnicodeMap = getGlyphsUnicode();
                      for (charcode in encoding)
                        if ("" !== (glyphName = encoding[charcode]))
                          if (void 0 !== glyphsUnicodeMap[glyphName])
                            toUnicode[charcode] = String.fromCharCode(glyphsUnicodeMap[glyphName]);
                          else {
                            var code = 0;
                            switch (glyphName[0]) {
                              case "G":
                                3 === glyphName.length && (code = parseInt(glyphName.substr(1), 16));
                                break;
                              case "g":
                                5 === glyphName.length && (code = parseInt(glyphName.substr(1), 16));
                                break;
                              case "C":
                              case "c":
                                glyphName.length >= 3 && (code = +glyphName.substr(1));
                                break;
                              default:
                                var unicode = getUnicodeForGlyph(glyphName, glyphsUnicodeMap);
                                -1 !== unicode && (code = unicode);
                            }
                            if (code) {
                              if (baseEncodingName && code === +charcode) {
                                var baseEncoding = getEncoding(baseEncodingName);
                                if (baseEncoding && (glyphName = baseEncoding[charcode])) {
                                  toUnicode[charcode] = String.fromCharCode(glyphsUnicodeMap[glyphName]);
                                  continue;
                                }
                              }
                              toUnicode[charcode] = String.fromCharCode(code);
                            }
                          }
                      return Promise.resolve(new ToUnicodeMap(toUnicode));
                    }
                    if (
                      properties.composite &&
                      ((properties.cMap.builtInCMap && !(properties.cMap instanceof IdentityCMap)) ||
                        ("Adobe" === properties.cidSystemInfo.registry &&
                          ("GB1" === properties.cidSystemInfo.ordering ||
                            "CNS1" === properties.cidSystemInfo.ordering ||
                            "Japan1" === properties.cidSystemInfo.ordering ||
                            "Korea1" === properties.cidSystemInfo.ordering)))
                    ) {
                      var registry = properties.cidSystemInfo.registry,
                        ordering = properties.cidSystemInfo.ordering,
                        ucs2CMapName = Name.get(registry + "-" + ordering + "-UCS2");
                      return CMapFactory.create(ucs2CMapName, this.options.cMapOptions, null).then(function (ucs2CMap) {
                        var cMap = properties.cMap;
                        return (
                          (toUnicode = []),
                          cMap.forEach(function (charcode, cid) {
                            assert(cid <= 65535, "Max size of CID is 65,535");
                            var ucs2 = ucs2CMap.lookup(cid);
                            ucs2 &&
                              (toUnicode[charcode] = String.fromCharCode(
                                (ucs2.charCodeAt(0) << 8) + ucs2.charCodeAt(1)
                              ));
                          }),
                          new ToUnicodeMap(toUnicode)
                        );
                      });
                    }
                    return Promise.resolve(new IdentityToUnicodeMap(properties.firstChar, properties.lastChar));
                  },
                  readToUnicode: function (toUnicode) {
                    var cmapObj = toUnicode;
                    return isName(cmapObj)
                      ? CMapFactory.create(cmapObj, this.options.cMapOptions, null).then(function (cmap) {
                          return cmap instanceof IdentityCMap
                            ? new IdentityToUnicodeMap(0, 65535)
                            : new ToUnicodeMap(cmap.getMap());
                        })
                      : isStream(cmapObj)
                      ? CMapFactory.create(cmapObj, this.options.cMapOptions, null).then(function (cmap) {
                          if (cmap instanceof IdentityCMap) return new IdentityToUnicodeMap(0, 65535);
                          var map = new Array(cmap.length);
                          return (
                            cmap.forEach(function (charCode, token) {
                              for (var str = [], k = 0; k < token.length; k += 2) {
                                var w1 = (token.charCodeAt(k) << 8) | token.charCodeAt(k + 1);
                                if (55296 == (63488 & w1)) {
                                  k += 2;
                                  var w2 = (token.charCodeAt(k) << 8) | token.charCodeAt(k + 1);
                                  str.push(((1023 & w1) << 10) + (1023 & w2) + 65536);
                                } else str.push(w1);
                              }
                              map[charCode] = String.fromCharCode.apply(String, str);
                            }),
                            new ToUnicodeMap(map)
                          );
                        })
                      : Promise.resolve(null);
                  },
                  readCidToGidMap: function (cidToGidStream) {
                    for (
                      var glyphsData = cidToGidStream.getBytes(), result = [], j = 0, jj = glyphsData.length;
                      j < jj;
                      j++
                    ) {
                      var glyphID = (glyphsData[j++] << 8) | glyphsData[j];
                      if (0 !== glyphID) {
                        result[j >> 1] = glyphID;
                      }
                    }
                    return result;
                  },
                  extractWidths: function (dict, xref, descriptor, properties) {
                    var defaultVMetrics,
                      i,
                      ii,
                      j,
                      jj,
                      start,
                      code,
                      widths,
                      glyphsWidths = [],
                      defaultWidth = 0,
                      glyphsVMetrics = [];
                    if (properties.composite) {
                      if (((defaultWidth = dict.get("DW") || 1e3), (widths = dict.get("W"))))
                        for (i = 0, ii = widths.length; i < ii; i++)
                          if (((start = widths[i++]), (code = xref.fetchIfRef(widths[i])), isArray(code)))
                            for (j = 0, jj = code.length; j < jj; j++) glyphsWidths[start++] = code[j];
                          else {
                            var width = widths[++i];
                            for (j = start; j <= code; j++) glyphsWidths[j] = width;
                          }
                      if (properties.vertical) {
                        var vmetrics = dict.get("DW2") || [880, -1e3];
                        if (
                          ((defaultVMetrics = [vmetrics[1], 0.5 * defaultWidth, vmetrics[0]]),
                          (vmetrics = dict.get("W2")))
                        )
                          for (i = 0, ii = vmetrics.length; i < ii; i++)
                            if (((start = vmetrics[i++]), (code = xref.fetchIfRef(vmetrics[i])), isArray(code)))
                              for (j = 0, jj = code.length; j < jj; j++)
                                glyphsVMetrics[start++] = [code[j++], code[j++], code[j]];
                            else {
                              var vmetric = [vmetrics[++i], vmetrics[++i], vmetrics[++i]];
                              for (j = start; j <= code; j++) glyphsVMetrics[j] = vmetric;
                            }
                      }
                    } else {
                      var firstChar = properties.firstChar;
                      if ((widths = dict.get("Widths"))) {
                        for (j = firstChar, i = 0, ii = widths.length; i < ii; i++) glyphsWidths[j++] = widths[i];
                        defaultWidth = parseFloat(descriptor.get("MissingWidth")) || 0;
                      } else {
                        var baseFontName = dict.get("BaseFont");
                        if (isName(baseFontName)) {
                          var metrics = this.getBaseFontMetrics(baseFontName.name);
                          (glyphsWidths = this.buildCharCodeToWidth(metrics.widths, properties)),
                            (defaultWidth = metrics.defaultWidth);
                        }
                      }
                    }
                    var isMonospace = !0,
                      firstWidth = defaultWidth;
                    for (var glyph in glyphsWidths) {
                      var glyphWidth = glyphsWidths[glyph];
                      if (glyphWidth)
                        if (firstWidth) {
                          if (firstWidth !== glyphWidth) {
                            isMonospace = !1;
                            break;
                          }
                        } else firstWidth = glyphWidth;
                    }
                    isMonospace && (properties.flags |= FontFlags.FixedPitch),
                      (properties.defaultWidth = defaultWidth),
                      (properties.widths = glyphsWidths),
                      (properties.defaultVMetrics = defaultVMetrics),
                      (properties.vmetrics = glyphsVMetrics);
                  },
                  isSerifFont: function (baseFontName) {
                    var fontNameWoStyle = baseFontName.split("-")[0];
                    return fontNameWoStyle in getSerifFonts() || -1 !== fontNameWoStyle.search(/serif/gi);
                  },
                  getBaseFontMetrics: function (name) {
                    var defaultWidth = 0,
                      widths = [],
                      monospace = !1,
                      stdFontMap = getStdFontMap(),
                      lookupName = stdFontMap[name] || name,
                      Metrics = getMetrics();
                    lookupName in Metrics || (lookupName = this.isSerifFont(name) ? "Times-Roman" : "Helvetica");
                    var glyphWidths = Metrics[lookupName];
                    return (
                      isNum(glyphWidths) ? ((defaultWidth = glyphWidths), (monospace = !0)) : (widths = glyphWidths()),
                      { defaultWidth: defaultWidth, monospace: monospace, widths: widths }
                    );
                  },
                  buildCharCodeToWidth: function (widthsByGlyphName, properties) {
                    for (
                      var widths = Object.create(null),
                        differences = properties.differences,
                        encoding = properties.defaultEncoding,
                        charCode = 0;
                      charCode < 256;
                      charCode++
                    )
                      charCode in differences && widthsByGlyphName[differences[charCode]]
                        ? (widths[charCode] = widthsByGlyphName[differences[charCode]])
                        : charCode in encoding &&
                          widthsByGlyphName[encoding[charCode]] &&
                          (widths[charCode] = widthsByGlyphName[encoding[charCode]]);
                    return widths;
                  },
                  preEvaluateFont: function (dict, xref) {
                    var baseDict = dict,
                      type = dict.get("Subtype");
                    assert(isName(type), "invalid font Subtype");
                    var uint8array,
                      composite = !1;
                    if ("Type0" === type.name) {
                      var df = dict.get("DescendantFonts");
                      df || error("Descendant fonts are not specified"),
                        (dict = isArray(df) ? xref.fetchIfRef(df[0]) : df),
                        (type = dict.get("Subtype")),
                        assert(isName(type), "invalid font Subtype"),
                        (composite = !0);
                    }
                    var descriptor = dict.get("FontDescriptor");
                    if (descriptor) {
                      var hash = new MurmurHash3_64(),
                        encoding = baseDict.getRaw("Encoding");
                      if (isName(encoding)) hash.update(encoding.name);
                      else if (isRef(encoding)) hash.update(encoding.toString());
                      else if (isDict(encoding))
                        for (var keys = encoding.getKeys(), i = 0, ii = keys.length; i < ii; i++) {
                          var entry = encoding.getRaw(keys[i]);
                          isName(entry)
                            ? hash.update(entry.name)
                            : isRef(entry)
                            ? hash.update(entry.toString())
                            : isArray(entry) && hash.update(entry.length.toString());
                        }
                      var toUnicode = dict.get("ToUnicode") || baseDict.get("ToUnicode");
                      if (isStream(toUnicode)) {
                        var stream = toUnicode.str || toUnicode;
                        (uint8array = stream.buffer
                          ? new Uint8Array(stream.buffer.buffer, 0, stream.bufferLength)
                          : new Uint8Array(stream.bytes.buffer, stream.start, stream.end - stream.start)),
                          hash.update(uint8array);
                      } else isName(toUnicode) && hash.update(toUnicode.name);
                      var widths = dict.get("Widths") || baseDict.get("Widths");
                      widths &&
                        ((uint8array = new Uint8Array(new Uint32Array(widths).buffer)), hash.update(uint8array));
                    }
                    return {
                      descriptor: descriptor,
                      dict: dict,
                      baseDict: baseDict,
                      composite: composite,
                      type: type.name,
                      hash: hash ? hash.hexdigest() : "",
                    };
                  },
                  translateFont: function (preEvaluatedFont, xref) {
                    var properties,
                      baseDict = preEvaluatedFont.baseDict,
                      dict = preEvaluatedFont.dict,
                      composite = preEvaluatedFont.composite,
                      descriptor = preEvaluatedFont.descriptor,
                      type = preEvaluatedFont.type,
                      maxCharIndex = composite ? 65535 : 255,
                      cMapOptions = this.options.cMapOptions;
                    if (!descriptor) {
                      if ("Type3" !== type) {
                        var baseFontName = dict.get("BaseFont");
                        isName(baseFontName) || error("Base font is not specified"),
                          (baseFontName = baseFontName.name.replace(/[,_]/g, "-"));
                        var metrics = this.getBaseFontMetrics(baseFontName),
                          fontNameWoStyle = baseFontName.split("-")[0],
                          flags =
                            (this.isSerifFont(fontNameWoStyle) ? FontFlags.Serif : 0) |
                            (metrics.monospace ? FontFlags.FixedPitch : 0) |
                            (getSymbolsFonts()[fontNameWoStyle] ? FontFlags.Symbolic : FontFlags.Nonsymbolic);
                        return (
                          (properties = {
                            type: type,
                            name: baseFontName,
                            widths: metrics.widths,
                            defaultWidth: metrics.defaultWidth,
                            flags: flags,
                            firstChar: 0,
                            lastChar: maxCharIndex,
                          }),
                          this.extractDataStructures(dict, dict, xref, properties).then(
                            function (properties) {
                              return (
                                (properties.widths = this.buildCharCodeToWidth(metrics.widths, properties)),
                                new Font(baseFontName, null, properties)
                              );
                            }.bind(this)
                          )
                        );
                      }
                      (descriptor = new Dict(null)),
                        descriptor.set("FontName", Name.get(type)),
                        descriptor.set("FontBBox", dict.getArray("FontBBox"));
                    }
                    var firstChar = dict.get("FirstChar") || 0,
                      lastChar = dict.get("LastChar") || maxCharIndex,
                      fontName = descriptor.get("FontName"),
                      baseFont = dict.get("BaseFont");
                    if (
                      (isString(fontName) && (fontName = Name.get(fontName)),
                      isString(baseFont) && (baseFont = Name.get(baseFont)),
                      "Type3" !== type)
                    ) {
                      var fontNameStr = fontName && fontName.name,
                        baseFontStr = baseFont && baseFont.name;
                      fontNameStr !== baseFontStr &&
                        (info(
                          "The FontDescriptor's FontName is \"" +
                            fontNameStr +
                            '" but should be the same as the Font\'s BaseFont "' +
                            baseFontStr +
                            '"'
                        ),
                        fontNameStr && baseFontStr && 0 === baseFontStr.indexOf(fontNameStr) && (fontName = baseFont));
                    }
                    (fontName = fontName || baseFont), assert(isName(fontName), "invalid font name");
                    var fontFile = descriptor.get("FontFile", "FontFile2", "FontFile3");
                    if (fontFile && fontFile.dict) {
                      var subtype = fontFile.dict.get("Subtype");
                      subtype && (subtype = subtype.name);
                      var length1 = fontFile.dict.get("Length1"),
                        length2 = fontFile.dict.get("Length2"),
                        length3 = fontFile.dict.get("Length3");
                    }
                    properties = {
                      type: type,
                      name: fontName.name,
                      subtype: subtype,
                      file: fontFile,
                      length1: length1,
                      length2: length2,
                      length3: length3,
                      loadedName: baseDict.loadedName,
                      composite: composite,
                      wideChars: composite,
                      fixedPitch: !1,
                      fontMatrix: dict.getArray("FontMatrix") || FONT_IDENTITY_MATRIX,
                      firstChar: firstChar || 0,
                      lastChar: lastChar || maxCharIndex,
                      bbox: descriptor.getArray("FontBBox"),
                      ascent: descriptor.get("Ascent"),
                      descent: descriptor.get("Descent"),
                      xHeight: descriptor.get("XHeight"),
                      capHeight: descriptor.get("CapHeight"),
                      flags: descriptor.get("Flags"),
                      italicAngle: descriptor.get("ItalicAngle"),
                      coded: !1,
                    };
                    var cMapPromise;
                    if (composite) {
                      var cidEncoding = baseDict.get("Encoding");
                      isName(cidEncoding) && (properties.cidEncoding = cidEncoding.name),
                        (cMapPromise = CMapFactory.create(cidEncoding, cMapOptions, null).then(function (cMap) {
                          (properties.cMap = cMap), (properties.vertical = properties.cMap.vertical);
                        }));
                    } else cMapPromise = Promise.resolve(void 0);
                    return cMapPromise
                      .then(
                        function () {
                          return this.extractDataStructures(dict, baseDict, xref, properties);
                        }.bind(this)
                      )
                      .then(
                        function (properties) {
                          return (
                            this.extractWidths(dict, xref, descriptor, properties),
                            "Type3" === type && (properties.isType3Font = !0),
                            new Font(fontName.name, fontFile, properties)
                          );
                        }.bind(this)
                      );
                  },
                }),
                PartialEvaluator
              );
            })(),
            TranslatedFont = (function () {
              function TranslatedFont(loadedName, font, dict) {
                (this.loadedName = loadedName),
                  (this.font = font),
                  (this.dict = dict),
                  (this.type3Loaded = null),
                  (this.sent = !1);
              }
              return (
                (TranslatedFont.prototype = {
                  send: function (handler) {
                    if (!this.sent) {
                      var fontData = this.font.exportData();
                      handler.send("commonobj", [this.loadedName, "Font", fontData]), (this.sent = !0);
                    }
                  },
                  loadType3Data: function (evaluator, resources, parentOperatorList, task) {
                    if ((assert(this.font.isType3Font), this.type3Loaded)) return this.type3Loaded;
                    for (
                      var translatedFont = this.font,
                        loadCharProcsPromise = Promise.resolve(),
                        charProcs = this.dict.get("CharProcs"),
                        fontResources = this.dict.get("Resources") || resources,
                        charProcKeys = charProcs.getKeys(),
                        charProcOperatorList = Object.create(null),
                        i = 0,
                        n = charProcKeys.length;
                      i < n;
                      ++i
                    )
                      loadCharProcsPromise = loadCharProcsPromise.then(
                        function (key) {
                          var glyphStream = charProcs.get(key),
                            operatorList = new OperatorList();
                          return evaluator.getOperatorList(glyphStream, task, fontResources, operatorList).then(
                            function () {
                              (charProcOperatorList[key] = operatorList.getIR()),
                                parentOperatorList.addDependencies(operatorList.dependencies);
                            },
                            function (reason) {
                              warn('Type3 font resource "' + key + '" is not available');
                              var operatorList = new OperatorList();
                              charProcOperatorList[key] = operatorList.getIR();
                            }
                          );
                        }.bind(this, charProcKeys[i])
                      );
                    return (
                      (this.type3Loaded = loadCharProcsPromise.then(function () {
                        translatedFont.charProcOperatorList = charProcOperatorList;
                      })),
                      this.type3Loaded
                    );
                  },
                }),
                TranslatedFont
              );
            })(),
            OperatorList = (function () {
              function getTransfers(queue) {
                for (
                  var transfers = [], fnArray = queue.fnArray, argsArray = queue.argsArray, i = 0, ii = queue.length;
                  i < ii;
                  i++
                )
                  switch (fnArray[i]) {
                    case OPS.paintInlineImageXObject:
                    case OPS.paintInlineImageXObjectGroup:
                    case OPS.paintImageMaskXObject:
                      var arg = argsArray[i][0];
                      arg.cached || transfers.push(arg.data.buffer);
                  }
                return transfers;
              }
              function OperatorList(intent, messageHandler, pageIndex) {
                (this.messageHandler = messageHandler),
                  (this.fnArray = []),
                  (this.argsArray = []),
                  (this.dependencies = Object.create(null)),
                  (this._totalLength = 0),
                  (this.pageIndex = pageIndex),
                  (this.intent = intent);
              }
              return (
                (OperatorList.prototype = {
                  get length() {
                    return this.argsArray.length;
                  },
                  get totalLength() {
                    return this._totalLength + this.length;
                  },
                  addOp: function (fn, args) {
                    this.fnArray.push(fn),
                      this.argsArray.push(args),
                      this.messageHandler &&
                        (this.fnArray.length >= 1e3
                          ? this.flush()
                          : this.fnArray.length >= 995 && (fn === OPS.restore || fn === OPS.endText) && this.flush());
                  },
                  addDependency: function (dependency) {
                    dependency in this.dependencies ||
                      ((this.dependencies[dependency] = !0), this.addOp(OPS.dependency, [dependency]));
                  },
                  addDependencies: function (dependencies) {
                    for (var key in dependencies) this.addDependency(key);
                  },
                  addOpList: function (opList) {
                    Util.extendObj(this.dependencies, opList.dependencies);
                    for (var i = 0, ii = opList.length; i < ii; i++) this.addOp(opList.fnArray[i], opList.argsArray[i]);
                  },
                  getIR: function () {
                    return { fnArray: this.fnArray, argsArray: this.argsArray, length: this.length };
                  },
                  flush: function (lastChunk) {
                    "oplist" !== this.intent && new QueueOptimizer().optimize(this);
                    var transfers = getTransfers(this),
                      length = this.length;
                    (this._totalLength += length),
                      this.messageHandler.send(
                        "RenderPageChunk",
                        {
                          operatorList: {
                            fnArray: this.fnArray,
                            argsArray: this.argsArray,
                            lastChunk: lastChunk,
                            length: length,
                          },
                          pageIndex: this.pageIndex,
                          intent: this.intent,
                        },
                        transfers
                      ),
                      (this.dependencies = Object.create(null)),
                      (this.fnArray.length = 0),
                      (this.argsArray.length = 0);
                  },
                }),
                OperatorList
              );
            })(),
            StateManager = (function () {
              function StateManager(initialState) {
                (this.state = initialState), (this.stateStack = []);
              }
              return (
                (StateManager.prototype = {
                  save: function () {
                    var old = this.state;
                    this.stateStack.push(this.state), (this.state = old.clone());
                  },
                  restore: function () {
                    var prev = this.stateStack.pop();
                    prev && (this.state = prev);
                  },
                  transform: function (args) {
                    this.state.ctm = Util.transform(this.state.ctm, args);
                  },
                }),
                StateManager
              );
            })(),
            TextState = (function () {
              function TextState() {
                (this.ctm = new Float32Array(IDENTITY_MATRIX)),
                  (this.fontName = null),
                  (this.fontSize = 0),
                  (this.font = null),
                  (this.fontMatrix = FONT_IDENTITY_MATRIX),
                  (this.textMatrix = IDENTITY_MATRIX.slice()),
                  (this.textLineMatrix = IDENTITY_MATRIX.slice()),
                  (this.charSpacing = 0),
                  (this.wordSpacing = 0),
                  (this.leading = 0),
                  (this.textHScale = 1),
                  (this.textRise = 0);
              }
              return (
                (TextState.prototype = {
                  setTextMatrix: function (a, b, c, d, e, f) {
                    var m = this.textMatrix;
                    (m[0] = a), (m[1] = b), (m[2] = c), (m[3] = d), (m[4] = e), (m[5] = f);
                  },
                  setTextLineMatrix: function (a, b, c, d, e, f) {
                    var m = this.textLineMatrix;
                    (m[0] = a), (m[1] = b), (m[2] = c), (m[3] = d), (m[4] = e), (m[5] = f);
                  },
                  translateTextMatrix: function (x, y) {
                    var m = this.textMatrix;
                    (m[4] = m[0] * x + m[2] * y + m[4]), (m[5] = m[1] * x + m[3] * y + m[5]);
                  },
                  translateTextLineMatrix: function (x, y) {
                    var m = this.textLineMatrix;
                    (m[4] = m[0] * x + m[2] * y + m[4]), (m[5] = m[1] * x + m[3] * y + m[5]);
                  },
                  calcTextLineMatrixAdvance: function (a, b, c, d, e, f) {
                    var font = this.font;
                    if (!font) return null;
                    var m = this.textLineMatrix;
                    if (a !== m[0] || b !== m[1] || c !== m[2] || d !== m[3]) return null;
                    var txDiff = e - m[4],
                      tyDiff = f - m[5];
                    if ((font.vertical && 0 !== txDiff) || (!font.vertical && 0 !== tyDiff)) return null;
                    var tx,
                      ty,
                      denominator = a * d - b * c;
                    return (
                      font.vertical
                        ? ((tx = (-tyDiff * c) / denominator), (ty = (tyDiff * a) / denominator))
                        : ((tx = (txDiff * d) / denominator), (ty = (-txDiff * b) / denominator)),
                      { width: tx, height: ty, value: font.vertical ? ty : tx }
                    );
                  },
                  calcRenderMatrix: function (ctm) {
                    var tsm = [this.fontSize * this.textHScale, 0, 0, this.fontSize, 0, this.textRise];
                    return Util.transform(ctm, Util.transform(this.textMatrix, tsm));
                  },
                  carriageReturn: function () {
                    this.translateTextLineMatrix(0, -this.leading), (this.textMatrix = this.textLineMatrix.slice());
                  },
                  clone: function () {
                    var clone = Object.create(this);
                    return (
                      (clone.textMatrix = this.textMatrix.slice()),
                      (clone.textLineMatrix = this.textLineMatrix.slice()),
                      (clone.fontMatrix = this.fontMatrix.slice()),
                      clone
                    );
                  },
                }),
                TextState
              );
            })(),
            EvalState = (function () {
              function EvalState() {
                (this.ctm = new Float32Array(IDENTITY_MATRIX)),
                  (this.font = null),
                  (this.textRenderingMode = TextRenderingMode.FILL),
                  (this.fillColorSpace = ColorSpace.singletons.gray),
                  (this.strokeColorSpace = ColorSpace.singletons.gray);
              }
              return (
                (EvalState.prototype = {
                  clone: function () {
                    return Object.create(this);
                  },
                }),
                EvalState
              );
            })(),
            EvaluatorPreprocessor = (function () {
              function EvaluatorPreprocessor(stream, xref, stateManager) {
                (this.opMap = getOPMap()),
                  (this.parser = new Parser(new Lexer(stream, this.opMap), !1, xref)),
                  (this.stateManager = stateManager),
                  (this.nonProcessedArgs = []);
              }
              var getOPMap = getLookupTableFactory(function (t) {
                (t.w = { id: OPS.setLineWidth, numArgs: 1, variableArgs: !1 }),
                  (t.J = { id: OPS.setLineCap, numArgs: 1, variableArgs: !1 }),
                  (t.j = { id: OPS.setLineJoin, numArgs: 1, variableArgs: !1 }),
                  (t.M = { id: OPS.setMiterLimit, numArgs: 1, variableArgs: !1 }),
                  (t.d = { id: OPS.setDash, numArgs: 2, variableArgs: !1 }),
                  (t.ri = { id: OPS.setRenderingIntent, numArgs: 1, variableArgs: !1 }),
                  (t.i = { id: OPS.setFlatness, numArgs: 1, variableArgs: !1 }),
                  (t.gs = { id: OPS.setGState, numArgs: 1, variableArgs: !1 }),
                  (t.q = { id: OPS.save, numArgs: 0, variableArgs: !1 }),
                  (t.Q = { id: OPS.restore, numArgs: 0, variableArgs: !1 }),
                  (t.cm = { id: OPS.transform, numArgs: 6, variableArgs: !1 }),
                  (t.m = { id: OPS.moveTo, numArgs: 2, variableArgs: !1 }),
                  (t.l = { id: OPS.lineTo, numArgs: 2, variableArgs: !1 }),
                  (t.c = { id: OPS.curveTo, numArgs: 6, variableArgs: !1 }),
                  (t.v = { id: OPS.curveTo2, numArgs: 4, variableArgs: !1 }),
                  (t.y = { id: OPS.curveTo3, numArgs: 4, variableArgs: !1 }),
                  (t.h = { id: OPS.closePath, numArgs: 0, variableArgs: !1 }),
                  (t.re = { id: OPS.rectangle, numArgs: 4, variableArgs: !1 }),
                  (t.S = { id: OPS.stroke, numArgs: 0, variableArgs: !1 }),
                  (t.s = { id: OPS.closeStroke, numArgs: 0, variableArgs: !1 }),
                  (t.f = { id: OPS.fill, numArgs: 0, variableArgs: !1 }),
                  (t.F = { id: OPS.fill, numArgs: 0, variableArgs: !1 }),
                  (t["f*"] = { id: OPS.eoFill, numArgs: 0, variableArgs: !1 }),
                  (t.B = { id: OPS.fillStroke, numArgs: 0, variableArgs: !1 }),
                  (t["B*"] = { id: OPS.eoFillStroke, numArgs: 0, variableArgs: !1 }),
                  (t.b = { id: OPS.closeFillStroke, numArgs: 0, variableArgs: !1 }),
                  (t["b*"] = { id: OPS.closeEOFillStroke, numArgs: 0, variableArgs: !1 }),
                  (t.n = { id: OPS.endPath, numArgs: 0, variableArgs: !1 }),
                  (t.W = { id: OPS.clip, numArgs: 0, variableArgs: !1 }),
                  (t["W*"] = { id: OPS.eoClip, numArgs: 0, variableArgs: !1 }),
                  (t.BT = { id: OPS.beginText, numArgs: 0, variableArgs: !1 }),
                  (t.ET = { id: OPS.endText, numArgs: 0, variableArgs: !1 }),
                  (t.Tc = { id: OPS.setCharSpacing, numArgs: 1, variableArgs: !1 }),
                  (t.Tw = { id: OPS.setWordSpacing, numArgs: 1, variableArgs: !1 }),
                  (t.Tz = { id: OPS.setHScale, numArgs: 1, variableArgs: !1 }),
                  (t.TL = { id: OPS.setLeading, numArgs: 1, variableArgs: !1 }),
                  (t.Tf = { id: OPS.setFont, numArgs: 2, variableArgs: !1 }),
                  (t.Tr = { id: OPS.setTextRenderingMode, numArgs: 1, variableArgs: !1 }),
                  (t.Ts = { id: OPS.setTextRise, numArgs: 1, variableArgs: !1 }),
                  (t.Td = { id: OPS.moveText, numArgs: 2, variableArgs: !1 }),
                  (t.TD = { id: OPS.setLeadingMoveText, numArgs: 2, variableArgs: !1 }),
                  (t.Tm = { id: OPS.setTextMatrix, numArgs: 6, variableArgs: !1 }),
                  (t["T*"] = { id: OPS.nextLine, numArgs: 0, variableArgs: !1 }),
                  (t.Tj = { id: OPS.showText, numArgs: 1, variableArgs: !1 }),
                  (t.TJ = { id: OPS.showSpacedText, numArgs: 1, variableArgs: !1 }),
                  (t["'"] = { id: OPS.nextLineShowText, numArgs: 1, variableArgs: !1 }),
                  (t['"'] = { id: OPS.nextLineSetSpacingShowText, numArgs: 3, variableArgs: !1 }),
                  (t.d0 = { id: OPS.setCharWidth, numArgs: 2, variableArgs: !1 }),
                  (t.d1 = { id: OPS.setCharWidthAndBounds, numArgs: 6, variableArgs: !1 }),
                  (t.CS = { id: OPS.setStrokeColorSpace, numArgs: 1, variableArgs: !1 }),
                  (t.cs = { id: OPS.setFillColorSpace, numArgs: 1, variableArgs: !1 }),
                  (t.SC = { id: OPS.setStrokeColor, numArgs: 4, variableArgs: !0 }),
                  (t.SCN = { id: OPS.setStrokeColorN, numArgs: 33, variableArgs: !0 }),
                  (t.sc = { id: OPS.setFillColor, numArgs: 4, variableArgs: !0 }),
                  (t.scn = { id: OPS.setFillColorN, numArgs: 33, variableArgs: !0 }),
                  (t.G = { id: OPS.setStrokeGray, numArgs: 1, variableArgs: !1 }),
                  (t.g = { id: OPS.setFillGray, numArgs: 1, variableArgs: !1 }),
                  (t.RG = { id: OPS.setStrokeRGBColor, numArgs: 3, variableArgs: !1 }),
                  (t.rg = { id: OPS.setFillRGBColor, numArgs: 3, variableArgs: !1 }),
                  (t.K = { id: OPS.setStrokeCMYKColor, numArgs: 4, variableArgs: !1 }),
                  (t.k = { id: OPS.setFillCMYKColor, numArgs: 4, variableArgs: !1 }),
                  (t.sh = { id: OPS.shadingFill, numArgs: 1, variableArgs: !1 }),
                  (t.BI = { id: OPS.beginInlineImage, numArgs: 0, variableArgs: !1 }),
                  (t.ID = { id: OPS.beginImageData, numArgs: 0, variableArgs: !1 }),
                  (t.EI = { id: OPS.endInlineImage, numArgs: 1, variableArgs: !1 }),
                  (t.Do = { id: OPS.paintXObject, numArgs: 1, variableArgs: !1 }),
                  (t.MP = { id: OPS.markPoint, numArgs: 1, variableArgs: !1 }),
                  (t.DP = { id: OPS.markPointProps, numArgs: 2, variableArgs: !1 }),
                  (t.BMC = { id: OPS.beginMarkedContent, numArgs: 1, variableArgs: !1 }),
                  (t.BDC = { id: OPS.beginMarkedContentProps, numArgs: 2, variableArgs: !1 }),
                  (t.EMC = { id: OPS.endMarkedContent, numArgs: 0, variableArgs: !1 }),
                  (t.BX = { id: OPS.beginCompat, numArgs: 0, variableArgs: !1 }),
                  (t.EX = { id: OPS.endCompat, numArgs: 0, variableArgs: !1 }),
                  (t.BM = null),
                  (t.BD = null),
                  (t.true = null),
                  (t.fa = null),
                  (t.fal = null),
                  (t.fals = null),
                  (t.false = null),
                  (t.nu = null),
                  (t.nul = null),
                  (t.null = null);
              });
              return (
                (EvaluatorPreprocessor.prototype = {
                  get savedStatesDepth() {
                    return this.stateManager.stateStack.length;
                  },
                  read: function (operation) {
                    for (var args = operation.args; ; ) {
                      var obj = this.parser.getObj();
                      if (isCmd(obj)) {
                        var cmd = obj.cmd,
                          opSpec = this.opMap[cmd];
                        if (!opSpec) {
                          warn('Unknown command "' + cmd + '"');
                          continue;
                        }
                        var fn = opSpec.id,
                          numArgs = opSpec.numArgs,
                          argsLength = null !== args ? args.length : 0;
                        if (opSpec.variableArgs)
                          argsLength > numArgs &&
                            info(
                              "Command " +
                                fn +
                                ": expected [0," +
                                numArgs +
                                "] args, but received " +
                                argsLength +
                                " args"
                            );
                        else {
                          if (argsLength !== numArgs) {
                            for (var nonProcessedArgs = this.nonProcessedArgs; argsLength > numArgs; )
                              nonProcessedArgs.push(args.shift()), argsLength--;
                            for (; argsLength < numArgs && 0 !== nonProcessedArgs.length; )
                              args || (args = []), args.unshift(nonProcessedArgs.pop()), argsLength++;
                          }
                          if (argsLength < numArgs) {
                            info(
                              "Command " +
                                fn +
                                ": because expected " +
                                numArgs +
                                " args, but received " +
                                argsLength +
                                " args; skipping"
                            ),
                              (args = null);
                            continue;
                          }
                        }
                        return this.preprocessCommand(fn, args), (operation.fn = fn), (operation.args = args), !0;
                      }
                      if (isEOF(obj)) return !1;
                      null !== obj &&
                        (args || (args = []), args.push(obj), assert(args.length <= 33, "Too many arguments"));
                    }
                  },
                  preprocessCommand: function (fn, args) {
                    switch (0 | fn) {
                      case OPS.save:
                        this.stateManager.save();
                        break;
                      case OPS.restore:
                        this.stateManager.restore();
                        break;
                      case OPS.transform:
                        this.stateManager.transform(args);
                    }
                  },
                }),
                EvaluatorPreprocessor
              );
            })(),
            QueueOptimizer = (function () {
              function addState(parentState, pattern, fn) {
                for (var state = parentState, i = 0, ii = pattern.length - 1; i < ii; i++) {
                  var item = pattern[i];
                  state = state[item] || (state[item] = []);
                }
                state[pattern[pattern.length - 1]] = fn;
              }
              function handlePaintSolidColorImageMask(iFirstSave, count, fnArray, argsArray) {
                for (var iFirstPIMXO = iFirstSave + 2, i = 0; i < count; i++) {
                  var arg = argsArray[iFirstPIMXO + 4 * i],
                    imageMask = 1 === arg.length && arg[0];
                  if (
                    !imageMask ||
                    1 !== imageMask.width ||
                    1 !== imageMask.height ||
                    (imageMask.data.length && (1 !== imageMask.data.length || 0 !== imageMask.data[0]))
                  )
                    break;
                  fnArray[iFirstPIMXO + 4 * i] = OPS.paintSolidColorImageMask;
                }
                return count - i;
              }
              function QueueOptimizer() {}
              var InitialState = [];
              return (
                addState(InitialState, [OPS.save, OPS.transform, OPS.paintInlineImageXObject, OPS.restore], function (
                  context
                ) {
                  for (
                    var fnArray = context.fnArray,
                      argsArray = context.argsArray,
                      curr = context.iCurr,
                      iFirstSave = curr - 3,
                      iFirstTransform = curr - 2,
                      iFirstPIIXO = curr - 1,
                      i = iFirstSave + 4,
                      ii = fnArray.length;
                    i + 3 < ii &&
                    fnArray[i] === OPS.save &&
                    fnArray[i + 1] === OPS.transform &&
                    fnArray[i + 2] === OPS.paintInlineImageXObject &&
                    fnArray[i + 3] === OPS.restore;

                  )
                    i += 4;
                  var count = Math.min((i - iFirstSave) / 4, 200);
                  if (count < 10) return i;
                  var q,
                    maxX = 0,
                    map = [],
                    maxLineHeight = 0,
                    currentX = 1,
                    currentY = 1;
                  for (q = 0; q < count; q++) {
                    var transform = argsArray[iFirstTransform + (q << 2)],
                      img = argsArray[iFirstPIIXO + (q << 2)][0];
                    currentX + img.width > 1e3 &&
                      ((maxX = Math.max(maxX, currentX)),
                      (currentY += maxLineHeight + 2),
                      (currentX = 0),
                      (maxLineHeight = 0)),
                      map.push({ transform: transform, x: currentX, y: currentY, w: img.width, h: img.height }),
                      (currentX += img.width + 2),
                      (maxLineHeight = Math.max(maxLineHeight, img.height));
                  }
                  var imgWidth = Math.max(maxX, currentX) + 1,
                    imgHeight = currentY + maxLineHeight + 1,
                    imgData = new Uint8Array(imgWidth * imgHeight * 4),
                    imgRowSize = imgWidth << 2;
                  for (q = 0; q < count; q++) {
                    var data = argsArray[iFirstPIIXO + (q << 2)][0].data,
                      rowSize = map[q].w << 2,
                      dataOffset = 0,
                      offset = (map[q].x + map[q].y * imgWidth) << 2;
                    imgData.set(data.subarray(0, rowSize), offset - imgRowSize);
                    for (var k = 0, kk = map[q].h; k < kk; k++)
                      imgData.set(data.subarray(dataOffset, dataOffset + rowSize), offset),
                        (dataOffset += rowSize),
                        (offset += imgRowSize);
                    for (imgData.set(data.subarray(dataOffset - rowSize, dataOffset), offset); offset >= 0; )
                      (data[offset - 4] = data[offset]),
                        (data[offset - 3] = data[offset + 1]),
                        (data[offset - 2] = data[offset + 2]),
                        (data[offset - 1] = data[offset + 3]),
                        (data[offset + rowSize] = data[offset + rowSize - 4]),
                        (data[offset + rowSize + 1] = data[offset + rowSize - 3]),
                        (data[offset + rowSize + 2] = data[offset + rowSize - 2]),
                        (data[offset + rowSize + 3] = data[offset + rowSize - 1]),
                        (offset -= imgRowSize);
                  }
                  return (
                    fnArray.splice(iFirstSave, 4 * count, OPS.paintInlineImageXObjectGroup),
                    argsArray.splice(iFirstSave, 4 * count, [
                      { width: imgWidth, height: imgHeight, kind: ImageKind.RGBA_32BPP, data: imgData },
                      map,
                    ]),
                    iFirstSave + 1
                  );
                }),
                addState(InitialState, [OPS.save, OPS.transform, OPS.paintImageMaskXObject, OPS.restore], function (
                  context
                ) {
                  for (
                    var fnArray = context.fnArray,
                      argsArray = context.argsArray,
                      curr = context.iCurr,
                      iFirstSave = curr - 3,
                      iFirstTransform = curr - 2,
                      iFirstPIMXO = curr - 1,
                      i = iFirstSave + 4,
                      ii = fnArray.length;
                    i + 3 < ii &&
                    fnArray[i] === OPS.save &&
                    fnArray[i + 1] === OPS.transform &&
                    fnArray[i + 2] === OPS.paintImageMaskXObject &&
                    fnArray[i + 3] === OPS.restore;

                  )
                    i += 4;
                  var count = (i - iFirstSave) / 4;
                  if ((count = handlePaintSolidColorImageMask(iFirstSave, count, fnArray, argsArray)) < 10) return i;
                  var q,
                    iTransform,
                    transformArgs,
                    isSameImage = !1,
                    firstPIMXOArg0 = argsArray[iFirstPIMXO][0];
                  if (0 === argsArray[iFirstTransform][1] && 0 === argsArray[iFirstTransform][2]) {
                    isSameImage = !0;
                    var firstTransformArg0 = argsArray[iFirstTransform][0],
                      firstTransformArg3 = argsArray[iFirstTransform][3];
                    iTransform = iFirstTransform + 4;
                    var iPIMXO = iFirstPIMXO + 4;
                    for (q = 1; q < count; q++, iTransform += 4, iPIMXO += 4)
                      if (
                        ((transformArgs = argsArray[iTransform]),
                        argsArray[iPIMXO][0] !== firstPIMXOArg0 ||
                          transformArgs[0] !== firstTransformArg0 ||
                          0 !== transformArgs[1] ||
                          0 !== transformArgs[2] ||
                          transformArgs[3] !== firstTransformArg3)
                      ) {
                        q < 10 ? (isSameImage = !1) : (count = q);
                        break;
                      }
                  }
                  if (isSameImage) {
                    count = Math.min(count, 1e3);
                    var positions = new Float32Array(2 * count);
                    for (iTransform = iFirstTransform, q = 0; q < count; q++, iTransform += 4)
                      (transformArgs = argsArray[iTransform]),
                        (positions[q << 1] = transformArgs[4]),
                        (positions[1 + (q << 1)] = transformArgs[5]);
                    fnArray.splice(iFirstSave, 4 * count, OPS.paintImageMaskXObjectRepeat),
                      argsArray.splice(iFirstSave, 4 * count, [
                        firstPIMXOArg0,
                        firstTransformArg0,
                        firstTransformArg3,
                        positions,
                      ]);
                  } else {
                    count = Math.min(count, 100);
                    var images = [];
                    for (q = 0; q < count; q++) {
                      transformArgs = argsArray[iFirstTransform + (q << 2)];
                      var maskParams = argsArray[iFirstPIMXO + (q << 2)][0];
                      images.push({
                        data: maskParams.data,
                        width: maskParams.width,
                        height: maskParams.height,
                        transform: transformArgs,
                      });
                    }
                    fnArray.splice(iFirstSave, 4 * count, OPS.paintImageMaskXObjectGroup),
                      argsArray.splice(iFirstSave, 4 * count, [images]);
                  }
                  return iFirstSave + 1;
                }),
                addState(InitialState, [OPS.save, OPS.transform, OPS.paintImageXObject, OPS.restore], function (
                  context
                ) {
                  var fnArray = context.fnArray,
                    argsArray = context.argsArray,
                    curr = context.iCurr,
                    iFirstSave = curr - 3,
                    iFirstTransform = curr - 2,
                    iFirstPIXO = curr - 1,
                    iFirstRestore = curr;
                  if (0 !== argsArray[iFirstTransform][1] || 0 !== argsArray[iFirstTransform][2])
                    return iFirstRestore + 1;
                  for (
                    var firstPIXOArg0 = argsArray[iFirstPIXO][0],
                      firstTransformArg0 = argsArray[iFirstTransform][0],
                      firstTransformArg3 = argsArray[iFirstTransform][3],
                      i = iFirstSave + 4,
                      ii = fnArray.length;
                    i + 3 < ii &&
                    fnArray[i] === OPS.save &&
                    fnArray[i + 1] === OPS.transform &&
                    fnArray[i + 2] === OPS.paintImageXObject &&
                    fnArray[i + 3] === OPS.restore &&
                    argsArray[i + 1][0] === firstTransformArg0 &&
                    0 === argsArray[i + 1][1] &&
                    0 === argsArray[i + 1][2] &&
                    argsArray[i + 1][3] === firstTransformArg3 &&
                    argsArray[i + 2][0] === firstPIXOArg0;

                  )
                    i += 4;
                  var count = Math.min((i - iFirstSave) / 4, 1e3);
                  if (count < 3) return i;
                  for (
                    var positions = new Float32Array(2 * count), iTransform = iFirstTransform, q = 0;
                    q < count;
                    q++, iTransform += 4
                  ) {
                    var transformArgs = argsArray[iTransform];
                    (positions[q << 1] = transformArgs[4]), (positions[1 + (q << 1)] = transformArgs[5]);
                  }
                  var args = [firstPIXOArg0, firstTransformArg0, firstTransformArg3, positions];
                  return (
                    fnArray.splice(iFirstSave, 4 * count, OPS.paintImageXObjectRepeat),
                    argsArray.splice(iFirstSave, 4 * count, args),
                    iFirstSave + 1
                  );
                }),
                addState(
                  InitialState,
                  [OPS.beginText, OPS.setFont, OPS.setTextMatrix, OPS.showText, OPS.endText],
                  function (context) {
                    for (
                      var fnArray = context.fnArray,
                        argsArray = context.argsArray,
                        curr = context.iCurr,
                        iFirstBeginText = curr - 4,
                        iFirstSetFont = curr - 3,
                        iFirstSetTextMatrix = curr - 2,
                        iFirstShowText = curr - 1,
                        iFirstEndText = curr,
                        firstSetFontArg0 = argsArray[iFirstSetFont][0],
                        firstSetFontArg1 = argsArray[iFirstSetFont][1],
                        i = iFirstBeginText + 5,
                        ii = fnArray.length;
                      i + 4 < ii &&
                      fnArray[i] === OPS.beginText &&
                      fnArray[i + 1] === OPS.setFont &&
                      fnArray[i + 2] === OPS.setTextMatrix &&
                      fnArray[i + 3] === OPS.showText &&
                      fnArray[i + 4] === OPS.endText &&
                      argsArray[i + 1][0] === firstSetFontArg0 &&
                      argsArray[i + 1][1] === firstSetFontArg1;

                    )
                      i += 5;
                    var count = Math.min((i - iFirstBeginText) / 5, 1e3);
                    if (count < 3) return i;
                    var iFirst = iFirstBeginText;
                    iFirstBeginText >= 4 &&
                      fnArray[iFirstBeginText - 4] === fnArray[iFirstSetFont] &&
                      fnArray[iFirstBeginText - 3] === fnArray[iFirstSetTextMatrix] &&
                      fnArray[iFirstBeginText - 2] === fnArray[iFirstShowText] &&
                      fnArray[iFirstBeginText - 1] === fnArray[iFirstEndText] &&
                      argsArray[iFirstBeginText - 4][0] === firstSetFontArg0 &&
                      argsArray[iFirstBeginText - 4][1] === firstSetFontArg1 &&
                      (count++, (iFirst -= 5));
                    for (var iEndText = iFirst + 4, q = 1; q < count; q++)
                      fnArray.splice(iEndText, 3), argsArray.splice(iEndText, 3), (iEndText += 2);
                    return iEndText + 1;
                  }
                ),
                (QueueOptimizer.prototype = {
                  optimize: function (queue) {
                    for (
                      var state,
                        fnArray = queue.fnArray,
                        argsArray = queue.argsArray,
                        context = { iCurr: 0, fnArray: fnArray, argsArray: argsArray },
                        i = 0,
                        ii = fnArray.length;
                      i < ii;

                    )
                      (state = (state || InitialState)[fnArray[i]]),
                        "function" == typeof state
                          ? ((context.iCurr = i), (i = state(context)), (state = void 0), (ii = context.fnArray.length))
                          : i++;
                  },
                }),
                QueueOptimizer
              );
            })();
          (exports.OperatorList = OperatorList), (exports.PartialEvaluator = PartialEvaluator);
        })(
          (root.pdfjsCoreEvaluator = {}),
          root.pdfjsSharedUtil,
          root.pdfjsCorePrimitives,
          root.pdfjsCoreStream,
          root.pdfjsCoreParser,
          root.pdfjsCoreImage,
          root.pdfjsCoreColorSpace,
          root.pdfjsCoreMurmurHash3,
          root.pdfjsCoreFonts,
          root.pdfjsCoreFunction,
          root.pdfjsCorePattern,
          root.pdfjsCoreCMap,
          root.pdfjsCoreMetrics,
          root.pdfjsCoreBidi,
          root.pdfjsCoreEncodings,
          root.pdfjsCoreStandardFonts,
          root.pdfjsCoreUnicode,
          root.pdfjsCoreGlyphList
        );
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, corePrimitives, coreStream, coreColorSpace, coreObj, coreEvaluator) {
          function AnnotationFactory() {}
          var AnnotationBorderStyleType = sharedUtil.AnnotationBorderStyleType,
            AnnotationFieldFlag = sharedUtil.AnnotationFieldFlag,
            AnnotationFlag = sharedUtil.AnnotationFlag,
            AnnotationType = sharedUtil.AnnotationType,
            OPS = sharedUtil.OPS,
            Util = sharedUtil.Util,
            isBool = sharedUtil.isBool,
            isString = sharedUtil.isString,
            isArray = sharedUtil.isArray,
            isInt = sharedUtil.isInt,
            isValidUrl = sharedUtil.isValidUrl,
            stringToBytes = sharedUtil.stringToBytes,
            stringToPDFString = sharedUtil.stringToPDFString,
            stringToUTF8String = sharedUtil.stringToUTF8String,
            warn = sharedUtil.warn,
            Dict = corePrimitives.Dict,
            isDict = corePrimitives.isDict,
            isName = corePrimitives.isName,
            isRef = corePrimitives.isRef,
            Stream = coreStream.Stream,
            ColorSpace = coreColorSpace.ColorSpace,
            ObjectLoader = coreObj.ObjectLoader,
            FileSpec = coreObj.FileSpec,
            OperatorList = coreEvaluator.OperatorList;
          AnnotationFactory.prototype = {
            create: function (xref, ref, uniquePrefix, idCounters) {
              var dict = xref.fetchIfRef(ref);
              if (isDict(dict)) {
                var id = isRef(ref) ? ref.toString() : "annot_" + (uniquePrefix || "") + ++idCounters.obj,
                  subtype = dict.get("Subtype");
                subtype = isName(subtype) ? subtype.name : null;
                var parameters = { xref: xref, dict: dict, ref: isRef(ref) ? ref : null, subtype: subtype, id: id };
                switch (subtype) {
                  case "Link":
                    return new LinkAnnotation(parameters);
                  case "Text":
                    return new TextAnnotation(parameters);
                  case "Widget":
                    var fieldType = Util.getInheritableProperty(dict, "FT");
                    switch ((fieldType = isName(fieldType) ? fieldType.name : null)) {
                      case "Tx":
                        return new TextWidgetAnnotation(parameters);
                    }
                    return (
                      warn('Unimplemented widget field type "' + fieldType + '", falling back to base field type.'),
                      new WidgetAnnotation(parameters)
                    );
                  case "Popup":
                    return new PopupAnnotation(parameters);
                  case "Highlight":
                    return new HighlightAnnotation(parameters);
                  case "Underline":
                    return new UnderlineAnnotation(parameters);
                  case "Squiggly":
                    return new SquigglyAnnotation(parameters);
                  case "StrikeOut":
                    return new StrikeOutAnnotation(parameters);
                  case "FileAttachment":
                    return new FileAttachmentAnnotation(parameters);
                  default:
                    return (
                      warn(
                        subtype
                          ? 'Unimplemented annotation type "' + subtype + '", falling back to base annotation.'
                          : "Annotation is missing the required /Subtype."
                      ),
                      new Annotation(parameters)
                    );
                }
              }
            },
          };
          var Annotation = (function () {
              function getTransformMatrix(rect, bbox, matrix) {
                var bounds = Util.getAxialAlignedBoundingBox(bbox, matrix),
                  minX = bounds[0],
                  minY = bounds[1],
                  maxX = bounds[2],
                  maxY = bounds[3];
                if (minX === maxX || minY === maxY) return [1, 0, 0, 1, rect[0], rect[1]];
                var xRatio = (rect[2] - rect[0]) / (maxX - minX),
                  yRatio = (rect[3] - rect[1]) / (maxY - minY);
                return [xRatio, 0, 0, yRatio, rect[0] - minX * xRatio, rect[1] - minY * yRatio];
              }
              function getDefaultAppearance(dict) {
                var appearanceState = dict.get("AP");
                if (isDict(appearanceState)) {
                  var appearance,
                    appearances = appearanceState.get("N");
                  if (isDict(appearances)) {
                    var as = dict.get("AS");
                    as && appearances.has(as.name) && (appearance = appearances.get(as.name));
                  } else appearance = appearances;
                  return appearance;
                }
              }
              function Annotation(params) {
                var dict = params.dict;
                this.setFlags(dict.get("F")),
                  this.setRectangle(dict.getArray("Rect")),
                  this.setColor(dict.getArray("C")),
                  this.setBorderStyle(dict),
                  (this.appearance = getDefaultAppearance(dict)),
                  (this.data = {}),
                  (this.data.id = params.id),
                  (this.data.subtype = params.subtype),
                  (this.data.annotationFlags = this.flags),
                  (this.data.rect = this.rectangle),
                  (this.data.color = this.color),
                  (this.data.borderStyle = this.borderStyle),
                  (this.data.hasAppearance = !!this.appearance);
              }
              return (
                (Annotation.prototype = {
                  _hasFlag: function (flags, flag) {
                    return !!(flags & flag);
                  },
                  _isViewable: function (flags) {
                    return (
                      !this._hasFlag(flags, AnnotationFlag.INVISIBLE) &&
                      !this._hasFlag(flags, AnnotationFlag.HIDDEN) &&
                      !this._hasFlag(flags, AnnotationFlag.NOVIEW)
                    );
                  },
                  _isPrintable: function (flags) {
                    return (
                      this._hasFlag(flags, AnnotationFlag.PRINT) &&
                      !this._hasFlag(flags, AnnotationFlag.INVISIBLE) &&
                      !this._hasFlag(flags, AnnotationFlag.HIDDEN)
                    );
                  },
                  get viewable() {
                    return 0 === this.flags || this._isViewable(this.flags);
                  },
                  get printable() {
                    return 0 !== this.flags && this._isPrintable(this.flags);
                  },
                  setFlags: function (flags) {
                    this.flags = isInt(flags) && flags > 0 ? flags : 0;
                  },
                  hasFlag: function (flag) {
                    return this._hasFlag(this.flags, flag);
                  },
                  setRectangle: function (rectangle) {
                    isArray(rectangle) && 4 === rectangle.length
                      ? (this.rectangle = Util.normalizeRect(rectangle))
                      : (this.rectangle = [0, 0, 0, 0]);
                  },
                  setColor: function (color) {
                    var rgbColor = new Uint8Array(3);
                    if (!isArray(color)) return void (this.color = rgbColor);
                    switch (color.length) {
                      case 0:
                        this.color = null;
                        break;
                      case 1:
                        ColorSpace.singletons.gray.getRgbItem(color, 0, rgbColor, 0), (this.color = rgbColor);
                        break;
                      case 3:
                        ColorSpace.singletons.rgb.getRgbItem(color, 0, rgbColor, 0), (this.color = rgbColor);
                        break;
                      case 4:
                        ColorSpace.singletons.cmyk.getRgbItem(color, 0, rgbColor, 0), (this.color = rgbColor);
                        break;
                      default:
                        this.color = rgbColor;
                    }
                  },
                  setBorderStyle: function (borderStyle) {
                    if (((this.borderStyle = new AnnotationBorderStyle()), isDict(borderStyle)))
                      if (borderStyle.has("BS")) {
                        var dict = borderStyle.get("BS"),
                          dictType = dict.get("Type");
                        (dictType && !isName(dictType, "Border")) ||
                          (this.borderStyle.setWidth(dict.get("W")),
                          this.borderStyle.setStyle(dict.get("S")),
                          this.borderStyle.setDashArray(dict.getArray("D")));
                      } else if (borderStyle.has("Border")) {
                        var array = borderStyle.getArray("Border");
                        isArray(array) &&
                          array.length >= 3 &&
                          (this.borderStyle.setHorizontalCornerRadius(array[0]),
                          this.borderStyle.setVerticalCornerRadius(array[1]),
                          this.borderStyle.setWidth(array[2]),
                          4 === array.length && this.borderStyle.setDashArray(array[3]));
                      } else this.borderStyle.setWidth(0);
                  },
                  _preparePopup: function (dict) {
                    dict.has("C") || (this.data.color = null),
                      (this.data.hasPopup = dict.has("Popup")),
                      (this.data.title = stringToPDFString(dict.get("T") || "")),
                      (this.data.contents = stringToPDFString(dict.get("Contents") || ""));
                  },
                  loadResources: function (keys) {
                    return new Promise(
                      function (resolve, reject) {
                        this.appearance.dict.getAsync("Resources").then(function (resources) {
                          if (!resources) return void resolve();
                          new ObjectLoader(resources.map, keys, resources.xref).load().then(function () {
                            resolve(resources);
                          }, reject);
                        }, reject);
                      }.bind(this)
                    );
                  },
                  getOperatorList: function (evaluator, task, renderForms) {
                    if (!this.appearance) return Promise.resolve(new OperatorList());
                    var data = this.data,
                      appearanceDict = this.appearance.dict,
                      resourcesPromise = this.loadResources([
                        "ExtGState",
                        "ColorSpace",
                        "Pattern",
                        "Shading",
                        "XObject",
                        "Font",
                      ]),
                      bbox = appearanceDict.getArray("BBox") || [0, 0, 1, 1],
                      matrix = appearanceDict.getArray("Matrix") || [1, 0, 0, 1, 0, 0],
                      transform = getTransformMatrix(data.rect, bbox, matrix),
                      self = this;
                    return resourcesPromise.then(function (resources) {
                      var opList = new OperatorList();
                      return (
                        opList.addOp(OPS.beginAnnotation, [data.rect, transform, matrix]),
                        evaluator.getOperatorList(self.appearance, task, resources, opList).then(function () {
                          return opList.addOp(OPS.endAnnotation, []), self.appearance.reset(), opList;
                        })
                      );
                    });
                  },
                }),
                (Annotation.appendToOperatorList = function (
                  annotations,
                  opList,
                  partialEvaluator,
                  task,
                  intent,
                  renderForms
                ) {
                  for (var annotationPromises = [], i = 0, n = annotations.length; i < n; ++i)
                    (("display" === intent && annotations[i].viewable) ||
                      ("print" === intent && annotations[i].printable)) &&
                      annotationPromises.push(annotations[i].getOperatorList(partialEvaluator, task, renderForms));
                  return Promise.all(annotationPromises).then(function (operatorLists) {
                    opList.addOp(OPS.beginAnnotations, []);
                    for (var i = 0, n = operatorLists.length; i < n; ++i) opList.addOpList(operatorLists[i]);
                    opList.addOp(OPS.endAnnotations, []);
                  });
                }),
                Annotation
              );
            })(),
            AnnotationBorderStyle = (function () {
              function AnnotationBorderStyle() {
                (this.width = 1),
                  (this.style = AnnotationBorderStyleType.SOLID),
                  (this.dashArray = [3]),
                  (this.horizontalCornerRadius = 0),
                  (this.verticalCornerRadius = 0);
              }
              return (
                (AnnotationBorderStyle.prototype = {
                  setWidth: function (width) {
                    width === (0 | width) && (this.width = width);
                  },
                  setStyle: function (style) {
                    if (style)
                      switch (style.name) {
                        case "S":
                          this.style = AnnotationBorderStyleType.SOLID;
                          break;
                        case "D":
                          this.style = AnnotationBorderStyleType.DASHED;
                          break;
                        case "B":
                          this.style = AnnotationBorderStyleType.BEVELED;
                          break;
                        case "I":
                          this.style = AnnotationBorderStyleType.INSET;
                          break;
                        case "U":
                          this.style = AnnotationBorderStyleType.UNDERLINE;
                      }
                  },
                  setDashArray: function (dashArray) {
                    if (isArray(dashArray) && dashArray.length > 0) {
                      for (var isValid = !0, allZeros = !0, i = 0, len = dashArray.length; i < len; i++) {
                        var element = dashArray[i];
                        if (!(+element >= 0)) {
                          isValid = !1;
                          break;
                        }
                        element > 0 && (allZeros = !1);
                      }
                      isValid && !allZeros ? (this.dashArray = dashArray) : (this.width = 0);
                    } else dashArray && (this.width = 0);
                  },
                  setHorizontalCornerRadius: function (radius) {
                    radius === (0 | radius) && (this.horizontalCornerRadius = radius);
                  },
                  setVerticalCornerRadius: function (radius) {
                    radius === (0 | radius) && (this.verticalCornerRadius = radius);
                  },
                }),
                AnnotationBorderStyle
              );
            })(),
            WidgetAnnotation = (function () {
              function WidgetAnnotation(params) {
                Annotation.call(this, params);
                var dict = params.dict,
                  data = this.data;
                (data.annotationType = AnnotationType.WIDGET),
                  (data.fieldValue = stringToPDFString(Util.getInheritableProperty(dict, "V") || "")),
                  (data.alternativeText = stringToPDFString(dict.get("TU") || "")),
                  (data.defaultAppearance = Util.getInheritableProperty(dict, "DA") || "");
                var fieldType = Util.getInheritableProperty(dict, "FT");
                (data.fieldType = isName(fieldType) ? fieldType.name : null),
                  (this.fieldResources = Util.getInheritableProperty(dict, "DR") || Dict.empty),
                  (data.fieldFlags = Util.getInheritableProperty(dict, "Ff")),
                  (!isInt(data.fieldFlags) || data.fieldFlags < 0) && (data.fieldFlags = 0),
                  "Sig" === data.fieldType && this.setFlags(AnnotationFlag.HIDDEN);
                for (var fieldName = [], namedItem = dict, ref = params.ref; namedItem; ) {
                  var parent = namedItem.get("Parent"),
                    parentRef = namedItem.getRaw("Parent"),
                    name = namedItem.get("T");
                  if (name) fieldName.unshift(stringToPDFString(name));
                  else if (parent && ref) {
                    var j,
                      jj,
                      kids = parent.get("Kids");
                    for (j = 0, jj = kids.length; j < jj; j++) {
                      var kidRef = kids[j];
                      if (kidRef.num === ref.num && kidRef.gen === ref.gen) break;
                    }
                    fieldName.unshift("`" + j);
                  }
                  (namedItem = parent), (ref = parentRef);
                }
                data.fullName = fieldName.join(".");
              }
              return (
                Util.inherit(WidgetAnnotation, Annotation, {
                  hasFieldFlag: function (flag) {
                    return !!(this.data.fieldFlags & flag);
                  },
                }),
                WidgetAnnotation
              );
            })(),
            TextWidgetAnnotation = (function () {
              function TextWidgetAnnotation(params) {
                WidgetAnnotation.call(this, params);
                var alignment = Util.getInheritableProperty(params.dict, "Q");
                (!isInt(alignment) || alignment < 0 || alignment > 2) && (alignment = null),
                  (this.data.textAlignment = alignment);
                var maximumLength = Util.getInheritableProperty(params.dict, "MaxLen");
                (!isInt(maximumLength) || maximumLength < 0) && (maximumLength = null),
                  (this.data.maxLen = maximumLength),
                  (this.data.readOnly = this.hasFieldFlag(AnnotationFieldFlag.READONLY)),
                  (this.data.multiLine = this.hasFieldFlag(AnnotationFieldFlag.MULTILINE)),
                  (this.data.comb =
                    this.hasFieldFlag(AnnotationFieldFlag.COMB) &&
                    !this.hasFieldFlag(AnnotationFieldFlag.MULTILINE) &&
                    !this.hasFieldFlag(AnnotationFieldFlag.PASSWORD) &&
                    !this.hasFieldFlag(AnnotationFieldFlag.FILESELECT) &&
                    null !== this.data.maxLen);
              }
              return (
                Util.inherit(TextWidgetAnnotation, WidgetAnnotation, {
                  getOperatorList: function (evaluator, task, renderForms) {
                    var operatorList = new OperatorList();
                    if (renderForms) return Promise.resolve(operatorList);
                    if (this.appearance)
                      return Annotation.prototype.getOperatorList.call(this, evaluator, task, renderForms);
                    if (!this.data.defaultAppearance) return Promise.resolve(operatorList);
                    var stream = new Stream(stringToBytes(this.data.defaultAppearance));
                    return evaluator.getOperatorList(stream, task, this.fieldResources, operatorList).then(function () {
                      return operatorList;
                    });
                  },
                }),
                TextWidgetAnnotation
              );
            })(),
            TextAnnotation = (function () {
              function TextAnnotation(parameters) {
                Annotation.call(this, parameters),
                  (this.data.annotationType = AnnotationType.TEXT),
                  this.data.hasAppearance
                    ? (this.data.name = "NoIcon")
                    : ((this.data.rect[1] = this.data.rect[3] - DEFAULT_ICON_SIZE),
                      (this.data.rect[2] = this.data.rect[0] + DEFAULT_ICON_SIZE),
                      (this.data.name = parameters.dict.has("Name") ? parameters.dict.get("Name").name : "Note")),
                  this._preparePopup(parameters.dict);
              }
              var DEFAULT_ICON_SIZE = 22;
              return Util.inherit(TextAnnotation, Annotation, {}), TextAnnotation;
            })(),
            LinkAnnotation = (function () {
              function LinkAnnotation(params) {
                Annotation.call(this, params);
                var dict = params.dict,
                  data = this.data;
                data.annotationType = AnnotationType.LINK;
                var url,
                  dest,
                  action = dict.get("A");
                if (action && isDict(action)) {
                  var linkType = action.get("S").name;
                  switch (linkType) {
                    case "URI":
                      (url = action.get("URI")),
                        isName(url) ? (url = "/" + url.name) : url && (url = addDefaultProtocolToUrl(url));
                      break;
                    case "GoTo":
                      dest = action.get("D");
                      break;
                    case "GoToR":
                      var urlDict = action.get("F");
                      isDict(urlDict) ? (url = urlDict.get("F") || null) : isString(urlDict) && (url = urlDict);
                      var remoteDest = action.get("D");
                      if (remoteDest && (isName(remoteDest) && (remoteDest = remoteDest.name), isString(url))) {
                        var baseUrl = url.split("#")[0];
                        isString(remoteDest)
                          ? (url = baseUrl + "#" + (/^\d+$/.test(remoteDest) ? "nameddest=" : "") + remoteDest)
                          : isArray(remoteDest) && (url = baseUrl + "#" + JSON.stringify(remoteDest));
                      }
                      var newWindow = action.get("NewWindow");
                      isBool(newWindow) && (data.newWindow = newWindow);
                      break;
                    case "Named":
                      data.action = action.get("N").name;
                      break;
                    default:
                      warn("unrecognized link type: " + linkType);
                  }
                } else dict.has("Dest") && (dest = dict.get("Dest"));
                url && isValidUrl(url, !1) && (data.url = tryConvertUrlEncoding(url)),
                  dest && (data.dest = isName(dest) ? dest.name : dest);
              }
              function addDefaultProtocolToUrl(url) {
                return isString(url) && 0 === url.indexOf("www.") ? "http://" + url : url;
              }
              function tryConvertUrlEncoding(url) {
                try {
                  return stringToUTF8String(url);
                } catch (e) {
                  return url;
                }
              }
              return Util.inherit(LinkAnnotation, Annotation, {}), LinkAnnotation;
            })(),
            PopupAnnotation = (function () {
              function PopupAnnotation(parameters) {
                Annotation.call(this, parameters), (this.data.annotationType = AnnotationType.POPUP);
                var dict = parameters.dict,
                  parentItem = dict.get("Parent");
                if (!parentItem) return void warn("Popup annotation has a missing or invalid parent annotation.");
                if (
                  ((this.data.parentId = dict.getRaw("Parent").toString()),
                  (this.data.title = stringToPDFString(parentItem.get("T") || "")),
                  (this.data.contents = stringToPDFString(parentItem.get("Contents") || "")),
                  parentItem.has("C")
                    ? (this.setColor(parentItem.getArray("C")), (this.data.color = this.color))
                    : (this.data.color = null),
                  !this.viewable)
                ) {
                  var parentFlags = parentItem.get("F");
                  this._isViewable(parentFlags) && this.setFlags(parentFlags);
                }
              }
              return Util.inherit(PopupAnnotation, Annotation, {}), PopupAnnotation;
            })(),
            HighlightAnnotation = (function () {
              function HighlightAnnotation(parameters) {
                Annotation.call(this, parameters),
                  (this.data.annotationType = AnnotationType.HIGHLIGHT),
                  this._preparePopup(parameters.dict),
                  this.data.borderStyle.setWidth(0);
              }
              return Util.inherit(HighlightAnnotation, Annotation, {}), HighlightAnnotation;
            })(),
            UnderlineAnnotation = (function () {
              function UnderlineAnnotation(parameters) {
                Annotation.call(this, parameters),
                  (this.data.annotationType = AnnotationType.UNDERLINE),
                  this._preparePopup(parameters.dict),
                  this.data.borderStyle.setWidth(0);
              }
              return Util.inherit(UnderlineAnnotation, Annotation, {}), UnderlineAnnotation;
            })(),
            SquigglyAnnotation = (function () {
              function SquigglyAnnotation(parameters) {
                Annotation.call(this, parameters),
                  (this.data.annotationType = AnnotationType.SQUIGGLY),
                  this._preparePopup(parameters.dict),
                  this.data.borderStyle.setWidth(0);
              }
              return Util.inherit(SquigglyAnnotation, Annotation, {}), SquigglyAnnotation;
            })(),
            StrikeOutAnnotation = (function () {
              function StrikeOutAnnotation(parameters) {
                Annotation.call(this, parameters),
                  (this.data.annotationType = AnnotationType.STRIKEOUT),
                  this._preparePopup(parameters.dict),
                  this.data.borderStyle.setWidth(0);
              }
              return Util.inherit(StrikeOutAnnotation, Annotation, {}), StrikeOutAnnotation;
            })(),
            FileAttachmentAnnotation = (function () {
              function FileAttachmentAnnotation(parameters) {
                Annotation.call(this, parameters);
                var file = new FileSpec(parameters.dict.get("FS"), parameters.xref);
                (this.data.annotationType = AnnotationType.FILEATTACHMENT),
                  (this.data.file = file.serializable),
                  this._preparePopup(parameters.dict);
              }
              return Util.inherit(FileAttachmentAnnotation, Annotation, {}), FileAttachmentAnnotation;
            })();
          (exports.Annotation = Annotation),
            (exports.AnnotationBorderStyle = AnnotationBorderStyle),
            (exports.AnnotationFactory = AnnotationFactory);
        })(
          (root.pdfjsCoreAnnotation = {}),
          root.pdfjsSharedUtil,
          root.pdfjsCorePrimitives,
          root.pdfjsCoreStream,
          root.pdfjsCoreColorSpace,
          root.pdfjsCoreObj,
          root.pdfjsCoreEvaluator
        );
      })(this),
      (function (root, factory) {
        !(function (
          exports,
          sharedUtil,
          corePrimitives,
          coreStream,
          coreObj,
          coreParser,
          coreCrypto,
          coreEvaluator,
          coreAnnotation
        ) {
          var MissingDataException = sharedUtil.MissingDataException,
            Util = sharedUtil.Util,
            assert = sharedUtil.assert,
            error = sharedUtil.error,
            info = sharedUtil.info,
            isArray = sharedUtil.isArray,
            isArrayBuffer = sharedUtil.isArrayBuffer,
            isString = sharedUtil.isString,
            shadow = sharedUtil.shadow,
            stringToBytes = sharedUtil.stringToBytes,
            stringToPDFString = sharedUtil.stringToPDFString,
            warn = sharedUtil.warn,
            isSpace = sharedUtil.isSpace,
            Dict = corePrimitives.Dict,
            isDict = corePrimitives.isDict,
            isName = corePrimitives.isName,
            isStream = corePrimitives.isStream,
            NullStream = coreStream.NullStream,
            Stream = coreStream.Stream,
            StreamsSequenceStream = coreStream.StreamsSequenceStream,
            Catalog = coreObj.Catalog,
            ObjectLoader = coreObj.ObjectLoader,
            XRef = coreObj.XRef,
            Linearization = coreParser.Linearization,
            calculateMD5 = coreCrypto.calculateMD5,
            OperatorList = coreEvaluator.OperatorList,
            PartialEvaluator = coreEvaluator.PartialEvaluator,
            Annotation = coreAnnotation.Annotation,
            AnnotationFactory = coreAnnotation.AnnotationFactory,
            Page = (function () {
              function Page(pdfManager, xref, pageIndex, pageDict, ref, fontCache) {
                (this.pdfManager = pdfManager),
                  (this.pageIndex = pageIndex),
                  (this.pageDict = pageDict),
                  (this.xref = xref),
                  (this.ref = ref),
                  (this.fontCache = fontCache),
                  (this.uniquePrefix = "p" + this.pageIndex + "_"),
                  (this.idCounters = { obj: 0 }),
                  (this.evaluatorOptions = pdfManager.evaluatorOptions),
                  (this.resourcesPromise = null);
              }
              var LETTER_SIZE_MEDIABOX = [0, 0, 612, 792];
              return (
                (Page.prototype = {
                  getPageProp: function (key) {
                    return this.pageDict.get(key);
                  },
                  getInheritedPageProp: function (key) {
                    for (var dict = this.pageDict, valueArray = null, loopCount = 0; dict; ) {
                      var value = dict.get(key);
                      if ((value && (valueArray || (valueArray = []), valueArray.push(value)), ++loopCount > 100)) {
                        warn("Page_getInheritedPageProp: maximum loop count exceeded.");
                        break;
                      }
                      dict = dict.get("Parent");
                    }
                    return valueArray
                      ? 1 === valueArray.length || !isDict(valueArray[0]) || loopCount > 100
                        ? valueArray[0]
                        : Dict.merge(this.xref, valueArray)
                      : Dict.empty;
                  },
                  get content() {
                    return this.getPageProp("Contents");
                  },
                  get resources() {
                    return shadow(this, "resources", this.getInheritedPageProp("Resources"));
                  },
                  get mediaBox() {
                    var obj = this.getInheritedPageProp("MediaBox");
                    return (
                      (isArray(obj) && 4 === obj.length) || (obj = LETTER_SIZE_MEDIABOX), shadow(this, "mediaBox", obj)
                    );
                  },
                  get view() {
                    var mediaBox = this.mediaBox,
                      cropBox = this.getInheritedPageProp("CropBox");
                    return isArray(cropBox) && 4 === cropBox.length
                      ? ((cropBox = Util.intersect(cropBox, mediaBox)),
                        cropBox ? shadow(this, "view", cropBox) : shadow(this, "view", mediaBox))
                      : shadow(this, "view", mediaBox);
                  },
                  get rotate() {
                    var rotate = this.getInheritedPageProp("Rotate") || 0;
                    return (
                      rotate % 90 != 0
                        ? (rotate = 0)
                        : rotate >= 360
                        ? (rotate %= 360)
                        : rotate < 0 && (rotate = ((rotate % 360) + 360) % 360),
                      shadow(this, "rotate", rotate)
                    );
                  },
                  getContentStream: function () {
                    var stream,
                      content = this.content;
                    if (isArray(content)) {
                      var i,
                        xref = this.xref,
                        n = content.length,
                        streams = [];
                      for (i = 0; i < n; ++i) streams.push(xref.fetchIfRef(content[i]));
                      stream = new StreamsSequenceStream(streams);
                    } else stream = isStream(content) ? content : new NullStream();
                    return stream;
                  },
                  loadResources: function (keys) {
                    return (
                      this.resourcesPromise || (this.resourcesPromise = this.pdfManager.ensure(this, "resources")),
                      this.resourcesPromise.then(
                        function () {
                          return new ObjectLoader(this.resources.map, keys, this.xref).load();
                        }.bind(this)
                      )
                    );
                  },
                  getOperatorList: function (handler, task, intent, renderInteractiveForms) {
                    var self = this,
                      pdfManager = this.pdfManager,
                      contentStreamPromise = pdfManager.ensure(this, "getContentStream", []),
                      resourcesPromise = this.loadResources([
                        "ExtGState",
                        "ColorSpace",
                        "Pattern",
                        "Shading",
                        "XObject",
                        "Font",
                      ]),
                      partialEvaluator = new PartialEvaluator(
                        pdfManager,
                        this.xref,
                        handler,
                        this.pageIndex,
                        this.uniquePrefix,
                        this.idCounters,
                        this.fontCache,
                        this.evaluatorOptions
                      ),
                      dataPromises = Promise.all([contentStreamPromise, resourcesPromise]),
                      pageListPromise = dataPromises.then(function (data) {
                        var contentStream = data[0],
                          opList = new OperatorList(intent, handler, self.pageIndex);
                        return (
                          handler.send("StartRenderPage", {
                            transparency: partialEvaluator.hasBlendModes(self.resources),
                            pageIndex: self.pageIndex,
                            intent: intent,
                          }),
                          partialEvaluator
                            .getOperatorList(contentStream, task, self.resources, opList)
                            .then(function () {
                              return opList;
                            })
                        );
                      }),
                      annotationsPromise = pdfManager.ensure(this, "annotations");
                    return Promise.all([pageListPromise, annotationsPromise]).then(function (datas) {
                      var pageOpList = datas[0],
                        annotations = datas[1];
                      return 0 === annotations.length
                        ? (pageOpList.flush(!0), pageOpList)
                        : Annotation.appendToOperatorList(
                            annotations,
                            pageOpList,
                            partialEvaluator,
                            task,
                            intent,
                            renderInteractiveForms
                          ).then(function () {
                            return pageOpList.flush(!0), pageOpList;
                          });
                    });
                  },
                  extractTextContent: function (task, normalizeWhitespace, combineTextItems) {
                    var handler = { on: function () {}, send: function () {} },
                      self = this,
                      pdfManager = this.pdfManager,
                      contentStreamPromise = pdfManager.ensure(this, "getContentStream", []),
                      resourcesPromise = this.loadResources(["ExtGState", "XObject", "Font"]);
                    return Promise.all([contentStreamPromise, resourcesPromise]).then(function (data) {
                      var contentStream = data[0];
                      return new PartialEvaluator(
                        pdfManager,
                        self.xref,
                        handler,
                        self.pageIndex,
                        self.uniquePrefix,
                        self.idCounters,
                        self.fontCache,
                        self.evaluatorOptions
                      ).getTextContent(
                        contentStream,
                        task,
                        self.resources,
                        null,
                        normalizeWhitespace,
                        combineTextItems
                      );
                    });
                  },
                  getAnnotationsData: function (intent) {
                    for (
                      var annotations = this.annotations, annotationsData = [], i = 0, n = annotations.length;
                      i < n;
                      ++i
                    )
                      (!intent ||
                        ("display" === intent && annotations[i].viewable) ||
                        ("print" === intent && annotations[i].printable)) &&
                        annotationsData.push(annotations[i].data);
                    return annotationsData;
                  },
                  get annotations() {
                    for (
                      var annotations = [],
                        annotationRefs = this.getInheritedPageProp("Annots") || [],
                        annotationFactory = new AnnotationFactory(),
                        i = 0,
                        n = annotationRefs.length;
                      i < n;
                      ++i
                    ) {
                      var annotationRef = annotationRefs[i],
                        annotation = annotationFactory.create(
                          this.xref,
                          annotationRef,
                          this.uniquePrefix,
                          this.idCounters
                        );
                      annotation && annotations.push(annotation);
                    }
                    return shadow(this, "annotations", annotations);
                  },
                }),
                Page
              );
            })(),
            PDFDocument = (function () {
              function PDFDocument(pdfManager, arg, password) {
                isStream(arg)
                  ? init.call(this, pdfManager, arg, password)
                  : isArrayBuffer(arg)
                  ? init.call(this, pdfManager, new Stream(arg), password)
                  : error("PDFDocument: Unknown argument type");
              }
              function init(pdfManager, stream, password) {
                assert(stream.length > 0, "stream must have data"),
                  (this.pdfManager = pdfManager),
                  (this.stream = stream);
                var xref = new XRef(this.stream, password, pdfManager);
                this.xref = xref;
              }
              function find(stream, needle, limit, backwards) {
                var pos = stream.pos,
                  end = stream.end,
                  strBuf = [];
                pos + limit > end && (limit = end - pos);
                for (var n = 0; n < limit; ++n) strBuf.push(String.fromCharCode(stream.getByte()));
                var str = strBuf.join("");
                stream.pos = pos;
                var index = backwards ? str.lastIndexOf(needle) : str.indexOf(needle);
                return -1 !== index && ((stream.pos += index), !0);
              }
              var FINGERPRINT_FIRST_BYTES = 1024,
                DocumentInfoValidators = {
                  get entries() {
                    return shadow(this, "entries", {
                      Title: isString,
                      Author: isString,
                      Subject: isString,
                      Keywords: isString,
                      Creator: isString,
                      Producer: isString,
                      CreationDate: isString,
                      ModDate: isString,
                      Trapped: isName,
                    });
                  },
                };
              return (
                (PDFDocument.prototype = {
                  parse: function (recoveryMode) {
                    this.setup(recoveryMode);
                    var version = this.catalog.catDict.get("Version");
                    isName(version) && (this.pdfFormatVersion = version.name);
                    try {
                      if (((this.acroForm = this.catalog.catDict.get("AcroForm")), this.acroForm)) {
                        this.xfa = this.acroForm.get("XFA");
                        var fields = this.acroForm.get("Fields");
                        (fields && isArray(fields) && 0 !== fields.length) || this.xfa || (this.acroForm = null);
                      }
                    } catch (ex) {
                      info("Something wrong with AcroForm entry"), (this.acroForm = null);
                    }
                  },
                  get linearization() {
                    var linearization = null;
                    if (this.stream.length)
                      try {
                        linearization = Linearization.create(this.stream);
                      } catch (err) {
                        if (err instanceof MissingDataException) throw err;
                        info(err);
                      }
                    return shadow(this, "linearization", linearization);
                  },
                  get startXRef() {
                    var stream = this.stream,
                      startXRef = 0;
                    if (this.linearization)
                      stream.reset(), find(stream, "endobj", 1024) && (startXRef = stream.pos + 6);
                    else {
                      for (var found = !1, pos = stream.end; !found && pos > 0; )
                        (pos -= 1024 - "startxref".length),
                          pos < 0 && (pos = 0),
                          (stream.pos = pos),
                          (found = find(stream, "startxref", 1024, !0));
                      if (found) {
                        stream.skip(9);
                        var ch;
                        do {
                          ch = stream.getByte();
                        } while (isSpace(ch));
                        for (var str = ""; ch >= 32 && ch <= 57; )
                          (str += String.fromCharCode(ch)), (ch = stream.getByte());
                        (startXRef = parseInt(str, 10)), isNaN(startXRef) && (startXRef = 0);
                      }
                    }
                    return shadow(this, "startXRef", startXRef);
                  },
                  get mainXRefEntriesOffset() {
                    var mainXRefEntriesOffset = 0,
                      linearization = this.linearization;
                    return (
                      linearization && (mainXRefEntriesOffset = linearization.mainXRefEntriesOffset),
                      shadow(this, "mainXRefEntriesOffset", mainXRefEntriesOffset)
                    );
                  },
                  checkHeader: function () {
                    var stream = this.stream;
                    if ((stream.reset(), find(stream, "%PDF-", 1024))) {
                      stream.moveStart();
                      for (var ch, version = ""; (ch = stream.getByte()) > 32 && !(version.length >= 12); )
                        version += String.fromCharCode(ch);
                      return void (this.pdfFormatVersion || (this.pdfFormatVersion = version.substring(5)));
                    }
                  },
                  parseStartXRef: function () {
                    var startXRef = this.startXRef;
                    this.xref.setStartXRef(startXRef);
                  },
                  setup: function (recoveryMode) {
                    this.xref.parse(recoveryMode);
                    var self = this,
                      pageFactory = {
                        createPage: function (pageIndex, dict, ref, fontCache) {
                          return new Page(self.pdfManager, self.xref, pageIndex, dict, ref, fontCache);
                        },
                      };
                    this.catalog = new Catalog(this.pdfManager, this.xref, pageFactory);
                  },
                  get numPages() {
                    var linearization = this.linearization,
                      num = linearization ? linearization.numPages : this.catalog.numPages;
                    return shadow(this, "numPages", num);
                  },
                  get documentInfo() {
                    var infoDict,
                      docInfo = {
                        PDFFormatVersion: this.pdfFormatVersion,
                        IsAcroFormPresent: !!this.acroForm,
                        IsXFAPresent: !!this.xfa,
                      };
                    try {
                      infoDict = this.xref.trailer.get("Info");
                    } catch (err) {
                      info("The document information dictionary is invalid.");
                    }
                    if (infoDict) {
                      var validEntries = DocumentInfoValidators.entries;
                      for (var key in validEntries)
                        if (infoDict.has(key)) {
                          var value = infoDict.get(key);
                          validEntries[key](value)
                            ? (docInfo[key] = "string" != typeof value ? value : stringToPDFString(value))
                            : info('Bad value in document info for "' + key + '"');
                        }
                    }
                    return shadow(this, "documentInfo", docInfo);
                  },
                  get fingerprint() {
                    var hash,
                      xref = this.xref,
                      fileID = "",
                      idArray = xref.trailer.get("ID");
                    idArray &&
                    isArray(idArray) &&
                    idArray[0] &&
                    isString(idArray[0]) &&
                    "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0" !== idArray[0]
                      ? (hash = stringToBytes(idArray[0]))
                      : (this.stream.ensureRange &&
                          this.stream.ensureRange(0, Math.min(FINGERPRINT_FIRST_BYTES, this.stream.end)),
                        (hash = calculateMD5(
                          this.stream.bytes.subarray(0, FINGERPRINT_FIRST_BYTES),
                          0,
                          FINGERPRINT_FIRST_BYTES
                        )));
                    for (var i = 0, n = hash.length; i < n; i++) {
                      var hex = hash[i].toString(16);
                      fileID += 1 === hex.length ? "0" + hex : hex;
                    }
                    return shadow(this, "fingerprint", fileID);
                  },
                  getPage: function (pageIndex) {
                    return this.catalog.getPage(pageIndex);
                  },
                  cleanup: function () {
                    return this.catalog.cleanup();
                  },
                }),
                PDFDocument
              );
            })();
          (exports.Page = Page), (exports.PDFDocument = PDFDocument);
        })(
          (root.pdfjsCoreDocument = {}),
          root.pdfjsSharedUtil,
          root.pdfjsCorePrimitives,
          root.pdfjsCoreStream,
          root.pdfjsCoreObj,
          root.pdfjsCoreParser,
          root.pdfjsCoreCrypto,
          root.pdfjsCoreEvaluator,
          root.pdfjsCoreAnnotation
        );
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, coreStream, coreChunkedStream, coreDocument) {
          var NotImplementedException = sharedUtil.NotImplementedException,
            MissingDataException = sharedUtil.MissingDataException,
            createPromiseCapability = sharedUtil.createPromiseCapability,
            Util = sharedUtil.Util,
            Stream = coreStream.Stream,
            ChunkedStreamManager = coreChunkedStream.ChunkedStreamManager,
            PDFDocument = coreDocument.PDFDocument,
            BasePdfManager = (function () {
              function BasePdfManager() {
                throw new Error("Cannot initialize BaseManagerManager");
              }
              return (
                (BasePdfManager.prototype = {
                  get docId() {
                    return this._docId;
                  },
                  onLoadedStream: function () {
                    throw new NotImplementedException();
                  },
                  ensureDoc: function (prop, args) {
                    return this.ensure(this.pdfDocument, prop, args);
                  },
                  ensureXRef: function (prop, args) {
                    return this.ensure(this.pdfDocument.xref, prop, args);
                  },
                  ensureCatalog: function (prop, args) {
                    return this.ensure(this.pdfDocument.catalog, prop, args);
                  },
                  getPage: function (pageIndex) {
                    return this.pdfDocument.getPage(pageIndex);
                  },
                  cleanup: function () {
                    return this.pdfDocument.cleanup();
                  },
                  ensure: function (obj, prop, args) {
                    return new NotImplementedException();
                  },
                  requestRange: function (begin, end) {
                    return new NotImplementedException();
                  },
                  requestLoadedStream: function () {
                    return new NotImplementedException();
                  },
                  sendProgressiveData: function (chunk) {
                    return new NotImplementedException();
                  },
                  updatePassword: function (password) {
                    (this.pdfDocument.xref.password = this.password = password),
                      this._passwordChangedCapability && this._passwordChangedCapability.resolve();
                  },
                  passwordChanged: function () {
                    return (
                      (this._passwordChangedCapability = createPromiseCapability()),
                      this._passwordChangedCapability.promise
                    );
                  },
                  terminate: function () {
                    return new NotImplementedException();
                  },
                }),
                BasePdfManager
              );
            })(),
            LocalPdfManager = (function () {
              function LocalPdfManager(docId, data, password, evaluatorOptions) {
                (this._docId = docId), (this.evaluatorOptions = evaluatorOptions);
                var stream = new Stream(data);
                (this.pdfDocument = new PDFDocument(this, stream, password)),
                  (this._loadedStreamCapability = createPromiseCapability()),
                  this._loadedStreamCapability.resolve(stream);
              }
              return (
                Util.inherit(LocalPdfManager, BasePdfManager, {
                  ensure: function (obj, prop, args) {
                    return new Promise(function (resolve, reject) {
                      try {
                        var result,
                          value = obj[prop];
                        (result = "function" == typeof value ? value.apply(obj, args) : value), resolve(result);
                      } catch (e) {
                        reject(e);
                      }
                    });
                  },
                  requestRange: function (begin, end) {
                    return Promise.resolve();
                  },
                  requestLoadedStream: function () {},
                  onLoadedStream: function () {
                    return this._loadedStreamCapability.promise;
                  },
                  terminate: function () {},
                }),
                LocalPdfManager
              );
            })(),
            NetworkPdfManager = (function () {
              function NetworkPdfManager(docId, pdfNetworkStream, args, evaluatorOptions) {
                (this._docId = docId), (this.msgHandler = args.msgHandler), (this.evaluatorOptions = evaluatorOptions);
                var params = {
                  msgHandler: args.msgHandler,
                  url: args.url,
                  length: args.length,
                  disableAutoFetch: args.disableAutoFetch,
                  rangeChunkSize: args.rangeChunkSize,
                };
                (this.streamManager = new ChunkedStreamManager(pdfNetworkStream, params)),
                  (this.pdfDocument = new PDFDocument(this, this.streamManager.getStream(), args.password));
              }
              return (
                Util.inherit(NetworkPdfManager, BasePdfManager, {
                  ensure: function (obj, prop, args) {
                    var pdfManager = this;
                    return new Promise(function (resolve, reject) {
                      function ensureHelper() {
                        try {
                          var result,
                            value = obj[prop];
                          (result = "function" == typeof value ? value.apply(obj, args) : value), resolve(result);
                        } catch (e) {
                          if (!(e instanceof MissingDataException)) return void reject(e);
                          pdfManager.streamManager.requestRange(e.begin, e.end).then(ensureHelper, reject);
                        }
                      }
                      ensureHelper();
                    });
                  },
                  requestRange: function (begin, end) {
                    return this.streamManager.requestRange(begin, end);
                  },
                  requestLoadedStream: function () {
                    this.streamManager.requestAllChunks();
                  },
                  sendProgressiveData: function (chunk) {
                    this.streamManager.onReceiveData({ chunk: chunk });
                  },
                  onLoadedStream: function () {
                    return this.streamManager.onLoadedStream();
                  },
                  terminate: function () {
                    this.streamManager.abort();
                  },
                }),
                NetworkPdfManager
              );
            })();
          (exports.LocalPdfManager = LocalPdfManager), (exports.NetworkPdfManager = NetworkPdfManager);
        })(
          (root.pdfjsCorePdfManager = {}),
          root.pdfjsSharedUtil,
          root.pdfjsCoreStream,
          root.pdfjsCoreChunkedStream,
          root.pdfjsCoreDocument
        );
      })(this),
      (function (root, factory) {
        !(function (exports, sharedUtil, corePrimitives, corePdfManager) {
          function setPDFNetworkStreamClass(cls) {
            PDFNetworkStream = cls;
          }
          var PDFNetworkStream,
            UNSUPPORTED_FEATURES = sharedUtil.UNSUPPORTED_FEATURES,
            InvalidPDFException = sharedUtil.InvalidPDFException,
            MessageHandler = sharedUtil.MessageHandler,
            MissingPDFException = sharedUtil.MissingPDFException,
            UnexpectedResponseException = sharedUtil.UnexpectedResponseException,
            PasswordException = sharedUtil.PasswordException,
            PasswordResponses = sharedUtil.PasswordResponses,
            UnknownErrorException = sharedUtil.UnknownErrorException,
            XRefParseException = sharedUtil.XRefParseException,
            arrayByteLength = sharedUtil.arrayByteLength,
            arraysToBytes = sharedUtil.arraysToBytes,
            assert = sharedUtil.assert,
            createPromiseCapability = sharedUtil.createPromiseCapability,
            error = sharedUtil.error,
            info = sharedUtil.info,
            warn = sharedUtil.warn,
            setVerbosityLevel = sharedUtil.setVerbosityLevel,
            Ref = corePrimitives.Ref,
            LocalPdfManager = corePdfManager.LocalPdfManager,
            NetworkPdfManager = corePdfManager.NetworkPdfManager,
            globalScope = sharedUtil.globalScope,
            WorkerTask = (function () {
              function WorkerTask(name) {
                (this.name = name), (this.terminated = !1), (this._capability = createPromiseCapability());
              }
              return (
                (WorkerTask.prototype = {
                  get finished() {
                    return this._capability.promise;
                  },
                  finish: function () {
                    this._capability.resolve();
                  },
                  terminate: function () {
                    this.terminated = !0;
                  },
                  ensureNotTerminated: function () {
                    if (this.terminated) throw new Error("Worker task was terminated");
                  },
                }),
                WorkerTask
              );
            })(),
            PDFWorkerStream = (function () {
              function PDFWorkerStream(params, msgHandler) {
                this._queuedChunks = [];
                var initialData = params.initialData;
                initialData && initialData.length > 0 && this._queuedChunks.push(initialData),
                  (this._msgHandler = msgHandler),
                  (this._isRangeSupported = !params.disableRange),
                  (this._isStreamingSupported = !params.disableStream),
                  (this._contentLength = params.length),
                  (this._fullRequestReader = null),
                  (this._rangeReaders = []),
                  msgHandler.on("OnDataRange", this._onReceiveData.bind(this)),
                  msgHandler.on("OnDataProgress", this._onProgress.bind(this));
              }
              function PDFWorkerStreamReader(stream, queuedChunks) {
                (this._stream = stream),
                  (this._done = !1),
                  (this._queuedChunks = queuedChunks || []),
                  (this._requests = []),
                  (this._headersReady = Promise.resolve()),
                  (stream._fullRequestReader = this),
                  (this.onProgress = null);
              }
              function PDFWorkerStreamRangeReader(stream, begin, end) {
                (this._stream = stream),
                  (this._begin = begin),
                  (this._end = end),
                  (this._queuedChunk = null),
                  (this._requests = []),
                  (this._done = !1),
                  (this.onProgress = null);
              }
              return (
                (PDFWorkerStream.prototype = {
                  _onReceiveData: function (args) {
                    if (void 0 === args.begin)
                      this._fullRequestReader
                        ? this._fullRequestReader._enqueue(args.chunk)
                        : this._queuedChunks.push(args.chunk);
                    else {
                      var found = this._rangeReaders.some(function (rangeReader) {
                        return rangeReader._begin === args.begin && (rangeReader._enqueue(args.chunk), !0);
                      });
                      assert(found);
                    }
                  },
                  _onProgress: function (evt) {
                    if (this._rangeReaders.length > 0) {
                      var firstReader = this._rangeReaders[0];
                      firstReader.onProgress && firstReader.onProgress({ loaded: evt.loaded });
                    }
                  },
                  _removeRangeReader: function (reader) {
                    var i = this._rangeReaders.indexOf(reader);
                    i >= 0 && this._rangeReaders.splice(i, 1);
                  },
                  getFullReader: function () {
                    assert(!this._fullRequestReader);
                    var queuedChunks = this._queuedChunks;
                    return (this._queuedChunks = null), new PDFWorkerStreamReader(this, queuedChunks);
                  },
                  getRangeReader: function (begin, end) {
                    var reader = new PDFWorkerStreamRangeReader(this, begin, end);
                    return (
                      this._msgHandler.send("RequestDataRange", { begin: begin, end: end }),
                      this._rangeReaders.push(reader),
                      reader
                    );
                  },
                  cancelAllRequests: function (reason) {
                    this._fullRequestReader && this._fullRequestReader.cancel(reason),
                      this._rangeReaders.slice(0).forEach(function (rangeReader) {
                        rangeReader.cancel(reason);
                      });
                  },
                }),
                (PDFWorkerStreamReader.prototype = {
                  _enqueue: function (chunk) {
                    if (!this._done) {
                      if (this._requests.length > 0) {
                        return void this._requests.shift().resolve({ value: chunk, done: !1 });
                      }
                      this._queuedChunks.push(chunk);
                    }
                  },
                  get headersReady() {
                    return this._headersReady;
                  },
                  get isRangeSupported() {
                    return this._stream._isRangeSupported;
                  },
                  get isStreamingSupported() {
                    return this._stream._isStreamingSupported;
                  },
                  get contentLength() {
                    return this._stream._contentLength;
                  },
                  read: function () {
                    if (this._queuedChunks.length > 0) {
                      var chunk = this._queuedChunks.shift();
                      return Promise.resolve({ value: chunk, done: !1 });
                    }
                    if (this._done) return Promise.resolve({ value: void 0, done: !0 });
                    var requestCapability = createPromiseCapability();
                    return this._requests.push(requestCapability), requestCapability.promise;
                  },
                  cancel: function (reason) {
                    (this._done = !0),
                      this._requests.forEach(function (requestCapability) {
                        requestCapability.resolve({ value: void 0, done: !0 });
                      }),
                      (this._requests = []);
                  },
                }),
                (PDFWorkerStreamRangeReader.prototype = {
                  _enqueue: function (chunk) {
                    if (!this._done) {
                      if (0 === this._requests.length) this._queuedChunk = chunk;
                      else {
                        this._requests.shift().resolve({ value: chunk, done: !1 }),
                          this._requests.forEach(function (requestCapability) {
                            requestCapability.resolve({ value: void 0, done: !0 });
                          }),
                          (this._requests = []);
                      }
                      (this._done = !0), this._stream._removeRangeReader(this);
                    }
                  },
                  get isStreamingSupported() {
                    return !1;
                  },
                  read: function () {
                    if (this._queuedChunk) return Promise.resolve({ value: this._queuedChunk, done: !1 });
                    if (this._done) return Promise.resolve({ value: void 0, done: !0 });
                    var requestCapability = createPromiseCapability();
                    return this._requests.push(requestCapability), requestCapability.promise;
                  },
                  cancel: function (reason) {
                    (this._done = !0),
                      this._requests.forEach(function (requestCapability) {
                        requestCapability.resolve({ value: void 0, done: !0 });
                      }),
                      (this._requests = []),
                      this._stream._removeRangeReader(this);
                  },
                }),
                PDFWorkerStream
              );
            })(),
            WorkerMessageHandler = {
              setup: function (handler, port) {
                var testMessageProcessed = !1;
                handler.on("test", function (data) {
                  if (!testMessageProcessed) {
                    if (((testMessageProcessed = !0), !(data instanceof Uint8Array)))
                      return void handler.send("test", "main", !1);
                    var supportTransfers = 255 === data[0];
                    handler.postMessageTransfers = supportTransfers;
                    var xhr = new XMLHttpRequest(),
                      responseExists = "response" in xhr;
                    try {
                      xhr.responseType;
                    } catch (e) {
                      responseExists = !1;
                    }
                    if (!responseExists) return void handler.send("test", !1);
                    handler.send("test", { supportTypedArray: !0, supportTransfers: supportTransfers });
                  }
                }),
                  handler.on("configure", function (data) {
                    setVerbosityLevel(data.verbosity);
                  }),
                  handler.on("GetDocRequest", function (data) {
                    return WorkerMessageHandler.createDocumentHandler(data, port);
                  });
              },
              createDocumentHandler: function (docParams, port) {
                function ensureNotTerminated() {
                  if (terminated) throw new Error("Worker was terminated");
                }
                function startWorkerTask(task) {
                  WorkerTasks.push(task);
                }
                function finishWorkerTask(task) {
                  task.finish();
                  var i = WorkerTasks.indexOf(task);
                  WorkerTasks.splice(i, 1);
                }
                function loadDocument(recoveryMode) {
                  var loadDocumentCapability = createPromiseCapability(),
                    parseSuccess = function () {
                      var numPagesPromise = pdfManager.ensureDoc("numPages"),
                        fingerprintPromise = pdfManager.ensureDoc("fingerprint"),
                        encryptedPromise = pdfManager.ensureXRef("encrypt");
                      Promise.all([numPagesPromise, fingerprintPromise, encryptedPromise]).then(function (results) {
                        var doc = { numPages: results[0], fingerprint: results[1], encrypted: !!results[2] };
                        loadDocumentCapability.resolve(doc);
                      }, parseFailure);
                    },
                    parseFailure = function (e) {
                      loadDocumentCapability.reject(e);
                    };
                  return (
                    pdfManager.ensureDoc("checkHeader", []).then(function () {
                      pdfManager.ensureDoc("parseStartXRef", []).then(function () {
                        pdfManager.ensureDoc("parse", [recoveryMode]).then(parseSuccess, parseFailure);
                      }, parseFailure);
                    }, parseFailure),
                    loadDocumentCapability.promise
                  );
                }
                function getPdfManager(data, evaluatorOptions) {
                  var pdfManager,
                    pdfManagerCapability = createPromiseCapability(),
                    source = data.source;
                  if (source.data) {
                    try {
                      (pdfManager = new LocalPdfManager(docId, source.data, source.password, evaluatorOptions)),
                        pdfManagerCapability.resolve(pdfManager);
                    } catch (ex) {
                      pdfManagerCapability.reject(ex);
                    }
                    return pdfManagerCapability.promise;
                  }
                  var pdfStream;
                  try {
                    source.chunkedViewerLoading
                      ? (pdfStream = new PDFWorkerStream(source, handler))
                      : (assert(PDFNetworkStream, "pdfjs/core/network module is not loaded"),
                        (pdfStream = new PDFNetworkStream(data)));
                  } catch (ex) {
                    return pdfManagerCapability.reject(ex), pdfManagerCapability.promise;
                  }
                  var fullRequest = pdfStream.getFullReader();
                  fullRequest.headersReady
                    .then(function () {
                      if (
                        ((fullRequest.isStreamingSupported && fullRequest.isRangeSupported) ||
                          (fullRequest.onProgress = function (evt) {
                            handler.send("DocProgress", { loaded: evt.loaded, total: evt.total });
                          }),
                        fullRequest.isRangeSupported)
                      ) {
                        var disableAutoFetch = source.disableAutoFetch || fullRequest.isStreamingSupported;
                        (pdfManager = new NetworkPdfManager(
                          docId,
                          pdfStream,
                          {
                            msgHandler: handler,
                            url: source.url,
                            password: source.password,
                            length: fullRequest.contentLength,
                            disableAutoFetch: disableAutoFetch,
                            rangeChunkSize: source.rangeChunkSize,
                          },
                          evaluatorOptions
                        )),
                          pdfManagerCapability.resolve(pdfManager),
                          (cancelXHRs = null);
                      }
                    })
                    .catch(function (reason) {
                      pdfManagerCapability.reject(reason), (cancelXHRs = null);
                    });
                  var cachedChunks = [],
                    loaded = 0,
                    flushChunks = function () {
                      var pdfFile = arraysToBytes(cachedChunks);
                      source.length &&
                        pdfFile.length !== source.length &&
                        warn("reported HTTP length is different from actual");
                      try {
                        (pdfManager = new LocalPdfManager(docId, pdfFile, source.password, evaluatorOptions)),
                          pdfManagerCapability.resolve(pdfManager);
                      } catch (ex) {
                        pdfManagerCapability.reject(ex);
                      }
                      cachedChunks = [];
                    };
                  return (
                    new Promise(function (resolve, reject) {
                      var readChunk = function (chunk) {
                        try {
                          if ((ensureNotTerminated(), chunk.done))
                            return pdfManager || flushChunks(), void (cancelXHRs = null);
                          var data = chunk.value;
                          (loaded += arrayByteLength(data)),
                            fullRequest.isStreamingSupported ||
                              handler.send("DocProgress", {
                                loaded: loaded,
                                total: Math.max(loaded, fullRequest.contentLength || 0),
                              }),
                            pdfManager ? pdfManager.sendProgressiveData(data) : cachedChunks.push(data),
                            fullRequest.read().then(readChunk, reject);
                        } catch (e) {
                          reject(e);
                        }
                      };
                      fullRequest.read().then(readChunk, reject);
                    }).catch(function (e) {
                      pdfManagerCapability.reject(e), (cancelXHRs = null);
                    }),
                    (cancelXHRs = function () {
                      pdfStream.cancelAllRequests("abort");
                    }),
                    pdfManagerCapability.promise
                  );
                }
                var pdfManager,
                  terminated = !1,
                  cancelXHRs = null,
                  WorkerTasks = [],
                  docId = docParams.docId,
                  workerHandlerName = docParams.docId + "_worker",
                  handler = new MessageHandler(workerHandlerName, docId, port);
                handler.postMessageTransfers = docParams.postMessageTransfers;
                var setupDoc = function (data) {
                  var onSuccess = function (doc) {
                      ensureNotTerminated(), handler.send("GetDoc", { pdfInfo: doc });
                    },
                    onFailure = function (e) {
                      e instanceof PasswordException
                        ? e.code === PasswordResponses.NEED_PASSWORD
                          ? handler.send("NeedPassword", e)
                          : e.code === PasswordResponses.INCORRECT_PASSWORD && handler.send("IncorrectPassword", e)
                        : e instanceof InvalidPDFException
                        ? handler.send("InvalidPDF", e)
                        : e instanceof MissingPDFException
                        ? handler.send("MissingPDF", e)
                        : e instanceof UnexpectedResponseException
                        ? handler.send("UnexpectedResponse", e)
                        : handler.send("UnknownError", new UnknownErrorException(e.message, e.toString()));
                    };
                  ensureNotTerminated();
                  var cMapOptions = {
                    url: void 0 === data.cMapUrl ? null : data.cMapUrl,
                    packed: !0 === data.cMapPacked,
                  };
                  getPdfManager(data, {
                    forceDataSchema: data.disableCreateObjectURL,
                    maxImageSize: void 0 === data.maxImageSize ? -1 : data.maxImageSize,
                    disableFontFace: data.disableFontFace,
                    cMapOptions: cMapOptions,
                  })
                    .then(function (newPdfManager) {
                      if (terminated) throw (newPdfManager.terminate(), new Error("Worker was terminated"));
                      (pdfManager = newPdfManager),
                        handler.send("PDFManagerReady", null),
                        pdfManager.onLoadedStream().then(function (stream) {
                          handler.send("DataLoaded", { length: stream.bytes.byteLength });
                        });
                    })
                    .then(function pdfManagerReady() {
                      ensureNotTerminated(),
                        loadDocument(!1).then(
                          onSuccess,
                          function (ex) {
                            if ((ensureNotTerminated(), !(ex instanceof XRefParseException)))
                              return (
                                ex instanceof PasswordException && pdfManager.passwordChanged().then(pdfManagerReady),
                                void onFailure(ex)
                              );
                            pdfManager.requestLoadedStream(),
                              pdfManager.onLoadedStream().then(function () {
                                ensureNotTerminated(), loadDocument(!0).then(onSuccess, onFailure);
                              });
                          },
                          onFailure
                        );
                    }, onFailure);
                };
                return (
                  handler.on("GetPage", function (data) {
                    return pdfManager.getPage(data.pageIndex).then(function (page) {
                      var rotatePromise = pdfManager.ensure(page, "rotate"),
                        refPromise = pdfManager.ensure(page, "ref"),
                        viewPromise = pdfManager.ensure(page, "view");
                      return Promise.all([rotatePromise, refPromise, viewPromise]).then(function (results) {
                        return { rotate: results[0], ref: results[1], view: results[2] };
                      });
                    });
                  }),
                  handler.on("GetPageIndex", function (data) {
                    var ref = new Ref(data.ref.num, data.ref.gen);
                    return pdfManager.pdfDocument.catalog.getPageIndex(ref);
                  }),
                  handler.on("GetDestinations", function (data) {
                    return pdfManager.ensureCatalog("destinations");
                  }),
                  handler.on("GetDestination", function (data) {
                    return pdfManager.ensureCatalog("getDestination", [data.id]);
                  }),
                  handler.on("GetPageLabels", function (data) {
                    return pdfManager.ensureCatalog("pageLabels");
                  }),
                  handler.on("GetAttachments", function (data) {
                    return pdfManager.ensureCatalog("attachments");
                  }),
                  handler.on("GetJavaScript", function (data) {
                    return pdfManager.ensureCatalog("javaScript");
                  }),
                  handler.on("GetOutline", function (data) {
                    return pdfManager.ensureCatalog("documentOutline");
                  }),
                  handler.on("GetMetadata", function (data) {
                    return Promise.all([pdfManager.ensureDoc("documentInfo"), pdfManager.ensureCatalog("metadata")]);
                  }),
                  handler.on("GetData", function (data) {
                    return (
                      pdfManager.requestLoadedStream(),
                      pdfManager.onLoadedStream().then(function (stream) {
                        return stream.bytes;
                      })
                    );
                  }),
                  handler.on("GetStats", function (data) {
                    return pdfManager.pdfDocument.xref.stats;
                  }),
                  handler.on("UpdatePassword", function (data) {
                    pdfManager.updatePassword(data);
                  }),
                  handler.on("GetAnnotations", function (data) {
                    return pdfManager.getPage(data.pageIndex).then(function (page) {
                      return pdfManager.ensure(page, "getAnnotationsData", [data.intent]);
                    });
                  }),
                  handler.on(
                    "RenderPageRequest",
                    function (data) {
                      var pageIndex = data.pageIndex;
                      pdfManager.getPage(pageIndex).then(function (page) {
                        var task = new WorkerTask("RenderPageRequest: page " + pageIndex);
                        startWorkerTask(task);
                        var pageNum = pageIndex + 1,
                          start = Date.now();
                        page.getOperatorList(handler, task, data.intent, data.renderInteractiveForms).then(
                          function (operatorList) {
                            finishWorkerTask(task),
                              info(
                                "page=" +
                                  pageNum +
                                  " - getOperatorList: time=" +
                                  (Date.now() - start) +
                                  "ms, len=" +
                                  operatorList.totalLength
                              );
                          },
                          function (e) {
                            if ((finishWorkerTask(task), !task.terminated)) {
                              handler.send("UnsupportedFeature", { featureId: UNSUPPORTED_FEATURES.unknown });
                              var wrappedException,
                                minimumStackMessage = "worker.js: while trying to getPage() and getOperatorList()";
                              (wrappedException =
                                "string" == typeof e
                                  ? { message: e, stack: minimumStackMessage }
                                  : "object" == typeof e
                                  ? { message: e.message || e.toString(), stack: e.stack || minimumStackMessage }
                                  : { message: "Unknown exception type: " + typeof e, stack: minimumStackMessage }),
                                handler.send("PageError", {
                                  pageNum: pageNum,
                                  error: wrappedException,
                                  intent: data.intent,
                                });
                            }
                          }
                        );
                      });
                    },
                    this
                  ),
                  handler.on("GetTextContent", function (data) {
                    var pageIndex = data.pageIndex,
                      normalizeWhitespace = data.normalizeWhitespace,
                      combineTextItems = data.combineTextItems;
                    return pdfManager.getPage(pageIndex).then(function (page) {
                      var task = new WorkerTask("GetTextContent: page " + pageIndex);
                      startWorkerTask(task);
                      var pageNum = pageIndex + 1,
                        start = Date.now();
                      return page.extractTextContent(task, normalizeWhitespace, combineTextItems).then(
                        function (textContent) {
                          return (
                            finishWorkerTask(task),
                            info("text indexing: page=" + pageNum + " - time=" + (Date.now() - start) + "ms"),
                            textContent
                          );
                        },
                        function (reason) {
                          if ((finishWorkerTask(task), !task.terminated)) throw reason;
                        }
                      );
                    });
                  }),
                  handler.on("Cleanup", function (data) {
                    return pdfManager.cleanup();
                  }),
                  handler.on("Terminate", function (data) {
                    (terminated = !0),
                      pdfManager && (pdfManager.terminate(), (pdfManager = null)),
                      cancelXHRs && cancelXHRs();
                    var waitOn = [];
                    return (
                      WorkerTasks.forEach(function (task) {
                        waitOn.push(task.finished), task.terminate();
                      }),
                      Promise.all(waitOn).then(function () {
                        handler.destroy(), (handler = null);
                      })
                    );
                  }),
                  handler.on("Ready", function (data) {
                    setupDoc(docParams), (docParams = null);
                  }),
                  workerHandlerName
                );
              },
            };
          "undefined" != typeof window ||
            ("undefined" != typeof module && module.require) ||
            (function () {
              if (!("console" in globalScope)) {
                var consoleTimer = {},
                  workerConsole = {
                    log: function () {
                      var args = Array.prototype.slice.call(arguments);
                      globalScope.postMessage({ targetName: "main", action: "console_log", data: args });
                    },
                    error: function () {
                      var args = Array.prototype.slice.call(arguments);
                      throw (
                        (globalScope.postMessage({ targetName: "main", action: "console_error", data: args }),
                        "pdf.js execution error")
                      );
                    },
                    time: function (name) {
                      consoleTimer[name] = Date.now();
                    },
                    timeEnd: function (name) {
                      var time = consoleTimer[name];
                      time || error("Unknown timer name " + name), this.log("Timer:", name, Date.now() - time);
                    },
                  };
                globalScope.console = workerConsole;
              }
              var handler = new MessageHandler("worker", "main", self);
              WorkerMessageHandler.setup(handler, self), handler.send("ready", null);
            })(),
            (exports.setPDFNetworkStreamClass = setPDFNetworkStreamClass),
            (exports.WorkerTask = WorkerTask),
            (exports.WorkerMessageHandler = WorkerMessageHandler);
        })((root.pdfjsCoreWorker = {}), root.pdfjsSharedUtil, root.pdfjsCorePrimitives, root.pdfjsCorePdfManager);
      })(this);
    var NetworkManager = (function () {
      function NetworkManager(url, args) {
        (this.url = url),
          (args = args || {}),
          (this.isHttp = /^https?:/i.test(url)),
          (this.httpHeaders = (this.isHttp && args.httpHeaders) || {}),
          (this.withCredentials = args.withCredentials || !1),
          (this.getXhr =
            args.getXhr ||
            function () {
              return new XMLHttpRequest();
            }),
          (this.currXhrId = 0),
          (this.pendingRequests = Object.create(null)),
          (this.loadedRequests = Object.create(null));
      }
      function getArrayBuffer(xhr) {
        var data = xhr.response;
        if ("string" != typeof data) return data;
        for (var length = data.length, array = new Uint8Array(length), i = 0; i < length; i++)
          array[i] = 255 & data.charCodeAt(i);
        return array.buffer;
      }
      var supportsMozChunked = (function () {
        try {
          var x = new XMLHttpRequest();
          return (
            x.open("GET", "https://example.com"),
            (x.responseType = "moz-chunked-arraybuffer"),
            "moz-chunked-arraybuffer" === x.responseType
          );
        } catch (e) {
          return !1;
        }
      })();
      return (
        (NetworkManager.prototype = {
          requestRange: function (begin, end, listeners) {
            var args = { begin: begin, end: end };
            for (var prop in listeners) args[prop] = listeners[prop];
            return this.request(args);
          },
          requestFull: function (listeners) {
            return this.request(listeners);
          },
          request: function (args) {
            var xhr = this.getXhr(),
              xhrId = this.currXhrId++,
              pendingRequest = (this.pendingRequests[xhrId] = { xhr: xhr });
            xhr.open("GET", this.url), (xhr.withCredentials = this.withCredentials);
            for (var property in this.httpHeaders) {
              var value = this.httpHeaders[property];
              void 0 !== value && xhr.setRequestHeader(property, value);
            }
            if (this.isHttp && "begin" in args && "end" in args) {
              var rangeStr = args.begin + "-" + (args.end - 1);
              xhr.setRequestHeader("Range", "bytes=" + rangeStr),
                xhr.setRequestHeader("Cache-Control", "no-cache"),
                (pendingRequest.expectedStatus = 206);
            } else pendingRequest.expectedStatus = 200;
            return (
              supportsMozChunked && !!args.onProgressiveData
                ? ((xhr.responseType = "moz-chunked-arraybuffer"),
                  (pendingRequest.onProgressiveData = args.onProgressiveData),
                  (pendingRequest.mozChunked = !0))
                : (xhr.responseType = "arraybuffer"),
              args.onError &&
                (xhr.onerror = function (evt) {
                  args.onError(xhr.status);
                }),
              (xhr.onreadystatechange = this.onStateChange.bind(this, xhrId)),
              (xhr.onprogress = this.onProgress.bind(this, xhrId)),
              (pendingRequest.onHeadersReceived = args.onHeadersReceived),
              (pendingRequest.onDone = args.onDone),
              (pendingRequest.onError = args.onError),
              (pendingRequest.onProgress = args.onProgress),
              xhr.send(null),
              xhrId
            );
          },
          onProgress: function (xhrId, evt) {
            var pendingRequest = this.pendingRequests[xhrId];
            if (pendingRequest) {
              if (pendingRequest.mozChunked) {
                var chunk = getArrayBuffer(pendingRequest.xhr);
                pendingRequest.onProgressiveData(chunk);
              }
              var onProgress = pendingRequest.onProgress;
              onProgress && onProgress(evt);
            }
          },
          onStateChange: function (xhrId, evt) {
            var pendingRequest = this.pendingRequests[xhrId];
            if (pendingRequest) {
              var xhr = pendingRequest.xhr;
              if (
                (xhr.readyState >= 2 &&
                  pendingRequest.onHeadersReceived &&
                  (pendingRequest.onHeadersReceived(), delete pendingRequest.onHeadersReceived),
                4 === xhr.readyState && xhrId in this.pendingRequests)
              ) {
                if ((delete this.pendingRequests[xhrId], 0 === xhr.status && this.isHttp))
                  return void (pendingRequest.onError && pendingRequest.onError(xhr.status));
                var xhrStatus = xhr.status || 200;
                if (
                  !(200 === xhrStatus && 206 === pendingRequest.expectedStatus) &&
                  xhrStatus !== pendingRequest.expectedStatus
                )
                  return void (pendingRequest.onError && pendingRequest.onError(xhr.status));
                this.loadedRequests[xhrId] = !0;
                var chunk = getArrayBuffer(xhr);
                if (206 === xhrStatus) {
                  var rangeHeader = xhr.getResponseHeader("Content-Range"),
                    matches = /bytes (\d+)-(\d+)\/(\d+)/.exec(rangeHeader),
                    begin = parseInt(matches[1], 10);
                  pendingRequest.onDone({ begin: begin, chunk: chunk });
                } else
                  pendingRequest.onProgressiveData
                    ? pendingRequest.onDone(null)
                    : chunk
                    ? pendingRequest.onDone({ begin: 0, chunk: chunk })
                    : pendingRequest.onError && pendingRequest.onError(xhr.status);
              }
            }
          },
          hasPendingRequests: function () {
            for (var xhrId in this.pendingRequests) return !0;
            return !1;
          },
          getRequestXhr: function (xhrId) {
            return this.pendingRequests[xhrId].xhr;
          },
          isStreamingRequest: function (xhrId) {
            return !!this.pendingRequests[xhrId].onProgressiveData;
          },
          isPendingRequest: function (xhrId) {
            return xhrId in this.pendingRequests;
          },
          isLoadedRequest: function (xhrId) {
            return xhrId in this.loadedRequests;
          },
          abortAllRequests: function () {
            for (var xhrId in this.pendingRequests) this.abortRequest(0 | xhrId);
          },
          abortRequest: function (xhrId) {
            var xhr = this.pendingRequests[xhrId].xhr;
            delete this.pendingRequests[xhrId], xhr.abort();
          },
        }),
        NetworkManager
      );
    })();
    !(function (root, factory) {
      !(function (exports, sharedUtil, coreWorker) {
        function PDFNetworkStream(options) {
          this._options = options;
          var source = options.source;
          (this._manager = new NetworkManager(source.url, {
            httpHeaders: source.httpHeaders,
            withCredentials: source.withCredentials,
          })),
            (this._rangeChunkSize = source.rangeChunkSize),
            (this._fullRequestReader = null),
            (this._rangeRequestReaders = []);
        }
        function PDFNetworkStreamFullRequestReader(manager, options) {
          this._manager = manager;
          var source = options.source,
            args = {
              onHeadersReceived: this._onHeadersReceived.bind(this),
              onProgressiveData: source.disableStream ? null : this._onProgressiveData.bind(this),
              onDone: this._onDone.bind(this),
              onError: this._onError.bind(this),
              onProgress: this._onProgress.bind(this),
            };
          (this._url = source.url),
            (this._fullRequestId = manager.requestFull(args)),
            (this._headersReceivedCapability = createPromiseCapability()),
            (this._disableRange = options.disableRange || !1),
            (this._contentLength = source.length),
            (this._rangeChunkSize = source.rangeChunkSize),
            this._rangeChunkSize || this._disableRange || (this._disableRange = !0),
            (this._isStreamingSupported = !1),
            (this._isRangeSupported = !1),
            (this._cachedChunks = []),
            (this._requests = []),
            (this._done = !1),
            (this._storedError = void 0),
            (this.onProgress = null);
        }
        function PDFNetworkStreamRangeRequestReader(manager, begin, end) {
          this._manager = manager;
          var args = { onDone: this._onDone.bind(this), onProgress: this._onProgress.bind(this) };
          (this._requestId = manager.requestRange(begin, end, args)),
            (this._requests = []),
            (this._queuedChunk = null),
            (this._done = !1),
            (this.onProgress = null),
            (this.onClosed = null);
        }
        var assert = sharedUtil.assert,
          createPromiseCapability = sharedUtil.createPromiseCapability,
          isInt = sharedUtil.isInt,
          MissingPDFException = sharedUtil.MissingPDFException,
          UnexpectedResponseException = sharedUtil.UnexpectedResponseException;
        (PDFNetworkStream.prototype = {
          _onRangeRequestReaderClosed: function (reader) {
            var i = this._rangeRequestReaders.indexOf(reader);
            i >= 0 && this._rangeRequestReaders.splice(i, 1);
          },
          getFullReader: function () {
            return (
              assert(!this._fullRequestReader),
              (this._fullRequestReader = new PDFNetworkStreamFullRequestReader(this._manager, this._options)),
              this._fullRequestReader
            );
          },
          getRangeReader: function (begin, end) {
            var reader = new PDFNetworkStreamRangeRequestReader(this._manager, begin, end);
            return (
              (reader.onClosed = this._onRangeRequestReaderClosed.bind(this)),
              this._rangeRequestReaders.push(reader),
              reader
            );
          },
          cancelAllRequests: function (reason) {
            this._fullRequestReader && this._fullRequestReader.cancel(reason),
              this._rangeRequestReaders.slice(0).forEach(function (reader) {
                reader.cancel(reason);
              });
          },
        }),
          (PDFNetworkStreamFullRequestReader.prototype = {
            _validateRangeRequestCapabilities: function () {
              if (this._disableRange) return !1;
              var networkManager = this._manager,
                fullRequestXhrId = this._fullRequestId,
                fullRequestXhr = networkManager.getRequestXhr(fullRequestXhrId);
              if ("bytes" !== fullRequestXhr.getResponseHeader("Accept-Ranges")) return !1;
              if ("identity" !== (fullRequestXhr.getResponseHeader("Content-Encoding") || "identity")) return !1;
              var length = fullRequestXhr.getResponseHeader("Content-Length");
              return (
                (length = parseInt(length, 10)),
                !!isInt(length) && ((this._contentLength = length), !(length <= 2 * this._rangeChunkSize))
              );
            },
            _onHeadersReceived: function () {
              this._validateRangeRequestCapabilities() && (this._isRangeSupported = !0);
              var networkManager = this._manager,
                fullRequestXhrId = this._fullRequestId;
              networkManager.isStreamingRequest(fullRequestXhrId)
                ? (this._isStreamingSupported = !0)
                : this._isRangeSupported && networkManager.abortRequest(fullRequestXhrId),
                this._headersReceivedCapability.resolve();
            },
            _onProgressiveData: function (chunk) {
              if (this._requests.length > 0) {
                this._requests.shift().resolve({ value: chunk, done: !1 });
              } else this._cachedChunks.push(chunk);
            },
            _onDone: function (args) {
              args && this._onProgressiveData(args.chunk),
                (this._done = !0),
                this._cachedChunks.length > 0 ||
                  (this._requests.forEach(function (requestCapability) {
                    requestCapability.resolve({ value: void 0, done: !0 });
                  }),
                  (this._requests = []));
            },
            _onError: function (status) {
              var exception,
                url = this._url;
              (exception =
                404 === status || (0 === status && /^file:/.test(url))
                  ? new MissingPDFException('Missing PDF "' + url + '".')
                  : new UnexpectedResponseException(
                      "Unexpected server response (" + status + ') while retrieving PDF "' + url + '".',
                      status
                    )),
                (this._storedError = exception),
                this._headersReceivedCapability.reject(exception),
                this._requests.forEach(function (requestCapability) {
                  requestCapability.reject(exception);
                }),
                (this._requests = []),
                (this._cachedChunks = []);
            },
            _onProgress: function (data) {
              this.onProgress &&
                this.onProgress({
                  loaded: data.loaded,
                  total: data.lengthComputable ? data.total : this._contentLength,
                });
            },
            get isRangeSupported() {
              return this._isRangeSupported;
            },
            get isStreamingSupported() {
              return this._isStreamingSupported;
            },
            get contentLength() {
              return this._contentLength;
            },
            get headersReady() {
              return this._headersReceivedCapability.promise;
            },
            read: function () {
              if (this._storedError) return Promise.reject(this._storedError);
              if (this._cachedChunks.length > 0) {
                var chunk = this._cachedChunks.shift();
                return Promise.resolve(chunk);
              }
              if (this._done) return Promise.resolve({ value: void 0, done: !0 });
              var requestCapability = createPromiseCapability();
              return this._requests.push(requestCapability), requestCapability.promise;
            },
            cancel: function (reason) {
              (this._done = !0),
                this._headersReceivedCapability.reject(reason),
                this._requests.forEach(function (requestCapability) {
                  requestCapability.resolve({ value: void 0, done: !0 });
                }),
                (this._requests = []),
                this._manager.isPendingRequest(this._fullRequestId) && this._manager.abortRequest(this._fullRequestId),
                (this._fullRequestReader = null);
            },
          }),
          (PDFNetworkStreamRangeRequestReader.prototype = {
            _close: function () {
              this.onClosed && this.onClosed(this);
            },
            _onDone: function (data) {
              var chunk = data.chunk;
              if (this._requests.length > 0) {
                this._requests.shift().resolve({ value: chunk, done: !1 });
              } else this._queuedChunk = chunk;
              (this._done = !0),
                this._requests.forEach(function (requestCapability) {
                  requestCapability.resolve({ value: void 0, done: !0 });
                }),
                (this._requests = []),
                this._close();
            },
            _onProgress: function (evt) {
              !this.isStreamingSupported && this.onProgress && this.onProgress({ loaded: evt.loaded });
            },
            get isStreamingSupported() {
              return !1;
            },
            read: function () {
              if (null !== this._queuedChunk) {
                var chunk = this._queuedChunk;
                return (this._queuedChunk = null), Promise.resolve({ value: chunk, done: !1 });
              }
              if (this._done) return Promise.resolve({ value: void 0, done: !0 });
              var requestCapability = createPromiseCapability();
              return this._requests.push(requestCapability), requestCapability.promise;
            },
            cancel: function (reason) {
              (this._done = !0),
                this._requests.forEach(function (requestCapability) {
                  requestCapability.resolve({ value: void 0, done: !0 });
                }),
                (this._requests = []),
                this._manager.isPendingRequest(this._requestId) && this._manager.abortRequest(this._requestId),
                this._close();
            },
          }),
          coreWorker.setPDFNetworkStreamClass(PDFNetworkStream),
          (exports.PDFNetworkStream = PDFNetworkStream),
          (exports.NetworkManager = NetworkManager);
      })((root.pdfjsCoreNetwork = {}), root.pdfjsSharedUtil, root.pdfjsCoreWorker);
    })(this);
  }.call(pdfjsLibs),
    (exports.WorkerMessageHandler = pdfjsLibs.pdfjsCoreWorker.WorkerMessageHandler));
});
